/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_00g0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|g0) integrals */

void d12hrr_order_00g0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][4][11] = int_stack + 0;
 Libderiv->deriv_classes[0][4][10] = int_stack + 15;
 Libderiv->deriv_classes[0][4][9] = int_stack + 30;
 Libderiv->deriv_classes[0][4][8] = int_stack + 45;
 Libderiv->deriv_classes[0][4][7] = int_stack + 60;
 Libderiv->deriv_classes[0][4][6] = int_stack + 75;
 Libderiv->deriv_classes[0][4][2] = int_stack + 90;
 Libderiv->deriv_classes[0][4][1] = int_stack + 105;
 Libderiv->deriv_classes[0][4][0] = int_stack + 120;
 Libderiv->deriv2_classes[0][4][143] = int_stack + 135;
 Libderiv->deriv2_classes[0][4][131] = int_stack + 150;
 Libderiv->deriv2_classes[0][4][130] = int_stack + 165;
 Libderiv->deriv2_classes[0][4][119] = int_stack + 180;
 Libderiv->deriv2_classes[0][4][118] = int_stack + 195;
 Libderiv->deriv2_classes[0][4][117] = int_stack + 210;
 Libderiv->deriv2_classes[0][4][107] = int_stack + 225;
 Libderiv->deriv2_classes[0][4][106] = int_stack + 240;
 Libderiv->deriv2_classes[0][4][105] = int_stack + 255;
 Libderiv->deriv2_classes[0][4][104] = int_stack + 270;
 Libderiv->deriv2_classes[0][4][95] = int_stack + 285;
 Libderiv->deriv2_classes[0][4][94] = int_stack + 300;
 Libderiv->deriv2_classes[0][4][93] = int_stack + 315;
 Libderiv->deriv2_classes[0][4][92] = int_stack + 330;
 Libderiv->deriv2_classes[0][4][91] = int_stack + 345;
 Libderiv->deriv2_classes[0][4][83] = int_stack + 360;
 Libderiv->deriv2_classes[0][4][82] = int_stack + 375;
 Libderiv->deriv2_classes[0][4][81] = int_stack + 390;
 Libderiv->deriv2_classes[0][4][80] = int_stack + 405;
 Libderiv->deriv2_classes[0][4][79] = int_stack + 420;
 Libderiv->deriv2_classes[0][4][78] = int_stack + 435;
 Libderiv->deriv2_classes[0][4][35] = int_stack + 450;
 Libderiv->deriv2_classes[0][4][34] = int_stack + 465;
 Libderiv->deriv2_classes[0][4][33] = int_stack + 480;
 Libderiv->deriv2_classes[0][4][32] = int_stack + 495;
 Libderiv->deriv2_classes[0][4][31] = int_stack + 510;
 Libderiv->deriv2_classes[0][4][30] = int_stack + 525;
 Libderiv->deriv2_classes[0][4][26] = int_stack + 540;
 Libderiv->deriv2_classes[0][4][23] = int_stack + 555;
 Libderiv->deriv2_classes[0][4][22] = int_stack + 570;
 Libderiv->deriv2_classes[0][4][21] = int_stack + 585;
 Libderiv->deriv2_classes[0][4][20] = int_stack + 600;
 Libderiv->deriv2_classes[0][4][19] = int_stack + 615;
 Libderiv->deriv2_classes[0][4][18] = int_stack + 630;
 Libderiv->deriv2_classes[0][4][14] = int_stack + 645;
 Libderiv->deriv2_classes[0][4][13] = int_stack + 660;
 Libderiv->deriv2_classes[0][4][11] = int_stack + 675;
 Libderiv->deriv2_classes[0][4][10] = int_stack + 690;
 Libderiv->deriv2_classes[0][4][9] = int_stack + 705;
 Libderiv->deriv2_classes[0][4][8] = int_stack + 720;
 Libderiv->deriv2_classes[0][4][7] = int_stack + 735;
 Libderiv->deriv2_classes[0][4][6] = int_stack + 750;
 Libderiv->deriv2_classes[0][4][2] = int_stack + 765;
 Libderiv->deriv2_classes[0][4][1] = int_stack + 780;
 Libderiv->deriv2_classes[0][4][0] = int_stack + 795;
 memset(int_stack,0,6480);

 Libderiv->dvrr_stack = int_stack + 810;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_00g0(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[11] = int_stack + 0;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[10] = int_stack + 15;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[9] = int_stack + 30;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[8] = int_stack + 45;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[7] = int_stack + 60;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[6] = int_stack + 75;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[2] = int_stack + 90;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[1] = int_stack + 105;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[0] = int_stack + 120;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[155] = int_stack + 135;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[143] = int_stack + 150;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[142] = int_stack + 165;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[131] = int_stack + 180;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[130] = int_stack + 195;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[129] = int_stack + 210;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[119] = int_stack + 225;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[118] = int_stack + 240;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[117] = int_stack + 255;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[116] = int_stack + 270;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[107] = int_stack + 285;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[106] = int_stack + 300;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[105] = int_stack + 315;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[104] = int_stack + 330;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[103] = int_stack + 345;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[95] = int_stack + 360;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[94] = int_stack + 375;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[93] = int_stack + 390;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[92] = int_stack + 405;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[91] = int_stack + 420;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[90] = int_stack + 435;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[47] = int_stack + 450;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[46] = int_stack + 465;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[45] = int_stack + 480;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[44] = int_stack + 495;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[43] = int_stack + 510;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[42] = int_stack + 525;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[38] = int_stack + 540;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[35] = int_stack + 555;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[34] = int_stack + 570;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[33] = int_stack + 585;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[32] = int_stack + 600;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[31] = int_stack + 615;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[30] = int_stack + 630;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[26] = int_stack + 645;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[25] = int_stack + 660;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[23] = int_stack + 675;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[22] = int_stack + 690;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[21] = int_stack + 705;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[20] = int_stack + 720;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[19] = int_stack + 735;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[18] = int_stack + 750;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[14] = int_stack + 765;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[13] = int_stack + 780;
 /*--- compute (00|g0) ---*/
     Libderiv->ABCD[12] = int_stack + 795;

}
