/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_ppgp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (pp|gp) integrals */

void d12hrr_order_ppgp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][5][11] = int_stack + 0;
 Libderiv->deriv_classes[2][5][10] = int_stack + 126;
 Libderiv->deriv_classes[2][5][9] = int_stack + 252;
 Libderiv->deriv_classes[2][5][8] = int_stack + 378;
 Libderiv->deriv_classes[2][5][7] = int_stack + 504;
 Libderiv->dvrr_classes[2][4] = int_stack + 630;
 Libderiv->deriv_classes[2][5][6] = int_stack + 720;
 Libderiv->deriv_classes[2][5][2] = int_stack + 846;
 Libderiv->deriv_classes[2][5][1] = int_stack + 972;
 Libderiv->dvrr_classes[1][5] = int_stack + 1098;
 Libderiv->deriv_classes[2][5][0] = int_stack + 1161;
 Libderiv->deriv2_classes[1][4][143] = int_stack + 1287;
 Libderiv->deriv2_classes[1][5][143] = int_stack + 1332;
 Libderiv->deriv2_classes[2][4][143] = int_stack + 1395;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 1485;
 Libderiv->deriv2_classes[1][4][131] = int_stack + 1611;
 Libderiv->deriv2_classes[1][5][131] = int_stack + 1656;
 Libderiv->deriv2_classes[2][4][131] = int_stack + 1719;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 1809;
 Libderiv->deriv2_classes[1][4][130] = int_stack + 1935;
 Libderiv->deriv2_classes[1][5][130] = int_stack + 1980;
 Libderiv->deriv2_classes[2][4][130] = int_stack + 2043;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 2133;
 Libderiv->deriv2_classes[1][4][119] = int_stack + 2259;
 Libderiv->deriv2_classes[1][5][119] = int_stack + 2304;
 Libderiv->deriv2_classes[2][4][119] = int_stack + 2367;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 2457;
 Libderiv->deriv2_classes[1][4][118] = int_stack + 2583;
 Libderiv->deriv2_classes[1][5][118] = int_stack + 2628;
 Libderiv->deriv2_classes[2][4][118] = int_stack + 2691;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 2781;
 Libderiv->deriv2_classes[1][4][117] = int_stack + 2907;
 Libderiv->deriv2_classes[1][5][117] = int_stack + 2952;
 Libderiv->deriv2_classes[2][4][117] = int_stack + 3015;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 3105;
 Libderiv->deriv2_classes[1][4][107] = int_stack + 3231;
 Libderiv->deriv2_classes[1][5][107] = int_stack + 3276;
 Libderiv->deriv2_classes[2][4][107] = int_stack + 3339;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 3429;
 Libderiv->deriv2_classes[1][4][106] = int_stack + 3555;
 Libderiv->deriv2_classes[1][5][106] = int_stack + 3600;
 Libderiv->deriv2_classes[2][4][106] = int_stack + 3663;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 3753;
 Libderiv->deriv2_classes[1][4][105] = int_stack + 3879;
 Libderiv->deriv2_classes[1][5][105] = int_stack + 3924;
 Libderiv->deriv2_classes[2][4][105] = int_stack + 3987;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 4077;
 Libderiv->deriv2_classes[1][4][104] = int_stack + 4203;
 Libderiv->deriv2_classes[1][5][104] = int_stack + 4248;
 Libderiv->deriv2_classes[2][4][104] = int_stack + 4311;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 4401;
 Libderiv->deriv2_classes[1][4][95] = int_stack + 4527;
 Libderiv->deriv2_classes[1][5][95] = int_stack + 4572;
 Libderiv->deriv2_classes[2][4][95] = int_stack + 4635;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 4725;
 Libderiv->deriv2_classes[1][4][94] = int_stack + 4851;
 Libderiv->deriv2_classes[1][5][94] = int_stack + 4896;
 Libderiv->deriv2_classes[2][4][94] = int_stack + 4959;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 5049;
 Libderiv->deriv2_classes[1][4][93] = int_stack + 5175;
 Libderiv->deriv2_classes[1][5][93] = int_stack + 5220;
 Libderiv->deriv2_classes[2][4][93] = int_stack + 5283;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 5373;
 Libderiv->deriv2_classes[1][4][92] = int_stack + 5499;
 Libderiv->deriv2_classes[1][5][92] = int_stack + 5544;
 Libderiv->deriv2_classes[2][4][92] = int_stack + 5607;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 5697;
 Libderiv->deriv2_classes[1][4][91] = int_stack + 5823;
 Libderiv->deriv2_classes[1][5][91] = int_stack + 5868;
 Libderiv->deriv2_classes[2][4][91] = int_stack + 5931;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 6021;
 Libderiv->deriv2_classes[1][4][83] = int_stack + 6147;
 Libderiv->deriv2_classes[1][5][83] = int_stack + 6192;
 Libderiv->deriv_classes[2][4][11] = int_stack + 6255;
 Libderiv->deriv2_classes[2][4][83] = int_stack + 6345;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 6435;
 Libderiv->deriv2_classes[1][4][82] = int_stack + 6561;
 Libderiv->deriv2_classes[1][5][82] = int_stack + 6606;
 Libderiv->deriv_classes[2][4][10] = int_stack + 6669;
 Libderiv->deriv2_classes[2][4][82] = int_stack + 6759;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 6849;
 Libderiv->deriv2_classes[1][4][81] = int_stack + 6975;
 Libderiv->deriv2_classes[1][5][81] = int_stack + 7020;
 Libderiv->deriv_classes[2][4][9] = int_stack + 7083;
 Libderiv->deriv2_classes[2][4][81] = int_stack + 7173;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 7263;
 Libderiv->deriv2_classes[1][4][80] = int_stack + 7389;
 Libderiv->deriv2_classes[1][5][80] = int_stack + 7434;
 Libderiv->deriv_classes[2][4][8] = int_stack + 7497;
 Libderiv->deriv2_classes[2][4][80] = int_stack + 7587;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 7677;
 Libderiv->deriv2_classes[1][4][79] = int_stack + 7803;
 Libderiv->deriv2_classes[1][5][79] = int_stack + 7848;
 Libderiv->deriv_classes[2][4][7] = int_stack + 7911;
 Libderiv->deriv2_classes[2][4][79] = int_stack + 8001;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 8091;
 Libderiv->deriv2_classes[1][4][78] = int_stack + 8217;
 Libderiv->deriv2_classes[1][5][78] = int_stack + 8262;
 Libderiv->deriv_classes[2][4][6] = int_stack + 8325;
 Libderiv->deriv2_classes[2][4][78] = int_stack + 8415;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 8505;
 Libderiv->deriv2_classes[1][4][35] = int_stack + 8631;
 Libderiv->deriv2_classes[1][5][35] = int_stack + 8676;
 Libderiv->deriv2_classes[2][4][35] = int_stack + 8739;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 8829;
 Libderiv->deriv2_classes[1][4][34] = int_stack + 8955;
 Libderiv->deriv2_classes[1][5][34] = int_stack + 9000;
 Libderiv->deriv2_classes[2][4][34] = int_stack + 9063;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 9153;
 Libderiv->deriv2_classes[1][4][33] = int_stack + 9279;
 Libderiv->deriv2_classes[1][5][33] = int_stack + 9324;
 Libderiv->deriv2_classes[2][4][33] = int_stack + 9387;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 9477;
 Libderiv->deriv2_classes[1][4][32] = int_stack + 9603;
 Libderiv->deriv2_classes[1][5][32] = int_stack + 9648;
 Libderiv->deriv2_classes[2][4][32] = int_stack + 9711;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 9801;
 Libderiv->deriv2_classes[1][4][31] = int_stack + 9927;
 Libderiv->deriv2_classes[1][5][31] = int_stack + 9972;
 Libderiv->deriv2_classes[2][4][31] = int_stack + 10035;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 10125;
 Libderiv->deriv2_classes[1][4][30] = int_stack + 10251;
 Libderiv->deriv2_classes[1][5][30] = int_stack + 10296;
 Libderiv->deriv_classes[2][4][2] = int_stack + 10359;
 Libderiv->deriv2_classes[2][4][30] = int_stack + 10449;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 10539;
 Libderiv->deriv2_classes[1][4][26] = int_stack + 10665;
 Libderiv->deriv2_classes[1][5][26] = int_stack + 10710;
 Libderiv->deriv2_classes[2][4][26] = int_stack + 10773;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 10863;
 Libderiv->deriv2_classes[1][4][23] = int_stack + 10989;
 Libderiv->deriv2_classes[1][5][23] = int_stack + 11034;
 Libderiv->deriv2_classes[2][4][23] = int_stack + 11097;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 11187;
 Libderiv->deriv2_classes[1][4][22] = int_stack + 11313;
 Libderiv->deriv2_classes[1][5][22] = int_stack + 11358;
 Libderiv->deriv2_classes[2][4][22] = int_stack + 11421;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 11511;
 Libderiv->deriv2_classes[1][4][21] = int_stack + 11637;
 Libderiv->deriv2_classes[1][5][21] = int_stack + 11682;
 Libderiv->deriv2_classes[2][4][21] = int_stack + 11745;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 11835;
 Libderiv->deriv2_classes[1][4][20] = int_stack + 11961;
 Libderiv->deriv2_classes[1][5][20] = int_stack + 12006;
 Libderiv->deriv2_classes[2][4][20] = int_stack + 12069;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 12159;
 Libderiv->deriv2_classes[1][4][19] = int_stack + 12285;
 Libderiv->deriv2_classes[1][5][19] = int_stack + 12330;
 Libderiv->deriv2_classes[2][4][19] = int_stack + 12393;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 12483;
 Libderiv->deriv2_classes[1][4][18] = int_stack + 12609;
 Libderiv->deriv2_classes[1][5][18] = int_stack + 12654;
 Libderiv->deriv_classes[2][4][1] = int_stack + 12717;
 Libderiv->deriv2_classes[2][4][18] = int_stack + 12807;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 12897;
 Libderiv->deriv2_classes[1][4][14] = int_stack + 13023;
 Libderiv->deriv2_classes[1][5][14] = int_stack + 13068;
 Libderiv->deriv2_classes[2][4][14] = int_stack + 13131;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 13221;
 Libderiv->deriv2_classes[1][4][13] = int_stack + 13347;
 Libderiv->deriv2_classes[1][5][13] = int_stack + 13392;
 Libderiv->deriv2_classes[2][4][13] = int_stack + 13455;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 13545;
 Libderiv->deriv_classes[1][4][11] = int_stack + 13671;
 Libderiv->deriv_classes[1][5][11] = int_stack + 13716;
 Libderiv->deriv2_classes[1][4][11] = int_stack + 13779;
 Libderiv->deriv2_classes[1][5][11] = int_stack + 13824;
 Libderiv->deriv2_classes[2][4][11] = int_stack + 13887;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 13977;
 Libderiv->deriv_classes[1][4][10] = int_stack + 14103;
 Libderiv->deriv_classes[1][5][10] = int_stack + 14148;
 Libderiv->deriv2_classes[1][4][10] = int_stack + 14211;
 Libderiv->deriv2_classes[1][5][10] = int_stack + 14256;
 Libderiv->deriv2_classes[2][4][10] = int_stack + 14319;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 14409;
 Libderiv->deriv_classes[1][4][9] = int_stack + 14535;
 Libderiv->deriv_classes[1][5][9] = int_stack + 14580;
 Libderiv->deriv2_classes[1][4][9] = int_stack + 14643;
 Libderiv->deriv2_classes[1][5][9] = int_stack + 14688;
 Libderiv->deriv2_classes[2][4][9] = int_stack + 14751;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 14841;
 Libderiv->deriv_classes[1][4][8] = int_stack + 14967;
 Libderiv->deriv_classes[1][5][8] = int_stack + 15012;
 Libderiv->deriv2_classes[1][4][8] = int_stack + 15075;
 Libderiv->deriv2_classes[1][5][8] = int_stack + 15120;
 Libderiv->deriv2_classes[2][4][8] = int_stack + 15183;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 15273;
 Libderiv->deriv_classes[1][4][7] = int_stack + 15399;
 Libderiv->deriv_classes[1][5][7] = int_stack + 15444;
 Libderiv->deriv2_classes[1][4][7] = int_stack + 15507;
 Libderiv->deriv2_classes[1][5][7] = int_stack + 15552;
 Libderiv->deriv2_classes[2][4][7] = int_stack + 15615;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 15705;
 Libderiv->dvrr_classes[1][4] = int_stack + 15831;
 Libderiv->deriv_classes[1][4][6] = int_stack + 15876;
 Libderiv->deriv_classes[1][5][6] = int_stack + 15921;
 Libderiv->deriv2_classes[1][4][6] = int_stack + 15984;
 Libderiv->deriv2_classes[1][5][6] = int_stack + 16029;
 Libderiv->deriv_classes[2][4][0] = int_stack + 16092;
 Libderiv->deriv2_classes[2][4][6] = int_stack + 16182;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 16272;
 Libderiv->deriv_classes[1][4][2] = int_stack + 16398;
 Libderiv->deriv_classes[1][5][2] = int_stack + 16443;
 Libderiv->deriv2_classes[1][4][2] = int_stack + 16506;
 Libderiv->deriv2_classes[1][5][2] = int_stack + 16551;
 Libderiv->deriv2_classes[2][4][2] = int_stack + 16614;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 16704;
 Libderiv->deriv_classes[1][4][1] = int_stack + 16830;
 Libderiv->deriv_classes[1][5][1] = int_stack + 16875;
 Libderiv->deriv2_classes[1][4][1] = int_stack + 16938;
 Libderiv->deriv2_classes[1][5][1] = int_stack + 16983;
 Libderiv->deriv2_classes[2][4][1] = int_stack + 17046;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 17136;
 Libderiv->deriv_classes[1][4][0] = int_stack + 17262;
 Libderiv->deriv_classes[1][5][0] = int_stack + 17307;
 Libderiv->deriv2_classes[1][4][0] = int_stack + 17370;
 Libderiv->deriv2_classes[1][5][0] = int_stack + 17415;
 Libderiv->deriv2_classes[2][4][0] = int_stack + 17478;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 17568;
 memset(int_stack,0,141552);

 Libderiv->dvrr_stack = int_stack + 24579;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_ppgp(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17694,int_stack+13716,int_stack+13671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15831,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17829,int_stack+0,int_stack+6255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18099,int_stack+14148,int_stack+14103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15831, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18234,int_stack+126,int_stack+6669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+14580,int_stack+14535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15831, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18504,int_stack+252,int_stack+7083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+135,int_stack+15012,int_stack+14967, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18774,int_stack+378,int_stack+7497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+270,int_stack+15444,int_stack+15399, 0.0, zero_stack, 1.0, int_stack+15831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+19044,int_stack+504,int_stack+7911, 0.0, zero_stack, 1.0, int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+405,int_stack+15921,int_stack+15876, 1.0, int_stack+15831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+19314,int_stack+720,int_stack+8325, 1.0, int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+540,int_stack+1098,int_stack+15831,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+675,int_stack+16443,int_stack+16398,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+19584,int_stack+846,int_stack+10359,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+16875,int_stack+16830,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+19854,int_stack+972,int_stack+12717,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+945,int_stack+17307,int_stack+17262,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+20124,int_stack+1161,int_stack+16092,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1080,int_stack+1332,int_stack+1287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+13671,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20394,int_stack+1485,int_stack+1395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6255,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1215,int_stack+1656,int_stack+1611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13671, 1.0, int_stack+14103,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+1809,int_stack+1719, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6255, 1.0, int_stack+6669,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1620,int_stack+1980,int_stack+1935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+14103, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1755,int_stack+2133,int_stack+2043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6669, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2025,int_stack+2304,int_stack+2259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13671, 0.0, zero_stack, 1.0, int_stack+14535,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20664,int_stack+2457,int_stack+2367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6255, 0.0, zero_stack, 1.0, int_stack+7083,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2160,int_stack+2628,int_stack+2583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14103, 1.0, int_stack+14535, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2295,int_stack+2781,int_stack+2691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6669, 1.0, int_stack+7083, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2565,int_stack+2952,int_stack+2907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+14535, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2700,int_stack+3105,int_stack+3015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7083, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2970,int_stack+3276,int_stack+3231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14967,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20934,int_stack+3429,int_stack+3339, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7497,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3105,int_stack+3600,int_stack+3555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14103, 0.0, zero_stack, 1.0, int_stack+14967, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3240,int_stack+3753,int_stack+3663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6669, 0.0, zero_stack, 1.0, int_stack+7497, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3510,int_stack+3924,int_stack+3879, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14535, 1.0, int_stack+14967, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3645,int_stack+4077,int_stack+3987, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7083, 1.0, int_stack+7497, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3915,int_stack+4248,int_stack+4203, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+14967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21204,int_stack+4401,int_stack+4311, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4050,int_stack+4572,int_stack+4527, 0.0, zero_stack, 1.0, int_stack+13671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15399,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4185,int_stack+4725,int_stack+4635, 0.0, zero_stack, 1.0, int_stack+6255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7911,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4455,int_stack+4896,int_stack+4851, 0.0, zero_stack, 1.0, int_stack+14103, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15399, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4590,int_stack+5049,int_stack+4959, 0.0, zero_stack, 1.0, int_stack+6669, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7911, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4860,int_stack+5220,int_stack+5175, 0.0, zero_stack, 1.0, int_stack+14535, 0.0, zero_stack, 1.0, int_stack+15399, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4995,int_stack+5373,int_stack+5283, 0.0, zero_stack, 1.0, int_stack+7083, 0.0, zero_stack, 1.0, int_stack+7911, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5265,int_stack+5544,int_stack+5499, 0.0, zero_stack, 1.0, int_stack+14967, 1.0, int_stack+15399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21474,int_stack+5697,int_stack+5607, 0.0, zero_stack, 1.0, int_stack+7497, 1.0, int_stack+7911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5400,int_stack+5868,int_stack+5823, 0.0, zero_stack, 2.0, int_stack+15399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5535,int_stack+6021,int_stack+5931, 0.0, zero_stack, 2.0, int_stack+7911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5805,int_stack+6192,int_stack+6147, 1.0, int_stack+13671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15876,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5940,int_stack+6435,int_stack+6345, 1.0, int_stack+6255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8325,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6210,int_stack+6606,int_stack+6561, 1.0, int_stack+14103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6345,int_stack+6849,int_stack+6759, 1.0, int_stack+6669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8325, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6615,int_stack+7020,int_stack+6975, 1.0, int_stack+14535, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6750,int_stack+7263,int_stack+7173, 1.0, int_stack+7083, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8325, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7020,int_stack+7434,int_stack+7389, 1.0, int_stack+14967, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7155,int_stack+7677,int_stack+7587, 1.0, int_stack+7497, 0.0, zero_stack, 1.0, int_stack+8325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7425,int_stack+7848,int_stack+7803, 1.0, int_stack+15399, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7560,int_stack+8091,int_stack+8001, 1.0, int_stack+7911, 1.0, int_stack+8325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7830,int_stack+8262,int_stack+8217, 2.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7965,int_stack+8505,int_stack+8415, 2.0, int_stack+8325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15831,int_stack+8676,int_stack+8631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16398,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8235,int_stack+8829,int_stack+8739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10359,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8505,int_stack+9000,int_stack+8955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16398, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8640,int_stack+9153,int_stack+9063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10359, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8910,int_stack+9324,int_stack+9279, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16398, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9045,int_stack+9477,int_stack+9387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10359, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9315,int_stack+9648,int_stack+9603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21744,int_stack+9801,int_stack+9711, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9450,int_stack+9972,int_stack+9927, 0.0, zero_stack, 1.0, int_stack+16398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9585,int_stack+10125,int_stack+10035, 0.0, zero_stack, 1.0, int_stack+10359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9855,int_stack+10296,int_stack+10251, 1.0, int_stack+16398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9990,int_stack+10539,int_stack+10449, 1.0, int_stack+10359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+10260,int_stack+10710,int_stack+10665,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+10395,int_stack+10863,int_stack+10773,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10665,int_stack+11034,int_stack+10989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16830,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10800,int_stack+11187,int_stack+11097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12717,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11070,int_stack+11358,int_stack+11313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16830, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22014,int_stack+11511,int_stack+11421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12717, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11205,int_stack+11682,int_stack+11637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16830, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11340,int_stack+11835,int_stack+11745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12717, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11610,int_stack+12006,int_stack+11961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11745,int_stack+12159,int_stack+12069, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12015,int_stack+12330,int_stack+12285, 0.0, zero_stack, 1.0, int_stack+16830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22284,int_stack+12483,int_stack+12393, 0.0, zero_stack, 1.0, int_stack+12717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12150,int_stack+12654,int_stack+12609, 1.0, int_stack+16830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12285,int_stack+12897,int_stack+12807, 1.0, int_stack+12717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12555,int_stack+13068,int_stack+13023,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12690,int_stack+13221,int_stack+13131,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12960,int_stack+13392,int_stack+13347,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+13095,int_stack+13545,int_stack+13455,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13365,int_stack+13824,int_stack+13779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17262,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13500,int_stack+13977,int_stack+13887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16092,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13770,int_stack+14256,int_stack+14211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17262, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13905,int_stack+14409,int_stack+14319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16092, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14175,int_stack+14688,int_stack+14643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17262, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14310,int_stack+14841,int_stack+14751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16092, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14580,int_stack+15120,int_stack+15075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14715,int_stack+15273,int_stack+15183, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14985,int_stack+15552,int_stack+15507, 0.0, zero_stack, 1.0, int_stack+17262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15120,int_stack+15705,int_stack+15615, 0.0, zero_stack, 1.0, int_stack+16092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15390,int_stack+16029,int_stack+15984, 1.0, int_stack+17262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15525,int_stack+16272,int_stack+16182, 1.0, int_stack+16092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+15966,int_stack+16551,int_stack+16506,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+16101,int_stack+16704,int_stack+16614,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+16371,int_stack+16983,int_stack+16938,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+16506,int_stack+17136,int_stack+17046,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+16776,int_stack+17415,int_stack+17370,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+16911,int_stack+17568,int_stack+17478,6);
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+17181,int_stack+17829,int_stack+17694,45);
     Libderiv->ABCD[11] = int_stack + 17181;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+22554,int_stack+18234,int_stack+18099,45);
     Libderiv->ABCD[10] = int_stack + 22554;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+22959,int_stack+18504,int_stack+0,45);
     Libderiv->ABCD[9] = int_stack + 22959;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+18234,int_stack+18774,int_stack+135,45);
     Libderiv->ABCD[8] = int_stack + 18234;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+18639,int_stack+19044,int_stack+270,45);
     Libderiv->ABCD[7] = int_stack + 18639;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+23364,int_stack+19314,int_stack+405,45);
     Libderiv->ABCD[6] = int_stack + 23364;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+19044,int_stack+19584,int_stack+675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[2] = int_stack + 19044;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+19449,int_stack+19854,int_stack+810, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[1] = int_stack + 19449;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+23769,int_stack+20124,int_stack+945, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[0] = int_stack + 23769;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+19854,int_stack+20394,int_stack+1080,45);
     Libderiv->ABCD[155] = int_stack + 19854;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+20259,int_stack+1350,int_stack+1215,45);
     Libderiv->ABCD[143] = int_stack + 20259;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1080,int_stack+1755,int_stack+1620,45);
     Libderiv->ABCD[142] = int_stack + 1080;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1485,int_stack+20664,int_stack+2025,45);
     Libderiv->ABCD[131] = int_stack + 1485;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+24174,int_stack+2295,int_stack+2160,45);
     Libderiv->ABCD[130] = int_stack + 24174;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1890,int_stack+2700,int_stack+2565,45);
     Libderiv->ABCD[129] = int_stack + 1890;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2295,int_stack+20934,int_stack+2970,45);
     Libderiv->ABCD[119] = int_stack + 2295;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2700,int_stack+3240,int_stack+3105,45);
     Libderiv->ABCD[118] = int_stack + 2700;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3105,int_stack+3645,int_stack+3510,45);
     Libderiv->ABCD[117] = int_stack + 3105;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3510,int_stack+21204,int_stack+3915,45);
     Libderiv->ABCD[116] = int_stack + 3510;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+20664,int_stack+4185,int_stack+4050,45);
     Libderiv->ABCD[107] = int_stack + 20664;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+21069,int_stack+4590,int_stack+4455,45);
     Libderiv->ABCD[106] = int_stack + 21069;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3915,int_stack+4995,int_stack+4860,45);
     Libderiv->ABCD[105] = int_stack + 3915;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4320,int_stack+21474,int_stack+5265,45);
     Libderiv->ABCD[104] = int_stack + 4320;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4725,int_stack+5535,int_stack+5400,45);
     Libderiv->ABCD[103] = int_stack + 4725;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+5130,int_stack+5940,int_stack+5805,45);
     Libderiv->ABCD[95] = int_stack + 5130;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+5535,int_stack+6345,int_stack+6210,45);
     Libderiv->ABCD[94] = int_stack + 5535;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+5940,int_stack+6750,int_stack+6615,45);
     Libderiv->ABCD[93] = int_stack + 5940;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+6345,int_stack+7155,int_stack+7020,45);
     Libderiv->ABCD[92] = int_stack + 6345;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+6750,int_stack+7560,int_stack+7425,45);
     Libderiv->ABCD[91] = int_stack + 6750;
 /*--- compute (pp|gp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+7155,int_stack+7965,int_stack+7830,45);
     Libderiv->ABCD[90] = int_stack + 7155;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+7560,int_stack+8235,int_stack+15831, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[47] = int_stack + 7560;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+7965,int_stack+8640,int_stack+8505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[46] = int_stack + 7965;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+8370,int_stack+9045,int_stack+8910, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[45] = int_stack + 8370;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+8775,int_stack+21744,int_stack+9315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[44] = int_stack + 8775;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+21474,int_stack+9585,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[43] = int_stack + 21474;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+9180,int_stack+9990,int_stack+9855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[42] = int_stack + 9180;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+9585,int_stack+10395,int_stack+10260, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[38] = int_stack + 9585;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+9990,int_stack+10800,int_stack+10665, 0.0, zero_stack, 1.0, int_stack+17694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[35] = int_stack + 9990;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+10395,int_stack+22014,int_stack+11070, 0.0, zero_stack, 1.0, int_stack+18099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[34] = int_stack + 10395;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+21879,int_stack+11340,int_stack+11205, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[33] = int_stack + 21879;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+10800,int_stack+11745,int_stack+11610, 0.0, zero_stack, 1.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[32] = int_stack + 10800;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+11205,int_stack+22284,int_stack+12015, 0.0, zero_stack, 1.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[31] = int_stack + 11205;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+11610,int_stack+12285,int_stack+12150, 0.0, zero_stack, 1.0, int_stack+405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[30] = int_stack + 11610;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+12015,int_stack+12690,int_stack+12555, 0.0, zero_stack, 1.0, int_stack+675, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[26] = int_stack + 12015;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+12420,int_stack+13095,int_stack+12960, 0.0, zero_stack, 2.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[25] = int_stack + 12420;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+12825,int_stack+13500,int_stack+13365, 1.0, int_stack+17694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[23] = int_stack + 12825;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+13230,int_stack+13905,int_stack+13770, 1.0, int_stack+18099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[22] = int_stack + 13230;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+13635,int_stack+14310,int_stack+14175, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[21] = int_stack + 13635;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+14040,int_stack+14715,int_stack+14580, 1.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[20] = int_stack + 14040;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+14445,int_stack+15120,int_stack+14985, 1.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[19] = int_stack + 14445;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+0,int_stack+15525,int_stack+15390, 1.0, int_stack+405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[18] = int_stack + 0;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+14850,int_stack+16101,int_stack+15966, 1.0, int_stack+675, 0.0, zero_stack, 1.0, int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[14] = int_stack + 14850;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+405,int_stack+16506,int_stack+16371, 1.0, int_stack+810, 1.0, int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[13] = int_stack + 405;
 /*--- compute (pp|gp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+15255,int_stack+16911,int_stack+16776, 2.0, int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[12] = int_stack + 15255;

}
