/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_pph0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (pp|h0) integrals */

void d12hrr_order_pph0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][5][11] = int_stack + 0;
 Libderiv->deriv_classes[2][5][10] = int_stack + 126;
 Libderiv->deriv_classes[2][5][9] = int_stack + 252;
 Libderiv->deriv_classes[2][5][8] = int_stack + 378;
 Libderiv->deriv_classes[2][5][7] = int_stack + 504;
 Libderiv->deriv_classes[2][5][6] = int_stack + 630;
 Libderiv->deriv_classes[2][5][2] = int_stack + 756;
 Libderiv->deriv_classes[2][5][1] = int_stack + 882;
 Libderiv->dvrr_classes[1][5] = int_stack + 1008;
 Libderiv->deriv_classes[2][5][0] = int_stack + 1071;
 Libderiv->deriv2_classes[1][5][143] = int_stack + 1197;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 1260;
 Libderiv->deriv2_classes[1][5][131] = int_stack + 1386;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 1449;
 Libderiv->deriv2_classes[1][5][130] = int_stack + 1575;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 1638;
 Libderiv->deriv2_classes[1][5][119] = int_stack + 1764;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 1827;
 Libderiv->deriv2_classes[1][5][118] = int_stack + 1953;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 2016;
 Libderiv->deriv2_classes[1][5][117] = int_stack + 2142;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 2205;
 Libderiv->deriv2_classes[1][5][107] = int_stack + 2331;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 2394;
 Libderiv->deriv2_classes[1][5][106] = int_stack + 2520;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 2583;
 Libderiv->deriv2_classes[1][5][105] = int_stack + 2709;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 2772;
 Libderiv->deriv2_classes[1][5][104] = int_stack + 2898;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 2961;
 Libderiv->deriv2_classes[1][5][95] = int_stack + 3087;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 3150;
 Libderiv->deriv2_classes[1][5][94] = int_stack + 3276;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 3339;
 Libderiv->deriv2_classes[1][5][93] = int_stack + 3465;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 3528;
 Libderiv->deriv2_classes[1][5][92] = int_stack + 3654;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 3717;
 Libderiv->deriv2_classes[1][5][91] = int_stack + 3843;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 3906;
 Libderiv->deriv2_classes[1][5][83] = int_stack + 4032;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 4095;
 Libderiv->deriv2_classes[1][5][82] = int_stack + 4221;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 4284;
 Libderiv->deriv2_classes[1][5][81] = int_stack + 4410;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 4473;
 Libderiv->deriv2_classes[1][5][80] = int_stack + 4599;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 4662;
 Libderiv->deriv2_classes[1][5][79] = int_stack + 4788;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 4851;
 Libderiv->deriv2_classes[1][5][78] = int_stack + 4977;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 5040;
 Libderiv->deriv2_classes[1][5][35] = int_stack + 5166;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 5229;
 Libderiv->deriv2_classes[1][5][34] = int_stack + 5355;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 5418;
 Libderiv->deriv2_classes[1][5][33] = int_stack + 5544;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 5607;
 Libderiv->deriv2_classes[1][5][32] = int_stack + 5733;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 5796;
 Libderiv->deriv2_classes[1][5][31] = int_stack + 5922;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 5985;
 Libderiv->deriv2_classes[1][5][30] = int_stack + 6111;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 6174;
 Libderiv->deriv2_classes[1][5][26] = int_stack + 6300;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 6363;
 Libderiv->deriv2_classes[1][5][23] = int_stack + 6489;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 6552;
 Libderiv->deriv2_classes[1][5][22] = int_stack + 6678;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 6741;
 Libderiv->deriv2_classes[1][5][21] = int_stack + 6867;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 6930;
 Libderiv->deriv2_classes[1][5][20] = int_stack + 7056;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 7119;
 Libderiv->deriv2_classes[1][5][19] = int_stack + 7245;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 7308;
 Libderiv->deriv2_classes[1][5][18] = int_stack + 7434;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 7497;
 Libderiv->deriv2_classes[1][5][14] = int_stack + 7623;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 7686;
 Libderiv->deriv2_classes[1][5][13] = int_stack + 7812;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 7875;
 Libderiv->deriv_classes[1][5][11] = int_stack + 8001;
 Libderiv->deriv2_classes[1][5][11] = int_stack + 8064;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 8127;
 Libderiv->deriv_classes[1][5][10] = int_stack + 8253;
 Libderiv->deriv2_classes[1][5][10] = int_stack + 8316;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 8379;
 Libderiv->deriv_classes[1][5][9] = int_stack + 8505;
 Libderiv->deriv2_classes[1][5][9] = int_stack + 8568;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 8631;
 Libderiv->deriv_classes[1][5][8] = int_stack + 8757;
 Libderiv->deriv2_classes[1][5][8] = int_stack + 8820;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 8883;
 Libderiv->deriv_classes[1][5][7] = int_stack + 9009;
 Libderiv->deriv2_classes[1][5][7] = int_stack + 9072;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 9135;
 Libderiv->deriv_classes[1][5][6] = int_stack + 9261;
 Libderiv->deriv2_classes[1][5][6] = int_stack + 9324;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 9387;
 Libderiv->deriv_classes[1][5][2] = int_stack + 9513;
 Libderiv->deriv2_classes[1][5][2] = int_stack + 9576;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 9639;
 Libderiv->deriv_classes[1][5][1] = int_stack + 9765;
 Libderiv->deriv2_classes[1][5][1] = int_stack + 9828;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 9891;
 Libderiv->deriv_classes[1][5][0] = int_stack + 10017;
 Libderiv->deriv2_classes[1][5][0] = int_stack + 10080;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 10143;
 memset(int_stack,0,82152);

 Libderiv->dvrr_stack = int_stack + 11025;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_pph0(Libderiv, Data);
   Data++;
 }

 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+10269,int_stack+0,int_stack+8001,21);
     Libderiv->ABCD[11] = int_stack + 10269;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+10458,int_stack+126,int_stack+8253,21);
     Libderiv->ABCD[10] = int_stack + 10458;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+0,int_stack+252,int_stack+8505,21);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+189,int_stack+378,int_stack+8757,21);
     Libderiv->ABCD[8] = int_stack + 189;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+10647,int_stack+504,int_stack+9009,21);
     Libderiv->ABCD[7] = int_stack + 10647;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+378,int_stack+630,int_stack+9261,21);
     Libderiv->ABCD[6] = int_stack + 378;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+567,int_stack+756,int_stack+9513, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[2] = int_stack + 567;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+10836,int_stack+882,int_stack+9765, 0.0, zero_stack, 1.0, int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[1] = int_stack + 10836;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+756,int_stack+1071,int_stack+10017, 1.0, int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[0] = int_stack + 756;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+945,int_stack+1260,int_stack+1197,21);
     Libderiv->ABCD[155] = int_stack + 945;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1134,int_stack+1449,int_stack+1386,21);
     Libderiv->ABCD[143] = int_stack + 1134;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1323,int_stack+1638,int_stack+1575,21);
     Libderiv->ABCD[142] = int_stack + 1323;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1512,int_stack+1827,int_stack+1764,21);
     Libderiv->ABCD[131] = int_stack + 1512;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1701,int_stack+2016,int_stack+1953,21);
     Libderiv->ABCD[130] = int_stack + 1701;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1890,int_stack+2205,int_stack+2142,21);
     Libderiv->ABCD[129] = int_stack + 1890;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2079,int_stack+2394,int_stack+2331,21);
     Libderiv->ABCD[119] = int_stack + 2079;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2268,int_stack+2583,int_stack+2520,21);
     Libderiv->ABCD[118] = int_stack + 2268;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2457,int_stack+2772,int_stack+2709,21);
     Libderiv->ABCD[117] = int_stack + 2457;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2646,int_stack+2961,int_stack+2898,21);
     Libderiv->ABCD[116] = int_stack + 2646;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2835,int_stack+3150,int_stack+3087,21);
     Libderiv->ABCD[107] = int_stack + 2835;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3024,int_stack+3339,int_stack+3276,21);
     Libderiv->ABCD[106] = int_stack + 3024;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3213,int_stack+3528,int_stack+3465,21);
     Libderiv->ABCD[105] = int_stack + 3213;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3402,int_stack+3717,int_stack+3654,21);
     Libderiv->ABCD[104] = int_stack + 3402;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3591,int_stack+3906,int_stack+3843,21);
     Libderiv->ABCD[103] = int_stack + 3591;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3780,int_stack+4095,int_stack+4032,21);
     Libderiv->ABCD[95] = int_stack + 3780;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3969,int_stack+4284,int_stack+4221,21);
     Libderiv->ABCD[94] = int_stack + 3969;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4158,int_stack+4473,int_stack+4410,21);
     Libderiv->ABCD[93] = int_stack + 4158;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4347,int_stack+4662,int_stack+4599,21);
     Libderiv->ABCD[92] = int_stack + 4347;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4536,int_stack+4851,int_stack+4788,21);
     Libderiv->ABCD[91] = int_stack + 4536;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4725,int_stack+5040,int_stack+4977,21);
     Libderiv->ABCD[90] = int_stack + 4725;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+4914,int_stack+5229,int_stack+5166, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[47] = int_stack + 4914;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+5103,int_stack+5418,int_stack+5355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[46] = int_stack + 5103;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+5292,int_stack+5607,int_stack+5544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[45] = int_stack + 5292;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+5481,int_stack+5796,int_stack+5733, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[44] = int_stack + 5481;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+5670,int_stack+5985,int_stack+5922, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[43] = int_stack + 5670;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+5859,int_stack+6174,int_stack+6111, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[42] = int_stack + 5859;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+6048,int_stack+6363,int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[38] = int_stack + 6048;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+6237,int_stack+6552,int_stack+6489, 0.0, zero_stack, 1.0, int_stack+8001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[35] = int_stack + 6237;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+6426,int_stack+6741,int_stack+6678, 0.0, zero_stack, 1.0, int_stack+8253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[34] = int_stack + 6426;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+6615,int_stack+6930,int_stack+6867, 0.0, zero_stack, 1.0, int_stack+8505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[33] = int_stack + 6615;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+6804,int_stack+7119,int_stack+7056, 0.0, zero_stack, 1.0, int_stack+8757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[32] = int_stack + 6804;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+6993,int_stack+7308,int_stack+7245, 0.0, zero_stack, 1.0, int_stack+9009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[31] = int_stack + 6993;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+7182,int_stack+7497,int_stack+7434, 0.0, zero_stack, 1.0, int_stack+9261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[30] = int_stack + 7182;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+7371,int_stack+7686,int_stack+7623, 0.0, zero_stack, 1.0, int_stack+9513, 1.0, int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[26] = int_stack + 7371;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+7560,int_stack+7875,int_stack+7812, 0.0, zero_stack, 2.0, int_stack+9765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[25] = int_stack + 7560;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+7749,int_stack+8127,int_stack+8064, 1.0, int_stack+8001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[23] = int_stack + 7749;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+7938,int_stack+8379,int_stack+8316, 1.0, int_stack+8253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[22] = int_stack + 7938;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+8127,int_stack+8631,int_stack+8568, 1.0, int_stack+8505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[21] = int_stack + 8127;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+8316,int_stack+8883,int_stack+8820, 1.0, int_stack+8757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[20] = int_stack + 8316;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+8505,int_stack+9135,int_stack+9072, 1.0, int_stack+9009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[19] = int_stack + 8505;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+8694,int_stack+9387,int_stack+9324, 1.0, int_stack+9261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[18] = int_stack + 8694;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+8883,int_stack+9639,int_stack+9576, 1.0, int_stack+9513, 0.0, zero_stack, 1.0, int_stack+10017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[14] = int_stack + 8883;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+9072,int_stack+9891,int_stack+9828, 1.0, int_stack+9765, 1.0, int_stack+10017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[13] = int_stack + 9072;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+9261,int_stack+10143,int_stack+10080, 2.0, int_stack+10017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[12] = int_stack + 9261;

}
