/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_pphd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (pp|hd) integrals */

void d12hrr_order_pphd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][7][11] = int_stack + 0;
 Libderiv->deriv_classes[2][7][10] = int_stack + 216;
 Libderiv->deriv_classes[2][7][9] = int_stack + 432;
 Libderiv->deriv_classes[2][7][8] = int_stack + 648;
 Libderiv->deriv_classes[2][7][7] = int_stack + 864;
 Libderiv->dvrr_classes[2][6] = int_stack + 1080;
 Libderiv->deriv_classes[2][7][6] = int_stack + 1248;
 Libderiv->deriv_classes[2][7][2] = int_stack + 1464;
 Libderiv->deriv_classes[2][7][1] = int_stack + 1680;
 Libderiv->dvrr_classes[1][7] = int_stack + 1896;
 Libderiv->deriv_classes[2][7][0] = int_stack + 2004;
 Libderiv->deriv2_classes[1][5][143] = int_stack + 2220;
 Libderiv->deriv2_classes[1][6][143] = int_stack + 2283;
 Libderiv->deriv2_classes[1][7][143] = int_stack + 2367;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 2475;
 Libderiv->deriv2_classes[2][6][143] = int_stack + 2601;
 Libderiv->deriv2_classes[2][7][143] = int_stack + 2769;
 Libderiv->deriv2_classes[1][5][131] = int_stack + 2985;
 Libderiv->deriv2_classes[1][6][131] = int_stack + 3048;
 Libderiv->deriv2_classes[1][7][131] = int_stack + 3132;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 3240;
 Libderiv->deriv2_classes[2][6][131] = int_stack + 3366;
 Libderiv->deriv2_classes[2][7][131] = int_stack + 3534;
 Libderiv->deriv2_classes[1][5][130] = int_stack + 3750;
 Libderiv->deriv2_classes[1][6][130] = int_stack + 3813;
 Libderiv->deriv2_classes[1][7][130] = int_stack + 3897;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 4005;
 Libderiv->deriv2_classes[2][6][130] = int_stack + 4131;
 Libderiv->deriv2_classes[2][7][130] = int_stack + 4299;
 Libderiv->deriv2_classes[1][5][119] = int_stack + 4515;
 Libderiv->deriv2_classes[1][6][119] = int_stack + 4578;
 Libderiv->deriv2_classes[1][7][119] = int_stack + 4662;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 4770;
 Libderiv->deriv2_classes[2][6][119] = int_stack + 4896;
 Libderiv->deriv2_classes[2][7][119] = int_stack + 5064;
 Libderiv->deriv2_classes[1][5][118] = int_stack + 5280;
 Libderiv->deriv2_classes[1][6][118] = int_stack + 5343;
 Libderiv->deriv2_classes[1][7][118] = int_stack + 5427;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 5535;
 Libderiv->deriv2_classes[2][6][118] = int_stack + 5661;
 Libderiv->deriv2_classes[2][7][118] = int_stack + 5829;
 Libderiv->deriv2_classes[1][5][117] = int_stack + 6045;
 Libderiv->deriv2_classes[1][6][117] = int_stack + 6108;
 Libderiv->deriv2_classes[1][7][117] = int_stack + 6192;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 6300;
 Libderiv->deriv2_classes[2][6][117] = int_stack + 6426;
 Libderiv->deriv2_classes[2][7][117] = int_stack + 6594;
 Libderiv->deriv2_classes[1][5][107] = int_stack + 6810;
 Libderiv->deriv2_classes[1][6][107] = int_stack + 6873;
 Libderiv->deriv2_classes[1][7][107] = int_stack + 6957;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 7065;
 Libderiv->deriv2_classes[2][6][107] = int_stack + 7191;
 Libderiv->deriv2_classes[2][7][107] = int_stack + 7359;
 Libderiv->deriv2_classes[1][5][106] = int_stack + 7575;
 Libderiv->deriv2_classes[1][6][106] = int_stack + 7638;
 Libderiv->deriv2_classes[1][7][106] = int_stack + 7722;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 7830;
 Libderiv->deriv2_classes[2][6][106] = int_stack + 7956;
 Libderiv->deriv2_classes[2][7][106] = int_stack + 8124;
 Libderiv->deriv2_classes[1][5][105] = int_stack + 8340;
 Libderiv->deriv2_classes[1][6][105] = int_stack + 8403;
 Libderiv->deriv2_classes[1][7][105] = int_stack + 8487;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 8595;
 Libderiv->deriv2_classes[2][6][105] = int_stack + 8721;
 Libderiv->deriv2_classes[2][7][105] = int_stack + 8889;
 Libderiv->deriv2_classes[1][5][104] = int_stack + 9105;
 Libderiv->deriv2_classes[1][6][104] = int_stack + 9168;
 Libderiv->deriv2_classes[1][7][104] = int_stack + 9252;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 9360;
 Libderiv->deriv2_classes[2][6][104] = int_stack + 9486;
 Libderiv->deriv2_classes[2][7][104] = int_stack + 9654;
 Libderiv->deriv2_classes[1][5][95] = int_stack + 9870;
 Libderiv->deriv2_classes[1][6][95] = int_stack + 9933;
 Libderiv->deriv2_classes[1][7][95] = int_stack + 10017;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 10125;
 Libderiv->deriv2_classes[2][6][95] = int_stack + 10251;
 Libderiv->deriv2_classes[2][7][95] = int_stack + 10419;
 Libderiv->deriv2_classes[1][5][94] = int_stack + 10635;
 Libderiv->deriv2_classes[1][6][94] = int_stack + 10698;
 Libderiv->deriv2_classes[1][7][94] = int_stack + 10782;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 10890;
 Libderiv->deriv2_classes[2][6][94] = int_stack + 11016;
 Libderiv->deriv2_classes[2][7][94] = int_stack + 11184;
 Libderiv->deriv2_classes[1][5][93] = int_stack + 11400;
 Libderiv->deriv2_classes[1][6][93] = int_stack + 11463;
 Libderiv->deriv2_classes[1][7][93] = int_stack + 11547;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 11655;
 Libderiv->deriv2_classes[2][6][93] = int_stack + 11781;
 Libderiv->deriv2_classes[2][7][93] = int_stack + 11949;
 Libderiv->deriv2_classes[1][5][92] = int_stack + 12165;
 Libderiv->deriv2_classes[1][6][92] = int_stack + 12228;
 Libderiv->deriv2_classes[1][7][92] = int_stack + 12312;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 12420;
 Libderiv->deriv2_classes[2][6][92] = int_stack + 12546;
 Libderiv->deriv2_classes[2][7][92] = int_stack + 12714;
 Libderiv->deriv2_classes[1][5][91] = int_stack + 12930;
 Libderiv->deriv2_classes[1][6][91] = int_stack + 12993;
 Libderiv->deriv2_classes[1][7][91] = int_stack + 13077;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 13185;
 Libderiv->deriv2_classes[2][6][91] = int_stack + 13311;
 Libderiv->deriv2_classes[2][7][91] = int_stack + 13479;
 Libderiv->deriv2_classes[1][5][83] = int_stack + 13695;
 Libderiv->deriv2_classes[1][6][83] = int_stack + 13758;
 Libderiv->deriv2_classes[1][7][83] = int_stack + 13842;
 Libderiv->deriv_classes[2][5][11] = int_stack + 13950;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 14076;
 Libderiv->deriv_classes[2][6][11] = int_stack + 14202;
 Libderiv->deriv2_classes[2][6][83] = int_stack + 14370;
 Libderiv->deriv2_classes[2][7][83] = int_stack + 14538;
 Libderiv->deriv2_classes[1][5][82] = int_stack + 14754;
 Libderiv->deriv2_classes[1][6][82] = int_stack + 14817;
 Libderiv->deriv2_classes[1][7][82] = int_stack + 14901;
 Libderiv->deriv_classes[2][5][10] = int_stack + 15009;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 15135;
 Libderiv->deriv_classes[2][6][10] = int_stack + 15261;
 Libderiv->deriv2_classes[2][6][82] = int_stack + 15429;
 Libderiv->deriv2_classes[2][7][82] = int_stack + 15597;
 Libderiv->deriv2_classes[1][5][81] = int_stack + 15813;
 Libderiv->deriv2_classes[1][6][81] = int_stack + 15876;
 Libderiv->deriv2_classes[1][7][81] = int_stack + 15960;
 Libderiv->deriv_classes[2][5][9] = int_stack + 16068;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 16194;
 Libderiv->deriv_classes[2][6][9] = int_stack + 16320;
 Libderiv->deriv2_classes[2][6][81] = int_stack + 16488;
 Libderiv->deriv2_classes[2][7][81] = int_stack + 16656;
 Libderiv->deriv2_classes[1][5][80] = int_stack + 16872;
 Libderiv->deriv2_classes[1][6][80] = int_stack + 16935;
 Libderiv->deriv2_classes[1][7][80] = int_stack + 17019;
 Libderiv->deriv_classes[2][5][8] = int_stack + 17127;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 17253;
 Libderiv->deriv_classes[2][6][8] = int_stack + 17379;
 Libderiv->deriv2_classes[2][6][80] = int_stack + 17547;
 Libderiv->deriv2_classes[2][7][80] = int_stack + 17715;
 Libderiv->deriv2_classes[1][5][79] = int_stack + 17931;
 Libderiv->deriv2_classes[1][6][79] = int_stack + 17994;
 Libderiv->deriv2_classes[1][7][79] = int_stack + 18078;
 Libderiv->deriv_classes[2][5][7] = int_stack + 18186;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 18312;
 Libderiv->deriv_classes[2][6][7] = int_stack + 18438;
 Libderiv->deriv2_classes[2][6][79] = int_stack + 18606;
 Libderiv->deriv2_classes[2][7][79] = int_stack + 18774;
 Libderiv->deriv2_classes[1][5][78] = int_stack + 18990;
 Libderiv->deriv2_classes[1][6][78] = int_stack + 19053;
 Libderiv->deriv2_classes[1][7][78] = int_stack + 19137;
 Libderiv->dvrr_classes[2][5] = int_stack + 19245;
 Libderiv->deriv_classes[2][5][6] = int_stack + 19371;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 19497;
 Libderiv->deriv_classes[2][6][6] = int_stack + 19623;
 Libderiv->deriv2_classes[2][6][78] = int_stack + 19791;
 Libderiv->deriv2_classes[2][7][78] = int_stack + 19959;
 Libderiv->deriv2_classes[1][5][35] = int_stack + 20175;
 Libderiv->deriv2_classes[1][6][35] = int_stack + 20238;
 Libderiv->deriv2_classes[1][7][35] = int_stack + 20322;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 20430;
 Libderiv->deriv2_classes[2][6][35] = int_stack + 20556;
 Libderiv->deriv2_classes[2][7][35] = int_stack + 20724;
 Libderiv->deriv2_classes[1][5][34] = int_stack + 20940;
 Libderiv->deriv2_classes[1][6][34] = int_stack + 21003;
 Libderiv->deriv2_classes[1][7][34] = int_stack + 21087;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 21195;
 Libderiv->deriv2_classes[2][6][34] = int_stack + 21321;
 Libderiv->deriv2_classes[2][7][34] = int_stack + 21489;
 Libderiv->deriv2_classes[1][5][33] = int_stack + 21705;
 Libderiv->deriv2_classes[1][6][33] = int_stack + 21768;
 Libderiv->deriv2_classes[1][7][33] = int_stack + 21852;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 21960;
 Libderiv->deriv2_classes[2][6][33] = int_stack + 22086;
 Libderiv->deriv2_classes[2][7][33] = int_stack + 22254;
 Libderiv->deriv2_classes[1][5][32] = int_stack + 22470;
 Libderiv->deriv2_classes[1][6][32] = int_stack + 22533;
 Libderiv->deriv2_classes[1][7][32] = int_stack + 22617;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 22725;
 Libderiv->deriv2_classes[2][6][32] = int_stack + 22851;
 Libderiv->deriv2_classes[2][7][32] = int_stack + 23019;
 Libderiv->deriv2_classes[1][5][31] = int_stack + 23235;
 Libderiv->deriv2_classes[1][6][31] = int_stack + 23298;
 Libderiv->deriv2_classes[1][7][31] = int_stack + 23382;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 23490;
 Libderiv->deriv2_classes[2][6][31] = int_stack + 23616;
 Libderiv->deriv2_classes[2][7][31] = int_stack + 23784;
 Libderiv->deriv2_classes[1][5][30] = int_stack + 24000;
 Libderiv->deriv2_classes[1][6][30] = int_stack + 24063;
 Libderiv->deriv2_classes[1][7][30] = int_stack + 24147;
 Libderiv->deriv_classes[2][5][2] = int_stack + 24255;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 24381;
 Libderiv->deriv_classes[2][6][2] = int_stack + 24507;
 Libderiv->deriv2_classes[2][6][30] = int_stack + 24675;
 Libderiv->deriv2_classes[2][7][30] = int_stack + 24843;
 Libderiv->deriv2_classes[1][5][26] = int_stack + 25059;
 Libderiv->deriv2_classes[1][6][26] = int_stack + 25122;
 Libderiv->deriv2_classes[1][7][26] = int_stack + 25206;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 25314;
 Libderiv->deriv2_classes[2][6][26] = int_stack + 25440;
 Libderiv->deriv2_classes[2][7][26] = int_stack + 25608;
 Libderiv->deriv2_classes[1][5][23] = int_stack + 25824;
 Libderiv->deriv2_classes[1][6][23] = int_stack + 25887;
 Libderiv->deriv2_classes[1][7][23] = int_stack + 25971;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 26079;
 Libderiv->deriv2_classes[2][6][23] = int_stack + 26205;
 Libderiv->deriv2_classes[2][7][23] = int_stack + 26373;
 Libderiv->deriv2_classes[1][5][22] = int_stack + 26589;
 Libderiv->deriv2_classes[1][6][22] = int_stack + 26652;
 Libderiv->deriv2_classes[1][7][22] = int_stack + 26736;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 26844;
 Libderiv->deriv2_classes[2][6][22] = int_stack + 26970;
 Libderiv->deriv2_classes[2][7][22] = int_stack + 27138;
 Libderiv->deriv2_classes[1][5][21] = int_stack + 27354;
 Libderiv->deriv2_classes[1][6][21] = int_stack + 27417;
 Libderiv->deriv2_classes[1][7][21] = int_stack + 27501;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 27609;
 Libderiv->deriv2_classes[2][6][21] = int_stack + 27735;
 Libderiv->deriv2_classes[2][7][21] = int_stack + 27903;
 Libderiv->deriv2_classes[1][5][20] = int_stack + 28119;
 Libderiv->deriv2_classes[1][6][20] = int_stack + 28182;
 Libderiv->deriv2_classes[1][7][20] = int_stack + 28266;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 28374;
 Libderiv->deriv2_classes[2][6][20] = int_stack + 28500;
 Libderiv->deriv2_classes[2][7][20] = int_stack + 28668;
 Libderiv->deriv2_classes[1][5][19] = int_stack + 28884;
 Libderiv->deriv2_classes[1][6][19] = int_stack + 28947;
 Libderiv->deriv2_classes[1][7][19] = int_stack + 29031;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 29139;
 Libderiv->deriv2_classes[2][6][19] = int_stack + 29265;
 Libderiv->deriv2_classes[2][7][19] = int_stack + 29433;
 Libderiv->deriv2_classes[1][5][18] = int_stack + 29649;
 Libderiv->deriv2_classes[1][6][18] = int_stack + 29712;
 Libderiv->deriv2_classes[1][7][18] = int_stack + 29796;
 Libderiv->deriv_classes[2][5][1] = int_stack + 29904;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 30030;
 Libderiv->deriv_classes[2][6][1] = int_stack + 30156;
 Libderiv->deriv2_classes[2][6][18] = int_stack + 30324;
 Libderiv->deriv2_classes[2][7][18] = int_stack + 30492;
 Libderiv->deriv2_classes[1][5][14] = int_stack + 30708;
 Libderiv->deriv2_classes[1][6][14] = int_stack + 30771;
 Libderiv->deriv2_classes[1][7][14] = int_stack + 30855;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 30963;
 Libderiv->deriv2_classes[2][6][14] = int_stack + 31089;
 Libderiv->deriv2_classes[2][7][14] = int_stack + 31257;
 Libderiv->deriv2_classes[1][5][13] = int_stack + 31473;
 Libderiv->deriv2_classes[1][6][13] = int_stack + 31536;
 Libderiv->deriv2_classes[1][7][13] = int_stack + 31620;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 31728;
 Libderiv->deriv2_classes[2][6][13] = int_stack + 31854;
 Libderiv->deriv2_classes[2][7][13] = int_stack + 32022;
 Libderiv->deriv_classes[1][5][11] = int_stack + 32238;
 Libderiv->deriv_classes[1][6][11] = int_stack + 32301;
 Libderiv->deriv_classes[1][7][11] = int_stack + 32385;
 Libderiv->deriv2_classes[1][5][11] = int_stack + 32493;
 Libderiv->deriv2_classes[1][6][11] = int_stack + 32556;
 Libderiv->deriv2_classes[1][7][11] = int_stack + 32640;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 32748;
 Libderiv->deriv2_classes[2][6][11] = int_stack + 32874;
 Libderiv->deriv2_classes[2][7][11] = int_stack + 33042;
 Libderiv->deriv_classes[1][5][10] = int_stack + 33258;
 Libderiv->deriv_classes[1][6][10] = int_stack + 33321;
 Libderiv->deriv_classes[1][7][10] = int_stack + 33405;
 Libderiv->deriv2_classes[1][5][10] = int_stack + 33513;
 Libderiv->deriv2_classes[1][6][10] = int_stack + 33576;
 Libderiv->deriv2_classes[1][7][10] = int_stack + 33660;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 33768;
 Libderiv->deriv2_classes[2][6][10] = int_stack + 33894;
 Libderiv->deriv2_classes[2][7][10] = int_stack + 34062;
 Libderiv->deriv_classes[1][5][9] = int_stack + 34278;
 Libderiv->deriv_classes[1][6][9] = int_stack + 34341;
 Libderiv->deriv_classes[1][7][9] = int_stack + 34425;
 Libderiv->deriv2_classes[1][5][9] = int_stack + 34533;
 Libderiv->deriv2_classes[1][6][9] = int_stack + 34596;
 Libderiv->deriv2_classes[1][7][9] = int_stack + 34680;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 34788;
 Libderiv->deriv2_classes[2][6][9] = int_stack + 34914;
 Libderiv->deriv2_classes[2][7][9] = int_stack + 35082;
 Libderiv->deriv_classes[1][5][8] = int_stack + 35298;
 Libderiv->deriv_classes[1][6][8] = int_stack + 35361;
 Libderiv->deriv_classes[1][7][8] = int_stack + 35445;
 Libderiv->deriv2_classes[1][5][8] = int_stack + 35553;
 Libderiv->deriv2_classes[1][6][8] = int_stack + 35616;
 Libderiv->deriv2_classes[1][7][8] = int_stack + 35700;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 35808;
 Libderiv->deriv2_classes[2][6][8] = int_stack + 35934;
 Libderiv->deriv2_classes[2][7][8] = int_stack + 36102;
 Libderiv->deriv_classes[1][5][7] = int_stack + 36318;
 Libderiv->deriv_classes[1][6][7] = int_stack + 36381;
 Libderiv->deriv_classes[1][7][7] = int_stack + 36465;
 Libderiv->deriv2_classes[1][5][7] = int_stack + 36573;
 Libderiv->deriv2_classes[1][6][7] = int_stack + 36636;
 Libderiv->deriv2_classes[1][7][7] = int_stack + 36720;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 36828;
 Libderiv->deriv2_classes[2][6][7] = int_stack + 36954;
 Libderiv->deriv2_classes[2][7][7] = int_stack + 37122;
 Libderiv->dvrr_classes[1][5] = int_stack + 37338;
 Libderiv->deriv_classes[1][5][6] = int_stack + 37401;
 Libderiv->dvrr_classes[1][6] = int_stack + 37464;
 Libderiv->deriv_classes[1][6][6] = int_stack + 37548;
 Libderiv->deriv_classes[1][7][6] = int_stack + 37632;
 Libderiv->deriv2_classes[1][5][6] = int_stack + 37740;
 Libderiv->deriv2_classes[1][6][6] = int_stack + 37803;
 Libderiv->deriv2_classes[1][7][6] = int_stack + 37887;
 Libderiv->deriv_classes[2][5][0] = int_stack + 37995;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 38121;
 Libderiv->deriv_classes[2][6][0] = int_stack + 38247;
 Libderiv->deriv2_classes[2][6][6] = int_stack + 38415;
 Libderiv->deriv2_classes[2][7][6] = int_stack + 38583;
 Libderiv->deriv_classes[1][5][2] = int_stack + 38799;
 Libderiv->deriv_classes[1][6][2] = int_stack + 38862;
 Libderiv->deriv_classes[1][7][2] = int_stack + 38946;
 Libderiv->deriv2_classes[1][5][2] = int_stack + 39054;
 Libderiv->deriv2_classes[1][6][2] = int_stack + 39117;
 Libderiv->deriv2_classes[1][7][2] = int_stack + 39201;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 39309;
 Libderiv->deriv2_classes[2][6][2] = int_stack + 39435;
 Libderiv->deriv2_classes[2][7][2] = int_stack + 39603;
 Libderiv->deriv_classes[1][5][1] = int_stack + 39819;
 Libderiv->deriv_classes[1][6][1] = int_stack + 39882;
 Libderiv->deriv_classes[1][7][1] = int_stack + 39966;
 Libderiv->deriv2_classes[1][5][1] = int_stack + 40074;
 Libderiv->deriv2_classes[1][6][1] = int_stack + 40137;
 Libderiv->deriv2_classes[1][7][1] = int_stack + 40221;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 40329;
 Libderiv->deriv2_classes[2][6][1] = int_stack + 40455;
 Libderiv->deriv2_classes[2][7][1] = int_stack + 40623;
 Libderiv->deriv_classes[1][5][0] = int_stack + 40839;
 Libderiv->deriv_classes[1][6][0] = int_stack + 40902;
 Libderiv->deriv_classes[1][7][0] = int_stack + 40986;
 Libderiv->deriv2_classes[1][5][0] = int_stack + 41094;
 Libderiv->deriv2_classes[1][6][0] = int_stack + 41157;
 Libderiv->deriv2_classes[1][7][0] = int_stack + 41241;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 41349;
 Libderiv->deriv2_classes[2][6][0] = int_stack + 41475;
 Libderiv->deriv2_classes[2][7][0] = int_stack + 41643;
 memset(int_stack,0,334872);

 Libderiv->dvrr_stack = int_stack + 78777;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_pphd(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+41859,int_stack+37464,int_stack+37338,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+42048,int_stack+32301,int_stack+32238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37338,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+32385,int_stack+32301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37464,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+42489,int_stack+42237,int_stack+42048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41859,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+42867,int_stack+1080,int_stack+19245,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+43245,int_stack+14202,int_stack+13950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19245,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43623,int_stack+0,int_stack+14202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+44127,int_stack+43623,int_stack+43245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42867,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+43623,int_stack+33321,int_stack+33258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37338, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+33405,int_stack+33321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37464, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+44883,int_stack+42237,int_stack+43623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41859, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+45261,int_stack+15261,int_stack+15009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19245, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+45639,int_stack+216,int_stack+15261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+46143,int_stack+45639,int_stack+45261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42867, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+45639,int_stack+34341,int_stack+34278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37338, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+34425,int_stack+34341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37464, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+42237,int_stack+45639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41859, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46899,int_stack+16320,int_stack+16068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19245, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+47277,int_stack+432,int_stack+16320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+47781,int_stack+47277,int_stack+46899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42867, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+47277,int_stack+35361,int_stack+35298, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+35445,int_stack+35361, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+48537,int_stack+42237,int_stack+47277, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+48915,int_stack+17379,int_stack+17127, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49293,int_stack+648,int_stack+17379, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+49797,int_stack+49293,int_stack+48915, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+49293,int_stack+36381,int_stack+36318, 0.0, zero_stack, 1.0, int_stack+37338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+36465,int_stack+36381, 0.0, zero_stack, 1.0, int_stack+37464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+378,int_stack+42237,int_stack+49293, 0.0, zero_stack, 1.0, int_stack+41859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50553,int_stack+18438,int_stack+18186, 0.0, zero_stack, 1.0, int_stack+19245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+50931,int_stack+864,int_stack+18438, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+51435,int_stack+50931,int_stack+50553, 0.0, zero_stack, 1.0, int_stack+42867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50931,int_stack+37548,int_stack+37401, 1.0, int_stack+37338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+37632,int_stack+37548, 1.0, int_stack+37464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+52191,int_stack+42237,int_stack+50931, 1.0, int_stack+41859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+19623,int_stack+19371, 1.0, int_stack+19245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+52947,int_stack+1248,int_stack+19623, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+53451,int_stack+52947,int_stack+52569, 1.0, int_stack+42867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+1896,int_stack+37464,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+42867,int_stack+42237,int_stack+41859,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+41859,int_stack+38862,int_stack+38799,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+38946,int_stack+38862,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+52947,int_stack+42237,int_stack+41859,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+24507,int_stack+24255,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+54207,int_stack+1464,int_stack+24507,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+54711,int_stack+54207,int_stack+756,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+54207,int_stack+39882,int_stack+39819,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+39966,int_stack+39882,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1134,int_stack+42237,int_stack+54207,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+30156,int_stack+29904,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+55845,int_stack+1680,int_stack+30156,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+56349,int_stack+55845,int_stack+55467,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+55845,int_stack+40902,int_stack+40839,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+40986,int_stack+40902,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1512,int_stack+42237,int_stack+55845,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57105,int_stack+38247,int_stack+37995,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+57483,int_stack+2004,int_stack+38247,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+57987,int_stack+57483,int_stack+57105,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+2283,int_stack+2220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32238,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+2367,int_stack+2283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32301,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+42048,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+2601,int_stack+2475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+13950,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+58743,int_stack+2769,int_stack+2601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+14202,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+59247,int_stack+58743,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+43245,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+3048,int_stack+2985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32238, 1.0, int_stack+33258,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+3132,int_stack+3048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32301, 1.0, int_stack+33321,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+58743,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42048, 1.0, int_stack+43623,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+3366,int_stack+3240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13950, 1.0, int_stack+15009,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+3534,int_stack+3366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14202, 1.0, int_stack+15261,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43245, 1.0, int_stack+45261,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+3813,int_stack+3750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+33258, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+3897,int_stack+3813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+33321, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2268,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+43623, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+4131,int_stack+4005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15009, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3528,int_stack+4299,int_stack+4131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15261, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+60003,int_stack+3528,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+45261, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+4578,int_stack+4515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32238, 0.0, zero_stack, 1.0, int_stack+34278,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+4662,int_stack+4578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32301, 0.0, zero_stack, 1.0, int_stack+34341,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3528,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42048, 0.0, zero_stack, 1.0, int_stack+45639,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+4896,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13950, 0.0, zero_stack, 1.0, int_stack+16068,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3906,int_stack+5064,int_stack+4896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14202, 0.0, zero_stack, 1.0, int_stack+16320,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4410,int_stack+3906,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43245, 0.0, zero_stack, 1.0, int_stack+46899,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+5343,int_stack+5280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33258, 1.0, int_stack+34278, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+5427,int_stack+5343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33321, 1.0, int_stack+34341, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3906,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43623, 1.0, int_stack+45639, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+5661,int_stack+5535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15009, 1.0, int_stack+16068, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+60759,int_stack+5829,int_stack+5661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15261, 1.0, int_stack+16320, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5166,int_stack+60759,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45261, 1.0, int_stack+46899, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+6108,int_stack+6045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+34278, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+6192,int_stack+6108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+34341, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5922,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+45639, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+6426,int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16068, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+60759,int_stack+6594,int_stack+6426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16320, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+61263,int_stack+60759,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+46899, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+6873,int_stack+6810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32238, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35298,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+6957,int_stack+6873, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32301, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35361,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+60759,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47277,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+7191,int_stack+7065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17127,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6300,int_stack+7359,int_stack+7191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14202, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17379,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6804,int_stack+6300,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48915,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+7638,int_stack+7575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33258, 0.0, zero_stack, 1.0, int_stack+35298, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+7722,int_stack+7638, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33321, 0.0, zero_stack, 1.0, int_stack+35361, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6300,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43623, 0.0, zero_stack, 1.0, int_stack+47277, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+7956,int_stack+7830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15009, 0.0, zero_stack, 1.0, int_stack+17127, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+62019,int_stack+8124,int_stack+7956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15261, 0.0, zero_stack, 1.0, int_stack+17379, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7560,int_stack+62019,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45261, 0.0, zero_stack, 1.0, int_stack+48915, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+8403,int_stack+8340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34278, 1.0, int_stack+35298, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+8487,int_stack+8403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34341, 1.0, int_stack+35361, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+62019,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45639, 1.0, int_stack+47277, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+8721,int_stack+8595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16068, 1.0, int_stack+17127, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+62397,int_stack+8889,int_stack+8721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16320, 1.0, int_stack+17379, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8316,int_stack+62397,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46899, 1.0, int_stack+48915, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+9168,int_stack+9105, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+9252,int_stack+9168, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+62397,int_stack+42237,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+47277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+9486,int_stack+9360, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+62775,int_stack+9654,int_stack+9486, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9072,int_stack+62775,int_stack+57483, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+48915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+9933,int_stack+9870, 0.0, zero_stack, 1.0, int_stack+32238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36318,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+10017,int_stack+9933, 0.0, zero_stack, 1.0, int_stack+32301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36381,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+62775,int_stack+42237,int_stack+57483, 0.0, zero_stack, 1.0, int_stack+42048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49293,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+10251,int_stack+10125, 0.0, zero_stack, 1.0, int_stack+13950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18186,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+63153,int_stack+10419,int_stack+10251, 0.0, zero_stack, 1.0, int_stack+14202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18438,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9828,int_stack+63153,int_stack+57483, 0.0, zero_stack, 1.0, int_stack+43245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50553,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+10698,int_stack+10635, 0.0, zero_stack, 1.0, int_stack+33258, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36318, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+10782,int_stack+10698, 0.0, zero_stack, 1.0, int_stack+33321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36381, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+63153,int_stack+42237,int_stack+57483, 0.0, zero_stack, 1.0, int_stack+43623, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49293, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+11016,int_stack+10890, 0.0, zero_stack, 1.0, int_stack+15009, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18186, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+63531,int_stack+11184,int_stack+11016, 0.0, zero_stack, 1.0, int_stack+15261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18438, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+64035,int_stack+63531,int_stack+57483, 0.0, zero_stack, 1.0, int_stack+45261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50553, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+11463,int_stack+11400, 0.0, zero_stack, 1.0, int_stack+34278, 0.0, zero_stack, 1.0, int_stack+36318, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+11547,int_stack+11463, 0.0, zero_stack, 1.0, int_stack+34341, 0.0, zero_stack, 1.0, int_stack+36381, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+63531,int_stack+42237,int_stack+57483, 0.0, zero_stack, 1.0, int_stack+45639, 0.0, zero_stack, 1.0, int_stack+49293, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+11781,int_stack+11655, 0.0, zero_stack, 1.0, int_stack+16068, 0.0, zero_stack, 1.0, int_stack+18186, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10584,int_stack+11949,int_stack+11781, 0.0, zero_stack, 1.0, int_stack+16320, 0.0, zero_stack, 1.0, int_stack+18438, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11088,int_stack+10584,int_stack+57483, 0.0, zero_stack, 1.0, int_stack+46899, 0.0, zero_stack, 1.0, int_stack+50553, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+12228,int_stack+12165, 0.0, zero_stack, 1.0, int_stack+35298, 1.0, int_stack+36318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+12312,int_stack+12228, 0.0, zero_stack, 1.0, int_stack+35361, 1.0, int_stack+36381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10584,int_stack+42237,int_stack+57483, 0.0, zero_stack, 1.0, int_stack+47277, 1.0, int_stack+49293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+12546,int_stack+12420, 0.0, zero_stack, 1.0, int_stack+17127, 1.0, int_stack+18186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11844,int_stack+12714,int_stack+12546, 0.0, zero_stack, 1.0, int_stack+17379, 1.0, int_stack+18438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+64791,int_stack+11844,int_stack+57483, 0.0, zero_stack, 1.0, int_stack+48915, 1.0, int_stack+50553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+12993,int_stack+12930, 0.0, zero_stack, 2.0, int_stack+36318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+13077,int_stack+12993, 0.0, zero_stack, 2.0, int_stack+36381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11844,int_stack+42237,int_stack+57483, 0.0, zero_stack, 2.0, int_stack+49293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+13311,int_stack+13185, 0.0, zero_stack, 2.0, int_stack+18186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12222,int_stack+13479,int_stack+13311, 0.0, zero_stack, 2.0, int_stack+18438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12726,int_stack+12222,int_stack+57483, 0.0, zero_stack, 2.0, int_stack+50553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57483,int_stack+13758,int_stack+13695, 1.0, int_stack+32238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37401,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42237,int_stack+13842,int_stack+13758, 1.0, int_stack+32301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37548,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12222,int_stack+42237,int_stack+57483, 1.0, int_stack+42048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50931,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+42048,int_stack+14370,int_stack+14076, 1.0, int_stack+13950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19371,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+57483,int_stack+14538,int_stack+14370, 1.0, int_stack+14202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19623,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13482,int_stack+57483,int_stack+42048, 1.0, int_stack+43245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52569,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+43245,int_stack+14817,int_stack+14754, 1.0, int_stack+33258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37401, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42048,int_stack+14901,int_stack+14817, 1.0, int_stack+33321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37548, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+57483,int_stack+42048,int_stack+43245, 1.0, int_stack+43623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50931, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+43245,int_stack+15429,int_stack+15135, 1.0, int_stack+15009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19371, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43623,int_stack+15597,int_stack+15429, 1.0, int_stack+15261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19623, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14238,int_stack+43623,int_stack+43245, 1.0, int_stack+45261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52569, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+45261,int_stack+15876,int_stack+15813, 1.0, int_stack+34278, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37401, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+15960,int_stack+15876, 1.0, int_stack+34341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37548, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+43497,int_stack+43245,int_stack+45261, 1.0, int_stack+45639, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50931, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+45261,int_stack+16488,int_stack+16194, 1.0, int_stack+16068, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19371, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+45639,int_stack+16656,int_stack+16488, 1.0, int_stack+16320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19623, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14994,int_stack+45639,int_stack+45261, 1.0, int_stack+46899, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52569, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46899,int_stack+16935,int_stack+16872, 1.0, int_stack+35298, 0.0, zero_stack, 1.0, int_stack+37401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+17019,int_stack+16935, 1.0, int_stack+35361, 0.0, zero_stack, 1.0, int_stack+37548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+45261,int_stack+43245,int_stack+46899, 1.0, int_stack+47277, 0.0, zero_stack, 1.0, int_stack+50931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46899,int_stack+17547,int_stack+17253, 1.0, int_stack+17127, 0.0, zero_stack, 1.0, int_stack+19371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+47277,int_stack+17715,int_stack+17547, 1.0, int_stack+17379, 0.0, zero_stack, 1.0, int_stack+19623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15750,int_stack+47277,int_stack+46899, 1.0, int_stack+48915, 0.0, zero_stack, 1.0, int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+48915,int_stack+17994,int_stack+17931, 1.0, int_stack+36318, 1.0, int_stack+37401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+18078,int_stack+17994, 1.0, int_stack+36381, 1.0, int_stack+37548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+46899,int_stack+43245,int_stack+48915, 1.0, int_stack+49293, 1.0, int_stack+50931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+48915,int_stack+18606,int_stack+18312, 1.0, int_stack+18186, 1.0, int_stack+19371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49293,int_stack+18774,int_stack+18606, 1.0, int_stack+18438, 1.0, int_stack+19623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+16506,int_stack+49293,int_stack+48915, 1.0, int_stack+50553, 1.0, int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50553,int_stack+19053,int_stack+18990, 2.0, int_stack+37401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+19137,int_stack+19053, 2.0, int_stack+37548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+48915,int_stack+43245,int_stack+50553, 2.0, int_stack+50931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50553,int_stack+19791,int_stack+19497, 2.0, int_stack+19371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+50931,int_stack+19959,int_stack+19791, 2.0, int_stack+19623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+17262,int_stack+50931,int_stack+50553, 2.0, int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+20238,int_stack+20175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38799,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+20322,int_stack+20238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38862,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+50553,int_stack+43245,int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41859,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+20556,int_stack+20430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24255,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+50931,int_stack+20724,int_stack+20556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24507,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18018,int_stack+50931,int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+21003,int_stack+20940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38799, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+21087,int_stack+21003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38862, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+50931,int_stack+43245,int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41859, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+21321,int_stack+21195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24255, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49293,int_stack+21489,int_stack+21321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24507, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18774,int_stack+49293,int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+21768,int_stack+21705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38799, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+21852,int_stack+21768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38862, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+49293,int_stack+43245,int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41859, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+22086,int_stack+21960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24255, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+47277,int_stack+22254,int_stack+22086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24507, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19530,int_stack+47277,int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+22533,int_stack+22470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+22617,int_stack+22533, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+47277,int_stack+43245,int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+22851,int_stack+22725, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+45639,int_stack+23019,int_stack+22851, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+20286,int_stack+45639,int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+23298,int_stack+23235, 0.0, zero_stack, 1.0, int_stack+38799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+23382,int_stack+23298, 0.0, zero_stack, 1.0, int_stack+38862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+45639,int_stack+43245,int_stack+52569, 0.0, zero_stack, 1.0, int_stack+41859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+23616,int_stack+23490, 0.0, zero_stack, 1.0, int_stack+24255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21042,int_stack+23784,int_stack+23616, 0.0, zero_stack, 1.0, int_stack+24507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21546,int_stack+21042,int_stack+52569, 0.0, zero_stack, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+24063,int_stack+24000, 1.0, int_stack+38799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+24147,int_stack+24063, 1.0, int_stack+38862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21042,int_stack+43245,int_stack+52569, 1.0, int_stack+41859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52569,int_stack+24675,int_stack+24381, 1.0, int_stack+24255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+41859,int_stack+24843,int_stack+24675, 1.0, int_stack+24507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22302,int_stack+41859,int_stack+52569, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+25122,int_stack+25059,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+25206,int_stack+25122,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+52569,int_stack+43245,int_stack+756,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+25440,int_stack+25314,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+41859,int_stack+25608,int_stack+25440,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+23058,int_stack+41859,int_stack+756,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+25887,int_stack+25824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39819,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+25971,int_stack+25887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39882,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+41859,int_stack+43245,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54207,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+26205,int_stack+26079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29904,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23814,int_stack+26373,int_stack+26205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30156,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+24318,int_stack+23814,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55467,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+26652,int_stack+26589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39819, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+26736,int_stack+26652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39882, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+23814,int_stack+43245,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54207, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+26970,int_stack+26844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29904, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25074,int_stack+27138,int_stack+26970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30156, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25578,int_stack+25074,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55467, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+27417,int_stack+27354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39819, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+27501,int_stack+27417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39882, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25074,int_stack+43245,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54207, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+27735,int_stack+27609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29904, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26334,int_stack+27903,int_stack+27735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30156, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+26838,int_stack+26334,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55467, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+28182,int_stack+28119, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+28266,int_stack+28182, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+26334,int_stack+43245,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+28500,int_stack+28374, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+27594,int_stack+28668,int_stack+28500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+28098,int_stack+27594,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+28947,int_stack+28884, 0.0, zero_stack, 1.0, int_stack+39819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+29031,int_stack+28947, 0.0, zero_stack, 1.0, int_stack+39882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+27594,int_stack+43245,int_stack+756, 0.0, zero_stack, 1.0, int_stack+54207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+29265,int_stack+29139, 0.0, zero_stack, 1.0, int_stack+29904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+65547,int_stack+29433,int_stack+29265, 0.0, zero_stack, 1.0, int_stack+30156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+28854,int_stack+65547,int_stack+756, 0.0, zero_stack, 1.0, int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+29712,int_stack+29649, 1.0, int_stack+39819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+29796,int_stack+29712, 1.0, int_stack+39882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+65547,int_stack+43245,int_stack+756, 1.0, int_stack+54207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+30324,int_stack+30030, 1.0, int_stack+29904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54207,int_stack+30492,int_stack+30324, 1.0, int_stack+30156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+65925,int_stack+54207,int_stack+756, 1.0, int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+30771,int_stack+30708,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+30855,int_stack+30771,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+756,int_stack+43245,int_stack+55467,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+31089,int_stack+30963,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+54207,int_stack+31257,int_stack+31089,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+29610,int_stack+54207,int_stack+55467,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+31536,int_stack+31473,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+31620,int_stack+31536,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+54207,int_stack+43245,int_stack+55467,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+31854,int_stack+31728,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+30366,int_stack+32022,int_stack+31854,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+30870,int_stack+30366,int_stack+55467,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+32556,int_stack+32493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40839,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+32640,int_stack+32556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40902,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+30366,int_stack+43245,int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55845,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+32874,int_stack+32748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37995,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+31626,int_stack+33042,int_stack+32874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38247,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32130,int_stack+31626,int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57105,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+33576,int_stack+33513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40839, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+33660,int_stack+33576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40902, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+31626,int_stack+43245,int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55845, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+33894,int_stack+33768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37995, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+32886,int_stack+34062,int_stack+33894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38247, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33390,int_stack+32886,int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57105, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+34596,int_stack+34533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40839, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+34680,int_stack+34596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40902, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32886,int_stack+43245,int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55845, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+34914,int_stack+34788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37995, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+34146,int_stack+35082,int_stack+34914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38247, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+34650,int_stack+34146,int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57105, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+35616,int_stack+35553, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+35700,int_stack+35616, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+34146,int_stack+43245,int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+35934,int_stack+35808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+35406,int_stack+36102,int_stack+35934, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+66681,int_stack+35406,int_stack+55467, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+36636,int_stack+36573, 0.0, zero_stack, 1.0, int_stack+40839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+36720,int_stack+36636, 0.0, zero_stack, 1.0, int_stack+40902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+35406,int_stack+43245,int_stack+55467, 0.0, zero_stack, 1.0, int_stack+55845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+36954,int_stack+36828, 0.0, zero_stack, 1.0, int_stack+37995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+35784,int_stack+37122,int_stack+36954, 0.0, zero_stack, 1.0, int_stack+38247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+36288,int_stack+35784,int_stack+55467, 0.0, zero_stack, 1.0, int_stack+57105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+37803,int_stack+37740, 1.0, int_stack+40839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+37887,int_stack+37803, 1.0, int_stack+40902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+35784,int_stack+43245,int_stack+55467, 1.0, int_stack+55845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55467,int_stack+38415,int_stack+38121, 1.0, int_stack+37995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+55845,int_stack+38583,int_stack+38415, 1.0, int_stack+38247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37044,int_stack+55845,int_stack+55467, 1.0, int_stack+57105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57105,int_stack+39117,int_stack+39054,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+39201,int_stack+39117,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+55467,int_stack+43245,int_stack+57105,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57105,int_stack+39435,int_stack+39309,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+55845,int_stack+39603,int_stack+39435,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+37800,int_stack+55845,int_stack+57105,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57105,int_stack+40137,int_stack+40074,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+40221,int_stack+40137,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+55845,int_stack+43245,int_stack+57105,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57105,int_stack+40455,int_stack+40329,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+38556,int_stack+40623,int_stack+40455,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+39060,int_stack+38556,int_stack+57105,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57105,int_stack+41157,int_stack+41094,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+43245,int_stack+41241,int_stack+41157,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38556,int_stack+43245,int_stack+57105,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57105,int_stack+41475,int_stack+41349,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+39816,int_stack+41643,int_stack+41475,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+40320,int_stack+39816,int_stack+57105,6);
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+67437,int_stack+44127,int_stack+42489,126);
     Libderiv->ABCD[11] = int_stack + 67437;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+68571,int_stack+46143,int_stack+44883,126);
     Libderiv->ABCD[10] = int_stack + 68571;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+69705,int_stack+47781,int_stack+0,126);
     Libderiv->ABCD[9] = int_stack + 69705;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+70839,int_stack+49797,int_stack+48537,126);
     Libderiv->ABCD[8] = int_stack + 70839;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+71973,int_stack+51435,int_stack+378,126);
     Libderiv->ABCD[7] = int_stack + 71973;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+73107,int_stack+53451,int_stack+52191,126);
     Libderiv->ABCD[6] = int_stack + 73107;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+74241,int_stack+54711,int_stack+52947, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[2] = int_stack + 74241;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+75375,int_stack+56349,int_stack+1134, 0.0, zero_stack, 1.0, int_stack+42867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[1] = int_stack + 75375;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+56223,int_stack+57987,int_stack+1512, 1.0, int_stack+42867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[0] = int_stack + 56223;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+76509,int_stack+59247,int_stack+1890,126);
     Libderiv->ABCD[155] = int_stack + 76509;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+77643,int_stack+2772,int_stack+58743,126);
     Libderiv->ABCD[143] = int_stack + 77643;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+57861,int_stack+60003,int_stack+2268,126);
     Libderiv->ABCD[142] = int_stack + 57861;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1890,int_stack+4410,int_stack+3528,126);
     Libderiv->ABCD[131] = int_stack + 1890;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+58995,int_stack+5166,int_stack+3906,126);
     Libderiv->ABCD[130] = int_stack + 58995;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3024,int_stack+61263,int_stack+5922,126);
     Libderiv->ABCD[129] = int_stack + 3024;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4158,int_stack+6804,int_stack+60759,126);
     Libderiv->ABCD[119] = int_stack + 4158;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+60129,int_stack+7560,int_stack+6300,126);
     Libderiv->ABCD[118] = int_stack + 60129;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+5292,int_stack+8316,int_stack+62019,126);
     Libderiv->ABCD[117] = int_stack + 5292;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+61263,int_stack+9072,int_stack+62397,126);
     Libderiv->ABCD[116] = int_stack + 61263;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+6426,int_stack+9828,int_stack+62775,126);
     Libderiv->ABCD[107] = int_stack + 6426;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+7560,int_stack+64035,int_stack+63153,126);
     Libderiv->ABCD[106] = int_stack + 7560;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+62397,int_stack+11088,int_stack+63531,126);
     Libderiv->ABCD[105] = int_stack + 62397;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+63531,int_stack+64791,int_stack+10584,126);
     Libderiv->ABCD[104] = int_stack + 63531;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+8694,int_stack+12726,int_stack+11844,126);
     Libderiv->ABCD[103] = int_stack + 8694;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+9828,int_stack+13482,int_stack+12222,126);
     Libderiv->ABCD[95] = int_stack + 9828;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+10962,int_stack+14238,int_stack+57483,126);
     Libderiv->ABCD[94] = int_stack + 10962;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+12096,int_stack+14994,int_stack+43497,126);
     Libderiv->ABCD[93] = int_stack + 12096;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+13230,int_stack+15750,int_stack+45261,126);
     Libderiv->ABCD[92] = int_stack + 13230;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+14364,int_stack+16506,int_stack+46899,126);
     Libderiv->ABCD[91] = int_stack + 14364;
 /*--- compute (pp|hd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+15498,int_stack+17262,int_stack+48915,126);
     Libderiv->ABCD[90] = int_stack + 15498;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+16632,int_stack+18018,int_stack+50553, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[47] = int_stack + 16632;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+42867,int_stack+18774,int_stack+50931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[46] = int_stack + 42867;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+17766,int_stack+19530,int_stack+49293, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[45] = int_stack + 17766;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+48915,int_stack+20286,int_stack+47277, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[44] = int_stack + 48915;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+50049,int_stack+21546,int_stack+45639, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[43] = int_stack + 50049;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+45261,int_stack+22302,int_stack+21042, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[42] = int_stack + 45261;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+46395,int_stack+23058,int_stack+52569, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+52947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[38] = int_stack + 46395;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+18900,int_stack+24318,int_stack+41859, 0.0, zero_stack, 1.0, int_stack+42489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[35] = int_stack + 18900;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+20034,int_stack+25578,int_stack+23814, 0.0, zero_stack, 1.0, int_stack+44883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[34] = int_stack + 20034;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+21168,int_stack+26838,int_stack+25074, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[33] = int_stack + 21168;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+22302,int_stack+28098,int_stack+26334, 0.0, zero_stack, 1.0, int_stack+48537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[32] = int_stack + 22302;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+23436,int_stack+28854,int_stack+27594, 0.0, zero_stack, 1.0, int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[31] = int_stack + 23436;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+24570,int_stack+65925,int_stack+65547, 0.0, zero_stack, 1.0, int_stack+52191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[30] = int_stack + 24570;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+64665,int_stack+29610,int_stack+756, 0.0, zero_stack, 1.0, int_stack+52947, 1.0, int_stack+1134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[26] = int_stack + 64665;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+25704,int_stack+30870,int_stack+54207, 0.0, zero_stack, 2.0, int_stack+1134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[25] = int_stack + 25704;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+26838,int_stack+32130,int_stack+30366, 1.0, int_stack+42489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[23] = int_stack + 26838;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+27972,int_stack+33390,int_stack+31626, 1.0, int_stack+44883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[22] = int_stack + 27972;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+29106,int_stack+34650,int_stack+32886, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[21] = int_stack + 29106;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+30240,int_stack+66681,int_stack+34146, 1.0, int_stack+48537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[20] = int_stack + 30240;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+47529,int_stack+36288,int_stack+35406, 1.0, int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[19] = int_stack + 47529;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+0,int_stack+37044,int_stack+35784, 1.0, int_stack+52191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[18] = int_stack + 0;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+51183,int_stack+37800,int_stack+55467, 1.0, int_stack+52947, 0.0, zero_stack, 1.0, int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[14] = int_stack + 51183;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+52317,int_stack+39060,int_stack+55845, 1.0, int_stack+1134, 1.0, int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[13] = int_stack + 52317;
 /*--- compute (pp|hd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+53451,int_stack+40320,int_stack+38556, 2.0, int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[12] = int_stack + 53451;

}
