/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* This machine-generated function computes a quartet of |df) first derivative ERIs */

void d1hrr3_build_df(const double *CD, double *vp, const double *I0, const double *I1,
        double c2, const double *I2, double c3, const double *I3, double c4, const double *I4,
        double c5, const double *I5, double c6, const double *I6, double c7, const double *I7, int ab_num)
{
  int ab;
  const double CD0 = CD[0];
  const double CD1 = CD[1];
  const double CD2 = CD[2];
  for(ab=0;ab<ab_num;ab++) {
    *(vp++) = I0[0] + CD0*I1[0] + c2*I2[0] - c5*I5[0];
    *(vp++) = I0[1] + CD0*I1[1] + c2*I2[1] - c5*I5[1];
    *(vp++) = I0[2] + CD0*I1[2] + c2*I2[2] - c5*I5[2];
    *(vp++) = I0[3] + CD0*I1[3] + c2*I2[3] - c5*I5[3];
    *(vp++) = I0[4] + CD0*I1[4] + c2*I2[4] - c5*I5[4];
    *(vp++) = I0[5] + CD0*I1[5] + c2*I2[5] - c5*I5[5];
    *(vp++) = I0[9] + CD1*I1[3] + c3*I3[3] - c6*I6[3];
    *(vp++) = I0[10] + CD1*I1[4] + c3*I3[4] - c6*I6[4];
    *(vp++) = I0[11] + CD1*I1[5] + c3*I3[5] - c6*I6[5];
    *(vp++) = I0[17] + CD2*I1[5] + c4*I4[5] - c7*I7[5];
    *(vp++) = I0[6] + CD0*I1[6] + c2*I2[6] - c5*I5[6];
    *(vp++) = I0[7] + CD0*I1[7] + c2*I2[7] - c5*I5[7];
    *(vp++) = I0[8] + CD0*I1[8] + c2*I2[8] - c5*I5[8];
    *(vp++) = I0[9] + CD0*I1[9] + c2*I2[9] - c5*I5[9];
    *(vp++) = I0[10] + CD0*I1[10] + c2*I2[10] - c5*I5[10];
    *(vp++) = I0[11] + CD0*I1[11] + c2*I2[11] - c5*I5[11];
    *(vp++) = I0[21] + CD1*I1[9] + c3*I3[9] - c6*I6[9];
    *(vp++) = I0[22] + CD1*I1[10] + c3*I3[10] - c6*I6[10];
    *(vp++) = I0[23] + CD1*I1[11] + c3*I3[11] - c6*I6[11];
    *(vp++) = I0[29] + CD2*I1[11] + c4*I4[11] - c7*I7[11];
    *(vp++) = I0[12] + CD0*I1[12] + c2*I2[12] - c5*I5[12];
    *(vp++) = I0[13] + CD0*I1[13] + c2*I2[13] - c5*I5[13];
    *(vp++) = I0[14] + CD0*I1[14] + c2*I2[14] - c5*I5[14];
    *(vp++) = I0[15] + CD0*I1[15] + c2*I2[15] - c5*I5[15];
    *(vp++) = I0[16] + CD0*I1[16] + c2*I2[16] - c5*I5[16];
    *(vp++) = I0[17] + CD0*I1[17] + c2*I2[17] - c5*I5[17];
    *(vp++) = I0[27] + CD1*I1[15] + c3*I3[15] - c6*I6[15];
    *(vp++) = I0[28] + CD1*I1[16] + c3*I3[16] - c6*I6[16];
    *(vp++) = I0[29] + CD1*I1[17] + c3*I3[17] - c6*I6[17];
    *(vp++) = I0[35] + CD2*I1[17] + c4*I4[17] - c7*I7[17];
    *(vp++) = I0[18] + CD0*I1[18] + c2*I2[18] - c5*I5[18];
    *(vp++) = I0[19] + CD0*I1[19] + c2*I2[19] - c5*I5[19];
    *(vp++) = I0[20] + CD0*I1[20] + c2*I2[20] - c5*I5[20];
    *(vp++) = I0[21] + CD0*I1[21] + c2*I2[21] - c5*I5[21];
    *(vp++) = I0[22] + CD0*I1[22] + c2*I2[22] - c5*I5[22];
    *(vp++) = I0[23] + CD0*I1[23] + c2*I2[23] - c5*I5[23];
    *(vp++) = I0[39] + CD1*I1[21] + c3*I3[21] - c6*I6[21];
    *(vp++) = I0[40] + CD1*I1[22] + c3*I3[22] - c6*I6[22];
    *(vp++) = I0[41] + CD1*I1[23] + c3*I3[23] - c6*I6[23];
    *(vp++) = I0[47] + CD2*I1[23] + c4*I4[23] - c7*I7[23];
    *(vp++) = I0[24] + CD0*I1[24] + c2*I2[24] - c5*I5[24];
    *(vp++) = I0[25] + CD0*I1[25] + c2*I2[25] - c5*I5[25];
    *(vp++) = I0[26] + CD0*I1[26] + c2*I2[26] - c5*I5[26];
    *(vp++) = I0[27] + CD0*I1[27] + c2*I2[27] - c5*I5[27];
    *(vp++) = I0[28] + CD0*I1[28] + c2*I2[28] - c5*I5[28];
    *(vp++) = I0[29] + CD0*I1[29] + c2*I2[29] - c5*I5[29];
    *(vp++) = I0[45] + CD1*I1[27] + c3*I3[27] - c6*I6[27];
    *(vp++) = I0[46] + CD1*I1[28] + c3*I3[28] - c6*I6[28];
    *(vp++) = I0[47] + CD1*I1[29] + c3*I3[29] - c6*I6[29];
    *(vp++) = I0[53] + CD2*I1[29] + c4*I4[29] - c7*I7[29];
    *(vp++) = I0[30] + CD0*I1[30] + c2*I2[30] - c5*I5[30];
    *(vp++) = I0[31] + CD0*I1[31] + c2*I2[31] - c5*I5[31];
    *(vp++) = I0[32] + CD0*I1[32] + c2*I2[32] - c5*I5[32];
    *(vp++) = I0[33] + CD0*I1[33] + c2*I2[33] - c5*I5[33];
    *(vp++) = I0[34] + CD0*I1[34] + c2*I2[34] - c5*I5[34];
    *(vp++) = I0[35] + CD0*I1[35] + c2*I2[35] - c5*I5[35];
    *(vp++) = I0[51] + CD1*I1[33] + c3*I3[33] - c6*I6[33];
    *(vp++) = I0[52] + CD1*I1[34] + c3*I3[34] - c6*I6[34];
    *(vp++) = I0[53] + CD1*I1[35] + c3*I3[35] - c6*I6[35];
    *(vp++) = I0[59] + CD2*I1[35] + c4*I4[35] - c7*I7[35];
    I0 += 60;
    I1 += 36;
    I2 += 36;
    I3 += 36;
    I4 += 36;
    I5 += 36;
    I6 += 36;
    I7 += 36;
  }
}
