/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_00ii(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|ii) integrals */

void d1hrr_order_00ii(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][6][11] = int_stack + 0;
 Libderiv->deriv_classes[0][7][11] = int_stack + 28;
 Libderiv->deriv_classes[0][8][11] = int_stack + 64;
 Libderiv->deriv_classes[0][9][11] = int_stack + 109;
 Libderiv->deriv_classes[0][10][11] = int_stack + 164;
 Libderiv->deriv_classes[0][11][11] = int_stack + 230;
 Libderiv->deriv_classes[0][12][11] = int_stack + 308;
 Libderiv->deriv_classes[0][6][10] = int_stack + 399;
 Libderiv->deriv_classes[0][7][10] = int_stack + 427;
 Libderiv->deriv_classes[0][8][10] = int_stack + 463;
 Libderiv->deriv_classes[0][9][10] = int_stack + 508;
 Libderiv->deriv_classes[0][10][10] = int_stack + 563;
 Libderiv->deriv_classes[0][11][10] = int_stack + 629;
 Libderiv->deriv_classes[0][12][10] = int_stack + 707;
 Libderiv->deriv_classes[0][6][9] = int_stack + 798;
 Libderiv->deriv_classes[0][7][9] = int_stack + 826;
 Libderiv->deriv_classes[0][8][9] = int_stack + 862;
 Libderiv->deriv_classes[0][9][9] = int_stack + 907;
 Libderiv->deriv_classes[0][10][9] = int_stack + 962;
 Libderiv->deriv_classes[0][11][9] = int_stack + 1028;
 Libderiv->deriv_classes[0][12][9] = int_stack + 1106;
 Libderiv->deriv_classes[0][6][8] = int_stack + 1197;
 Libderiv->deriv_classes[0][7][8] = int_stack + 1225;
 Libderiv->deriv_classes[0][8][8] = int_stack + 1261;
 Libderiv->deriv_classes[0][9][8] = int_stack + 1306;
 Libderiv->deriv_classes[0][10][8] = int_stack + 1361;
 Libderiv->deriv_classes[0][11][8] = int_stack + 1427;
 Libderiv->deriv_classes[0][12][8] = int_stack + 1505;
 Libderiv->deriv_classes[0][6][7] = int_stack + 1596;
 Libderiv->deriv_classes[0][7][7] = int_stack + 1624;
 Libderiv->deriv_classes[0][8][7] = int_stack + 1660;
 Libderiv->deriv_classes[0][9][7] = int_stack + 1705;
 Libderiv->deriv_classes[0][10][7] = int_stack + 1760;
 Libderiv->deriv_classes[0][11][7] = int_stack + 1826;
 Libderiv->deriv_classes[0][12][7] = int_stack + 1904;
 Libderiv->dvrr_classes[0][6] = int_stack + 1995;
 Libderiv->deriv_classes[0][6][6] = int_stack + 2023;
 Libderiv->dvrr_classes[0][7] = int_stack + 2051;
 Libderiv->deriv_classes[0][7][6] = int_stack + 2087;
 Libderiv->dvrr_classes[0][8] = int_stack + 2123;
 Libderiv->deriv_classes[0][8][6] = int_stack + 2168;
 Libderiv->dvrr_classes[0][9] = int_stack + 2213;
 Libderiv->deriv_classes[0][9][6] = int_stack + 2268;
 Libderiv->dvrr_classes[0][10] = int_stack + 2323;
 Libderiv->deriv_classes[0][10][6] = int_stack + 2389;
 Libderiv->dvrr_classes[0][11] = int_stack + 2455;
 Libderiv->deriv_classes[0][11][6] = int_stack + 2533;
 Libderiv->deriv_classes[0][12][6] = int_stack + 2611;
 Libderiv->deriv_classes[0][6][2] = int_stack + 2702;
 Libderiv->deriv_classes[0][7][2] = int_stack + 2730;
 Libderiv->deriv_classes[0][8][2] = int_stack + 2766;
 Libderiv->deriv_classes[0][9][2] = int_stack + 2811;
 Libderiv->deriv_classes[0][10][2] = int_stack + 2866;
 Libderiv->deriv_classes[0][11][2] = int_stack + 2932;
 Libderiv->deriv_classes[0][12][2] = int_stack + 3010;
 Libderiv->deriv_classes[0][6][1] = int_stack + 3101;
 Libderiv->deriv_classes[0][7][1] = int_stack + 3129;
 Libderiv->deriv_classes[0][8][1] = int_stack + 3165;
 Libderiv->deriv_classes[0][9][1] = int_stack + 3210;
 Libderiv->deriv_classes[0][10][1] = int_stack + 3265;
 Libderiv->deriv_classes[0][11][1] = int_stack + 3331;
 Libderiv->deriv_classes[0][12][1] = int_stack + 3409;
 Libderiv->deriv_classes[0][6][0] = int_stack + 3500;
 Libderiv->deriv_classes[0][7][0] = int_stack + 3528;
 Libderiv->deriv_classes[0][8][0] = int_stack + 3564;
 Libderiv->deriv_classes[0][9][0] = int_stack + 3609;
 Libderiv->deriv_classes[0][10][0] = int_stack + 3664;
 Libderiv->deriv_classes[0][11][0] = int_stack + 3730;
 Libderiv->deriv_classes[0][12][0] = int_stack + 3808;
 memset(int_stack,0,31192);

 Libderiv->dvrr_stack = int_stack + 17302;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_00ii(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3899,int_stack+2051,int_stack+1995,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3983,int_stack+2123,int_stack+2051,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4091,int_stack+3983,int_stack+3899,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4259,int_stack+2213,int_stack+2123,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4394,int_stack+4259,int_stack+3983,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4610,int_stack+4394,int_stack+4091,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4890,int_stack+2323,int_stack+2213,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5055,int_stack+4890,int_stack+4259,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5325,int_stack+5055,int_stack+4394,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5685,int_stack+5325,int_stack+4610,1);
 /*--- compute (00|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+6105,int_stack+2455,int_stack+2323,1);
 /*--- compute (00|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+6303,int_stack+6105,int_stack+4890,1);
 /*--- compute (00|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+6633,int_stack+6303,int_stack+5055,1);
 /*--- compute (00|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+7083,int_stack+6633,int_stack+5325,1);
 /*--- compute (00|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+7623,int_stack+7083,int_stack+5685,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8211,int_stack+28,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1995,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8295,int_stack+64,int_stack+28, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8403,int_stack+8295,int_stack+8211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3899,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+8571,int_stack+109,int_stack+64, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2123,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8706,int_stack+8571,int_stack+8295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3983,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+8922,int_stack+8706,int_stack+8403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4091,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+8211,int_stack+164,int_stack+109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2213,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+9202,int_stack+8211,int_stack+8571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4259,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+9472,int_stack+9202,int_stack+8706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4394,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8376,int_stack+9472,int_stack+8922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4610,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+8796,int_stack+230,int_stack+164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2323,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+9832,int_stack+8796,int_stack+8211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4890,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+10162,int_stack+9832,int_stack+9202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5055,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+10612,int_stack+10162,int_stack+9472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5325,1);
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+8994,int_stack+10612,int_stack+8376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5685,1);
 /*--- compute (00|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+8211,int_stack+308,int_stack+230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2455,1);
 /*--- compute (00|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+0,int_stack+8211,int_stack+8796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6105,1);
 /*--- compute (00|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+8211,int_stack+0,int_stack+9832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6303,1);
 /*--- compute (00|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+11152,int_stack+8211,int_stack+10162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6633,1);
 /*--- compute (00|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+8211,int_stack+11152,int_stack+10612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7083,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+427,int_stack+399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1995, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+84,int_stack+463,int_stack+427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+192,int_stack+84,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3899, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9582,int_stack+508,int_stack+463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2123, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9717,int_stack+9582,int_stack+84, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3983, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9933,int_stack+9717,int_stack+192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4091, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+563,int_stack+508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2213, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+165,int_stack+0,int_stack+9582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4259, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+10213,int_stack+165,int_stack+9717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4394, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+10573,int_stack+10213,int_stack+9933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4610, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+9582,int_stack+629,int_stack+563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2323, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+9780,int_stack+9582,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4890, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+10993,int_stack+9780,int_stack+165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5055, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+0,int_stack+10993,int_stack+10213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5325, 0.0, zero_stack,1);
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+11443,int_stack+0,int_stack+10573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5685, 0.0, zero_stack,1);
 /*--- compute (00|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+10110,int_stack+707,int_stack+629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2455, 0.0, zero_stack,1);
 /*--- compute (00|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+10344,int_stack+10110,int_stack+9582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6105, 0.0, zero_stack,1);
 /*--- compute (00|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+12031,int_stack+10344,int_stack+9780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6303, 0.0, zero_stack,1);
 /*--- compute (00|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+9582,int_stack+12031,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6633, 0.0, zero_stack,1);
 /*--- compute (00|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+12031,int_stack+9582,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7083, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+826,int_stack+798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1995, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+84,int_stack+862,int_stack+826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+192,int_stack+84,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3899, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+360,int_stack+907,int_stack+862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2123, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+495,int_stack+360,int_stack+84, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3983, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9582,int_stack+495,int_stack+192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4091, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+962,int_stack+907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2213, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+9862,int_stack+0,int_stack+360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4259, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+10132,int_stack+9862,int_stack+495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4394, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+165,int_stack+10132,int_stack+9582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4610, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+9582,int_stack+1028,int_stack+962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2323, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+585,int_stack+9582,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4890, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+10492,int_stack+585,int_stack+9862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5055, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+12787,int_stack+10492,int_stack+10132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5325, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+9780,int_stack+12787,int_stack+165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5685, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+0,int_stack+1106,int_stack+1028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2455, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+10942,int_stack+0,int_stack+9582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6105, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+0,int_stack+10942,int_stack+585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6303, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+13327,int_stack+0,int_stack+10492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6633, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+0,int_stack+13327,int_stack+12787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7083, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12787,int_stack+1225,int_stack+1197, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12871,int_stack+1261,int_stack+1225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12979,int_stack+12871,int_stack+12787, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+13147,int_stack+1306,int_stack+1261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+13282,int_stack+13147,int_stack+12871, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+13498,int_stack+13282,int_stack+12979, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+12787,int_stack+1361,int_stack+1306, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+13778,int_stack+12787,int_stack+13147, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+14048,int_stack+13778,int_stack+13282, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+12952,int_stack+14048,int_stack+13498, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+9582,int_stack+1427,int_stack+1361, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+13372,int_stack+9582,int_stack+12787, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+14408,int_stack+13372,int_stack+13778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+756,int_stack+14408,int_stack+14048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+13702,int_stack+756,int_stack+12952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+12787,int_stack+1505,int_stack+1427, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+10368,int_stack+12787,int_stack+9582, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+12787,int_stack+10368,int_stack+13372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+10368,int_stack+12787,int_stack+14408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+12787,int_stack+10368,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+756,int_stack+1624,int_stack+1596, 0.0, zero_stack, 1.0, int_stack+1995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+840,int_stack+1660,int_stack+1624, 0.0, zero_stack, 1.0, int_stack+2051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+948,int_stack+840,int_stack+756, 0.0, zero_stack, 1.0, int_stack+3899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1116,int_stack+1705,int_stack+1660, 0.0, zero_stack, 1.0, int_stack+2123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1251,int_stack+1116,int_stack+840, 0.0, zero_stack, 1.0, int_stack+3983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+10368,int_stack+1251,int_stack+948, 0.0, zero_stack, 1.0, int_stack+4091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+756,int_stack+1760,int_stack+1705, 0.0, zero_stack, 1.0, int_stack+2213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1467,int_stack+756,int_stack+1116, 0.0, zero_stack, 1.0, int_stack+4259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+10648,int_stack+1467,int_stack+1251, 0.0, zero_stack, 1.0, int_stack+4394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+921,int_stack+10648,int_stack+10368, 0.0, zero_stack, 1.0, int_stack+4610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+9582,int_stack+1826,int_stack+1760, 0.0, zero_stack, 1.0, int_stack+2323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+11008,int_stack+9582,int_stack+756, 0.0, zero_stack, 1.0, int_stack+4890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+14290,int_stack+11008,int_stack+1467, 0.0, zero_stack, 1.0, int_stack+5055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+14740,int_stack+14290,int_stack+10648, 0.0, zero_stack, 1.0, int_stack+5325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+10368,int_stack+14740,int_stack+921, 0.0, zero_stack, 1.0, int_stack+5685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+756,int_stack+1904,int_stack+1826, 0.0, zero_stack, 1.0, int_stack+2455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+990,int_stack+756,int_stack+9582, 0.0, zero_stack, 1.0, int_stack+6105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1386,int_stack+990,int_stack+11008, 0.0, zero_stack, 1.0, int_stack+6303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+15280,int_stack+1386,int_stack+14290, 0.0, zero_stack, 1.0, int_stack+6633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+756,int_stack+15280,int_stack+14740, 0.0, zero_stack, 1.0, int_stack+7083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14290,int_stack+2087,int_stack+2023, 1.0, int_stack+1995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+14374,int_stack+2168,int_stack+2087, 1.0, int_stack+2051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14482,int_stack+14374,int_stack+14290, 1.0, int_stack+3899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+14650,int_stack+2268,int_stack+2168, 1.0, int_stack+2123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+14785,int_stack+14650,int_stack+14374, 1.0, int_stack+3983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+15001,int_stack+14785,int_stack+14482, 1.0, int_stack+4091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3899,int_stack+2389,int_stack+2268, 1.0, int_stack+2213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+14290,int_stack+3899,int_stack+14650, 1.0, int_stack+4259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+15281,int_stack+14290,int_stack+14785, 1.0, int_stack+4394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4064,int_stack+15281,int_stack+15001, 1.0, int_stack+4610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+9582,int_stack+2533,int_stack+2389, 1.0, int_stack+2323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+4484,int_stack+9582,int_stack+3899, 1.0, int_stack+4890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+14560,int_stack+4484,int_stack+14290, 1.0, int_stack+5055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1512,int_stack+14560,int_stack+15281, 1.0, int_stack+5325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+4814,int_stack+1512,int_stack+4064, 1.0, int_stack+5685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+14290,int_stack+2611,int_stack+2533, 1.0, int_stack+2455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3899,int_stack+14290,int_stack+9582, 1.0, int_stack+6105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+5402,int_stack+3899,int_stack+4484, 1.0, int_stack+6303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3899,int_stack+5402,int_stack+14560, 1.0, int_stack+6633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+5402,int_stack+3899,int_stack+1512, 1.0, int_stack+7083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1512,int_stack+2730,int_stack+2702,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1596,int_stack+2766,int_stack+2730,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1704,int_stack+1596,int_stack+1512,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1872,int_stack+2811,int_stack+2766,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2007,int_stack+1872,int_stack+1596,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2223,int_stack+2007,int_stack+1704,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1512,int_stack+2866,int_stack+2811,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2503,int_stack+1512,int_stack+1872,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3899,int_stack+2503,int_stack+2007,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1677,int_stack+3899,int_stack+2223,1);
 /*--- compute (00|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+9582,int_stack+2932,int_stack+2866,1);
 /*--- compute (00|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+2097,int_stack+9582,int_stack+1512,1);
 /*--- compute (00|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+4259,int_stack+2097,int_stack+2503,1);
 /*--- compute (00|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+6158,int_stack+4259,int_stack+3899,1);
 /*--- compute (00|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+6698,int_stack+6158,int_stack+1677,1);
 /*--- compute (00|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+3899,int_stack+3010,int_stack+2932,1);
 /*--- compute (00|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+1512,int_stack+3899,int_stack+9582,1);
 /*--- compute (00|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+2427,int_stack+1512,int_stack+2097,1);
 /*--- compute (00|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+1512,int_stack+2427,int_stack+4259,1);
 /*--- compute (00|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+2187,int_stack+1512,int_stack+6158,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6158,int_stack+3129,int_stack+3101,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6242,int_stack+3165,int_stack+3129,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6350,int_stack+6242,int_stack+6158,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+6518,int_stack+3210,int_stack+3165,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1512,int_stack+6518,int_stack+6242,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1728,int_stack+1512,int_stack+6350,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6158,int_stack+3265,int_stack+3210,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2943,int_stack+6158,int_stack+6518,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6323,int_stack+2943,int_stack+1512,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3899,int_stack+6323,int_stack+1728,1);
 /*--- compute (00|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+9582,int_stack+3331,int_stack+3265,1);
 /*--- compute (00|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1512,int_stack+9582,int_stack+6158,1);
 /*--- compute (00|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+4319,int_stack+1512,int_stack+2943,1);
 /*--- compute (00|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+14290,int_stack+4319,int_stack+6323,1);
 /*--- compute (00|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+14830,int_stack+14290,int_stack+3899,1);
 /*--- compute (00|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+3899,int_stack+3409,int_stack+3331,1);
 /*--- compute (00|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+2943,int_stack+3899,int_stack+9582,1);
 /*--- compute (00|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+15418,int_stack+2943,int_stack+1512,1);
 /*--- compute (00|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+1512,int_stack+15418,int_stack+4319,1);
 /*--- compute (00|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+3899,int_stack+1512,int_stack+14290,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14290,int_stack+3528,int_stack+3500,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14374,int_stack+3564,int_stack+3528,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14482,int_stack+14374,int_stack+14290,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+14650,int_stack+3609,int_stack+3564,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1512,int_stack+14650,int_stack+14374,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1728,int_stack+1512,int_stack+14482,1);
 /*--- compute (00|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+14290,int_stack+3664,int_stack+3609,1);
 /*--- compute (00|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+15418,int_stack+14290,int_stack+14650,1);
 /*--- compute (00|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+14455,int_stack+15418,int_stack+1512,1);
 /*--- compute (00|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2943,int_stack+14455,int_stack+1728,1);
 /*--- compute (00|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+9582,int_stack+3730,int_stack+3664,1);
 /*--- compute (00|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1512,int_stack+9582,int_stack+14290,1);
 /*--- compute (00|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+6158,int_stack+1512,int_stack+15418,1);
 /*--- compute (00|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+15418,int_stack+6158,int_stack+14455,1);
 /*--- compute (00|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+15958,int_stack+15418,int_stack+2943,1);
 /*--- compute (00|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+2943,int_stack+3808,int_stack+3730,1);
 /*--- compute (00|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+3177,int_stack+2943,int_stack+9582,1);
 /*--- compute (00|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+16546,int_stack+3177,int_stack+1512,1);
 /*--- compute (00|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+1512,int_stack+16546,int_stack+6158,1);
 /*--- compute (00|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+16546,int_stack+1512,int_stack+15418,1);
 /*--- compute (00|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+2943,int_stack+8211,int_stack+8994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7623,1);
     Libderiv->ABCD[11] = int_stack + 2943;
 /*--- compute (00|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+8211,int_stack+12031,int_stack+11443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7623, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 8211;
 /*--- compute (00|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+8995,int_stack+0,int_stack+9780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7623, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 8995;
 /*--- compute (00|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+10956,int_stack+12787,int_stack+13702, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 10956;
 /*--- compute (00|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+11740,int_stack+756,int_stack+10368, 0.0, zero_stack, 1.0, int_stack+7623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 11740;
 /*--- compute (00|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+0,int_stack+5402,int_stack+4814, 1.0, int_stack+7623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (00|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+784,int_stack+2187,int_stack+6698,1);
     Libderiv->ABCD[2] = int_stack + 784;
 /*--- compute (00|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+1568,int_stack+3899,int_stack+14830,1);
     Libderiv->ABCD[1] = int_stack + 1568;
 /*--- compute (00|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+9779,int_stack+16546,int_stack+15958,1);
     Libderiv->ABCD[0] = int_stack + 9779;

}
