/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_d0hg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|hg) integrals */

void d1hrr_order_d0hg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][5][11] = int_stack + 0;
 Libderiv->deriv_classes[2][6][11] = int_stack + 126;
 Libderiv->deriv_classes[2][7][11] = int_stack + 294;
 Libderiv->deriv_classes[2][8][11] = int_stack + 510;
 Libderiv->deriv_classes[2][9][11] = int_stack + 780;
 Libderiv->deriv_classes[2][5][10] = int_stack + 1110;
 Libderiv->deriv_classes[2][6][10] = int_stack + 1236;
 Libderiv->deriv_classes[2][7][10] = int_stack + 1404;
 Libderiv->deriv_classes[2][8][10] = int_stack + 1620;
 Libderiv->deriv_classes[2][9][10] = int_stack + 1890;
 Libderiv->deriv_classes[2][5][9] = int_stack + 2220;
 Libderiv->deriv_classes[2][6][9] = int_stack + 2346;
 Libderiv->deriv_classes[2][7][9] = int_stack + 2514;
 Libderiv->deriv_classes[2][8][9] = int_stack + 2730;
 Libderiv->deriv_classes[2][9][9] = int_stack + 3000;
 Libderiv->deriv_classes[2][5][8] = int_stack + 3330;
 Libderiv->deriv_classes[2][6][8] = int_stack + 3456;
 Libderiv->deriv_classes[2][7][8] = int_stack + 3624;
 Libderiv->deriv_classes[2][8][8] = int_stack + 3840;
 Libderiv->deriv_classes[2][9][8] = int_stack + 4110;
 Libderiv->deriv_classes[2][5][7] = int_stack + 4440;
 Libderiv->deriv_classes[2][6][7] = int_stack + 4566;
 Libderiv->deriv_classes[2][7][7] = int_stack + 4734;
 Libderiv->deriv_classes[2][8][7] = int_stack + 4950;
 Libderiv->deriv_classes[2][9][7] = int_stack + 5220;
 Libderiv->dvrr_classes[2][5] = int_stack + 5550;
 Libderiv->deriv_classes[2][5][6] = int_stack + 5676;
 Libderiv->dvrr_classes[2][6] = int_stack + 5802;
 Libderiv->deriv_classes[2][6][6] = int_stack + 5970;
 Libderiv->dvrr_classes[2][7] = int_stack + 6138;
 Libderiv->deriv_classes[2][7][6] = int_stack + 6354;
 Libderiv->dvrr_classes[2][8] = int_stack + 6570;
 Libderiv->deriv_classes[2][8][6] = int_stack + 6840;
 Libderiv->deriv_classes[2][9][6] = int_stack + 7110;
 Libderiv->deriv_classes[2][5][2] = int_stack + 7440;
 Libderiv->deriv_classes[2][6][2] = int_stack + 7566;
 Libderiv->deriv_classes[2][7][2] = int_stack + 7734;
 Libderiv->deriv_classes[2][8][2] = int_stack + 7950;
 Libderiv->deriv_classes[2][9][2] = int_stack + 8220;
 Libderiv->deriv_classes[2][5][1] = int_stack + 8550;
 Libderiv->deriv_classes[2][6][1] = int_stack + 8676;
 Libderiv->deriv_classes[2][7][1] = int_stack + 8844;
 Libderiv->deriv_classes[2][8][1] = int_stack + 9060;
 Libderiv->deriv_classes[2][9][1] = int_stack + 9330;
 Libderiv->deriv_classes[2][5][0] = int_stack + 9660;
 Libderiv->deriv_classes[2][6][0] = int_stack + 9786;
 Libderiv->deriv_classes[2][7][0] = int_stack + 9954;
 Libderiv->deriv_classes[2][8][0] = int_stack + 10170;
 Libderiv->deriv_classes[2][9][0] = int_stack + 10440;
 memset(int_stack,0,86160);

 Libderiv->dvrr_stack = int_stack + 36642;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_d0hg(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+10770,int_stack+5802,int_stack+5550,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+11148,int_stack+6138,int_stack+5802,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+11652,int_stack+11148,int_stack+10770,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12408,int_stack+6570,int_stack+6138,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+13056,int_stack+12408,int_stack+11148,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+14064,int_stack+13056,int_stack+11652,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15324,int_stack+126,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5550,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15702,int_stack+294,int_stack+126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5802,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+16206,int_stack+15702,int_stack+15324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10770,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+16962,int_stack+510,int_stack+294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6138,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17610,int_stack+16962,int_stack+15702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11148,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18618,int_stack+17610,int_stack+16206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11652,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+15324,int_stack+780,int_stack+510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6570,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19878,int_stack+15324,int_stack+16962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12408,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+15324,int_stack+19878,int_stack+17610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13056,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19878,int_stack+1236,int_stack+1110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5550, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20256,int_stack+1404,int_stack+1236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5802, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+20760,int_stack+20256,int_stack+19878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10770, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17004,int_stack+1620,int_stack+1404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6138, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+17004,int_stack+20256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11148, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21516,int_stack+0,int_stack+20760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11652, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+19878,int_stack+1890,int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6570, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+22776,int_stack+19878,int_stack+17004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12408, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+24072,int_stack+22776,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13056, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+2346,int_stack+2220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5550, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+2514,int_stack+2346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5802, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+882,int_stack+378,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10770, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1638,int_stack+2730,int_stack+2514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6138, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+22776,int_stack+1638,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11148, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+17004,int_stack+22776,int_stack+882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11652, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+3000,int_stack+2730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6570, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19878,int_stack+0,int_stack+1638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12408, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+19878,int_stack+22776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13056, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22776,int_stack+3456,int_stack+3330, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23154,int_stack+3624,int_stack+3456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19878,int_stack+23154,int_stack+22776, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+20634,int_stack+3840,int_stack+3624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1680,int_stack+20634,int_stack+23154, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22776,int_stack+1680,int_stack+19878, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2688,int_stack+4110,int_stack+3840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+25752,int_stack+2688,int_stack+20634, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2688,int_stack+25752,int_stack+1680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1680,int_stack+4566,int_stack+4440, 0.0, zero_stack, 1.0, int_stack+5550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2058,int_stack+4734,int_stack+4566, 0.0, zero_stack, 1.0, int_stack+5802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25752,int_stack+2058,int_stack+1680, 0.0, zero_stack, 1.0, int_stack+10770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+26508,int_stack+4950,int_stack+4734, 0.0, zero_stack, 1.0, int_stack+6138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19878,int_stack+26508,int_stack+2058, 0.0, zero_stack, 1.0, int_stack+11148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+27156,int_stack+19878,int_stack+25752, 0.0, zero_stack, 1.0, int_stack+11652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1680,int_stack+5220,int_stack+4950, 0.0, zero_stack, 1.0, int_stack+6570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+28416,int_stack+1680,int_stack+26508, 0.0, zero_stack, 1.0, int_stack+12408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+29712,int_stack+28416,int_stack+19878, 0.0, zero_stack, 1.0, int_stack+13056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19878,int_stack+5970,int_stack+5676, 1.0, int_stack+5550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20256,int_stack+6354,int_stack+5970, 1.0, int_stack+5802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+20760,int_stack+20256,int_stack+19878, 1.0, int_stack+10770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+28416,int_stack+6840,int_stack+6354, 1.0, int_stack+6138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1680,int_stack+28416,int_stack+20256, 1.0, int_stack+11148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+25752,int_stack+1680,int_stack+20760, 1.0, int_stack+11652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+10770,int_stack+7110,int_stack+6840, 1.0, int_stack+6570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19878,int_stack+10770,int_stack+28416, 1.0, int_stack+12408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+10770,int_stack+19878,int_stack+1680, 1.0, int_stack+13056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1680,int_stack+7566,int_stack+7440,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2058,int_stack+7734,int_stack+7566,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+19878,int_stack+2058,int_stack+1680,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+20634,int_stack+7950,int_stack+7734,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+28416,int_stack+20634,int_stack+2058,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+12450,int_stack+28416,int_stack+19878,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1680,int_stack+8220,int_stack+7950,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4368,int_stack+1680,int_stack+20634,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5664,int_stack+4368,int_stack+28416,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+28416,int_stack+8676,int_stack+8550,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28794,int_stack+8844,int_stack+8676,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4368,int_stack+28794,int_stack+28416,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1680,int_stack+9060,int_stack+8844,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+19878,int_stack+1680,int_stack+28794,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+28416,int_stack+19878,int_stack+4368,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4368,int_stack+9330,int_stack+9060,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+7344,int_stack+4368,int_stack+1680,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+31392,int_stack+7344,int_stack+19878,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19878,int_stack+9786,int_stack+9660,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+20256,int_stack+9954,int_stack+9786,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+20760,int_stack+20256,int_stack+19878,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+7344,int_stack+10170,int_stack+9954,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1680,int_stack+7344,int_stack+20256,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+7992,int_stack+1680,int_stack+20760,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+19878,int_stack+10440,int_stack+10170,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4368,int_stack+19878,int_stack+7344,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+33072,int_stack+4368,int_stack+1680,6);
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+34752,int_stack+15324,int_stack+18618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14064,6);
     Libderiv->ABCD[11] = int_stack + 34752;
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+18264,int_stack+24072,int_stack+21516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14064, 0.0, zero_stack,6);
     Libderiv->ABCD[10] = int_stack + 18264;
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+20154,int_stack+0,int_stack+17004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14064, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[9] = int_stack + 20154;
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+2688,int_stack+22776, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1890,int_stack+29712,int_stack+27156, 0.0, zero_stack, 1.0, int_stack+14064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[7] = int_stack + 1890;
 /*--- compute (d0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+15324,int_stack+10770,int_stack+25752, 1.0, int_stack+14064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[6] = int_stack + 15324;
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+9252,int_stack+5664,int_stack+12450,6);
     Libderiv->ABCD[2] = int_stack + 9252;
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3780,int_stack+31392,int_stack+28416,6);
     Libderiv->ABCD[1] = int_stack + 3780;
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5670,int_stack+33072,int_stack+7992,6);
     Libderiv->ABCD[0] = int_stack + 5670;

}
