/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ffhf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ff|hf) integrals */

void d1hrr_order_ffhf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][5][11] = int_stack + 0;
 Libderiv->deriv_classes[3][6][11] = int_stack + 210;
 Libderiv->deriv_classes[3][7][11] = int_stack + 490;
 Libderiv->deriv_classes[3][8][11] = int_stack + 850;
 Libderiv->deriv_classes[4][5][11] = int_stack + 1300;
 Libderiv->deriv_classes[4][6][11] = int_stack + 1615;
 Libderiv->deriv_classes[4][7][11] = int_stack + 2035;
 Libderiv->deriv_classes[4][8][11] = int_stack + 2575;
 Libderiv->deriv_classes[5][5][11] = int_stack + 3250;
 Libderiv->deriv_classes[5][6][11] = int_stack + 3691;
 Libderiv->deriv_classes[5][7][11] = int_stack + 4279;
 Libderiv->deriv_classes[5][8][11] = int_stack + 5035;
 Libderiv->deriv_classes[6][5][11] = int_stack + 5980;
 Libderiv->deriv_classes[6][6][11] = int_stack + 6568;
 Libderiv->deriv_classes[6][7][11] = int_stack + 7352;
 Libderiv->deriv_classes[6][8][11] = int_stack + 8360;
 Libderiv->deriv_classes[3][5][10] = int_stack + 9620;
 Libderiv->deriv_classes[3][6][10] = int_stack + 9830;
 Libderiv->deriv_classes[3][7][10] = int_stack + 10110;
 Libderiv->deriv_classes[3][8][10] = int_stack + 10470;
 Libderiv->deriv_classes[4][5][10] = int_stack + 10920;
 Libderiv->deriv_classes[4][6][10] = int_stack + 11235;
 Libderiv->deriv_classes[4][7][10] = int_stack + 11655;
 Libderiv->deriv_classes[4][8][10] = int_stack + 12195;
 Libderiv->deriv_classes[5][5][10] = int_stack + 12870;
 Libderiv->deriv_classes[5][6][10] = int_stack + 13311;
 Libderiv->deriv_classes[5][7][10] = int_stack + 13899;
 Libderiv->deriv_classes[5][8][10] = int_stack + 14655;
 Libderiv->deriv_classes[6][5][10] = int_stack + 15600;
 Libderiv->deriv_classes[6][6][10] = int_stack + 16188;
 Libderiv->deriv_classes[6][7][10] = int_stack + 16972;
 Libderiv->deriv_classes[6][8][10] = int_stack + 17980;
 Libderiv->deriv_classes[3][5][9] = int_stack + 19240;
 Libderiv->deriv_classes[3][6][9] = int_stack + 19450;
 Libderiv->deriv_classes[3][7][9] = int_stack + 19730;
 Libderiv->deriv_classes[3][8][9] = int_stack + 20090;
 Libderiv->deriv_classes[4][5][9] = int_stack + 20540;
 Libderiv->deriv_classes[4][6][9] = int_stack + 20855;
 Libderiv->deriv_classes[4][7][9] = int_stack + 21275;
 Libderiv->deriv_classes[4][8][9] = int_stack + 21815;
 Libderiv->deriv_classes[5][5][9] = int_stack + 22490;
 Libderiv->deriv_classes[5][6][9] = int_stack + 22931;
 Libderiv->deriv_classes[5][7][9] = int_stack + 23519;
 Libderiv->deriv_classes[5][8][9] = int_stack + 24275;
 Libderiv->deriv_classes[6][5][9] = int_stack + 25220;
 Libderiv->deriv_classes[6][6][9] = int_stack + 25808;
 Libderiv->deriv_classes[6][7][9] = int_stack + 26592;
 Libderiv->deriv_classes[6][8][9] = int_stack + 27600;
 Libderiv->deriv_classes[3][5][8] = int_stack + 28860;
 Libderiv->deriv_classes[3][6][8] = int_stack + 29070;
 Libderiv->deriv_classes[3][7][8] = int_stack + 29350;
 Libderiv->deriv_classes[3][8][8] = int_stack + 29710;
 Libderiv->deriv_classes[4][5][8] = int_stack + 30160;
 Libderiv->deriv_classes[4][6][8] = int_stack + 30475;
 Libderiv->deriv_classes[4][7][8] = int_stack + 30895;
 Libderiv->deriv_classes[4][8][8] = int_stack + 31435;
 Libderiv->deriv_classes[5][5][8] = int_stack + 32110;
 Libderiv->deriv_classes[5][6][8] = int_stack + 32551;
 Libderiv->deriv_classes[5][7][8] = int_stack + 33139;
 Libderiv->deriv_classes[5][8][8] = int_stack + 33895;
 Libderiv->deriv_classes[6][5][8] = int_stack + 34840;
 Libderiv->deriv_classes[6][6][8] = int_stack + 35428;
 Libderiv->deriv_classes[6][7][8] = int_stack + 36212;
 Libderiv->deriv_classes[6][8][8] = int_stack + 37220;
 Libderiv->deriv_classes[3][5][7] = int_stack + 38480;
 Libderiv->deriv_classes[3][6][7] = int_stack + 38690;
 Libderiv->deriv_classes[3][7][7] = int_stack + 38970;
 Libderiv->deriv_classes[3][8][7] = int_stack + 39330;
 Libderiv->deriv_classes[4][5][7] = int_stack + 39780;
 Libderiv->deriv_classes[4][6][7] = int_stack + 40095;
 Libderiv->deriv_classes[4][7][7] = int_stack + 40515;
 Libderiv->deriv_classes[4][8][7] = int_stack + 41055;
 Libderiv->deriv_classes[5][5][7] = int_stack + 41730;
 Libderiv->deriv_classes[5][6][7] = int_stack + 42171;
 Libderiv->deriv_classes[5][7][7] = int_stack + 42759;
 Libderiv->deriv_classes[5][8][7] = int_stack + 43515;
 Libderiv->deriv_classes[6][5][7] = int_stack + 44460;
 Libderiv->deriv_classes[6][6][7] = int_stack + 45048;
 Libderiv->deriv_classes[6][7][7] = int_stack + 45832;
 Libderiv->deriv_classes[6][8][7] = int_stack + 46840;
 Libderiv->deriv_classes[3][5][6] = int_stack + 48100;
 Libderiv->deriv_classes[3][6][6] = int_stack + 48310;
 Libderiv->deriv_classes[3][7][6] = int_stack + 48590;
 Libderiv->deriv_classes[3][8][6] = int_stack + 48950;
 Libderiv->deriv_classes[4][5][6] = int_stack + 49400;
 Libderiv->deriv_classes[4][6][6] = int_stack + 49715;
 Libderiv->deriv_classes[4][7][6] = int_stack + 50135;
 Libderiv->deriv_classes[4][8][6] = int_stack + 50675;
 Libderiv->deriv_classes[5][5][6] = int_stack + 51350;
 Libderiv->deriv_classes[5][6][6] = int_stack + 51791;
 Libderiv->deriv_classes[5][7][6] = int_stack + 52379;
 Libderiv->deriv_classes[5][8][6] = int_stack + 53135;
 Libderiv->dvrr_classes[6][5] = int_stack + 54080;
 Libderiv->deriv_classes[6][5][6] = int_stack + 54668;
 Libderiv->dvrr_classes[6][6] = int_stack + 55256;
 Libderiv->deriv_classes[6][6][6] = int_stack + 56040;
 Libderiv->dvrr_classes[6][7] = int_stack + 56824;
 Libderiv->deriv_classes[6][7][6] = int_stack + 57832;
 Libderiv->deriv_classes[6][8][6] = int_stack + 58840;
 Libderiv->deriv_classes[3][5][2] = int_stack + 60100;
 Libderiv->deriv_classes[3][6][2] = int_stack + 60310;
 Libderiv->deriv_classes[3][7][2] = int_stack + 60590;
 Libderiv->deriv_classes[3][8][2] = int_stack + 60950;
 Libderiv->deriv_classes[4][5][2] = int_stack + 61400;
 Libderiv->deriv_classes[4][6][2] = int_stack + 61715;
 Libderiv->deriv_classes[4][7][2] = int_stack + 62135;
 Libderiv->deriv_classes[4][8][2] = int_stack + 62675;
 Libderiv->deriv_classes[5][5][2] = int_stack + 63350;
 Libderiv->deriv_classes[5][6][2] = int_stack + 63791;
 Libderiv->deriv_classes[5][7][2] = int_stack + 64379;
 Libderiv->deriv_classes[5][8][2] = int_stack + 65135;
 Libderiv->deriv_classes[6][5][2] = int_stack + 66080;
 Libderiv->deriv_classes[6][6][2] = int_stack + 66668;
 Libderiv->deriv_classes[6][7][2] = int_stack + 67452;
 Libderiv->deriv_classes[6][8][2] = int_stack + 68460;
 Libderiv->deriv_classes[3][5][1] = int_stack + 69720;
 Libderiv->deriv_classes[3][6][1] = int_stack + 69930;
 Libderiv->deriv_classes[3][7][1] = int_stack + 70210;
 Libderiv->deriv_classes[3][8][1] = int_stack + 70570;
 Libderiv->deriv_classes[4][5][1] = int_stack + 71020;
 Libderiv->deriv_classes[4][6][1] = int_stack + 71335;
 Libderiv->deriv_classes[4][7][1] = int_stack + 71755;
 Libderiv->deriv_classes[4][8][1] = int_stack + 72295;
 Libderiv->deriv_classes[5][5][1] = int_stack + 72970;
 Libderiv->deriv_classes[5][6][1] = int_stack + 73411;
 Libderiv->deriv_classes[5][7][1] = int_stack + 73999;
 Libderiv->deriv_classes[5][8][1] = int_stack + 74755;
 Libderiv->deriv_classes[6][5][1] = int_stack + 75700;
 Libderiv->deriv_classes[6][6][1] = int_stack + 76288;
 Libderiv->deriv_classes[6][7][1] = int_stack + 77072;
 Libderiv->deriv_classes[6][8][1] = int_stack + 78080;
 Libderiv->dvrr_classes[3][5] = int_stack + 79340;
 Libderiv->dvrr_classes[3][6] = int_stack + 79550;
 Libderiv->dvrr_classes[3][7] = int_stack + 79830;
 Libderiv->dvrr_classes[3][8] = int_stack + 80190;
 Libderiv->deriv_classes[3][5][0] = int_stack + 80640;
 Libderiv->deriv_classes[3][6][0] = int_stack + 80850;
 Libderiv->deriv_classes[3][7][0] = int_stack + 81130;
 Libderiv->deriv_classes[3][8][0] = int_stack + 81490;
 Libderiv->dvrr_classes[4][5] = int_stack + 81940;
 Libderiv->dvrr_classes[4][6] = int_stack + 82255;
 Libderiv->dvrr_classes[4][7] = int_stack + 82675;
 Libderiv->dvrr_classes[4][8] = int_stack + 83215;
 Libderiv->deriv_classes[4][5][0] = int_stack + 83890;
 Libderiv->deriv_classes[4][6][0] = int_stack + 84205;
 Libderiv->deriv_classes[4][7][0] = int_stack + 84625;
 Libderiv->deriv_classes[4][8][0] = int_stack + 85165;
 Libderiv->dvrr_classes[5][5] = int_stack + 85840;
 Libderiv->dvrr_classes[5][6] = int_stack + 86281;
 Libderiv->dvrr_classes[5][7] = int_stack + 86869;
 Libderiv->dvrr_classes[5][8] = int_stack + 87625;
 Libderiv->deriv_classes[5][5][0] = int_stack + 88570;
 Libderiv->deriv_classes[5][6][0] = int_stack + 89011;
 Libderiv->deriv_classes[5][7][0] = int_stack + 89599;
 Libderiv->deriv_classes[5][8][0] = int_stack + 90355;
 Libderiv->deriv_classes[6][5][0] = int_stack + 91300;
 Libderiv->deriv_classes[6][6][0] = int_stack + 91888;
 Libderiv->deriv_classes[6][7][0] = int_stack + 92672;
 Libderiv->deriv_classes[6][8][0] = int_stack + 93680;
 memset(int_stack,0,759520);

 Libderiv->dvrr_stack = int_stack + 379877;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ffhf(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+94940,int_stack+79550,int_stack+79340,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+95570,int_stack+79830,int_stack+79550,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+96410,int_stack+95570,int_stack+94940,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+97670,int_stack+210,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79340,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+98300,int_stack+490,int_stack+210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79550,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+99140,int_stack+98300,int_stack+97670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94940,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+100400,int_stack+850,int_stack+490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79830,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+101480,int_stack+100400,int_stack+98300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95570,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+103160,int_stack+101480,int_stack+99140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96410,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+97670,int_stack+82255,int_stack+81940,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+98615,int_stack+82675,int_stack+82255,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+99875,int_stack+98615,int_stack+97670,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+101765,int_stack+1615,int_stack+1300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81940,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+2035,int_stack+1615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82255,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+105260,int_stack+0,int_stack+101765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97670,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+107150,int_stack+2575,int_stack+2035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82675,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+108770,int_stack+107150,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98615,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+108770,int_stack+105260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99875,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+105260,int_stack+0,int_stack+103160,210);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+101765,int_stack+86281,int_stack+85840,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+103088,int_stack+86869,int_stack+86281,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+111560,int_stack+103088,int_stack+101765,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+3691,int_stack+3250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85840,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115529,int_stack+4279,int_stack+3691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86281,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+117293,int_stack+115529,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101765,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+119939,int_stack+5035,int_stack+4279, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86869,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122207,int_stack+119939,int_stack+115529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103088,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+125735,int_stack+122207,int_stack+117293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111560,21);
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+114206,int_stack+125735,int_stack+0,210);
 /*--- compute (fd|hf) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+130145,int_stack+114206,int_stack+105260,210);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+55256,int_stack+54080,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+56824,int_stack+55256,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+104852,int_stack+1764,int_stack+0,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+6568,int_stack+5980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54080,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+108380,int_stack+7352,int_stack+6568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55256,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+142745,int_stack+108380,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4116,int_stack+8360,int_stack+7352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56824,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+146273,int_stack+4116,int_stack+108380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+150977,int_stack+146273,int_stack+142745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104852,28);
 /*--- compute (hp|hf) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+156857,int_stack+150977,int_stack+125735,210);
 /*--- compute (gd|hf) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+170087,int_stack+156857,int_stack+114206,210);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+9830,int_stack+9620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79340, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114836,int_stack+10110,int_stack+9830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79550, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+115676,int_stack+114836,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94940, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+116936,int_stack+10470,int_stack+10110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79830, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+118016,int_stack+116936,int_stack+114836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95570, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+119696,int_stack+118016,int_stack+115676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96410, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+11235,int_stack+10920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81940, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115151,int_stack+11655,int_stack+11235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82255, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+116411,int_stack+115151,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97670, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+121796,int_stack+12195,int_stack+11655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82675, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123416,int_stack+121796,int_stack+115151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98615, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+125936,int_stack+123416,int_stack+116411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99875, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+142745,int_stack+125936,int_stack+119696,210);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+13311,int_stack+12870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85840, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115529,int_stack+13899,int_stack+13311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86281, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+117293,int_stack+115529,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101765, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+119939,int_stack+14655,int_stack+13899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86869, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122207,int_stack+119939,int_stack+115529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103088, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+149045,int_stack+122207,int_stack+117293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111560, 0.0, zero_stack,21);
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+114206,int_stack+149045,int_stack+125936,210);
 /*--- compute (fd|hf) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+153455,int_stack+114206,int_stack+142745,210);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+142745,int_stack+16188,int_stack+15600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54080, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+144509,int_stack+16972,int_stack+16188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55256, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+123656,int_stack+144509,int_stack+142745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+166055,int_stack+17980,int_stack+16972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56824, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4116,int_stack+166055,int_stack+144509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+142745,int_stack+4116,int_stack+123656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104852, 0.0, zero_stack,28);
 /*--- compute (hp|hf) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+4116,int_stack+142745,int_stack+149045,210);
 /*--- compute (gd|hf) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+188987,int_stack+4116,int_stack+114206,210);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+19450,int_stack+19240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79340, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114836,int_stack+19730,int_stack+19450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79550, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+115676,int_stack+114836,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94940, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+116936,int_stack+20090,int_stack+19730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79830, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+118016,int_stack+116936,int_stack+114836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95570, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+119696,int_stack+118016,int_stack+115676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96410, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+20855,int_stack+20540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81940, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115151,int_stack+21275,int_stack+20855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82255, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+116411,int_stack+115151,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97670, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+121796,int_stack+21815,int_stack+21275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82675, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123416,int_stack+121796,int_stack+115151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98615, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+125936,int_stack+123416,int_stack+116411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99875, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+4116,int_stack+125936,int_stack+119696,210);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+22931,int_stack+22490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85840, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115529,int_stack+23519,int_stack+22931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86281, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+117293,int_stack+115529,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101765, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+119939,int_stack+24275,int_stack+23519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86869, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122207,int_stack+119939,int_stack+115529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103088, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10416,int_stack+122207,int_stack+117293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111560, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+114206,int_stack+10416,int_stack+125936,210);
 /*--- compute (fd|hf) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+207887,int_stack+114206,int_stack+4116,210);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+25808,int_stack+25220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54080, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5880,int_stack+26592,int_stack+25808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55256, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+123656,int_stack+5880,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+14826,int_stack+27600,int_stack+26592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56824, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17850,int_stack+14826,int_stack+5880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4116,int_stack+17850,int_stack+123656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104852, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hf) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+14826,int_stack+4116,int_stack+10416,210);
 /*--- compute (gd|hf) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+220487,int_stack+14826,int_stack+114206,210);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+29070,int_stack+28860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114836,int_stack+29350,int_stack+29070, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+115676,int_stack+114836,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+116936,int_stack+29710,int_stack+29350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+118016,int_stack+116936,int_stack+114836, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+119696,int_stack+118016,int_stack+115676, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+30475,int_stack+30160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115151,int_stack+30895,int_stack+30475, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+116411,int_stack+115151,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+121796,int_stack+31435,int_stack+30895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123416,int_stack+121796,int_stack+115151, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+125936,int_stack+123416,int_stack+116411, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+4116,int_stack+125936,int_stack+119696,210);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+32551,int_stack+32110, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115529,int_stack+33139,int_stack+32551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+117293,int_stack+115529,int_stack+114206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+119939,int_stack+33895,int_stack+33139, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122207,int_stack+119939,int_stack+115529, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10416,int_stack+122207,int_stack+117293, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+114206,int_stack+10416,int_stack+125936,210);
 /*--- compute (fd|hf) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+14826,int_stack+114206,int_stack+4116,210);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+35428,int_stack+34840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5880,int_stack+36212,int_stack+35428, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+123656,int_stack+5880,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+27426,int_stack+37220,int_stack+36212, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+30450,int_stack+27426,int_stack+5880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4116,int_stack+30450,int_stack+123656, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hf) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+239387,int_stack+4116,int_stack+10416,210);
 /*--- compute (gd|hf) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+252617,int_stack+239387,int_stack+114206,210);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+38690,int_stack+38480, 0.0, zero_stack, 1.0, int_stack+79340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114836,int_stack+38970,int_stack+38690, 0.0, zero_stack, 1.0, int_stack+79550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+115676,int_stack+114836,int_stack+114206, 0.0, zero_stack, 1.0, int_stack+94940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+116936,int_stack+39330,int_stack+38970, 0.0, zero_stack, 1.0, int_stack+79830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+118016,int_stack+116936,int_stack+114836, 0.0, zero_stack, 1.0, int_stack+95570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+119696,int_stack+118016,int_stack+115676, 0.0, zero_stack, 1.0, int_stack+96410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+40095,int_stack+39780, 0.0, zero_stack, 1.0, int_stack+81940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115151,int_stack+40515,int_stack+40095, 0.0, zero_stack, 1.0, int_stack+82255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+116411,int_stack+115151,int_stack+114206, 0.0, zero_stack, 1.0, int_stack+97670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+121796,int_stack+41055,int_stack+40515, 0.0, zero_stack, 1.0, int_stack+82675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123416,int_stack+121796,int_stack+115151, 0.0, zero_stack, 1.0, int_stack+98615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+125936,int_stack+123416,int_stack+116411, 0.0, zero_stack, 1.0, int_stack+99875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+239387,int_stack+125936,int_stack+119696,210);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+42171,int_stack+41730, 0.0, zero_stack, 1.0, int_stack+85840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115529,int_stack+42759,int_stack+42171, 0.0, zero_stack, 1.0, int_stack+86281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+117293,int_stack+115529,int_stack+114206, 0.0, zero_stack, 1.0, int_stack+101765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+119939,int_stack+43515,int_stack+42759, 0.0, zero_stack, 1.0, int_stack+86869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122207,int_stack+119939,int_stack+115529, 0.0, zero_stack, 1.0, int_stack+103088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+245687,int_stack+122207,int_stack+117293, 0.0, zero_stack, 1.0, int_stack+111560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+114206,int_stack+245687,int_stack+125936,210);
 /*--- compute (fd|hf) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+27426,int_stack+114206,int_stack+239387,210);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239387,int_stack+45048,int_stack+44460, 0.0, zero_stack, 1.0, int_stack+54080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+241151,int_stack+45832,int_stack+45048, 0.0, zero_stack, 1.0, int_stack+55256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+123656,int_stack+241151,int_stack+239387, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4116,int_stack+46840,int_stack+45832, 0.0, zero_stack, 1.0, int_stack+56824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7140,int_stack+4116,int_stack+241151, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+239387,int_stack+7140,int_stack+123656, 0.0, zero_stack, 1.0, int_stack+104852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hf) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+271517,int_stack+239387,int_stack+245687,210);
 /*--- compute (gd|hf) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+284747,int_stack+271517,int_stack+114206,210);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+48310,int_stack+48100, 1.0, int_stack+79340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114836,int_stack+48590,int_stack+48310, 1.0, int_stack+79550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+115676,int_stack+114836,int_stack+114206, 1.0, int_stack+94940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+116936,int_stack+48950,int_stack+48590, 1.0, int_stack+79830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+118016,int_stack+116936,int_stack+114836, 1.0, int_stack+95570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+119696,int_stack+118016,int_stack+115676, 1.0, int_stack+96410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+49715,int_stack+49400, 1.0, int_stack+81940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115151,int_stack+50135,int_stack+49715, 1.0, int_stack+82255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+116411,int_stack+115151,int_stack+114206, 1.0, int_stack+97670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+121796,int_stack+50675,int_stack+50135, 1.0, int_stack+82675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123416,int_stack+121796,int_stack+115151, 1.0, int_stack+98615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+125936,int_stack+123416,int_stack+116411, 1.0, int_stack+99875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+271517,int_stack+125936,int_stack+119696,210);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114206,int_stack+51791,int_stack+51350, 1.0, int_stack+85840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115529,int_stack+52379,int_stack+51791, 1.0, int_stack+86281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+117293,int_stack+115529,int_stack+114206, 1.0, int_stack+101765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+119939,int_stack+53135,int_stack+52379, 1.0, int_stack+86869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122207,int_stack+119939,int_stack+115529, 1.0, int_stack+103088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+277817,int_stack+122207,int_stack+117293, 1.0, int_stack+111560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+114206,int_stack+277817,int_stack+125936,210);
 /*--- compute (fd|hf) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+239387,int_stack+114206,int_stack+271517,210);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271517,int_stack+56040,int_stack+54668, 1.0, int_stack+54080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+273281,int_stack+57832,int_stack+56040, 1.0, int_stack+55256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+123656,int_stack+273281,int_stack+271517, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4116,int_stack+58840,int_stack+57832, 1.0, int_stack+56824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7140,int_stack+4116,int_stack+273281, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+7140,int_stack+123656, 1.0, int_stack+104852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hf) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+40026,int_stack+0,int_stack+277817,210);
 /*--- compute (gd|hf) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+303647,int_stack+40026,int_stack+114206,210);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+114206,int_stack+80190,int_stack+79830,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+115286,int_stack+114206,int_stack+95570,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+116966,int_stack+115286,int_stack+96410,10);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+114206,int_stack+83215,int_stack+82675,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+119066,int_stack+114206,int_stack+98615,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+121586,int_stack+119066,int_stack+99875,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+40026,int_stack+121586,int_stack+116966,210);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+119066,int_stack+87625,int_stack+86869,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+124736,int_stack+119066,int_stack+103088,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+46326,int_stack+124736,int_stack+111560,21);
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+0,int_stack+46326,int_stack+121586,210);
 /*--- compute (fd|hf) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+271517,int_stack+0,int_stack+40026,210);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+284117,int_stack+60310,int_stack+60100,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+124736,int_stack+60590,int_stack+60310,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+125576,int_stack+124736,int_stack+284117,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+126836,int_stack+60950,int_stack+60590,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+127916,int_stack+126836,int_stack+124736,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+119066,int_stack+127916,int_stack+125576,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+124736,int_stack+61715,int_stack+61400,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+125681,int_stack+62135,int_stack+61715,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+126941,int_stack+125681,int_stack+124736,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+50736,int_stack+62675,int_stack+62135,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+52356,int_stack+50736,int_stack+125681,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+54876,int_stack+52356,int_stack+126941,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+94940,int_stack+54876,int_stack+119066, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+119066,int_stack+63791,int_stack+63350,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+50736,int_stack+64379,int_stack+63791,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+124736,int_stack+50736,int_stack+119066,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+119066,int_stack+65135,int_stack+64379,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+58026,int_stack+119066,int_stack+50736,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+61554,int_stack+58026,int_stack+124736,21);
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+101240,int_stack+61554,int_stack+54876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+121586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (fd|hf) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+322547,int_stack+101240,int_stack+94940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+94940,int_stack+66668,int_stack+66080,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+96704,int_stack+67452,int_stack+66668,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+124736,int_stack+96704,int_stack+94940,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+50736,int_stack+68460,int_stack+67452,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+53760,int_stack+50736,int_stack+96704,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+94940,int_stack+53760,int_stack+124736,28);
 /*--- compute (hp|hf) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+335147,int_stack+94940,int_stack+61554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (gd|hf) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+50736,int_stack+335147,int_stack+101240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+284117,int_stack+69930,int_stack+69720,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+335147,int_stack+70210,int_stack+69930,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+335987,int_stack+335147,int_stack+284117,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+337247,int_stack+70570,int_stack+70210,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+338327,int_stack+337247,int_stack+335147,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+340007,int_stack+338327,int_stack+335987,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+335147,int_stack+71335,int_stack+71020,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+336092,int_stack+71755,int_stack+71335,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+337352,int_stack+336092,int_stack+335147,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+342107,int_stack+72295,int_stack+71755,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+119066,int_stack+342107,int_stack+336092,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+342107,int_stack+119066,int_stack+337352,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+94940,int_stack+342107,int_stack+340007, 0.0, zero_stack, 1.0, int_stack+116966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+119066,int_stack+73411,int_stack+72970,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+345257,int_stack+73999,int_stack+73411,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+335147,int_stack+345257,int_stack+119066,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+119066,int_stack+74755,int_stack+73999,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+337793,int_stack+119066,int_stack+345257,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+101240,int_stack+337793,int_stack+335147,21);
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+105650,int_stack+101240,int_stack+342107, 0.0, zero_stack, 1.0, int_stack+121586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (fd|hf) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+335147,int_stack+105650,int_stack+94940, 0.0, zero_stack, 1.0, int_stack+40026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+94940,int_stack+76288,int_stack+75700,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+96704,int_stack+77072,int_stack+76288,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+124736,int_stack+96704,int_stack+94940,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+69636,int_stack+78080,int_stack+77072,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+72660,int_stack+69636,int_stack+96704,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+94940,int_stack+72660,int_stack+124736,28);
 /*--- compute (hp|hf) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+347747,int_stack+94940,int_stack+101240, 0.0, zero_stack, 1.0, int_stack+46326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (gd|hf) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+360977,int_stack+347747,int_stack+105650, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+284117,int_stack+80850,int_stack+80640,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+347747,int_stack+81130,int_stack+80850,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+348587,int_stack+347747,int_stack+284117,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+349847,int_stack+81490,int_stack+81130,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+350927,int_stack+349847,int_stack+347747,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+352607,int_stack+350927,int_stack+348587,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+347747,int_stack+84205,int_stack+83890,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+348692,int_stack+84625,int_stack+84205,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+349952,int_stack+348692,int_stack+347747,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+354707,int_stack+85165,int_stack+84625,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+119066,int_stack+354707,int_stack+348692,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+354707,int_stack+119066,int_stack+349952,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+94940,int_stack+354707,int_stack+352607, 1.0, int_stack+116966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+357857,int_stack+89011,int_stack+88570,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+359180,int_stack+89599,int_stack+89011,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+347747,int_stack+359180,int_stack+357857,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+350393,int_stack+90355,int_stack+89599,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+101240,int_stack+350393,int_stack+359180,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+104768,int_stack+101240,int_stack+347747,21);
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+109178,int_stack+104768,int_stack+354707, 1.0, int_stack+121586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (fd|hf) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+347747,int_stack+109178,int_stack+94940, 1.0, int_stack+40026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+40026,int_stack+91888,int_stack+91300,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+41790,int_stack+92672,int_stack+91888,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+94940,int_stack+41790,int_stack+40026,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+98468,int_stack+93680,int_stack+92672,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+118628,int_stack+98468,int_stack+41790,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+98468,int_stack+118628,int_stack+94940,28);
 /*--- compute (hp|hf) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+69636,int_stack+98468,int_stack+104768, 1.0, int_stack+46326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (gd|hf) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+82866,int_stack+69636,int_stack+109178, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (ff|hf) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+101766,int_stack+170087,int_stack+130145,210);
     Libderiv->ABCD[11] = int_stack + 101766;
 /*--- compute (ff|hf) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+122766,int_stack+188987,int_stack+153455,210);
     Libderiv->ABCD[10] = int_stack + 122766;
 /*--- compute (ff|hf) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+143766,int_stack+220487,int_stack+207887,210);
     Libderiv->ABCD[9] = int_stack + 143766;
 /*--- compute (ff|hf) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+164766,int_stack+252617,int_stack+14826,210);
     Libderiv->ABCD[8] = int_stack + 164766;
 /*--- compute (ff|hf) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+0,int_stack+284747,int_stack+27426,210);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (ff|hf) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+21000,int_stack+303647,int_stack+239387,210);
     Libderiv->ABCD[6] = int_stack + 21000;
 /*--- compute (ff|hf) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+284117,int_stack+50736,int_stack+322547, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271517, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[2] = int_stack + 284117;
 /*--- compute (ff|hf) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+42000,int_stack+360977,int_stack+335147, 0.0, zero_stack, 1.0, int_stack+271517, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[1] = int_stack + 42000;
 /*--- compute (ff|hf) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+305117,int_stack+82866,int_stack+347747, 1.0, int_stack+271517, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[0] = int_stack + 305117;

}
