/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_d0mm(Libint_t*, prim_data*);

  /* Computes quartets of (d0|mm) integrals */

REALTYPE *hrr_order_d0mm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][9] = int_stack + 0;
 Libint->vrr_classes[2][10] = int_stack + 330;
 Libint->vrr_classes[2][11] = int_stack + 726;
 Libint->vrr_classes[2][12] = int_stack + 1194;
 Libint->vrr_classes[2][13] = int_stack + 1740;
 Libint->vrr_classes[2][14] = int_stack + 2370;
 Libint->vrr_classes[2][15] = int_stack + 3090;
 Libint->vrr_classes[2][16] = int_stack + 3906;
 Libint->vrr_classes[2][17] = int_stack + 4824;
 Libint->vrr_classes[2][18] = int_stack + 5850;
 memset(int_stack,0,6990*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 6990;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_d0mm(Libint, Data);
   Data++;
 }
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6990,int_stack+330,int_stack+0,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7980,int_stack+726,int_stack+330,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+9168,int_stack+7980,int_stack+6990,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+11148,int_stack+1194,int_stack+726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12552,int_stack+11148,int_stack+7980,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+14928,int_stack+12552,int_stack+9168,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+6990,int_stack+1740,int_stack+1194,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+18228,int_stack+6990,int_stack+11148,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21036,int_stack+18228,int_stack+12552,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+8628,int_stack+21036,int_stack+14928,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+13578,int_stack+2370,int_stack+1740,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+24996,int_stack+13578,int_stack+6990,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28272,int_stack+24996,int_stack+18228,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+32952,int_stack+28272,int_stack+21036,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+15468,int_stack+32952,int_stack+8628,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+6990,int_stack+3090,int_stack+2370,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+9150,int_stack+6990,int_stack+13578,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+38892,int_stack+9150,int_stack+24996,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+44352,int_stack+38892,int_stack+28272,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+22398,int_stack+44352,int_stack+32952,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+51372,int_stack+22398,int_stack+15468,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+12930,int_stack+3906,int_stack+3090,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+15378,int_stack+12930,int_stack+6990,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+30714,int_stack+15378,int_stack+9150,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+60612,int_stack+30714,int_stack+38892,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+68802,int_stack+60612,int_stack+44352,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+37014,int_stack+68802,int_stack+22398,6);
 /*--- compute (d0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+78630,int_stack+37014,int_stack+51372,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+6990,int_stack+4824,int_stack+3906,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+19698,int_stack+6990,int_stack+12930,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+48102,int_stack+19698,int_stack+15378,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+9744,int_stack+48102,int_stack+30714,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+24594,int_stack+9744,int_stack+60612,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+55302,int_stack+24594,int_stack+68802,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+90510,int_stack+55302,int_stack+37014,6);
 /*--- compute (d0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+104766,int_stack+90510,int_stack+78630,6);
 /*--- compute (d0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+36060,int_stack+5850,int_stack+4824,6);
 /*--- compute (d0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+39138,int_stack+36060,int_stack+6990,6);
 /*--- compute (d0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+68406,int_stack+39138,int_stack+19698,6);
 /*--- compute (d0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+36060,int_stack+68406,int_stack+48102,6);
 /*--- compute (d0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+68406,int_stack+36060,int_stack+9744,6);
 /*--- compute (d0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+36060,int_stack+68406,int_stack+24594,6);
 /*--- compute (d0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+68406,int_stack+36060,int_stack+55302,6);
 /*--- compute (d0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+68406,int_stack+90510,6);
 /*--- compute (d0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+17820,int_stack+0,int_stack+104766,6);
 return int_stack+17820;}
