/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddmk(Libint_t*, prim_data*);

  /* Computes quartets of (dd|mk) integrals */

REALTYPE *hrr_order_ddmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][9] = int_stack + 0;
 Libint->vrr_classes[2][10] = int_stack + 330;
 Libint->vrr_classes[2][11] = int_stack + 726;
 Libint->vrr_classes[2][12] = int_stack + 1194;
 Libint->vrr_classes[2][13] = int_stack + 1740;
 Libint->vrr_classes[2][14] = int_stack + 2370;
 Libint->vrr_classes[2][15] = int_stack + 3090;
 Libint->vrr_classes[2][16] = int_stack + 3906;
 Libint->vrr_classes[3][9] = int_stack + 4824;
 Libint->vrr_classes[3][10] = int_stack + 5374;
 Libint->vrr_classes[3][11] = int_stack + 6034;
 Libint->vrr_classes[3][12] = int_stack + 6814;
 Libint->vrr_classes[3][13] = int_stack + 7724;
 Libint->vrr_classes[3][14] = int_stack + 8774;
 Libint->vrr_classes[3][15] = int_stack + 9974;
 Libint->vrr_classes[3][16] = int_stack + 11334;
 Libint->vrr_classes[4][9] = int_stack + 12864;
 Libint->vrr_classes[4][10] = int_stack + 13689;
 Libint->vrr_classes[4][11] = int_stack + 14679;
 Libint->vrr_classes[4][12] = int_stack + 15849;
 Libint->vrr_classes[4][13] = int_stack + 17214;
 Libint->vrr_classes[4][14] = int_stack + 18789;
 Libint->vrr_classes[4][15] = int_stack + 20589;
 Libint->vrr_classes[4][16] = int_stack + 22629;
 memset(int_stack,0,24924*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 24924;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddmk(Libint, Data);
   Data++;
 }
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24924,int_stack+330,int_stack+0,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25914,int_stack+726,int_stack+330,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27102,int_stack+25914,int_stack+24924,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+29082,int_stack+1194,int_stack+726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+30486,int_stack+29082,int_stack+25914,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+32862,int_stack+30486,int_stack+27102,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+24924,int_stack+1740,int_stack+1194,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+36162,int_stack+24924,int_stack+29082,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+38970,int_stack+36162,int_stack+30486,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+26562,int_stack+38970,int_stack+32862,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+31512,int_stack+2370,int_stack+1740,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+42930,int_stack+31512,int_stack+24924,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+46206,int_stack+42930,int_stack+36162,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+50886,int_stack+46206,int_stack+38970,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+33402,int_stack+50886,int_stack+26562,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+24924,int_stack+3090,int_stack+2370,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+27084,int_stack+24924,int_stack+31512,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+56826,int_stack+27084,int_stack+42930,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+62286,int_stack+56826,int_stack+46206,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+40332,int_stack+62286,int_stack+50886,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+69306,int_stack+40332,int_stack+33402,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+30864,int_stack+3906,int_stack+3090,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+33312,int_stack+30864,int_stack+24924,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+48648,int_stack+33312,int_stack+27084,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+24924,int_stack+48648,int_stack+56826,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+48648,int_stack+24924,int_stack+62286,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+24924,int_stack+48648,int_stack+40332,6);
 /*--- compute (d0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+36012,int_stack+24924,int_stack+69306,6);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24924,int_stack+5374,int_stack+4824,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26574,int_stack+6034,int_stack+5374,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28554,int_stack+26574,int_stack+24924,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+31854,int_stack+6814,int_stack+6034,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+47892,int_stack+31854,int_stack+26574,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51852,int_stack+47892,int_stack+28554,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+24924,int_stack+7724,int_stack+6814,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57352,int_stack+24924,int_stack+31854,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+27654,int_stack+57352,int_stack+47892,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+62032,int_stack+27654,int_stack+51852,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+47892,int_stack+8774,int_stack+7724,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+51042,int_stack+47892,int_stack+24924,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+70282,int_stack+51042,int_stack+57352,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+78082,int_stack+70282,int_stack+27654,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+87982,int_stack+78082,int_stack+62032,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+24924,int_stack+9974,int_stack+8774,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+28524,int_stack+24924,int_stack+47892,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+56502,int_stack+28524,int_stack+51042,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+99532,int_stack+56502,int_stack+70282,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+111232,int_stack+99532,int_stack+78082,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+65602,int_stack+111232,int_stack+87982,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+47892,int_stack+11334,int_stack+9974,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+81002,int_stack+47892,int_stack+24924,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+88202,int_stack+81002,int_stack+28524,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+125092,int_stack+88202,int_stack+56502,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+81002,int_stack+125092,int_stack+99532,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+125092,int_stack+81002,int_stack+111232,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+81002,int_stack+125092,int_stack+65602,10);
 /*--- compute (dp|mk) ---*/
 hrr1_build_dp(Libint->AB,int_stack+100802,int_stack+81002,int_stack+36012,1980);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+136442,int_stack+13689,int_stack+12864,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+138917,int_stack+14679,int_stack+13689,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+24924,int_stack+138917,int_stack+136442,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+29874,int_stack+15849,int_stack+14679,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33384,int_stack+29874,int_stack+138917,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+39324,int_stack+33384,int_stack+24924,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+24924,int_stack+17214,int_stack+15849,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+136442,int_stack+24924,int_stack+29874,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+47574,int_stack+136442,int_stack+33384,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+57474,int_stack+47574,int_stack+39324,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+29019,int_stack+18789,int_stack+17214,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+33744,int_stack+29019,int_stack+24924,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+33744,int_stack+136442,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+136442,int_stack+0,int_stack+47574,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+151292,int_stack+136442,int_stack+57474,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+41934,int_stack+20589,int_stack+18789,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+47334,int_stack+41934,int_stack+29019,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+56784,int_stack+47334,int_stack+33744,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+168617,int_stack+56784,int_stack+0,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+186167,int_stack+168617,int_stack+136442,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+206957,int_stack+186167,int_stack+151292,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+136442,int_stack+22629,int_stack+20589,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+142562,int_stack+136442,int_stack+41934,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+142562,int_stack+47334,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+136442,int_stack+0,int_stack+56784,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+136442,int_stack+168617,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+136442,int_stack+0,int_stack+186167,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+136442,int_stack+206957,15);
 /*--- compute (fp|mk) ---*/
 hrr1_build_fp(Libint->AB,int_stack+136442,int_stack+0,int_stack+81002,1980);
 /*--- compute (dd|mk) ---*/
 hrr1_build_dd(Libint->AB,int_stack+0,int_stack+136442,int_stack+100802,1980);
 return int_stack+0;}
