/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpmf(Libint_t*, prim_data*);

  /* Computes quartets of (dp|mf) integrals */

REALTYPE *hrr_order_dpmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][9] = int_stack + 0;
 Libint->vrr_classes[2][10] = int_stack + 330;
 Libint->vrr_classes[2][11] = int_stack + 726;
 Libint->vrr_classes[2][12] = int_stack + 1194;
 Libint->vrr_classes[3][9] = int_stack + 1740;
 Libint->vrr_classes[3][10] = int_stack + 2290;
 Libint->vrr_classes[3][11] = int_stack + 2950;
 Libint->vrr_classes[3][12] = int_stack + 3730;
 memset(int_stack,0,4640*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 4640;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpmf(Libint, Data);
   Data++;
 }
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4640,int_stack+330,int_stack+0,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5630,int_stack+726,int_stack+330,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+6818,int_stack+5630,int_stack+4640,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8798,int_stack+1194,int_stack+726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+10202,int_stack+8798,int_stack+5630,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+12578,int_stack+10202,int_stack+6818,6);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4640,int_stack+2290,int_stack+1740,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6290,int_stack+2950,int_stack+2290,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+8270,int_stack+6290,int_stack+4640,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+3730,int_stack+2950,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15878,int_stack+0,int_stack+6290,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+15878,int_stack+8270,10);
 /*--- compute (dp|mf) ---*/
 hrr1_build_dp(Libint->AB,int_stack+15878,int_stack+0,int_stack+12578,550);
 return int_stack+15878;}
