/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdnd(Libint_t*, prim_data*);

  /* Computes quartets of (fd|nd) integrals */

REALTYPE *hrr_order_fdnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[4][10] = int_stack + 2350;
 Libint->vrr_classes[4][11] = int_stack + 3340;
 Libint->vrr_classes[4][12] = int_stack + 4510;
 Libint->vrr_classes[5][10] = int_stack + 5875;
 Libint->vrr_classes[5][11] = int_stack + 7261;
 Libint->vrr_classes[5][12] = int_stack + 8899;
 memset(int_stack,0,10810*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 10810;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdnd(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10810,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+12790,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15130,int_stack+12790,int_stack+10810,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10810,int_stack+3340,int_stack+2350,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19090,int_stack+4510,int_stack+3340,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+22600,int_stack+19090,int_stack+10810,15);
 /*--- compute (fp|nd) ---*/
 hrr1_build_fp(Libint->AB,int_stack+28540,int_stack+22600,int_stack+15130,396);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10810,int_stack+7261,int_stack+5875,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+14968,int_stack+8899,int_stack+7261,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+14968,int_stack+10810,21);
 /*--- compute (gp|nd) ---*/
 hrr1_build_gp(Libint->AB,int_stack+40420,int_stack+0,int_stack+22600,396);
 /*--- compute (fd|nd) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+40420,int_stack+28540,396);
 return int_stack+0;}
