/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdni(Libint_t*, prim_data*);

  /* Computes quartets of (fd|ni) integrals */

REALTYPE *hrr_order_fdni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[3][15] = int_stack + 4600;
 Libint->vrr_classes[3][16] = int_stack + 5960;
 Libint->vrr_classes[4][10] = int_stack + 7490;
 Libint->vrr_classes[4][11] = int_stack + 8480;
 Libint->vrr_classes[4][12] = int_stack + 9650;
 Libint->vrr_classes[4][13] = int_stack + 11015;
 Libint->vrr_classes[4][14] = int_stack + 12590;
 Libint->vrr_classes[4][15] = int_stack + 14390;
 Libint->vrr_classes[4][16] = int_stack + 16430;
 Libint->vrr_classes[5][10] = int_stack + 18725;
 Libint->vrr_classes[5][11] = int_stack + 20111;
 Libint->vrr_classes[5][12] = int_stack + 21749;
 Libint->vrr_classes[5][13] = int_stack + 23660;
 Libint->vrr_classes[5][14] = int_stack + 25865;
 Libint->vrr_classes[5][15] = int_stack + 28385;
 Libint->vrr_classes[5][16] = int_stack + 31241;
 memset(int_stack,0,34454*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 34454;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdni(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34454,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36434,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+38774,int_stack+36434,int_stack+34454,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+42734,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+45464,int_stack+42734,int_stack+36434,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+50144,int_stack+45464,int_stack+38774,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+34454,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+56744,int_stack+34454,int_stack+42734,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37604,int_stack+56744,int_stack+45464,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+62204,int_stack+37604,int_stack+50144,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+45404,int_stack+4600,int_stack+3400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+49004,int_stack+45404,int_stack+34454,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+72104,int_stack+49004,int_stack+56744,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+81204,int_stack+72104,int_stack+37604,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+92904,int_stack+81204,int_stack+62204,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+34454,int_stack+5960,int_stack+4600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+55304,int_stack+34454,int_stack+45404,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+34454,int_stack+55304,int_stack+49004,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+44954,int_stack+34454,int_stack+72104,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+58604,int_stack+44954,int_stack+81204,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+34454,int_stack+58604,int_stack+92904,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+52934,int_stack+8480,int_stack+7490,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+55904,int_stack+9650,int_stack+8480,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+59414,int_stack+55904,int_stack+52934,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+65354,int_stack+11015,int_stack+9650,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+69449,int_stack+65354,int_stack+55904,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+76469,int_stack+69449,int_stack+59414,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+52934,int_stack+12590,int_stack+11015,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+86369,int_stack+52934,int_stack+65354,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+57659,int_stack+86369,int_stack+69449,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+94559,int_stack+57659,int_stack+76469,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+69359,int_stack+14390,int_stack+12590,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+74759,int_stack+69359,int_stack+52934,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+74759,int_stack+86369,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+109409,int_stack+0,int_stack+57659,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+126959,int_stack+109409,int_stack+94559,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+52934,int_stack+16430,int_stack+14390,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+84209,int_stack+52934,int_stack+69359,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+52934,int_stack+84209,int_stack+74759,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+68684,int_stack+52934,int_stack+0,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+147749,int_stack+68684,int_stack+109409,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+52934,int_stack+147749,int_stack+126959,15);
 /*--- compute (fp|ni) ---*/
 hrr1_build_fp(Libint->AB,int_stack+80654,int_stack+52934,int_stack+34454,1848);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34454,int_stack+20111,int_stack+18725,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38612,int_stack+21749,int_stack+20111,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43526,int_stack+38612,int_stack+34454,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+23660,int_stack+21749,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5733,int_stack+0,int_stack+38612,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+136094,int_stack+5733,int_stack+43526,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+34454,int_stack+25865,int_stack+23660,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+41069,int_stack+34454,int_stack+0,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+149954,int_stack+41069,int_stack+5733,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+149954,int_stack+136094,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+136094,int_stack+28385,int_stack+25865,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+166334,int_stack+136094,int_stack+34454,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+179564,int_stack+166334,int_stack+41069,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+198674,int_stack+179564,int_stack+149954,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+223244,int_stack+198674,int_stack+0,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+31241,int_stack+28385,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+8568,int_stack+0,int_stack+136094,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+136094,int_stack+8568,int_stack+166334,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+136094,int_stack+179564,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+136094,int_stack+0,int_stack+198674,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+136094,int_stack+223244,21);
 /*--- compute (gp|ni) ---*/
 hrr1_build_gp(Libint->AB,int_stack+136094,int_stack+0,int_stack+52934,1848);
 /*--- compute (fd|ni) ---*/
 hrr1_build_fd(Libint->AB,int_stack+219254,int_stack+136094,int_stack+80654,1848);
 return int_stack+219254;}
