/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffli(Libint_t*, prim_data*);

  /* Computes quartets of (ff|li) integrals */

REALTYPE *hrr_order_ffli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[3][12] = int_stack + 2440;
 Libint->vrr_classes[3][13] = int_stack + 3350;
 Libint->vrr_classes[3][14] = int_stack + 4400;
 Libint->vrr_classes[4][8] = int_stack + 5600;
 Libint->vrr_classes[4][9] = int_stack + 6275;
 Libint->vrr_classes[4][10] = int_stack + 7100;
 Libint->vrr_classes[4][11] = int_stack + 8090;
 Libint->vrr_classes[4][12] = int_stack + 9260;
 Libint->vrr_classes[4][13] = int_stack + 10625;
 Libint->vrr_classes[4][14] = int_stack + 12200;
 Libint->vrr_classes[5][8] = int_stack + 14000;
 Libint->vrr_classes[5][9] = int_stack + 14945;
 Libint->vrr_classes[5][10] = int_stack + 16100;
 Libint->vrr_classes[5][11] = int_stack + 17486;
 Libint->vrr_classes[5][12] = int_stack + 19124;
 Libint->vrr_classes[5][13] = int_stack + 21035;
 Libint->vrr_classes[5][14] = int_stack + 23240;
 Libint->vrr_classes[6][8] = int_stack + 25760;
 Libint->vrr_classes[6][9] = int_stack + 27020;
 Libint->vrr_classes[6][10] = int_stack + 28560;
 Libint->vrr_classes[6][11] = int_stack + 30408;
 Libint->vrr_classes[6][12] = int_stack + 32592;
 Libint->vrr_classes[6][13] = int_stack + 35140;
 Libint->vrr_classes[6][14] = int_stack + 38080;
 memset(int_stack,0,41440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 41440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffli(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41440,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+42790,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+44440,int_stack+42790,int_stack+41440,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47140,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49120,int_stack+47140,int_stack+42790,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+52420,int_stack+49120,int_stack+44440,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+41440,int_stack+2440,int_stack+1660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+56920,int_stack+41440,int_stack+47140,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+60880,int_stack+56920,int_stack+49120,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+43780,int_stack+60880,int_stack+52420,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+50530,int_stack+3350,int_stack+2440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+66380,int_stack+50530,int_stack+41440,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+71060,int_stack+66380,int_stack+56920,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+77660,int_stack+71060,int_stack+60880,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+53260,int_stack+77660,int_stack+43780,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+41440,int_stack+4400,int_stack+3350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+44590,int_stack+41440,int_stack+50530,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+85910,int_stack+44590,int_stack+66380,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+41440,int_stack+85910,int_stack+71060,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+62710,int_stack+41440,int_stack+77660,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+74260,int_stack+62710,int_stack+53260,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41440,int_stack+6275,int_stack+5600,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+43465,int_stack+7100,int_stack+6275,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+45940,int_stack+43465,int_stack+41440,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+49990,int_stack+8090,int_stack+7100,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+52960,int_stack+49990,int_stack+43465,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+57910,int_stack+52960,int_stack+45940,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+41440,int_stack+9260,int_stack+8090,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+64660,int_stack+41440,int_stack+49990,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+64660,int_stack+52960,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+44950,int_stack+0,int_stack+57910,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+55075,int_stack+10625,int_stack+9260,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+86860,int_stack+55075,int_stack+41440,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+93880,int_stack+86860,int_stack+64660,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+59170,int_stack+93880,int_stack+0,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+103780,int_stack+59170,int_stack+44950,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+12200,int_stack+10625,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+4725,int_stack+0,int_stack+55075,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+41440,int_stack+4725,int_stack+86860,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+117955,int_stack+41440,int_stack+93880,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+41440,int_stack+117955,int_stack+59170,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+117955,int_stack+41440,int_stack+103780,15);
 /*--- compute (fp|li) ---*/
 hrr1_build_fp(Libint->AB,int_stack+136855,int_stack+117955,int_stack+74260,1260);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41440,int_stack+14945,int_stack+14000,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44275,int_stack+16100,int_stack+14945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+47740,int_stack+44275,int_stack+41440,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+53410,int_stack+17486,int_stack+16100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+57568,int_stack+53410,int_stack+44275,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+64498,int_stack+57568,int_stack+47740,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+41440,int_stack+19124,int_stack+17486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+73948,int_stack+41440,int_stack+53410,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+82264,int_stack+73948,int_stack+57568,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+46354,int_stack+82264,int_stack+64498,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+60529,int_stack+21035,int_stack+19124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+93814,int_stack+60529,int_stack+41440,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+103642,int_stack+93814,int_stack+73948,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+103642,int_stack+82264,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+66262,int_stack+0,int_stack+46354,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+41440,int_stack+23240,int_stack+21035,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+48055,int_stack+41440,int_stack+60529,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+174655,int_stack+48055,int_stack+93814,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+41440,int_stack+174655,int_stack+103642,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+86107,int_stack+41440,int_stack+0,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+174655,int_stack+86107,int_stack+66262,21);
 /*--- compute (gp|li) ---*/
 hrr1_build_gp(Libint->AB,int_stack+41440,int_stack+174655,int_stack+117955,1260);
 /*--- compute (fd|li) ---*/
 hrr1_build_fd(Libint->AB,int_stack+201115,int_stack+41440,int_stack+136855,1260);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+27020,int_stack+25760,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3780,int_stack+28560,int_stack+27020,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+8400,int_stack+3780,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15960,int_stack+30408,int_stack+28560,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+98140,int_stack+15960,int_stack+3780,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+107380,int_stack+98140,int_stack+8400,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+32592,int_stack+30408,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+21504,int_stack+0,int_stack+15960,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+119980,int_stack+21504,int_stack+98140,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+135380,int_stack+119980,int_stack+107380,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+98140,int_stack+35140,int_stack+32592,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+105784,int_stack+98140,int_stack+0,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+105784,int_stack+21504,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+276715,int_stack+0,int_stack+119980,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+299815,int_stack+276715,int_stack+135380,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+18480,int_stack+38080,int_stack+35140,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+118888,int_stack+18480,int_stack+98140,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+18480,int_stack+118888,int_stack+105784,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+98140,int_stack+18480,int_stack+0,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+98140,int_stack+276715,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+98140,int_stack+0,int_stack+299815,28);
 /*--- compute (hp|li) ---*/
 hrr1_build_hp(Libint->AB,int_stack+276715,int_stack+98140,int_stack+174655,1260);
 /*--- compute (gd|li) ---*/
 hrr1_build_gd(Libint->AB,int_stack+356095,int_stack+276715,int_stack+41440,1260);
 /*--- compute (ff|li) ---*/
 hrr1_build_ff(Libint->AB,int_stack+0,int_stack+356095,int_stack+201115,1260);
 return int_stack+0;}
