/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffmf(Libint_t*, prim_data*);

  /* Computes quartets of (ff|mf) integrals */

REALTYPE *hrr_order_ffmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[4][9] = int_stack + 2900;
 Libint->vrr_classes[4][10] = int_stack + 3725;
 Libint->vrr_classes[4][11] = int_stack + 4715;
 Libint->vrr_classes[4][12] = int_stack + 5885;
 Libint->vrr_classes[5][9] = int_stack + 7250;
 Libint->vrr_classes[5][10] = int_stack + 8405;
 Libint->vrr_classes[5][11] = int_stack + 9791;
 Libint->vrr_classes[5][12] = int_stack + 11429;
 Libint->vrr_classes[6][9] = int_stack + 13340;
 Libint->vrr_classes[6][10] = int_stack + 14880;
 Libint->vrr_classes[6][11] = int_stack + 16728;
 Libint->vrr_classes[6][12] = int_stack + 18912;
 memset(int_stack,0,21460*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21460;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffmf(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+21460,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23110,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+25090,int_stack+23110,int_stack+21460,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28390,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+30730,int_stack+28390,int_stack+23110,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+34690,int_stack+30730,int_stack+25090,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+21460,int_stack+3725,int_stack+2900,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23935,int_stack+4715,int_stack+3725,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+26905,int_stack+23935,int_stack+21460,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+5885,int_stack+4715,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40190,int_stack+0,int_stack+23935,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+46130,int_stack+40190,int_stack+26905,15);
 /*--- compute (fp|mf) ---*/
 hrr1_build_fp(Libint->AB,int_stack+54380,int_stack+46130,int_stack+34690,550);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+8405,int_stack+7250,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3465,int_stack+9791,int_stack+8405,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+21460,int_stack+3465,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28390,int_stack+11429,int_stack+9791,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33304,int_stack+28390,int_stack+3465,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+33304,int_stack+21460,21);
 /*--- compute (gp|mf) ---*/
 hrr1_build_gp(Libint->AB,int_stack+70880,int_stack+0,int_stack+46130,550);
 /*--- compute (fd|mf) ---*/
 hrr1_build_fd(Libint->AB,int_stack+95630,int_stack+70880,int_stack+54380,550);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+21460,int_stack+14880,int_stack+13340,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26080,int_stack+16728,int_stack+14880,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+31624,int_stack+26080,int_stack+21460,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+40864,int_stack+18912,int_stack+16728,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+47416,int_stack+40864,int_stack+26080,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+11550,int_stack+47416,int_stack+31624,28);
 /*--- compute (hp|mf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+26950,int_stack+11550,int_stack+0,550);
 /*--- compute (gd|mf) ---*/
 hrr1_build_gd(Libint->AB,int_stack+128630,int_stack+26950,int_stack+70880,550);
 /*--- compute (ff|mf) ---*/
 hrr1_build_ff(Libint->AB,int_stack+0,int_stack+128630,int_stack+95630,550);
 return int_stack+0;}
