/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffng(Libint_t*, prim_data*);

  /* Computes quartets of (ff|ng) integrals */

REALTYPE *hrr_order_ffng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[4][10] = int_stack + 4600;
 Libint->vrr_classes[4][11] = int_stack + 5590;
 Libint->vrr_classes[4][12] = int_stack + 6760;
 Libint->vrr_classes[4][13] = int_stack + 8125;
 Libint->vrr_classes[4][14] = int_stack + 9700;
 Libint->vrr_classes[5][10] = int_stack + 11500;
 Libint->vrr_classes[5][11] = int_stack + 12886;
 Libint->vrr_classes[5][12] = int_stack + 14524;
 Libint->vrr_classes[5][13] = int_stack + 16435;
 Libint->vrr_classes[5][14] = int_stack + 18640;
 Libint->vrr_classes[6][10] = int_stack + 21160;
 Libint->vrr_classes[6][11] = int_stack + 23008;
 Libint->vrr_classes[6][12] = int_stack + 25192;
 Libint->vrr_classes[6][13] = int_stack + 27740;
 Libint->vrr_classes[6][14] = int_stack + 30680;
 memset(int_stack,0,34040*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 34040;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffng(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34040,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36020,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+38360,int_stack+36020,int_stack+34040,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+42320,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+45050,int_stack+42320,int_stack+36020,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49730,int_stack+45050,int_stack+38360,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+34040,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+56330,int_stack+34040,int_stack+42320,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+34040,int_stack+56330,int_stack+45050,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+56330,int_stack+34040,int_stack+49730,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34040,int_stack+5590,int_stack+4600,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+37010,int_stack+6760,int_stack+5590,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40520,int_stack+37010,int_stack+34040,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+46460,int_stack+8125,int_stack+6760,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+46460,int_stack+37010,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+66230,int_stack+0,int_stack+40520,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+34040,int_stack+9700,int_stack+8125,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+76130,int_stack+34040,int_stack+46460,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+34040,int_stack+76130,int_stack+0,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+76130,int_stack+34040,int_stack+66230,15);
 /*--- compute (fp|ng) ---*/
 hrr1_build_fp(Libint->AB,int_stack+90980,int_stack+76130,int_stack+56330,990);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34040,int_stack+12886,int_stack+11500,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38198,int_stack+14524,int_stack+12886,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43112,int_stack+38198,int_stack+34040,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+51428,int_stack+16435,int_stack+14524,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57161,int_stack+51428,int_stack+38198,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+57161,int_stack+43112,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+34040,int_stack+18640,int_stack+16435,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+120680,int_stack+34040,int_stack+51428,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+34040,int_stack+120680,int_stack+57161,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+50420,int_stack+34040,int_stack+0,21);
 /*--- compute (gp|ng) ---*/
 hrr1_build_gp(Libint->AB,int_stack+120680,int_stack+50420,int_stack+76130,990);
 /*--- compute (fd|ng) ---*/
 hrr1_build_fd(Libint->AB,int_stack+165230,int_stack+120680,int_stack+90980,990);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+23008,int_stack+21160,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5544,int_stack+25192,int_stack+23008,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12096,int_stack+5544,int_stack+0,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+34040,int_stack+27740,int_stack+25192,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+71210,int_stack+34040,int_stack+5544,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+84314,int_stack+71210,int_stack+12096,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+30680,int_stack+27740,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+34040,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24108,int_stack+8820,int_stack+71210,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+224630,int_stack+24108,int_stack+84314,28);
 /*--- compute (hp|ng) ---*/
 hrr1_build_hp(Libint->AB,int_stack+252350,int_stack+224630,int_stack+50420,990);
 /*--- compute (gd|ng) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+252350,int_stack+120680,990);
 /*--- compute (ff|ng) ---*/
 hrr1_build_ff(Libint->AB,int_stack+224630,int_stack+0,int_stack+165230,990);
 return int_stack+224630;}
