/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffnn(Libint_t*, prim_data*);

  /* Computes quartets of (ff|nn) integrals */

REALTYPE *hrr_order_ffnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[3][15] = int_stack + 4600;
 Libint->vrr_classes[3][16] = int_stack + 5960;
 Libint->vrr_classes[3][17] = int_stack + 7490;
 Libint->vrr_classes[3][18] = int_stack + 9200;
 Libint->vrr_classes[3][19] = int_stack + 11100;
 Libint->vrr_classes[3][20] = int_stack + 13200;
 Libint->vrr_classes[4][10] = int_stack + 15510;
 Libint->vrr_classes[4][11] = int_stack + 16500;
 Libint->vrr_classes[4][12] = int_stack + 17670;
 Libint->vrr_classes[4][13] = int_stack + 19035;
 Libint->vrr_classes[4][14] = int_stack + 20610;
 Libint->vrr_classes[4][15] = int_stack + 22410;
 Libint->vrr_classes[4][16] = int_stack + 24450;
 Libint->vrr_classes[4][17] = int_stack + 26745;
 Libint->vrr_classes[4][18] = int_stack + 29310;
 Libint->vrr_classes[4][19] = int_stack + 32160;
 Libint->vrr_classes[4][20] = int_stack + 35310;
 Libint->vrr_classes[5][10] = int_stack + 38775;
 Libint->vrr_classes[5][11] = int_stack + 40161;
 Libint->vrr_classes[5][12] = int_stack + 41799;
 Libint->vrr_classes[5][13] = int_stack + 43710;
 Libint->vrr_classes[5][14] = int_stack + 45915;
 Libint->vrr_classes[5][15] = int_stack + 48435;
 Libint->vrr_classes[5][16] = int_stack + 51291;
 Libint->vrr_classes[5][17] = int_stack + 54504;
 Libint->vrr_classes[5][18] = int_stack + 58095;
 Libint->vrr_classes[5][19] = int_stack + 62085;
 Libint->vrr_classes[5][20] = int_stack + 66495;
 Libint->vrr_classes[6][10] = int_stack + 71346;
 Libint->vrr_classes[6][11] = int_stack + 73194;
 Libint->vrr_classes[6][12] = int_stack + 75378;
 Libint->vrr_classes[6][13] = int_stack + 77926;
 Libint->vrr_classes[6][14] = int_stack + 80866;
 Libint->vrr_classes[6][15] = int_stack + 84226;
 Libint->vrr_classes[6][16] = int_stack + 88034;
 Libint->vrr_classes[6][17] = int_stack + 92318;
 Libint->vrr_classes[6][18] = int_stack + 97106;
 Libint->vrr_classes[6][19] = int_stack + 102426;
 Libint->vrr_classes[6][20] = int_stack + 108306;
 memset(int_stack,0,114774*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 114774;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffnn(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+114774,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+116754,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+119094,int_stack+116754,int_stack+114774,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+123054,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+125784,int_stack+123054,int_stack+116754,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+130464,int_stack+125784,int_stack+119094,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+114774,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+137064,int_stack+114774,int_stack+123054,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+117924,int_stack+137064,int_stack+125784,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+142524,int_stack+117924,int_stack+130464,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+125724,int_stack+4600,int_stack+3400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+129324,int_stack+125724,int_stack+114774,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+152424,int_stack+129324,int_stack+137064,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+161524,int_stack+152424,int_stack+117924,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+173224,int_stack+161524,int_stack+142524,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+114774,int_stack+5960,int_stack+4600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+135624,int_stack+114774,int_stack+125724,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+187084,int_stack+135624,int_stack+129324,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+118854,int_stack+187084,int_stack+152424,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+142824,int_stack+118854,int_stack+161524,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+197584,int_stack+142824,int_stack+173224,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+159204,int_stack+7490,int_stack+5960,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+163794,int_stack+159204,int_stack+114774,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+171954,int_stack+163794,int_stack+135624,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+216064,int_stack+171954,int_stack+187084,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+231814,int_stack+216064,int_stack+118854,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+114774,int_stack+231814,int_stack+142824,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+250924,int_stack+114774,int_stack+197584,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+136614,int_stack+9200,int_stack+7490,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+141744,int_stack+136614,int_stack+159204,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+183954,int_stack+141744,int_stack+163794,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+150924,int_stack+183954,int_stack+171954,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+274684,int_stack+150924,int_stack+216064,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+197554,int_stack+274684,int_stack+231814,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+296734,int_stack+197554,int_stack+114774,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+324814,int_stack+296734,int_stack+250924,10);
 /*--- compute (f0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+114774,int_stack+11100,int_stack+9200,10);
 /*--- compute (f0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+120474,int_stack+114774,int_stack+136614,10);
 /*--- compute (f0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+223034,int_stack+120474,int_stack+141744,10);
 /*--- compute (f0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+238334,int_stack+223034,int_stack+183954,10);
 /*--- compute (f0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+168924,int_stack+238334,int_stack+150924,10);
 /*--- compute (f0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+130734,int_stack+168924,int_stack+274684,10);
 /*--- compute (f0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+258734,int_stack+130734,int_stack+197554,10);
 /*--- compute (f0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+354514,int_stack+258734,int_stack+296734,10);
 /*--- compute (f0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+389614,int_stack+354514,int_stack+324814,10);
 /*--- compute (f0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+160134,int_stack+13200,int_stack+11100,10);
 /*--- compute (f0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+194124,int_stack+160134,int_stack+114774,10);
 /*--- compute (f0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+205524,int_stack+194124,int_stack+120474,10);
 /*--- compute (f0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+291494,int_stack+205524,int_stack+223034,10);
 /*--- compute (f0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+194124,int_stack+291494,int_stack+238334,10);
 /*--- compute (f0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+291494,int_stack+194124,int_stack+168924,10);
 /*--- compute (f0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+160134,int_stack+291494,int_stack+130734,10);
 /*--- compute (f0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+291494,int_stack+160134,int_stack+258734,10);
 /*--- compute (f0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+114774,int_stack+291494,int_stack+354514,10);
 /*--- compute (f0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+157674,int_stack+114774,int_stack+389614,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+114774,int_stack+16500,int_stack+15510,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+117744,int_stack+17670,int_stack+16500,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+121254,int_stack+117744,int_stack+114774,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+127194,int_stack+19035,int_stack+17670,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+131289,int_stack+127194,int_stack+117744,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+138309,int_stack+131289,int_stack+121254,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+114774,int_stack+20610,int_stack+19035,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+148209,int_stack+114774,int_stack+127194,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+119499,int_stack+148209,int_stack+131289,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+201234,int_stack+119499,int_stack+138309,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131199,int_stack+22410,int_stack+20610,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+136599,int_stack+131199,int_stack+114774,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+216084,int_stack+136599,int_stack+148209,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+229734,int_stack+216084,int_stack+119499,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+247284,int_stack+229734,int_stack+201234,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+201234,int_stack+24450,int_stack+22410,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+114774,int_stack+201234,int_stack+131199,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+268074,int_stack+114774,int_stack+136599,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+125574,int_stack+268074,int_stack+216084,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+283824,int_stack+125574,int_stack+229734,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+207354,int_stack+283824,int_stack+247284,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+235074,int_stack+26745,int_stack+24450,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+241959,int_stack+235074,int_stack+201234,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+308394,int_stack+241959,int_stack+114774,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+326394,int_stack+308394,int_stack+268074,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+254199,int_stack+326394,int_stack+125574,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+114774,int_stack+254199,int_stack+283824,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+350019,int_stack+114774,int_stack+207354,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+147534,int_stack+29310,int_stack+26745,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+201234,int_stack+147534,int_stack+235074,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+215004,int_stack+201234,int_stack+241959,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+385659,int_stack+215004,int_stack+308394,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+282864,int_stack+385659,int_stack+326394,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+412659,int_stack+282864,int_stack+254199,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+235404,int_stack+412659,int_stack+114774,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+450879,int_stack+235404,int_stack+350019,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+114774,int_stack+32160,int_stack+29310,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+123324,int_stack+114774,int_stack+147534,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+315939,int_stack+123324,int_stack+201234,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+338889,int_stack+315939,int_stack+215004,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+495429,int_stack+338889,int_stack+385659,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+533229,int_stack+495429,int_stack+282864,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+577329,int_stack+533229,int_stack+412659,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+369489,int_stack+577329,int_stack+235404,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+201234,int_stack+369489,int_stack+450879,15);
 /*--- compute (g0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+255684,int_stack+35310,int_stack+32160,15);
 /*--- compute (g0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+265134,int_stack+255684,int_stack+114774,15);
 /*--- compute (g0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+282234,int_stack+265134,int_stack+123324,15);
 /*--- compute (g0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+114774,int_stack+282234,int_stack+315939,15);
 /*--- compute (g0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+255684,int_stack+114774,int_stack+338889,15);
 /*--- compute (g0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+298524,int_stack+255684,int_stack+495429,15);
 /*--- compute (g0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+422139,int_stack+298524,int_stack+533229,15);
 /*--- compute (g0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+255684,int_stack+422139,int_stack+577329,15);
 /*--- compute (g0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+422139,int_stack+255684,int_stack+369489,15);
 /*--- compute (g0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+255684,int_stack+422139,int_stack+201234,15);
 /*--- compute (fp|nn) ---*/
 hrr1_build_fp(Libint->AB,int_stack+321024,int_stack+255684,int_stack+157674,4356);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+451704,int_stack+40161,int_stack+38775,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+455862,int_stack+41799,int_stack+40161,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+460776,int_stack+455862,int_stack+451704,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+469092,int_stack+43710,int_stack+41799,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+474825,int_stack+469092,int_stack+455862,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+484653,int_stack+474825,int_stack+460776,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+451704,int_stack+45915,int_stack+43710,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+498513,int_stack+451704,int_stack+469092,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+458319,int_stack+498513,int_stack+474825,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+509979,int_stack+458319,int_stack+484653,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+474699,int_stack+48435,int_stack+45915,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+482259,int_stack+474699,int_stack+451704,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+530769,int_stack+482259,int_stack+498513,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+549879,int_stack+530769,int_stack+458319,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+574449,int_stack+549879,int_stack+509979,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+451704,int_stack+51291,int_stack+48435,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+495489,int_stack+451704,int_stack+474699,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+603555,int_stack+495489,int_stack+482259,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+460272,int_stack+603555,int_stack+530769,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+510609,int_stack+460272,int_stack+549879,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+114774,int_stack+510609,int_stack+574449,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+545007,int_stack+54504,int_stack+51291,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+554646,int_stack+545007,int_stack+451704,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+571782,int_stack+554646,int_stack+495489,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+153582,int_stack+571782,int_stack+603555,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+186657,int_stack+153582,int_stack+460272,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+451704,int_stack+186657,int_stack+510609,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+451704,int_stack+114774,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+114774,int_stack+58095,int_stack+54504,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+125547,int_stack+114774,int_stack+545007,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+497568,int_stack+125547,int_stack+554646,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+526128,int_stack+497568,int_stack+571782,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+563928,int_stack+526128,int_stack+153582,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+610233,int_stack+563928,int_stack+186657,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+144825,int_stack+610233,int_stack+451704,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+663741,int_stack+144825,int_stack+0,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+62085,int_stack+58095,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+11970,int_stack+0,int_stack+114774,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+451704,int_stack+11970,int_stack+125547,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+203793,int_stack+451704,int_stack+497568,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+726111,int_stack+203793,int_stack+526128,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+483834,int_stack+726111,int_stack+563928,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+779031,int_stack+483834,int_stack+610233,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+545574,int_stack+779031,int_stack+144825,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+114774,int_stack+545574,int_stack+663741,21);
 /*--- compute (h0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+33516,int_stack+66495,int_stack+62085,21);
 /*--- compute (h0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+46746,int_stack+33516,int_stack+0,21);
 /*--- compute (h0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+619284,int_stack+46746,int_stack+11970,21);
 /*--- compute (h0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+0,int_stack+619284,int_stack+451704,21);
 /*--- compute (h0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+619284,int_stack+0,int_stack+203793,21);
 /*--- compute (h0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+0,int_stack+619284,int_stack+726111,21);
 /*--- compute (h0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+619284,int_stack+0,int_stack+483834,21);
 /*--- compute (h0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+451704,int_stack+619284,int_stack+779031,21);
 /*--- compute (h0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+619284,int_stack+451704,int_stack+545574,21);
 /*--- compute (h0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+451704,int_stack+619284,int_stack+114774,21);
 /*--- compute (gp|nn) ---*/
 hrr1_build_gp(Libint->AB,int_stack+543180,int_stack+451704,int_stack+255684,4356);
 /*--- compute (fd|nn) ---*/
 hrr1_build_fd(Libint->AB,int_stack+739200,int_stack+543180,int_stack+321024,4356);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+114774,int_stack+73194,int_stack+71346,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+120318,int_stack+75378,int_stack+73194,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+126870,int_stack+120318,int_stack+114774,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+137958,int_stack+77926,int_stack+75378,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+145602,int_stack+137958,int_stack+120318,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+158706,int_stack+145602,int_stack+126870,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+114774,int_stack+80866,int_stack+77926,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+177186,int_stack+114774,int_stack+137958,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+123594,int_stack+177186,int_stack+145602,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+192474,int_stack+123594,int_stack+158706,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+145434,int_stack+84226,int_stack+80866,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+155514,int_stack+145434,int_stack+114774,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+220194,int_stack+155514,int_stack+177186,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+245674,int_stack+220194,int_stack+123594,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+278434,int_stack+245674,int_stack+192474,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+114774,int_stack+88034,int_stack+84226,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+173154,int_stack+114774,int_stack+145434,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+317242,int_stack+173154,int_stack+155514,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+126198,int_stack+317242,int_stack+220194,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+193314,int_stack+126198,int_stack+245674,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+346642,int_stack+193314,int_stack+278434,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+239178,int_stack+92318,int_stack+88034,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+252030,int_stack+239178,int_stack+114774,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+274878,int_stack+252030,int_stack+173154,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+398386,int_stack+274878,int_stack+317242,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+398386,int_stack+126198,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+114774,int_stack+0,int_stack+193314,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1000560,int_stack+114774,int_stack+346642,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+175926,int_stack+97106,int_stack+92318,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+190290,int_stack+175926,int_stack+239178,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+308478,int_stack+190290,int_stack+252030,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+215994,int_stack+308478,int_stack+274878,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1067088,int_stack+215994,int_stack+398386,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+346558,int_stack+1067088,int_stack+0,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+346558,int_stack+114774,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1128828,int_stack+0,int_stack+1000560,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1000560,int_stack+102426,int_stack+97106,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1016520,int_stack+1000560,int_stack+175926,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+114774,int_stack+1016520,int_stack+190290,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+157614,int_stack+114774,int_stack+308478,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+266394,int_stack+157614,int_stack+215994,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1211988,int_stack+266394,int_stack+1067088,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1294308,int_stack+1211988,int_stack+346558,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+336954,int_stack+1294308,int_stack+0,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+336954,int_stack+1128828,28);
 /*--- compute (i0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1045248,int_stack+108306,int_stack+102426,28);
 /*--- compute (i0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1062888,int_stack+1045248,int_stack+1000560,28);
 /*--- compute (i0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1094808,int_stack+1062888,int_stack+1016520,28);
 /*--- compute (i0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1000560,int_stack+1094808,int_stack+114774,28);
 /*--- compute (i0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1064820,int_stack+1000560,int_stack+157614,28);
 /*--- compute (i0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+101640,int_stack+1064820,int_stack+266394,28);
 /*--- compute (i0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1000560,int_stack+101640,int_stack+1211988,28);
 /*--- compute (i0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+101640,int_stack+1000560,int_stack+1294308,28);
 /*--- compute (i0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1000560,int_stack+101640,int_stack+336954,28);
 /*--- compute (i0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+101640,int_stack+1000560,int_stack+0,28);
 /*--- compute (hp|nn) ---*/
 hrr1_build_hp(Libint->AB,int_stack+1000560,int_stack+101640,int_stack+451704,4356);
 /*--- compute (gd|nn) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+1000560,int_stack+543180,4356);
 /*--- compute (ff|nn) ---*/
 hrr1_build_ff(Libint->AB,int_stack+1000560,int_stack+0,int_stack+739200,4356);
 return int_stack+1000560;}
