/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpmi(Libint_t*, prim_data*);

  /* Computes quartets of (fp|mi) integrals */

REALTYPE *hrr_order_fpmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[3][15] = int_stack + 5150;
 Libint->vrr_classes[4][9] = int_stack + 6510;
 Libint->vrr_classes[4][10] = int_stack + 7335;
 Libint->vrr_classes[4][11] = int_stack + 8325;
 Libint->vrr_classes[4][12] = int_stack + 9495;
 Libint->vrr_classes[4][13] = int_stack + 10860;
 Libint->vrr_classes[4][14] = int_stack + 12435;
 Libint->vrr_classes[4][15] = int_stack + 14235;
 memset(int_stack,0,16275*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 16275;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpmi(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16275,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17925,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19905,int_stack+17925,int_stack+16275,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23205,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+25545,int_stack+23205,int_stack+17925,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+29505,int_stack+25545,int_stack+19905,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+16275,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+35005,int_stack+16275,int_stack+23205,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+39685,int_stack+35005,int_stack+25545,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+19005,int_stack+39685,int_stack+29505,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+27255,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+46285,int_stack+27255,int_stack+16275,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+51745,int_stack+46285,int_stack+35005,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+59545,int_stack+51745,int_stack+39685,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+30405,int_stack+59545,int_stack+19005,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+16275,int_stack+5150,int_stack+3950,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19875,int_stack+16275,int_stack+27255,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+69445,int_stack+19875,int_stack+46285,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+16275,int_stack+69445,int_stack+51745,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+41955,int_stack+16275,int_stack+59545,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+55815,int_stack+41955,int_stack+30405,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16275,int_stack+7335,int_stack+6510,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+18750,int_stack+8325,int_stack+7335,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+21720,int_stack+18750,int_stack+16275,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26670,int_stack+9495,int_stack+8325,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+30180,int_stack+26670,int_stack+18750,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36120,int_stack+30180,int_stack+21720,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+16275,int_stack+10860,int_stack+9495,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+44370,int_stack+16275,int_stack+26670,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+44370,int_stack+30180,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+20370,int_stack+0,int_stack+36120,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+32745,int_stack+12435,int_stack+10860,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+71215,int_stack+32745,int_stack+16275,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+79405,int_stack+71215,int_stack+44370,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+37470,int_stack+79405,int_stack+0,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+91105,int_stack+37470,int_stack+20370,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+14235,int_stack+12435,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5400,int_stack+0,int_stack+32745,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+14850,int_stack+5400,int_stack+71215,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+108430,int_stack+14850,int_stack+79405,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+108430,int_stack+37470,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+20790,int_stack+0,int_stack+91105,15);
 /*--- compute (fp|mi) ---*/
 hrr1_build_fp(Libint->AB,int_stack+71215,int_stack+20790,int_stack+55815,1540);
 return int_stack+71215;}
