/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpml(Libint_t*, prim_data*);

  /* Computes quartets of (fp|ml) integrals */

REALTYPE *hrr_order_fpml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[3][15] = int_stack + 5150;
 Libint->vrr_classes[3][16] = int_stack + 6510;
 Libint->vrr_classes[3][17] = int_stack + 8040;
 Libint->vrr_classes[4][9] = int_stack + 9750;
 Libint->vrr_classes[4][10] = int_stack + 10575;
 Libint->vrr_classes[4][11] = int_stack + 11565;
 Libint->vrr_classes[4][12] = int_stack + 12735;
 Libint->vrr_classes[4][13] = int_stack + 14100;
 Libint->vrr_classes[4][14] = int_stack + 15675;
 Libint->vrr_classes[4][15] = int_stack + 17475;
 Libint->vrr_classes[4][16] = int_stack + 19515;
 Libint->vrr_classes[4][17] = int_stack + 21810;
 memset(int_stack,0,24375*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 24375;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpml(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24375,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26025,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28005,int_stack+26025,int_stack+24375,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+31305,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33645,int_stack+31305,int_stack+26025,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+37605,int_stack+33645,int_stack+28005,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+24375,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+43105,int_stack+24375,int_stack+31305,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+47785,int_stack+43105,int_stack+33645,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+27105,int_stack+47785,int_stack+37605,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+35355,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+54385,int_stack+35355,int_stack+24375,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+59845,int_stack+54385,int_stack+43105,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+67645,int_stack+59845,int_stack+47785,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+38505,int_stack+67645,int_stack+27105,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+24375,int_stack+5150,int_stack+3950,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+27975,int_stack+24375,int_stack+35355,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+77545,int_stack+27975,int_stack+54385,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+86645,int_stack+77545,int_stack+59845,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+50055,int_stack+86645,int_stack+67645,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+98345,int_stack+50055,int_stack+38505,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+34275,int_stack+6510,int_stack+5150,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+38355,int_stack+34275,int_stack+24375,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+63915,int_stack+38355,int_stack+27975,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+113745,int_stack+63915,int_stack+77545,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+127395,int_stack+113745,int_stack+86645,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+74415,int_stack+127395,int_stack+50055,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+143775,int_stack+74415,int_stack+98345,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+24375,int_stack+8040,int_stack+6510,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+45555,int_stack+24375,int_stack+34275,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+24375,int_stack+45555,int_stack+38355,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+36375,int_stack+24375,int_stack+63915,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+52125,int_stack+36375,int_stack+113745,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+24375,int_stack+52125,int_stack+127395,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+46215,int_stack+24375,int_stack+74415,10);
 /*--- compute (f0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+69975,int_stack+46215,int_stack+143775,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24375,int_stack+10575,int_stack+9750,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26850,int_stack+11565,int_stack+10575,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+29820,int_stack+26850,int_stack+24375,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+34770,int_stack+12735,int_stack+11565,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+38280,int_stack+34770,int_stack+26850,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+44220,int_stack+38280,int_stack+29820,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+24375,int_stack+14100,int_stack+12735,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+52470,int_stack+24375,int_stack+34770,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+59490,int_stack+52470,int_stack+38280,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28470,int_stack+59490,int_stack+44220,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+40845,int_stack+15675,int_stack+14100,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+94725,int_stack+40845,int_stack+24375,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+102915,int_stack+94725,int_stack+52470,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+114615,int_stack+102915,int_stack+59490,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+45570,int_stack+114615,int_stack+28470,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+24375,int_stack+17475,int_stack+15675,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+29775,int_stack+24375,int_stack+40845,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+129465,int_stack+29775,int_stack+94725,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+143115,int_stack+129465,int_stack+102915,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+160665,int_stack+143115,int_stack+114615,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+94725,int_stack+160665,int_stack+45570,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+117825,int_stack+19515,int_stack+17475,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+39225,int_stack+117825,int_stack+24375,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+50025,int_stack+39225,int_stack+29775,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+181455,int_stack+50025,int_stack+129465,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+201930,int_stack+181455,int_stack+143115,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+123945,int_stack+201930,int_stack+160665,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+151665,int_stack+123945,int_stack+94725,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+94725,int_stack+21810,int_stack+19515,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+101610,int_stack+94725,int_stack+117825,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+101610,int_stack+39225,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+94725,int_stack+0,int_stack+50025,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+94725,int_stack+181455,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+28665,int_stack+0,int_stack+201930,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+181365,int_stack+28665,int_stack+123945,15);
 /*--- compute (g0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+181365,int_stack+151665,15);
 /*--- compute (fp|ml) ---*/
 hrr1_build_fp(Libint->AB,int_stack+94725,int_stack+0,int_stack+69975,2475);
 return int_stack+94725;}
