/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfll(Libint_t*, prim_data*);

  /* Computes quartets of (gf|ll) integrals */

REALTYPE *hrr_order_gfll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[4][15] = int_stack + 8400;
 Libint->vrr_classes[4][16] = int_stack + 10440;
 Libint->vrr_classes[5][8] = int_stack + 12735;
 Libint->vrr_classes[5][9] = int_stack + 13680;
 Libint->vrr_classes[5][10] = int_stack + 14835;
 Libint->vrr_classes[5][11] = int_stack + 16221;
 Libint->vrr_classes[5][12] = int_stack + 17859;
 Libint->vrr_classes[5][13] = int_stack + 19770;
 Libint->vrr_classes[5][14] = int_stack + 21975;
 Libint->vrr_classes[5][15] = int_stack + 24495;
 Libint->vrr_classes[5][16] = int_stack + 27351;
 Libint->vrr_classes[6][8] = int_stack + 30564;
 Libint->vrr_classes[6][9] = int_stack + 31824;
 Libint->vrr_classes[6][10] = int_stack + 33364;
 Libint->vrr_classes[6][11] = int_stack + 35212;
 Libint->vrr_classes[6][12] = int_stack + 37396;
 Libint->vrr_classes[6][13] = int_stack + 39944;
 Libint->vrr_classes[6][14] = int_stack + 42884;
 Libint->vrr_classes[6][15] = int_stack + 46244;
 Libint->vrr_classes[6][16] = int_stack + 50052;
 Libint->vrr_classes[7][8] = int_stack + 54336;
 Libint->vrr_classes[7][9] = int_stack + 55956;
 Libint->vrr_classes[7][10] = int_stack + 57936;
 Libint->vrr_classes[7][11] = int_stack + 60312;
 Libint->vrr_classes[7][12] = int_stack + 63120;
 Libint->vrr_classes[7][13] = int_stack + 66396;
 Libint->vrr_classes[7][14] = int_stack + 70176;
 Libint->vrr_classes[7][15] = int_stack + 74496;
 Libint->vrr_classes[7][16] = int_stack + 79392;
 memset(int_stack,0,84900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 84900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfll(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84900,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+86925,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+89400,int_stack+86925,int_stack+84900,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+93450,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+96420,int_stack+93450,int_stack+86925,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+101370,int_stack+96420,int_stack+89400,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84900,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+108120,int_stack+84900,int_stack+93450,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+114060,int_stack+108120,int_stack+96420,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+88410,int_stack+114060,int_stack+101370,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+98535,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+122310,int_stack+98535,int_stack+84900,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+129330,int_stack+122310,int_stack+108120,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+139230,int_stack+129330,int_stack+114060,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+102630,int_stack+139230,int_stack+88410,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84900,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+89625,int_stack+84900,int_stack+98535,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+151605,int_stack+89625,int_stack+122310,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+163305,int_stack+151605,int_stack+129330,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+116805,int_stack+163305,int_stack+139230,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+178155,int_stack+116805,int_stack+102630,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+97815,int_stack+8400,int_stack+6600,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+103215,int_stack+97815,int_stack+84900,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+134130,int_stack+103215,int_stack+89625,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+197055,int_stack+134130,int_stack+151605,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+214605,int_stack+197055,int_stack+163305,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+147780,int_stack+214605,int_stack+116805,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+235395,int_stack+147780,int_stack+178155,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+84900,int_stack+10440,int_stack+8400,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+112665,int_stack+84900,int_stack+97815,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+84900,int_stack+112665,int_stack+103215,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+100650,int_stack+84900,int_stack+134130,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+121125,int_stack+100650,int_stack+197055,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+84900,int_stack+121125,int_stack+214605,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+112620,int_stack+84900,int_stack+147780,15);
 /*--- compute (g0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+142320,int_stack+112620,int_stack+235395,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84900,int_stack+13680,int_stack+12735,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+87735,int_stack+14835,int_stack+13680,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+91200,int_stack+87735,int_stack+84900,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+96870,int_stack+16221,int_stack+14835,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+101028,int_stack+96870,int_stack+87735,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+107958,int_stack+101028,int_stack+91200,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84900,int_stack+17859,int_stack+16221,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+117408,int_stack+84900,int_stack+96870,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+125724,int_stack+117408,int_stack+101028,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+89814,int_stack+125724,int_stack+107958,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+103989,int_stack+19770,int_stack+17859,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+172695,int_stack+103989,int_stack+84900,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+182523,int_stack+172695,int_stack+117408,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+196383,int_stack+182523,int_stack+125724,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+109722,int_stack+196383,int_stack+89814,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84900,int_stack+21975,int_stack+19770,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+91515,int_stack+84900,int_stack+103989,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+213708,int_stack+91515,int_stack+172695,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+230088,int_stack+213708,int_stack+182523,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+250878,int_stack+230088,int_stack+196383,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+172695,int_stack+250878,int_stack+109722,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+199155,int_stack+24495,int_stack+21975,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+102981,int_stack+199155,int_stack+84900,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+116211,int_stack+102981,int_stack+91515,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+275133,int_stack+116211,int_stack+213708,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+299703,int_stack+275133,int_stack+230088,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+206715,int_stack+299703,int_stack+250878,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+239055,int_stack+206715,int_stack+172695,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+172695,int_stack+27351,int_stack+24495,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+181263,int_stack+172695,int_stack+199155,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+181263,int_stack+102981,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+172695,int_stack+0,int_stack+116211,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+84900,int_stack+172695,int_stack+275133,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+328809,int_stack+84900,int_stack+299703,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+84900,int_stack+328809,int_stack+206715,21);
 /*--- compute (h0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+172695,int_stack+84900,int_stack+239055,21);
 /*--- compute (gp|ll) ---*/
 hrr1_build_gp(Libint->AB,int_stack+215220,int_stack+172695,int_stack+142320,2025);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84900,int_stack+31824,int_stack+30564,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+88680,int_stack+33364,int_stack+31824,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+93300,int_stack+88680,int_stack+84900,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+100860,int_stack+35212,int_stack+33364,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+106404,int_stack+100860,int_stack+88680,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+115644,int_stack+106404,int_stack+93300,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84900,int_stack+37396,int_stack+35212,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+128244,int_stack+84900,int_stack+100860,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+139332,int_stack+128244,int_stack+106404,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+91452,int_stack+139332,int_stack+115644,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+110352,int_stack+39944,int_stack+37396,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+154732,int_stack+110352,int_stack+84900,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+306345,int_stack+154732,int_stack+128244,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+324825,int_stack+306345,int_stack+139332,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+117996,int_stack+324825,int_stack+91452,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84900,int_stack+42884,int_stack+39944,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+93720,int_stack+84900,int_stack+110352,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+93720,int_stack+154732,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+144456,int_stack+0,int_stack+306345,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+347925,int_stack+144456,int_stack+324825,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+306345,int_stack+347925,int_stack+117996,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+109008,int_stack+46244,int_stack+42884,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+119088,int_stack+109008,int_stack+84900,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+380265,int_stack+119088,int_stack+93720,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+405745,int_stack+380265,int_stack+0,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+405745,int_stack+144456,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+438505,int_stack+0,int_stack+347925,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+481625,int_stack+438505,int_stack+306345,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+306345,int_stack+50052,int_stack+46244,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+317769,int_stack+306345,int_stack+109008,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+337929,int_stack+317769,int_stack+119088,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+84900,int_stack+337929,int_stack+380265,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+306345,int_stack+84900,int_stack+405745,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+84900,int_stack+306345,int_stack+0,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+306345,int_stack+84900,int_stack+438505,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+84900,int_stack+306345,int_stack+481625,28);
 /*--- compute (hp|ll) ---*/
 hrr1_build_hp(Libint->AB,int_stack+306345,int_stack+84900,int_stack+172695,2025);
 /*--- compute (gd|ll) ---*/
 hrr1_build_gd(Libint->AB,int_stack+433920,int_stack+306345,int_stack+215220,2025);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+141600,int_stack+55956,int_stack+54336,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+146460,int_stack+57936,int_stack+55956,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+152400,int_stack+146460,int_stack+141600,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+162120,int_stack+60312,int_stack+57936,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+169248,int_stack+162120,int_stack+146460,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+181128,int_stack+169248,int_stack+152400,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+141600,int_stack+63120,int_stack+60312,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+197328,int_stack+141600,int_stack+162120,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+211584,int_stack+197328,int_stack+169248,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+150024,int_stack+211584,int_stack+181128,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+174324,int_stack+66396,int_stack+63120,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+231384,int_stack+174324,int_stack+141600,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+248232,int_stack+231384,int_stack+197328,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+271992,int_stack+248232,int_stack+211584,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+184152,int_stack+271992,int_stack+150024,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+141600,int_stack+70176,int_stack+66396,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+152940,int_stack+141600,int_stack+174324,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+152940,int_stack+231384,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+28080,int_stack+0,int_stack+248232,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+218172,int_stack+28080,int_stack+271992,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+259752,int_stack+218172,int_stack+184152,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+172596,int_stack+74496,int_stack+70176,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+185556,int_stack+172596,int_stack+141600,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+616170,int_stack+185556,int_stack+152940,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+648930,int_stack+616170,int_stack+0,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+691050,int_stack+648930,int_stack+28080,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+691050,int_stack+218172,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+740946,int_stack+0,int_stack+259752,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+55440,int_stack+79392,int_stack+74496,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+141600,int_stack+55440,int_stack+172596,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+208236,int_stack+141600,int_stack+185556,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+141600,int_stack+208236,int_stack+616170,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+190740,int_stack+141600,int_stack+648930,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+616170,int_stack+190740,int_stack+691050,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+141600,int_stack+616170,int_stack+0,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+141600,int_stack+740946,36);
 /*--- compute (ip|ll) ---*/
 hrr1_build_ip(Libint->AB,int_stack+616170,int_stack+0,int_stack+84900,2025);
 /*--- compute (hd|ll) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+616170,int_stack+306345,2025);
 /*--- compute (gf|ll) ---*/
 hrr1_build_gf(Libint->AB,int_stack+616170,int_stack+0,int_stack+433920,2025);
 return int_stack+616170;}
