/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfni(Libint_t*, prim_data*);

  /* Computes quartets of (gf|ni) integrals */

REALTYPE *hrr_order_gfni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[5][10] = int_stack + 11235;
 Libint->vrr_classes[5][11] = int_stack + 12621;
 Libint->vrr_classes[5][12] = int_stack + 14259;
 Libint->vrr_classes[5][13] = int_stack + 16170;
 Libint->vrr_classes[5][14] = int_stack + 18375;
 Libint->vrr_classes[5][15] = int_stack + 20895;
 Libint->vrr_classes[5][16] = int_stack + 23751;
 Libint->vrr_classes[6][10] = int_stack + 26964;
 Libint->vrr_classes[6][11] = int_stack + 28812;
 Libint->vrr_classes[6][12] = int_stack + 30996;
 Libint->vrr_classes[6][13] = int_stack + 33544;
 Libint->vrr_classes[6][14] = int_stack + 36484;
 Libint->vrr_classes[6][15] = int_stack + 39844;
 Libint->vrr_classes[6][16] = int_stack + 43652;
 Libint->vrr_classes[7][10] = int_stack + 47936;
 Libint->vrr_classes[7][11] = int_stack + 50312;
 Libint->vrr_classes[7][12] = int_stack + 53120;
 Libint->vrr_classes[7][13] = int_stack + 56396;
 Libint->vrr_classes[7][14] = int_stack + 60176;
 Libint->vrr_classes[7][15] = int_stack + 64496;
 Libint->vrr_classes[7][16] = int_stack + 69392;
 memset(int_stack,0,74900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 74900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfni(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+74900,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77870,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+81380,int_stack+77870,int_stack+74900,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+87320,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+91415,int_stack+87320,int_stack+77870,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+98435,int_stack+91415,int_stack+81380,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+74900,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+108335,int_stack+74900,int_stack+87320,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+79625,int_stack+108335,int_stack+91415,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+116525,int_stack+79625,int_stack+98435,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+91325,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+96725,int_stack+91325,int_stack+74900,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+131375,int_stack+96725,int_stack+108335,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+145025,int_stack+131375,int_stack+79625,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+162575,int_stack+145025,int_stack+116525,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+74900,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+106175,int_stack+74900,int_stack+91325,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+74900,int_stack+106175,int_stack+96725,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+90650,int_stack+74900,int_stack+131375,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+111125,int_stack+90650,int_stack+145025,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+74900,int_stack+111125,int_stack+162575,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+102620,int_stack+12621,int_stack+11235,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+106778,int_stack+14259,int_stack+12621,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111692,int_stack+106778,int_stack+102620,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+120008,int_stack+16170,int_stack+14259,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+125741,int_stack+120008,int_stack+106778,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+135569,int_stack+125741,int_stack+111692,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+102620,int_stack+18375,int_stack+16170,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+149429,int_stack+102620,int_stack+120008,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+109235,int_stack+149429,int_stack+125741,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+160895,int_stack+109235,int_stack+135569,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+125615,int_stack+20895,int_stack+18375,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+133175,int_stack+125615,int_stack+102620,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+133175,int_stack+149429,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+181685,int_stack+0,int_stack+109235,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+206255,int_stack+181685,int_stack+160895,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+102620,int_stack+23751,int_stack+20895,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+146405,int_stack+102620,int_stack+125615,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+102620,int_stack+146405,int_stack+133175,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+124670,int_stack+102620,int_stack+0,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+235361,int_stack+124670,int_stack+181685,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+102620,int_stack+235361,int_stack+206255,21);
 /*--- compute (gp|ni) ---*/
 hrr1_build_gp(Libint->AB,int_stack+141428,int_stack+102620,int_stack+74900,1848);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+74900,int_stack+28812,int_stack+26964,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+80444,int_stack+30996,int_stack+28812,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+86996,int_stack+80444,int_stack+74900,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+33544,int_stack+30996,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+7644,int_stack+0,int_stack+80444,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+224588,int_stack+7644,int_stack+86996,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+74900,int_stack+36484,int_stack+33544,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+83720,int_stack+74900,int_stack+0,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+243068,int_stack+83720,int_stack+7644,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+243068,int_stack+224588,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+224588,int_stack+39844,int_stack+36484,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+264908,int_stack+224588,int_stack+74900,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+282548,int_stack+264908,int_stack+83720,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+308028,int_stack+282548,int_stack+243068,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+340788,int_stack+308028,int_stack+0,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+43652,int_stack+39844,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+11424,int_stack+0,int_stack+224588,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+224588,int_stack+11424,int_stack+264908,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+224588,int_stack+282548,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+224588,int_stack+0,int_stack+308028,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+270452,int_stack+224588,int_stack+340788,28);
 /*--- compute (hp|ni) ---*/
 hrr1_build_hp(Libint->AB,int_stack+322196,int_stack+270452,int_stack+102620,1848);
 /*--- compute (gd|ni) ---*/
 hrr1_build_gd(Libint->AB,int_stack+438620,int_stack+322196,int_stack+141428,1848);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+50312,int_stack+47936,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+53120,int_stack+50312,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15552,int_stack+7128,int_stack+0,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29808,int_stack+56396,int_stack+53120,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+74900,int_stack+29808,int_stack+7128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+91748,int_stack+74900,int_stack+15552,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+60176,int_stack+56396,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+39636,int_stack+0,int_stack+29808,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+11340,int_stack+39636,int_stack+74900,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+115508,int_stack+11340,int_stack+91748,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+74900,int_stack+64496,int_stack+60176,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+87860,int_stack+74900,int_stack+0,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+151148,int_stack+87860,int_stack+39636,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+183908,int_stack+151148,int_stack+11340,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+183908,int_stack+115508,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+110540,int_stack+69392,int_stack+64496,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+125228,int_stack+110540,int_stack+74900,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+49896,int_stack+125228,int_stack+87860,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+87696,int_stack+49896,int_stack+151148,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+604940,int_stack+87696,int_stack+183908,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+49896,int_stack+604940,int_stack+0,36);
 /*--- compute (ip|ni) ---*/
 hrr1_build_ip(Libint->AB,int_stack+604940,int_stack+49896,int_stack+270452,1848);
 /*--- compute (hd|ni) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+604940,int_stack+322196,1848);
 /*--- compute (gf|ni) ---*/
 hrr1_build_gf(Libint->AB,int_stack+604940,int_stack+0,int_stack+438620,1848);
 return int_stack+604940;}
