/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggml(Libint_t*, prim_data*);

  /* Computes quartets of (gg|ml) integrals */

REALTYPE *hrr_order_ggml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[4][14] = int_stack + 5925;
 Libint->vrr_classes[4][15] = int_stack + 7725;
 Libint->vrr_classes[4][16] = int_stack + 9765;
 Libint->vrr_classes[4][17] = int_stack + 12060;
 Libint->vrr_classes[5][9] = int_stack + 14625;
 Libint->vrr_classes[5][10] = int_stack + 15780;
 Libint->vrr_classes[5][11] = int_stack + 17166;
 Libint->vrr_classes[5][12] = int_stack + 18804;
 Libint->vrr_classes[5][13] = int_stack + 20715;
 Libint->vrr_classes[5][14] = int_stack + 22920;
 Libint->vrr_classes[5][15] = int_stack + 25440;
 Libint->vrr_classes[5][16] = int_stack + 28296;
 Libint->vrr_classes[5][17] = int_stack + 31509;
 Libint->vrr_classes[6][9] = int_stack + 35100;
 Libint->vrr_classes[6][10] = int_stack + 36640;
 Libint->vrr_classes[6][11] = int_stack + 38488;
 Libint->vrr_classes[6][12] = int_stack + 40672;
 Libint->vrr_classes[6][13] = int_stack + 43220;
 Libint->vrr_classes[6][14] = int_stack + 46160;
 Libint->vrr_classes[6][15] = int_stack + 49520;
 Libint->vrr_classes[6][16] = int_stack + 53328;
 Libint->vrr_classes[6][17] = int_stack + 57612;
 Libint->vrr_classes[7][9] = int_stack + 62400;
 Libint->vrr_classes[7][10] = int_stack + 64380;
 Libint->vrr_classes[7][11] = int_stack + 66756;
 Libint->vrr_classes[7][12] = int_stack + 69564;
 Libint->vrr_classes[7][13] = int_stack + 72840;
 Libint->vrr_classes[7][14] = int_stack + 76620;
 Libint->vrr_classes[7][15] = int_stack + 80940;
 Libint->vrr_classes[7][16] = int_stack + 85836;
 Libint->vrr_classes[7][17] = int_stack + 91344;
 Libint->vrr_classes[8][9] = int_stack + 97500;
 Libint->vrr_classes[8][10] = int_stack + 99975;
 Libint->vrr_classes[8][11] = int_stack + 102945;
 Libint->vrr_classes[8][12] = int_stack + 106455;
 Libint->vrr_classes[8][13] = int_stack + 110550;
 Libint->vrr_classes[8][14] = int_stack + 115275;
 Libint->vrr_classes[8][15] = int_stack + 120675;
 Libint->vrr_classes[8][16] = int_stack + 126795;
 Libint->vrr_classes[8][17] = int_stack + 133680;
 memset(int_stack,0,141375*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 141375;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggml(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+141375,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+143850,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+146820,int_stack+143850,int_stack+141375,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+151770,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+155280,int_stack+151770,int_stack+143850,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+161220,int_stack+155280,int_stack+146820,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+141375,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+169470,int_stack+141375,int_stack+151770,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+176490,int_stack+169470,int_stack+155280,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+145470,int_stack+176490,int_stack+161220,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+157845,int_stack+5925,int_stack+4350,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+186390,int_stack+157845,int_stack+141375,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+194580,int_stack+186390,int_stack+169470,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+206280,int_stack+194580,int_stack+176490,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+162570,int_stack+206280,int_stack+145470,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+141375,int_stack+7725,int_stack+5925,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+146775,int_stack+141375,int_stack+157845,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+221130,int_stack+146775,int_stack+186390,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+234780,int_stack+221130,int_stack+194580,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+179895,int_stack+234780,int_stack+206280,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+252330,int_stack+179895,int_stack+162570,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+156225,int_stack+9765,int_stack+7725,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+162345,int_stack+156225,int_stack+141375,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+200685,int_stack+162345,int_stack+146775,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+275430,int_stack+200685,int_stack+221130,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+295905,int_stack+275430,int_stack+234780,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+216435,int_stack+295905,int_stack+179895,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+320475,int_stack+216435,int_stack+252330,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+141375,int_stack+12060,int_stack+9765,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+173145,int_stack+141375,int_stack+156225,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+141375,int_stack+173145,int_stack+162345,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+159375,int_stack+141375,int_stack+200685,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+183000,int_stack+159375,int_stack+275430,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+141375,int_stack+183000,int_stack+295905,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+174135,int_stack+141375,int_stack+216435,15);
 /*--- compute (g0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+209775,int_stack+174135,int_stack+320475,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+141375,int_stack+15780,int_stack+14625,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+144840,int_stack+17166,int_stack+15780,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+148998,int_stack+144840,int_stack+141375,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+155928,int_stack+18804,int_stack+17166,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+160842,int_stack+155928,int_stack+144840,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+169158,int_stack+160842,int_stack+148998,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+141375,int_stack+20715,int_stack+18804,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+180708,int_stack+141375,int_stack+155928,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+190536,int_stack+180708,int_stack+160842,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+147108,int_stack+190536,int_stack+169158,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+164433,int_stack+22920,int_stack+20715,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+246900,int_stack+164433,int_stack+141375,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+258366,int_stack+246900,int_stack+180708,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+274746,int_stack+258366,int_stack+190536,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+171048,int_stack+274746,int_stack+147108,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+141375,int_stack+25440,int_stack+22920,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+148935,int_stack+141375,int_stack+164433,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+295536,int_stack+148935,int_stack+246900,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+314646,int_stack+295536,int_stack+258366,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+339216,int_stack+314646,int_stack+274746,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+246900,int_stack+339216,int_stack+171048,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+279240,int_stack+28296,int_stack+25440,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+162165,int_stack+279240,int_stack+141375,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+177285,int_stack+162165,int_stack+148935,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+368322,int_stack+177285,int_stack+295536,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+396987,int_stack+368322,int_stack+314646,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+287808,int_stack+396987,int_stack+339216,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+326616,int_stack+287808,int_stack+246900,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+246900,int_stack+31509,int_stack+28296,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+256539,int_stack+246900,int_stack+279240,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+256539,int_stack+162165,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+246900,int_stack+0,int_stack+177285,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+141375,int_stack+246900,int_stack+368322,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+431385,int_stack+141375,int_stack+396987,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+141375,int_stack+431385,int_stack+287808,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+246900,int_stack+141375,int_stack+326616,21);
 /*--- compute (gp|ml) ---*/
 hrr1_build_gp(Libint->AB,int_stack+298875,int_stack+246900,int_stack+209775,2475);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+141375,int_stack+36640,int_stack+35100,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+145995,int_stack+38488,int_stack+36640,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+151539,int_stack+145995,int_stack+141375,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+160779,int_stack+40672,int_stack+38488,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+167331,int_stack+160779,int_stack+145995,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+178419,int_stack+167331,int_stack+151539,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+141375,int_stack+43220,int_stack+40672,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+193819,int_stack+141375,int_stack+160779,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+206923,int_stack+193819,int_stack+167331,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+149019,int_stack+206923,int_stack+178419,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+172119,int_stack+46160,int_stack+43220,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+225403,int_stack+172119,int_stack+141375,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+410250,int_stack+225403,int_stack+193819,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+432090,int_stack+410250,int_stack+206923,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+180939,int_stack+432090,int_stack+149019,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+141375,int_stack+49520,int_stack+46160,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+151455,int_stack+141375,int_stack+172119,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+151455,int_stack+225403,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+213279,int_stack+0,int_stack+410250,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+459810,int_stack+213279,int_stack+432090,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+410250,int_stack+459810,int_stack+180939,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+169095,int_stack+53328,int_stack+49520,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+180519,int_stack+169095,int_stack+141375,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+498618,int_stack+180519,int_stack+151455,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+528018,int_stack+498618,int_stack+0,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+528018,int_stack+213279,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+566238,int_stack+0,int_stack+459810,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+617982,int_stack+566238,int_stack+410250,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+410250,int_stack+57612,int_stack+53328,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+423102,int_stack+410250,int_stack+169095,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+445950,int_stack+423102,int_stack+180519,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+141375,int_stack+445950,int_stack+498618,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+410250,int_stack+141375,int_stack+528018,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+141375,int_stack+410250,int_stack+0,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+410250,int_stack+141375,int_stack+566238,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+141375,int_stack+410250,int_stack+617982,28);
 /*--- compute (hp|ml) ---*/
 hrr1_build_hp(Libint->AB,int_stack+410250,int_stack+141375,int_stack+246900,2475);
 /*--- compute (gd|ml) ---*/
 hrr1_build_gd(Libint->AB,int_stack+566175,int_stack+410250,int_stack+298875,2475);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+210675,int_stack+64380,int_stack+62400,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+216615,int_stack+66756,int_stack+64380,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+223743,int_stack+216615,int_stack+210675,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+235623,int_stack+69564,int_stack+66756,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+244047,int_stack+235623,int_stack+216615,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+258303,int_stack+244047,int_stack+223743,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+210675,int_stack+72840,int_stack+69564,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+278103,int_stack+210675,int_stack+235623,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+294951,int_stack+278103,int_stack+244047,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+220503,int_stack+294951,int_stack+258303,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+250203,int_stack+76620,int_stack+72840,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+318711,int_stack+250203,int_stack+210675,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+338367,int_stack+318711,int_stack+278103,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+366447,int_stack+338367,int_stack+294951,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+261543,int_stack+366447,int_stack+220503,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+210675,int_stack+80940,int_stack+76620,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+223635,int_stack+210675,int_stack+250203,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+223635,int_stack+318711,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+32760,int_stack+0,int_stack+338367,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+303123,int_stack+32760,int_stack+366447,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+353019,int_stack+303123,int_stack+261543,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+246315,int_stack+85836,int_stack+80940,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+261003,int_stack+246315,int_stack+210675,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+788925,int_stack+261003,int_stack+223635,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+826725,int_stack+788925,int_stack+0,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+875865,int_stack+826725,int_stack+32760,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+875865,int_stack+303123,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+934833,int_stack+0,int_stack+353019,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+66528,int_stack+91344,int_stack+85836,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+210675,int_stack+66528,int_stack+246315,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+286923,int_stack+210675,int_stack+261003,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+210675,int_stack+286923,int_stack+788925,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+267375,int_stack+210675,int_stack+826725,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+788925,int_stack+267375,int_stack+875865,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+210675,int_stack+788925,int_stack+0,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+210675,int_stack+934833,36);
 /*--- compute (ip|ml) ---*/
 hrr1_build_ip(Libint->AB,int_stack+788925,int_stack+0,int_stack+141375,2475);
 /*--- compute (hd|ml) ---*/
 hrr1_build_hd(Libint->AB,int_stack+996825,int_stack+788925,int_stack+410250,2475);
 /*--- compute (gf|ml) ---*/
 hrr1_build_gf(Libint->AB,int_stack+141375,int_stack+996825,int_stack+566175,2475);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+512625,int_stack+99975,int_stack+97500,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+520050,int_stack+102945,int_stack+99975,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+528960,int_stack+520050,int_stack+512625,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+543810,int_stack+106455,int_stack+102945,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+554340,int_stack+543810,int_stack+520050,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+572160,int_stack+554340,int_stack+528960,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+512625,int_stack+110550,int_stack+106455,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+596910,int_stack+512625,int_stack+543810,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+617970,int_stack+596910,int_stack+554340,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+524910,int_stack+617970,int_stack+572160,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+562035,int_stack+115275,int_stack+110550,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+647670,int_stack+562035,int_stack+512625,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+672240,int_stack+647670,int_stack+596910,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+707340,int_stack+672240,int_stack+617970,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+576210,int_stack+707340,int_stack+524910,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+512625,int_stack+120675,int_stack+115275,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+528825,int_stack+512625,int_stack+562035,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1308675,int_stack+528825,int_stack+647670,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1349625,int_stack+1308675,int_stack+672240,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+628185,int_stack+1349625,int_stack+707340,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+690555,int_stack+628185,int_stack+576210,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+557175,int_stack+126795,int_stack+120675,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+575535,int_stack+557175,int_stack+512625,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1402275,int_stack+575535,int_stack+528825,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1449525,int_stack+1402275,int_stack+1308675,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1510950,int_stack+1449525,int_stack+1349625,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1308675,int_stack+1510950,int_stack+628185,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1584660,int_stack+1308675,int_stack+690555,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+512625,int_stack+133680,int_stack+126795,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+607935,int_stack+512625,int_stack+557175,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+512625,int_stack+607935,int_stack+575535,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+566625,int_stack+512625,int_stack+1402275,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+637500,int_stack+566625,int_stack+1449525,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+512625,int_stack+637500,int_stack+1510950,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+610905,int_stack+512625,int_stack+1308675,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1308675,int_stack+610905,int_stack+1584660,45);
 /*--- compute (kp|ml) ---*/
 hrr1_build_kp(Libint->AB,int_stack+512625,int_stack+1308675,int_stack+0,2475);
 /*--- compute (id|ml) ---*/
 hrr1_build_id(Libint->AB,int_stack+1308675,int_stack+512625,int_stack+788925,2475);
 /*--- compute (hf|ml) ---*/
 hrr1_build_hf(Libint->AB,int_stack+1724475,int_stack+1308675,int_stack+996825,2475);
 /*--- compute (gg|ml) ---*/
 hrr1_build_gg(Libint->AB,int_stack+512625,int_stack+1724475,int_stack+141375,2475);
 return int_stack+512625;}
