/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpkg(Libint_t*, prim_data*);

  /* Computes quartets of (gp|kg) integrals */

REALTYPE *hrr_order_gpkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[5][7] = int_stack + 4200;
 Libint->vrr_classes[5][8] = int_stack + 4956;
 Libint->vrr_classes[5][9] = int_stack + 5901;
 Libint->vrr_classes[5][10] = int_stack + 7056;
 Libint->vrr_classes[5][11] = int_stack + 8442;
 memset(int_stack,0,10080*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 10080;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpkg(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+10080,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11700,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13725,int_stack+11700,int_stack+10080,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16965,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19440,int_stack+16965,int_stack+11700,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+23490,int_stack+19440,int_stack+13725,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10080,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28890,int_stack+10080,int_stack+16965,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+10080,int_stack+28890,int_stack+19440,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+28890,int_stack+10080,int_stack+23490,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+10080,int_stack+4956,int_stack+4200,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+12348,int_stack+5901,int_stack+4956,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+15183,int_stack+12348,int_stack+10080,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19719,int_stack+7056,int_stack+5901,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23184,int_stack+19719,int_stack+12348,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+36990,int_stack+23184,int_stack+15183,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10080,int_stack+8442,int_stack+7056,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+10080,int_stack+19719,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+6930,int_stack+0,int_stack+23184,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+16380,int_stack+6930,int_stack+36990,21);
 /*--- compute (gp|kg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+36990,int_stack+16380,int_stack+28890,540);
 return int_stack+36990;}
