/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpkh(Libint_t*, prim_data*);

  /* Computes quartets of (gp|kh) integrals */

REALTYPE *hrr_order_gpkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[4][12] = int_stack + 4200;
 Libint->vrr_classes[5][7] = int_stack + 5565;
 Libint->vrr_classes[5][8] = int_stack + 6321;
 Libint->vrr_classes[5][9] = int_stack + 7266;
 Libint->vrr_classes[5][10] = int_stack + 8421;
 Libint->vrr_classes[5][11] = int_stack + 9807;
 Libint->vrr_classes[5][12] = int_stack + 11445;
 memset(int_stack,0,13356*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 13356;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpkh(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+13356,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+14976,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+17001,int_stack+14976,int_stack+13356,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20241,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+22716,int_stack+20241,int_stack+14976,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+26766,int_stack+22716,int_stack+17001,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+13356,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+32166,int_stack+13356,int_stack+20241,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+37116,int_stack+32166,int_stack+22716,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+16326,int_stack+37116,int_stack+26766,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+24426,int_stack+4200,int_stack+3030,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43866,int_stack+24426,int_stack+13356,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+49806,int_stack+43866,int_stack+32166,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24426,int_stack+49806,int_stack+37116,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+34551,int_stack+24426,int_stack+16326,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+13356,int_stack+6321,int_stack+5565,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15624,int_stack+7266,int_stack+6321,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18459,int_stack+15624,int_stack+13356,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+22995,int_stack+8421,int_stack+7266,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+26460,int_stack+22995,int_stack+15624,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+45891,int_stack+26460,int_stack+18459,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+13356,int_stack+9807,int_stack+8421,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+13356,int_stack+22995,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+53451,int_stack+0,int_stack+26460,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+17514,int_stack+53451,int_stack+45891,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45891,int_stack+11445,int_stack+9807,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+62901,int_stack+45891,int_stack+13356,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+71217,int_stack+62901,int_stack+0,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+71217,int_stack+53451,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+45891,int_stack+0,int_stack+17514,21);
 /*--- compute (gp|kh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+0,int_stack+45891,int_stack+34551,756);
 return int_stack+0;}
