/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gplh(Libint_t*, prim_data*);

  /* Computes quartets of (gp|lh) integrals */

REALTYPE *hrr_order_gplh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[5][8] = int_stack + 6600;
 Libint->vrr_classes[5][9] = int_stack + 7545;
 Libint->vrr_classes[5][10] = int_stack + 8700;
 Libint->vrr_classes[5][11] = int_stack + 10086;
 Libint->vrr_classes[5][12] = int_stack + 11724;
 Libint->vrr_classes[5][13] = int_stack + 13635;
 memset(int_stack,0,15840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 15840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gplh(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15840,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+17865,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+20340,int_stack+17865,int_stack+15840,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+24390,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27360,int_stack+24390,int_stack+17865,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+32310,int_stack+27360,int_stack+20340,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15840,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39060,int_stack+15840,int_stack+24390,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+45000,int_stack+39060,int_stack+27360,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+19350,int_stack+45000,int_stack+32310,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29475,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+53250,int_stack+29475,int_stack+15840,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+60270,int_stack+53250,int_stack+39060,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+29475,int_stack+60270,int_stack+45000,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+41850,int_stack+29475,int_stack+19350,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15840,int_stack+7545,int_stack+6600,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18675,int_stack+8700,int_stack+7545,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+22140,int_stack+18675,int_stack+15840,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27810,int_stack+10086,int_stack+8700,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+31968,int_stack+27810,int_stack+18675,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+56025,int_stack+31968,int_stack+22140,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15840,int_stack+11724,int_stack+10086,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+15840,int_stack+27810,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+65475,int_stack+0,int_stack+31968,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+20754,int_stack+65475,int_stack+56025,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+56025,int_stack+13635,int_stack+11724,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+77025,int_stack+56025,int_stack+15840,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+86853,int_stack+77025,int_stack+0,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+86853,int_stack+65475,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+56025,int_stack+0,int_stack+20754,21);
 /*--- compute (gp|lh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+75870,int_stack+56025,int_stack+41850,945);
 return int_stack+75870;}
