/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpll(Libint_t*, prim_data*);

  /* Computes quartets of (gp|ll) integrals */

REALTYPE *hrr_order_gpll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[4][15] = int_stack + 8400;
 Libint->vrr_classes[4][16] = int_stack + 10440;
 Libint->vrr_classes[5][8] = int_stack + 12735;
 Libint->vrr_classes[5][9] = int_stack + 13680;
 Libint->vrr_classes[5][10] = int_stack + 14835;
 Libint->vrr_classes[5][11] = int_stack + 16221;
 Libint->vrr_classes[5][12] = int_stack + 17859;
 Libint->vrr_classes[5][13] = int_stack + 19770;
 Libint->vrr_classes[5][14] = int_stack + 21975;
 Libint->vrr_classes[5][15] = int_stack + 24495;
 Libint->vrr_classes[5][16] = int_stack + 27351;
 memset(int_stack,0,30564*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 30564;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpll(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30564,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32589,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35064,int_stack+32589,int_stack+30564,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39114,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42084,int_stack+39114,int_stack+32589,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+47034,int_stack+42084,int_stack+35064,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30564,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+53784,int_stack+30564,int_stack+39114,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+59724,int_stack+53784,int_stack+42084,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+34074,int_stack+59724,int_stack+47034,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+44199,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+67974,int_stack+44199,int_stack+30564,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+74994,int_stack+67974,int_stack+53784,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+84894,int_stack+74994,int_stack+59724,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+48294,int_stack+84894,int_stack+34074,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+30564,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+35289,int_stack+30564,int_stack+44199,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+97269,int_stack+35289,int_stack+67974,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+108969,int_stack+97269,int_stack+74994,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+62469,int_stack+108969,int_stack+84894,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+123819,int_stack+62469,int_stack+48294,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+43479,int_stack+8400,int_stack+6600,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48879,int_stack+43479,int_stack+30564,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+79794,int_stack+48879,int_stack+35289,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+142719,int_stack+79794,int_stack+97269,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+160269,int_stack+142719,int_stack+108969,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+93444,int_stack+160269,int_stack+62469,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+181059,int_stack+93444,int_stack+123819,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+30564,int_stack+10440,int_stack+8400,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+58329,int_stack+30564,int_stack+43479,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+30564,int_stack+58329,int_stack+48879,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+46314,int_stack+30564,int_stack+79794,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+66789,int_stack+46314,int_stack+142719,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+30564,int_stack+66789,int_stack+160269,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+58284,int_stack+30564,int_stack+93444,15);
 /*--- compute (g0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+87984,int_stack+58284,int_stack+181059,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30564,int_stack+13680,int_stack+12735,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33399,int_stack+14835,int_stack+13680,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+36864,int_stack+33399,int_stack+30564,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+42534,int_stack+16221,int_stack+14835,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+46692,int_stack+42534,int_stack+33399,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+53622,int_stack+46692,int_stack+36864,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30564,int_stack+17859,int_stack+16221,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+63072,int_stack+30564,int_stack+42534,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+71388,int_stack+63072,int_stack+46692,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+35478,int_stack+71388,int_stack+53622,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+49653,int_stack+19770,int_stack+17859,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+118359,int_stack+49653,int_stack+30564,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+128187,int_stack+118359,int_stack+63072,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+142047,int_stack+128187,int_stack+71388,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+55386,int_stack+142047,int_stack+35478,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+30564,int_stack+21975,int_stack+19770,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+37179,int_stack+30564,int_stack+49653,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+159372,int_stack+37179,int_stack+118359,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+175752,int_stack+159372,int_stack+128187,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+196542,int_stack+175752,int_stack+142047,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+118359,int_stack+196542,int_stack+55386,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+144819,int_stack+24495,int_stack+21975,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48645,int_stack+144819,int_stack+30564,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+61875,int_stack+48645,int_stack+37179,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+220797,int_stack+61875,int_stack+159372,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+245367,int_stack+220797,int_stack+175752,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+152379,int_stack+245367,int_stack+196542,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+184719,int_stack+152379,int_stack+118359,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+118359,int_stack+27351,int_stack+24495,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+126927,int_stack+118359,int_stack+144819,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+126927,int_stack+48645,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+118359,int_stack+0,int_stack+61875,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+118359,int_stack+220797,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+34398,int_stack+0,int_stack+245367,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+218739,int_stack+34398,int_stack+152379,21);
 /*--- compute (h0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+218739,int_stack+184719,21);
 /*--- compute (gp|ll) ---*/
 hrr1_build_gp(Libint->AB,int_stack+118359,int_stack+0,int_stack+87984,2025);
 return int_stack+118359;}
