/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpmh(Libint_t*, prim_data*);

  /* Computes quartets of (gp|mh) integrals */

REALTYPE *hrr_order_gpmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[4][14] = int_stack + 5925;
 Libint->vrr_classes[5][9] = int_stack + 7725;
 Libint->vrr_classes[5][10] = int_stack + 8880;
 Libint->vrr_classes[5][11] = int_stack + 10266;
 Libint->vrr_classes[5][12] = int_stack + 11904;
 Libint->vrr_classes[5][13] = int_stack + 13815;
 Libint->vrr_classes[5][14] = int_stack + 16020;
 memset(int_stack,0,18540*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 18540;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpmh(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18540,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21015,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23985,int_stack+21015,int_stack+18540,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28935,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+32445,int_stack+28935,int_stack+21015,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+38385,int_stack+32445,int_stack+23985,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+18540,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+46635,int_stack+18540,int_stack+28935,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+53655,int_stack+46635,int_stack+32445,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+22635,int_stack+53655,int_stack+38385,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+35010,int_stack+5925,int_stack+4350,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+63555,int_stack+35010,int_stack+18540,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+71745,int_stack+63555,int_stack+46635,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+35010,int_stack+71745,int_stack+53655,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+49860,int_stack+35010,int_stack+22635,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18540,int_stack+8880,int_stack+7725,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+22005,int_stack+10266,int_stack+8880,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+26163,int_stack+22005,int_stack+18540,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33093,int_stack+11904,int_stack+10266,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+38007,int_stack+33093,int_stack+22005,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+67185,int_stack+38007,int_stack+26163,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+18540,int_stack+13815,int_stack+11904,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+18540,int_stack+33093,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+78735,int_stack+0,int_stack+38007,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24273,int_stack+78735,int_stack+67185,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+67185,int_stack+16020,int_stack+13815,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+92595,int_stack+67185,int_stack+18540,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+104061,int_stack+92595,int_stack+0,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+104061,int_stack+78735,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+67185,int_stack+0,int_stack+24273,21);
 /*--- compute (gp|mh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+91440,int_stack+67185,int_stack+49860,1155);
 return int_stack+91440;}
