/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpnl(Libint_t*, prim_data*);

  /* Computes quartets of (gp|nl) integrals */

REALTYPE *hrr_order_gpnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[4][17] = int_stack + 11235;
 Libint->vrr_classes[4][18] = int_stack + 13800;
 Libint->vrr_classes[5][10] = int_stack + 16650;
 Libint->vrr_classes[5][11] = int_stack + 18036;
 Libint->vrr_classes[5][12] = int_stack + 19674;
 Libint->vrr_classes[5][13] = int_stack + 21585;
 Libint->vrr_classes[5][14] = int_stack + 23790;
 Libint->vrr_classes[5][15] = int_stack + 26310;
 Libint->vrr_classes[5][16] = int_stack + 29166;
 Libint->vrr_classes[5][17] = int_stack + 32379;
 Libint->vrr_classes[5][18] = int_stack + 35970;
 memset(int_stack,0,39960*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 39960;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpnl(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39960,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+42930,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+46440,int_stack+42930,int_stack+39960,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+52380,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+56475,int_stack+52380,int_stack+42930,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+63495,int_stack+56475,int_stack+46440,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+39960,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+73395,int_stack+39960,int_stack+52380,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+44685,int_stack+73395,int_stack+56475,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+81585,int_stack+44685,int_stack+63495,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+56385,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+61785,int_stack+56385,int_stack+39960,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+96435,int_stack+61785,int_stack+73395,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+110085,int_stack+96435,int_stack+44685,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+127635,int_stack+110085,int_stack+81585,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+39960,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+71235,int_stack+39960,int_stack+56385,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+148425,int_stack+71235,int_stack+61785,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+46080,int_stack+148425,int_stack+96435,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+82035,int_stack+46080,int_stack+110085,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+164175,int_stack+82035,int_stack+127635,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+106605,int_stack+11235,int_stack+8940,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+113490,int_stack+106605,int_stack+39960,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+125730,int_stack+113490,int_stack+71235,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+191895,int_stack+125730,int_stack+148425,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+215520,int_stack+191895,int_stack+46080,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+39960,int_stack+215520,int_stack+82035,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+244185,int_stack+39960,int_stack+164175,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+72720,int_stack+13800,int_stack+11235,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+80415,int_stack+72720,int_stack+106605,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+143730,int_stack+80415,int_stack+113490,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+72720,int_stack+143730,int_stack+125730,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+99720,int_stack+72720,int_stack+191895,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+132795,int_stack+99720,int_stack+215520,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+72720,int_stack+132795,int_stack+39960,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+114840,int_stack+72720,int_stack+244185,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39960,int_stack+18036,int_stack+16650,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+44118,int_stack+19674,int_stack+18036,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+49032,int_stack+44118,int_stack+39960,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+57348,int_stack+21585,int_stack+19674,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+63081,int_stack+57348,int_stack+44118,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+72909,int_stack+63081,int_stack+49032,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+39960,int_stack+23790,int_stack+21585,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+86769,int_stack+39960,int_stack+57348,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+46575,int_stack+86769,int_stack+63081,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+159390,int_stack+46575,int_stack+72909,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+62955,int_stack+26310,int_stack+23790,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+70515,int_stack+62955,int_stack+39960,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+180180,int_stack+70515,int_stack+86769,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+83745,int_stack+180180,int_stack+46575,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+199290,int_stack+83745,int_stack+159390,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+159390,int_stack+29166,int_stack+26310,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+39960,int_stack+159390,int_stack+62955,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+228396,int_stack+39960,int_stack+70515,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55080,int_stack+228396,int_stack+180180,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+250446,int_stack+55080,int_stack+83745,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+284844,int_stack+250446,int_stack+199290,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+83745,int_stack+32379,int_stack+29166,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+93384,int_stack+83745,int_stack+159390,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+159390,int_stack+93384,int_stack+39960,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+184590,int_stack+159390,int_stack+228396,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+323652,int_stack+184590,int_stack+55080,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+363783,int_stack+323652,int_stack+250446,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+217665,int_stack+363783,int_stack+284844,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+39960,int_stack+35970,int_stack+32379,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+50733,int_stack+39960,int_stack+83745,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+267561,int_stack+50733,int_stack+93384,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+267561,int_stack+159390,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+267561,int_stack+0,int_stack+184590,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+267561,int_stack+323652,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+267561,int_stack+0,int_stack+363783,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+267561,int_stack+217665,21);
 /*--- compute (gp|nl) ---*/
 hrr1_build_gp(Libint->AB,int_stack+159390,int_stack+0,int_stack+114840,2970);
 return int_stack+159390;}
