/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_h0ii(Libint_t*, prim_data*);

  /* Computes quartets of (h0|ii) integrals */

REALTYPE *hrr_order_h0ii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[5][8] = int_stack + 1344;
 Libint->vrr_classes[5][9] = int_stack + 2289;
 Libint->vrr_classes[5][10] = int_stack + 3444;
 Libint->vrr_classes[5][11] = int_stack + 4830;
 Libint->vrr_classes[5][12] = int_stack + 6468;
 memset(int_stack,0,8379*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8379;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_h0ii(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+8379,int_stack+588,int_stack+0,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+10143,int_stack+1344,int_stack+588,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+12411,int_stack+10143,int_stack+8379,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15939,int_stack+2289,int_stack+1344,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18774,int_stack+15939,int_stack+10143,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+23310,int_stack+18774,int_stack+12411,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8379,int_stack+3444,int_stack+2289,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+29190,int_stack+8379,int_stack+15939,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+34860,int_stack+29190,int_stack+18774,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+11844,int_stack+34860,int_stack+23310,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20664,int_stack+4830,int_stack+3444,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42420,int_stack+20664,int_stack+8379,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+49350,int_stack+42420,int_stack+29190,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+58800,int_stack+49350,int_stack+34860,21);
 /*--- compute (h0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+24822,int_stack+58800,int_stack+11844,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8379,int_stack+6468,int_stack+4830,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+8379,int_stack+20664,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+8316,int_stack+0,int_stack+42420,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+70140,int_stack+8316,int_stack+49350,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+70140,int_stack+58800,21);
 /*--- compute (h0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+37170,int_stack+0,int_stack+24822,21);
 return int_stack+37170;}
