/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_h0nn(Libint_t*, prim_data*);

  /* Computes quartets of (h0|nn) integrals */

REALTYPE *hrr_order_h0nn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[5][17] = int_stack + 15729;
 Libint->vrr_classes[5][18] = int_stack + 19320;
 Libint->vrr_classes[5][19] = int_stack + 23310;
 Libint->vrr_classes[5][20] = int_stack + 27720;
 memset(int_stack,0,32571*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 32571;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_h0nn(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+32571,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36729,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+41643,int_stack+36729,int_stack+32571,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+49959,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+55692,int_stack+49959,int_stack+36729,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+65520,int_stack+55692,int_stack+41643,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+32571,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+79380,int_stack+32571,int_stack+49959,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+39186,int_stack+79380,int_stack+55692,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+90846,int_stack+39186,int_stack+65520,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+55566,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+63126,int_stack+55566,int_stack+32571,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+111636,int_stack+63126,int_stack+79380,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+130746,int_stack+111636,int_stack+39186,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+155316,int_stack+130746,int_stack+90846,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+32571,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+76356,int_stack+32571,int_stack+55566,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+184422,int_stack+76356,int_stack+63126,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+41139,int_stack+184422,int_stack+111636,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+91476,int_stack+41139,int_stack+130746,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+206472,int_stack+91476,int_stack+155316,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+125874,int_stack+15729,int_stack+12516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+135513,int_stack+125874,int_stack+32571,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+152649,int_stack+135513,int_stack+76356,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+245280,int_stack+152649,int_stack+184422,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+278355,int_stack+245280,int_stack+41139,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+32571,int_stack+278355,int_stack+91476,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+318486,int_stack+32571,int_stack+206472,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+78435,int_stack+19320,int_stack+15729,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+89208,int_stack+78435,int_stack+125874,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+177849,int_stack+89208,int_stack+135513,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+108486,int_stack+177849,int_stack+152649,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+368382,int_stack+108486,int_stack+245280,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+206409,int_stack+368382,int_stack+278355,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+414687,int_stack+206409,int_stack+32571,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+473655,int_stack+414687,int_stack+318486,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+32571,int_stack+23310,int_stack+19320,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+44541,int_stack+32571,int_stack+78435,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+259917,int_stack+44541,int_stack+89208,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+292047,int_stack+259917,int_stack+177849,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+146286,int_stack+292047,int_stack+108486,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+66087,int_stack+146286,int_stack+368382,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+334887,int_stack+66087,int_stack+206409,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+536025,int_stack+334887,int_stack+414687,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+609735,int_stack+536025,int_stack+473655,21);
 /*--- compute (h0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+127827,int_stack+27720,int_stack+23310,21);
 /*--- compute (h0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+199206,int_stack+127827,int_stack+32571,21);
 /*--- compute (h0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+223146,int_stack+199206,int_stack+44541,21);
 /*--- compute (h0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+403683,int_stack+223146,int_stack+259917,21);
 /*--- compute (h0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+199206,int_stack+403683,int_stack+292047,21);
 /*--- compute (h0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+403683,int_stack+199206,int_stack+146286,21);
 /*--- compute (h0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+127827,int_stack+403683,int_stack+66087,21);
 /*--- compute (h0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+403683,int_stack+127827,int_stack+334887,21);
 /*--- compute (h0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+403683,int_stack+536025,21);
 /*--- compute (h0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+90090,int_stack+0,int_stack+609735,21);
 return int_stack+90090;}
