/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdkg(Libint_t*, prim_data*);

  /* Computes quartets of (hd|kg) integrals */

REALTYPE *hrr_order_hdkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[6][7] = int_stack + 5880;
 Libint->vrr_classes[6][8] = int_stack + 6888;
 Libint->vrr_classes[6][9] = int_stack + 8148;
 Libint->vrr_classes[6][10] = int_stack + 9688;
 Libint->vrr_classes[6][11] = int_stack + 11536;
 Libint->vrr_classes[7][7] = int_stack + 13720;
 Libint->vrr_classes[7][8] = int_stack + 15016;
 Libint->vrr_classes[7][9] = int_stack + 16636;
 Libint->vrr_classes[7][10] = int_stack + 18616;
 Libint->vrr_classes[7][11] = int_stack + 20992;
 memset(int_stack,0,23800*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 23800;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdkg(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+23800,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+26068,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+28903,int_stack+26068,int_stack+23800,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33439,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+36904,int_stack+33439,int_stack+26068,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+42574,int_stack+36904,int_stack+28903,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23800,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50134,int_stack+23800,int_stack+33439,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+23800,int_stack+50134,int_stack+36904,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+50134,int_stack+23800,int_stack+42574,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+23800,int_stack+6888,int_stack+5880,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+26824,int_stack+8148,int_stack+6888,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+30604,int_stack+26824,int_stack+23800,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36652,int_stack+9688,int_stack+8148,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+41272,int_stack+36652,int_stack+26824,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+61474,int_stack+41272,int_stack+30604,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23800,int_stack+11536,int_stack+9688,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+23800,int_stack+36652,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+23800,int_stack+0,int_stack+41272,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+71554,int_stack+23800,int_stack+61474,28);
 /*--- compute (hp|kg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+86674,int_stack+71554,int_stack+50134,540);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+23800,int_stack+15016,int_stack+13720,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27688,int_stack+16636,int_stack+15016,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+32548,int_stack+27688,int_stack+23800,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40324,int_stack+18616,int_stack+16636,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+46264,int_stack+40324,int_stack+27688,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+55984,int_stack+46264,int_stack+32548,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23800,int_stack+20992,int_stack+18616,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+23800,int_stack+40324,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+11880,int_stack+0,int_stack+46264,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+28080,int_stack+11880,int_stack+55984,36);
 /*--- compute (ip|kg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+120694,int_stack+28080,int_stack+71554,540);
 /*--- compute (hd|kg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+120694,int_stack+86674,540);
 return int_stack+0;}
