/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hflh(Libint_t*, prim_data*);

  /* Computes quartets of (hf|lh) integrals */

REALTYPE *hrr_order_hflh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[6][8] = int_stack + 9240;
 Libint->vrr_classes[6][9] = int_stack + 10500;
 Libint->vrr_classes[6][10] = int_stack + 12040;
 Libint->vrr_classes[6][11] = int_stack + 13888;
 Libint->vrr_classes[6][12] = int_stack + 16072;
 Libint->vrr_classes[6][13] = int_stack + 18620;
 Libint->vrr_classes[7][8] = int_stack + 21560;
 Libint->vrr_classes[7][9] = int_stack + 23180;
 Libint->vrr_classes[7][10] = int_stack + 25160;
 Libint->vrr_classes[7][11] = int_stack + 27536;
 Libint->vrr_classes[7][12] = int_stack + 30344;
 Libint->vrr_classes[7][13] = int_stack + 33620;
 Libint->vrr_classes[8][8] = int_stack + 37400;
 Libint->vrr_classes[8][9] = int_stack + 39425;
 Libint->vrr_classes[8][10] = int_stack + 41900;
 Libint->vrr_classes[8][11] = int_stack + 44870;
 Libint->vrr_classes[8][12] = int_stack + 48380;
 Libint->vrr_classes[8][13] = int_stack + 52475;
 memset(int_stack,0,57200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 57200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hflh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+57200,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+60035,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+63500,int_stack+60035,int_stack+57200,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+69170,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+73328,int_stack+69170,int_stack+60035,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+80258,int_stack+73328,int_stack+63500,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57200,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+89708,int_stack+57200,int_stack+69170,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+98024,int_stack+89708,int_stack+73328,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+62114,int_stack+98024,int_stack+80258,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+76289,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+109574,int_stack+76289,int_stack+57200,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+119402,int_stack+109574,int_stack+89708,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+76289,int_stack+119402,int_stack+98024,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+93614,int_stack+76289,int_stack+62114,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+57200,int_stack+10500,int_stack+9240,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+60980,int_stack+12040,int_stack+10500,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65600,int_stack+60980,int_stack+57200,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+73160,int_stack+13888,int_stack+12040,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+78704,int_stack+73160,int_stack+60980,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+113459,int_stack+78704,int_stack+65600,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57200,int_stack+16072,int_stack+13888,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+57200,int_stack+73160,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+126059,int_stack+0,int_stack+78704,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+63752,int_stack+126059,int_stack+113459,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+113459,int_stack+18620,int_stack+16072,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+141459,int_stack+113459,int_stack+57200,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+154563,int_stack+141459,int_stack+0,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+173043,int_stack+154563,int_stack+126059,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+113459,int_stack+173043,int_stack+63752,28);
 /*--- compute (hp|lh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+139919,int_stack+113459,int_stack+93614,945);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+23180,int_stack+21560,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4860,int_stack+25160,int_stack+23180,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10800,int_stack+4860,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+57200,int_stack+27536,int_stack+25160,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+64328,int_stack+57200,int_stack+4860,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+76208,int_stack+64328,int_stack+10800,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+30344,int_stack+27536,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+8424,int_stack+0,int_stack+57200,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+92408,int_stack+8424,int_stack+64328,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+199454,int_stack+92408,int_stack+76208,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+57200,int_stack+33620,int_stack+30344,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+67028,int_stack+57200,int_stack+0,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+223754,int_stack+67028,int_stack+8424,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+223754,int_stack+92408,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+57200,int_stack+0,int_stack+199454,36);
 /*--- compute (ip|lh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+199454,int_stack+57200,int_stack+113459,945);
 /*--- compute (hd|lh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+278834,int_stack+199454,int_stack+139919,945);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+39425,int_stack+37400,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6075,int_stack+41900,int_stack+39425,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+13500,int_stack+6075,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25650,int_stack+44870,int_stack+41900,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+91220,int_stack+25650,int_stack+6075,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+106070,int_stack+91220,int_stack+13500,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+48380,int_stack+44870,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+126320,int_stack+0,int_stack+25650,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+10530,int_stack+126320,int_stack+91220,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+144140,int_stack+10530,int_stack+106070,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+91220,int_stack+52475,int_stack+48380,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+103505,int_stack+91220,int_stack+0,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+397904,int_stack+103505,int_stack+126320,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+91220,int_stack+397904,int_stack+10530,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+91220,int_stack+144140,45);
 /*--- compute (kp|lh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+91220,int_stack+0,int_stack+57200,945);
 /*--- compute (id|lh) ---*/
 hrr1_build_id(Libint->AB,int_stack+397904,int_stack+91220,int_stack+199454,945);
 /*--- compute (hf|lh) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+397904,int_stack+278834,945);
 return int_stack+0;}
