/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhni(Libint_t*, prim_data*);

  /* Computes quartets of (hh|ni) integrals */

REALTYPE *hrr_order_hhni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[6][10] = int_stack + 15729;
 Libint->vrr_classes[6][11] = int_stack + 17577;
 Libint->vrr_classes[6][12] = int_stack + 19761;
 Libint->vrr_classes[6][13] = int_stack + 22309;
 Libint->vrr_classes[6][14] = int_stack + 25249;
 Libint->vrr_classes[6][15] = int_stack + 28609;
 Libint->vrr_classes[6][16] = int_stack + 32417;
 Libint->vrr_classes[7][10] = int_stack + 36701;
 Libint->vrr_classes[7][11] = int_stack + 39077;
 Libint->vrr_classes[7][12] = int_stack + 41885;
 Libint->vrr_classes[7][13] = int_stack + 45161;
 Libint->vrr_classes[7][14] = int_stack + 48941;
 Libint->vrr_classes[7][15] = int_stack + 53261;
 Libint->vrr_classes[7][16] = int_stack + 58157;
 Libint->vrr_classes[8][10] = int_stack + 63665;
 Libint->vrr_classes[8][11] = int_stack + 66635;
 Libint->vrr_classes[8][12] = int_stack + 70145;
 Libint->vrr_classes[8][13] = int_stack + 74240;
 Libint->vrr_classes[8][14] = int_stack + 78965;
 Libint->vrr_classes[8][15] = int_stack + 84365;
 Libint->vrr_classes[8][16] = int_stack + 90485;
 Libint->vrr_classes[9][10] = int_stack + 97370;
 Libint->vrr_classes[9][11] = int_stack + 101000;
 Libint->vrr_classes[9][12] = int_stack + 105290;
 Libint->vrr_classes[9][13] = int_stack + 110295;
 Libint->vrr_classes[9][14] = int_stack + 116070;
 Libint->vrr_classes[9][15] = int_stack + 122670;
 Libint->vrr_classes[9][16] = int_stack + 130150;
 Libint->vrr_classes[10][10] = int_stack + 138565;
 Libint->vrr_classes[10][11] = int_stack + 142921;
 Libint->vrr_classes[10][12] = int_stack + 148069;
 Libint->vrr_classes[10][13] = int_stack + 154075;
 Libint->vrr_classes[10][14] = int_stack + 161005;
 Libint->vrr_classes[10][15] = int_stack + 168925;
 Libint->vrr_classes[10][16] = int_stack + 177901;
 memset(int_stack,0,187999*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 187999;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhni(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+187999,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+192157,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+197071,int_stack+192157,int_stack+187999,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+205387,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+211120,int_stack+205387,int_stack+192157,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+220948,int_stack+211120,int_stack+197071,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+187999,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+234808,int_stack+187999,int_stack+205387,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+194614,int_stack+234808,int_stack+211120,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+246274,int_stack+194614,int_stack+220948,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+210994,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+218554,int_stack+210994,int_stack+187999,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+267064,int_stack+218554,int_stack+234808,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+286174,int_stack+267064,int_stack+194614,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+310744,int_stack+286174,int_stack+246274,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+187999,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+231784,int_stack+187999,int_stack+210994,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+187999,int_stack+231784,int_stack+218554,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+210049,int_stack+187999,int_stack+267064,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+238714,int_stack+210049,int_stack+286174,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+187999,int_stack+238714,int_stack+310744,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+226807,int_stack+17577,int_stack+15729,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+232351,int_stack+19761,int_stack+17577,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+238903,int_stack+232351,int_stack+226807,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+249991,int_stack+22309,int_stack+19761,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+257635,int_stack+249991,int_stack+232351,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+270739,int_stack+257635,int_stack+238903,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+226807,int_stack+25249,int_stack+22309,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+289219,int_stack+226807,int_stack+249991,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+235627,int_stack+289219,int_stack+257635,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+304507,int_stack+235627,int_stack+270739,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+257467,int_stack+28609,int_stack+25249,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+267547,int_stack+257467,int_stack+226807,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+267547,int_stack+289219,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+332227,int_stack+0,int_stack+235627,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+364987,int_stack+332227,int_stack+304507,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+226807,int_stack+32417,int_stack+28609,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+285187,int_stack+226807,int_stack+257467,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+226807,int_stack+285187,int_stack+267547,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+256207,int_stack+226807,int_stack+0,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+403795,int_stack+256207,int_stack+332227,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+226807,int_stack+403795,int_stack+364987,28);
 /*--- compute (hp|ni) ---*/
 hrr1_build_hp(Libint->AB,int_stack+278551,int_stack+226807,int_stack+187999,1848);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+187999,int_stack+39077,int_stack+36701,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+195127,int_stack+41885,int_stack+39077,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+203551,int_stack+195127,int_stack+187999,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+45161,int_stack+41885,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9828,int_stack+0,int_stack+195127,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+394975,int_stack+9828,int_stack+203551,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+187999,int_stack+48941,int_stack+45161,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+199339,int_stack+187999,int_stack+0,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+418735,int_stack+199339,int_stack+9828,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+418735,int_stack+394975,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+394975,int_stack+53261,int_stack+48941,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+446815,int_stack+394975,int_stack+187999,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+469495,int_stack+446815,int_stack+199339,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+502255,int_stack+469495,int_stack+418735,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+544375,int_stack+502255,int_stack+0,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+58157,int_stack+53261,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+14688,int_stack+0,int_stack+394975,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+394975,int_stack+14688,int_stack+446815,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+394975,int_stack+469495,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+394975,int_stack+0,int_stack+502255,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+453943,int_stack+394975,int_stack+544375,36);
 /*--- compute (ip|ni) ---*/
 hrr1_build_ip(Libint->AB,int_stack+520471,int_stack+453943,int_stack+226807,1848);
 /*--- compute (hd|ni) ---*/
 hrr1_build_hd(Libint->AB,int_stack+675703,int_stack+520471,int_stack+278551,1848);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+66635,int_stack+63665,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+70145,int_stack+66635,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+37260,int_stack+74240,int_stack+70145,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+49545,int_stack+37260,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+187999,int_stack+49545,int_stack+19440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+78965,int_stack+74240,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+217699,int_stack+0,int_stack+37260,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+14175,int_stack+217699,int_stack+49545,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+242269,int_stack+14175,int_stack+187999,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+187999,int_stack+84365,int_stack+78965,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+49275,int_stack+187999,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+286819,int_stack+49275,int_stack+217699,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+327769,int_stack+286819,int_stack+14175,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+380419,int_stack+327769,int_stack+242269,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+90485,int_stack+84365,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+204199,int_stack+0,int_stack+187999,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+204199,int_stack+49275,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+187999,int_stack+0,int_stack+286819,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+187999,int_stack+327769,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+187999,int_stack+0,int_stack+380419,45);
 /*--- compute (kp|ni) ---*/
 hrr1_build_kp(Libint->AB,int_stack+908551,int_stack+187999,int_stack+453943,1848);
 /*--- compute (id|ni) ---*/
 hrr1_build_id(Libint->AB,int_stack+1108135,int_stack+908551,int_stack+520471,1848);
 /*--- compute (hf|ni) ---*/
 hrr1_build_hf(Libint->AB,int_stack+271159,int_stack+1108135,int_stack+675703,1848);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+101000,int_stack+97370,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+105290,int_stack+101000,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+110295,int_stack+105290,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60555,int_stack+45540,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+659239,int_stack+60555,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+116070,int_stack+110295,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+695539,int_stack+0,int_stack+45540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17325,int_stack+695539,int_stack+60555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+60225,int_stack+17325,int_stack+659239,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+659239,int_stack+122670,int_stack+116070,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+725569,int_stack+659239,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+760219,int_stack+725569,int_stack+695539,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+810269,int_stack+760219,int_stack+17325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1418599,int_stack+810269,int_stack+60225,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+130150,int_stack+122670,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+22440,int_stack+0,int_stack+659239,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+659239,int_stack+22440,int_stack+725569,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+659239,int_stack+760219,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+659239,int_stack+0,int_stack+810269,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+659239,int_stack+1418599,55);
 /*--- compute (lp|ni) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1418599,int_stack+0,int_stack+187999,1848);
 /*--- compute (kd|ni) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1668079,int_stack+1418599,int_stack+908551,1848);
 /*--- compute (if|ni) ---*/
 hrr1_build_if(Libint->AB,int_stack+2067247,int_stack+1668079,int_stack+1108135,1848);
 /*--- compute (hg|ni) ---*/
 hrr1_build_hg(Libint->AB,int_stack+659239,int_stack+2067247,int_stack+271159,1848);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+187999,int_stack+142921,int_stack+138565,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+201067,int_stack+148069,int_stack+142921,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+216511,int_stack+201067,int_stack+187999,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+242647,int_stack+154075,int_stack+148069,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+260665,int_stack+242647,int_stack+201067,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+291553,int_stack+260665,int_stack+216511,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+187999,int_stack+161005,int_stack+154075,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+335113,int_stack+187999,int_stack+242647,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+208789,int_stack+335113,int_stack+260665,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+371149,int_stack+208789,int_stack+291553,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+260269,int_stack+168925,int_stack+161005,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+284029,int_stack+260269,int_stack+187999,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+436489,int_stack+284029,int_stack+335113,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+496549,int_stack+436489,int_stack+208789,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1241359,int_stack+496549,int_stack+371149,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+187999,int_stack+177901,int_stack+168925,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+325609,int_stack+187999,int_stack+260269,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+573769,int_stack+325609,int_stack+284029,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+101640,int_stack+573769,int_stack+436489,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+191730,int_stack+101640,int_stack+496549,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+299838,int_stack+191730,int_stack+1241359,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2584687,int_stack+299838,int_stack+0,1848);
 /*--- compute (ld|ni) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+2584687,int_stack+1418599,1848);
 /*--- compute (kf|ni) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2584687,int_stack+0,int_stack+1668079,1848);
 /*--- compute (ig|ni) ---*/
 hrr1_build_ig(Libint->AB,int_stack+1241359,int_stack+2584687,int_stack+2067247,1848);
 /*--- compute (hh|ni) ---*/
 hrr1_build_hh(Libint->AB,int_stack+2017519,int_stack+1241359,int_stack+659239,1848);
 return int_stack+2017519;}
