/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpkk(Libint_t*, prim_data*);

  /* Computes quartets of (hp|kk) integrals */

REALTYPE *hrr_order_hpkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[5][13] = int_stack + 7791;
 Libint->vrr_classes[5][14] = int_stack + 9996;
 Libint->vrr_classes[6][7] = int_stack + 12516;
 Libint->vrr_classes[6][8] = int_stack + 13524;
 Libint->vrr_classes[6][9] = int_stack + 14784;
 Libint->vrr_classes[6][10] = int_stack + 16324;
 Libint->vrr_classes[6][11] = int_stack + 18172;
 Libint->vrr_classes[6][12] = int_stack + 20356;
 Libint->vrr_classes[6][13] = int_stack + 22904;
 Libint->vrr_classes[6][14] = int_stack + 25844;
 memset(int_stack,0,29204*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 29204;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpkk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+29204,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+31472,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+34307,int_stack+31472,int_stack+29204,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+38843,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+42308,int_stack+38843,int_stack+31472,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+47978,int_stack+42308,int_stack+34307,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+29204,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+55538,int_stack+29204,int_stack+38843,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+62468,int_stack+55538,int_stack+42308,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+33362,int_stack+62468,int_stack+47978,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+44702,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+71918,int_stack+44702,int_stack+29204,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+80234,int_stack+71918,int_stack+55538,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+91784,int_stack+80234,int_stack+62468,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+49616,int_stack+91784,int_stack+33362,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29204,int_stack+7791,int_stack+5880,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+105959,int_stack+29204,int_stack+44702,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+34937,int_stack+105959,int_stack+71918,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+115787,int_stack+34937,int_stack+80234,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+65492,int_stack+115787,int_stack+91784,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+133112,int_stack+65492,int_stack+49616,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+48797,int_stack+9996,int_stack+7791,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+85337,int_stack+48797,int_stack+29204,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+48797,int_stack+85337,int_stack+105959,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+85337,int_stack+48797,int_stack+34937,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+29204,int_stack+85337,int_stack+115787,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+85337,int_stack+29204,int_stack+65492,21);
 /*--- compute (h0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+29204,int_stack+85337,int_stack+133112,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+56420,int_stack+13524,int_stack+12516,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59444,int_stack+14784,int_stack+13524,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+63224,int_stack+59444,int_stack+56420,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+69272,int_stack+16324,int_stack+14784,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+73892,int_stack+69272,int_stack+59444,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+81452,int_stack+73892,int_stack+63224,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+56420,int_stack+18172,int_stack+16324,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+91532,int_stack+56420,int_stack+69272,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+100772,int_stack+91532,int_stack+73892,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+61964,int_stack+100772,int_stack+81452,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77084,int_stack+20356,int_stack+18172,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+113372,int_stack+77084,int_stack+56420,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+124460,int_stack+113372,int_stack+91532,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+124460,int_stack+100772,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+83636,int_stack+0,int_stack+61964,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+56420,int_stack+22904,int_stack+20356,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+139860,int_stack+56420,int_stack+77084,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+64064,int_stack+139860,int_stack+113372,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+152964,int_stack+64064,int_stack+124460,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+104804,int_stack+152964,int_stack+0,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+176064,int_stack+104804,int_stack+83636,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+25844,int_stack+22904,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+56420,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+82544,int_stack+8820,int_stack+139860,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+82544,int_stack+64064,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+56420,int_stack+0,int_stack+152964,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+131264,int_stack+56420,int_stack+104804,28);
 /*--- compute (i0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+56420,int_stack+131264,int_stack+176064,28);
 /*--- compute (hp|kk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+92708,int_stack+56420,int_stack+29204,1296);
 return int_stack+92708;}
