/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idgg(Libint_t*, prim_data*);

  /* Computes quartets of (id|gg) integrals */

REALTYPE *hrr_order_idgg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][4] = int_stack + 0;
 Libint->vrr_classes[6][5] = int_stack + 420;
 Libint->vrr_classes[6][6] = int_stack + 1008;
 Libint->vrr_classes[6][7] = int_stack + 1792;
 Libint->vrr_classes[6][8] = int_stack + 2800;
 Libint->vrr_classes[7][4] = int_stack + 4060;
 Libint->vrr_classes[7][5] = int_stack + 4600;
 Libint->vrr_classes[7][6] = int_stack + 5356;
 Libint->vrr_classes[7][7] = int_stack + 6364;
 Libint->vrr_classes[7][8] = int_stack + 7660;
 Libint->vrr_classes[8][4] = int_stack + 9280;
 Libint->vrr_classes[8][5] = int_stack + 9955;
 Libint->vrr_classes[8][6] = int_stack + 10900;
 Libint->vrr_classes[8][7] = int_stack + 12160;
 Libint->vrr_classes[8][8] = int_stack + 13780;
 memset(int_stack,0,15805*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 15805;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idgg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+15805,int_stack+420,int_stack+0,28);
 /*--- compute (i0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+17065,int_stack+1008,int_stack+420,28);
 /*--- compute (i0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+18829,int_stack+17065,int_stack+15805,28);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+21349,int_stack+1792,int_stack+1008,28);
 /*--- compute (i0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+23701,int_stack+21349,int_stack+17065,28);
 /*--- compute (i0|gf) ---*/
 hrr3_build_gf(Libint->CD,int_stack+27229,int_stack+23701,int_stack+18829,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+15805,int_stack+2800,int_stack+1792,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+31429,int_stack+15805,int_stack+21349,28);
 /*--- compute (i0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+15805,int_stack+31429,int_stack+23701,28);
 /*--- compute (i0|gg) ---*/
 hrr3_build_gg(Libint->CD,int_stack+31429,int_stack+15805,int_stack+27229,28);
 /*--- compute (k0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+15805,int_stack+4600,int_stack+4060,36);
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+17425,int_stack+5356,int_stack+4600,36);
 /*--- compute (k0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+19693,int_stack+17425,int_stack+15805,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+22933,int_stack+6364,int_stack+5356,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+25957,int_stack+22933,int_stack+17425,36);
 /*--- compute (k0|gf) ---*/
 hrr3_build_gf(Libint->CD,int_stack+0,int_stack+25957,int_stack+19693,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+15805,int_stack+7660,int_stack+6364,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+37729,int_stack+15805,int_stack+22933,36);
 /*--- compute (k0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+15805,int_stack+37729,int_stack+25957,36);
 /*--- compute (k0|gg) ---*/
 hrr3_build_gg(Libint->CD,int_stack+37729,int_stack+15805,int_stack+0,36);
 /*--- compute (ip|gg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+45829,int_stack+37729,int_stack+31429,225);
 /*--- compute (l0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+0,int_stack+9955,int_stack+9280,45);
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+2025,int_stack+10900,int_stack+9955,45);
 /*--- compute (l0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+4860,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+15805,int_stack+12160,int_stack+10900,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+19585,int_stack+15805,int_stack+2025,45);
 /*--- compute (l0|gf) ---*/
 hrr3_build_gf(Libint->CD,int_stack+25255,int_stack+19585,int_stack+4860,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+13780,int_stack+12160,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+4860,int_stack+0,int_stack+15805,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+64729,int_stack+4860,int_stack+19585,45);
 /*--- compute (l0|gg) ---*/
 hrr3_build_gg(Libint->CD,int_stack+0,int_stack+64729,int_stack+25255,45);
 /*--- compute (kp|gg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+10125,int_stack+0,int_stack+37729,225);
 /*--- compute (id|gg) ---*/
 hrr1_build_id(Libint->AB,int_stack+64729,int_stack+10125,int_stack+45829,225);
 return int_stack+64729;}
