/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idmh(Libint_t*, prim_data*);

  /* Computes quartets of (id|mh) integrals */

REALTYPE *hrr_order_idmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[7][9] = int_stack + 14420;
 Libint->vrr_classes[7][10] = int_stack + 16400;
 Libint->vrr_classes[7][11] = int_stack + 18776;
 Libint->vrr_classes[7][12] = int_stack + 21584;
 Libint->vrr_classes[7][13] = int_stack + 24860;
 Libint->vrr_classes[7][14] = int_stack + 28640;
 Libint->vrr_classes[8][9] = int_stack + 32960;
 Libint->vrr_classes[8][10] = int_stack + 35435;
 Libint->vrr_classes[8][11] = int_stack + 38405;
 Libint->vrr_classes[8][12] = int_stack + 41915;
 Libint->vrr_classes[8][13] = int_stack + 46010;
 Libint->vrr_classes[8][14] = int_stack + 50735;
 memset(int_stack,0,56135*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 56135;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idmh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+56135,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60755,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+66299,int_stack+60755,int_stack+56135,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+75539,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+82091,int_stack+75539,int_stack+60755,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+93179,int_stack+82091,int_stack+66299,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+56135,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+108579,int_stack+56135,int_stack+75539,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+121683,int_stack+108579,int_stack+82091,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+63779,int_stack+121683,int_stack+93179,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+86879,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+140163,int_stack+86879,int_stack+56135,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+155451,int_stack+140163,int_stack+108579,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+86879,int_stack+155451,int_stack+121683,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+114599,int_stack+86879,int_stack+63779,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+56135,int_stack+16400,int_stack+14420,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+62075,int_stack+18776,int_stack+16400,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+69203,int_stack+62075,int_stack+56135,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81083,int_stack+21584,int_stack+18776,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+89507,int_stack+81083,int_stack+62075,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+146939,int_stack+89507,int_stack+69203,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+56135,int_stack+24860,int_stack+21584,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+56135,int_stack+81083,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+166739,int_stack+0,int_stack+89507,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+65963,int_stack+166739,int_stack+146939,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+146939,int_stack+28640,int_stack+24860,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+190499,int_stack+146939,int_stack+56135,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+210155,int_stack+190499,int_stack+0,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+238235,int_stack+210155,int_stack+166739,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+146939,int_stack+238235,int_stack+65963,36);
 /*--- compute (ip|mh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+188519,int_stack+146939,int_stack+114599,1155);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+35435,int_stack+32960,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+38405,int_stack+35435,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16335,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+56135,int_stack+41915,int_stack+38405,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66665,int_stack+56135,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84485,int_stack+66665,int_stack+16335,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+46010,int_stack+41915,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+12285,int_stack+0,int_stack+56135,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+109235,int_stack+12285,int_stack+66665,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+285539,int_stack+109235,int_stack+84485,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+56135,int_stack+50735,int_stack+46010,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+70310,int_stack+56135,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33345,int_stack+70310,int_stack+12285,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+322664,int_stack+33345,int_stack+109235,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+322664,int_stack+285539,45);
 /*--- compute (kp|mh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+285539,int_stack+0,int_stack+146939,1155);
 /*--- compute (id|mh) ---*/
 hrr1_build_id(Libint->AB,int_stack+410279,int_stack+285539,int_stack+188519,1155);
 return int_stack+410279;}
