/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idnf(Libint_t*, prim_data*);

  /* Computes quartets of (id|nf) integrals */

REALTYPE *hrr_order_idnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[7][10] = int_stack + 9520;
 Libint->vrr_classes[7][11] = int_stack + 11896;
 Libint->vrr_classes[7][12] = int_stack + 14704;
 Libint->vrr_classes[7][13] = int_stack + 17980;
 Libint->vrr_classes[8][10] = int_stack + 21760;
 Libint->vrr_classes[8][11] = int_stack + 24730;
 Libint->vrr_classes[8][12] = int_stack + 28240;
 Libint->vrr_classes[8][13] = int_stack + 32335;
 memset(int_stack,0,37060*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 37060;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idnf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37060,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+42604,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+49156,int_stack+42604,int_stack+37060,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+60244,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+67888,int_stack+60244,int_stack+42604,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+80992,int_stack+67888,int_stack+49156,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37060,int_stack+11896,int_stack+9520,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+44188,int_stack+14704,int_stack+11896,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+52612,int_stack+44188,int_stack+37060,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+66868,int_stack+17980,int_stack+14704,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+66868,int_stack+44188,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+99472,int_stack+0,int_stack+52612,36);
 /*--- compute (ip|nf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+123232,int_stack+99472,int_stack+80992,660);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+24730,int_stack+21760,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+28240,int_stack+24730,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+37060,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54880,int_stack+32335,int_stack+28240,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+67165,int_stack+54880,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+67165,int_stack+37060,45);
 /*--- compute (kp|nf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+178672,int_stack+0,int_stack+99472,660);
 /*--- compute (id|nf) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+178672,int_stack+123232,660);
 return int_stack+0;}
