/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ignm(Libint_t*, prim_data*);

  /* Computes quartets of (ig|nm) integrals */

REALTYPE *hrr_order_ignm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[6][19] = int_stack + 31080;
 Libint->vrr_classes[7][10] = int_stack + 36960;
 Libint->vrr_classes[7][11] = int_stack + 39336;
 Libint->vrr_classes[7][12] = int_stack + 42144;
 Libint->vrr_classes[7][13] = int_stack + 45420;
 Libint->vrr_classes[7][14] = int_stack + 49200;
 Libint->vrr_classes[7][15] = int_stack + 53520;
 Libint->vrr_classes[7][16] = int_stack + 58416;
 Libint->vrr_classes[7][17] = int_stack + 63924;
 Libint->vrr_classes[7][18] = int_stack + 70080;
 Libint->vrr_classes[7][19] = int_stack + 76920;
 Libint->vrr_classes[8][10] = int_stack + 84480;
 Libint->vrr_classes[8][11] = int_stack + 87450;
 Libint->vrr_classes[8][12] = int_stack + 90960;
 Libint->vrr_classes[8][13] = int_stack + 95055;
 Libint->vrr_classes[8][14] = int_stack + 99780;
 Libint->vrr_classes[8][15] = int_stack + 105180;
 Libint->vrr_classes[8][16] = int_stack + 111300;
 Libint->vrr_classes[8][17] = int_stack + 118185;
 Libint->vrr_classes[8][18] = int_stack + 125880;
 Libint->vrr_classes[8][19] = int_stack + 134430;
 Libint->vrr_classes[9][10] = int_stack + 143880;
 Libint->vrr_classes[9][11] = int_stack + 147510;
 Libint->vrr_classes[9][12] = int_stack + 151800;
 Libint->vrr_classes[9][13] = int_stack + 156805;
 Libint->vrr_classes[9][14] = int_stack + 162580;
 Libint->vrr_classes[9][15] = int_stack + 169180;
 Libint->vrr_classes[9][16] = int_stack + 176660;
 Libint->vrr_classes[9][17] = int_stack + 185075;
 Libint->vrr_classes[9][18] = int_stack + 194480;
 Libint->vrr_classes[9][19] = int_stack + 204930;
 Libint->vrr_classes[10][10] = int_stack + 216480;
 Libint->vrr_classes[10][11] = int_stack + 220836;
 Libint->vrr_classes[10][12] = int_stack + 225984;
 Libint->vrr_classes[10][13] = int_stack + 231990;
 Libint->vrr_classes[10][14] = int_stack + 238920;
 Libint->vrr_classes[10][15] = int_stack + 246840;
 Libint->vrr_classes[10][16] = int_stack + 255816;
 Libint->vrr_classes[10][17] = int_stack + 265914;
 Libint->vrr_classes[10][18] = int_stack + 277200;
 Libint->vrr_classes[10][19] = int_stack + 289740;
 memset(int_stack,0,303600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 303600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ignm(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+303600,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+309144,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+315696,int_stack+309144,int_stack+303600,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+326784,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+334428,int_stack+326784,int_stack+309144,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+347532,int_stack+334428,int_stack+315696,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+303600,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+366012,int_stack+303600,int_stack+326784,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+312420,int_stack+366012,int_stack+334428,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+381300,int_stack+312420,int_stack+347532,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+334260,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+344340,int_stack+334260,int_stack+303600,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+409020,int_stack+344340,int_stack+366012,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+434500,int_stack+409020,int_stack+312420,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+467260,int_stack+434500,int_stack+381300,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+303600,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+361980,int_stack+303600,int_stack+334260,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+506068,int_stack+361980,int_stack+344340,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+315024,int_stack+506068,int_stack+409020,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+382140,int_stack+315024,int_stack+434500,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+535468,int_stack+382140,int_stack+467260,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+428004,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+440856,int_stack+428004,int_stack+303600,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+463704,int_stack+440856,int_stack+361980,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+587212,int_stack+463704,int_stack+506068,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+631312,int_stack+587212,int_stack+315024,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+303600,int_stack+631312,int_stack+382140,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+684820,int_stack+303600,int_stack+535468,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+364752,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+379116,int_stack+364752,int_stack+428004,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+497304,int_stack+379116,int_stack+440856,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+404820,int_stack+497304,int_stack+463704,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+751348,int_stack+404820,int_stack+587212,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+535384,int_stack+751348,int_stack+631312,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+813088,int_stack+535384,int_stack+303600,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+891712,int_stack+813088,int_stack+684820,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+303600,int_stack+31080,int_stack+25760,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+319560,int_stack+303600,int_stack+364752,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+606728,int_stack+319560,int_stack+379116,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+303600,int_stack+606728,int_stack+497304,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+606728,int_stack+303600,int_stack+404820,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+303600,int_stack+606728,int_stack+751348,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+606728,int_stack+303600,int_stack+535384,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+303600,int_stack+606728,int_stack+813088,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+401880,int_stack+303600,int_stack+891712,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+303600,int_stack+39336,int_stack+36960,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+310728,int_stack+42144,int_stack+39336,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+319152,int_stack+310728,int_stack+303600,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+333408,int_stack+45420,int_stack+42144,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+343236,int_stack+333408,int_stack+310728,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+360084,int_stack+343236,int_stack+319152,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+303600,int_stack+49200,int_stack+45420,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+503520,int_stack+303600,int_stack+333408,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+314940,int_stack+503520,int_stack+343236,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+523176,int_stack+314940,int_stack+360084,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+343020,int_stack+53520,int_stack+49200,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+355980,int_stack+343020,int_stack+303600,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+558816,int_stack+355980,int_stack+503520,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+591576,int_stack+558816,int_stack+314940,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+633696,int_stack+591576,int_stack+523176,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+503520,int_stack+58416,int_stack+53520,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+518208,int_stack+503520,int_stack+343020,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+303600,int_stack+518208,int_stack+355980,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+341400,int_stack+303600,int_stack+558816,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+683592,int_stack+341400,int_stack+591576,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+544128,int_stack+683592,int_stack+633696,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+610656,int_stack+63924,int_stack+58416,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+627180,int_stack+610656,int_stack+503520,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+742560,int_stack+627180,int_stack+518208,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+785760,int_stack+742560,int_stack+303600,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+842460,int_stack+785760,int_stack+341400,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+303600,int_stack+842460,int_stack+683592,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+656556,int_stack+303600,int_stack+544128,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+382224,int_stack+70080,int_stack+63924,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+503520,int_stack+382224,int_stack+610656,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+536568,int_stack+503520,int_stack+627180,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+585528,int_stack+536568,int_stack+742560,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+911256,int_stack+585528,int_stack+785760,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+742092,int_stack+911256,int_stack+842460,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+990636,int_stack+742092,int_stack+303600,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1091724,int_stack+990636,int_stack+656556,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+303600,int_stack+76920,int_stack+70080,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+324120,int_stack+303600,int_stack+382224,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+650328,int_stack+324120,int_stack+503520,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+303600,int_stack+650328,int_stack+536568,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+650328,int_stack+303600,int_stack+585528,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+503520,int_stack+650328,int_stack+911256,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+609360,int_stack+503520,int_stack+742092,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+727296,int_stack+609360,int_stack+990636,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+503520,int_stack+727296,int_stack+1091724,36);
 /*--- compute (ip|nm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+634200,int_stack+503520,int_stack+401880,3630);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+939120,int_stack+87450,int_stack+84480,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+948030,int_stack+90960,int_stack+87450,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+958560,int_stack+948030,int_stack+939120,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+976380,int_stack+95055,int_stack+90960,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+988665,int_stack+976380,int_stack+948030,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1009725,int_stack+988665,int_stack+958560,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+939120,int_stack+99780,int_stack+95055,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1039425,int_stack+939120,int_stack+976380,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+953295,int_stack+1039425,int_stack+988665,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1063995,int_stack+953295,int_stack+1009725,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+988395,int_stack+105180,int_stack+99780,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1004595,int_stack+988395,int_stack+939120,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1108545,int_stack+1004595,int_stack+1039425,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+303600,int_stack+1108545,int_stack+953295,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+356250,int_stack+303600,int_stack+1063995,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+939120,int_stack+111300,int_stack+105180,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1032945,int_stack+939120,int_stack+988395,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1149495,int_stack+1032945,int_stack+1004595,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+957480,int_stack+1149495,int_stack+1108545,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1065345,int_stack+957480,int_stack+303600,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+418620,int_stack+1065345,int_stack+356250,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+303600,int_stack+118185,int_stack+111300,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+324255,int_stack+303600,int_stack+939120,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+360975,int_stack+324255,int_stack+1032945,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+360975,int_stack+1149495,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1139055,int_stack+0,int_stack+957480,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+939120,int_stack+1139055,int_stack+1065345,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1225050,int_stack+939120,int_stack+418620,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1037400,int_stack+125880,int_stack+118185,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1060485,int_stack+1037400,int_stack+303600,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+414975,int_stack+1060485,int_stack+324255,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1331970,int_stack+414975,int_stack+360975,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+303600,int_stack+1331970,int_stack+0,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+303600,int_stack+1139055,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1412970,int_stack+0,int_stack+939120,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1539330,int_stack+1412970,int_stack+1225050,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+939120,int_stack+134430,int_stack+125880,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+964770,int_stack+939120,int_stack+1037400,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1101795,int_stack+964770,int_stack+1060485,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+939120,int_stack+1101795,int_stack+414975,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1030920,int_stack+939120,int_stack+1331970,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1144320,int_stack+1030920,int_stack+303600,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+303600,int_stack+1144320,int_stack+0,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+939120,int_stack+303600,int_stack+1412970,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+303600,int_stack+939120,int_stack+1539330,45);
 /*--- compute (kp|nm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+939120,int_stack+303600,int_stack+503520,3630);
 /*--- compute (id|nm) ---*/
 hrr1_build_id(Libint->AB,int_stack+1331160,int_stack+939120,int_stack+634200,3630);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+466950,int_stack+147510,int_stack+143880,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+477840,int_stack+151800,int_stack+147510,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+490710,int_stack+477840,int_stack+466950,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+512490,int_stack+156805,int_stack+151800,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+527505,int_stack+512490,int_stack+477840,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+553245,int_stack+527505,int_stack+490710,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+466950,int_stack+162580,int_stack+156805,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+589545,int_stack+466950,int_stack+512490,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+484275,int_stack+589545,int_stack+527505,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+619575,int_stack+484275,int_stack+553245,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+527175,int_stack+169180,int_stack+162580,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+546975,int_stack+527175,int_stack+466950,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+674025,int_stack+546975,int_stack+589545,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+724075,int_stack+674025,int_stack+484275,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+788425,int_stack+724075,int_stack+619575,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+466950,int_stack+176660,int_stack+169180,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+581625,int_stack+466950,int_stack+527175,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+864655,int_stack+581625,int_stack+546975,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+489390,int_stack+864655,int_stack+674025,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+621225,int_stack+489390,int_stack+724075,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+621225,int_stack+788425,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+711315,int_stack+185075,int_stack+176660,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+736560,int_stack+711315,int_stack+466950,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+781440,int_stack+736560,int_stack+581625,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1941000,int_stack+781440,int_stack+864655,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2027625,int_stack+1941000,int_stack+489390,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+466950,int_stack+2027625,int_stack+621225,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2132730,int_stack+466950,int_stack+0,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+194480,int_stack+185075,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+28215,int_stack+0,int_stack+711315,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+78705,int_stack+28215,int_stack+736560,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+587070,int_stack+78705,int_stack+781440,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+686070,int_stack+587070,int_stack+1941000,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2263410,int_stack+686070,int_stack+2027625,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1941000,int_stack+2263410,int_stack+466950,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2403550,int_stack+1941000,int_stack+2132730,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+466950,int_stack+204930,int_stack+194480,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+498300,int_stack+466950,int_stack+0,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2095440,int_stack+498300,int_stack+28215,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+466950,int_stack+2095440,int_stack+78705,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2095440,int_stack+466950,int_stack+587070,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+466950,int_stack+2095440,int_stack+686070,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+628650,int_stack+466950,int_stack+2263410,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2095440,int_stack+628650,int_stack+1941000,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+466950,int_stack+2095440,int_stack+2403550,55);
 /*--- compute (lp|nm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1941000,int_stack+466950,int_stack+303600,3630);
 /*--- compute (kd|nm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2431050,int_stack+1941000,int_stack+939120,3630);
 /*--- compute (if|nm) ---*/
 hrr1_build_if(Libint->AB,int_stack+3215130,int_stack+2431050,int_stack+1331160,3630);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+303600,int_stack+220836,int_stack+216480,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+316668,int_stack+225984,int_stack+220836,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+332112,int_stack+316668,int_stack+303600,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+358248,int_stack+231990,int_stack+225984,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+376266,int_stack+358248,int_stack+316668,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+407154,int_stack+376266,int_stack+332112,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+303600,int_stack+238920,int_stack+231990,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+666600,int_stack+303600,int_stack+358248,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+324390,int_stack+666600,int_stack+376266,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+702636,int_stack+324390,int_stack+407154,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+375870,int_stack+246840,int_stack+238920,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+399630,int_stack+375870,int_stack+303600,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+767976,int_stack+399630,int_stack+666600,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+828036,int_stack+767976,int_stack+324390,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+905256,int_stack+828036,int_stack+702636,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+666600,int_stack+255816,int_stack+246840,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+693528,int_stack+666600,int_stack+375870,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+303600,int_stack+693528,int_stack+399630,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+372900,int_stack+303600,int_stack+767976,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+996732,int_stack+372900,int_stack+828036,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+741048,int_stack+996732,int_stack+905256,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+863016,int_stack+265914,int_stack+255816,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+893310,int_stack+863016,int_stack+666600,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1104840,int_stack+893310,int_stack+693528,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1184040,int_stack+1104840,int_stack+303600,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1287990,int_stack+1184040,int_stack+372900,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+303600,int_stack+1287990,int_stack+996732,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+947166,int_stack+303600,int_stack+741048,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+666600,int_stack+277200,int_stack+265914,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+700458,int_stack+666600,int_stack+863016,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+761046,int_stack+700458,int_stack+893310,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1414116,int_stack+761046,int_stack+1104840,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1532916,int_stack+1414116,int_stack+1184040,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1103982,int_stack+1532916,int_stack+1287990,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1678446,int_stack+1103982,int_stack+303600,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1678446,int_stack+947166,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+303600,int_stack+289740,int_stack+277200,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+341220,int_stack+303600,int_stack+666600,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+850806,int_stack+341220,int_stack+700458,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+951786,int_stack+850806,int_stack+761046,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+666600,int_stack+951786,int_stack+1414116,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+832920,int_stack+666600,int_stack+1532916,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1272150,int_stack+832920,int_stack+1103982,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+666600,int_stack+1272150,int_stack+1678446,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+898260,int_stack+666600,int_stack+0,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1137840,int_stack+898260,int_stack+466950,3630);
 /*--- compute (ld|nm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+1137840,int_stack+1941000,3630);
 /*--- compute (kf|nm) ---*/
 hrr1_build_kf(Libint->AB,int_stack+980100,int_stack+0,int_stack+2431050,3630);
 /*--- compute (ig|nm) ---*/
 hrr1_build_ig(Libint->AB,int_stack+4231530,int_stack+980100,int_stack+3215130,3630);
 return int_stack+4231530;}
