/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ignn(Libint_t*, prim_data*);

  /* Computes quartets of (ig|nn) integrals */

REALTYPE *hrr_order_ignn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[6][19] = int_stack + 31080;
 Libint->vrr_classes[6][20] = int_stack + 36960;
 Libint->vrr_classes[7][10] = int_stack + 43428;
 Libint->vrr_classes[7][11] = int_stack + 45804;
 Libint->vrr_classes[7][12] = int_stack + 48612;
 Libint->vrr_classes[7][13] = int_stack + 51888;
 Libint->vrr_classes[7][14] = int_stack + 55668;
 Libint->vrr_classes[7][15] = int_stack + 59988;
 Libint->vrr_classes[7][16] = int_stack + 64884;
 Libint->vrr_classes[7][17] = int_stack + 70392;
 Libint->vrr_classes[7][18] = int_stack + 76548;
 Libint->vrr_classes[7][19] = int_stack + 83388;
 Libint->vrr_classes[7][20] = int_stack + 90948;
 Libint->vrr_classes[8][10] = int_stack + 99264;
 Libint->vrr_classes[8][11] = int_stack + 102234;
 Libint->vrr_classes[8][12] = int_stack + 105744;
 Libint->vrr_classes[8][13] = int_stack + 109839;
 Libint->vrr_classes[8][14] = int_stack + 114564;
 Libint->vrr_classes[8][15] = int_stack + 119964;
 Libint->vrr_classes[8][16] = int_stack + 126084;
 Libint->vrr_classes[8][17] = int_stack + 132969;
 Libint->vrr_classes[8][18] = int_stack + 140664;
 Libint->vrr_classes[8][19] = int_stack + 149214;
 Libint->vrr_classes[8][20] = int_stack + 158664;
 Libint->vrr_classes[9][10] = int_stack + 169059;
 Libint->vrr_classes[9][11] = int_stack + 172689;
 Libint->vrr_classes[9][12] = int_stack + 176979;
 Libint->vrr_classes[9][13] = int_stack + 181984;
 Libint->vrr_classes[9][14] = int_stack + 187759;
 Libint->vrr_classes[9][15] = int_stack + 194359;
 Libint->vrr_classes[9][16] = int_stack + 201839;
 Libint->vrr_classes[9][17] = int_stack + 210254;
 Libint->vrr_classes[9][18] = int_stack + 219659;
 Libint->vrr_classes[9][19] = int_stack + 230109;
 Libint->vrr_classes[9][20] = int_stack + 241659;
 Libint->vrr_classes[10][10] = int_stack + 254364;
 Libint->vrr_classes[10][11] = int_stack + 258720;
 Libint->vrr_classes[10][12] = int_stack + 263868;
 Libint->vrr_classes[10][13] = int_stack + 269874;
 Libint->vrr_classes[10][14] = int_stack + 276804;
 Libint->vrr_classes[10][15] = int_stack + 284724;
 Libint->vrr_classes[10][16] = int_stack + 293700;
 Libint->vrr_classes[10][17] = int_stack + 303798;
 Libint->vrr_classes[10][18] = int_stack + 315084;
 Libint->vrr_classes[10][19] = int_stack + 327624;
 Libint->vrr_classes[10][20] = int_stack + 341484;
 memset(int_stack,0,356730*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 356730;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ignn(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+356730,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+362274,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+368826,int_stack+362274,int_stack+356730,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+379914,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+387558,int_stack+379914,int_stack+362274,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+400662,int_stack+387558,int_stack+368826,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+356730,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+419142,int_stack+356730,int_stack+379914,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+365550,int_stack+419142,int_stack+387558,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+434430,int_stack+365550,int_stack+400662,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+387390,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+397470,int_stack+387390,int_stack+356730,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+462150,int_stack+397470,int_stack+419142,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+487630,int_stack+462150,int_stack+365550,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+520390,int_stack+487630,int_stack+434430,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+356730,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+415110,int_stack+356730,int_stack+387390,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+559198,int_stack+415110,int_stack+397470,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+368154,int_stack+559198,int_stack+462150,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+435270,int_stack+368154,int_stack+487630,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+588598,int_stack+435270,int_stack+520390,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+481134,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+493986,int_stack+481134,int_stack+356730,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+516834,int_stack+493986,int_stack+415110,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+640342,int_stack+516834,int_stack+559198,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+684442,int_stack+640342,int_stack+368154,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+356730,int_stack+684442,int_stack+435270,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+737950,int_stack+356730,int_stack+588598,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+417882,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+432246,int_stack+417882,int_stack+481134,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+550434,int_stack+432246,int_stack+493986,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+457950,int_stack+550434,int_stack+516834,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+804478,int_stack+457950,int_stack+640342,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+588514,int_stack+804478,int_stack+684442,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+866218,int_stack+588514,int_stack+356730,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+944842,int_stack+866218,int_stack+737950,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+356730,int_stack+31080,int_stack+25760,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+372690,int_stack+356730,int_stack+417882,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+659858,int_stack+372690,int_stack+432246,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+702698,int_stack+659858,int_stack+550434,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+508350,int_stack+702698,int_stack+457950,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+401418,int_stack+508350,int_stack+804478,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+759818,int_stack+401418,int_stack+588514,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1028002,int_stack+759818,int_stack+866218,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1126282,int_stack+1028002,int_stack+944842,28);
 /*--- compute (i0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+483738,int_stack+36960,int_stack+31080,28);
 /*--- compute (i0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+578910,int_stack+483738,int_stack+356730,28);
 /*--- compute (i0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+610830,int_stack+578910,int_stack+372690,28);
 /*--- compute (i0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+851546,int_stack+610830,int_stack+659858,28);
 /*--- compute (i0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+578910,int_stack+851546,int_stack+702698,28);
 /*--- compute (i0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+851546,int_stack+578910,int_stack+508350,28);
 /*--- compute (i0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+483738,int_stack+851546,int_stack+401418,28);
 /*--- compute (i0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+851546,int_stack+483738,int_stack+759818,28);
 /*--- compute (i0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+356730,int_stack+851546,int_stack+1028002,28);
 /*--- compute (i0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+476850,int_stack+356730,int_stack+1126282,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+356730,int_stack+45804,int_stack+43428,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+363858,int_stack+48612,int_stack+45804,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+372282,int_stack+363858,int_stack+356730,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+386538,int_stack+51888,int_stack+48612,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+396366,int_stack+386538,int_stack+363858,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+413214,int_stack+396366,int_stack+372282,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+356730,int_stack+55668,int_stack+51888,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+436974,int_stack+356730,int_stack+386538,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+368070,int_stack+436974,int_stack+396366,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+598818,int_stack+368070,int_stack+413214,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+396150,int_stack+59988,int_stack+55668,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+409110,int_stack+396150,int_stack+356730,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+634458,int_stack+409110,int_stack+436974,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+431790,int_stack+634458,int_stack+368070,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+667218,int_stack+431790,int_stack+598818,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+598818,int_stack+64884,int_stack+59988,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+356730,int_stack+598818,int_stack+396150,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+717114,int_stack+356730,int_stack+409110,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+382650,int_stack+717114,int_stack+634458,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+754914,int_stack+382650,int_stack+431790,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+813882,int_stack+754914,int_stack+667218,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+431790,int_stack+70392,int_stack+64884,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+613506,int_stack+431790,int_stack+598818,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+642882,int_stack+613506,int_stack+356730,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+880410,int_stack+642882,int_stack+717114,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+686082,int_stack+880410,int_stack+382650,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+937110,int_stack+686082,int_stack+754914,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1015734,int_stack+937110,int_stack+813882,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+356730,int_stack+76548,int_stack+70392,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+375198,int_stack+356730,int_stack+431790,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+408246,int_stack+375198,int_stack+613506,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+754878,int_stack+408246,int_stack+642882,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+598818,int_stack+754878,int_stack+880410,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+819678,int_stack+598818,int_stack+686082,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1101270,int_stack+819678,int_stack+937110,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1202358,int_stack+1101270,int_stack+1015734,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+678198,int_stack+83388,int_stack+76548,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+698718,int_stack+678198,int_stack+356730,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+911406,int_stack+698718,int_stack+375198,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+966486,int_stack+911406,int_stack+408246,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+356730,int_stack+966486,int_stack+754878,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1309278,int_stack+356730,int_stack+598818,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1415118,int_stack+1309278,int_stack+819678,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+735654,int_stack+1415118,int_stack+1101270,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1039926,int_stack+735654,int_stack+1202358,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+598818,int_stack+90948,int_stack+83388,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+621498,int_stack+598818,int_stack+678198,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1170606,int_stack+621498,int_stack+698718,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+598818,int_stack+1170606,int_stack+911406,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1170606,int_stack+598818,int_stack+966486,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+598818,int_stack+1170606,int_stack+356730,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1170606,int_stack+598818,int_stack+1309278,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+862014,int_stack+1170606,int_stack+1415118,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1170606,int_stack+862014,int_stack+735654,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1325046,int_stack+1170606,int_stack+1039926,36);
 /*--- compute (ip|nn) ---*/
 hrr1_build_ip(Libint->AB,int_stack+598818,int_stack+1325046,int_stack+476850,4356);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1481862,int_stack+102234,int_stack+99264,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1490772,int_stack+105744,int_stack+102234,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1501302,int_stack+1490772,int_stack+1481862,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1519122,int_stack+109839,int_stack+105744,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+964722,int_stack+1519122,int_stack+1490772,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+985782,int_stack+964722,int_stack+1501302,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1481862,int_stack+114564,int_stack+109839,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1015482,int_stack+1481862,int_stack+1519122,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1496037,int_stack+1015482,int_stack+964722,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1040052,int_stack+1496037,int_stack+985782,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+964722,int_stack+119964,int_stack+114564,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+980922,int_stack+964722,int_stack+1481862,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1084602,int_stack+980922,int_stack+1015482,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1125552,int_stack+1084602,int_stack+1496037,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1178202,int_stack+1125552,int_stack+1040052,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1481862,int_stack+126084,int_stack+119964,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1500222,int_stack+1481862,int_stack+964722,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1009272,int_stack+1500222,int_stack+980922,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1240572,int_stack+1009272,int_stack+1084602,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+356730,int_stack+1240572,int_stack+1125552,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1056522,int_stack+356730,int_stack+1178202,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+964722,int_stack+132969,int_stack+126084,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1139682,int_stack+964722,int_stack+1481862,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1176402,int_stack+1139682,int_stack+1500222,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+430440,int_stack+1176402,int_stack+1009272,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+501315,int_stack+430440,int_stack+1240572,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+501315,int_stack+356730,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1481862,int_stack+0,int_stack+1056522,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+356730,int_stack+140664,int_stack+132969,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+379815,int_stack+356730,int_stack+964722,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+964722,int_stack+379815,int_stack+1139682,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1025922,int_stack+964722,int_stack+1176402,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1106922,int_stack+1025922,int_stack+430440,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1206147,int_stack+1106922,int_stack+501315,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+421125,int_stack+1206147,int_stack+0,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+421125,int_stack+1481862,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1481862,int_stack+149214,int_stack+140664,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1507512,int_stack+1481862,int_stack+356730,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1553682,int_stack+1507512,int_stack+379815,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1622532,int_stack+1553682,int_stack+964722,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1714332,int_stack+1622532,int_stack+1025922,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+964722,int_stack+1714332,int_stack+1106922,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1827732,int_stack+964722,int_stack+1206147,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1097022,int_stack+1827732,int_stack+421125,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+356730,int_stack+1097022,int_stack+0,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+158664,int_stack+149214,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+28350,int_stack+0,int_stack+1481862,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+79650,int_stack+28350,int_stack+1507512,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1975152,int_stack+79650,int_stack+1553682,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1481862,int_stack+1975152,int_stack+1622532,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+0,int_stack+1481862,int_stack+1714332,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1481862,int_stack+0,int_stack+964722,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1975152,int_stack+1481862,int_stack+1827732,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1481862,int_stack+1975152,int_stack+1097022,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1674912,int_stack+1481862,int_stack+356730,45);
 /*--- compute (kp|nn) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1870932,int_stack+1674912,int_stack+1325046,4356);
 /*--- compute (id|nn) ---*/
 hrr1_build_id(Libint->AB,int_stack+2341380,int_stack+1870932,int_stack+598818,4356);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+356730,int_stack+172689,int_stack+169059,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+367620,int_stack+176979,int_stack+172689,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+380490,int_stack+367620,int_stack+356730,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+402270,int_stack+181984,int_stack+176979,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+417285,int_stack+402270,int_stack+367620,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+443025,int_stack+417285,int_stack+380490,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+356730,int_stack+187759,int_stack+181984,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+479325,int_stack+356730,int_stack+402270,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+374055,int_stack+479325,int_stack+417285,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+509355,int_stack+374055,int_stack+443025,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+416955,int_stack+194359,int_stack+187759,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+436755,int_stack+416955,int_stack+356730,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+563805,int_stack+436755,int_stack+479325,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+613855,int_stack+563805,int_stack+374055,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+678205,int_stack+613855,int_stack+509355,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+356730,int_stack+201839,int_stack+194359,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+471405,int_stack+356730,int_stack+416955,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+754435,int_stack+471405,int_stack+436755,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+379170,int_stack+754435,int_stack+563805,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+511005,int_stack+379170,int_stack+613855,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+812185,int_stack+511005,int_stack+678205,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+601095,int_stack+210254,int_stack+201839,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+626340,int_stack+601095,int_stack+356730,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+671220,int_stack+626340,int_stack+471405,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+913825,int_stack+671220,int_stack+754435,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1000450,int_stack+913825,int_stack+379170,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+356730,int_stack+1000450,int_stack+511005,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1105555,int_stack+356730,int_stack+812185,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+476850,int_stack+219659,int_stack+210254,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+505065,int_stack+476850,int_stack+601095,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+737220,int_stack+505065,int_stack+626340,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+555555,int_stack+737220,int_stack+671220,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1236235,int_stack+555555,int_stack+913825,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+812020,int_stack+1236235,int_stack+1000450,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1357510,int_stack+812020,int_stack+356730,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1357510,int_stack+1105555,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+356730,int_stack+230109,int_stack+219659,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+388080,int_stack+356730,int_stack+476850,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+952160,int_stack+388080,int_stack+505065,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1036310,int_stack+952160,int_stack+737220,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+654555,int_stack+1036310,int_stack+555555,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+444510,int_stack+654555,int_stack+1236235,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1148510,int_stack+444510,int_stack+812020,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3073188,int_stack+1148510,int_stack+1357510,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1328690,int_stack+3073188,int_stack+0,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+241659,int_stack+230109,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+34650,int_stack+0,int_stack+356730,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+97350,int_stack+34650,int_stack+388080,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+793155,int_stack+97350,int_stack+952160,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+793155,int_stack+1036310,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+793155,int_stack+0,int_stack+654555,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+793155,int_stack+444510,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+356730,int_stack+0,int_stack+1148510,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+356730,int_stack+3073188,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+356730,int_stack+0,int_stack+1328690,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+596310,int_stack+356730,int_stack+1674912,4356);
 /*--- compute (kd|nn) ---*/
 hrr1_build_kd(Libint->AB,int_stack+3073188,int_stack+596310,int_stack+1870932,4356);
 /*--- compute (if|nn) ---*/
 hrr1_build_if(Libint->AB,int_stack+4014084,int_stack+3073188,int_stack+2341380,4356);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+258720,int_stack+254364,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+263868,int_stack+258720,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+269874,int_stack+263868,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72666,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+103554,int_stack+72666,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+276804,int_stack+269874,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+147114,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+147114,int_stack+72666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+183150,int_stack+20790,int_stack+103554,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+72270,int_stack+284724,int_stack+276804,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+96030,int_stack+72270,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1184370,int_stack+96030,int_stack+147114,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1244430,int_stack+1184370,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1321650,int_stack+1244430,int_stack+183150,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+293700,int_stack+284724,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+137610,int_stack+0,int_stack+72270,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+185130,int_stack+137610,int_stack+96030,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+26928,int_stack+185130,int_stack+1184370,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1413126,int_stack+26928,int_stack+1244430,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1184370,int_stack+1413126,int_stack+1321650,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1306338,int_stack+303798,int_stack+293700,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1336632,int_stack+1306338,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1521234,int_stack+1336632,int_stack+137610,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1600434,int_stack+1521234,int_stack+185130,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+117018,int_stack+1600434,int_stack+26928,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1704384,int_stack+117018,int_stack+1413126,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1848528,int_stack+1704384,int_stack+1184370,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1184370,int_stack+315084,int_stack+303798,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1218228,int_stack+1184370,int_stack+1306338,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1218228,int_stack+1336632,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1278816,int_stack+0,int_stack+1521234,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1397616,int_stack+1278816,int_stack+1600434,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2005344,int_stack+1397616,int_stack+117018,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+89760,int_stack+2005344,int_stack+1704384,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1543146,int_stack+89760,int_stack+1848528,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1739166,int_stack+327624,int_stack+315084,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1776786,int_stack+1739166,int_stack+1184370,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1844502,int_stack+1776786,int_stack+1218228,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2173512,int_stack+1844502,int_stack+0,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2308152,int_stack+2173512,int_stack+1278816,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1184370,int_stack+2308152,int_stack+1397616,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2474472,int_stack+1184370,int_stack+2005344,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2690688,int_stack+2474472,int_stack+89760,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+2690688,int_stack+1543146,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+239580,int_stack+341484,int_stack+327624,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+281160,int_stack+239580,int_stack+1739166,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1378410,int_stack+281160,int_stack+1776786,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1491270,int_stack+1378410,int_stack+1844502,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1642740,int_stack+1491270,int_stack+2173512,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1378410,int_stack+1642740,int_stack+2308152,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1600170,int_stack+1378410,int_stack+1184370,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1184370,int_stack+1600170,int_stack+2474472,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1454640,int_stack+1184370,int_stack+2690688,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1737780,int_stack+1454640,int_stack+0,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2025276,int_stack+1737780,int_stack+356730,4356);
 /*--- compute (ld|nn) ---*/
 hrr1_build_ld(Libint->AB,int_stack+5233764,int_stack+2025276,int_stack+596310,4356);
 /*--- compute (kf|nn) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+5233764,int_stack+3073188,4356);
 /*--- compute (ig|nn) ---*/
 hrr1_build_ig(Libint->AB,int_stack+1568160,int_stack+0,int_stack+4014084,4356);
 return int_stack+1568160;}
