/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihii(Libint_t*, prim_data*);

  /* Computes quartets of (ih|ii) integrals */

REALTYPE *hrr_order_ihii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[6][10] = int_stack + 4592;
 Libint->vrr_classes[6][11] = int_stack + 6440;
 Libint->vrr_classes[6][12] = int_stack + 8624;
 Libint->vrr_classes[7][6] = int_stack + 11172;
 Libint->vrr_classes[7][7] = int_stack + 12180;
 Libint->vrr_classes[7][8] = int_stack + 13476;
 Libint->vrr_classes[7][9] = int_stack + 15096;
 Libint->vrr_classes[7][10] = int_stack + 17076;
 Libint->vrr_classes[7][11] = int_stack + 19452;
 Libint->vrr_classes[7][12] = int_stack + 22260;
 Libint->vrr_classes[8][6] = int_stack + 25536;
 Libint->vrr_classes[8][7] = int_stack + 26796;
 Libint->vrr_classes[8][8] = int_stack + 28416;
 Libint->vrr_classes[8][9] = int_stack + 30441;
 Libint->vrr_classes[8][10] = int_stack + 32916;
 Libint->vrr_classes[8][11] = int_stack + 35886;
 Libint->vrr_classes[8][12] = int_stack + 39396;
 Libint->vrr_classes[9][6] = int_stack + 43491;
 Libint->vrr_classes[9][7] = int_stack + 45031;
 Libint->vrr_classes[9][8] = int_stack + 47011;
 Libint->vrr_classes[9][9] = int_stack + 49486;
 Libint->vrr_classes[9][10] = int_stack + 52511;
 Libint->vrr_classes[9][11] = int_stack + 56141;
 Libint->vrr_classes[9][12] = int_stack + 60431;
 Libint->vrr_classes[10][6] = int_stack + 65436;
 Libint->vrr_classes[10][7] = int_stack + 67284;
 Libint->vrr_classes[10][8] = int_stack + 69660;
 Libint->vrr_classes[10][9] = int_stack + 72630;
 Libint->vrr_classes[10][10] = int_stack + 76260;
 Libint->vrr_classes[10][11] = int_stack + 80616;
 Libint->vrr_classes[10][12] = int_stack + 85764;
 Libint->vrr_classes[11][6] = int_stack + 91770;
 Libint->vrr_classes[11][7] = int_stack + 93954;
 Libint->vrr_classes[11][8] = int_stack + 96762;
 Libint->vrr_classes[11][9] = int_stack + 100272;
 Libint->vrr_classes[11][10] = int_stack + 104562;
 Libint->vrr_classes[11][11] = int_stack + 109710;
 Libint->vrr_classes[11][12] = int_stack + 115794;
 memset(int_stack,0,122892*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 122892;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihii(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+122892,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+125244,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+128268,int_stack+125244,int_stack+122892,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+132972,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+136752,int_stack+132972,int_stack+125244,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+142800,int_stack+136752,int_stack+128268,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+122892,int_stack+4592,int_stack+3052,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+150640,int_stack+122892,int_stack+132972,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+158200,int_stack+150640,int_stack+136752,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+127512,int_stack+158200,int_stack+142800,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+139272,int_stack+6440,int_stack+4592,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+168280,int_stack+139272,int_stack+122892,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+177520,int_stack+168280,int_stack+150640,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+190120,int_stack+177520,int_stack+158200,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+144816,int_stack+190120,int_stack+127512,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+122892,int_stack+8624,int_stack+6440,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+122892,int_stack+139272,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+122892,int_stack+0,int_stack+168280,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+205240,int_stack+122892,int_stack+177520,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+122892,int_stack+205240,int_stack+190120,28);
 /*--- compute (i0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+161280,int_stack+122892,int_stack+144816,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+122892,int_stack+12180,int_stack+11172,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+125916,int_stack+13476,int_stack+12180,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+129804,int_stack+125916,int_stack+122892,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+135852,int_stack+15096,int_stack+13476,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+140712,int_stack+135852,int_stack+125916,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+148488,int_stack+140712,int_stack+129804,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+122892,int_stack+17076,int_stack+15096,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+122892,int_stack+135852,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+183232,int_stack+0,int_stack+140712,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+128832,int_stack+183232,int_stack+148488,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+143952,int_stack+19452,int_stack+17076,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+196192,int_stack+143952,int_stack+122892,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+208072,int_stack+196192,int_stack+0,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+208072,int_stack+183232,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+224272,int_stack+0,int_stack+128832,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+183232,int_stack+22260,int_stack+19452,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+122892,int_stack+183232,int_stack+143952,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+137148,int_stack+122892,int_stack+196192,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+183232,int_stack+137148,int_stack+208072,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+122892,int_stack+183232,int_stack+0,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+183232,int_stack+122892,int_stack+224272,36);
 /*--- compute (ip|ii) ---*/
 hrr1_build_ip(Libint->AB,int_stack+211456,int_stack+183232,int_stack+161280,784);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+122892,int_stack+26796,int_stack+25536,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+126672,int_stack+28416,int_stack+26796,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+131532,int_stack+126672,int_stack+122892,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+139092,int_stack+30441,int_stack+28416,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+145167,int_stack+139092,int_stack+126672,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+154887,int_stack+145167,int_stack+131532,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+122892,int_stack+32916,int_stack+30441,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+167487,int_stack+122892,int_stack+139092,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+167487,int_stack+145167,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+130317,int_stack+0,int_stack+154887,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149217,int_stack+35886,int_stack+32916,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16200,int_stack+149217,int_stack+122892,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+277312,int_stack+16200,int_stack+167487,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+158127,int_stack+277312,int_stack+0,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+297562,int_stack+158127,int_stack+130317,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+39396,int_stack+35886,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+122892,int_stack+0,int_stack+149217,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+324022,int_stack+122892,int_stack+16200,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+122892,int_stack+324022,int_stack+277312,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+122892,int_stack+158127,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+122892,int_stack+0,int_stack+297562,45);
 /*--- compute (kp|ii) ---*/
 hrr1_build_kp(Libint->AB,int_stack+277312,int_stack+122892,int_stack+183232,784);
 /*--- compute (id|ii) ---*/
 hrr1_build_id(Libint->AB,int_stack+361984,int_stack+277312,int_stack+211456,784);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+45031,int_stack+43491,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+4620,int_stack+47011,int_stack+45031,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10560,int_stack+4620,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19800,int_stack+49486,int_stack+47011,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+27225,int_stack+19800,int_stack+4620,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+158172,int_stack+27225,int_stack+10560,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+52511,int_stack+49486,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+173572,int_stack+0,int_stack+19800,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+188422,int_stack+173572,int_stack+27225,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+9075,int_stack+188422,int_stack+158172,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+158172,int_stack+56141,int_stack+52511,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+32175,int_stack+158172,int_stack+0,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+208222,int_stack+32175,int_stack+173572,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+232972,int_stack+208222,int_stack+188422,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+169062,int_stack+232972,int_stack+9075,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+60431,int_stack+56141,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+493696,int_stack+0,int_stack+158172,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+493696,int_stack+32175,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+493696,int_stack+0,int_stack+208222,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+493696,int_stack+232972,55);
 /*--- compute (m0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+201402,int_stack+0,int_stack+169062,55);
 /*--- compute (lp|ii) ---*/
 hrr1_build_lp(Libint->AB,int_stack+493696,int_stack+201402,int_stack+122892,784);
 /*--- compute (kd|ii) ---*/
 hrr1_build_kd(Libint->AB,int_stack+599536,int_stack+493696,int_stack+277312,784);
 /*--- compute (if|ii) ---*/
 hrr1_build_if(Libint->AB,int_stack+768880,int_stack+599536,int_stack+361984,784);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+122892,int_stack+67284,int_stack+65436,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+128436,int_stack+69660,int_stack+67284,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+135564,int_stack+128436,int_stack+122892,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+146652,int_stack+72630,int_stack+69660,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+155562,int_stack+146652,int_stack+128436,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+169818,int_stack+155562,int_stack+135564,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+122892,int_stack+76260,int_stack+72630,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+122892,int_stack+146652,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+17820,int_stack+0,int_stack+155562,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+133782,int_stack+17820,int_stack+169818,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161502,int_stack+80616,int_stack+76260,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+174570,int_stack+161502,int_stack+122892,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+41580,int_stack+174570,int_stack+0,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+244522,int_stack+41580,int_stack+17820,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+244522,int_stack+133782,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+122892,int_stack+85764,int_stack+80616,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+280162,int_stack+122892,int_stack+161502,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+122892,int_stack+280162,int_stack+174570,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+280162,int_stack+122892,int_stack+41580,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+122892,int_stack+280162,int_stack+244522,66);
 /*--- compute (n0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+244522,int_stack+122892,int_stack+0,66);
 /*--- compute (mp|ii) ---*/
 hrr1_build_mp(Libint->AB,int_stack+296266,int_stack+244522,int_stack+201402,784);
 /*--- compute (ld|ii) ---*/
 hrr1_build_ld(Libint->AB,int_stack+988400,int_stack+296266,int_stack+493696,784);
 /*--- compute (kf|ii) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1200080,int_stack+988400,int_stack+599536,784);
 /*--- compute (ig|ii) ---*/
 hrr1_build_ig(Libint->AB,int_stack+425626,int_stack+1200080,int_stack+768880,784);
 /*--- compute (o0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+93954,int_stack+91770,78);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+6552,int_stack+96762,int_stack+93954,78);
 /*--- compute (o0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+14976,int_stack+6552,int_stack+0,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28080,int_stack+100272,int_stack+96762,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+38610,int_stack+28080,int_stack+6552,78);
 /*--- compute (o0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+55458,int_stack+38610,int_stack+14976,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+104562,int_stack+100272,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+77298,int_stack+0,int_stack+28080,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+122892,int_stack+77298,int_stack+38610,78);
 /*--- compute (o0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+12870,int_stack+122892,int_stack+55458,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45630,int_stack+109710,int_stack+104562,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+150972,int_stack+45630,int_stack+0,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+176712,int_stack+150972,int_stack+77298,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+61074,int_stack+176712,int_stack+122892,78);
 /*--- compute (o0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+754906,int_stack+61074,int_stack+12870,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+122892,int_stack+115794,int_stack+109710,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+122892,int_stack+45630,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103194,int_stack+0,int_stack+150972,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+103194,int_stack+176712,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+103194,int_stack+0,int_stack+61074,78);
 /*--- compute (o0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+0,int_stack+103194,int_stack+754906,78);
 /*--- compute (np|ii) ---*/
 hrr1_build_np(Libint->AB,int_stack+754906,int_stack+0,int_stack+244522,784);
 /*--- compute (md|ii) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+754906,int_stack+296266,784);
 /*--- compute (lf|ii) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1482320,int_stack+0,int_stack+988400,784);
 /*--- compute (kg|ii) ---*/
 hrr1_build_kg(Libint->AB,int_stack+0,int_stack+1482320,int_stack+1200080,784);
 /*--- compute (ih|ii) ---*/
 hrr1_build_ih(Libint->AB,int_stack+754906,int_stack+0,int_stack+425626,784);
 return int_stack+754906;}
