/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iiii(Libint_t*, prim_data*);

  /* Computes quartets of (ii|ii) integrals */

REALTYPE *hrr_order_iiii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[6][10] = int_stack + 4592;
 Libint->vrr_classes[6][11] = int_stack + 6440;
 Libint->vrr_classes[6][12] = int_stack + 8624;
 Libint->vrr_classes[7][6] = int_stack + 11172;
 Libint->vrr_classes[7][7] = int_stack + 12180;
 Libint->vrr_classes[7][8] = int_stack + 13476;
 Libint->vrr_classes[7][9] = int_stack + 15096;
 Libint->vrr_classes[7][10] = int_stack + 17076;
 Libint->vrr_classes[7][11] = int_stack + 19452;
 Libint->vrr_classes[7][12] = int_stack + 22260;
 Libint->vrr_classes[8][6] = int_stack + 25536;
 Libint->vrr_classes[8][7] = int_stack + 26796;
 Libint->vrr_classes[8][8] = int_stack + 28416;
 Libint->vrr_classes[8][9] = int_stack + 30441;
 Libint->vrr_classes[8][10] = int_stack + 32916;
 Libint->vrr_classes[8][11] = int_stack + 35886;
 Libint->vrr_classes[8][12] = int_stack + 39396;
 Libint->vrr_classes[9][6] = int_stack + 43491;
 Libint->vrr_classes[9][7] = int_stack + 45031;
 Libint->vrr_classes[9][8] = int_stack + 47011;
 Libint->vrr_classes[9][9] = int_stack + 49486;
 Libint->vrr_classes[9][10] = int_stack + 52511;
 Libint->vrr_classes[9][11] = int_stack + 56141;
 Libint->vrr_classes[9][12] = int_stack + 60431;
 Libint->vrr_classes[10][6] = int_stack + 65436;
 Libint->vrr_classes[10][7] = int_stack + 67284;
 Libint->vrr_classes[10][8] = int_stack + 69660;
 Libint->vrr_classes[10][9] = int_stack + 72630;
 Libint->vrr_classes[10][10] = int_stack + 76260;
 Libint->vrr_classes[10][11] = int_stack + 80616;
 Libint->vrr_classes[10][12] = int_stack + 85764;
 Libint->vrr_classes[11][6] = int_stack + 91770;
 Libint->vrr_classes[11][7] = int_stack + 93954;
 Libint->vrr_classes[11][8] = int_stack + 96762;
 Libint->vrr_classes[11][9] = int_stack + 100272;
 Libint->vrr_classes[11][10] = int_stack + 104562;
 Libint->vrr_classes[11][11] = int_stack + 109710;
 Libint->vrr_classes[11][12] = int_stack + 115794;
 Libint->vrr_classes[12][6] = int_stack + 122892;
 Libint->vrr_classes[12][7] = int_stack + 125440;
 Libint->vrr_classes[12][8] = int_stack + 128716;
 Libint->vrr_classes[12][9] = int_stack + 132811;
 Libint->vrr_classes[12][10] = int_stack + 137816;
 Libint->vrr_classes[12][11] = int_stack + 143822;
 Libint->vrr_classes[12][12] = int_stack + 150920;
 memset(int_stack,0,159201*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 159201;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iiii(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+159201,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+161553,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+164577,int_stack+161553,int_stack+159201,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+169281,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+173061,int_stack+169281,int_stack+161553,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+179109,int_stack+173061,int_stack+164577,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+159201,int_stack+4592,int_stack+3052,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+186949,int_stack+159201,int_stack+169281,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+194509,int_stack+186949,int_stack+173061,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+163821,int_stack+194509,int_stack+179109,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+175581,int_stack+6440,int_stack+4592,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+204589,int_stack+175581,int_stack+159201,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+213829,int_stack+204589,int_stack+186949,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+226429,int_stack+213829,int_stack+194509,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+181125,int_stack+226429,int_stack+163821,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+159201,int_stack+8624,int_stack+6440,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+159201,int_stack+175581,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+159201,int_stack+0,int_stack+204589,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+241549,int_stack+159201,int_stack+213829,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+159201,int_stack+241549,int_stack+226429,28);
 /*--- compute (i0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+197589,int_stack+159201,int_stack+181125,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+159201,int_stack+12180,int_stack+11172,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+162225,int_stack+13476,int_stack+12180,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+166113,int_stack+162225,int_stack+159201,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+172161,int_stack+15096,int_stack+13476,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+177021,int_stack+172161,int_stack+162225,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+184797,int_stack+177021,int_stack+166113,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+159201,int_stack+17076,int_stack+15096,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+159201,int_stack+172161,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+219541,int_stack+0,int_stack+177021,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+165141,int_stack+219541,int_stack+184797,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+180261,int_stack+19452,int_stack+17076,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+232501,int_stack+180261,int_stack+159201,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+244381,int_stack+232501,int_stack+0,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+244381,int_stack+219541,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+260581,int_stack+0,int_stack+165141,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+219541,int_stack+22260,int_stack+19452,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+159201,int_stack+219541,int_stack+180261,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+173457,int_stack+159201,int_stack+232501,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+219541,int_stack+173457,int_stack+244381,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+159201,int_stack+219541,int_stack+0,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+219541,int_stack+159201,int_stack+260581,36);
 /*--- compute (ip|ii) ---*/
 hrr1_build_ip(Libint->AB,int_stack+247765,int_stack+219541,int_stack+197589,784);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+159201,int_stack+26796,int_stack+25536,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+162981,int_stack+28416,int_stack+26796,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+167841,int_stack+162981,int_stack+159201,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+175401,int_stack+30441,int_stack+28416,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+181476,int_stack+175401,int_stack+162981,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+191196,int_stack+181476,int_stack+167841,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+159201,int_stack+32916,int_stack+30441,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+203796,int_stack+159201,int_stack+175401,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+203796,int_stack+181476,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+166626,int_stack+0,int_stack+191196,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+185526,int_stack+35886,int_stack+32916,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16200,int_stack+185526,int_stack+159201,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+313621,int_stack+16200,int_stack+203796,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+194436,int_stack+313621,int_stack+0,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+333871,int_stack+194436,int_stack+166626,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+39396,int_stack+35886,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+159201,int_stack+0,int_stack+185526,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+360331,int_stack+159201,int_stack+16200,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+159201,int_stack+360331,int_stack+313621,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+159201,int_stack+194436,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+159201,int_stack+0,int_stack+333871,45);
 /*--- compute (kp|ii) ---*/
 hrr1_build_kp(Libint->AB,int_stack+313621,int_stack+159201,int_stack+219541,784);
 /*--- compute (id|ii) ---*/
 hrr1_build_id(Libint->AB,int_stack+398293,int_stack+313621,int_stack+247765,784);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+45031,int_stack+43491,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+4620,int_stack+47011,int_stack+45031,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10560,int_stack+4620,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19800,int_stack+49486,int_stack+47011,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+27225,int_stack+19800,int_stack+4620,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+194481,int_stack+27225,int_stack+10560,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+52511,int_stack+49486,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+209881,int_stack+0,int_stack+19800,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+224731,int_stack+209881,int_stack+27225,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+9075,int_stack+224731,int_stack+194481,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+194481,int_stack+56141,int_stack+52511,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+32175,int_stack+194481,int_stack+0,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+244531,int_stack+32175,int_stack+209881,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+269281,int_stack+244531,int_stack+224731,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+205371,int_stack+269281,int_stack+9075,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+60431,int_stack+56141,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+530005,int_stack+0,int_stack+194481,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+530005,int_stack+32175,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+530005,int_stack+0,int_stack+244531,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+530005,int_stack+269281,55);
 /*--- compute (m0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+237711,int_stack+0,int_stack+205371,55);
 /*--- compute (lp|ii) ---*/
 hrr1_build_lp(Libint->AB,int_stack+530005,int_stack+237711,int_stack+159201,784);
 /*--- compute (kd|ii) ---*/
 hrr1_build_kd(Libint->AB,int_stack+635845,int_stack+530005,int_stack+313621,784);
 /*--- compute (if|ii) ---*/
 hrr1_build_if(Libint->AB,int_stack+805189,int_stack+635845,int_stack+398293,784);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+159201,int_stack+67284,int_stack+65436,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+164745,int_stack+69660,int_stack+67284,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+171873,int_stack+164745,int_stack+159201,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+182961,int_stack+72630,int_stack+69660,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+191871,int_stack+182961,int_stack+164745,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+206127,int_stack+191871,int_stack+171873,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+159201,int_stack+76260,int_stack+72630,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+159201,int_stack+182961,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+17820,int_stack+0,int_stack+191871,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+170091,int_stack+17820,int_stack+206127,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+197811,int_stack+80616,int_stack+76260,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+210879,int_stack+197811,int_stack+159201,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+41580,int_stack+210879,int_stack+0,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+280831,int_stack+41580,int_stack+17820,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+280831,int_stack+170091,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+159201,int_stack+85764,int_stack+80616,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+316471,int_stack+159201,int_stack+197811,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+159201,int_stack+316471,int_stack+210879,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+316471,int_stack+159201,int_stack+41580,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+159201,int_stack+316471,int_stack+280831,66);
 /*--- compute (n0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+280831,int_stack+159201,int_stack+0,66);
 /*--- compute (mp|ii) ---*/
 hrr1_build_mp(Libint->AB,int_stack+332575,int_stack+280831,int_stack+237711,784);
 /*--- compute (ld|ii) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1024709,int_stack+332575,int_stack+530005,784);
 /*--- compute (kf|ii) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1236389,int_stack+1024709,int_stack+635845,784);
 /*--- compute (ig|ii) ---*/
 hrr1_build_ig(Libint->AB,int_stack+461935,int_stack+1236389,int_stack+805189,784);
 /*--- compute (o0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+93954,int_stack+91770,78);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+6552,int_stack+96762,int_stack+93954,78);
 /*--- compute (o0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+14976,int_stack+6552,int_stack+0,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28080,int_stack+100272,int_stack+96762,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+38610,int_stack+28080,int_stack+6552,78);
 /*--- compute (o0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+55458,int_stack+38610,int_stack+14976,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+104562,int_stack+100272,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+77298,int_stack+0,int_stack+28080,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+159201,int_stack+77298,int_stack+38610,78);
 /*--- compute (o0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+12870,int_stack+159201,int_stack+55458,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45630,int_stack+109710,int_stack+104562,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+187281,int_stack+45630,int_stack+0,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+213021,int_stack+187281,int_stack+77298,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+61074,int_stack+213021,int_stack+159201,78);
 /*--- compute (o0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+791215,int_stack+61074,int_stack+12870,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+159201,int_stack+115794,int_stack+109710,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+159201,int_stack+45630,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+837079,int_stack+0,int_stack+187281,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+837079,int_stack+213021,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+837079,int_stack+0,int_stack+61074,78);
 /*--- compute (o0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+0,int_stack+837079,int_stack+791215,78);
 /*--- compute (np|ii) ---*/
 hrr1_build_np(Libint->AB,int_stack+791215,int_stack+0,int_stack+280831,784);
 /*--- compute (md|ii) ---*/
 hrr1_build_md(Libint->AB,int_stack+1518629,int_stack+791215,int_stack+332575,784);
 /*--- compute (lf|ii) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1777349,int_stack+1518629,int_stack+1024709,784);
 /*--- compute (kg|ii) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2130149,int_stack+1777349,int_stack+1236389,784);
 /*--- compute (ih|ii) ---*/
 hrr1_build_ih(Libint->AB,int_stack+946447,int_stack+2130149,int_stack+461935,784);
 /*--- compute (q0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+1407439,int_stack+125440,int_stack+122892,91);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+1415083,int_stack+128716,int_stack+125440,91);
 /*--- compute (q0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+1424911,int_stack+1415083,int_stack+1407439,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+1440199,int_stack+132811,int_stack+128716,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+1452484,int_stack+1440199,int_stack+1415083,91);
 /*--- compute (q0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+1472140,int_stack+1452484,int_stack+1424911,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1407439,int_stack+137816,int_stack+132811,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+61152,int_stack+1407439,int_stack+1440199,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+85722,int_stack+61152,int_stack+1452484,91);
 /*--- compute (q0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+1422454,int_stack+85722,int_stack+1472140,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1460674,int_stack+143822,int_stack+137816,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1478692,int_stack+1460674,int_stack+1407439,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+159201,int_stack+1478692,int_stack+61152,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+200151,int_stack+159201,int_stack+85722,91);
 /*--- compute (q0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+61152,int_stack+200151,int_stack+1422454,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+114660,int_stack+150920,int_stack+143822,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1407439,int_stack+114660,int_stack+1460674,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+249291,int_stack+1407439,int_stack+1478692,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+1407439,int_stack+249291,int_stack+159201,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+249291,int_stack+1407439,int_stack+200151,91);
 /*--- compute (q0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+1407439,int_stack+249291,int_stack+61152,91);
 /*--- compute (op|ii) ---*/
 hrr1_build_op(Libint->AB,int_stack+61152,int_stack+1407439,int_stack+0,784);
 /*--- compute (nd|ii) ---*/
 hrr1_build_nd(Libint->AB,int_stack+244608,int_stack+61152,int_stack+791215,784);
 /*--- compute (mf|ii) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2553509,int_stack+244608,int_stack+1518629,784);
 /*--- compute (lg|ii) ---*/
 hrr1_build_lg(Libint->AB,int_stack+0,int_stack+2553509,int_stack+1777349,784);
 /*--- compute (kh|ii) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1407439,int_stack+0,int_stack+2130149,784);
 /*--- compute (ii|ii) ---*/
 hrr1_build_ii(Libint->AB,int_stack+0,int_stack+1407439,int_stack+946447,784);
 return int_stack+0;}
