/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iilg(Libint_t*, prim_data*);

  /* Computes quartets of (ii|lg) integrals */

REALTYPE *hrr_order_iilg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[7][8] = int_stack + 9380;
 Libint->vrr_classes[7][9] = int_stack + 11000;
 Libint->vrr_classes[7][10] = int_stack + 12980;
 Libint->vrr_classes[7][11] = int_stack + 15356;
 Libint->vrr_classes[7][12] = int_stack + 18164;
 Libint->vrr_classes[8][8] = int_stack + 21440;
 Libint->vrr_classes[8][9] = int_stack + 23465;
 Libint->vrr_classes[8][10] = int_stack + 25940;
 Libint->vrr_classes[8][11] = int_stack + 28910;
 Libint->vrr_classes[8][12] = int_stack + 32420;
 Libint->vrr_classes[9][8] = int_stack + 36515;
 Libint->vrr_classes[9][9] = int_stack + 38990;
 Libint->vrr_classes[9][10] = int_stack + 42015;
 Libint->vrr_classes[9][11] = int_stack + 45645;
 Libint->vrr_classes[9][12] = int_stack + 49935;
 Libint->vrr_classes[10][8] = int_stack + 54940;
 Libint->vrr_classes[10][9] = int_stack + 57910;
 Libint->vrr_classes[10][10] = int_stack + 61540;
 Libint->vrr_classes[10][11] = int_stack + 65896;
 Libint->vrr_classes[10][12] = int_stack + 71044;
 Libint->vrr_classes[11][8] = int_stack + 77050;
 Libint->vrr_classes[11][9] = int_stack + 80560;
 Libint->vrr_classes[11][10] = int_stack + 84850;
 Libint->vrr_classes[11][11] = int_stack + 89998;
 Libint->vrr_classes[11][12] = int_stack + 96082;
 Libint->vrr_classes[12][8] = int_stack + 103180;
 Libint->vrr_classes[12][9] = int_stack + 107275;
 Libint->vrr_classes[12][10] = int_stack + 112280;
 Libint->vrr_classes[12][11] = int_stack + 118286;
 Libint->vrr_classes[12][12] = int_stack + 125384;
 memset(int_stack,0,133665*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 133665;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iilg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+133665,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+137445,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+142065,int_stack+137445,int_stack+133665,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149625,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+155169,int_stack+149625,int_stack+137445,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+164409,int_stack+155169,int_stack+142065,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+133665,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+177009,int_stack+133665,int_stack+149625,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+133665,int_stack+177009,int_stack+155169,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+177009,int_stack+133665,int_stack+164409,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+133665,int_stack+11000,int_stack+9380,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+138525,int_stack+12980,int_stack+11000,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+144465,int_stack+138525,int_stack+133665,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+154185,int_stack+15356,int_stack+12980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+161313,int_stack+154185,int_stack+138525,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+195909,int_stack+161313,int_stack+144465,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+133665,int_stack+18164,int_stack+15356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+133665,int_stack+154185,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+133665,int_stack+0,int_stack+161313,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+212109,int_stack+133665,int_stack+195909,36);
 /*--- compute (ip|lg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+236409,int_stack+212109,int_stack+177009,675);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+133665,int_stack+23465,int_stack+21440,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+139740,int_stack+25940,int_stack+23465,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+147165,int_stack+139740,int_stack+133665,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+159315,int_stack+28910,int_stack+25940,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+168225,int_stack+159315,int_stack+139740,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+183075,int_stack+168225,int_stack+147165,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+133665,int_stack+32420,int_stack+28910,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+133665,int_stack+159315,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+133665,int_stack+0,int_stack+168225,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+133665,int_stack+183075,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+133665,int_stack+0,int_stack+212109,675);
 /*--- compute (id|lg) ---*/
 hrr1_build_id(Libint->AB,int_stack+293109,int_stack+133665,int_stack+236409,675);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+206565,int_stack+38990,int_stack+36515,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+213990,int_stack+42015,int_stack+38990,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+223065,int_stack+213990,int_stack+206565,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+237915,int_stack+45645,int_stack+42015,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+248805,int_stack+237915,int_stack+213990,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+266955,int_stack+248805,int_stack+223065,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+206565,int_stack+49935,int_stack+45645,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+30375,int_stack+206565,int_stack+237915,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+206565,int_stack+30375,int_stack+248805,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+406509,int_stack+206565,int_stack+266955,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+443634,int_stack+406509,int_stack+0,675);
 /*--- compute (kd|lg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+534759,int_stack+443634,int_stack+133665,675);
 /*--- compute (if|lg) ---*/
 hrr1_build_if(Libint->AB,int_stack+680559,int_stack+534759,int_stack+293109,675);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+133665,int_stack+57910,int_stack+54940,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+142575,int_stack+61540,int_stack+57910,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+153465,int_stack+142575,int_stack+133665,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+171285,int_stack+65896,int_stack+61540,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+184353,int_stack+171285,int_stack+142575,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+206133,int_stack+184353,int_stack+153465,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+133665,int_stack+71044,int_stack+65896,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+235833,int_stack+133665,int_stack+171285,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+133665,int_stack+235833,int_stack+184353,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+235833,int_stack+133665,int_stack+206133,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+280383,int_stack+235833,int_stack+406509,675);
 /*--- compute (ld|lg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+869559,int_stack+280383,int_stack+443634,675);
 /*--- compute (kf|lg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1051809,int_stack+869559,int_stack+534759,675);
 /*--- compute (ig|lg) ---*/
 hrr1_build_ig(Libint->AB,int_stack+391758,int_stack+1051809,int_stack+680559,675);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+133665,int_stack+80560,int_stack+77050,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+144195,int_stack+84850,int_stack+80560,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+157065,int_stack+144195,int_stack+133665,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+178125,int_stack+89998,int_stack+84850,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+193569,int_stack+178125,int_stack+144195,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+675258,int_stack+193569,int_stack+157065,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+133665,int_stack+96082,int_stack+89998,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+710358,int_stack+133665,int_stack+178125,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+133665,int_stack+710358,int_stack+193569,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+710358,int_stack+133665,int_stack+675258,78);
 /*--- compute (np|lg) ---*/
 hrr1_build_np(Libint->AB,int_stack+1294809,int_stack+710358,int_stack+235833,675);
 /*--- compute (md|lg) ---*/
 hrr1_build_md(Libint->AB,int_stack+1428459,int_stack+1294809,int_stack+280383,675);
 /*--- compute (lf|lg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1651209,int_stack+1428459,int_stack+869559,675);
 /*--- compute (kg|lg) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1954959,int_stack+1651209,int_stack+1051809,675);
 /*--- compute (ih|lg) ---*/
 hrr1_build_ih(Libint->AB,int_stack+763008,int_stack+1954959,int_stack+391758,675);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+133665,int_stack+107275,int_stack+103180,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+145950,int_stack+112280,int_stack+107275,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+160965,int_stack+145950,int_stack+133665,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+185535,int_stack+118286,int_stack+112280,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+203553,int_stack+185535,int_stack+145950,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+233583,int_stack+203553,int_stack+160965,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+133665,int_stack+125384,int_stack+118286,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+274533,int_stack+133665,int_stack+185535,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+310569,int_stack+274533,int_stack+203553,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+360619,int_stack+310569,int_stack+233583,91);
 /*--- compute (op|lg) ---*/
 hrr1_build_op(Libint->AB,int_stack+422044,int_stack+360619,int_stack+710358,675);
 /*--- compute (nd|lg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+422044,int_stack+1294809,675);
 /*--- compute (mf|lg) ---*/
 hrr1_build_mf(Libint->AB,int_stack+267300,int_stack+0,int_stack+1428459,675);
 /*--- compute (lg|lg) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1159908,int_stack+267300,int_stack+1651209,675);
 /*--- compute (kh|lg) ---*/
 hrr1_build_kh(Libint->AB,int_stack+0,int_stack+1159908,int_stack+1954959,675);
 /*--- compute (ii|lg) ---*/
 hrr1_build_ii(Libint->AB,int_stack+1159908,int_stack+0,int_stack+763008,675);
 return int_stack+1159908;}
