/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdih(Libint_t*, prim_data*);

  /* Computes quartets of (kd|ih) integrals */

REALTYPE *hrr_order_kdih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][6] = int_stack + 0;
 Libint->vrr_classes[7][7] = int_stack + 1008;
 Libint->vrr_classes[7][8] = int_stack + 2304;
 Libint->vrr_classes[7][9] = int_stack + 3924;
 Libint->vrr_classes[7][10] = int_stack + 5904;
 Libint->vrr_classes[7][11] = int_stack + 8280;
 Libint->vrr_classes[8][6] = int_stack + 11088;
 Libint->vrr_classes[8][7] = int_stack + 12348;
 Libint->vrr_classes[8][8] = int_stack + 13968;
 Libint->vrr_classes[8][9] = int_stack + 15993;
 Libint->vrr_classes[8][10] = int_stack + 18468;
 Libint->vrr_classes[8][11] = int_stack + 21438;
 Libint->vrr_classes[9][6] = int_stack + 24948;
 Libint->vrr_classes[9][7] = int_stack + 26488;
 Libint->vrr_classes[9][8] = int_stack + 28468;
 Libint->vrr_classes[9][9] = int_stack + 30943;
 Libint->vrr_classes[9][10] = int_stack + 33968;
 Libint->vrr_classes[9][11] = int_stack + 37598;
 memset(int_stack,0,41888*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 41888;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdih(Libint, Data);
   Data++;
 }
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+41888,int_stack+1008,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+44912,int_stack+2304,int_stack+1008,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+48800,int_stack+44912,int_stack+41888,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54848,int_stack+3924,int_stack+2304,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+59708,int_stack+54848,int_stack+44912,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+67484,int_stack+59708,int_stack+48800,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41888,int_stack+5904,int_stack+3924,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+77564,int_stack+41888,int_stack+54848,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+87284,int_stack+77564,int_stack+59708,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+47828,int_stack+87284,int_stack+67484,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+62948,int_stack+8280,int_stack+5904,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+100244,int_stack+62948,int_stack+41888,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+112124,int_stack+100244,int_stack+77564,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+62948,int_stack+112124,int_stack+87284,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+82388,int_stack+62948,int_stack+47828,36);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+41888,int_stack+12348,int_stack+11088,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+45668,int_stack+13968,int_stack+12348,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+50528,int_stack+45668,int_stack+41888,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+58088,int_stack+15993,int_stack+13968,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+64163,int_stack+58088,int_stack+45668,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+103556,int_stack+64163,int_stack+50528,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41888,int_stack+18468,int_stack+15993,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+116156,int_stack+41888,int_stack+58088,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+116156,int_stack+64163,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+49313,int_stack+0,int_stack+103556,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+103556,int_stack+21438,int_stack+18468,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+128306,int_stack+103556,int_stack+41888,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+143156,int_stack+128306,int_stack+116156,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+103556,int_stack+143156,int_stack+0,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+127856,int_stack+103556,int_stack+49313,45);
 /*--- compute (kp|ih) ---*/
 hrr1_build_kp(Libint->AB,int_stack+154316,int_stack+127856,int_stack+82388,588);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+26488,int_stack+24948,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+4620,int_stack+28468,int_stack+26488,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10560,int_stack+4620,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19800,int_stack+30943,int_stack+28468,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+41888,int_stack+19800,int_stack+4620,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+53768,int_stack+41888,int_stack+10560,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+33968,int_stack+30943,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+69168,int_stack+0,int_stack+19800,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+9075,int_stack+69168,int_stack+41888,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+84018,int_stack+9075,int_stack+53768,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+41888,int_stack+37598,int_stack+33968,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+107118,int_stack+41888,int_stack+0,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+28875,int_stack+107118,int_stack+69168,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+53625,int_stack+28875,int_stack+9075,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+53625,int_stack+84018,55);
 /*--- compute (lp|ih) ---*/
 hrr1_build_lp(Libint->AB,int_stack+32340,int_stack+0,int_stack+127856,588);
 /*--- compute (kd|ih) ---*/
 hrr1_build_kd(Libint->AB,int_stack+217820,int_stack+32340,int_stack+154316,588);
 return int_stack+217820;}
