/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdnk(Libint_t*, prim_data*);

  /* Computes quartets of (kd|nk) integrals */

REALTYPE *hrr_order_kdnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[8][10] = int_stack + 33120;
 Libint->vrr_classes[8][11] = int_stack + 36090;
 Libint->vrr_classes[8][12] = int_stack + 39600;
 Libint->vrr_classes[8][13] = int_stack + 43695;
 Libint->vrr_classes[8][14] = int_stack + 48420;
 Libint->vrr_classes[8][15] = int_stack + 53820;
 Libint->vrr_classes[8][16] = int_stack + 59940;
 Libint->vrr_classes[8][17] = int_stack + 66825;
 Libint->vrr_classes[9][10] = int_stack + 74520;
 Libint->vrr_classes[9][11] = int_stack + 78150;
 Libint->vrr_classes[9][12] = int_stack + 82440;
 Libint->vrr_classes[9][13] = int_stack + 87445;
 Libint->vrr_classes[9][14] = int_stack + 93220;
 Libint->vrr_classes[9][15] = int_stack + 99820;
 Libint->vrr_classes[9][16] = int_stack + 107300;
 Libint->vrr_classes[9][17] = int_stack + 115715;
 memset(int_stack,0,125120*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 125120;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdnk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125120,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+132248,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+140672,int_stack+132248,int_stack+125120,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+154928,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+164756,int_stack+154928,int_stack+132248,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+181604,int_stack+164756,int_stack+140672,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+125120,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+205364,int_stack+125120,int_stack+154928,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+136460,int_stack+205364,int_stack+164756,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+225020,int_stack+136460,int_stack+181604,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+164540,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+177500,int_stack+164540,int_stack+125120,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+260660,int_stack+177500,int_stack+205364,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+293420,int_stack+260660,int_stack+136460,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+335540,int_stack+293420,int_stack+225020,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+125120,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+200180,int_stack+125120,int_stack+164540,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+385436,int_stack+200180,int_stack+177500,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+139808,int_stack+385436,int_stack+260660,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+226100,int_stack+139808,int_stack+293420,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+423236,int_stack+226100,int_stack+335540,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+285068,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+301592,int_stack+285068,int_stack+125120,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+330968,int_stack+301592,int_stack+200180,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+489764,int_stack+330968,int_stack+385436,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+285068,int_stack+489764,int_stack+139808,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+125120,int_stack+285068,int_stack+226100,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+203744,int_stack+125120,int_stack+423236,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125120,int_stack+36090,int_stack+33120,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+134030,int_stack+39600,int_stack+36090,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+144560,int_stack+134030,int_stack+125120,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+162380,int_stack+43695,int_stack+39600,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+174665,int_stack+162380,int_stack+134030,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+289280,int_stack+174665,int_stack+144560,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+125120,int_stack+48420,int_stack+43695,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+318980,int_stack+125120,int_stack+162380,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+139295,int_stack+318980,int_stack+174665,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+343550,int_stack+139295,int_stack+289280,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+289280,int_stack+53820,int_stack+48420,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174395,int_stack+289280,int_stack+125120,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+388100,int_stack+174395,int_stack+318980,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+429050,int_stack+388100,int_stack+139295,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+481700,int_stack+429050,int_stack+343550,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+125120,int_stack+59940,int_stack+53820,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+305480,int_stack+125120,int_stack+289280,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+337880,int_stack+305480,int_stack+174395,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+544070,int_stack+337880,int_stack+388100,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+605495,int_stack+544070,int_stack+429050,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+385130,int_stack+605495,int_stack+481700,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+143480,int_stack+66825,int_stack+59940,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+164135,int_stack+143480,int_stack+125120,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+468290,int_stack+164135,int_stack+305480,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+125120,int_stack+468290,int_stack+337880,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+289280,int_stack+125120,int_stack+544070,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+468290,int_stack+289280,int_stack+605495,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+566570,int_stack+468290,int_stack+385130,45);
 /*--- compute (kp|nk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+289280,int_stack+566570,int_stack+203744,2376);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+545888,int_stack+78150,int_stack+74520,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+125120,int_stack+82440,int_stack+78150,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+137990,int_stack+125120,int_stack+545888,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+545888,int_stack+87445,int_stack+82440,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+159770,int_stack+545888,int_stack+125120,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+185510,int_stack+159770,int_stack+137990,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+125120,int_stack+93220,int_stack+87445,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+221810,int_stack+125120,int_stack+545888,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+221810,int_stack+159770,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+673490,int_stack+0,int_stack+185510,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+545888,int_stack+99820,int_stack+93220,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+142445,int_stack+545888,int_stack+125120,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+42900,int_stack+142445,int_stack+221810,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+177095,int_stack+42900,int_stack+0,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+727940,int_stack+177095,int_stack+673490,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+673490,int_stack+107300,int_stack+99820,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+673490,int_stack+545888,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+804170,int_stack+0,int_stack+142445,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+861920,int_stack+804170,int_stack+42900,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+936995,int_stack+861920,int_stack+177095,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+125120,int_stack+936995,int_stack+727940,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+695930,int_stack+115715,int_stack+107300,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+721175,int_stack+695930,int_stack+673490,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+39600,int_stack+721175,int_stack+0,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+673490,int_stack+39600,int_stack+804170,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+673490,int_stack+861920,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+673490,int_stack+0,int_stack+936995,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+793610,int_stack+673490,int_stack+125120,55);
 /*--- compute (lp|nk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+924290,int_stack+793610,int_stack+566570,2376);
 /*--- compute (kd|nk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1245050,int_stack+924290,int_stack+289280,2376);
 return int_stack+1245050;}
