/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfnd(Libint_t*, prim_data*);

  /* Computes quartets of (kf|nd) integrals */

REALTYPE *hrr_order_kfnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[8][10] = int_stack + 8460;
 Libint->vrr_classes[8][11] = int_stack + 11430;
 Libint->vrr_classes[8][12] = int_stack + 14940;
 Libint->vrr_classes[9][10] = int_stack + 19035;
 Libint->vrr_classes[9][11] = int_stack + 22665;
 Libint->vrr_classes[9][12] = int_stack + 26955;
 Libint->vrr_classes[10][10] = int_stack + 31960;
 Libint->vrr_classes[10][11] = int_stack + 36316;
 Libint->vrr_classes[10][12] = int_stack + 41464;
 memset(int_stack,0,47470*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 47470;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfnd(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47470,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54598,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+63022,int_stack+54598,int_stack+47470,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47470,int_stack+11430,int_stack+8460,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+14940,int_stack+11430,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+77278,int_stack+0,int_stack+47470,45);
 /*--- compute (kp|nd) ---*/
 hrr1_build_kp(Libint->AB,int_stack+95098,int_stack+77278,int_stack+63022,396);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47470,int_stack+22665,int_stack+19035,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+58360,int_stack+26955,int_stack+22665,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+58360,int_stack+47470,55);
 /*--- compute (lp|nd) ---*/
 hrr1_build_lp(Libint->AB,int_stack+137866,int_stack+0,int_stack+77278,396);
 /*--- compute (kd|nd) ---*/
 hrr1_build_kd(Libint->AB,int_stack+191326,int_stack+137866,int_stack+95098,396);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47470,int_stack+36316,int_stack+31960,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+60538,int_stack+41464,int_stack+36316,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+75982,int_stack+60538,int_stack+47470,66);
 /*--- compute (mp|nd) ---*/
 hrr1_build_mp(Libint->AB,int_stack+276862,int_stack+75982,int_stack+0,396);
 /*--- compute (ld|nd) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+276862,int_stack+137866,396);
 /*--- compute (kf|nd) ---*/
 hrr1_build_kf(Libint->AB,int_stack+276862,int_stack+0,int_stack+191326,396);
 return int_stack+276862;}
