/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgki(Libint_t*, prim_data*);

  /* Computes quartets of (kg|ki) integrals */

REALTYPE *hrr_order_kgki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[7][11] = int_stack + 7272;
 Libint->vrr_classes[7][12] = int_stack + 10080;
 Libint->vrr_classes[7][13] = int_stack + 13356;
 Libint->vrr_classes[8][7] = int_stack + 17136;
 Libint->vrr_classes[8][8] = int_stack + 18756;
 Libint->vrr_classes[8][9] = int_stack + 20781;
 Libint->vrr_classes[8][10] = int_stack + 23256;
 Libint->vrr_classes[8][11] = int_stack + 26226;
 Libint->vrr_classes[8][12] = int_stack + 29736;
 Libint->vrr_classes[8][13] = int_stack + 33831;
 Libint->vrr_classes[9][7] = int_stack + 38556;
 Libint->vrr_classes[9][8] = int_stack + 40536;
 Libint->vrr_classes[9][9] = int_stack + 43011;
 Libint->vrr_classes[9][10] = int_stack + 46036;
 Libint->vrr_classes[9][11] = int_stack + 49666;
 Libint->vrr_classes[9][12] = int_stack + 53956;
 Libint->vrr_classes[9][13] = int_stack + 58961;
 Libint->vrr_classes[10][7] = int_stack + 64736;
 Libint->vrr_classes[10][8] = int_stack + 67112;
 Libint->vrr_classes[10][9] = int_stack + 70082;
 Libint->vrr_classes[10][10] = int_stack + 73712;
 Libint->vrr_classes[10][11] = int_stack + 78068;
 Libint->vrr_classes[10][12] = int_stack + 83216;
 Libint->vrr_classes[10][13] = int_stack + 89222;
 Libint->vrr_classes[11][7] = int_stack + 96152;
 Libint->vrr_classes[11][8] = int_stack + 98960;
 Libint->vrr_classes[11][9] = int_stack + 102470;
 Libint->vrr_classes[11][10] = int_stack + 106760;
 Libint->vrr_classes[11][11] = int_stack + 111908;
 Libint->vrr_classes[11][12] = int_stack + 117992;
 Libint->vrr_classes[11][13] = int_stack + 125090;
 memset(int_stack,0,133280*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 133280;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgki(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+133280,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+137168,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+142028,int_stack+137168,int_stack+133280,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+149804,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+155744,int_stack+149804,int_stack+137168,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+165464,int_stack+155744,int_stack+142028,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133280,int_stack+7272,int_stack+4896,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+178424,int_stack+133280,int_stack+149804,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+190304,int_stack+178424,int_stack+155744,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+140408,int_stack+190304,int_stack+165464,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+159848,int_stack+10080,int_stack+7272,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+206504,int_stack+159848,int_stack+133280,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+220760,int_stack+206504,int_stack+178424,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+240560,int_stack+220760,int_stack+190304,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+168272,int_stack+240560,int_stack+140408,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+133280,int_stack+13356,int_stack+10080,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+133280,int_stack+159848,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+133280,int_stack+0,int_stack+206504,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+264860,int_stack+133280,int_stack+220760,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+133280,int_stack+264860,int_stack+240560,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+195488,int_stack+133280,int_stack+168272,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+133280,int_stack+18756,int_stack+17136,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+138140,int_stack+20781,int_stack+18756,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+144215,int_stack+138140,int_stack+133280,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+153935,int_stack+23256,int_stack+20781,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+161360,int_stack+153935,int_stack+138140,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+173510,int_stack+161360,int_stack+144215,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133280,int_stack+26226,int_stack+23256,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+133280,int_stack+153935,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+231776,int_stack+0,int_stack+161360,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+142190,int_stack+231776,int_stack+173510,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+166490,int_stack+29736,int_stack+26226,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+177020,int_stack+166490,int_stack+133280,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+252026,int_stack+177020,int_stack+0,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+276776,int_stack+252026,int_stack+231776,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+307151,int_stack+276776,int_stack+142190,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+231776,int_stack+33831,int_stack+29736,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+231776,int_stack+166490,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+133280,int_stack+0,int_stack+177020,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+133280,int_stack+252026,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+133280,int_stack+0,int_stack+276776,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+231776,int_stack+133280,int_stack+307151,45);
 /*--- compute (kp|ki) ---*/
 hrr1_build_kp(Libint->AB,int_stack+277136,int_stack+231776,int_stack+195488,1008);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+133280,int_stack+40536,int_stack+38556,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+139220,int_stack+43011,int_stack+40536,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+146645,int_stack+139220,int_stack+133280,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+158525,int_stack+46036,int_stack+43011,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+167600,int_stack+158525,int_stack+139220,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+182450,int_stack+167600,int_stack+146645,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133280,int_stack+49666,int_stack+46036,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+202250,int_stack+133280,int_stack+158525,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+202250,int_stack+167600,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+144170,int_stack+0,int_stack+182450,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+173870,int_stack+53956,int_stack+49666,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24750,int_stack+173870,int_stack+133280,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+386000,int_stack+24750,int_stack+202250,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+186740,int_stack+386000,int_stack+0,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+416250,int_stack+186740,int_stack+144170,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+58961,int_stack+53956,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+133280,int_stack+0,int_stack+173870,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+457830,int_stack+133280,int_stack+24750,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+133280,int_stack+457830,int_stack+386000,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+133280,int_stack+186740,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+133280,int_stack+0,int_stack+416250,55);
 /*--- compute (lp|ki) ---*/
 hrr1_build_lp(Libint->AB,int_stack+386000,int_stack+133280,int_stack+231776,1008);
 /*--- compute (kd|ki) ---*/
 hrr1_build_kd(Libint->AB,int_stack+522080,int_stack+386000,int_stack+277136,1008);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+67112,int_stack+64736,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7128,int_stack+70082,int_stack+67112,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+16038,int_stack+7128,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30294,int_stack+73712,int_stack+70082,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+41184,int_stack+30294,int_stack+7128,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+188720,int_stack+41184,int_stack+16038,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+78068,int_stack+73712,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+212480,int_stack+0,int_stack+30294,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+234260,int_stack+212480,int_stack+41184,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+13068,int_stack+234260,int_stack+188720,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+188720,int_stack+83216,int_stack+78068,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+48708,int_stack+188720,int_stack+0,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+263960,int_stack+48708,int_stack+212480,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+300260,int_stack+263960,int_stack+234260,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+204164,int_stack+300260,int_stack+13068,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+89222,int_stack+83216,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+344810,int_stack+0,int_stack+188720,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+344810,int_stack+48708,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+739808,int_stack+0,int_stack+263960,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+739808,int_stack+300260,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+254060,int_stack+0,int_stack+204164,66);
 /*--- compute (mp|ki) ---*/
 hrr1_build_mp(Libint->AB,int_stack+739808,int_stack+254060,int_stack+133280,1008);
 /*--- compute (ld|ki) ---*/
 hrr1_build_ld(Libint->AB,int_stack+906128,int_stack+739808,int_stack+386000,1008);
 /*--- compute (kf|ki) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1178288,int_stack+906128,int_stack+522080,1008);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+133280,int_stack+98960,int_stack+96152,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+141704,int_stack+102470,int_stack+98960,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+152234,int_stack+141704,int_stack+133280,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+169082,int_stack+106760,int_stack+102470,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+181952,int_stack+169082,int_stack+141704,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+203012,int_stack+181952,int_stack+152234,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133280,int_stack+111908,int_stack+106760,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+133280,int_stack+169082,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+25740,int_stack+0,int_stack+181952,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+148724,int_stack+25740,int_stack+203012,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+190844,int_stack+117992,int_stack+111908,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+209096,int_stack+190844,int_stack+133280,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+60840,int_stack+209096,int_stack+0,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+320588,int_stack+60840,int_stack+25740,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+320588,int_stack+148724,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+133280,int_stack+125090,int_stack+117992,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+373238,int_stack+133280,int_stack+190844,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+103740,int_stack+373238,int_stack+209096,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+373238,int_stack+103740,int_stack+60840,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+437588,int_stack+373238,int_stack+320588,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+320588,int_stack+437588,int_stack+0,78);
 /*--- compute (np|ki) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+320588,int_stack+254060,1008);
 /*--- compute (md|ki) ---*/
 hrr1_build_md(Libint->AB,int_stack+199584,int_stack+0,int_stack+739808,1008);
 /*--- compute (lf|ki) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1541168,int_stack+199584,int_stack+906128,1008);
 /*--- compute (kg|ki) ---*/
 hrr1_build_kg(Libint->AB,int_stack+0,int_stack+1541168,int_stack+1178288,1008);
 return int_stack+0;}
