/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kglg(Libint_t*, prim_data*);

  /* Computes quartets of (kg|lg) integrals */

REALTYPE *hrr_order_kglg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[8][8] = int_stack + 12060;
 Libint->vrr_classes[8][9] = int_stack + 14085;
 Libint->vrr_classes[8][10] = int_stack + 16560;
 Libint->vrr_classes[8][11] = int_stack + 19530;
 Libint->vrr_classes[8][12] = int_stack + 23040;
 Libint->vrr_classes[9][8] = int_stack + 27135;
 Libint->vrr_classes[9][9] = int_stack + 29610;
 Libint->vrr_classes[9][10] = int_stack + 32635;
 Libint->vrr_classes[9][11] = int_stack + 36265;
 Libint->vrr_classes[9][12] = int_stack + 40555;
 Libint->vrr_classes[10][8] = int_stack + 45560;
 Libint->vrr_classes[10][9] = int_stack + 48530;
 Libint->vrr_classes[10][10] = int_stack + 52160;
 Libint->vrr_classes[10][11] = int_stack + 56516;
 Libint->vrr_classes[10][12] = int_stack + 61664;
 Libint->vrr_classes[11][8] = int_stack + 67670;
 Libint->vrr_classes[11][9] = int_stack + 71180;
 Libint->vrr_classes[11][10] = int_stack + 75470;
 Libint->vrr_classes[11][11] = int_stack + 80618;
 Libint->vrr_classes[11][12] = int_stack + 86702;
 memset(int_stack,0,93800*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 93800;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kglg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+93800,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+98660,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+104600,int_stack+98660,int_stack+93800,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+114320,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+121448,int_stack+114320,int_stack+98660,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+133328,int_stack+121448,int_stack+104600,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+93800,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+149528,int_stack+93800,int_stack+114320,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+93800,int_stack+149528,int_stack+121448,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+149528,int_stack+93800,int_stack+133328,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+93800,int_stack+14085,int_stack+12060,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+99875,int_stack+16560,int_stack+14085,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+107300,int_stack+99875,int_stack+93800,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119450,int_stack+19530,int_stack+16560,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+128360,int_stack+119450,int_stack+99875,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+173828,int_stack+128360,int_stack+107300,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+93800,int_stack+23040,int_stack+19530,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+93800,int_stack+119450,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+93800,int_stack+0,int_stack+128360,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+118550,int_stack+93800,int_stack+173828,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+173828,int_stack+118550,int_stack+149528,675);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+93800,int_stack+29610,int_stack+27135,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+101225,int_stack+32635,int_stack+29610,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+101225,int_stack+93800,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14850,int_stack+36265,int_stack+32635,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+148925,int_stack+14850,int_stack+101225,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+93800,int_stack+148925,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+40555,int_stack+36265,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+246728,int_stack+0,int_stack+14850,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+246728,int_stack+148925,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+246728,int_stack+0,int_stack+93800,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+283853,int_stack+246728,int_stack+118550,675);
 /*--- compute (kd|lg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+374978,int_stack+283853,int_stack+173828,675);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+93800,int_stack+48530,int_stack+45560,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+102710,int_stack+52160,int_stack+48530,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+113600,int_stack+102710,int_stack+93800,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131420,int_stack+56516,int_stack+52160,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144488,int_stack+131420,int_stack+102710,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+166268,int_stack+144488,int_stack+113600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+93800,int_stack+61664,int_stack+56516,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+195968,int_stack+93800,int_stack+131420,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+93800,int_stack+195968,int_stack+144488,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+195968,int_stack+93800,int_stack+166268,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+520778,int_stack+195968,int_stack+246728,675);
 /*--- compute (ld|lg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+632153,int_stack+520778,int_stack+283853,675);
 /*--- compute (kf|lg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+814403,int_stack+632153,int_stack+374978,675);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+93800,int_stack+71180,int_stack+67670,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+104330,int_stack+75470,int_stack+71180,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+117200,int_stack+104330,int_stack+93800,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+138260,int_stack+80618,int_stack+75470,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+153704,int_stack+138260,int_stack+104330,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+240518,int_stack+153704,int_stack+117200,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+93800,int_stack+86702,int_stack+80618,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+275618,int_stack+93800,int_stack+138260,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+306506,int_stack+275618,int_stack+153704,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+349406,int_stack+306506,int_stack+240518,78);
 /*--- compute (np|lg) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+349406,int_stack+195968,675);
 /*--- compute (md|lg) ---*/
 hrr1_build_md(Libint->AB,int_stack+133650,int_stack+0,int_stack+520778,675);
 /*--- compute (lf|lg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1057403,int_stack+133650,int_stack+632153,675);
 /*--- compute (kg|lg) ---*/
 hrr1_build_kg(Libint->AB,int_stack+0,int_stack+1057403,int_stack+814403,675);
 return int_stack+0;}
