/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khli(Libint_t*, prim_data*);

  /* Computes quartets of (kh|li) integrals */

REALTYPE *hrr_order_khli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[8][8] = int_stack + 20160;
 Libint->vrr_classes[8][9] = int_stack + 22185;
 Libint->vrr_classes[8][10] = int_stack + 24660;
 Libint->vrr_classes[8][11] = int_stack + 27630;
 Libint->vrr_classes[8][12] = int_stack + 31140;
 Libint->vrr_classes[8][13] = int_stack + 35235;
 Libint->vrr_classes[8][14] = int_stack + 39960;
 Libint->vrr_classes[9][8] = int_stack + 45360;
 Libint->vrr_classes[9][9] = int_stack + 47835;
 Libint->vrr_classes[9][10] = int_stack + 50860;
 Libint->vrr_classes[9][11] = int_stack + 54490;
 Libint->vrr_classes[9][12] = int_stack + 58780;
 Libint->vrr_classes[9][13] = int_stack + 63785;
 Libint->vrr_classes[9][14] = int_stack + 69560;
 Libint->vrr_classes[10][8] = int_stack + 76160;
 Libint->vrr_classes[10][9] = int_stack + 79130;
 Libint->vrr_classes[10][10] = int_stack + 82760;
 Libint->vrr_classes[10][11] = int_stack + 87116;
 Libint->vrr_classes[10][12] = int_stack + 92264;
 Libint->vrr_classes[10][13] = int_stack + 98270;
 Libint->vrr_classes[10][14] = int_stack + 105200;
 Libint->vrr_classes[11][8] = int_stack + 113120;
 Libint->vrr_classes[11][9] = int_stack + 116630;
 Libint->vrr_classes[11][10] = int_stack + 120920;
 Libint->vrr_classes[11][11] = int_stack + 126068;
 Libint->vrr_classes[11][12] = int_stack + 132152;
 Libint->vrr_classes[11][13] = int_stack + 139250;
 Libint->vrr_classes[11][14] = int_stack + 147440;
 Libint->vrr_classes[12][8] = int_stack + 156800;
 Libint->vrr_classes[12][9] = int_stack + 160895;
 Libint->vrr_classes[12][10] = int_stack + 165900;
 Libint->vrr_classes[12][11] = int_stack + 171906;
 Libint->vrr_classes[12][12] = int_stack + 179004;
 Libint->vrr_classes[12][13] = int_stack + 187285;
 Libint->vrr_classes[12][14] = int_stack + 196840;
 memset(int_stack,0,207760*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 207760;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khli(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+207760,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+212620,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+218560,int_stack+212620,int_stack+207760,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+228280,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+235408,int_stack+228280,int_stack+212620,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+247288,int_stack+235408,int_stack+218560,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207760,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+263488,int_stack+207760,int_stack+228280,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+277744,int_stack+263488,int_stack+235408,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+216184,int_stack+277744,int_stack+247288,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+240484,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+297544,int_stack+240484,int_stack+207760,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+314392,int_stack+297544,int_stack+263488,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+338152,int_stack+314392,int_stack+277744,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+250312,int_stack+338152,int_stack+216184,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+207760,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+219100,int_stack+207760,int_stack+240484,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+367852,int_stack+219100,int_stack+297544,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+207760,int_stack+367852,int_stack+314392,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+284332,int_stack+207760,int_stack+338152,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+325912,int_stack+284332,int_stack+250312,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+207760,int_stack+22185,int_stack+20160,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+213835,int_stack+24660,int_stack+22185,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+221260,int_stack+213835,int_stack+207760,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+233410,int_stack+27630,int_stack+24660,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+242320,int_stack+233410,int_stack+213835,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+257170,int_stack+242320,int_stack+221260,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207760,int_stack+31140,int_stack+27630,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+277420,int_stack+207760,int_stack+233410,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+295240,int_stack+277420,int_stack+242320,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+218290,int_stack+295240,int_stack+257170,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+248665,int_stack+35235,int_stack+31140,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+371272,int_stack+248665,int_stack+207760,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+371272,int_stack+277420,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+392332,int_stack+0,int_stack+295240,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+260950,int_stack+392332,int_stack+218290,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+207760,int_stack+39960,int_stack+35235,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+221935,int_stack+207760,int_stack+248665,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+429457,int_stack+221935,int_stack+371272,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+207760,int_stack+429457,int_stack+0,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+429457,int_stack+207760,int_stack+392332,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+371272,int_stack+429457,int_stack+260950,45);
 /*--- compute (kp|li) ---*/
 hrr1_build_kp(Libint->AB,int_stack+427972,int_stack+371272,int_stack+325912,1260);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+207760,int_stack+47835,int_stack+45360,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+215185,int_stack+50860,int_stack+47835,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+224260,int_stack+215185,int_stack+207760,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+239110,int_stack+54490,int_stack+50860,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+250000,int_stack+239110,int_stack+215185,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+268150,int_stack+250000,int_stack+224260,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207760,int_stack+58780,int_stack+54490,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+292900,int_stack+207760,int_stack+239110,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+314680,int_stack+292900,int_stack+250000,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+220630,int_stack+314680,int_stack+268150,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+257755,int_stack+63785,int_stack+58780,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+344930,int_stack+257755,int_stack+207760,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+344930,int_stack+292900,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+564052,int_stack+0,int_stack+314680,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+272770,int_stack+564052,int_stack+220630,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+207760,int_stack+69560,int_stack+63785,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+225085,int_stack+207760,int_stack+257755,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+609427,int_stack+225085,int_stack+344930,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+207760,int_stack+609427,int_stack+0,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+207760,int_stack+564052,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+564052,int_stack+0,int_stack+272770,55);
 /*--- compute (lp|li) ---*/
 hrr1_build_lp(Libint->AB,int_stack+633352,int_stack+564052,int_stack+371272,1260);
 /*--- compute (kd|li) ---*/
 hrr1_build_kd(Libint->AB,int_stack+803452,int_stack+633352,int_stack+427972,1260);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+79130,int_stack+76160,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+82760,int_stack+79130,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37620,int_stack+87116,int_stack+82760,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50688,int_stack+37620,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+207760,int_stack+50688,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+92264,int_stack+87116,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+237460,int_stack+0,int_stack+37620,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+263596,int_stack+237460,int_stack+50688,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+15444,int_stack+263596,int_stack+207760,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+207760,int_stack+98270,int_stack+92264,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+59994,int_stack+207760,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+299896,int_stack+59994,int_stack+237460,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+343456,int_stack+299896,int_stack+263596,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+225778,int_stack+343456,int_stack+15444,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+105200,int_stack+98270,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20790,int_stack+0,int_stack+207760,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+397906,int_stack+20790,int_stack+59994,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+397906,int_stack+299896,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+397906,int_stack+0,int_stack+343456,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+397906,int_stack+225778,66);
 /*--- compute (mp|li) ---*/
 hrr1_build_mp(Libint->AB,int_stack+207760,int_stack+0,int_stack+564052,1260);
 /*--- compute (ld|li) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1075612,int_stack+207760,int_stack+633352,1260);
 /*--- compute (kf|li) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1415812,int_stack+1075612,int_stack+803452,1260);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+83160,int_stack+116630,int_stack+113120,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+93690,int_stack+120920,int_stack+116630,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+415660,int_stack+93690,int_stack+83160,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+436720,int_stack+126068,int_stack+120920,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+452164,int_stack+436720,int_stack+93690,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+83160,int_stack+452164,int_stack+415660,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+415660,int_stack+132152,int_stack+126068,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+477904,int_stack+415660,int_stack+436720,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+508792,int_stack+477904,int_stack+452164,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+551692,int_stack+508792,int_stack+83160,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+83160,int_stack+139250,int_stack+132152,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+433912,int_stack+83160,int_stack+415660,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+604342,int_stack+433912,int_stack+477904,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+655822,int_stack+604342,int_stack+508792,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+470416,int_stack+655822,int_stack+551692,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+104454,int_stack+147440,int_stack+139250,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+544126,int_stack+104454,int_stack+83160,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+83160,int_stack+544126,int_stack+433912,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+720172,int_stack+83160,int_stack+604342,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+544126,int_stack+720172,int_stack+655822,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+634216,int_stack+544126,int_stack+470416,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+732496,int_stack+634216,int_stack+0,1260);
 /*--- compute (md|li) ---*/
 hrr1_build_md(Libint->AB,int_stack+1869412,int_stack+732496,int_stack+207760,1260);
 /*--- compute (lf|li) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2285212,int_stack+1869412,int_stack+1075612,1260);
 /*--- compute (kg|li) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2852212,int_stack+2285212,int_stack+1415812,1260);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+207760,int_stack+160895,int_stack+156800,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+220045,int_stack+165900,int_stack+160895,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+235060,int_stack+220045,int_stack+207760,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+259630,int_stack+171906,int_stack+165900,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+277648,int_stack+259630,int_stack+220045,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+307678,int_stack+277648,int_stack+235060,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207760,int_stack+179004,int_stack+171906,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+348628,int_stack+207760,int_stack+259630,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+384664,int_stack+348628,int_stack+277648,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+229054,int_stack+384664,int_stack+307678,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+290479,int_stack+187285,int_stack+179004,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+434714,int_stack+290479,int_stack+207760,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+477302,int_stack+434714,int_stack+348628,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+537362,int_stack+477302,int_stack+384664,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+315322,int_stack+537362,int_stack+229054,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+207760,int_stack+196840,int_stack+187285,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+236425,int_stack+207760,int_stack+290479,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+236425,int_stack+434714,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+70980,int_stack+0,int_stack+477302,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+401317,int_stack+70980,int_stack+537362,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+401317,int_stack+315322,91);
 /*--- compute (op|li) ---*/
 hrr1_build_op(Libint->AB,int_stack+114660,int_stack+0,int_stack+634216,1260);
 /*--- compute (nd|li) ---*/
 hrr1_build_nd(Libint->AB,int_stack+981976,int_stack+114660,int_stack+732496,1260);
 /*--- compute (mf|li) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+981976,int_stack+1869412,1260);
 /*--- compute (lg|li) ---*/
 hrr1_build_lg(Libint->AB,int_stack+693000,int_stack+0,int_stack+2285212,1260);
 /*--- compute (kh|li) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1543500,int_stack+693000,int_stack+2852212,1260);
 return int_stack+1543500;}
