/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khml(Libint_t*, prim_data*);

  /* Computes quartets of (kh|ml) integrals */

REALTYPE *hrr_order_khml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[7][16] = int_stack + 23436;
 Libint->vrr_classes[7][17] = int_stack + 28944;
 Libint->vrr_classes[8][9] = int_stack + 35100;
 Libint->vrr_classes[8][10] = int_stack + 37575;
 Libint->vrr_classes[8][11] = int_stack + 40545;
 Libint->vrr_classes[8][12] = int_stack + 44055;
 Libint->vrr_classes[8][13] = int_stack + 48150;
 Libint->vrr_classes[8][14] = int_stack + 52875;
 Libint->vrr_classes[8][15] = int_stack + 58275;
 Libint->vrr_classes[8][16] = int_stack + 64395;
 Libint->vrr_classes[8][17] = int_stack + 71280;
 Libint->vrr_classes[9][9] = int_stack + 78975;
 Libint->vrr_classes[9][10] = int_stack + 82000;
 Libint->vrr_classes[9][11] = int_stack + 85630;
 Libint->vrr_classes[9][12] = int_stack + 89920;
 Libint->vrr_classes[9][13] = int_stack + 94925;
 Libint->vrr_classes[9][14] = int_stack + 100700;
 Libint->vrr_classes[9][15] = int_stack + 107300;
 Libint->vrr_classes[9][16] = int_stack + 114780;
 Libint->vrr_classes[9][17] = int_stack + 123195;
 Libint->vrr_classes[10][9] = int_stack + 132600;
 Libint->vrr_classes[10][10] = int_stack + 136230;
 Libint->vrr_classes[10][11] = int_stack + 140586;
 Libint->vrr_classes[10][12] = int_stack + 145734;
 Libint->vrr_classes[10][13] = int_stack + 151740;
 Libint->vrr_classes[10][14] = int_stack + 158670;
 Libint->vrr_classes[10][15] = int_stack + 166590;
 Libint->vrr_classes[10][16] = int_stack + 175566;
 Libint->vrr_classes[10][17] = int_stack + 185664;
 Libint->vrr_classes[11][9] = int_stack + 196950;
 Libint->vrr_classes[11][10] = int_stack + 201240;
 Libint->vrr_classes[11][11] = int_stack + 206388;
 Libint->vrr_classes[11][12] = int_stack + 212472;
 Libint->vrr_classes[11][13] = int_stack + 219570;
 Libint->vrr_classes[11][14] = int_stack + 227760;
 Libint->vrr_classes[11][15] = int_stack + 237120;
 Libint->vrr_classes[11][16] = int_stack + 247728;
 Libint->vrr_classes[11][17] = int_stack + 259662;
 Libint->vrr_classes[12][9] = int_stack + 273000;
 Libint->vrr_classes[12][10] = int_stack + 278005;
 Libint->vrr_classes[12][11] = int_stack + 284011;
 Libint->vrr_classes[12][12] = int_stack + 291109;
 Libint->vrr_classes[12][13] = int_stack + 299390;
 Libint->vrr_classes[12][14] = int_stack + 308945;
 Libint->vrr_classes[12][15] = int_stack + 319865;
 Libint->vrr_classes[12][16] = int_stack + 332241;
 Libint->vrr_classes[12][17] = int_stack + 346164;
 memset(int_stack,0,361725*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 361725;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khml(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+361725,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+367665,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+374793,int_stack+367665,int_stack+361725,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+386673,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+395097,int_stack+386673,int_stack+367665,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+409353,int_stack+395097,int_stack+374793,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+361725,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+429153,int_stack+361725,int_stack+386673,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+446001,int_stack+429153,int_stack+395097,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+371553,int_stack+446001,int_stack+409353,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+401253,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+469761,int_stack+401253,int_stack+361725,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+489417,int_stack+469761,int_stack+429153,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+517497,int_stack+489417,int_stack+446001,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+412593,int_stack+517497,int_stack+371553,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+361725,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+374685,int_stack+361725,int_stack+401253,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+553137,int_stack+374685,int_stack+469761,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+585897,int_stack+553137,int_stack+489417,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+454173,int_stack+585897,int_stack+517497,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+628017,int_stack+454173,int_stack+412593,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+397365,int_stack+23436,int_stack+18540,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+412053,int_stack+397365,int_stack+361725,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+504069,int_stack+412053,int_stack+374685,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+683457,int_stack+504069,int_stack+553137,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+732597,int_stack+683457,int_stack+585897,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+541869,int_stack+732597,int_stack+454173,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+791565,int_stack+541869,int_stack+628017,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+361725,int_stack+28944,int_stack+23436,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+437973,int_stack+361725,int_stack+397365,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+361725,int_stack+437973,int_stack+412053,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+404925,int_stack+361725,int_stack+504069,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+461625,int_stack+404925,int_stack+683457,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+361725,int_stack+461625,int_stack+732597,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+440349,int_stack+361725,int_stack+541869,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+525885,int_stack+440349,int_stack+791565,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+361725,int_stack+37575,int_stack+35100,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+369150,int_stack+40545,int_stack+37575,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+378060,int_stack+369150,int_stack+361725,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+392910,int_stack+44055,int_stack+40545,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+403440,int_stack+392910,int_stack+369150,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+421260,int_stack+403440,int_stack+378060,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+361725,int_stack+48150,int_stack+44055,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+446010,int_stack+361725,int_stack+392910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+467070,int_stack+446010,int_stack+403440,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+374010,int_stack+467070,int_stack+421260,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+411135,int_stack+52875,int_stack+48150,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+496770,int_stack+411135,int_stack+361725,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+614985,int_stack+496770,int_stack+446010,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+650085,int_stack+614985,int_stack+467070,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+425310,int_stack+650085,int_stack+374010,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+361725,int_stack+58275,int_stack+52875,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+377925,int_stack+361725,int_stack+411135,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+694635,int_stack+377925,int_stack+496770,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+735585,int_stack+694635,int_stack+614985,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+788235,int_stack+735585,int_stack+650085,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+614985,int_stack+788235,int_stack+425310,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+406275,int_stack+64395,int_stack+58275,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+424635,int_stack+406275,int_stack+361725,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+457035,int_stack+424635,int_stack+377925,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+457035,int_stack+694635,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+850605,int_stack+0,int_stack+735585,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+684285,int_stack+850605,int_stack+788235,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+924315,int_stack+684285,int_stack+614985,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+614985,int_stack+71280,int_stack+64395,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+635640,int_stack+614985,int_stack+406275,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+361725,int_stack+635640,int_stack+424635,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+767445,int_stack+361725,int_stack+457035,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+361725,int_stack+767445,int_stack+0,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1013415,int_stack+361725,int_stack+850605,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+361725,int_stack+1013415,int_stack+684285,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+614985,int_stack+361725,int_stack+924315,45);
 /*--- compute (kp|ml) ---*/
 hrr1_build_kp(Libint->AB,int_stack+726360,int_stack+614985,int_stack+525885,2475);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+361725,int_stack+82000,int_stack+78975,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+370800,int_stack+85630,int_stack+82000,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+381690,int_stack+370800,int_stack+361725,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+399840,int_stack+89920,int_stack+85630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+412710,int_stack+399840,int_stack+370800,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+434490,int_stack+412710,int_stack+381690,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+361725,int_stack+94925,int_stack+89920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+464740,int_stack+361725,int_stack+399840,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+490480,int_stack+464740,int_stack+412710,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+376740,int_stack+490480,int_stack+434490,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+422115,int_stack+100700,int_stack+94925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+526780,int_stack+422115,int_stack+361725,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+556810,int_stack+526780,int_stack+464740,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+556810,int_stack+490480,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+439440,int_stack+0,int_stack+376740,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+361725,int_stack+107300,int_stack+100700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+381525,int_stack+361725,int_stack+422115,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+54450,int_stack+381525,int_stack+526780,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+993660,int_stack+54450,int_stack+556810,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+502965,int_stack+993660,int_stack+0,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1058010,int_stack+502965,int_stack+439440,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+114780,int_stack+107300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+416175,int_stack+0,int_stack+361725,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1142710,int_stack+416175,int_stack+381525,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1200460,int_stack+1142710,int_stack+54450,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+22440,int_stack+1200460,int_stack+993660,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1275535,int_stack+22440,int_stack+502965,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+455775,int_stack+1275535,int_stack+1058010,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+993660,int_stack+123195,int_stack+114780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1018905,int_stack+993660,int_stack+0,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1063785,int_stack+1018905,int_stack+416175,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+361725,int_stack+1063785,int_stack+1142710,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+993660,int_stack+361725,int_stack+1200460,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1098765,int_stack+993660,int_stack+22440,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1098765,int_stack+1275535,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+993660,int_stack+0,int_stack+455775,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1129785,int_stack+993660,int_stack+614985,2475);
 /*--- compute (kd|ml) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1463910,int_stack+1129785,int_stack+726360,2475);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+136230,int_stack+132600,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+140586,int_stack+136230,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+145734,int_stack+140586,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+61182,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+87318,int_stack+61182,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+151740,int_stack+145734,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+361725,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+392613,int_stack+361725,int_stack+61182,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+18018,int_stack+392613,int_stack+87318,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+72468,int_stack+158670,int_stack+151740,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+93258,int_stack+72468,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+436173,int_stack+93258,int_stack+361725,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+487653,int_stack+436173,int_stack+392613,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+552993,int_stack+487653,int_stack+18018,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+361725,int_stack+166590,int_stack+158670,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+385485,int_stack+361725,int_stack+72468,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+385485,int_stack+93258,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+60060,int_stack+0,int_stack+436173,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+629223,int_stack+60060,int_stack+487653,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+427065,int_stack+629223,int_stack+552993,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+528705,int_stack+175566,int_stack+166590,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+555633,int_stack+528705,int_stack+361725,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+720699,int_stack+555633,int_stack+385485,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+789999,int_stack+720699,int_stack+0,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+880089,int_stack+789999,int_stack+60060,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+880089,int_stack+629223,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1998510,int_stack+0,int_stack+427065,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+121968,int_stack+185664,int_stack+175566,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+361725,int_stack+121968,int_stack+528705,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+415581,int_stack+361725,int_stack+555633,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+494781,int_stack+415581,int_stack+720699,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+361725,int_stack+494781,int_stack+789999,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+487851,int_stack+361725,int_stack+880089,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+631995,int_stack+487851,int_stack+0,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+631995,int_stack+1998510,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+361725,int_stack+0,int_stack+993660,2475);
 /*--- compute (ld|ml) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1998510,int_stack+361725,int_stack+1129785,2475);
 /*--- compute (kf|ml) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2666760,int_stack+1998510,int_stack+1463910,2475);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+163350,int_stack+201240,int_stack+196950,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+176220,int_stack+206388,int_stack+201240,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+770100,int_stack+176220,int_stack+163350,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+795840,int_stack+212472,int_stack+206388,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+814092,int_stack+795840,int_stack+176220,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+163350,int_stack+814092,int_stack+770100,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+770100,int_stack+219570,int_stack+212472,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+844980,int_stack+770100,int_stack+795840,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+881484,int_stack+844980,int_stack+814092,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+932964,int_stack+881484,int_stack+163350,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+163350,int_stack+227760,int_stack+219570,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+791394,int_stack+163350,int_stack+770100,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+997314,int_stack+791394,int_stack+844980,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1058154,int_stack+997314,int_stack+881484,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+833982,int_stack+1058154,int_stack+932964,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+187920,int_stack+237120,int_stack+227760,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+924072,int_stack+187920,int_stack+163350,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1135374,int_stack+924072,int_stack+791394,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1206354,int_stack+1135374,int_stack+997314,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1297614,int_stack+1206354,int_stack+1058154,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+973212,int_stack+1297614,int_stack+833982,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+770100,int_stack+247728,int_stack+237120,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+801924,int_stack+770100,int_stack+187920,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+163350,int_stack+801924,int_stack+924072,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+858084,int_stack+163350,int_stack+1135374,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1405722,int_stack+858084,int_stack+1206354,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1093332,int_stack+1405722,int_stack+1297614,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1237476,int_stack+1093332,int_stack+973212,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+964554,int_stack+259662,int_stack+247728,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1000356,int_stack+964554,int_stack+770100,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1533486,int_stack+1000356,int_stack+801924,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+964554,int_stack+1533486,int_stack+163350,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1533486,int_stack+964554,int_stack+858084,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1682544,int_stack+1533486,int_stack+1405722,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+770100,int_stack+1682544,int_stack+1093332,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+955428,int_stack+770100,int_stack+1237476,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+1148478,int_stack+955428,int_stack+0,2475);
 /*--- compute (md|ml) ---*/
 hrr1_build_md(Libint->AB,int_stack+3557760,int_stack+1148478,int_stack+361725,2475);
 /*--- compute (lf|ml) ---*/
 hrr1_build_lf(Libint->AB,int_stack+4374510,int_stack+3557760,int_stack+1998510,2475);
 /*--- compute (kg|ml) ---*/
 hrr1_build_kg(Libint->AB,int_stack+5488260,int_stack+4374510,int_stack+2666760,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+361725,int_stack+278005,int_stack+273000,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+376740,int_stack+284011,int_stack+278005,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+394758,int_stack+376740,int_stack+361725,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+424788,int_stack+291109,int_stack+284011,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+446082,int_stack+424788,int_stack+376740,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+482118,int_stack+446082,int_stack+394758,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+361725,int_stack+299390,int_stack+291109,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+532168,int_stack+361725,int_stack+424788,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+574756,int_stack+532168,int_stack+446082,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+386568,int_stack+574756,int_stack+482118,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+461643,int_stack+308945,int_stack+299390,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+634816,int_stack+461643,int_stack+361725,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+684502,int_stack+634816,int_stack+532168,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+755482,int_stack+684502,int_stack+574756,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+490308,int_stack+755482,int_stack+386568,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+361725,int_stack+319865,int_stack+308945,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+394485,int_stack+361725,int_stack+461643,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+845572,int_stack+394485,int_stack+634816,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+845572,int_stack+684502,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+595413,int_stack+0,int_stack+755482,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+106470,int_stack+595413,int_stack+490308,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+451815,int_stack+332241,int_stack+319865,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+488943,int_stack+451815,int_stack+361725,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+721539,int_stack+488943,int_stack+394485,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1638528,int_stack+721539,int_stack+845572,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1762743,int_stack+1638528,int_stack+0,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1911801,int_stack+1762743,int_stack+595413,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2079969,int_stack+1911801,int_stack+106470,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+346164,int_stack+332241,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+41769,int_stack+0,int_stack+451815,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+116025,int_stack+41769,int_stack+488943,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+225225,int_stack+116025,int_stack+721539,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+225225,int_stack+1638528,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+173901,int_stack+0,int_stack+1762743,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1638528,int_stack+173901,int_stack+1911801,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1854744,int_stack+1638528,int_stack+2079969,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+2079969,int_stack+1854744,int_stack+955428,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+2079969,int_stack+1148478,2475);
 /*--- compute (mf|ml) ---*/
 hrr1_build_mf(Libint->AB,int_stack+980100,int_stack+0,int_stack+3557760,2475);
 /*--- compute (lg|ml) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2341350,int_stack+980100,int_stack+4374510,2475);
 /*--- compute (kh|ml) ---*/
 hrr1_build_kh(Libint->AB,int_stack+0,int_stack+2341350,int_stack+5488260,2475);
 return int_stack+0;}
