/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khnn(Libint_t*, prim_data*);

  /* Computes quartets of (kh|nn) integrals */

REALTYPE *hrr_order_khnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[7][18] = int_stack + 33120;
 Libint->vrr_classes[7][19] = int_stack + 39960;
 Libint->vrr_classes[7][20] = int_stack + 47520;
 Libint->vrr_classes[8][10] = int_stack + 55836;
 Libint->vrr_classes[8][11] = int_stack + 58806;
 Libint->vrr_classes[8][12] = int_stack + 62316;
 Libint->vrr_classes[8][13] = int_stack + 66411;
 Libint->vrr_classes[8][14] = int_stack + 71136;
 Libint->vrr_classes[8][15] = int_stack + 76536;
 Libint->vrr_classes[8][16] = int_stack + 82656;
 Libint->vrr_classes[8][17] = int_stack + 89541;
 Libint->vrr_classes[8][18] = int_stack + 97236;
 Libint->vrr_classes[8][19] = int_stack + 105786;
 Libint->vrr_classes[8][20] = int_stack + 115236;
 Libint->vrr_classes[9][10] = int_stack + 125631;
 Libint->vrr_classes[9][11] = int_stack + 129261;
 Libint->vrr_classes[9][12] = int_stack + 133551;
 Libint->vrr_classes[9][13] = int_stack + 138556;
 Libint->vrr_classes[9][14] = int_stack + 144331;
 Libint->vrr_classes[9][15] = int_stack + 150931;
 Libint->vrr_classes[9][16] = int_stack + 158411;
 Libint->vrr_classes[9][17] = int_stack + 166826;
 Libint->vrr_classes[9][18] = int_stack + 176231;
 Libint->vrr_classes[9][19] = int_stack + 186681;
 Libint->vrr_classes[9][20] = int_stack + 198231;
 Libint->vrr_classes[10][10] = int_stack + 210936;
 Libint->vrr_classes[10][11] = int_stack + 215292;
 Libint->vrr_classes[10][12] = int_stack + 220440;
 Libint->vrr_classes[10][13] = int_stack + 226446;
 Libint->vrr_classes[10][14] = int_stack + 233376;
 Libint->vrr_classes[10][15] = int_stack + 241296;
 Libint->vrr_classes[10][16] = int_stack + 250272;
 Libint->vrr_classes[10][17] = int_stack + 260370;
 Libint->vrr_classes[10][18] = int_stack + 271656;
 Libint->vrr_classes[10][19] = int_stack + 284196;
 Libint->vrr_classes[10][20] = int_stack + 298056;
 Libint->vrr_classes[11][10] = int_stack + 313302;
 Libint->vrr_classes[11][11] = int_stack + 318450;
 Libint->vrr_classes[11][12] = int_stack + 324534;
 Libint->vrr_classes[11][13] = int_stack + 331632;
 Libint->vrr_classes[11][14] = int_stack + 339822;
 Libint->vrr_classes[11][15] = int_stack + 349182;
 Libint->vrr_classes[11][16] = int_stack + 359790;
 Libint->vrr_classes[11][17] = int_stack + 371724;
 Libint->vrr_classes[11][18] = int_stack + 385062;
 Libint->vrr_classes[11][19] = int_stack + 399882;
 Libint->vrr_classes[11][20] = int_stack + 416262;
 Libint->vrr_classes[12][10] = int_stack + 434280;
 Libint->vrr_classes[12][11] = int_stack + 440286;
 Libint->vrr_classes[12][12] = int_stack + 447384;
 Libint->vrr_classes[12][13] = int_stack + 455665;
 Libint->vrr_classes[12][14] = int_stack + 465220;
 Libint->vrr_classes[12][15] = int_stack + 476140;
 Libint->vrr_classes[12][16] = int_stack + 488516;
 Libint->vrr_classes[12][17] = int_stack + 502439;
 Libint->vrr_classes[12][18] = int_stack + 518000;
 Libint->vrr_classes[12][19] = int_stack + 535290;
 Libint->vrr_classes[12][20] = int_stack + 554400;
 memset(int_stack,0,575421*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 575421;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khnn(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+575421,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+582549,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+590973,int_stack+582549,int_stack+575421,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+605229,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+615057,int_stack+605229,int_stack+582549,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+631905,int_stack+615057,int_stack+590973,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+575421,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+655665,int_stack+575421,int_stack+605229,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+586761,int_stack+655665,int_stack+615057,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+675321,int_stack+586761,int_stack+631905,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+614841,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+627801,int_stack+614841,int_stack+575421,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+710961,int_stack+627801,int_stack+655665,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+743721,int_stack+710961,int_stack+586761,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+785841,int_stack+743721,int_stack+675321,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+575421,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+650481,int_stack+575421,int_stack+614841,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+835737,int_stack+650481,int_stack+627801,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+590109,int_stack+835737,int_stack+710961,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+676401,int_stack+590109,int_stack+743721,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+873537,int_stack+676401,int_stack+785841,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+735369,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+751893,int_stack+735369,int_stack+575421,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+781269,int_stack+751893,int_stack+650481,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+940065,int_stack+781269,int_stack+835737,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+996765,int_stack+940065,int_stack+590109,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+575421,int_stack+996765,int_stack+676401,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1065561,int_stack+575421,int_stack+873537,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+654045,int_stack+33120,int_stack+26964,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+672513,int_stack+654045,int_stack+735369,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+824469,int_stack+672513,int_stack+751893,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+705561,int_stack+824469,int_stack+781269,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1151097,int_stack+705561,int_stack+940065,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+873429,int_stack+1151097,int_stack+996765,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1230477,int_stack+873429,int_stack+575421,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1331565,int_stack+1230477,int_stack+1065561,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+575421,int_stack+39960,int_stack+33120,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+595941,int_stack+575421,int_stack+654045,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+965157,int_stack+595941,int_stack+672513,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1020237,int_stack+965157,int_stack+824469,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+770361,int_stack+1020237,int_stack+705561,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+632877,int_stack+770361,int_stack+1151097,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1093677,int_stack+632877,int_stack+873429,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1438485,int_stack+1093677,int_stack+1230477,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1564845,int_stack+1438485,int_stack+1331565,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+738717,int_stack+47520,int_stack+39960,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+861081,int_stack+738717,int_stack+575421,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+902121,int_stack+861081,int_stack+595941,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1211613,int_stack+902121,int_stack+965157,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+861081,int_stack+1211613,int_stack+1020237,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1211613,int_stack+861081,int_stack+770361,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+738717,int_stack+1211613,int_stack+632877,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1211613,int_stack+738717,int_stack+1093677,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+575421,int_stack+1211613,int_stack+1438485,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+729861,int_stack+575421,int_stack+1564845,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+575421,int_stack+58806,int_stack+55836,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+584331,int_stack+62316,int_stack+58806,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+594861,int_stack+584331,int_stack+575421,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+612681,int_stack+66411,int_stack+62316,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+624966,int_stack+612681,int_stack+584331,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+646026,int_stack+624966,int_stack+594861,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+575421,int_stack+71136,int_stack+66411,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+675726,int_stack+575421,int_stack+612681,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+589596,int_stack+675726,int_stack+624966,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+886677,int_stack+589596,int_stack+646026,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+624696,int_stack+76536,int_stack+71136,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+640896,int_stack+624696,int_stack+575421,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+931227,int_stack+640896,int_stack+675726,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+669246,int_stack+931227,int_stack+589596,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+972177,int_stack+669246,int_stack+886677,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+886677,int_stack+82656,int_stack+76536,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+575421,int_stack+886677,int_stack+624696,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1034547,int_stack+575421,int_stack+640896,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+607821,int_stack+1034547,int_stack+931227,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1081797,int_stack+607821,int_stack+669246,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1155507,int_stack+1081797,int_stack+972177,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+669246,int_stack+89541,int_stack+82656,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+689901,int_stack+669246,int_stack+886677,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+886677,int_stack+689901,int_stack+575421,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+940677,int_stack+886677,int_stack+1034547,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1238667,int_stack+940677,int_stack+607821,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1324662,int_stack+1238667,int_stack+1081797,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1011552,int_stack+1324662,int_stack+1155507,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+575421,int_stack+97236,int_stack+89541,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+598506,int_stack+575421,int_stack+669246,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1118472,int_stack+598506,int_stack+689901,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+639816,int_stack+1118472,int_stack+886677,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1422942,int_stack+639816,int_stack+940677,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+886677,int_stack+1422942,int_stack+1238667,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1179672,int_stack+886677,int_stack+1324662,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1522167,int_stack+1179672,int_stack+1011552,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1001337,int_stack+105786,int_stack+97236,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1026987,int_stack+1001337,int_stack+575421,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1306032,int_stack+1026987,int_stack+598506,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1306032,int_stack+1118472,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1655817,int_stack+0,int_stack+639816,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+575421,int_stack+1655817,int_stack+1422942,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1769217,int_stack+575421,int_stack+886677,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1916637,int_stack+1769217,int_stack+1179672,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1073157,int_stack+1916637,int_stack+1522167,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+886677,int_stack+115236,int_stack+105786,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+915027,int_stack+886677,int_stack+1001337,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1374882,int_stack+915027,int_stack+1026987,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+886677,int_stack+1374882,int_stack+1306032,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1236507,int_stack+886677,int_stack+0,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+886677,int_stack+1236507,int_stack+1655817,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1236507,int_stack+886677,int_stack+575421,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+886677,int_stack+1236507,int_stack+1769217,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1236507,int_stack+886677,int_stack+1916637,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1429557,int_stack+1236507,int_stack+1073157,45);
 /*--- compute (kp|nn) ---*/
 hrr1_build_kp(Libint->AB,int_stack+886677,int_stack+1429557,int_stack+729861,4356);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1357125,int_stack+129261,int_stack+125631,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1368015,int_stack+133551,int_stack+129261,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1380885,int_stack+1368015,int_stack+1357125,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1402665,int_stack+138556,int_stack+133551,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1625577,int_stack+1402665,int_stack+1368015,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1651317,int_stack+1625577,int_stack+1380885,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1357125,int_stack+144331,int_stack+138556,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1687617,int_stack+1357125,int_stack+1402665,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1374450,int_stack+1687617,int_stack+1625577,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1717647,int_stack+1374450,int_stack+1651317,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1625577,int_stack+150931,int_stack+144331,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1645377,int_stack+1625577,int_stack+1357125,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1772097,int_stack+1645377,int_stack+1687617,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1822147,int_stack+1772097,int_stack+1374450,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1886497,int_stack+1822147,int_stack+1717647,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1357125,int_stack+158411,int_stack+150931,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1379565,int_stack+1357125,int_stack+1625577,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1680027,int_stack+1379565,int_stack+1645377,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1962727,int_stack+1680027,int_stack+1772097,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+575421,int_stack+1962727,int_stack+1822147,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1737777,int_stack+575421,int_stack+1886497,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1625577,int_stack+166826,int_stack+158411,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1839417,int_stack+1625577,int_stack+1357125,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1884297,int_stack+1839417,int_stack+1379565,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+665511,int_stack+1884297,int_stack+1680027,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+752136,int_stack+665511,int_stack+1962727,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1950297,int_stack+752136,int_stack+575421,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1950297,int_stack+1737777,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+575421,int_stack+176231,int_stack+166826,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+603636,int_stack+575421,int_stack+1625577,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1625577,int_stack+603636,int_stack+1839417,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1700377,int_stack+1625577,int_stack+1884297,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1799377,int_stack+1700377,int_stack+665511,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2070417,int_stack+1799377,int_stack+752136,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+654126,int_stack+2070417,int_stack+1950297,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2210557,int_stack+654126,int_stack+0,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+186681,int_stack+176231,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+31350,int_stack+0,int_stack+575421,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+87780,int_stack+31350,int_stack+603636,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1920652,int_stack+87780,int_stack+1625577,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2373907,int_stack+1920652,int_stack+1700377,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1625577,int_stack+2373907,int_stack+1799377,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2512507,int_stack+1625577,int_stack+2070417,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2692687,int_stack+2512507,int_stack+654126,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+575421,int_stack+2692687,int_stack+2210557,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1787277,int_stack+198231,int_stack+186681,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1821927,int_stack+1787277,int_stack+0,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+775071,int_stack+1821927,int_stack+31350,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1787277,int_stack+775071,int_stack+87780,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1787277,int_stack+1920652,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1787277,int_stack+0,int_stack+2373907,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1787277,int_stack+1625577,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1625577,int_stack+0,int_stack+2512507,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1850802,int_stack+1625577,int_stack+2692687,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2086752,int_stack+1850802,int_stack+575421,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+2326332,int_stack+2086752,int_stack+1429557,4356);
 /*--- compute (kd|nn) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2914392,int_stack+2326332,int_stack+886677,4356);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+575421,int_stack+215292,int_stack+210936,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+588489,int_stack+220440,int_stack+215292,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+603933,int_stack+588489,int_stack+575421,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+630069,int_stack+226446,int_stack+220440,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+648087,int_stack+630069,int_stack+588489,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+678975,int_stack+648087,int_stack+603933,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+575421,int_stack+233376,int_stack+226446,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+722535,int_stack+575421,int_stack+630069,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+596211,int_stack+722535,int_stack+648087,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+758571,int_stack+596211,int_stack+678975,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+647691,int_stack+241296,int_stack+233376,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+671451,int_stack+647691,int_stack+575421,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+823911,int_stack+671451,int_stack+722535,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+883971,int_stack+823911,int_stack+596211,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+961191,int_stack+883971,int_stack+758571,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+575421,int_stack+250272,int_stack+241296,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+713031,int_stack+575421,int_stack+647691,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1052667,int_stack+713031,int_stack+671451,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+602349,int_stack+1052667,int_stack+823911,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+760551,int_stack+602349,int_stack+883971,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1121967,int_stack+760551,int_stack+961191,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+868659,int_stack+260370,int_stack+250272,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+898953,int_stack+868659,int_stack+575421,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+952809,int_stack+898953,int_stack+713031,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1243935,int_stack+952809,int_stack+1052667,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1347885,int_stack+1243935,int_stack+602349,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+575421,int_stack+1347885,int_stack+760551,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1474011,int_stack+575421,int_stack+1121967,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+719565,int_stack+271656,int_stack+260370,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+753423,int_stack+719565,int_stack+868659,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1032009,int_stack+753423,int_stack+898953,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+814011,int_stack+1032009,int_stack+952809,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1630827,int_stack+814011,int_stack+1243935,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1121769,int_stack+1630827,int_stack+1347885,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1776357,int_stack+1121769,int_stack+575421,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1776357,int_stack+1474011,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+575421,int_stack+284196,int_stack+271656,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+613041,int_stack+575421,int_stack+719565,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1289937,int_stack+613041,int_stack+753423,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1390917,int_stack+1289937,int_stack+1032009,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+932811,int_stack+1390917,int_stack+814011,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+680757,int_stack+932811,int_stack+1630827,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1525557,int_stack+680757,int_stack+1121769,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3855288,int_stack+1525557,int_stack+1776357,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1741773,int_stack+3855288,int_stack+0,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+298056,int_stack+284196,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+41580,int_stack+0,int_stack+575421,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+116820,int_stack+41580,int_stack+613041,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1099131,int_stack+116820,int_stack+1289937,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1099131,int_stack+1390917,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1099131,int_stack+0,int_stack+932811,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1099131,int_stack+680757,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+575421,int_stack+0,int_stack+1525557,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+575421,int_stack+3855288,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+575421,int_stack+0,int_stack+1741773,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+862917,int_stack+575421,int_stack+2086752,4356);
 /*--- compute (ld|nn) ---*/
 hrr1_build_ld(Libint->AB,int_stack+3855288,int_stack+862917,int_stack+2326332,4356);
 /*--- compute (kf|nn) ---*/
 hrr1_build_kf(Libint->AB,int_stack+5031408,int_stack+3855288,int_stack+2914392,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+318450,int_stack+313302,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+324534,int_stack+318450,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+331632,int_stack+324534,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+339822,int_stack+331632,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173862,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+173862,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+216450,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+349182,int_stack+339822,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1581657,int_stack+113490,int_stack+173862,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1652637,int_stack+1581657,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1743897,int_stack+1652637,int_stack+216450,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+359790,int_stack+349182,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+162630,int_stack+0,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+218790,int_stack+162630,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+218790,int_stack+1581657,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1852005,int_stack+31824,int_stack+1652637,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1581657,int_stack+1852005,int_stack+1743897,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1725801,int_stack+371724,int_stack+359790,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1761603,int_stack+1725801,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1979769,int_stack+1761603,int_stack+162630,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2073369,int_stack+1979769,int_stack+218790,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+138294,int_stack+2073369,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2196219,int_stack+138294,int_stack+1852005,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2366571,int_stack+2196219,int_stack+1581657,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1581657,int_stack+385062,int_stack+371724,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1621671,int_stack+1581657,int_stack+1725801,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1621671,int_stack+1761603,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1693275,int_stack+0,int_stack+1979769,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1833675,int_stack+1693275,int_stack+2073369,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2551899,int_stack+1833675,int_stack+138294,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+106080,int_stack+2551899,int_stack+2196219,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2005665,int_stack+106080,int_stack+2366571,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2237325,int_stack+399882,int_stack+385062,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2281785,int_stack+2237325,int_stack+1581657,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2361813,int_stack+2281785,int_stack+1621671,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2750643,int_stack+2361813,int_stack+0,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2909763,int_stack+2750643,int_stack+1693275,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1581657,int_stack+2909763,int_stack+1833675,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3106323,int_stack+1581657,int_stack+2551899,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3361851,int_stack+3106323,int_stack+106080,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+3361851,int_stack+2005665,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+283140,int_stack+416262,int_stack+399882,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+332280,int_stack+283140,int_stack+2237325,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1810977,int_stack+332280,int_stack+2281785,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1944357,int_stack+1810977,int_stack+2361813,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2123367,int_stack+1944357,int_stack+2750643,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1810977,int_stack+2123367,int_stack+2909763,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2073057,int_stack+1810977,int_stack+1581657,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1581657,int_stack+2073057,int_stack+3106323,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1901067,int_stack+1581657,int_stack+3361851,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2235687,int_stack+1901067,int_stack+0,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+2575455,int_stack+2235687,int_stack+575421,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+6599568,int_stack+2575455,int_stack+862917,4356);
 /*--- compute (lf|nn) ---*/
 hrr1_build_lf(Libint->AB,int_stack+8037048,int_stack+6599568,int_stack+3855288,4356);
 /*--- compute (kg|nn) ---*/
 hrr1_build_kg(Libint->AB,int_stack+9997248,int_stack+8037048,int_stack+5031408,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+575421,int_stack+440286,int_stack+434280,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+593439,int_stack+447384,int_stack+440286,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+614733,int_stack+593439,int_stack+575421,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+650769,int_stack+455665,int_stack+447384,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+675612,int_stack+650769,int_stack+593439,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+718200,int_stack+675612,int_stack+614733,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+575421,int_stack+465220,int_stack+455665,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+778260,int_stack+575421,int_stack+650769,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+604086,int_stack+778260,int_stack+675612,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+827946,int_stack+604086,int_stack+718200,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+675066,int_stack+476140,int_stack+465220,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+707826,int_stack+675066,int_stack+575421,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+918036,int_stack+707826,int_stack+778260,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1000846,int_stack+918036,int_stack+604086,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1107316,int_stack+1000846,int_stack+827946,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+575421,int_stack+488516,int_stack+476140,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+765156,int_stack+575421,int_stack+675066,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1233442,int_stack+765156,int_stack+707826,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+612549,int_stack+1233442,int_stack+918036,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+830676,int_stack+612549,int_stack+1000846,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1328992,int_stack+830676,int_stack+1107316,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+979734,int_stack+502439,int_stack+488516,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1021503,int_stack+979734,int_stack+575421,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1095759,int_stack+1021503,int_stack+765156,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1497160,int_stack+1095759,int_stack+1233442,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1640485,int_stack+1497160,int_stack+612549,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+575421,int_stack+1640485,int_stack+830676,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1814386,int_stack+575421,int_stack+1328992,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+774165,int_stack+518000,int_stack+502439,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+820848,int_stack+774165,int_stack+979734,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1204959,int_stack+820848,int_stack+1021503,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+904386,int_stack+1204959,int_stack+1095759,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2030602,int_stack+904386,int_stack+1497160,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1328719,int_stack+2030602,int_stack+1640485,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1328719,int_stack+575421,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3437943,int_stack+0,int_stack+1814386,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+575421,int_stack+535290,int_stack+518000,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+627291,int_stack+575421,int_stack+774165,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1560587,int_stack+627291,int_stack+820848,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1699817,int_stack+1560587,int_stack+1204959,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1068186,int_stack+1699817,int_stack+904386,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+720657,int_stack+1068186,int_stack+2030602,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1885457,int_stack+720657,int_stack+1328719,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3708213,int_stack+1885457,int_stack+0,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+3708213,int_stack+3437943,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+3437943,int_stack+554400,int_stack+535290,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+3495273,int_stack+3437943,int_stack+575421,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+330330,int_stack+3495273,int_stack+627291,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+3437943,int_stack+330330,int_stack+1560587,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+330330,int_stack+3437943,int_stack+1699817,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1297506,int_stack+330330,int_stack+1068186,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+330330,int_stack+1297506,int_stack+720657,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+674310,int_stack+330330,int_stack+1885457,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1046955,int_stack+674310,int_stack+3708213,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+330330,int_stack+1046955,int_stack+0,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+726726,int_stack+330330,int_stack+2235687,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3437943,int_stack+726726,int_stack+2575455,4356);
 /*--- compute (mf|nn) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+3437943,int_stack+6599568,4356);
 /*--- compute (lg|nn) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2395800,int_stack+0,int_stack+8037048,4356);
 /*--- compute (kh|nn) ---*/
 hrr1_build_kh(Libint->AB,int_stack+5336100,int_stack+2395800,int_stack+9997248,4356);
 return int_stack+5336100;}
