/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kkmh(Libint_t*, prim_data*);

  /* Computes quartets of (kk|mh) integrals */

REALTYPE *hrr_order_kkmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[8][9] = int_stack + 18540;
 Libint->vrr_classes[8][10] = int_stack + 21015;
 Libint->vrr_classes[8][11] = int_stack + 23985;
 Libint->vrr_classes[8][12] = int_stack + 27495;
 Libint->vrr_classes[8][13] = int_stack + 31590;
 Libint->vrr_classes[8][14] = int_stack + 36315;
 Libint->vrr_classes[9][9] = int_stack + 41715;
 Libint->vrr_classes[9][10] = int_stack + 44740;
 Libint->vrr_classes[9][11] = int_stack + 48370;
 Libint->vrr_classes[9][12] = int_stack + 52660;
 Libint->vrr_classes[9][13] = int_stack + 57665;
 Libint->vrr_classes[9][14] = int_stack + 63440;
 Libint->vrr_classes[10][9] = int_stack + 70040;
 Libint->vrr_classes[10][10] = int_stack + 73670;
 Libint->vrr_classes[10][11] = int_stack + 78026;
 Libint->vrr_classes[10][12] = int_stack + 83174;
 Libint->vrr_classes[10][13] = int_stack + 89180;
 Libint->vrr_classes[10][14] = int_stack + 96110;
 Libint->vrr_classes[11][9] = int_stack + 104030;
 Libint->vrr_classes[11][10] = int_stack + 108320;
 Libint->vrr_classes[11][11] = int_stack + 113468;
 Libint->vrr_classes[11][12] = int_stack + 119552;
 Libint->vrr_classes[11][13] = int_stack + 126650;
 Libint->vrr_classes[11][14] = int_stack + 134840;
 Libint->vrr_classes[12][9] = int_stack + 144200;
 Libint->vrr_classes[12][10] = int_stack + 149205;
 Libint->vrr_classes[12][11] = int_stack + 155211;
 Libint->vrr_classes[12][12] = int_stack + 162309;
 Libint->vrr_classes[12][13] = int_stack + 170590;
 Libint->vrr_classes[12][14] = int_stack + 180145;
 Libint->vrr_classes[13][9] = int_stack + 191065;
 Libint->vrr_classes[13][10] = int_stack + 196840;
 Libint->vrr_classes[13][11] = int_stack + 203770;
 Libint->vrr_classes[13][12] = int_stack + 211960;
 Libint->vrr_classes[13][13] = int_stack + 221515;
 Libint->vrr_classes[13][14] = int_stack + 232540;
 Libint->vrr_classes[14][9] = int_stack + 245140;
 Libint->vrr_classes[14][10] = int_stack + 251740;
 Libint->vrr_classes[14][11] = int_stack + 259660;
 Libint->vrr_classes[14][12] = int_stack + 269020;
 Libint->vrr_classes[14][13] = int_stack + 279940;
 Libint->vrr_classes[14][14] = int_stack + 292540;
 memset(int_stack,0,306940*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 306940;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kkmh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+306940,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+312880,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+320008,int_stack+312880,int_stack+306940,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+331888,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+340312,int_stack+331888,int_stack+312880,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+354568,int_stack+340312,int_stack+320008,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+306940,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+374368,int_stack+306940,int_stack+331888,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+391216,int_stack+374368,int_stack+340312,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+316768,int_stack+391216,int_stack+354568,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+346468,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+414976,int_stack+346468,int_stack+306940,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+434632,int_stack+414976,int_stack+374368,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+346468,int_stack+434632,int_stack+391216,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+382108,int_stack+346468,int_stack+316768,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+306940,int_stack+21015,int_stack+18540,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+314365,int_stack+23985,int_stack+21015,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+323275,int_stack+314365,int_stack+306940,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+338125,int_stack+27495,int_stack+23985,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+348655,int_stack+338125,int_stack+314365,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+423688,int_stack+348655,int_stack+323275,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+306940,int_stack+31590,int_stack+27495,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+306940,int_stack+338125,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+448438,int_stack+0,int_stack+348655,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+319225,int_stack+448438,int_stack+423688,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+423688,int_stack+36315,int_stack+31590,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+356350,int_stack+423688,int_stack+306940,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+478138,int_stack+356350,int_stack+0,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+513238,int_stack+478138,int_stack+448438,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+423688,int_stack+513238,int_stack+319225,45);
 /*--- compute (kp|mh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+475663,int_stack+423688,int_stack+382108,1155);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+44740,int_stack+41715,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+48370,int_stack+44740,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+306940,int_stack+52660,int_stack+48370,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+319810,int_stack+306940,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+341590,int_stack+319810,int_stack+19965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+57665,int_stack+52660,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+15015,int_stack+0,int_stack+306940,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+371840,int_stack+15015,int_stack+319810,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+600403,int_stack+371840,int_stack+341590,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+306940,int_stack+63440,int_stack+57665,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+324265,int_stack+306940,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+645778,int_stack+324265,int_stack+15015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+645778,int_stack+371840,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+306940,int_stack+0,int_stack+600403,55);
 /*--- compute (lp|mh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+600403,int_stack+306940,int_stack+423688,1155);
 /*--- compute (kd|mh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+756328,int_stack+600403,int_stack+475663,1155);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+73670,int_stack+70040,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+78026,int_stack+73670,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+83174,int_stack+78026,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+370465,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+396601,int_stack+370465,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+89180,int_stack+83174,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+432901,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+18018,int_stack+432901,int_stack+370465,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+463789,int_stack+18018,int_stack+396601,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+370465,int_stack+96110,int_stack+89180,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+391255,int_stack+370465,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+518239,int_stack+391255,int_stack+432901,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+370465,int_stack+518239,int_stack+18018,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+518239,int_stack+370465,int_stack+463789,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1005808,int_stack+518239,int_stack+306940,1155);
 /*--- compute (ld|mh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1196383,int_stack+1005808,int_stack+600403,1155);
 /*--- compute (kf|mh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1508233,int_stack+1196383,int_stack+756328,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+306940,int_stack+108320,int_stack+104030,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+319810,int_stack+113468,int_stack+108320,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+335254,int_stack+319810,int_stack+306940,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+360994,int_stack+119552,int_stack+113468,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+379246,int_stack+360994,int_stack+319810,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+410134,int_stack+379246,int_stack+335254,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+306940,int_stack+126650,int_stack+119552,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+453034,int_stack+306940,int_stack+360994,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+594469,int_stack+453034,int_stack+379246,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+328234,int_stack+594469,int_stack+410134,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+392584,int_stack+134840,int_stack+126650,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+645949,int_stack+392584,int_stack+306940,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+688537,int_stack+645949,int_stack+453034,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+392584,int_stack+688537,int_stack+594469,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+594469,int_stack+392584,int_stack+328234,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+684559,int_stack+594469,int_stack+518239,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+1924033,int_stack+684559,int_stack+1005808,1155);
 /*--- compute (lf|mh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2305183,int_stack+1924033,int_stack+1196383,1155);
 /*--- compute (kg|mh) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2824933,int_stack+2305183,int_stack+1508233,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+913249,int_stack+149205,int_stack+144200,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+928264,int_stack+155211,int_stack+149205,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+946282,int_stack+928264,int_stack+913249,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+976312,int_stack+162309,int_stack+155211,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+997606,int_stack+976312,int_stack+928264,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1033642,int_stack+997606,int_stack+946282,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+913249,int_stack+170590,int_stack+162309,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1083692,int_stack+913249,int_stack+976312,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1126280,int_stack+1083692,int_stack+997606,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+938092,int_stack+1126280,int_stack+1033642,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1013167,int_stack+180145,int_stack+170590,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1186340,int_stack+1013167,int_stack+913249,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1236026,int_stack+1186340,int_stack+1083692,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1013167,int_stack+1236026,int_stack+1126280,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1103257,int_stack+1013167,int_stack+938092,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1208362,int_stack+1103257,int_stack+594469,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3448633,int_stack+1208362,int_stack+684559,1155);
 /*--- compute (mf|mh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+306940,int_stack+3448633,int_stack+1924033,1155);
 /*--- compute (lg|mh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1478632,int_stack+306940,int_stack+2305183,1155);
 /*--- compute (kh|mh) ---*/
 hrr1_build_kh(Libint->AB,int_stack+3906013,int_stack+1478632,int_stack+2824933,1155);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2258257,int_stack+196840,int_stack+191065,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2275582,int_stack+203770,int_stack+196840,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2296372,int_stack+2275582,int_stack+2258257,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2331022,int_stack+211960,int_stack+203770,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2355592,int_stack+2331022,int_stack+2275582,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2397172,int_stack+2355592,int_stack+2296372,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2258257,int_stack+221515,int_stack+211960,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2454922,int_stack+2258257,int_stack+2331022,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2504062,int_stack+2454922,int_stack+2355592,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2286922,int_stack+2504062,int_stack+2397172,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2373547,int_stack+232540,int_stack+221515,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2573362,int_stack+2373547,int_stack+2258257,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2630692,int_stack+2573362,int_stack+2454922,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2373547,int_stack+2630692,int_stack+2504062,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2477497,int_stack+2373547,int_stack+2286922,105);
 /*--- compute (qp|mh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2598772,int_stack+2477497,int_stack+1103257,1155);
 /*--- compute (od|mh) ---*/
 hrr1_build_od(Libint->AB,int_stack+4779193,int_stack+2598772,int_stack+1208362,1155);
 /*--- compute (nf|mh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5319733,int_stack+4779193,int_stack+3448633,1155);
 /*--- compute (mg|mh) ---*/
 hrr1_build_mg(Libint->AB,int_stack+2914087,int_stack+5319733,int_stack+306940,1155);
 /*--- compute (lh|mh) ---*/
 hrr1_build_lh(Libint->AB,int_stack+306940,int_stack+2914087,int_stack+1478632,1155);
 /*--- compute (ki|mh) ---*/
 hrr1_build_ki(Libint->AB,int_stack+6082033,int_stack+306940,int_stack+3906013,1155);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1398415,int_stack+251740,int_stack+245140,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1418215,int_stack+259660,int_stack+251740,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1441975,int_stack+1418215,int_stack+1398415,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1481575,int_stack+269020,int_stack+259660,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1509655,int_stack+1481575,int_stack+1418215,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1557175,int_stack+1509655,int_stack+1441975,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1398415,int_stack+279940,int_stack+269020,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1623175,int_stack+1398415,int_stack+1481575,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1679335,int_stack+1623175,int_stack+1509655,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1431175,int_stack+1679335,int_stack+1557175,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1530175,int_stack+292540,int_stack+279940,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1758535,int_stack+1530175,int_stack+1398415,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1824055,int_stack+1758535,int_stack+1623175,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1530175,int_stack+1824055,int_stack+1679335,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1648975,int_stack+1530175,int_stack+1431175,120);
 /*--- compute (rp|mh) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1787575,int_stack+1648975,int_stack+2477497,1155);
 /*--- compute (qd|mh) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3866962,int_stack+1787575,int_stack+2598772,1155);
 /*--- compute (of|mh) ---*/
 hrr1_build_of(Libint->AB,int_stack+1398415,int_stack+3866962,int_stack+4779193,1155);
 /*--- compute (ng|mh) ---*/
 hrr1_build_ng(Libint->AB,int_stack+3866962,int_stack+1398415,int_stack+5319733,1155);
 /*--- compute (mh|mh) ---*/
 hrr1_build_mh(Libint->AB,int_stack+1398415,int_stack+3866962,int_stack+2914087,1155);
 /*--- compute (li|mh) ---*/
 hrr1_build_li(Libint->AB,int_stack+2732440,int_stack+1398415,int_stack+306940,1155);
 /*--- compute (kk|mh) ---*/
 hrr1_build_kk(Libint->AB,int_stack+4187740,int_stack+2732440,int_stack+6082033,1155);
 return int_stack+4187740;}
