/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldhh(Libint_t*, prim_data*);

  /* Computes quartets of (ld|hh) integrals */

REALTYPE *hrr_order_ldhh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][5] = int_stack + 0;
 Libint->vrr_classes[8][6] = int_stack + 945;
 Libint->vrr_classes[8][7] = int_stack + 2205;
 Libint->vrr_classes[8][8] = int_stack + 3825;
 Libint->vrr_classes[8][9] = int_stack + 5850;
 Libint->vrr_classes[8][10] = int_stack + 8325;
 Libint->vrr_classes[9][5] = int_stack + 11295;
 Libint->vrr_classes[9][6] = int_stack + 12450;
 Libint->vrr_classes[9][7] = int_stack + 13990;
 Libint->vrr_classes[9][8] = int_stack + 15970;
 Libint->vrr_classes[9][9] = int_stack + 18445;
 Libint->vrr_classes[9][10] = int_stack + 21470;
 Libint->vrr_classes[10][5] = int_stack + 25100;
 Libint->vrr_classes[10][6] = int_stack + 26486;
 Libint->vrr_classes[10][7] = int_stack + 28334;
 Libint->vrr_classes[10][8] = int_stack + 30710;
 Libint->vrr_classes[10][9] = int_stack + 33680;
 Libint->vrr_classes[10][10] = int_stack + 37310;
 memset(int_stack,0,41666*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 41666;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldhh(Libint, Data);
   Data++;
 }
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+41666,int_stack+945,int_stack+0,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+44501,int_stack+2205,int_stack+945,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+48281,int_stack+44501,int_stack+41666,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+53951,int_stack+3825,int_stack+2205,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+58811,int_stack+53951,int_stack+44501,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+66371,int_stack+58811,int_stack+48281,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41666,int_stack+5850,int_stack+3825,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+75821,int_stack+41666,int_stack+53951,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+85541,int_stack+75821,int_stack+58811,45);
 /*--- compute (l0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+47741,int_stack+85541,int_stack+66371,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+61916,int_stack+8325,int_stack+5850,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+98141,int_stack+61916,int_stack+41666,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+110291,int_stack+98141,int_stack+75821,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+61916,int_stack+110291,int_stack+85541,45);
 /*--- compute (l0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+80816,int_stack+61916,int_stack+47741,45);
 /*--- compute (m0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+41666,int_stack+12450,int_stack+11295,55);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+45131,int_stack+13990,int_stack+12450,55);
 /*--- compute (m0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+49751,int_stack+45131,int_stack+41666,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+56681,int_stack+15970,int_stack+13990,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+62621,int_stack+56681,int_stack+45131,55);
 /*--- compute (m0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+100661,int_stack+62621,int_stack+49751,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41666,int_stack+18445,int_stack+15970,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+112211,int_stack+41666,int_stack+56681,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+112211,int_stack+62621,55);
 /*--- compute (m0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+49091,int_stack+0,int_stack+100661,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+100661,int_stack+21470,int_stack+18445,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+124091,int_stack+100661,int_stack+41666,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+138941,int_stack+124091,int_stack+112211,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+100661,int_stack+138941,int_stack+0,55);
 /*--- compute (m0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+0,int_stack+100661,int_stack+49091,55);
 /*--- compute (lp|hh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+100661,int_stack+0,int_stack+80816,441);
 /*--- compute (n0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+41666,int_stack+26486,int_stack+25100,66);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+45824,int_stack+28334,int_stack+26486,66);
 /*--- compute (n0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+51368,int_stack+45824,int_stack+41666,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+59684,int_stack+30710,int_stack+28334,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+66812,int_stack+59684,int_stack+45824,66);
 /*--- compute (n0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+77900,int_stack+66812,int_stack+51368,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41666,int_stack+33680,int_stack+30710,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+160196,int_stack+41666,int_stack+59684,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+174452,int_stack+160196,int_stack+66812,66);
 /*--- compute (n0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+50576,int_stack+174452,int_stack+77900,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+71366,int_stack+37310,int_stack+33680,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+82256,int_stack+71366,int_stack+41666,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+24255,int_stack+82256,int_stack+160196,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+71366,int_stack+24255,int_stack+174452,66);
 /*--- compute (n0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+160196,int_stack+71366,int_stack+50576,66);
 /*--- compute (mp|hh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+24255,int_stack+160196,int_stack+0,441);
 /*--- compute (ld|hh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+160196,int_stack+24255,int_stack+100661,441);
 return int_stack+160196;}
