/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldmk(Libint_t*, prim_data*);

  /* Computes quartets of (ld|mk) integrals */

REALTYPE *hrr_order_ldmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[9][9] = int_stack + 36180;
 Libint->vrr_classes[9][10] = int_stack + 39205;
 Libint->vrr_classes[9][11] = int_stack + 42835;
 Libint->vrr_classes[9][12] = int_stack + 47125;
 Libint->vrr_classes[9][13] = int_stack + 52130;
 Libint->vrr_classes[9][14] = int_stack + 57905;
 Libint->vrr_classes[9][15] = int_stack + 64505;
 Libint->vrr_classes[9][16] = int_stack + 71985;
 Libint->vrr_classes[10][9] = int_stack + 80400;
 Libint->vrr_classes[10][10] = int_stack + 84030;
 Libint->vrr_classes[10][11] = int_stack + 88386;
 Libint->vrr_classes[10][12] = int_stack + 93534;
 Libint->vrr_classes[10][13] = int_stack + 99540;
 Libint->vrr_classes[10][14] = int_stack + 106470;
 Libint->vrr_classes[10][15] = int_stack + 114390;
 Libint->vrr_classes[10][16] = int_stack + 123366;
 memset(int_stack,0,133464*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 133464;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldmk(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+133464,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+140889,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+149799,int_stack+140889,int_stack+133464,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+164649,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+175179,int_stack+164649,int_stack+140889,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+192999,int_stack+175179,int_stack+149799,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+133464,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+217749,int_stack+133464,int_stack+164649,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+238809,int_stack+217749,int_stack+175179,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+145749,int_stack+238809,int_stack+192999,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+182874,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+268509,int_stack+182874,int_stack+133464,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+293079,int_stack+268509,int_stack+217749,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+328179,int_stack+293079,int_stack+238809,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+197049,int_stack+328179,int_stack+145749,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+133464,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+149664,int_stack+133464,int_stack+182874,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+372729,int_stack+149664,int_stack+268509,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+413679,int_stack+372729,int_stack+293079,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+249024,int_stack+413679,int_stack+328179,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+466329,int_stack+249024,int_stack+197049,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+178014,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+196374,int_stack+178014,int_stack+133464,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+311394,int_stack+196374,int_stack+149664,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+133464,int_stack+311394,int_stack+372729,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+311394,int_stack+133464,int_stack+413679,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+133464,int_stack+311394,int_stack+249024,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+216624,int_stack+133464,int_stack+466329,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+133464,int_stack+39205,int_stack+36180,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+142539,int_stack+42835,int_stack+39205,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+153429,int_stack+142539,int_stack+133464,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+171579,int_stack+47125,int_stack+42835,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+184449,int_stack+171579,int_stack+142539,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+305724,int_stack+184449,int_stack+153429,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+133464,int_stack+52130,int_stack+47125,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+335974,int_stack+133464,int_stack+171579,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+361714,int_stack+335974,int_stack+184449,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+148479,int_stack+361714,int_stack+305724,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+305724,int_stack+57905,int_stack+52130,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+398014,int_stack+305724,int_stack+133464,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+428044,int_stack+398014,int_stack+335974,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+470944,int_stack+428044,int_stack+361714,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+323049,int_stack+470944,int_stack+148479,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+133464,int_stack+64505,int_stack+57905,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+153264,int_stack+133464,int_stack+305724,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+153264,int_stack+398014,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+525394,int_stack+0,int_stack+428044,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+386574,int_stack+525394,int_stack+470944,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+589744,int_stack+386574,int_stack+323049,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+305724,int_stack+71985,int_stack+64505,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+328164,int_stack+305724,int_stack+133464,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+462804,int_stack+328164,int_stack+153264,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+133464,int_stack+462804,int_stack+0,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+674444,int_stack+133464,int_stack+525394,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+462804,int_stack+674444,int_stack+386574,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+305724,int_stack+462804,int_stack+589744,55);
 /*--- compute (lp|mk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+414624,int_stack+305724,int_stack+216624,1980);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+133464,int_stack+84030,int_stack+80400,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+144354,int_stack+88386,int_stack+84030,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+157422,int_stack+144354,int_stack+133464,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+179202,int_stack+93534,int_stack+88386,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+194646,int_stack+179202,int_stack+144354,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+220782,int_stack+194646,int_stack+157422,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+133464,int_stack+99540,int_stack+93534,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+257082,int_stack+133464,int_stack+179202,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+257082,int_stack+194646,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+151482,int_stack+0,int_stack+220782,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+205932,int_stack+106470,int_stack+99540,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+43560,int_stack+205932,int_stack+133464,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+681924,int_stack+43560,int_stack+257082,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+226722,int_stack+681924,int_stack+0,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+733404,int_stack+226722,int_stack+151482,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+114390,int_stack+106470,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+133464,int_stack+0,int_stack+205932,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+809634,int_stack+133464,int_stack+43560,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+23760,int_stack+809634,int_stack+681924,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+869694,int_stack+23760,int_stack+226722,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+175044,int_stack+869694,int_stack+733404,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+681924,int_stack+123366,int_stack+114390,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+708852,int_stack+681924,int_stack+0,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+961170,int_stack+708852,int_stack+133464,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+681924,int_stack+961170,int_stack+809634,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+961170,int_stack+681924,int_stack+23760,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+681924,int_stack+961170,int_stack+869694,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+803892,int_stack+681924,int_stack+175044,66);
 /*--- compute (mp|mk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+934572,int_stack+803892,int_stack+305724,1980);
 /*--- compute (ld|mk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1261272,int_stack+934572,int_stack+414624,1980);
 return int_stack+1261272;}
