/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhli(Libint_t*, prim_data*);

  /* Computes quartets of (lh|li) integrals */

REALTYPE *hrr_order_lhli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[8][14] = int_stack + 19800;
 Libint->vrr_classes[9][8] = int_stack + 25200;
 Libint->vrr_classes[9][9] = int_stack + 27675;
 Libint->vrr_classes[9][10] = int_stack + 30700;
 Libint->vrr_classes[9][11] = int_stack + 34330;
 Libint->vrr_classes[9][12] = int_stack + 38620;
 Libint->vrr_classes[9][13] = int_stack + 43625;
 Libint->vrr_classes[9][14] = int_stack + 49400;
 Libint->vrr_classes[10][8] = int_stack + 56000;
 Libint->vrr_classes[10][9] = int_stack + 58970;
 Libint->vrr_classes[10][10] = int_stack + 62600;
 Libint->vrr_classes[10][11] = int_stack + 66956;
 Libint->vrr_classes[10][12] = int_stack + 72104;
 Libint->vrr_classes[10][13] = int_stack + 78110;
 Libint->vrr_classes[10][14] = int_stack + 85040;
 Libint->vrr_classes[11][8] = int_stack + 92960;
 Libint->vrr_classes[11][9] = int_stack + 96470;
 Libint->vrr_classes[11][10] = int_stack + 100760;
 Libint->vrr_classes[11][11] = int_stack + 105908;
 Libint->vrr_classes[11][12] = int_stack + 111992;
 Libint->vrr_classes[11][13] = int_stack + 119090;
 Libint->vrr_classes[11][14] = int_stack + 127280;
 Libint->vrr_classes[12][8] = int_stack + 136640;
 Libint->vrr_classes[12][9] = int_stack + 140735;
 Libint->vrr_classes[12][10] = int_stack + 145740;
 Libint->vrr_classes[12][11] = int_stack + 151746;
 Libint->vrr_classes[12][12] = int_stack + 158844;
 Libint->vrr_classes[12][13] = int_stack + 167125;
 Libint->vrr_classes[12][14] = int_stack + 176680;
 Libint->vrr_classes[13][8] = int_stack + 187600;
 Libint->vrr_classes[13][9] = int_stack + 192325;
 Libint->vrr_classes[13][10] = int_stack + 198100;
 Libint->vrr_classes[13][11] = int_stack + 205030;
 Libint->vrr_classes[13][12] = int_stack + 213220;
 Libint->vrr_classes[13][13] = int_stack + 222775;
 Libint->vrr_classes[13][14] = int_stack + 233800;
 memset(int_stack,0,246400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 246400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhli(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+246400,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+252475,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+259900,int_stack+252475,int_stack+246400,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+272050,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+280960,int_stack+272050,int_stack+252475,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+295810,int_stack+280960,int_stack+259900,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+246400,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+316060,int_stack+246400,int_stack+272050,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+333880,int_stack+316060,int_stack+280960,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+256930,int_stack+333880,int_stack+295810,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+287305,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+358630,int_stack+287305,int_stack+246400,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+379690,int_stack+358630,int_stack+316060,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+409390,int_stack+379690,int_stack+333880,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+299590,int_stack+409390,int_stack+256930,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+246400,int_stack+19800,int_stack+15075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+260575,int_stack+246400,int_stack+287305,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+446515,int_stack+260575,int_stack+358630,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+246400,int_stack+446515,int_stack+379690,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+342115,int_stack+246400,int_stack+409390,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+394090,int_stack+342115,int_stack+299590,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+246400,int_stack+27675,int_stack+25200,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+253825,int_stack+30700,int_stack+27675,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+262900,int_stack+253825,int_stack+246400,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+277750,int_stack+34330,int_stack+30700,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+288640,int_stack+277750,int_stack+253825,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+306790,int_stack+288640,int_stack+262900,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+246400,int_stack+38620,int_stack+34330,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+331540,int_stack+246400,int_stack+277750,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+353320,int_stack+331540,int_stack+288640,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+259270,int_stack+353320,int_stack+306790,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+296395,int_stack+43625,int_stack+38620,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+450790,int_stack+296395,int_stack+246400,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+450790,int_stack+331540,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+476530,int_stack+0,int_stack+353320,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+311410,int_stack+476530,int_stack+259270,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+246400,int_stack+49400,int_stack+43625,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+263725,int_stack+246400,int_stack+296395,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+521905,int_stack+263725,int_stack+450790,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+246400,int_stack+521905,int_stack+0,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+521905,int_stack+246400,int_stack+476530,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+450790,int_stack+521905,int_stack+311410,55);
 /*--- compute (lp|li) ---*/
 hrr1_build_lp(Libint->AB,int_stack+520090,int_stack+450790,int_stack+394090,1260);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+246400,int_stack+58970,int_stack+56000,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+255310,int_stack+62600,int_stack+58970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+266200,int_stack+255310,int_stack+246400,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+284020,int_stack+66956,int_stack+62600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+297088,int_stack+284020,int_stack+255310,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+318868,int_stack+297088,int_stack+266200,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+246400,int_stack+72104,int_stack+66956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+348568,int_stack+246400,int_stack+284020,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+374704,int_stack+348568,int_stack+297088,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+261844,int_stack+374704,int_stack+318868,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+306394,int_stack+78110,int_stack+72104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+411004,int_stack+306394,int_stack+246400,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+411004,int_stack+348568,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+690190,int_stack+0,int_stack+374704,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+324412,int_stack+690190,int_stack+261844,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+246400,int_stack+85040,int_stack+78110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267190,int_stack+246400,int_stack+306394,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+744640,int_stack+267190,int_stack+411004,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+246400,int_stack+744640,int_stack+0,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+246400,int_stack+690190,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+690190,int_stack+0,int_stack+324412,66);
 /*--- compute (mp|li) ---*/
 hrr1_build_mp(Libint->AB,int_stack+773350,int_stack+690190,int_stack+450790,1260);
 /*--- compute (ld|li) ---*/
 hrr1_build_ld(Libint->AB,int_stack+981250,int_stack+773350,int_stack+520090,1260);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+96470,int_stack+92960,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+100760,int_stack+96470,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+105908,int_stack+100760,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59904,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+246400,int_stack+59904,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+111992,int_stack+105908,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+281500,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+312388,int_stack+281500,int_stack+59904,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18252,int_stack+312388,int_stack+246400,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+246400,int_stack+119090,int_stack+111992,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+70902,int_stack+246400,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+355288,int_stack+70902,int_stack+281500,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+406768,int_stack+355288,int_stack+312388,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+267694,int_stack+406768,int_stack+18252,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+127280,int_stack+119090,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+24570,int_stack+0,int_stack+246400,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+471118,int_stack+24570,int_stack+70902,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+471118,int_stack+355288,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+471118,int_stack+0,int_stack+406768,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+471118,int_stack+267694,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+246400,int_stack+0,int_stack+690190,1260);
 /*--- compute (md|li) ---*/
 hrr1_build_md(Libint->AB,int_stack+1321450,int_stack+246400,int_stack+773350,1260);
 /*--- compute (lf|li) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1737250,int_stack+1321450,int_stack+981250,1260);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+98280,int_stack+140735,int_stack+136640,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+110565,int_stack+145740,int_stack+140735,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+495880,int_stack+110565,int_stack+98280,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125580,int_stack+151746,int_stack+145740,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+520450,int_stack+125580,int_stack+110565,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+550480,int_stack+520450,int_stack+495880,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+495880,int_stack+158844,int_stack+151746,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+591430,int_stack+495880,int_stack+125580,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+98280,int_stack+591430,int_stack+520450,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+627466,int_stack+98280,int_stack+550480,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+517174,int_stack+167125,int_stack+158844,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+542017,int_stack+517174,int_stack+495880,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+688891,int_stack+542017,int_stack+591430,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+748951,int_stack+688891,int_stack+98280,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+824026,int_stack+748951,int_stack+627466,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+98280,int_stack+176680,int_stack+167125,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+126945,int_stack+98280,int_stack+517174,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+584605,int_stack+126945,int_stack+542017,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+910021,int_stack+584605,int_stack+688891,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+495880,int_stack+910021,int_stack+748951,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+910021,int_stack+495880,int_stack+824026,91);
 /*--- compute (op|li) ---*/
 hrr1_build_op(Libint->AB,int_stack+495880,int_stack+910021,int_stack+0,1260);
 /*--- compute (nd|li) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2304250,int_stack+495880,int_stack+246400,1260);
 /*--- compute (mf|li) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2803210,int_stack+2304250,int_stack+1321450,1260);
 /*--- compute (lg|li) ---*/
 hrr1_build_lg(Libint->AB,int_stack+3496210,int_stack+2803210,int_stack+1737250,1260);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+246400,int_stack+192325,int_stack+187600,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+260575,int_stack+198100,int_stack+192325,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+277900,int_stack+260575,int_stack+246400,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+306250,int_stack+205030,int_stack+198100,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+327040,int_stack+306250,int_stack+260575,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+361690,int_stack+327040,int_stack+277900,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+246400,int_stack+213220,int_stack+205030,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+408940,int_stack+246400,int_stack+306250,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+408940,int_stack+327040,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+270970,int_stack+0,int_stack+361690,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+341845,int_stack+222775,int_stack+213220,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57750,int_stack+341845,int_stack+246400,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+106890,int_stack+57750,int_stack+408940,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+370510,int_stack+106890,int_stack+0,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+790720,int_stack+370510,int_stack+270970,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+233800,int_stack+222775,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+176190,int_stack+0,int_stack+341845,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+233520,int_stack+176190,int_stack+57750,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+233520,int_stack+106890,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+103950,int_stack+0,int_stack+370510,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+225225,int_stack+103950,int_stack+790720,105);
 /*--- compute (qp|li) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1024681,int_stack+225225,int_stack+910021,1260);
 /*--- compute (od|li) ---*/
 hrr1_build_od(Libint->AB,int_stack+1368661,int_stack+1024681,int_stack+495880,1260);
 /*--- compute (nf|li) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+1368661,int_stack+2304250,1260);
 /*--- compute (mg|li) ---*/
 hrr1_build_mg(Libint->AB,int_stack+831600,int_stack+0,int_stack+2803210,1260);
 /*--- compute (lh|li) ---*/
 hrr1_build_lh(Libint->AB,int_stack+1871100,int_stack+831600,int_stack+3496210,1260);
 return int_stack+1871100;}
