/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhmm(Libint_t*, prim_data*);

  /* Computes quartets of (lh|mm) integrals */

REALTYPE *hrr_order_lhmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[8][18] = int_stack + 43875;
 Libint->vrr_classes[9][9] = int_stack + 52425;
 Libint->vrr_classes[9][10] = int_stack + 55450;
 Libint->vrr_classes[9][11] = int_stack + 59080;
 Libint->vrr_classes[9][12] = int_stack + 63370;
 Libint->vrr_classes[9][13] = int_stack + 68375;
 Libint->vrr_classes[9][14] = int_stack + 74150;
 Libint->vrr_classes[9][15] = int_stack + 80750;
 Libint->vrr_classes[9][16] = int_stack + 88230;
 Libint->vrr_classes[9][17] = int_stack + 96645;
 Libint->vrr_classes[9][18] = int_stack + 106050;
 Libint->vrr_classes[10][9] = int_stack + 116500;
 Libint->vrr_classes[10][10] = int_stack + 120130;
 Libint->vrr_classes[10][11] = int_stack + 124486;
 Libint->vrr_classes[10][12] = int_stack + 129634;
 Libint->vrr_classes[10][13] = int_stack + 135640;
 Libint->vrr_classes[10][14] = int_stack + 142570;
 Libint->vrr_classes[10][15] = int_stack + 150490;
 Libint->vrr_classes[10][16] = int_stack + 159466;
 Libint->vrr_classes[10][17] = int_stack + 169564;
 Libint->vrr_classes[10][18] = int_stack + 180850;
 Libint->vrr_classes[11][9] = int_stack + 193390;
 Libint->vrr_classes[11][10] = int_stack + 197680;
 Libint->vrr_classes[11][11] = int_stack + 202828;
 Libint->vrr_classes[11][12] = int_stack + 208912;
 Libint->vrr_classes[11][13] = int_stack + 216010;
 Libint->vrr_classes[11][14] = int_stack + 224200;
 Libint->vrr_classes[11][15] = int_stack + 233560;
 Libint->vrr_classes[11][16] = int_stack + 244168;
 Libint->vrr_classes[11][17] = int_stack + 256102;
 Libint->vrr_classes[11][18] = int_stack + 269440;
 Libint->vrr_classes[12][9] = int_stack + 284260;
 Libint->vrr_classes[12][10] = int_stack + 289265;
 Libint->vrr_classes[12][11] = int_stack + 295271;
 Libint->vrr_classes[12][12] = int_stack + 302369;
 Libint->vrr_classes[12][13] = int_stack + 310650;
 Libint->vrr_classes[12][14] = int_stack + 320205;
 Libint->vrr_classes[12][15] = int_stack + 331125;
 Libint->vrr_classes[12][16] = int_stack + 343501;
 Libint->vrr_classes[12][17] = int_stack + 357424;
 Libint->vrr_classes[12][18] = int_stack + 372985;
 Libint->vrr_classes[13][9] = int_stack + 390275;
 Libint->vrr_classes[13][10] = int_stack + 396050;
 Libint->vrr_classes[13][11] = int_stack + 402980;
 Libint->vrr_classes[13][12] = int_stack + 411170;
 Libint->vrr_classes[13][13] = int_stack + 420725;
 Libint->vrr_classes[13][14] = int_stack + 431750;
 Libint->vrr_classes[13][15] = int_stack + 444350;
 Libint->vrr_classes[13][16] = int_stack + 458630;
 Libint->vrr_classes[13][17] = int_stack + 474695;
 Libint->vrr_classes[13][18] = int_stack + 492650;
 memset(int_stack,0,512600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 512600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhmm(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+512600,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+520025,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+528935,int_stack+520025,int_stack+512600,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+543785,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+554315,int_stack+543785,int_stack+520025,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+572135,int_stack+554315,int_stack+528935,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+512600,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+596885,int_stack+512600,int_stack+543785,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+617945,int_stack+596885,int_stack+554315,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+524885,int_stack+617945,int_stack+572135,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+562010,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+647645,int_stack+562010,int_stack+512600,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+672215,int_stack+647645,int_stack+596885,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+707315,int_stack+672215,int_stack+617945,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+576185,int_stack+707315,int_stack+524885,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+512600,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+528800,int_stack+512600,int_stack+562010,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+751865,int_stack+528800,int_stack+647645,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+792815,int_stack+751865,int_stack+672215,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+628160,int_stack+792815,int_stack+707315,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+845465,int_stack+628160,int_stack+576185,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+557150,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+575510,int_stack+557150,int_stack+512600,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+690530,int_stack+575510,int_stack+528800,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+914765,int_stack+690530,int_stack+751865,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+976190,int_stack+914765,int_stack+792815,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+737780,int_stack+976190,int_stack+628160,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1049900,int_stack+737780,int_stack+845465,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+512600,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+607910,int_stack+512600,int_stack+557150,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+820940,int_stack+607910,int_stack+575510,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+533255,int_stack+820940,int_stack+690530,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+644630,int_stack+533255,int_stack+914765,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+874940,int_stack+644630,int_stack+976190,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1139000,int_stack+874940,int_stack+737780,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1245920,int_stack+1139000,int_stack+1049900,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+730625,int_stack+43875,int_stack+36180,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+753710,int_stack+730625,int_stack+512600,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+973220,int_stack+753710,int_stack+607910,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+730625,int_stack+973220,int_stack+820940,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+973220,int_stack+730625,int_stack+533255,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+730625,int_stack+973220,int_stack+644630,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+973220,int_stack+730625,int_stack+874940,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+512600,int_stack+973220,int_stack+1139000,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+646250,int_stack+512600,int_stack+1245920,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+512600,int_stack+55450,int_stack+52425,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+521675,int_stack+59080,int_stack+55450,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+532565,int_stack+521675,int_stack+512600,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+550715,int_stack+63370,int_stack+59080,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+563585,int_stack+550715,int_stack+521675,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+585365,int_stack+563585,int_stack+532565,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+512600,int_stack+68375,int_stack+63370,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+615615,int_stack+512600,int_stack+550715,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+782375,int_stack+615615,int_stack+563585,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+527615,int_stack+782375,int_stack+585365,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+572990,int_stack+74150,int_stack+68375,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+818675,int_stack+572990,int_stack+512600,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+848705,int_stack+818675,int_stack+615615,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+590315,int_stack+848705,int_stack+782375,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+891605,int_stack+590315,int_stack+527615,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+782375,int_stack+80750,int_stack+74150,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+512600,int_stack+782375,int_stack+572990,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+955130,int_stack+512600,int_stack+818675,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1005180,int_stack+955130,int_stack+848705,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+802175,int_stack+1005180,int_stack+590315,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+547250,int_stack+802175,int_stack+891605,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+878405,int_stack+88230,int_stack+80750,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+900845,int_stack+878405,int_stack+782375,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1069530,int_stack+900845,int_stack+512600,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1127280,int_stack+1069530,int_stack+955130,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1202355,int_stack+1127280,int_stack+1005180,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+940445,int_stack+1202355,int_stack+802175,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1292445,int_stack+940445,int_stack+547250,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+512600,int_stack+96645,int_stack+88230,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+537845,int_stack+512600,int_stack+878405,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+782375,int_stack+537845,int_stack+900845,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+848375,int_stack+782375,int_stack+1069530,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1401345,int_stack+848375,int_stack+1127280,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1042085,int_stack+1401345,int_stack+1202355,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1506450,int_stack+1042085,int_stack+940445,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1637130,int_stack+1506450,int_stack+1292445,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+582725,int_stack+106050,int_stack+96645,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+935000,int_stack+582725,int_stack+512600,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1162205,int_stack+935000,int_stack+537845,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+935000,int_stack+1162205,int_stack+782375,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1162205,int_stack+935000,int_stack+848375,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+782375,int_stack+1162205,int_stack+1401345,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1162205,int_stack+782375,int_stack+1042085,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+782375,int_stack+1162205,int_stack+1506450,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+945725,int_stack+782375,int_stack+1637130,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1112100,int_stack+945725,int_stack+646250,3025);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1520475,int_stack+120130,int_stack+116500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1531365,int_stack+124486,int_stack+120130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1544433,int_stack+1531365,int_stack+1520475,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1566213,int_stack+129634,int_stack+124486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1581657,int_stack+1566213,int_stack+1531365,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1607793,int_stack+1581657,int_stack+1544433,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1520475,int_stack+135640,int_stack+129634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1644093,int_stack+1520475,int_stack+1566213,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1674981,int_stack+1644093,int_stack+1581657,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1538493,int_stack+1674981,int_stack+1607793,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1592943,int_stack+142570,int_stack+135640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1718541,int_stack+1592943,int_stack+1520475,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+512600,int_stack+1718541,int_stack+1644093,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+564080,int_stack+512600,int_stack+1674981,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1613733,int_stack+564080,int_stack+1538493,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1520475,int_stack+150490,int_stack+142570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1544235,int_stack+1520475,int_stack+1592943,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+629420,int_stack+1544235,int_stack+1718541,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1689963,int_stack+629420,int_stack+512600,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+689480,int_stack+1689963,int_stack+564080,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+512600,int_stack+689480,int_stack+1613733,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1585815,int_stack+159466,int_stack+150490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1612743,int_stack+1585815,int_stack+1520475,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+780956,int_stack+1612743,int_stack+1544235,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+850256,int_stack+780956,int_stack+629420,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+850256,int_stack+1689963,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1660263,int_stack+0,int_stack+689480,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+614240,int_stack+1660263,int_stack+512600,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+512600,int_stack+169564,int_stack+159466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+542894,int_stack+512600,int_stack+1585815,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1520475,int_stack+542894,int_stack+1612743,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1782231,int_stack+1520475,int_stack+780956,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1886181,int_stack+1782231,int_stack+850256,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+744920,int_stack+1886181,int_stack+0,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+744920,int_stack+1660263,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1599675,int_stack+0,int_stack+614240,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+596750,int_stack+180850,int_stack+169564,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+630608,int_stack+596750,int_stack+512600,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2012307,int_stack+630608,int_stack+542894,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+512600,int_stack+2012307,int_stack+1520475,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2012307,int_stack+512600,int_stack+1782231,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+512600,int_stack+2012307,int_stack+1886181,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1763025,int_stack+512600,int_stack+744920,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+512600,int_stack+1763025,int_stack+0,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1763025,int_stack+512600,int_stack+1599675,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1962675,int_stack+1763025,int_stack+945725,3025);
 /*--- compute (ld|mm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2461800,int_stack+1962675,int_stack+1112100,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+512600,int_stack+197680,int_stack+193390,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+525470,int_stack+202828,int_stack+197680,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+540914,int_stack+525470,int_stack+512600,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+566654,int_stack+208912,int_stack+202828,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+584906,int_stack+566654,int_stack+525470,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+615794,int_stack+584906,int_stack+540914,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+512600,int_stack+216010,int_stack+208912,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+658694,int_stack+512600,int_stack+566654,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+695198,int_stack+658694,int_stack+584906,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+533894,int_stack+695198,int_stack+615794,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+598244,int_stack+224200,int_stack+216010,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+746678,int_stack+598244,int_stack+512600,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+789266,int_stack+746678,int_stack+658694,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+850106,int_stack+789266,int_stack+695198,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+622814,int_stack+850106,int_stack+533894,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+512600,int_stack+233560,int_stack+224200,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+540680,int_stack+512600,int_stack+598244,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+927326,int_stack+540680,int_stack+746678,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+998306,int_stack+927326,int_stack+789266,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+712904,int_stack+998306,int_stack+850106,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1089566,int_stack+712904,int_stack+622814,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+589820,int_stack+244168,int_stack+233560,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+621644,int_stack+589820,int_stack+512600,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+821012,int_stack+621644,int_stack+540680,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1209686,int_stack+821012,int_stack+927326,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1316156,int_stack+1209686,int_stack+998306,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+902912,int_stack+1316156,int_stack+712904,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1443920,int_stack+902912,int_stack+1089566,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+512600,int_stack+256102,int_stack+244168,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+677804,int_stack+512600,int_stack+589820,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1047056,int_stack+677804,int_stack+621644,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+548402,int_stack+1047056,int_stack+821012,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+741452,int_stack+548402,int_stack+1209686,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1140656,int_stack+741452,int_stack+1316156,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1140656,int_stack+902912,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3278550,int_stack+0,int_stack+1443920,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+890510,int_stack+269440,int_stack+256102,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+930524,int_stack+890510,int_stack+512600,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1311008,int_stack+930524,int_stack+677804,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+890510,int_stack+1311008,int_stack+1047056,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1311008,int_stack+890510,int_stack+548402,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+890510,int_stack+1311008,int_stack+741452,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1311008,int_stack+890510,int_stack+1140656,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1530032,int_stack+1311008,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+1530032,int_stack+3278550,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+512600,int_stack+0,int_stack+1763025,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+3278550,int_stack+512600,int_stack+1962675,3025);
 /*--- compute (lf|mm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+4276800,int_stack+3278550,int_stack+2461800,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+235950,int_stack+289265,int_stack+284260,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+250965,int_stack+295271,int_stack+289265,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1111550,int_stack+250965,int_stack+235950,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+268983,int_stack+302369,int_stack+295271,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1141580,int_stack+268983,int_stack+250965,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1177616,int_stack+1141580,int_stack+1111550,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1111550,int_stack+310650,int_stack+302369,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1227666,int_stack+1111550,int_stack+268983,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+235950,int_stack+1227666,int_stack+1141580,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1270254,int_stack+235950,int_stack+1177616,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1136393,int_stack+320205,int_stack+310650,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1165058,int_stack+1136393,int_stack+1111550,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1345329,int_stack+1165058,int_stack+1227666,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1416309,int_stack+1345329,int_stack+235950,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1506399,int_stack+1416309,int_stack+1270254,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+235950,int_stack+331125,int_stack+320205,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+268710,int_stack+235950,int_stack+1136393,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1214744,int_stack+268710,int_stack+1165058,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1611504,int_stack+1214744,int_stack+1345329,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1717974,int_stack+1611504,int_stack+1416309,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1297554,int_stack+1717974,int_stack+1506399,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1111550,int_stack+343501,int_stack+331125,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1148678,int_stack+1111550,int_stack+235950,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1437694,int_stack+1148678,int_stack+268710,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1844100,int_stack+1437694,int_stack+1214744,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1968315,int_stack+1844100,int_stack+1611504,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1533244,int_stack+1968315,int_stack+1717974,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2117373,int_stack+1533244,int_stack+1297554,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+235950,int_stack+357424,int_stack+343501,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+277719,int_stack+235950,int_stack+1111550,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1214198,int_stack+277719,int_stack+1148678,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2297553,int_stack+1214198,int_stack+1437694,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1323398,int_stack+2297553,int_stack+1844100,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1701412,int_stack+1323398,int_stack+1968315,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1900156,int_stack+1701412,int_stack+1533244,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2440878,int_stack+1900156,int_stack+2117373,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1111550,int_stack+372985,int_stack+357424,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1497299,int_stack+1111550,int_stack+235950,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2116372,int_stack+1497299,int_stack+277719,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1497299,int_stack+2116372,int_stack+1214198,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1111550,int_stack+1497299,int_stack+2297553,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2116372,int_stack+1111550,int_stack+1323398,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1111550,int_stack+2116372,int_stack+1701412,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2116372,int_stack+1111550,int_stack+1900156,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1111550,int_stack+2116372,int_stack+2440878,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+1386825,int_stack+1111550,int_stack+0,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+5638050,int_stack+1386825,int_stack+512600,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+6835950,int_stack+5638050,int_stack+3278550,3025);
 /*--- compute (lg|mm) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2094675,int_stack+6835950,int_stack+4276800,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+512600,int_stack+396050,int_stack+390275,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+529925,int_stack+402980,int_stack+396050,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+550715,int_stack+529925,int_stack+512600,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+585365,int_stack+411170,int_stack+402980,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+609935,int_stack+585365,int_stack+529925,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+651515,int_stack+609935,int_stack+550715,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+512600,int_stack+420725,int_stack+411170,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+709265,int_stack+512600,int_stack+585365,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+758405,int_stack+709265,int_stack+609935,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+541265,int_stack+758405,int_stack+651515,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+627890,int_stack+431750,int_stack+420725,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+827705,int_stack+627890,int_stack+512600,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+885035,int_stack+827705,int_stack+709265,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+966935,int_stack+885035,int_stack+758405,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+660965,int_stack+966935,int_stack+541265,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+512600,int_stack+444350,int_stack+431750,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+550400,int_stack+512600,int_stack+627890,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+550400,int_stack+827705,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+95550,int_stack+0,int_stack+885035,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+782240,int_stack+95550,int_stack+966935,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+927770,int_stack+782240,int_stack+660965,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+616550,int_stack+458630,int_stack+444350,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+659390,int_stack+616550,int_stack+512600,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+218400,int_stack+659390,int_stack+550400,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4136550,int_stack+218400,int_stack+0,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4279875,int_stack+4136550,int_stack+95550,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+4279875,int_stack+782240,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+4451865,int_stack+0,int_stack+927770,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+512600,int_stack+474695,int_stack+458630,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+734990,int_stack+512600,int_stack+616550,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+820670,int_stack+734990,int_stack+659390,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+560795,int_stack+820670,int_stack+218400,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+194040,int_stack+560795,int_stack+4136550,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4659765,int_stack+194040,int_stack+4279875,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4136550,int_stack+4659765,int_stack+0,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4889085,int_stack+4136550,int_stack+4451865,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+492650,int_stack+474695,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+53865,int_stack+0,int_stack+512600,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+4386030,int_stack+53865,int_stack+734990,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+4386030,int_stack+820670,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4386030,int_stack+0,int_stack+560795,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+394695,int_stack+4386030,int_stack+194040,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+394695,int_stack+4659765,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4386030,int_stack+0,int_stack+4136550,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+4386030,int_stack+4889085,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+4136550,int_stack+0,int_stack+1111550,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+8499700,int_stack+4136550,int_stack+1386825,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+8499700,int_stack+5638050,3025);
 /*--- compute (mg|mm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+4136550,int_stack+0,int_stack+6835950,3025);
 /*--- compute (lh|mm) ---*/
 hrr1_build_lh(Libint->AB,int_stack+6632175,int_stack+4136550,int_stack+2094675,3025);
 return int_stack+6632175;}
