/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lknk(Libint_t*, prim_data*);

  /* Computes quartets of (lk|nk) integrals */

REALTYPE *hrr_order_lknk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[9][10] = int_stack + 41400;
 Libint->vrr_classes[9][11] = int_stack + 45030;
 Libint->vrr_classes[9][12] = int_stack + 49320;
 Libint->vrr_classes[9][13] = int_stack + 54325;
 Libint->vrr_classes[9][14] = int_stack + 60100;
 Libint->vrr_classes[9][15] = int_stack + 66700;
 Libint->vrr_classes[9][16] = int_stack + 74180;
 Libint->vrr_classes[9][17] = int_stack + 82595;
 Libint->vrr_classes[10][10] = int_stack + 92000;
 Libint->vrr_classes[10][11] = int_stack + 96356;
 Libint->vrr_classes[10][12] = int_stack + 101504;
 Libint->vrr_classes[10][13] = int_stack + 107510;
 Libint->vrr_classes[10][14] = int_stack + 114440;
 Libint->vrr_classes[10][15] = int_stack + 122360;
 Libint->vrr_classes[10][16] = int_stack + 131336;
 Libint->vrr_classes[10][17] = int_stack + 141434;
 Libint->vrr_classes[11][10] = int_stack + 152720;
 Libint->vrr_classes[11][11] = int_stack + 157868;
 Libint->vrr_classes[11][12] = int_stack + 163952;
 Libint->vrr_classes[11][13] = int_stack + 171050;
 Libint->vrr_classes[11][14] = int_stack + 179240;
 Libint->vrr_classes[11][15] = int_stack + 188600;
 Libint->vrr_classes[11][16] = int_stack + 199208;
 Libint->vrr_classes[11][17] = int_stack + 211142;
 Libint->vrr_classes[12][10] = int_stack + 224480;
 Libint->vrr_classes[12][11] = int_stack + 230486;
 Libint->vrr_classes[12][12] = int_stack + 237584;
 Libint->vrr_classes[12][13] = int_stack + 245865;
 Libint->vrr_classes[12][14] = int_stack + 255420;
 Libint->vrr_classes[12][15] = int_stack + 266340;
 Libint->vrr_classes[12][16] = int_stack + 278716;
 Libint->vrr_classes[12][17] = int_stack + 292639;
 Libint->vrr_classes[13][10] = int_stack + 308200;
 Libint->vrr_classes[13][11] = int_stack + 315130;
 Libint->vrr_classes[13][12] = int_stack + 323320;
 Libint->vrr_classes[13][13] = int_stack + 332875;
 Libint->vrr_classes[13][14] = int_stack + 343900;
 Libint->vrr_classes[13][15] = int_stack + 356500;
 Libint->vrr_classes[13][16] = int_stack + 370780;
 Libint->vrr_classes[13][17] = int_stack + 386845;
 Libint->vrr_classes[14][10] = int_stack + 404800;
 Libint->vrr_classes[14][11] = int_stack + 412720;
 Libint->vrr_classes[14][12] = int_stack + 422080;
 Libint->vrr_classes[14][13] = int_stack + 433000;
 Libint->vrr_classes[14][14] = int_stack + 445600;
 Libint->vrr_classes[14][15] = int_stack + 460000;
 Libint->vrr_classes[14][16] = int_stack + 476320;
 Libint->vrr_classes[14][17] = int_stack + 494680;
 Libint->vrr_classes[15][10] = int_stack + 515200;
 Libint->vrr_classes[15][11] = int_stack + 524176;
 Libint->vrr_classes[15][12] = int_stack + 534784;
 Libint->vrr_classes[15][13] = int_stack + 547160;
 Libint->vrr_classes[15][14] = int_stack + 561440;
 Libint->vrr_classes[15][15] = int_stack + 577760;
 Libint->vrr_classes[15][16] = int_stack + 596256;
 Libint->vrr_classes[15][17] = int_stack + 617064;
 memset(int_stack,0,640320*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 640320;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lknk(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+640320,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+649230,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+659760,int_stack+649230,int_stack+640320,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+677580,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+689865,int_stack+677580,int_stack+649230,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+710925,int_stack+689865,int_stack+659760,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+640320,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+740625,int_stack+640320,int_stack+677580,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+654495,int_stack+740625,int_stack+689865,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+765195,int_stack+654495,int_stack+710925,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+689595,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+705795,int_stack+689595,int_stack+640320,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+809745,int_stack+705795,int_stack+740625,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+850695,int_stack+809745,int_stack+654495,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+903345,int_stack+850695,int_stack+765195,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+640320,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+734145,int_stack+640320,int_stack+689595,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+965715,int_stack+734145,int_stack+705795,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+658680,int_stack+965715,int_stack+809745,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+766545,int_stack+658680,int_stack+850695,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1012965,int_stack+766545,int_stack+903345,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+840255,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+860910,int_stack+840255,int_stack+640320,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+897630,int_stack+860910,int_stack+734145,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1096125,int_stack+897630,int_stack+965715,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+840255,int_stack+1096125,int_stack+658680,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+640320,int_stack+840255,int_stack+766545,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+738600,int_stack+640320,int_stack+1012965,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+640320,int_stack+45030,int_stack+41400,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+651210,int_stack+49320,int_stack+45030,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+664080,int_stack+651210,int_stack+640320,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+685860,int_stack+54325,int_stack+49320,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+700875,int_stack+685860,int_stack+651210,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+845520,int_stack+700875,int_stack+664080,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+640320,int_stack+60100,int_stack+54325,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+881820,int_stack+640320,int_stack+685860,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+657645,int_stack+881820,int_stack+700875,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+911850,int_stack+657645,int_stack+845520,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+845520,int_stack+66700,int_stack+60100,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+700545,int_stack+845520,int_stack+640320,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+966300,int_stack+700545,int_stack+881820,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1016350,int_stack+966300,int_stack+657645,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1080700,int_stack+1016350,int_stack+911850,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+640320,int_stack+74180,int_stack+66700,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+865320,int_stack+640320,int_stack+845520,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+904920,int_stack+865320,int_stack+700545,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+662760,int_stack+904920,int_stack+966300,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1156930,int_stack+662760,int_stack+1016350,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+962670,int_stack+1156930,int_stack+1080700,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1064310,int_stack+82595,int_stack+74180,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1089555,int_stack+1064310,int_stack+640320,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+1089555,int_stack+865320,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1064310,int_stack+0,int_stack+904920,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+845520,int_stack+1064310,int_stack+662760,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1247020,int_stack+845520,int_stack+1156930,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1064310,int_stack+1247020,int_stack+962670,55);
 /*--- compute (lp|nk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1194990,int_stack+1064310,int_stack+738600,2376);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+96356,int_stack+92000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+101504,int_stack+96356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+107510,int_stack+101504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72666,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+640320,int_stack+72666,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+114440,int_stack+107510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+683880,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+683880,int_stack+72666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+719916,int_stack+20790,int_stack+640320,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+640320,int_stack+122360,int_stack+114440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+72270,int_stack+640320,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+785256,int_stack+72270,int_stack+683880,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+845316,int_stack+785256,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+922536,int_stack+845316,int_stack+719916,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+131336,int_stack+122360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+664080,int_stack+0,int_stack+640320,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+711600,int_stack+664080,int_stack+72270,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+26928,int_stack+711600,int_stack+785256,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1515750,int_stack+26928,int_stack+845316,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+780900,int_stack+1515750,int_stack+922536,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+902868,int_stack+141434,int_stack+131336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+933162,int_stack+902868,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1623858,int_stack+933162,int_stack+664080,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+902868,int_stack+1623858,int_stack+711600,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+640320,int_stack+902868,int_stack+26928,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+902868,int_stack+640320,int_stack+1515750,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1515750,int_stack+902868,int_stack+780900,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+640320,int_stack+1515750,int_stack+1064310,2376);
 /*--- compute (ld|nk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1672566,int_stack+640320,int_stack+1194990,2376);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1032360,int_stack+157868,int_stack+152720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1047804,int_stack+163952,int_stack+157868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1066056,int_stack+1047804,int_stack+1032360,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1096944,int_stack+171050,int_stack+163952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1118238,int_stack+1096944,int_stack+1047804,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1154742,int_stack+1118238,int_stack+1066056,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1032360,int_stack+179240,int_stack+171050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1206222,int_stack+1032360,int_stack+1096944,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1056930,int_stack+1206222,int_stack+1118238,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1248810,int_stack+1056930,int_stack+1154742,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1117770,int_stack+188600,int_stack+179240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1145850,int_stack+1117770,int_stack+1032360,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1326030,int_stack+1145850,int_stack+1206222,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1397010,int_stack+1326030,int_stack+1056930,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+1397010,int_stack+1248810,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1032360,int_stack+199208,int_stack+188600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1194990,int_stack+1032360,int_stack+1117770,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+108108,int_stack+1194990,int_stack+1145850,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1064184,int_stack+108108,int_stack+1326030,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1251150,int_stack+1064184,int_stack+1397010,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2314086,int_stack+1251150,int_stack+0,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+211142,int_stack+199208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+35802,int_stack+0,int_stack+1032360,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1378914,int_stack+35802,int_stack+1194990,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2458230,int_stack+1378914,int_stack+108108,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+2458230,int_stack+1064184,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1032360,int_stack+0,int_stack+1251150,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1032360,int_stack+2314086,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1032360,int_stack+0,int_stack+1515750,2376);
 /*--- compute (md|nk) ---*/
 hrr1_build_md(Libint->AB,int_stack+2314086,int_stack+1032360,int_stack+640320,2376);
 /*--- compute (lf|nk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3098166,int_stack+2314086,int_stack+1672566,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+640320,int_stack+230486,int_stack+224480,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+658338,int_stack+237584,int_stack+230486,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+679632,int_stack+658338,int_stack+640320,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+715668,int_stack+245865,int_stack+237584,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+740511,int_stack+715668,int_stack+658338,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+783099,int_stack+740511,int_stack+679632,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+640320,int_stack+255420,int_stack+245865,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+843159,int_stack+640320,int_stack+715668,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+668985,int_stack+843159,int_stack+740511,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+892845,int_stack+668985,int_stack+783099,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+739965,int_stack+266340,int_stack+255420,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+772725,int_stack+739965,int_stack+640320,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1502808,int_stack+772725,int_stack+843159,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1585618,int_stack+1502808,int_stack+668985,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1692088,int_stack+1585618,int_stack+892845,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+640320,int_stack+278716,int_stack+266340,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+830055,int_stack+640320,int_stack+739965,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+895575,int_stack+830055,int_stack+772725,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+677448,int_stack+895575,int_stack+1502808,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1818214,int_stack+677448,int_stack+1585618,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1502808,int_stack+1818214,int_stack+1692088,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1670976,int_stack+292639,int_stack+278716,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1712745,int_stack+1670976,int_stack+640320,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1967272,int_stack+1712745,int_stack+830055,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1670976,int_stack+1967272,int_stack+895575,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1967272,int_stack+1670976,int_stack+677448,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+640320,int_stack+1967272,int_stack+1818214,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1670976,int_stack+640320,int_stack+1502808,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+4167366,int_stack+1670976,int_stack+0,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4723350,int_stack+4167366,int_stack+1032360,2376);
 /*--- compute (mf|nk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5664246,int_stack+4723350,int_stack+2314086,2376);
 /*--- compute (lg|nk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+6971046,int_stack+5664246,int_stack+3098166,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+315130,int_stack+308200,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+323320,int_stack+315130,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+332875,int_stack+323320,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+343900,int_stack+332875,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+234045,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+234045,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+640320,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+356500,int_stack+343900,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+744270,int_stack+152775,int_stack+234045,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+218925,int_stack+744270,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+839820,int_stack+218925,int_stack+640320,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+640320,int_stack+370780,int_stack+356500,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+640320,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+985350,int_stack+0,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+75600,int_stack+985350,int_stack+744270,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1095600,int_stack+75600,int_stack+218925,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1267590,int_stack+1095600,int_stack+839820,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+218925,int_stack+386845,int_stack+370780,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+267120,int_stack+218925,int_stack+640320,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+640320,int_stack+267120,int_stack+0,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+766320,int_stack+640320,int_stack+985350,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1461630,int_stack+766320,int_stack+75600,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+640320,int_stack+1461630,int_stack+1095600,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+869640,int_stack+640320,int_stack+1267590,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1887192,int_stack+869640,int_stack+1670976,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+2535840,int_stack+1887192,int_stack+4167366,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+8574846,int_stack+2535840,int_stack+4723350,2376);
 /*--- compute (mg|nk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+3647808,int_stack+8574846,int_stack+5664246,2376);
 /*--- compute (lh|nk) ---*/
 hrr1_build_lh(Libint->AB,int_stack+10143006,int_stack+3647808,int_stack+6971046,2376);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+640320,int_stack+412720,int_stack+404800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+664080,int_stack+422080,int_stack+412720,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+692160,int_stack+664080,int_stack+640320,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+739680,int_stack+433000,int_stack+422080,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+772440,int_stack+739680,int_stack+664080,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1119120,int_stack+772440,int_stack+692160,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+640320,int_stack+445600,int_stack+433000,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1198320,int_stack+640320,int_stack+739680,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+678120,int_stack+1198320,int_stack+772440,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1263840,int_stack+678120,int_stack+1119120,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1119120,int_stack+460000,int_stack+445600,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+771720,int_stack+1119120,int_stack+640320,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1382640,int_stack+771720,int_stack+1198320,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1491840,int_stack+1382640,int_stack+678120,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1632240,int_stack+1491840,int_stack+1263840,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+640320,int_stack+476320,int_stack+460000,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1162320,int_stack+640320,int_stack+1119120,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1248720,int_stack+1162320,int_stack+771720,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+689280,int_stack+1248720,int_stack+1382640,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+689280,int_stack+1491840,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1374720,int_stack+0,int_stack+1632240,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1596480,int_stack+494680,int_stack+476320,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1651560,int_stack+1596480,int_stack+640320,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+196560,int_stack+1651560,int_stack+1162320,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1596480,int_stack+196560,int_stack+1248720,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+196560,int_stack+1596480,int_stack+689280,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1596480,int_stack+196560,int_stack+0,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1596480,int_stack+1374720,120);
 /*--- compute (rp|nk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1119120,int_stack+0,int_stack+869640,2376);
 /*--- compute (qd|nk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+5608008,int_stack+1119120,int_stack+1887192,2376);
 /*--- compute (of|nk) ---*/
 hrr1_build_of(Libint->AB,int_stack+12388326,int_stack+5608008,int_stack+2535840,2376);
 /*--- compute (ng|nk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+14241606,int_stack+12388326,int_stack+8574846,2376);
 /*--- compute (mh|nk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+6905304,int_stack+14241606,int_stack+3647808,2376);
 /*--- compute (li|nk) ---*/
 hrr1_build_li(Libint->AB,int_stack+1867560,int_stack+6905304,int_stack+10143006,2376);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+285120,int_stack+524176,int_stack+515200,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+312048,int_stack+534784,int_stack+524176,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+343872,int_stack+312048,int_stack+285120,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+397728,int_stack+547160,int_stack+534784,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+434856,int_stack+397728,int_stack+312048,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+640320,int_stack+434856,int_stack+343872,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+285120,int_stack+561440,int_stack+547160,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+730080,int_stack+285120,int_stack+397728,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+327960,int_stack+730080,int_stack+434856,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+804336,int_stack+327960,int_stack+640320,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+640320,int_stack+577760,int_stack+561440,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+434040,int_stack+640320,int_stack+285120,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+938976,int_stack+434040,int_stack+730080,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4861320,int_stack+938976,int_stack+327960,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5020440,int_stack+4861320,int_stack+804336,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+285120,int_stack+596256,int_stack+577760,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+689280,int_stack+285120,int_stack+640320,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+787200,int_stack+689280,int_stack+434040,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+340608,int_stack+787200,int_stack+938976,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+5208936,int_stack+340608,int_stack+4861320,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+9649584,int_stack+5208936,int_stack+5020440,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+4861320,int_stack+617064,int_stack+596256,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4923744,int_stack+4861320,int_stack+285120,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+5034720,int_stack+4923744,int_stack+689280,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+526248,int_stack+5034720,int_stack+787200,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4861320,int_stack+526248,int_stack+340608,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+285120,int_stack+4861320,int_stack+5208936,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4861320,int_stack+285120,int_stack+9649584,136);
 /*--- compute (tp|nk) ---*/
 hrr1_build_tp(Libint->AB,int_stack+9649584,int_stack+4861320,int_stack+0,2376);
 /*--- compute (rd|nk) ---*/
 hrr1_build_rd(Libint->AB,int_stack+10504944,int_stack+9649584,int_stack+1119120,2376);
 /*--- compute (qf|nk) ---*/
 hrr1_build_qf(Libint->AB,int_stack+16593846,int_stack+10504944,int_stack+5608008,2376);
 /*--- compute (og|nk) ---*/
 hrr1_build_og(Libint->AB,int_stack+18756006,int_stack+16593846,int_stack+12388326,2376);
 /*--- compute (nh|nk) ---*/
 hrr1_build_nh(Libint->AB,int_stack+9649584,int_stack+18756006,int_stack+14241606,2376);
 /*--- compute (mi|nk) ---*/
 hrr1_build_mi(Libint->AB,int_stack+12942720,int_stack+9649584,int_stack+6905304,2376);
 /*--- compute (lk|nk) ---*/
 hrr1_build_lk(Libint->AB,int_stack+16601760,int_stack+12942720,int_stack+1867560,2376);
 return int_stack+16601760;}
