/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpll(Libint_t*, prim_data*);

  /* Computes quartets of (lp|ll) integrals */

REALTYPE *hrr_order_lpll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[8][14] = int_stack + 19800;
 Libint->vrr_classes[8][15] = int_stack + 25200;
 Libint->vrr_classes[8][16] = int_stack + 31320;
 Libint->vrr_classes[9][8] = int_stack + 38205;
 Libint->vrr_classes[9][9] = int_stack + 40680;
 Libint->vrr_classes[9][10] = int_stack + 43705;
 Libint->vrr_classes[9][11] = int_stack + 47335;
 Libint->vrr_classes[9][12] = int_stack + 51625;
 Libint->vrr_classes[9][13] = int_stack + 56630;
 Libint->vrr_classes[9][14] = int_stack + 62405;
 Libint->vrr_classes[9][15] = int_stack + 69005;
 Libint->vrr_classes[9][16] = int_stack + 76485;
 memset(int_stack,0,84900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 84900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpll(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84900,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+90975,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+98400,int_stack+90975,int_stack+84900,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+110550,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+119460,int_stack+110550,int_stack+90975,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+134310,int_stack+119460,int_stack+98400,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84900,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+154560,int_stack+84900,int_stack+110550,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+172380,int_stack+154560,int_stack+119460,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+95430,int_stack+172380,int_stack+134310,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+125805,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+197130,int_stack+125805,int_stack+84900,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+218190,int_stack+197130,int_stack+154560,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+247890,int_stack+218190,int_stack+172380,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+138090,int_stack+247890,int_stack+95430,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84900,int_stack+19800,int_stack+15075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+99075,int_stack+84900,int_stack+125805,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+285015,int_stack+99075,int_stack+197130,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+320115,int_stack+285015,int_stack+218190,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+180615,int_stack+320115,int_stack+247890,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+364665,int_stack+180615,int_stack+138090,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+123645,int_stack+25200,int_stack+19800,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+139845,int_stack+123645,int_stack+84900,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+232590,int_stack+139845,int_stack+99075,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+421365,int_stack+232590,int_stack+285015,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+474015,int_stack+421365,int_stack+320115,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+273540,int_stack+474015,int_stack+180615,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+536385,int_stack+273540,int_stack+364665,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+84900,int_stack+31320,int_stack+25200,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+168195,int_stack+84900,int_stack+123645,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+84900,int_stack+168195,int_stack+139845,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+132150,int_stack+84900,int_stack+232590,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+193575,int_stack+132150,int_stack+421365,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+84900,int_stack+193575,int_stack+474015,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+168060,int_stack+84900,int_stack+273540,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+257160,int_stack+168060,int_stack+536385,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84900,int_stack+40680,int_stack+38205,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+92325,int_stack+43705,int_stack+40680,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+101400,int_stack+92325,int_stack+84900,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+116250,int_stack+47335,int_stack+43705,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+127140,int_stack+116250,int_stack+92325,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+145290,int_stack+127140,int_stack+101400,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84900,int_stack+51625,int_stack+47335,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+170040,int_stack+84900,int_stack+116250,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+191820,int_stack+170040,int_stack+127140,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+97770,int_stack+191820,int_stack+145290,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+134895,int_stack+56630,int_stack+51625,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+222070,int_stack+134895,int_stack+84900,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+348285,int_stack+222070,int_stack+170040,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+384585,int_stack+348285,int_stack+191820,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+149910,int_stack+384585,int_stack+97770,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84900,int_stack+62405,int_stack+56630,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+102225,int_stack+84900,int_stack+134895,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+429960,int_stack+102225,int_stack+222070,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+201885,int_stack+429960,int_stack+348285,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+472860,int_stack+201885,int_stack+384585,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+348285,int_stack+472860,int_stack+149910,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+132255,int_stack+69005,int_stack+62405,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152055,int_stack+132255,int_stack+84900,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+536385,int_stack+152055,int_stack+102225,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+536385,int_stack+429960,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+586435,int_stack+0,int_stack+201885,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+662665,int_stack+586435,int_stack+472860,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+417585,int_stack+662665,int_stack+348285,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+348285,int_stack+76485,int_stack+69005,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+370725,int_stack+348285,int_stack+132255,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+186705,int_stack+370725,int_stack+152055,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+64350,int_stack+186705,int_stack+536385,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+139425,int_stack+64350,int_stack+0,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+139425,int_stack+586435,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+101640,int_stack+0,int_stack+662665,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+506685,int_stack+101640,int_stack+417585,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+618060,int_stack+506685,int_stack+257160,2025);
 return int_stack+618060;}
