/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpmp(Libint_t*, prim_data*);

  /* Computes quartets of (lp|mp) integrals */

REALTYPE *hrr_order_lpmp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[9][9] = int_stack + 5445;
 Libint->vrr_classes[9][10] = int_stack + 8470;
 memset(int_stack,0,12100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 12100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpmp(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12100,int_stack+2475,int_stack+0,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19525,int_stack+8470,int_stack+5445,55);
 /*--- compute (lp|mp) ---*/
 hrr1_build_lp(Libint->AB,int_stack+28600,int_stack+19525,int_stack+12100,165);
 return int_stack+28600;}
