/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfkh(Libint_t*, prim_data*);

  /* Computes quartets of (mf|kh) integrals */

REALTYPE *hrr_order_mfkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][7] = int_stack + 0;
 Libint->vrr_classes[9][8] = int_stack + 1980;
 Libint->vrr_classes[9][9] = int_stack + 4455;
 Libint->vrr_classes[9][10] = int_stack + 7480;
 Libint->vrr_classes[9][11] = int_stack + 11110;
 Libint->vrr_classes[9][12] = int_stack + 15400;
 Libint->vrr_classes[10][7] = int_stack + 20405;
 Libint->vrr_classes[10][8] = int_stack + 22781;
 Libint->vrr_classes[10][9] = int_stack + 25751;
 Libint->vrr_classes[10][10] = int_stack + 29381;
 Libint->vrr_classes[10][11] = int_stack + 33737;
 Libint->vrr_classes[10][12] = int_stack + 38885;
 Libint->vrr_classes[11][7] = int_stack + 44891;
 Libint->vrr_classes[11][8] = int_stack + 47699;
 Libint->vrr_classes[11][9] = int_stack + 51209;
 Libint->vrr_classes[11][10] = int_stack + 55499;
 Libint->vrr_classes[11][11] = int_stack + 60647;
 Libint->vrr_classes[11][12] = int_stack + 66731;
 Libint->vrr_classes[12][7] = int_stack + 73829;
 Libint->vrr_classes[12][8] = int_stack + 77105;
 Libint->vrr_classes[12][9] = int_stack + 81200;
 Libint->vrr_classes[12][10] = int_stack + 86205;
 Libint->vrr_classes[12][11] = int_stack + 92211;
 Libint->vrr_classes[12][12] = int_stack + 99309;
 memset(int_stack,0,107590*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 107590;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfkh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+107590,int_stack+1980,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+113530,int_stack+4455,int_stack+1980,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+120955,int_stack+113530,int_stack+107590,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+132835,int_stack+7480,int_stack+4455,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+141910,int_stack+132835,int_stack+113530,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+156760,int_stack+141910,int_stack+120955,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+107590,int_stack+11110,int_stack+7480,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+176560,int_stack+107590,int_stack+132835,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+194710,int_stack+176560,int_stack+141910,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+118480,int_stack+194710,int_stack+156760,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+148180,int_stack+15400,int_stack+11110,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+219460,int_stack+148180,int_stack+107590,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+241240,int_stack+219460,int_stack+176560,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+148180,int_stack+241240,int_stack+194710,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+185305,int_stack+148180,int_stack+118480,55);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+107590,int_stack+22781,int_stack+20405,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+114718,int_stack+25751,int_stack+22781,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+123628,int_stack+114718,int_stack+107590,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+137884,int_stack+29381,int_stack+25751,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+148774,int_stack+137884,int_stack+114718,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+226885,int_stack+148774,int_stack+123628,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+107590,int_stack+33737,int_stack+29381,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+107590,int_stack+137884,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+250645,int_stack+0,int_stack+148774,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+120658,int_stack+250645,int_stack+226885,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+226885,int_stack+38885,int_stack+33737,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+156298,int_stack+226885,int_stack+107590,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+280345,int_stack+156298,int_stack+0,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+280345,int_stack+250645,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+226885,int_stack+0,int_stack+120658,66);
 /*--- compute (mp|kh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+276781,int_stack+226885,int_stack+185305,756);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+47699,int_stack+44891,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8424,int_stack+51209,int_stack+47699,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18954,int_stack+8424,int_stack+0,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35802,int_stack+55499,int_stack+51209,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+107590,int_stack+35802,int_stack+8424,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+128650,int_stack+107590,int_stack+18954,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+60647,int_stack+55499,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+156730,int_stack+0,int_stack+35802,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+15444,int_stack+156730,int_stack+107590,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+182470,int_stack+15444,int_stack+128650,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+107590,int_stack+66731,int_stack+60647,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+125842,int_stack+107590,int_stack+0,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+401521,int_stack+125842,int_stack+156730,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+107590,int_stack+401521,int_stack+15444,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+107590,int_stack+182470,78);
 /*--- compute (np|kh) ---*/
 hrr1_build_np(Libint->AB,int_stack+401521,int_stack+0,int_stack+226885,756);
 /*--- compute (md|kh) ---*/
 hrr1_build_md(Libint->AB,int_stack+551209,int_stack+401521,int_stack+276781,756);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+107590,int_stack+77105,int_stack+73829,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+117418,int_stack+81200,int_stack+77105,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+129703,int_stack+117418,int_stack+107590,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+149359,int_stack+86205,int_stack+81200,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+164374,int_stack+149359,int_stack+117418,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+188944,int_stack+164374,int_stack+129703,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+107590,int_stack+92211,int_stack+86205,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+221704,int_stack+107590,int_stack+149359,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+251734,int_stack+221704,int_stack+164374,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+125608,int_stack+251734,int_stack+188944,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+174748,int_stack+99309,int_stack+92211,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+292684,int_stack+174748,int_stack+107590,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+328720,int_stack+292684,int_stack+221704,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+174748,int_stack+328720,int_stack+251734,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+236173,int_stack+174748,int_stack+125608,91);
 /*--- compute (op|kh) ---*/
 hrr1_build_op(Libint->AB,int_stack+58968,int_stack+236173,int_stack+0,756);
 /*--- compute (nd|kh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+800689,int_stack+58968,int_stack+401521,756);
 /*--- compute (mf|kh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+800689,int_stack+551209,756);
 return int_stack+0;}
