/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgnm(Libint_t*, prim_data*);

  /* Computes quartets of (mg|nm) integrals */

REALTYPE *hrr_order_mgnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[9][19] = int_stack + 61050;
 Libint->vrr_classes[10][10] = int_stack + 72600;
 Libint->vrr_classes[10][11] = int_stack + 76956;
 Libint->vrr_classes[10][12] = int_stack + 82104;
 Libint->vrr_classes[10][13] = int_stack + 88110;
 Libint->vrr_classes[10][14] = int_stack + 95040;
 Libint->vrr_classes[10][15] = int_stack + 102960;
 Libint->vrr_classes[10][16] = int_stack + 111936;
 Libint->vrr_classes[10][17] = int_stack + 122034;
 Libint->vrr_classes[10][18] = int_stack + 133320;
 Libint->vrr_classes[10][19] = int_stack + 145860;
 Libint->vrr_classes[11][10] = int_stack + 159720;
 Libint->vrr_classes[11][11] = int_stack + 164868;
 Libint->vrr_classes[11][12] = int_stack + 170952;
 Libint->vrr_classes[11][13] = int_stack + 178050;
 Libint->vrr_classes[11][14] = int_stack + 186240;
 Libint->vrr_classes[11][15] = int_stack + 195600;
 Libint->vrr_classes[11][16] = int_stack + 206208;
 Libint->vrr_classes[11][17] = int_stack + 218142;
 Libint->vrr_classes[11][18] = int_stack + 231480;
 Libint->vrr_classes[11][19] = int_stack + 246300;
 Libint->vrr_classes[12][10] = int_stack + 262680;
 Libint->vrr_classes[12][11] = int_stack + 268686;
 Libint->vrr_classes[12][12] = int_stack + 275784;
 Libint->vrr_classes[12][13] = int_stack + 284065;
 Libint->vrr_classes[12][14] = int_stack + 293620;
 Libint->vrr_classes[12][15] = int_stack + 304540;
 Libint->vrr_classes[12][16] = int_stack + 316916;
 Libint->vrr_classes[12][17] = int_stack + 330839;
 Libint->vrr_classes[12][18] = int_stack + 346400;
 Libint->vrr_classes[12][19] = int_stack + 363690;
 Libint->vrr_classes[13][10] = int_stack + 382800;
 Libint->vrr_classes[13][11] = int_stack + 389730;
 Libint->vrr_classes[13][12] = int_stack + 397920;
 Libint->vrr_classes[13][13] = int_stack + 407475;
 Libint->vrr_classes[13][14] = int_stack + 418500;
 Libint->vrr_classes[13][15] = int_stack + 431100;
 Libint->vrr_classes[13][16] = int_stack + 445380;
 Libint->vrr_classes[13][17] = int_stack + 461445;
 Libint->vrr_classes[13][18] = int_stack + 479400;
 Libint->vrr_classes[13][19] = int_stack + 499350;
 memset(int_stack,0,521400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 521400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgnm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+521400,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+532290,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+545160,int_stack+532290,int_stack+521400,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+566940,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+581955,int_stack+566940,int_stack+532290,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+607695,int_stack+581955,int_stack+545160,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+521400,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+643995,int_stack+521400,int_stack+566940,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+538725,int_stack+643995,int_stack+581955,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+674025,int_stack+538725,int_stack+607695,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+581625,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+601425,int_stack+581625,int_stack+521400,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+728475,int_stack+601425,int_stack+643995,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+778525,int_stack+728475,int_stack+538725,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+842875,int_stack+778525,int_stack+674025,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+521400,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+636075,int_stack+521400,int_stack+581625,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+919105,int_stack+636075,int_stack+601425,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+543840,int_stack+919105,int_stack+728475,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+675675,int_stack+543840,int_stack+778525,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+976855,int_stack+675675,int_stack+842875,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+765765,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+791010,int_stack+765765,int_stack+521400,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+835890,int_stack+791010,int_stack+636075,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1078495,int_stack+835890,int_stack+919105,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1165120,int_stack+1078495,int_stack+543840,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+521400,int_stack+1165120,int_stack+675675,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1270225,int_stack+521400,int_stack+976855,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+641520,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+669735,int_stack+641520,int_stack+765765,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+901890,int_stack+669735,int_stack+791010,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+720225,int_stack+901890,int_stack+835890,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1400905,int_stack+720225,int_stack+1078495,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+976690,int_stack+1400905,int_stack+1165120,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1522180,int_stack+976690,int_stack+521400,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1676620,int_stack+1522180,int_stack+1270225,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+521400,int_stack+61050,int_stack+50600,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+552750,int_stack+521400,int_stack+641520,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1116830,int_stack+552750,int_stack+669735,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+521400,int_stack+1116830,int_stack+901890,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1116830,int_stack+521400,int_stack+720225,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+521400,int_stack+1116830,int_stack+1400905,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1116830,int_stack+521400,int_stack+976690,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+521400,int_stack+1116830,int_stack+1522180,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+714450,int_stack+521400,int_stack+1676620,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+521400,int_stack+76956,int_stack+72600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+534468,int_stack+82104,int_stack+76956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+549912,int_stack+534468,int_stack+521400,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+576048,int_stack+88110,int_stack+82104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+594066,int_stack+576048,int_stack+534468,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+624954,int_stack+594066,int_stack+549912,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+521400,int_stack+95040,int_stack+88110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+668514,int_stack+521400,int_stack+576048,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+542190,int_stack+668514,int_stack+594066,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+914100,int_stack+542190,int_stack+624954,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+593670,int_stack+102960,int_stack+95040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+617430,int_stack+593670,int_stack+521400,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+979440,int_stack+617430,int_stack+668514,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1039500,int_stack+979440,int_stack+542190,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1116720,int_stack+1039500,int_stack+914100,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+914100,int_stack+111936,int_stack+102960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+521400,int_stack+914100,int_stack+593670,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1208196,int_stack+521400,int_stack+617430,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+568920,int_stack+1208196,int_stack+979440,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1277496,int_stack+568920,int_stack+1039500,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+941028,int_stack+1277496,int_stack+1116720,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1062996,int_stack+122034,int_stack+111936,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1093290,int_stack+1062996,int_stack+914100,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1385604,int_stack+1093290,int_stack+521400,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1464804,int_stack+1385604,int_stack+1208196,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1147146,int_stack+1464804,int_stack+568920,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+521400,int_stack+1147146,int_stack+1277496,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1568754,int_stack+521400,int_stack+941028,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+665544,int_stack+133320,int_stack+122034,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+914100,int_stack+665544,int_stack+1062996,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+974688,int_stack+914100,int_stack+1093290,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+974688,int_stack+1385604,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1273272,int_stack+0,int_stack+1464804,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1725570,int_stack+1273272,int_stack+1147146,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1064448,int_stack+1725570,int_stack+521400,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1893738,int_stack+1064448,int_stack+1568754,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+521400,int_stack+145860,int_stack+133320,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+559020,int_stack+521400,int_stack+665544,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1418802,int_stack+559020,int_stack+914100,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+521400,int_stack+1418802,int_stack+974688,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1418802,int_stack+521400,int_stack+0,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2089758,int_stack+1418802,int_stack+1273272,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1249776,int_stack+2089758,int_stack+1725570,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1465992,int_stack+1249776,int_stack+1064448,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+914100,int_stack+1465992,int_stack+1893738,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1153680,int_stack+914100,int_stack+714450,3630);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+164868,int_stack+159720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+170952,int_stack+164868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+178050,int_stack+170952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+186240,int_stack+178050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+521400,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+521400,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+563988,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+195600,int_stack+186240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+641208,int_stack+113490,int_stack+521400,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+712188,int_stack+641208,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+803448,int_stack+712188,int_stack+563988,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+521400,int_stack+206208,int_stack+195600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+553224,int_stack+521400,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+553224,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+81900,int_stack+0,int_stack+641208,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1752630,int_stack+81900,int_stack+712188,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+609384,int_stack+1752630,int_stack+803448,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+753528,int_stack+218142,int_stack+206208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+789330,int_stack+753528,int_stack+521400,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1880394,int_stack+789330,int_stack+553224,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1973994,int_stack+1880394,int_stack+0,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2096844,int_stack+1973994,int_stack+81900,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+2096844,int_stack+1752630,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2245902,int_stack+0,int_stack+609384,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1752630,int_stack+231480,int_stack+218142,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1792644,int_stack+1752630,int_stack+753528,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+521400,int_stack+1792644,int_stack+789330,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+627480,int_stack+521400,int_stack+1880394,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2431230,int_stack+627480,int_stack+1973994,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1864248,int_stack+2431230,int_stack+2096844,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2603220,int_stack+1864248,int_stack+0,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2822244,int_stack+2603220,int_stack+2245902,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+246300,int_stack+231480,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+44460,int_stack+0,int_stack+1752630,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+124488,int_stack+44460,int_stack+1792644,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2062992,int_stack+124488,int_stack+521400,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+2062992,int_stack+627480,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2062992,int_stack+0,int_stack+2431230,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+2062992,int_stack+1864248,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+521400,int_stack+0,int_stack+2603220,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1752630,int_stack+521400,int_stack+2822244,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+2035770,int_stack+1752630,int_stack+914100,3630);
 /*--- compute (md|nm) ---*/
 hrr1_build_md(Libint->AB,int_stack+2754510,int_stack+2035770,int_stack+1153680,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+521400,int_stack+268686,int_stack+262680,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+539418,int_stack+275784,int_stack+268686,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+560712,int_stack+539418,int_stack+521400,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+596748,int_stack+284065,int_stack+275784,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+621591,int_stack+596748,int_stack+539418,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+664179,int_stack+621591,int_stack+560712,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+521400,int_stack+293620,int_stack+284065,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+724239,int_stack+521400,int_stack+596748,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+550065,int_stack+724239,int_stack+621591,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+773925,int_stack+550065,int_stack+664179,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+621045,int_stack+304540,int_stack+293620,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+653805,int_stack+621045,int_stack+521400,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+864015,int_stack+653805,int_stack+724239,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+946825,int_stack+864015,int_stack+550065,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1053295,int_stack+946825,int_stack+773925,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+521400,int_stack+316916,int_stack+304540,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+711135,int_stack+521400,int_stack+621045,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1179421,int_stack+711135,int_stack+653805,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+558528,int_stack+1179421,int_stack+864015,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+776655,int_stack+558528,int_stack+946825,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1274971,int_stack+776655,int_stack+1053295,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+925713,int_stack+330839,int_stack+316916,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+967482,int_stack+925713,int_stack+521400,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1041738,int_stack+967482,int_stack+711135,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1443139,int_stack+1041738,int_stack+1179421,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+1443139,int_stack+558528,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+521400,int_stack+0,int_stack+776655,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3952410,int_stack+521400,int_stack+1274971,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+720144,int_stack+346400,int_stack+330839,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+766827,int_stack+720144,int_stack+925713,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1150938,int_stack+766827,int_stack+967482,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+850365,int_stack+1150938,int_stack+1041738,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4168626,int_stack+850365,int_stack+1443139,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1274698,int_stack+4168626,int_stack+0,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1274698,int_stack+521400,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4369281,int_stack+0,int_stack+3952410,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+3952410,int_stack+363690,int_stack+346400,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+4004280,int_stack+3952410,int_stack+720144,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+521400,int_stack+4004280,int_stack+766827,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3952410,int_stack+521400,int_stack+1150938,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+521400,int_stack+3952410,int_stack+850365,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+750720,int_stack+521400,int_stack+4168626,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3952410,int_stack+750720,int_stack+1274698,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+521400,int_stack+3952410,int_stack+0,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+521400,int_stack+4369281,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+521400,int_stack+0,int_stack+1752630,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3952410,int_stack+521400,int_stack+2035770,3630);
 /*--- compute (mf|nm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5389890,int_stack+3952410,int_stack+2754510,3630);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1370820,int_stack+389730,int_stack+382800,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1391610,int_stack+397920,int_stack+389730,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1416180,int_stack+1391610,int_stack+1370820,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1457760,int_stack+407475,int_stack+397920,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1486425,int_stack+1457760,int_stack+1391610,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1535565,int_stack+1486425,int_stack+1416180,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1370820,int_stack+418500,int_stack+407475,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1604865,int_stack+1370820,int_stack+1457760,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1403895,int_stack+1604865,int_stack+1486425,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1662195,int_stack+1403895,int_stack+1535565,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1485795,int_stack+431100,int_stack+418500,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1523595,int_stack+1485795,int_stack+1370820,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1766145,int_stack+1523595,int_stack+1604865,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1861695,int_stack+1766145,int_stack+1403895,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1984545,int_stack+1861695,int_stack+1662195,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1370820,int_stack+445380,int_stack+431100,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1589745,int_stack+1370820,int_stack+1485795,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2130075,int_stack+1589745,int_stack+1523595,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1413660,int_stack+2130075,int_stack+1766145,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1665345,int_stack+1413660,int_stack+1861695,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2240325,int_stack+1665345,int_stack+1984545,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1837335,int_stack+461445,int_stack+445380,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1885530,int_stack+1837335,int_stack+1370820,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1971210,int_stack+1885530,int_stack+1589745,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2434365,int_stack+1971210,int_stack+2130075,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2599740,int_stack+2434365,int_stack+1413660,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1370820,int_stack+2599740,int_stack+1665345,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2800395,int_stack+1370820,int_stack+2240325,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1600140,int_stack+479400,int_stack+461445,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1654005,int_stack+1600140,int_stack+1837335,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2097210,int_stack+1654005,int_stack+1885530,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1750395,int_stack+2097210,int_stack+1971210,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3049875,int_stack+1750395,int_stack+2434365,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2240010,int_stack+3049875,int_stack+2599740,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3281400,int_stack+2240010,int_stack+1370820,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3576240,int_stack+3281400,int_stack+2800395,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1370820,int_stack+499350,int_stack+479400,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1430670,int_stack+1370820,int_stack+1600140,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2507550,int_stack+1430670,int_stack+1654005,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1370820,int_stack+2507550,int_stack+2097210,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2507550,int_stack+1370820,int_stack+1750395,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1370820,int_stack+2507550,int_stack+3049875,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2507550,int_stack+1370820,int_stack+2240010,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1370820,int_stack+2507550,int_stack+3281400,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1739370,int_stack+1370820,int_stack+3576240,105);
 /*--- compute (qp|nm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2120520,int_stack+1739370,int_stack+0,3630);
 /*--- compute (od|nm) ---*/
 hrr1_build_od(Libint->AB,int_stack+7386390,int_stack+2120520,int_stack+521400,3630);
 /*--- compute (nf|nm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+7386390,int_stack+3952410,3630);
 /*--- compute (mg|nm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+7386390,int_stack+0,int_stack+5389890,3630);
 return int_stack+7386390;}
