/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhng(Libint_t*, prim_data*);

  /* Computes quartets of (mh|ng) integrals */

REALTYPE *hrr_order_mhng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[10][10] = int_stack + 25300;
 Libint->vrr_classes[10][11] = int_stack + 29656;
 Libint->vrr_classes[10][12] = int_stack + 34804;
 Libint->vrr_classes[10][13] = int_stack + 40810;
 Libint->vrr_classes[10][14] = int_stack + 47740;
 Libint->vrr_classes[11][10] = int_stack + 55660;
 Libint->vrr_classes[11][11] = int_stack + 60808;
 Libint->vrr_classes[11][12] = int_stack + 66892;
 Libint->vrr_classes[11][13] = int_stack + 73990;
 Libint->vrr_classes[11][14] = int_stack + 82180;
 Libint->vrr_classes[12][10] = int_stack + 91540;
 Libint->vrr_classes[12][11] = int_stack + 97546;
 Libint->vrr_classes[12][12] = int_stack + 104644;
 Libint->vrr_classes[12][13] = int_stack + 112925;
 Libint->vrr_classes[12][14] = int_stack + 122480;
 Libint->vrr_classes[13][10] = int_stack + 133400;
 Libint->vrr_classes[13][11] = int_stack + 140330;
 Libint->vrr_classes[13][12] = int_stack + 148520;
 Libint->vrr_classes[13][13] = int_stack + 158075;
 Libint->vrr_classes[13][14] = int_stack + 169100;
 Libint->vrr_classes[14][10] = int_stack + 181700;
 Libint->vrr_classes[14][11] = int_stack + 189620;
 Libint->vrr_classes[14][12] = int_stack + 198980;
 Libint->vrr_classes[14][13] = int_stack + 209900;
 Libint->vrr_classes[14][14] = int_stack + 222500;
 memset(int_stack,0,236900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 236900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhng(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+236900,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+247790,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+260660,int_stack+247790,int_stack+236900,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+282440,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+297455,int_stack+282440,int_stack+247790,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+323195,int_stack+297455,int_stack+260660,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236900,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+359495,int_stack+236900,int_stack+282440,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+236900,int_stack+359495,int_stack+297455,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+359495,int_stack+236900,int_stack+323195,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+236900,int_stack+29656,int_stack+25300,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+249968,int_stack+34804,int_stack+29656,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+265412,int_stack+249968,int_stack+236900,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+291548,int_stack+40810,int_stack+34804,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+309566,int_stack+291548,int_stack+249968,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+413945,int_stack+309566,int_stack+265412,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236900,int_stack+47740,int_stack+40810,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+236900,int_stack+291548,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+236900,int_stack+0,int_stack+309566,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+288380,int_stack+236900,int_stack+413945,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+413945,int_stack+288380,int_stack+359495,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+236900,int_stack+60808,int_stack+55660,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+252344,int_stack+66892,int_stack+60808,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+252344,int_stack+236900,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+30888,int_stack+73990,int_stack+66892,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+353720,int_stack+30888,int_stack+252344,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+236900,int_stack+353720,int_stack+0,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+82180,int_stack+73990,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+577295,int_stack+0,int_stack+30888,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+577295,int_stack+353720,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+577295,int_stack+0,int_stack+236900,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+654515,int_stack+577295,int_stack+288380,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+850535,int_stack+654515,int_stack+413945,990);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+236900,int_stack+97546,int_stack+91540,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+254918,int_stack+104644,int_stack+97546,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+276212,int_stack+254918,int_stack+236900,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+312248,int_stack+112925,int_stack+104644,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+337091,int_stack+312248,int_stack+254918,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+379679,int_stack+337091,int_stack+276212,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236900,int_stack+122480,int_stack+112925,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+439739,int_stack+236900,int_stack+312248,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+236900,int_stack+439739,int_stack+337091,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+439739,int_stack+236900,int_stack+379679,91);
 /*--- compute (op|ng) ---*/
 hrr1_build_op(Libint->AB,int_stack+1177235,int_stack+439739,int_stack+577295,990);
 /*--- compute (nd|ng) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1408895,int_stack+1177235,int_stack+654515,990);
 /*--- compute (mf|ng) ---*/
 hrr1_build_mf(Libint->AB,int_stack+1800935,int_stack+1408895,int_stack+850535,990);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+236900,int_stack+140330,int_stack+133400,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+257690,int_stack+148520,int_stack+140330,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+282260,int_stack+257690,int_stack+236900,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+323840,int_stack+158075,int_stack+148520,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+352505,int_stack+323840,int_stack+257690,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+529829,int_stack+352505,int_stack+282260,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236900,int_stack+169100,int_stack+158075,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+599129,int_stack+236900,int_stack+323840,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+236900,int_stack+599129,int_stack+352505,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+599129,int_stack+236900,int_stack+529829,105);
 /*--- compute (qp|ng) ---*/
 hrr1_build_qp(Libint->AB,int_stack+703079,int_stack+599129,int_stack+439739,990);
 /*--- compute (od|ng) ---*/
 hrr1_build_od(Libint->AB,int_stack+2345435,int_stack+703079,int_stack+1177235,990);
 /*--- compute (nf|ng) ---*/
 hrr1_build_nf(Libint->AB,int_stack+2808755,int_stack+2345435,int_stack+1408895,990);
 /*--- compute (mg|ng) ---*/
 hrr1_build_mg(Libint->AB,int_stack+973349,int_stack+2808755,int_stack+1800935,990);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+236900,int_stack+189620,int_stack+181700,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+260660,int_stack+198980,int_stack+189620,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+288740,int_stack+260660,int_stack+236900,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+336260,int_stack+209900,int_stack+198980,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+369020,int_stack+336260,int_stack+260660,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+425180,int_stack+369020,int_stack+288740,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236900,int_stack+222500,int_stack+209900,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+504380,int_stack+236900,int_stack+336260,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1790099,int_stack+504380,int_stack+369020,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1883699,int_stack+1790099,int_stack+425180,120);
 /*--- compute (rp|ng) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2002499,int_stack+1883699,int_stack+599129,990);
 /*--- compute (qd|ng) ---*/
 hrr1_build_qd(Libint->AB,int_stack+0,int_stack+2002499,int_stack+703079,990);
 /*--- compute (of|ng) ---*/
 hrr1_build_of(Libint->AB,int_stack+3462155,int_stack+0,int_stack+2345435,990);
 /*--- compute (ng|ng) ---*/
 hrr1_build_ng(Libint->AB,int_stack+1790099,int_stack+3462155,int_stack+2808755,990);
 /*--- compute (mh|ng) ---*/
 hrr1_build_mh(Libint->AB,int_stack+2770199,int_stack+1790099,int_stack+973349,990);
 return int_stack+2770199;}
