/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mimi(Libint_t*, prim_data*);

  /* Computes quartets of (mi|mi) integrals */

REALTYPE *hrr_order_mimi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[10][9] = int_stack + 35805;
 Libint->vrr_classes[10][10] = int_stack + 39435;
 Libint->vrr_classes[10][11] = int_stack + 43791;
 Libint->vrr_classes[10][12] = int_stack + 48939;
 Libint->vrr_classes[10][13] = int_stack + 54945;
 Libint->vrr_classes[10][14] = int_stack + 61875;
 Libint->vrr_classes[10][15] = int_stack + 69795;
 Libint->vrr_classes[11][9] = int_stack + 78771;
 Libint->vrr_classes[11][10] = int_stack + 83061;
 Libint->vrr_classes[11][11] = int_stack + 88209;
 Libint->vrr_classes[11][12] = int_stack + 94293;
 Libint->vrr_classes[11][13] = int_stack + 101391;
 Libint->vrr_classes[11][14] = int_stack + 109581;
 Libint->vrr_classes[11][15] = int_stack + 118941;
 Libint->vrr_classes[12][9] = int_stack + 129549;
 Libint->vrr_classes[12][10] = int_stack + 134554;
 Libint->vrr_classes[12][11] = int_stack + 140560;
 Libint->vrr_classes[12][12] = int_stack + 147658;
 Libint->vrr_classes[12][13] = int_stack + 155939;
 Libint->vrr_classes[12][14] = int_stack + 165494;
 Libint->vrr_classes[12][15] = int_stack + 176414;
 Libint->vrr_classes[13][9] = int_stack + 188790;
 Libint->vrr_classes[13][10] = int_stack + 194565;
 Libint->vrr_classes[13][11] = int_stack + 201495;
 Libint->vrr_classes[13][12] = int_stack + 209685;
 Libint->vrr_classes[13][13] = int_stack + 219240;
 Libint->vrr_classes[13][14] = int_stack + 230265;
 Libint->vrr_classes[13][15] = int_stack + 242865;
 Libint->vrr_classes[14][9] = int_stack + 257145;
 Libint->vrr_classes[14][10] = int_stack + 263745;
 Libint->vrr_classes[14][11] = int_stack + 271665;
 Libint->vrr_classes[14][12] = int_stack + 281025;
 Libint->vrr_classes[14][13] = int_stack + 291945;
 Libint->vrr_classes[14][14] = int_stack + 304545;
 Libint->vrr_classes[14][15] = int_stack + 318945;
 Libint->vrr_classes[15][9] = int_stack + 335265;
 Libint->vrr_classes[15][10] = int_stack + 342745;
 Libint->vrr_classes[15][11] = int_stack + 351721;
 Libint->vrr_classes[15][12] = int_stack + 362329;
 Libint->vrr_classes[15][13] = int_stack + 374705;
 Libint->vrr_classes[15][14] = int_stack + 388985;
 Libint->vrr_classes[15][15] = int_stack + 405305;
 memset(int_stack,0,423801*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 423801;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mimi(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+423801,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+432876,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+443766,int_stack+432876,int_stack+423801,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+461916,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+474786,int_stack+461916,int_stack+432876,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+496566,int_stack+474786,int_stack+443766,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+423801,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+526816,int_stack+423801,int_stack+461916,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+552556,int_stack+526816,int_stack+474786,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+438816,int_stack+552556,int_stack+496566,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+484191,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+588856,int_stack+484191,int_stack+423801,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+618886,int_stack+588856,int_stack+526816,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+661786,int_stack+618886,int_stack+552556,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+501516,int_stack+661786,int_stack+438816,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+423801,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+443601,int_stack+423801,int_stack+484191,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+716236,int_stack+443601,int_stack+588856,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+423801,int_stack+716236,int_stack+618886,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+565041,int_stack+423801,int_stack+661786,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+641271,int_stack+565041,int_stack+501516,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+423801,int_stack+39435,int_stack+35805,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+434691,int_stack+43791,int_stack+39435,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+447759,int_stack+434691,int_stack+423801,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+469539,int_stack+48939,int_stack+43791,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+484983,int_stack+469539,int_stack+434691,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+511119,int_stack+484983,int_stack+447759,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+423801,int_stack+54945,int_stack+48939,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+547419,int_stack+423801,int_stack+469539,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+578307,int_stack+547419,int_stack+484983,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+441819,int_stack+578307,int_stack+511119,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+496269,int_stack+61875,int_stack+54945,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+725971,int_stack+496269,int_stack+423801,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+725971,int_stack+547419,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+762007,int_stack+0,int_stack+578307,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+517059,int_stack+762007,int_stack+441819,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+423801,int_stack+69795,int_stack+61875,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+447561,int_stack+423801,int_stack+496269,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+827347,int_stack+447561,int_stack+725971,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+423801,int_stack+827347,int_stack+0,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+827347,int_stack+423801,int_stack+762007,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+918823,int_stack+827347,int_stack+517059,66);
 /*--- compute (mp|mi) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1020463,int_stack+918823,int_stack+641271,1540);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+423801,int_stack+83061,int_stack+78771,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+436671,int_stack+88209,int_stack+83061,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+452115,int_stack+436671,int_stack+423801,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+477855,int_stack+94293,int_stack+88209,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+496107,int_stack+477855,int_stack+436671,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+526995,int_stack+496107,int_stack+452115,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+423801,int_stack+101391,int_stack+94293,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+569895,int_stack+423801,int_stack+477855,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+606399,int_stack+569895,int_stack+496107,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+445095,int_stack+606399,int_stack+526995,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+509445,int_stack+109581,int_stack+101391,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+657879,int_stack+509445,int_stack+423801,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+700467,int_stack+657879,int_stack+569895,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+761307,int_stack+700467,int_stack+606399,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+534015,int_stack+761307,int_stack+445095,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+423801,int_stack+118941,int_stack+109581,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+451881,int_stack+423801,int_stack+509445,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+838527,int_stack+451881,int_stack+657879,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+423801,int_stack+838527,int_stack+700467,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+624105,int_stack+423801,int_stack+761307,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+732213,int_stack+624105,int_stack+534015,78);
 /*--- compute (np|mi) ---*/
 hrr1_build_np(Libint->AB,int_stack+423801,int_stack+732213,int_stack+918823,1540);
 /*--- compute (md|mi) ---*/
 hrr1_build_md(Libint->AB,int_stack+1274563,int_stack+423801,int_stack+1020463,1540);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+852333,int_stack+134554,int_stack+129549,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+867348,int_stack+140560,int_stack+134554,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+885366,int_stack+867348,int_stack+852333,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+915396,int_stack+147658,int_stack+140560,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+936690,int_stack+915396,int_stack+867348,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+972726,int_stack+936690,int_stack+885366,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+852333,int_stack+155939,int_stack+147658,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1022776,int_stack+852333,int_stack+915396,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1065364,int_stack+1022776,int_stack+936690,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+877176,int_stack+1065364,int_stack+972726,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+952251,int_stack+165494,int_stack+155939,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1125424,int_stack+952251,int_stack+852333,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1175110,int_stack+1125424,int_stack+1022776,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+1175110,int_stack+1065364,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+980916,int_stack+0,int_stack+877176,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+852333,int_stack+176414,int_stack+165494,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+885093,int_stack+852333,int_stack+952251,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+90090,int_stack+885093,int_stack+1125424,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+852333,int_stack+90090,int_stack+1175110,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1086021,int_stack+852333,int_stack+0,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1086021,int_stack+980916,91);
 /*--- compute (op|mi) ---*/
 hrr1_build_op(Libint->AB,int_stack+852333,int_stack+0,int_stack+732213,1540);
 /*--- compute (nd|mi) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1782763,int_stack+852333,int_stack+423801,1540);
 /*--- compute (mf|mi) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2392603,int_stack+1782763,int_stack+1274563,1540);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+423801,int_stack+194565,int_stack+188790,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+441126,int_stack+201495,int_stack+194565,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+461916,int_stack+441126,int_stack+423801,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+496566,int_stack+209685,int_stack+201495,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+521136,int_stack+496566,int_stack+441126,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+562716,int_stack+521136,int_stack+461916,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+423801,int_stack+219240,int_stack+209685,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+620466,int_stack+423801,int_stack+496566,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+669606,int_stack+620466,int_stack+521136,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+452466,int_stack+669606,int_stack+562716,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+539091,int_stack+230265,int_stack+219240,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+738906,int_stack+539091,int_stack+423801,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+140140,int_stack+738906,int_stack+620466,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1212693,int_stack+140140,int_stack+669606,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+572166,int_stack+1212693,int_stack+452466,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+423801,int_stack+242865,int_stack+230265,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+461601,int_stack+423801,int_stack+539091,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1316643,int_stack+461601,int_stack+738906,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+423801,int_stack+1316643,int_stack+140140,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1316643,int_stack+423801,int_stack+1212693,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1462173,int_stack+1316643,int_stack+572166,105);
 /*--- compute (qp|mi) ---*/
 hrr1_build_qp(Libint->AB,int_stack+423801,int_stack+1462173,int_stack+0,1540);
 /*--- compute (od|mi) ---*/
 hrr1_build_od(Libint->AB,int_stack+3239603,int_stack+423801,int_stack+852333,1540);
 /*--- compute (nf|mi) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3960323,int_stack+3239603,int_stack+1782763,1540);
 /*--- compute (mg|mi) ---*/
 hrr1_build_mg(Libint->AB,int_stack+4976723,int_stack+3960323,int_stack+2392603,1540);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+263745,int_stack+257145,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+271665,int_stack+263745,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+281025,int_stack+271665,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158760,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+291945,int_stack+281025,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224760,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+844221,int_stack+224760,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+844221,int_stack+158760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131760,int_stack+304545,int_stack+291945,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+923421,int_stack+131760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+988941,int_stack+923421,int_stack+224760,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+169560,int_stack+988941,int_stack+844221,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1082541,int_stack+169560,int_stack+32760,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+844221,int_stack+318945,int_stack+304545,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+844221,int_stack+131760,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1221141,int_stack+0,int_stack+923421,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+1221141,int_stack+988941,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1221141,int_stack+0,int_stack+169560,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1221141,int_stack+1082541,120);
 /*--- compute (rp|mi) ---*/
 hrr1_build_rp(Libint->AB,int_stack+844221,int_stack+0,int_stack+1462173,1540);
 /*--- compute (qd|mi) ---*/
 hrr1_build_qd(Libint->AB,int_stack+1329321,int_stack+844221,int_stack+423801,1540);
 /*--- compute (of|mi) ---*/
 hrr1_build_of(Libint->AB,int_stack+6247223,int_stack+1329321,int_stack+3239603,1540);
 /*--- compute (ng|mi) ---*/
 hrr1_build_ng(Libint->AB,int_stack+2170161,int_stack+6247223,int_stack+3960323,1540);
 /*--- compute (mh|mi) ---*/
 hrr1_build_mh(Libint->AB,int_stack+7448423,int_stack+2170161,int_stack+4976723,1540);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+423801,int_stack+342745,int_stack+335265,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446241,int_stack+351721,int_stack+342745,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+473169,int_stack+446241,int_stack+423801,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+518049,int_stack+362329,int_stack+351721,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+549873,int_stack+518049,int_stack+446241,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+603729,int_stack+549873,int_stack+473169,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+423801,int_stack+374705,int_stack+362329,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+678529,int_stack+423801,int_stack+518049,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+742177,int_stack+678529,int_stack+549873,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+460929,int_stack+742177,int_stack+603729,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+573129,int_stack+388985,int_stack+374705,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+184800,int_stack+573129,int_stack+423801,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+259056,int_stack+184800,int_stack+678529,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3694761,int_stack+259056,int_stack+742177,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+615969,int_stack+3694761,int_stack+460929,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+423801,int_stack+405305,int_stack+388985,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+472761,int_stack+423801,int_stack+573129,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3829401,int_stack+472761,int_stack+184800,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+365136,int_stack+3829401,int_stack+259056,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3829401,int_stack+365136,int_stack+3694761,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+4017897,int_stack+3829401,int_stack+615969,136);
 /*--- compute (tp|mi) ---*/
 hrr1_build_tp(Libint->AB,int_stack+4227337,int_stack+4017897,int_stack+0,1540);
 /*--- compute (rd|mi) ---*/
 hrr1_build_rd(Libint->AB,int_stack+4781737,int_stack+4227337,int_stack+844221,1540);
 /*--- compute (qf|mi) ---*/
 hrr1_build_qf(Libint->AB,int_stack+9227123,int_stack+4781737,int_stack+1329321,1540);
 /*--- compute (og|mi) ---*/
 hrr1_build_og(Libint->AB,int_stack+0,int_stack+9227123,int_stack+6247223,1540);
 /*--- compute (nh|mi) ---*/
 hrr1_build_nh(Libint->AB,int_stack+3694761,int_stack+0,int_stack+2170161,1540);
 /*--- compute (mi|mi) ---*/
 hrr1_build_mi(Libint->AB,int_stack+0,int_stack+3694761,int_stack+7448423,1540);
 return int_stack+0;}
