/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mlnk(Libint_t*, prim_data*);

  /* Computes quartets of (ml|nk) integrals */

REALTYPE *hrr_order_mlnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[10][10] = int_stack + 50600;
 Libint->vrr_classes[10][11] = int_stack + 54956;
 Libint->vrr_classes[10][12] = int_stack + 60104;
 Libint->vrr_classes[10][13] = int_stack + 66110;
 Libint->vrr_classes[10][14] = int_stack + 73040;
 Libint->vrr_classes[10][15] = int_stack + 80960;
 Libint->vrr_classes[10][16] = int_stack + 89936;
 Libint->vrr_classes[10][17] = int_stack + 100034;
 Libint->vrr_classes[11][10] = int_stack + 111320;
 Libint->vrr_classes[11][11] = int_stack + 116468;
 Libint->vrr_classes[11][12] = int_stack + 122552;
 Libint->vrr_classes[11][13] = int_stack + 129650;
 Libint->vrr_classes[11][14] = int_stack + 137840;
 Libint->vrr_classes[11][15] = int_stack + 147200;
 Libint->vrr_classes[11][16] = int_stack + 157808;
 Libint->vrr_classes[11][17] = int_stack + 169742;
 Libint->vrr_classes[12][10] = int_stack + 183080;
 Libint->vrr_classes[12][11] = int_stack + 189086;
 Libint->vrr_classes[12][12] = int_stack + 196184;
 Libint->vrr_classes[12][13] = int_stack + 204465;
 Libint->vrr_classes[12][14] = int_stack + 214020;
 Libint->vrr_classes[12][15] = int_stack + 224940;
 Libint->vrr_classes[12][16] = int_stack + 237316;
 Libint->vrr_classes[12][17] = int_stack + 251239;
 Libint->vrr_classes[13][10] = int_stack + 266800;
 Libint->vrr_classes[13][11] = int_stack + 273730;
 Libint->vrr_classes[13][12] = int_stack + 281920;
 Libint->vrr_classes[13][13] = int_stack + 291475;
 Libint->vrr_classes[13][14] = int_stack + 302500;
 Libint->vrr_classes[13][15] = int_stack + 315100;
 Libint->vrr_classes[13][16] = int_stack + 329380;
 Libint->vrr_classes[13][17] = int_stack + 345445;
 Libint->vrr_classes[14][10] = int_stack + 363400;
 Libint->vrr_classes[14][11] = int_stack + 371320;
 Libint->vrr_classes[14][12] = int_stack + 380680;
 Libint->vrr_classes[14][13] = int_stack + 391600;
 Libint->vrr_classes[14][14] = int_stack + 404200;
 Libint->vrr_classes[14][15] = int_stack + 418600;
 Libint->vrr_classes[14][16] = int_stack + 434920;
 Libint->vrr_classes[14][17] = int_stack + 453280;
 Libint->vrr_classes[15][10] = int_stack + 473800;
 Libint->vrr_classes[15][11] = int_stack + 482776;
 Libint->vrr_classes[15][12] = int_stack + 493384;
 Libint->vrr_classes[15][13] = int_stack + 505760;
 Libint->vrr_classes[15][14] = int_stack + 520040;
 Libint->vrr_classes[15][15] = int_stack + 536360;
 Libint->vrr_classes[15][16] = int_stack + 554856;
 Libint->vrr_classes[15][17] = int_stack + 575664;
 Libint->vrr_classes[16][10] = int_stack + 598920;
 Libint->vrr_classes[16][11] = int_stack + 609018;
 Libint->vrr_classes[16][12] = int_stack + 620952;
 Libint->vrr_classes[16][13] = int_stack + 634875;
 Libint->vrr_classes[16][14] = int_stack + 650940;
 Libint->vrr_classes[16][15] = int_stack + 669300;
 Libint->vrr_classes[16][16] = int_stack + 690108;
 Libint->vrr_classes[16][17] = int_stack + 713517;
 Libint->vrr_classes[17][10] = int_stack + 739680;
 Libint->vrr_classes[17][11] = int_stack + 750966;
 Libint->vrr_classes[17][12] = int_stack + 764304;
 Libint->vrr_classes[17][13] = int_stack + 779865;
 Libint->vrr_classes[17][14] = int_stack + 797820;
 Libint->vrr_classes[17][15] = int_stack + 818340;
 Libint->vrr_classes[17][16] = int_stack + 841596;
 Libint->vrr_classes[17][17] = int_stack + 867759;
 memset(int_stack,0,897000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 897000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mlnk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+897000,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+907890,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+920760,int_stack+907890,int_stack+897000,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+942540,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+957555,int_stack+942540,int_stack+907890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+983295,int_stack+957555,int_stack+920760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+897000,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1019595,int_stack+897000,int_stack+942540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+914325,int_stack+1019595,int_stack+957555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1049625,int_stack+914325,int_stack+983295,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+957225,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+977025,int_stack+957225,int_stack+897000,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1104075,int_stack+977025,int_stack+1019595,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1154125,int_stack+1104075,int_stack+914325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1218475,int_stack+1154125,int_stack+1049625,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+897000,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1011675,int_stack+897000,int_stack+957225,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1294705,int_stack+1011675,int_stack+977025,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+919440,int_stack+1294705,int_stack+1104075,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1051275,int_stack+919440,int_stack+1154125,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1352455,int_stack+1051275,int_stack+1218475,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1141365,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1166610,int_stack+1141365,int_stack+897000,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1211490,int_stack+1166610,int_stack+1011675,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1454095,int_stack+1211490,int_stack+1294705,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1141365,int_stack+1454095,int_stack+919440,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+897000,int_stack+1141365,int_stack+1051275,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1017120,int_stack+897000,int_stack+1352455,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+897000,int_stack+54956,int_stack+50600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+910068,int_stack+60104,int_stack+54956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+925512,int_stack+910068,int_stack+897000,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+951648,int_stack+66110,int_stack+60104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+969666,int_stack+951648,int_stack+910068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1147800,int_stack+969666,int_stack+925512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+897000,int_stack+73040,int_stack+66110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1191360,int_stack+897000,int_stack+951648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+917790,int_stack+1191360,int_stack+969666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1227396,int_stack+917790,int_stack+1147800,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1147800,int_stack+80960,int_stack+73040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+969270,int_stack+1147800,int_stack+897000,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1292736,int_stack+969270,int_stack+1191360,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1352796,int_stack+1292736,int_stack+917790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1430016,int_stack+1352796,int_stack+1227396,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+897000,int_stack+89936,int_stack+80960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1171560,int_stack+897000,int_stack+1147800,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1219080,int_stack+1171560,int_stack+969270,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+923928,int_stack+1219080,int_stack+1292736,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1521492,int_stack+923928,int_stack+1352796,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1288380,int_stack+1521492,int_stack+1430016,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1410348,int_stack+100034,int_stack+89936,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1440642,int_stack+1410348,int_stack+897000,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+1440642,int_stack+1171560,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1410348,int_stack+0,int_stack+1219080,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1147800,int_stack+1410348,int_stack+923928,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1629600,int_stack+1147800,int_stack+1521492,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1410348,int_stack+1629600,int_stack+1288380,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1567164,int_stack+1410348,int_stack+1017120,2376);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+116468,int_stack+111320,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+122552,int_stack+116468,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+129650,int_stack+122552,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+897000,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+137840,int_stack+129650,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+948480,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+948480,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+991068,int_stack+24570,int_stack+897000,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+897000,int_stack+147200,int_stack+137840,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85410,int_stack+897000,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1068288,int_stack+85410,int_stack+948480,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1139268,int_stack+1068288,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1230528,int_stack+1139268,int_stack+991068,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+157808,int_stack+147200,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+925080,int_stack+0,int_stack+897000,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+981240,int_stack+925080,int_stack+85410,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+981240,int_stack+1068288,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1959204,int_stack+31824,int_stack+1139268,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1063140,int_stack+1959204,int_stack+1230528,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1207284,int_stack+169742,int_stack+157808,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1243086,int_stack+1207284,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1306734,int_stack+1243086,int_stack+925080,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2086968,int_stack+1306734,int_stack+981240,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1207284,int_stack+2086968,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1207284,int_stack+1959204,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1959204,int_stack+0,int_stack+1063140,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+897000,int_stack+1959204,int_stack+1410348,2376);
 /*--- compute (md|nk) ---*/
 hrr1_build_md(Libint->AB,int_stack+2144532,int_stack+897000,int_stack+1567164,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+189086,int_stack+183080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+196184,int_stack+189086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+204465,int_stack+196184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+214020,int_stack+204465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1367448,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+1367448,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1417134,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+224940,int_stack+214020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1507224,int_stack+132405,int_stack+1367448,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1590034,int_stack+1507224,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1696504,int_stack+1590034,int_stack+1417134,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1367448,int_stack+237316,int_stack+224940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1404576,int_stack+1367448,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1404576,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+95550,int_stack+0,int_stack+1507224,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2928612,int_stack+95550,int_stack+1590034,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1470096,int_stack+2928612,int_stack+1696504,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1638264,int_stack+251239,int_stack+237316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1680033,int_stack+1638264,int_stack+1367448,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1754289,int_stack+1680033,int_stack+1404576,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3077670,int_stack+1754289,int_stack+0,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1638264,int_stack+3077670,int_stack+95550,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1638264,int_stack+2928612,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2928612,int_stack+0,int_stack+1470096,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+1367448,int_stack+2928612,int_stack+1959204,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3144828,int_stack+1367448,int_stack+897000,2376);
 /*--- compute (mf|nk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4085724,int_stack+3144828,int_stack+2144532,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+897000,int_stack+273730,int_stack+266800,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+917790,int_stack+281920,int_stack+273730,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+942360,int_stack+917790,int_stack+897000,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+983940,int_stack+291475,int_stack+281920,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1012605,int_stack+983940,int_stack+917790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1061745,int_stack+1012605,int_stack+942360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+897000,int_stack+302500,int_stack+291475,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1131045,int_stack+897000,int_stack+983940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+930075,int_stack+1131045,int_stack+1012605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1188375,int_stack+930075,int_stack+1061745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1011975,int_stack+315100,int_stack+302500,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1049775,int_stack+1011975,int_stack+897000,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+1049775,int_stack+1131045,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+95550,int_stack+0,int_stack+930075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1923432,int_stack+95550,int_stack+1188375,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+897000,int_stack+329380,int_stack+315100,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1115925,int_stack+897000,int_stack+1011975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1191525,int_stack+1115925,int_stack+1049775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+939840,int_stack+1191525,int_stack+0,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2068962,int_stack+939840,int_stack+95550,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+2068962,int_stack+1923432,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1923432,int_stack+345445,int_stack+329380,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1971627,int_stack+1923432,int_stack+897000,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+194040,int_stack+1971627,int_stack+1115925,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2240952,int_stack+194040,int_stack+1191525,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1083165,int_stack+2240952,int_stack+939840,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2240952,int_stack+1083165,int_stack+2068962,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2470272,int_stack+2240952,int_stack+0,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+5392524,int_stack+2470272,int_stack+2928612,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+6041172,int_stack+5392524,int_stack+1367448,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+897000,int_stack+6041172,int_stack+3144828,2376);
 /*--- compute (mg|nk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+7153140,int_stack+897000,int_stack+4085724,2376);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+371320,int_stack+363400,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+380680,int_stack+371320,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+391600,int_stack+380680,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+404200,int_stack+391600,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267480,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+267480,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2719752,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+418600,int_stack+404200,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2838552,int_stack+174600,int_stack+267480,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+250200,int_stack+2838552,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2947752,int_stack+250200,int_stack+2719752,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2719752,int_stack+434920,int_stack+418600,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+2719752,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3114072,int_stack+0,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+86400,int_stack+3114072,int_stack+2838552,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3240072,int_stack+86400,int_stack+250200,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3436632,int_stack+3240072,int_stack+2947752,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+250200,int_stack+453280,int_stack+434920,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+305280,int_stack+250200,int_stack+2719752,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2719752,int_stack+305280,int_stack+0,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2863752,int_stack+2719752,int_stack+3114072,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3658392,int_stack+2863752,int_stack+86400,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2719752,int_stack+3658392,int_stack+3240072,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3658392,int_stack+2719752,int_stack+3436632,120);
 /*--- compute (rp|nk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2719752,int_stack+3658392,int_stack+2470272,2376);
 /*--- compute (qd|nk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3943512,int_stack+2719752,int_stack+5392524,2376);
 /*--- compute (of|nk) ---*/
 hrr1_build_of(Libint->AB,int_stack+9113340,int_stack+3943512,int_stack+6041172,2376);
 /*--- compute (ng|nk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+10966620,int_stack+9113340,int_stack+897000,2376);
 /*--- compute (mh|nk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+13318860,int_stack+10966620,int_stack+7153140,2376);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+897000,int_stack+482776,int_stack+473800,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+923928,int_stack+493384,int_stack+482776,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+955752,int_stack+923928,int_stack+897000,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1009608,int_stack+505760,int_stack+493384,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1046736,int_stack+1009608,int_stack+923928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1110384,int_stack+1046736,int_stack+955752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+897000,int_stack+520040,int_stack+505760,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1200144,int_stack+897000,int_stack+1009608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+939840,int_stack+1200144,int_stack+1046736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1274400,int_stack+939840,int_stack+1110384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1045920,int_stack+536360,int_stack+520040,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1094880,int_stack+1045920,int_stack+897000,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1409040,int_stack+1094880,int_stack+1200144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1532800,int_stack+1409040,int_stack+939840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1691920,int_stack+1532800,int_stack+1274400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+897000,int_stack+554856,int_stack+536360,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1180560,int_stack+897000,int_stack+1045920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1880416,int_stack+1180560,int_stack+1094880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+952488,int_stack+1880416,int_stack+1409040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1278480,int_stack+952488,int_stack+1532800,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2023216,int_stack+1278480,int_stack+1691920,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1501248,int_stack+575664,int_stack+554856,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1563672,int_stack+1501248,int_stack+897000,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1674648,int_stack+1563672,int_stack+1180560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2274544,int_stack+1674648,int_stack+1880416,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1501248,int_stack+2274544,int_stack+952488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2274544,int_stack+1501248,int_stack+1278480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+897000,int_stack+2274544,int_stack+2023216,136);
 /*--- compute (tp|nk) ---*/
 hrr1_build_tp(Libint->AB,int_stack+1220136,int_stack+897000,int_stack+3658392,2376);
 /*--- compute (rd|nk) ---*/
 hrr1_build_rd(Libint->AB,int_stack+5240808,int_stack+1220136,int_stack+2719752,2376);
 /*--- compute (qf|nk) ---*/
 hrr1_build_qf(Libint->AB,int_stack+6737688,int_stack+5240808,int_stack+3943512,2376);
 /*--- compute (og|nk) ---*/
 hrr1_build_og(Libint->AB,int_stack+2075496,int_stack+6737688,int_stack+9113340,2376);
 /*--- compute (nh|nk) ---*/
 hrr1_build_nh(Libint->AB,int_stack+16063140,int_stack+2075496,int_stack+10966620,2376);
 /*--- compute (mi|nk) ---*/
 hrr1_build_mi(Libint->AB,int_stack+8899848,int_stack+16063140,int_stack+13318860,2376);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4855416,int_stack+609018,int_stack+598920,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4885710,int_stack+620952,int_stack+609018,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4921512,int_stack+4885710,int_stack+4855416,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+4982100,int_stack+634875,int_stack+620952,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5023869,int_stack+4982100,int_stack+4885710,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5095473,int_stack+5023869,int_stack+4921512,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+4855416,int_stack+650940,int_stack+634875,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+12558888,int_stack+4855416,int_stack+4982100,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+4903611,int_stack+12558888,int_stack+5023869,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+12642426,int_stack+4903611,int_stack+5095473,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5022951,int_stack+669300,int_stack+650940,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5078031,int_stack+5022951,int_stack+4855416,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+12793896,int_stack+5078031,int_stack+12558888,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+12933126,int_stack+12793896,int_stack+4903611,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+13112136,int_stack+12933126,int_stack+12642426,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+12558888,int_stack+690108,int_stack+669300,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+12621312,int_stack+12558888,int_stack+5022951,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4855416,int_stack+12621312,int_stack+5078031,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+5016066,int_stack+4855416,int_stack+12793896,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+13324194,int_stack+5016066,int_stack+12933126,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+12731472,int_stack+13324194,int_stack+13112136,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+13014216,int_stack+713517,int_stack+690108,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+13084443,int_stack+13014216,int_stack+12558888,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+13574808,int_stack+13084443,int_stack+12621312,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+13014216,int_stack+13574808,int_stack+4855416,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+13574808,int_stack+13014216,int_stack+5016066,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4855416,int_stack+13574808,int_stack+13324194,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+13014216,int_stack+4855416,int_stack+12731472,153);
 /*--- compute (up|nk) ---*/
 hrr1_build_up(Libint->AB,int_stack+13377744,int_stack+13014216,int_stack+897000,2376);
 /*--- compute (td|nk) ---*/
 hrr1_build_td(Libint->AB,int_stack+14347152,int_stack+13377744,int_stack+1220136,2376);
 /*--- compute (rf|nk) ---*/
 hrr1_build_rf(Libint->AB,int_stack+19356276,int_stack+14347152,int_stack+5240808,2376);
 /*--- compute (qg|nk) ---*/
 hrr1_build_qg(Libint->AB,int_stack+21851076,int_stack+19356276,int_stack+6737688,2376);
 /*--- compute (oh|nk) ---*/
 hrr1_build_oh(Libint->AB,int_stack+4855416,int_stack+21851076,int_stack+2075496,2376);
 /*--- compute (ni|nk) ---*/
 hrr1_build_ni(Libint->AB,int_stack+25094316,int_stack+4855416,int_stack+16063140,2376);
 /*--- compute (mk|nk) ---*/
 hrr1_build_mk(Libint->AB,int_stack+29485164,int_stack+25094316,int_stack+8899848,2376);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+897000,int_stack+750966,int_stack+739680,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+930858,int_stack+764304,int_stack+750966,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+970872,int_stack+930858,int_stack+897000,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1038588,int_stack+779865,int_stack+764304,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1085271,int_stack+1038588,int_stack+930858,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1165299,int_stack+1085271,int_stack+970872,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+897000,int_stack+797820,int_stack+779865,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1278159,int_stack+897000,int_stack+1038588,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+950865,int_stack+1278159,int_stack+1085271,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1371525,int_stack+950865,int_stack+1165299,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1084245,int_stack+818340,int_stack+797820,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1145805,int_stack+1084245,int_stack+897000,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1540815,int_stack+1145805,int_stack+1278159,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1696425,int_stack+1540815,int_stack+950865,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1896495,int_stack+1696425,int_stack+1371525,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+897000,int_stack+841596,int_stack+818340,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1253535,int_stack+897000,int_stack+1084245,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2133501,int_stack+1253535,int_stack+1145805,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+966768,int_stack+2133501,int_stack+1540815,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1376655,int_stack+966768,int_stack+1696425,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2313051,int_stack+1376655,int_stack+1896495,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1656753,int_stack+867759,int_stack+841596,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1735242,int_stack+1656753,int_stack+897000,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1874778,int_stack+1735242,int_stack+1253535,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2629059,int_stack+1874778,int_stack+2133501,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1656753,int_stack+2629059,int_stack+966768,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2629059,int_stack+1656753,int_stack+1376655,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3002523,int_stack+2629059,int_stack+2313051,171);
 /*--- compute (vp|nk) ---*/
 hrr1_build_vp(Libint->AB,int_stack+3408819,int_stack+3002523,int_stack+13014216,2376);
 /*--- compute (ud|nk) ---*/
 hrr1_build_ud(Libint->AB,int_stack+8747304,int_stack+3408819,int_stack+13377744,2376);
 /*--- compute (tf|nk) ---*/
 hrr1_build_tf(Libint->AB,int_stack+10686120,int_stack+8747304,int_stack+14347152,2376);
 /*--- compute (rg|nk) ---*/
 hrr1_build_rg(Libint->AB,int_stack+13537320,int_stack+10686120,int_stack+19356276,2376);
 /*--- compute (qh|nk) ---*/
 hrr1_build_qh(Libint->AB,int_stack+8747304,int_stack+13537320,int_stack+21851076,2376);
 /*--- compute (oi|nk) ---*/
 hrr1_build_oi(Libint->AB,int_stack+13287840,int_stack+8747304,int_stack+4855416,2376);
 /*--- compute (nk|nk) ---*/
 hrr1_build_nk(Libint->AB,int_stack+18477024,int_stack+13287840,int_stack+25094316,2376);
 /*--- compute (ml|nk) ---*/
 hrr1_build_ml(Libint->AB,int_stack+0,int_stack+18477024,int_stack+29485164,2376);
 return int_stack+0;}
