/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mpkg(Libint_t*, prim_data*);

  /* Computes quartets of (mp|kg) integrals */

REALTYPE *hrr_order_mpkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][7] = int_stack + 0;
 Libint->vrr_classes[9][8] = int_stack + 1980;
 Libint->vrr_classes[9][9] = int_stack + 4455;
 Libint->vrr_classes[9][10] = int_stack + 7480;
 Libint->vrr_classes[9][11] = int_stack + 11110;
 Libint->vrr_classes[10][7] = int_stack + 15400;
 Libint->vrr_classes[10][8] = int_stack + 17776;
 Libint->vrr_classes[10][9] = int_stack + 20746;
 Libint->vrr_classes[10][10] = int_stack + 24376;
 Libint->vrr_classes[10][11] = int_stack + 28732;
 memset(int_stack,0,33880*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33880;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mpkg(Libint, Data);
   Data++;
 }
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+33880,int_stack+1980,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+39820,int_stack+4455,int_stack+1980,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+47245,int_stack+39820,int_stack+33880,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+59125,int_stack+7480,int_stack+4455,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+68200,int_stack+59125,int_stack+39820,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+83050,int_stack+68200,int_stack+47245,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33880,int_stack+11110,int_stack+7480,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+102850,int_stack+33880,int_stack+59125,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+33880,int_stack+102850,int_stack+68200,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+102850,int_stack+33880,int_stack+83050,55);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+33880,int_stack+17776,int_stack+15400,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41008,int_stack+20746,int_stack+17776,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+49918,int_stack+41008,int_stack+33880,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+64174,int_stack+24376,int_stack+20746,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+75064,int_stack+64174,int_stack+41008,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+75064,int_stack+49918,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33880,int_stack+28732,int_stack+24376,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+132550,int_stack+33880,int_stack+64174,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+23760,int_stack+132550,int_stack+75064,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+53460,int_stack+23760,int_stack+0,66);
 /*--- compute (mp|kg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+132550,int_stack+53460,int_stack+102850,540);
 return int_stack+132550;}
