/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mplf(Libint_t*, prim_data*);

  /* Computes quartets of (mp|lf) integrals */

REALTYPE *hrr_order_mplf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[10][8] = int_stack + 13420;
 Libint->vrr_classes[10][9] = int_stack + 16390;
 Libint->vrr_classes[10][10] = int_stack + 20020;
 Libint->vrr_classes[10][11] = int_stack + 24376;
 memset(int_stack,0,29524*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 29524;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mplf(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29524,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36949,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+46024,int_stack+36949,int_stack+29524,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60874,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+71764,int_stack+60874,int_stack+36949,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+89914,int_stack+71764,int_stack+46024,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29524,int_stack+16390,int_stack+13420,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+38434,int_stack+20020,int_stack+16390,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+49324,int_stack+38434,int_stack+29524,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+67144,int_stack+24376,int_stack+20020,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+67144,int_stack+38434,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+114664,int_stack+0,int_stack+49324,66);
 /*--- compute (mp|lf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+114664,int_stack+89914,450);
 return int_stack+0;}
