/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_n0hh(Libint_t*, prim_data*);

  /* Computes quartets of (n0|hh) integrals */

REALTYPE *hrr_order_n0hh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][5] = int_stack + 0;
 Libint->vrr_classes[10][6] = int_stack + 1386;
 Libint->vrr_classes[10][7] = int_stack + 3234;
 Libint->vrr_classes[10][8] = int_stack + 5610;
 Libint->vrr_classes[10][9] = int_stack + 8580;
 Libint->vrr_classes[10][10] = int_stack + 12210;
 memset(int_stack,0,16566*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 16566;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_n0hh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+16566,int_stack+1386,int_stack+0,66);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+20724,int_stack+3234,int_stack+1386,66);
 /*--- compute (n0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+26268,int_stack+20724,int_stack+16566,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+34584,int_stack+5610,int_stack+3234,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+41712,int_stack+34584,int_stack+20724,66);
 /*--- compute (n0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+52800,int_stack+41712,int_stack+26268,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16566,int_stack+8580,int_stack+5610,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+66660,int_stack+16566,int_stack+34584,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+80916,int_stack+66660,int_stack+41712,66);
 /*--- compute (n0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+25476,int_stack+80916,int_stack+52800,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+46266,int_stack+12210,int_stack+8580,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+99396,int_stack+46266,int_stack+16566,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+99396,int_stack+66660,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+46266,int_stack+0,int_stack+80916,66);
 /*--- compute (n0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+73986,int_stack+46266,int_stack+25476,66);
 return int_stack+73986;}
