/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nfmg(Libint_t*, prim_data*);

  /* Computes quartets of (nf|mg) integrals */

REALTYPE *hrr_order_nfmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[11][9] = int_stack + 26070;
 Libint->vrr_classes[11][10] = int_stack + 30360;
 Libint->vrr_classes[11][11] = int_stack + 35508;
 Libint->vrr_classes[11][12] = int_stack + 41592;
 Libint->vrr_classes[11][13] = int_stack + 48690;
 Libint->vrr_classes[12][9] = int_stack + 56880;
 Libint->vrr_classes[12][10] = int_stack + 61885;
 Libint->vrr_classes[12][11] = int_stack + 67891;
 Libint->vrr_classes[12][12] = int_stack + 74989;
 Libint->vrr_classes[12][13] = int_stack + 83270;
 Libint->vrr_classes[13][9] = int_stack + 92825;
 Libint->vrr_classes[13][10] = int_stack + 98600;
 Libint->vrr_classes[13][11] = int_stack + 105530;
 Libint->vrr_classes[13][12] = int_stack + 113720;
 Libint->vrr_classes[13][13] = int_stack + 123275;
 memset(int_stack,0,134300*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 134300;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nfmg(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+134300,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+145190,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+158258,int_stack+145190,int_stack+134300,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+180038,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+195482,int_stack+180038,int_stack+145190,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+221618,int_stack+195482,int_stack+158258,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+134300,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+257918,int_stack+134300,int_stack+180038,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+134300,int_stack+257918,int_stack+195482,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+257918,int_stack+134300,int_stack+221618,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+134300,int_stack+30360,int_stack+26070,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+147170,int_stack+35508,int_stack+30360,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+162614,int_stack+147170,int_stack+134300,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+188354,int_stack+41592,int_stack+35508,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+206606,int_stack+188354,int_stack+147170,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+312368,int_stack+206606,int_stack+162614,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+134300,int_stack+48690,int_stack+41592,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+134300,int_stack+188354,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+134300,int_stack+0,int_stack+206606,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+185780,int_stack+134300,int_stack+312368,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+312368,int_stack+185780,int_stack+257918,825);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+134300,int_stack+61885,int_stack+56880,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149315,int_stack+67891,int_stack+61885,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+149315,int_stack+134300,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30030,int_stack+74989,int_stack+67891,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+250130,int_stack+30030,int_stack+149315,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+134300,int_stack+250130,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+83270,int_stack+74989,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+475718,int_stack+0,int_stack+30030,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+475718,int_stack+250130,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+475718,int_stack+0,int_stack+134300,91);
 /*--- compute (op|mg) ---*/
 hrr1_build_op(Libint->AB,int_stack+550793,int_stack+475718,int_stack+185780,825);
 /*--- compute (nd|mg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+743843,int_stack+550793,int_stack+312368,825);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+134300,int_stack+98600,int_stack+92825,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+151625,int_stack+105530,int_stack+98600,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+172415,int_stack+151625,int_stack+134300,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207065,int_stack+113720,int_stack+105530,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+231635,int_stack+207065,int_stack+151625,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+273215,int_stack+231635,int_stack+172415,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+134300,int_stack+123275,int_stack+113720,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+330965,int_stack+134300,int_stack+207065,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+380105,int_stack+330965,int_stack+231635,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+380105,int_stack+273215,105);
 /*--- compute (qp|mg) ---*/
 hrr1_build_qp(Libint->AB,int_stack+86625,int_stack+0,int_stack+475718,825);
 /*--- compute (od|mg) ---*/
 hrr1_build_od(Libint->AB,int_stack+1070543,int_stack+86625,int_stack+550793,825);
 /*--- compute (nf|mg) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+1070543,int_stack+743843,825);
 return int_stack+0;}
