/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ngmh(Libint_t*, prim_data*);

  /* Computes quartets of (ng|mh) integrals */

REALTYPE *hrr_order_ngmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[11][9] = int_stack + 33990;
 Libint->vrr_classes[11][10] = int_stack + 38280;
 Libint->vrr_classes[11][11] = int_stack + 43428;
 Libint->vrr_classes[11][12] = int_stack + 49512;
 Libint->vrr_classes[11][13] = int_stack + 56610;
 Libint->vrr_classes[11][14] = int_stack + 64800;
 Libint->vrr_classes[12][9] = int_stack + 74160;
 Libint->vrr_classes[12][10] = int_stack + 79165;
 Libint->vrr_classes[12][11] = int_stack + 85171;
 Libint->vrr_classes[12][12] = int_stack + 92269;
 Libint->vrr_classes[12][13] = int_stack + 100550;
 Libint->vrr_classes[12][14] = int_stack + 110105;
 Libint->vrr_classes[13][9] = int_stack + 121025;
 Libint->vrr_classes[13][10] = int_stack + 126800;
 Libint->vrr_classes[13][11] = int_stack + 133730;
 Libint->vrr_classes[13][12] = int_stack + 141920;
 Libint->vrr_classes[13][13] = int_stack + 151475;
 Libint->vrr_classes[13][14] = int_stack + 162500;
 Libint->vrr_classes[14][9] = int_stack + 175100;
 Libint->vrr_classes[14][10] = int_stack + 181700;
 Libint->vrr_classes[14][11] = int_stack + 189620;
 Libint->vrr_classes[14][12] = int_stack + 198980;
 Libint->vrr_classes[14][13] = int_stack + 209900;
 Libint->vrr_classes[14][14] = int_stack + 222500;
 memset(int_stack,0,236900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 236900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ngmh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+236900,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+247790,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+260858,int_stack+247790,int_stack+236900,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+282638,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+298082,int_stack+282638,int_stack+247790,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+324218,int_stack+298082,int_stack+260858,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+236900,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+360518,int_stack+236900,int_stack+282638,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+391406,int_stack+360518,int_stack+298082,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+254918,int_stack+391406,int_stack+324218,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+309368,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+434966,int_stack+309368,int_stack+236900,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+471002,int_stack+434966,int_stack+360518,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+309368,int_stack+471002,int_stack+391406,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+374708,int_stack+309368,int_stack+254918,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+236900,int_stack+38280,int_stack+33990,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+249770,int_stack+43428,int_stack+38280,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+265214,int_stack+249770,int_stack+236900,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+290954,int_stack+49512,int_stack+43428,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+309206,int_stack+290954,int_stack+249770,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+450938,int_stack+309206,int_stack+265214,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+236900,int_stack+56610,int_stack+49512,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+236900,int_stack+290954,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+493838,int_stack+0,int_stack+309206,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+258194,int_stack+493838,int_stack+450938,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+450938,int_stack+64800,int_stack+56610,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+322544,int_stack+450938,int_stack+236900,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+545318,int_stack+322544,int_stack+0,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+606158,int_stack+545318,int_stack+493838,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+450938,int_stack+606158,int_stack+258194,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+541028,int_stack+450938,int_stack+374708,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+79165,int_stack+74160,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+85171,int_stack+79165,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+92269,int_stack+85171,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+236900,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+272936,int_stack+236900,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+100550,int_stack+92269,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+322986,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+24843,int_stack+322986,int_stack+236900,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+365574,int_stack+24843,int_stack+272936,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236900,int_stack+110105,int_stack+100550,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+265565,int_stack+236900,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+769718,int_stack+265565,int_stack+322986,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+236900,int_stack+769718,int_stack+24843,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+236900,int_stack+365574,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+769718,int_stack+0,int_stack+450938,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1039988,int_stack+769718,int_stack+541028,1155);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+236900,int_stack+126800,int_stack+121025,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+254225,int_stack+133730,int_stack+126800,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+275015,int_stack+254225,int_stack+236900,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+309665,int_stack+141920,int_stack+133730,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+334235,int_stack+309665,int_stack+254225,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+375815,int_stack+334235,int_stack+275015,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+236900,int_stack+151475,int_stack+141920,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+433565,int_stack+236900,int_stack+309665,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+482705,int_stack+433565,int_stack+334235,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+265565,int_stack+482705,int_stack+375815,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+352190,int_stack+162500,int_stack+151475,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+552005,int_stack+352190,int_stack+236900,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+609335,int_stack+552005,int_stack+433565,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+352190,int_stack+609335,int_stack+482705,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+456140,int_stack+352190,int_stack+265565,105);
 /*--- compute (qp|mh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1497368,int_stack+456140,int_stack+0,1155);
 /*--- compute (od|mh) ---*/
 hrr1_build_od(Libint->AB,int_stack+1812683,int_stack+1497368,int_stack+769718,1155);
 /*--- compute (nf|mh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+2353223,int_stack+1812683,int_stack+1039988,1155);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+181700,int_stack+175100,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+189620,int_stack+181700,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+198980,int_stack+189620,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+236900,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+209900,int_stack+198980,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+302900,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+359060,int_stack+302900,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+359060,int_stack+236900,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236900,int_stack+222500,int_stack+209900,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+131760,int_stack+236900,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+197280,int_stack+131760,int_stack+302900,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+577415,int_stack+197280,int_stack+359060,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+131760,int_stack+577415,int_stack+32760,120);
 /*--- compute (rp|mh) ---*/
 hrr1_build_rp(Libint->AB,int_stack+577415,int_stack+131760,int_stack+456140,1155);
 /*--- compute (qd|mh) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3115523,int_stack+577415,int_stack+1497368,1155);
 /*--- compute (of|mh) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+3115523,int_stack+1812683,1155);
 /*--- compute (ng|mh) ---*/
 hrr1_build_ng(Libint->AB,int_stack+900900,int_stack+0,int_stack+2353223,1155);
 return int_stack+900900;}
