/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npii(Libint_t*, prim_data*);

  /* Computes quartets of (np|ii) integrals */

REALTYPE *hrr_order_npii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][6] = int_stack + 0;
 Libint->vrr_classes[10][7] = int_stack + 1848;
 Libint->vrr_classes[10][8] = int_stack + 4224;
 Libint->vrr_classes[10][9] = int_stack + 7194;
 Libint->vrr_classes[10][10] = int_stack + 10824;
 Libint->vrr_classes[10][11] = int_stack + 15180;
 Libint->vrr_classes[10][12] = int_stack + 20328;
 Libint->vrr_classes[11][6] = int_stack + 26334;
 Libint->vrr_classes[11][7] = int_stack + 28518;
 Libint->vrr_classes[11][8] = int_stack + 31326;
 Libint->vrr_classes[11][9] = int_stack + 34836;
 Libint->vrr_classes[11][10] = int_stack + 39126;
 Libint->vrr_classes[11][11] = int_stack + 44274;
 Libint->vrr_classes[11][12] = int_stack + 50358;
 memset(int_stack,0,57456*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 57456;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npii(Libint, Data);
   Data++;
 }
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+57456,int_stack+1848,int_stack+0,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+63000,int_stack+4224,int_stack+1848,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+70128,int_stack+63000,int_stack+57456,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81216,int_stack+7194,int_stack+4224,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+90126,int_stack+81216,int_stack+63000,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+104382,int_stack+90126,int_stack+70128,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57456,int_stack+10824,int_stack+7194,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+122862,int_stack+57456,int_stack+81216,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+140682,int_stack+122862,int_stack+90126,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+68346,int_stack+140682,int_stack+104382,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+96066,int_stack+15180,int_stack+10824,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+164442,int_stack+96066,int_stack+57456,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+186222,int_stack+164442,int_stack+122862,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+215922,int_stack+186222,int_stack+140682,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+109134,int_stack+215922,int_stack+68346,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57456,int_stack+20328,int_stack+15180,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+57456,int_stack+96066,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+57456,int_stack+0,int_stack+164442,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+251562,int_stack+57456,int_stack+186222,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+57456,int_stack+251562,int_stack+215922,66);
 /*--- compute (n0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+147942,int_stack+57456,int_stack+109134,66);
 /*--- compute (o0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+57456,int_stack+28518,int_stack+26334,78);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+64008,int_stack+31326,int_stack+28518,78);
 /*--- compute (o0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+72432,int_stack+64008,int_stack+57456,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+85536,int_stack+34836,int_stack+31326,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+96066,int_stack+85536,int_stack+64008,78);
 /*--- compute (o0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+112914,int_stack+96066,int_stack+72432,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57456,int_stack+39126,int_stack+34836,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+57456,int_stack+85536,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+199686,int_stack+0,int_stack+96066,78);
 /*--- compute (o0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+70326,int_stack+199686,int_stack+112914,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+103086,int_stack+44274,int_stack+39126,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+118530,int_stack+103086,int_stack+57456,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+227766,int_stack+118530,int_stack+0,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+227766,int_stack+199686,78);
 /*--- compute (o0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+262866,int_stack+0,int_stack+70326,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+199686,int_stack+50358,int_stack+44274,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+42120,int_stack+199686,int_stack+103086,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+73008,int_stack+42120,int_stack+118530,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+308730,int_stack+73008,int_stack+227766,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+42120,int_stack+308730,int_stack+0,78);
 /*--- compute (o0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+199686,int_stack+42120,int_stack+262866,78);
 /*--- compute (np|ii) ---*/
 hrr1_build_np(Libint->AB,int_stack+260838,int_stack+199686,int_stack+147942,784);
 return int_stack+260838;}
