/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (f0|hg) integrals */

void vrr_order_f0hg(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+3, Data->F+4, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+12, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+15, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+6, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+21, NULL, NULL, vrr_stack+6);
 _BUILD_00g0(Data,vrr_stack+80, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+3, vrr_stack+31, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+101, vrr_stack+95, vrr_stack+34, vrr_stack+3, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+101, vrr_stack+40, vrr_stack+95, vrr_stack+34, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+12, vrr_stack+31, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+126, vrr_stack+15, vrr_stack+34, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+136, vrr_stack+21, vrr_stack+126, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+151, vrr_stack+80, vrr_stack+136, NULL, NULL, vrr_stack+21);
 _BUILD_p0g0(Data,vrr_stack+196, vrr_stack+111, vrr_stack+80, NULL, NULL, vrr_stack+40);
 _BUILD_d0g0(Data,vrr_stack+241, vrr_stack+196, vrr_stack+151, vrr_stack+111, vrr_stack+80, vrr_stack+50);
 _BUILD_00h0(Data,vrr_stack+50, vrr_stack+80, vrr_stack+136, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+331, vrr_stack+111, vrr_stack+80, vrr_stack+101, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+352, vrr_stack+331, vrr_stack+50, NULL, NULL, vrr_stack+80);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+3, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+6, vrr_stack+95, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+415, vrr_stack+40, vrr_stack+101, vrr_stack+6, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+430, vrr_stack+415, vrr_stack+111, vrr_stack+40, vrr_stack+101, NULL);
 _BUILD_p0h0(Data,vrr_stack+451, vrr_stack+430, vrr_stack+331, NULL, NULL, vrr_stack+111);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+31, vrr_stack+40, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+95, vrr_stack+34, vrr_stack+43, vrr_stack+12, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+126, vrr_stack+95, vrr_stack+15, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+514, vrr_stack+136, vrr_stack+0, vrr_stack+21, vrr_stack+126, NULL);
 _BUILD_p0h0(Data,vrr_stack+535, vrr_stack+50, vrr_stack+514, NULL, NULL, vrr_stack+136);
 _BUILD_d0h0(Data,vrr_stack+598, vrr_stack+352, vrr_stack+535, vrr_stack+331, vrr_stack+50, vrr_stack+151);
 _BUILD_d0h0(Data,vrr_stack+724, vrr_stack+451, vrr_stack+352, vrr_stack+430, vrr_stack+331, vrr_stack+196);
 _BUILD_00i0(Data,vrr_stack+151, vrr_stack+50, vrr_stack+514, vrr_stack+80, vrr_stack+136, NULL);
 _BUILD_00i0(Data,vrr_stack+179, vrr_stack+331, vrr_stack+50, vrr_stack+111, vrr_stack+80, NULL);
 _BUILD_p0i0(Data,vrr_stack+850, vrr_stack+179, vrr_stack+151, NULL, NULL, vrr_stack+50);
 _BUILD_00i0(Data,vrr_stack+207, vrr_stack+430, vrr_stack+331, vrr_stack+415, vrr_stack+111, NULL);
 _BUILD_p0i0(Data,vrr_stack+934, vrr_stack+207, vrr_stack+179, NULL, NULL, vrr_stack+331);
 _BUILD_00p0(Data,vrr_stack+415, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+235, vrr_stack+40, vrr_stack+415, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+418, vrr_stack+43, vrr_stack+235, vrr_stack+31, vrr_stack+40, NULL);
 _BUILD_00g0(Data,vrr_stack+15, vrr_stack+95, vrr_stack+418, vrr_stack+34, vrr_stack+43, NULL);
 _BUILD_00h0(Data,vrr_stack+105, vrr_stack+0, vrr_stack+15, vrr_stack+126, vrr_stack+95, NULL);
 _BUILD_00i0(Data,vrr_stack+1018, vrr_stack+514, vrr_stack+105, vrr_stack+136, vrr_stack+0, NULL);
 _BUILD_p0i0(Data,vrr_stack+1046, vrr_stack+151, vrr_stack+1018, NULL, NULL, vrr_stack+514);
 _BUILD_d0i0(Data,vrr_stack+1130, vrr_stack+850, vrr_stack+1046, vrr_stack+179, vrr_stack+151, vrr_stack+535);
 _BUILD_d0i0(Data,vrr_stack+1298, vrr_stack+934, vrr_stack+850, vrr_stack+207, vrr_stack+179, vrr_stack+352);
 _BUILD_00k0(Data,vrr_stack+535, vrr_stack+151, vrr_stack+1018, vrr_stack+50, vrr_stack+514, NULL);
 _BUILD_00k0(Data,vrr_stack+1466, vrr_stack+179, vrr_stack+151, vrr_stack+331, vrr_stack+50, NULL);
 _BUILD_p0k0(Data,vrr_stack+1502, vrr_stack+1466, vrr_stack+535, NULL, NULL, vrr_stack+151);
 _BUILD_00k0(Data,vrr_stack+49, vrr_stack+207, vrr_stack+179, vrr_stack+430, vrr_stack+331, NULL);
 _BUILD_p0k0(Data,vrr_stack+1610, vrr_stack+49, vrr_stack+1466, NULL, NULL, vrr_stack+179);
 _BUILD_00p0(Data,vrr_stack+331, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+334, vrr_stack+415, vrr_stack+331, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+235, vrr_stack+334, vrr_stack+40, vrr_stack+415, NULL);
 _BUILD_00g0(Data,vrr_stack+571, vrr_stack+418, vrr_stack+30, vrr_stack+43, vrr_stack+235, NULL);
 _BUILD_00h0(Data,vrr_stack+126, vrr_stack+15, vrr_stack+571, vrr_stack+95, vrr_stack+418, NULL);
 _BUILD_00i0(Data,vrr_stack+1718, vrr_stack+105, vrr_stack+126, vrr_stack+0, vrr_stack+15, NULL);
 _BUILD_00k0(Data,vrr_stack+1746, vrr_stack+1018, vrr_stack+1718, vrr_stack+514, vrr_stack+105, NULL);
 _BUILD_p0k0(Data,vrr_stack+1782, vrr_stack+535, vrr_stack+1746, NULL, NULL, vrr_stack+1018);
 _BUILD_d0k0(Data,vrr_stack+1890, vrr_stack+1502, vrr_stack+1782, vrr_stack+1466, vrr_stack+535, vrr_stack+1046);
 _BUILD_d0k0(Data,vrr_stack+2106, vrr_stack+1610, vrr_stack+1502, vrr_stack+49, vrr_stack+1466, vrr_stack+850);
 _BUILD_00l0(Data,vrr_stack+1046, vrr_stack+535, vrr_stack+1746, vrr_stack+151, vrr_stack+1018, NULL);
 _BUILD_00l0(Data,vrr_stack+2322, vrr_stack+1466, vrr_stack+535, vrr_stack+179, vrr_stack+151, NULL);
 _BUILD_p0l0(Data,vrr_stack+2367, vrr_stack+2322, vrr_stack+1046, NULL, NULL, vrr_stack+535);
 _BUILD_00l0(Data,vrr_stack+2502, vrr_stack+49, vrr_stack+1466, vrr_stack+207, vrr_stack+179, NULL);
 _BUILD_p0l0(Data,vrr_stack+2547, vrr_stack+2502, vrr_stack+2322, NULL, NULL, vrr_stack+1466);
 _BUILD_00p0(Data,vrr_stack+1091, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1094, vrr_stack+331, vrr_stack+1091, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+1100, vrr_stack+334, vrr_stack+1094, vrr_stack+415, vrr_stack+331, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+30, vrr_stack+1100, vrr_stack+235, vrr_stack+334, NULL);
 _BUILD_00h0(Data,vrr_stack+514, vrr_stack+571, vrr_stack+0, vrr_stack+418, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+415, vrr_stack+126, vrr_stack+514, vrr_stack+15, vrr_stack+571, NULL);
 _BUILD_00k0(Data,vrr_stack+147, vrr_stack+1718, vrr_stack+415, vrr_stack+105, vrr_stack+126, NULL);
 _BUILD_00l0(Data,vrr_stack+183, vrr_stack+1746, vrr_stack+147, vrr_stack+1018, vrr_stack+1718, NULL);
 _BUILD_p0l0(Data,vrr_stack+2682, vrr_stack+1046, vrr_stack+183, NULL, NULL, vrr_stack+1746);
 _BUILD_d0l0(Data,vrr_stack+2817, vrr_stack+2367, vrr_stack+2682, vrr_stack+2322, vrr_stack+1046, vrr_stack+1782);
 _BUILD_d0l0(Data,vrr_stack+3087, vrr_stack+2547, vrr_stack+2367, vrr_stack+2502, vrr_stack+2322, vrr_stack+1502);
 _BUILD_00m0(Data,vrr_stack+1782, vrr_stack+1046, vrr_stack+183, vrr_stack+535, vrr_stack+1746, NULL);
 _BUILD_00m0(Data,vrr_stack+3357, vrr_stack+2322, vrr_stack+1046, vrr_stack+1466, vrr_stack+535, NULL);
 _BUILD_p0m0(Data,vrr_stack+3412, vrr_stack+3357, vrr_stack+1782, NULL, NULL, vrr_stack+1046);
 _BUILD_00m0(Data,vrr_stack+1018, vrr_stack+2502, vrr_stack+2322, vrr_stack+49, vrr_stack+1466, NULL);
 _BUILD_p0m0(Data,vrr_stack+3577, vrr_stack+1018, vrr_stack+3357, NULL, NULL, vrr_stack+2322);
 _BUILD_00p0(Data,vrr_stack+2322, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2325, vrr_stack+1091, vrr_stack+2322, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+2331, vrr_stack+1094, vrr_stack+2325, vrr_stack+331, vrr_stack+1091, NULL);
 _BUILD_00g0(Data,vrr_stack+15, vrr_stack+1100, vrr_stack+2331, vrr_stack+334, vrr_stack+1094, NULL);
 _BUILD_00h0(Data,vrr_stack+331, vrr_stack+0, vrr_stack+15, vrr_stack+30, vrr_stack+1100, NULL);
 _BUILD_00i0(Data,vrr_stack+15, vrr_stack+514, vrr_stack+331, vrr_stack+571, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+1466, vrr_stack+415, vrr_stack+15, vrr_stack+126, vrr_stack+514, NULL);
 _BUILD_00l0(Data,vrr_stack+2322, vrr_stack+147, vrr_stack+1466, vrr_stack+1718, vrr_stack+415, NULL);
 _BUILD_00m0(Data,vrr_stack+514, vrr_stack+183, vrr_stack+2322, vrr_stack+1746, vrr_stack+147, NULL);
 _BUILD_p0m0(Data,vrr_stack+0, vrr_stack+1782, vrr_stack+514, NULL, NULL, vrr_stack+183);
 _BUILD_d0m0(Data,vrr_stack+3742, vrr_stack+3412, vrr_stack+0, vrr_stack+3357, vrr_stack+1782, vrr_stack+2682);
 _BUILD_d0m0(Data,vrr_stack+4072, vrr_stack+3577, vrr_stack+3412, vrr_stack+1018, vrr_stack+3357, vrr_stack+2367);
 _BUILD_f0h0(Data,vrr_stack+0, vrr_stack+724, vrr_stack+598, vrr_stack+451, vrr_stack+352, vrr_stack+241);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[3][5];
   for(i=0;i<210;i++)
     target_ptr[i] += tmp[i];
 _BUILD_f0i0(Data,vrr_stack+210, vrr_stack+1298, vrr_stack+1130, vrr_stack+934, vrr_stack+850, vrr_stack+598);
   tmp = vrr_stack + 210;
   target_ptr = Libint->vrr_classes[3][6];
   for(i=0;i<280;i++)
     target_ptr[i] += tmp[i];
 _BUILD_f0k0(Data,vrr_stack+490, vrr_stack+2106, vrr_stack+1890, vrr_stack+1610, vrr_stack+1502, vrr_stack+1130);
   tmp = vrr_stack + 490;
   target_ptr = Libint->vrr_classes[3][7];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_f0l0(Data,vrr_stack+850, vrr_stack+3087, vrr_stack+2817, vrr_stack+2547, vrr_stack+2367, vrr_stack+1890);
   tmp = vrr_stack + 850;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];
 _BUILD_f0m0(Data,vrr_stack+1300, vrr_stack+4072, vrr_stack+3742, vrr_stack+3577, vrr_stack+3412, vrr_stack+2817);
   tmp = vrr_stack + 1300;
   target_ptr = Libint->vrr_classes[3][9];
   for(i=0;i<550;i++)
     target_ptr[i] += tmp[i];

}

