/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (hp|mf) integrals */

void vrr_order_hpmf(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+7, Data->F+8, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+6, vrr_stack+31, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+9, vrr_stack+34, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+21, vrr_stack+40, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+0, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+65, vrr_stack+15, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+71, vrr_stack+21, vrr_stack+65, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+50, NULL, NULL, vrr_stack+21);
 _BUILD_00h0(Data,vrr_stack+141, vrr_stack+81, vrr_stack+50, vrr_stack+71, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+162, vrr_stack+15, vrr_stack+65, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+172, vrr_stack+162, vrr_stack+71, vrr_stack+15, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+187, vrr_stack+172, vrr_stack+81, vrr_stack+162, vrr_stack+71, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+31, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+34, vrr_stack+65, vrr_stack+6, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+208, vrr_stack+40, vrr_stack+71, vrr_stack+9, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+223, vrr_stack+50, vrr_stack+208, vrr_stack+21, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+244, vrr_stack+141, vrr_stack+223, NULL, NULL, vrr_stack+50);
 _BUILD_p0h0(Data,vrr_stack+307, vrr_stack+187, vrr_stack+141, NULL, NULL, vrr_stack+81);
 _BUILD_d0h0(Data,vrr_stack+370, vrr_stack+307, vrr_stack+244, vrr_stack+187, vrr_stack+141, vrr_stack+96);
 _BUILD_00i0(Data,vrr_stack+96, vrr_stack+141, vrr_stack+223, vrr_stack+81, vrr_stack+50, NULL);
 _BUILD_00i0(Data,vrr_stack+496, vrr_stack+187, vrr_stack+141, vrr_stack+172, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+524, vrr_stack+496, vrr_stack+96, NULL, NULL, vrr_stack+141);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+84, vrr_stack+15, vrr_stack+81, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+124, vrr_stack+21, vrr_stack+162, vrr_stack+84, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+608, vrr_stack+124, vrr_stack+172, vrr_stack+21, vrr_stack+162, NULL);
 _BUILD_00i0(Data,vrr_stack+629, vrr_stack+608, vrr_stack+187, vrr_stack+124, vrr_stack+172, NULL);
 _BUILD_p0i0(Data,vrr_stack+657, vrr_stack+629, vrr_stack+496, NULL, NULL, vrr_stack+187);
 _BUILD_00p0(Data,vrr_stack+162, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+162, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+165, vrr_stack+65, vrr_stack+90, vrr_stack+31, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+71, vrr_stack+165, vrr_stack+34, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+741, vrr_stack+208, vrr_stack+3, vrr_stack+40, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+762, vrr_stack+223, vrr_stack+741, vrr_stack+50, vrr_stack+208, NULL);
 _BUILD_p0i0(Data,vrr_stack+790, vrr_stack+96, vrr_stack+762, NULL, NULL, vrr_stack+223);
 _BUILD_d0i0(Data,vrr_stack+874, vrr_stack+524, vrr_stack+790, vrr_stack+496, vrr_stack+96, vrr_stack+244);
 _BUILD_d0i0(Data,vrr_stack+1042, vrr_stack+657, vrr_stack+524, vrr_stack+629, vrr_stack+496, vrr_stack+307);
 _BUILD_f0i0(Data,vrr_stack+1210, vrr_stack+1042, vrr_stack+874, vrr_stack+657, vrr_stack+524, vrr_stack+370);
 _BUILD_00k0(Data,vrr_stack+244, vrr_stack+496, vrr_stack+96, vrr_stack+187, vrr_stack+141, NULL);
 _BUILD_00k0(Data,vrr_stack+280, vrr_stack+629, vrr_stack+496, vrr_stack+608, vrr_stack+187, NULL);
 _BUILD_00k0(Data,vrr_stack+316, vrr_stack+96, vrr_stack+762, vrr_stack+141, vrr_stack+223, NULL);
 _BUILD_p0k0(Data,vrr_stack+352, vrr_stack+244, vrr_stack+316, NULL, NULL, vrr_stack+96);
 _BUILD_p0k0(Data,vrr_stack+1490, vrr_stack+280, vrr_stack+244, NULL, NULL, vrr_stack+496);
 _BUILD_d0k0(Data,vrr_stack+1598, vrr_stack+1490, vrr_stack+352, vrr_stack+280, vrr_stack+244, vrr_stack+524);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+524, vrr_stack+18, vrr_stack+81, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+530, vrr_stack+524, vrr_stack+84, vrr_stack+18, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+540, vrr_stack+530, vrr_stack+21, vrr_stack+524, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+555, vrr_stack+540, vrr_stack+124, vrr_stack+530, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+21, vrr_stack+555, vrr_stack+608, vrr_stack+540, vrr_stack+124, NULL);
 _BUILD_00k0(Data,vrr_stack+460, vrr_stack+21, vrr_stack+629, vrr_stack+555, vrr_stack+608, NULL);
 _BUILD_p0k0(Data,vrr_stack+1814, vrr_stack+460, vrr_stack+280, NULL, NULL, vrr_stack+629);
 _BUILD_d0k0(Data,vrr_stack+1922, vrr_stack+1814, vrr_stack+1490, vrr_stack+460, vrr_stack+280, vrr_stack+657);
 _BUILD_00p0(Data,vrr_stack+657, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+660, vrr_stack+162, vrr_stack+657, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+666, vrr_stack+90, vrr_stack+660, vrr_stack+0, vrr_stack+162, NULL);
 _BUILD_00g0(Data,vrr_stack+676, vrr_stack+165, vrr_stack+666, vrr_stack+65, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+691, vrr_stack+3, vrr_stack+676, vrr_stack+71, vrr_stack+165, NULL);
 _BUILD_00i0(Data,vrr_stack+712, vrr_stack+741, vrr_stack+691, vrr_stack+208, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+124, vrr_stack+762, vrr_stack+712, vrr_stack+223, vrr_stack+741, NULL);
 _BUILD_p0k0(Data,vrr_stack+2138, vrr_stack+316, vrr_stack+124, NULL, NULL, vrr_stack+762);
 _BUILD_d0k0(Data,vrr_stack+2246, vrr_stack+352, vrr_stack+2138, vrr_stack+244, vrr_stack+316, vrr_stack+790);
 _BUILD_f0k0(Data,vrr_stack+2462, vrr_stack+1598, vrr_stack+2246, vrr_stack+1490, vrr_stack+352, vrr_stack+874);
 _BUILD_f0k0(Data,vrr_stack+2822, vrr_stack+1922, vrr_stack+1598, vrr_stack+1814, vrr_stack+1490, vrr_stack+1042);
 _BUILD_g0k0(Data,vrr_stack+3182, vrr_stack+2822, vrr_stack+2462, vrr_stack+1922, vrr_stack+1598, vrr_stack+1210);
 _BUILD_00l0(Data,vrr_stack+790, vrr_stack+244, vrr_stack+316, vrr_stack+496, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+835, vrr_stack+280, vrr_stack+244, vrr_stack+629, vrr_stack+496, NULL);
 _BUILD_p0l0(Data,vrr_stack+880, vrr_stack+835, vrr_stack+790, NULL, NULL, vrr_stack+244);
 _BUILD_00l0(Data,vrr_stack+1015, vrr_stack+460, vrr_stack+280, vrr_stack+21, vrr_stack+629, NULL);
 _BUILD_p0l0(Data,vrr_stack+1060, vrr_stack+1015, vrr_stack+835, NULL, NULL, vrr_stack+280);
 _BUILD_00l0(Data,vrr_stack+1195, vrr_stack+316, vrr_stack+124, vrr_stack+96, vrr_stack+762, NULL);
 _BUILD_p0l0(Data,vrr_stack+1240, vrr_stack+790, vrr_stack+1195, NULL, NULL, vrr_stack+316);
 _BUILD_d0l0(Data,vrr_stack+3722, vrr_stack+880, vrr_stack+1240, vrr_stack+835, vrr_stack+790, vrr_stack+352);
 _BUILD_d0l0(Data,vrr_stack+3992, vrr_stack+1060, vrr_stack+880, vrr_stack+1015, vrr_stack+835, vrr_stack+1490);
 _BUILD_f0l0(Data,vrr_stack+4262, vrr_stack+3992, vrr_stack+3722, vrr_stack+1060, vrr_stack+880, vrr_stack+1598);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+352, vrr_stack+0, vrr_stack+18, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+358, vrr_stack+352, vrr_stack+524, vrr_stack+0, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+368, vrr_stack+358, vrr_stack+530, vrr_stack+352, vrr_stack+524, NULL);
 _BUILD_00h0(Data,vrr_stack+383, vrr_stack+368, vrr_stack+540, vrr_stack+358, vrr_stack+530, NULL);
 _BUILD_00i0(Data,vrr_stack+96, vrr_stack+383, vrr_stack+555, vrr_stack+368, vrr_stack+540, NULL);
 _BUILD_00k0(Data,vrr_stack+404, vrr_stack+96, vrr_stack+21, vrr_stack+383, vrr_stack+555, NULL);
 _BUILD_00l0(Data,vrr_stack+496, vrr_stack+404, vrr_stack+460, vrr_stack+96, vrr_stack+21, NULL);
 _BUILD_p0l0(Data,vrr_stack+1375, vrr_stack+496, vrr_stack+1015, NULL, NULL, vrr_stack+460);
 _BUILD_d0l0(Data,vrr_stack+1510, vrr_stack+1375, vrr_stack+1060, vrr_stack+496, vrr_stack+1015, vrr_stack+1814);
 _BUILD_f0l0(Data,vrr_stack+4712, vrr_stack+1510, vrr_stack+3992, vrr_stack+1375, vrr_stack+1060, vrr_stack+1922);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+657, vrr_stack+18, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+27, vrr_stack+660, vrr_stack+21, vrr_stack+162, vrr_stack+657, NULL);
 _BUILD_00g0(Data,vrr_stack+37, vrr_stack+666, vrr_stack+27, vrr_stack+90, vrr_stack+660, NULL);
 _BUILD_00h0(Data,vrr_stack+52, vrr_stack+676, vrr_stack+37, vrr_stack+165, vrr_stack+666, NULL);
 _BUILD_00i0(Data,vrr_stack+541, vrr_stack+691, vrr_stack+52, vrr_stack+3, vrr_stack+676, NULL);
 _BUILD_00k0(Data,vrr_stack+569, vrr_stack+712, vrr_stack+541, vrr_stack+741, vrr_stack+691, NULL);
 _BUILD_00l0(Data,vrr_stack+605, vrr_stack+124, vrr_stack+569, vrr_stack+762, vrr_stack+712, NULL);
 _BUILD_p0l0(Data,vrr_stack+1780, vrr_stack+1195, vrr_stack+605, NULL, NULL, vrr_stack+124);
 _BUILD_d0l0(Data,vrr_stack+5162, vrr_stack+1240, vrr_stack+1780, vrr_stack+790, vrr_stack+1195, vrr_stack+2138);
 _BUILD_f0l0(Data,vrr_stack+5432, vrr_stack+3722, vrr_stack+5162, vrr_stack+880, vrr_stack+1240, vrr_stack+2246);
 _BUILD_g0l0(Data,vrr_stack+5882, vrr_stack+4262, vrr_stack+5432, vrr_stack+3992, vrr_stack+3722, vrr_stack+2462);
 _BUILD_g0l0(Data,vrr_stack+1915, vrr_stack+4712, vrr_stack+4262, vrr_stack+1510, vrr_stack+3992, vrr_stack+2822);
 _BUILD_h0l0(Data,vrr_stack+6557, vrr_stack+1915, vrr_stack+5882, vrr_stack+4712, vrr_stack+4262, vrr_stack+3182);
 _BUILD_00m0(Data,vrr_stack+2590, vrr_stack+835, vrr_stack+790, vrr_stack+280, vrr_stack+244, NULL);
 _BUILD_00m0(Data,vrr_stack+2645, vrr_stack+1015, vrr_stack+835, vrr_stack+460, vrr_stack+280, NULL);
 _BUILD_00m0(Data,vrr_stack+2700, vrr_stack+790, vrr_stack+1195, vrr_stack+244, vrr_stack+316, NULL);
 _BUILD_p0m0(Data,vrr_stack+2755, vrr_stack+2590, vrr_stack+2700, NULL, NULL, vrr_stack+790);
 _BUILD_p0m0(Data,vrr_stack+2920, vrr_stack+2645, vrr_stack+2590, NULL, NULL, vrr_stack+835);
 _BUILD_d0m0(Data,vrr_stack+3085, vrr_stack+2920, vrr_stack+2755, vrr_stack+2645, vrr_stack+2590, vrr_stack+880);
 _BUILD_00m0(Data,vrr_stack+880, vrr_stack+496, vrr_stack+1015, vrr_stack+404, vrr_stack+460, NULL);
 _BUILD_p0m0(Data,vrr_stack+3415, vrr_stack+880, vrr_stack+2645, NULL, NULL, vrr_stack+1015);
 _BUILD_d0m0(Data,vrr_stack+7502, vrr_stack+3415, vrr_stack+2920, vrr_stack+880, vrr_stack+2645, vrr_stack+1060);
 _BUILD_00m0(Data,vrr_stack+1060, vrr_stack+1195, vrr_stack+605, vrr_stack+316, vrr_stack+124, NULL);
 _BUILD_p0m0(Data,vrr_stack+160, vrr_stack+2700, vrr_stack+1060, NULL, NULL, vrr_stack+1195);
 _BUILD_d0m0(Data,vrr_stack+7832, vrr_stack+2755, vrr_stack+160, vrr_stack+2590, vrr_stack+2700, vrr_stack+1240);
 _BUILD_f0m0(Data,vrr_stack+8162, vrr_stack+3085, vrr_stack+7832, vrr_stack+2920, vrr_stack+2755, vrr_stack+3722);
 _BUILD_f0m0(Data,vrr_stack+8712, vrr_stack+7502, vrr_stack+3085, vrr_stack+3415, vrr_stack+2920, vrr_stack+3992);
 _BUILD_g0m0(Data,vrr_stack+9262, vrr_stack+8712, vrr_stack+8162, vrr_stack+7502, vrr_stack+3085, vrr_stack+4262);
 _BUILD_00p0(Data,vrr_stack+1240, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1243, vrr_stack+1240, vrr_stack+0, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+1249, vrr_stack+1243, vrr_stack+352, vrr_stack+1240, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+1249, vrr_stack+358, vrr_stack+1243, vrr_stack+352, NULL);
 _BUILD_00h0(Data,vrr_stack+1259, vrr_stack+0, vrr_stack+368, vrr_stack+1249, vrr_stack+358, NULL);
 _BUILD_00i0(Data,vrr_stack+1280, vrr_stack+1259, vrr_stack+383, vrr_stack+0, vrr_stack+368, NULL);
 _BUILD_00k0(Data,vrr_stack+1308, vrr_stack+1280, vrr_stack+96, vrr_stack+1259, vrr_stack+383, NULL);
 _BUILD_00l0(Data,vrr_stack+1115, vrr_stack+1308, vrr_stack+404, vrr_stack+1280, vrr_stack+96, NULL);
 _BUILD_00m0(Data,vrr_stack+1240, vrr_stack+1115, vrr_stack+496, vrr_stack+1308, vrr_stack+404, NULL);
 _BUILD_p0m0(Data,vrr_stack+3580, vrr_stack+1240, vrr_stack+880, NULL, NULL, vrr_stack+496);
 _BUILD_d0m0(Data,vrr_stack+3745, vrr_stack+3580, vrr_stack+3415, vrr_stack+1240, vrr_stack+880, vrr_stack+1375);
 _BUILD_f0m0(Data,vrr_stack+4075, vrr_stack+3745, vrr_stack+7502, vrr_stack+3580, vrr_stack+3415, vrr_stack+1510);
 _BUILD_g0m0(Data,vrr_stack+10087, vrr_stack+4075, vrr_stack+8712, vrr_stack+3745, vrr_stack+7502, vrr_stack+4712);
 _BUILD_00p0(Data,vrr_stack+3580, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3583, vrr_stack+18, vrr_stack+3580, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+3589, vrr_stack+21, vrr_stack+3583, vrr_stack+657, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+3599, vrr_stack+27, vrr_stack+3589, vrr_stack+660, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+3614, vrr_stack+37, vrr_stack+3599, vrr_stack+666, vrr_stack+27, NULL);
 _BUILD_00i0(Data,vrr_stack+3635, vrr_stack+52, vrr_stack+3614, vrr_stack+676, vrr_stack+37, NULL);
 _BUILD_00k0(Data,vrr_stack+3663, vrr_stack+541, vrr_stack+3635, vrr_stack+691, vrr_stack+52, NULL);
 _BUILD_00l0(Data,vrr_stack+3699, vrr_stack+569, vrr_stack+3663, vrr_stack+712, vrr_stack+541, NULL);
 _BUILD_00m0(Data,vrr_stack+3744, vrr_stack+605, vrr_stack+3699, vrr_stack+124, vrr_stack+569, NULL);
 _BUILD_p0m0(Data,vrr_stack+3799, vrr_stack+1060, vrr_stack+3744, NULL, NULL, vrr_stack+605);
 _BUILD_d0m0(Data,vrr_stack+1295, vrr_stack+160, vrr_stack+3799, vrr_stack+2700, vrr_stack+1060, vrr_stack+1780);
 _BUILD_f0m0(Data,vrr_stack+10912, vrr_stack+7832, vrr_stack+1295, vrr_stack+2755, vrr_stack+160, vrr_stack+5162);
 _BUILD_g0m0(Data,vrr_stack+11462, vrr_stack+8162, vrr_stack+10912, vrr_stack+3085, vrr_stack+7832, vrr_stack+5432);
 _BUILD_h0m0(Data,vrr_stack+4625, vrr_stack+9262, vrr_stack+11462, vrr_stack+8712, vrr_stack+8162, vrr_stack+5882);
 _BUILD_h0m0(Data,vrr_stack+12287, vrr_stack+10087, vrr_stack+9262, vrr_stack+4075, vrr_stack+8712, vrr_stack+1915);
   tmp = vrr_stack + 12287;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+3964, vrr_stack+2590, vrr_stack+2700, vrr_stack+835, vrr_stack+790, NULL);
 _BUILD_00n0(Data,vrr_stack+4030, vrr_stack+2645, vrr_stack+2590, vrr_stack+1015, vrr_stack+835, NULL);
 _BUILD_00n0(Data,vrr_stack+4096, vrr_stack+2700, vrr_stack+1060, vrr_stack+790, vrr_stack+1195, NULL);
 _BUILD_p0n0(Data,vrr_stack+4162, vrr_stack+3964, vrr_stack+4096, NULL, NULL, vrr_stack+2700);
 _BUILD_p0n0(Data,vrr_stack+4360, vrr_stack+4030, vrr_stack+3964, NULL, NULL, vrr_stack+2590);
 _BUILD_d0n0(Data,vrr_stack+1625, vrr_stack+4360, vrr_stack+4162, vrr_stack+4030, vrr_stack+3964, vrr_stack+2755);
 _BUILD_00n0(Data,vrr_stack+2755, vrr_stack+880, vrr_stack+2645, vrr_stack+496, vrr_stack+1015, NULL);
 _BUILD_p0n0(Data,vrr_stack+2021, vrr_stack+2755, vrr_stack+4030, NULL, NULL, vrr_stack+2645);
 _BUILD_d0n0(Data,vrr_stack+5780, vrr_stack+2021, vrr_stack+4360, vrr_stack+2755, vrr_stack+4030, vrr_stack+2920);
 _BUILD_00n0(Data,vrr_stack+2821, vrr_stack+1060, vrr_stack+3744, vrr_stack+1195, vrr_stack+605, NULL);
 _BUILD_p0n0(Data,vrr_stack+2887, vrr_stack+4096, vrr_stack+2821, NULL, NULL, vrr_stack+1060);
 _BUILD_d0n0(Data,vrr_stack+13442, vrr_stack+4162, vrr_stack+2887, vrr_stack+3964, vrr_stack+4096, vrr_stack+160);
 _BUILD_f0n0(Data,vrr_stack+13838, vrr_stack+1625, vrr_stack+13442, vrr_stack+4360, vrr_stack+4162, vrr_stack+7832);
 _BUILD_f0n0(Data,vrr_stack+14498, vrr_stack+5780, vrr_stack+1625, vrr_stack+2021, vrr_stack+4360, vrr_stack+3085);
 _BUILD_g0n0(Data,vrr_stack+15158, vrr_stack+14498, vrr_stack+13838, vrr_stack+5780, vrr_stack+1625, vrr_stack+8162);
 _BUILD_00n0(Data,vrr_stack+3085, vrr_stack+1240, vrr_stack+880, vrr_stack+1115, vrr_stack+496, NULL);
 _BUILD_p0n0(Data,vrr_stack+3151, vrr_stack+3085, vrr_stack+2755, NULL, NULL, vrr_stack+880);
 _BUILD_d0n0(Data,vrr_stack+7832, vrr_stack+3151, vrr_stack+2021, vrr_stack+3085, vrr_stack+2755, vrr_stack+3415);
 _BUILD_f0n0(Data,vrr_stack+16148, vrr_stack+7832, vrr_stack+5780, vrr_stack+3151, vrr_stack+2021, vrr_stack+7502);
 _BUILD_g0n0(Data,vrr_stack+16808, vrr_stack+16148, vrr_stack+14498, vrr_stack+7832, vrr_stack+5780, vrr_stack+8712);
 _BUILD_00p0(Data,vrr_stack+7502, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+7505, vrr_stack+3580, vrr_stack+7502, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+7511, vrr_stack+3583, vrr_stack+7505, vrr_stack+18, vrr_stack+3580, NULL);
 _BUILD_00g0(Data,vrr_stack+7521, vrr_stack+3589, vrr_stack+7511, vrr_stack+21, vrr_stack+3583, NULL);
 _BUILD_00h0(Data,vrr_stack+7536, vrr_stack+3599, vrr_stack+7521, vrr_stack+27, vrr_stack+3589, NULL);
 _BUILD_00i0(Data,vrr_stack+7557, vrr_stack+3614, vrr_stack+7536, vrr_stack+37, vrr_stack+3599, NULL);
 _BUILD_00k0(Data,vrr_stack+7585, vrr_stack+3635, vrr_stack+7557, vrr_stack+52, vrr_stack+3614, NULL);
 _BUILD_00l0(Data,vrr_stack+7621, vrr_stack+3663, vrr_stack+7585, vrr_stack+541, vrr_stack+3635, NULL);
 _BUILD_00m0(Data,vrr_stack+7666, vrr_stack+3699, vrr_stack+7621, vrr_stack+569, vrr_stack+3663, NULL);
 _BUILD_00n0(Data,vrr_stack+7721, vrr_stack+3744, vrr_stack+7666, vrr_stack+605, vrr_stack+3699, NULL);
 _BUILD_p0n0(Data,vrr_stack+7787, vrr_stack+2821, vrr_stack+7721, NULL, NULL, vrr_stack+3744);
 _BUILD_d0n0(Data,vrr_stack+7985, vrr_stack+2887, vrr_stack+7787, vrr_stack+4096, vrr_stack+2821, vrr_stack+3799);
 _BUILD_f0n0(Data,vrr_stack+8381, vrr_stack+13442, vrr_stack+7985, vrr_stack+4162, vrr_stack+2887, vrr_stack+1295);
 _BUILD_g0n0(Data,vrr_stack+17798, vrr_stack+13838, vrr_stack+8381, vrr_stack+1625, vrr_stack+13442, vrr_stack+10912);
 _BUILD_h0n0(Data,vrr_stack+18788, vrr_stack+15158, vrr_stack+17798, vrr_stack+14498, vrr_stack+13838, vrr_stack+11462);
 _BUILD_h0n0(Data,vrr_stack+20174, vrr_stack+16808, vrr_stack+15158, vrr_stack+16148, vrr_stack+14498, vrr_stack+9262);
   tmp = vrr_stack + 20174;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+16148, vrr_stack+3964, vrr_stack+4096, vrr_stack+2590, vrr_stack+2700, NULL);
 _BUILD_00o0(Data,vrr_stack+16226, vrr_stack+4030, vrr_stack+3964, vrr_stack+2645, vrr_stack+2590, NULL);
 _BUILD_00o0(Data,vrr_stack+16304, vrr_stack+4096, vrr_stack+2821, vrr_stack+2700, vrr_stack+1060, NULL);
 _BUILD_p0o0(Data,vrr_stack+16382, vrr_stack+16148, vrr_stack+16304, NULL, NULL, vrr_stack+4096);
 _BUILD_p0o0(Data,vrr_stack+10912, vrr_stack+16226, vrr_stack+16148, NULL, NULL, vrr_stack+3964);
 _BUILD_d0o0(Data,vrr_stack+11146, vrr_stack+10912, vrr_stack+16382, vrr_stack+16226, vrr_stack+16148, vrr_stack+4162);
 _BUILD_00o0(Data,vrr_stack+4162, vrr_stack+2755, vrr_stack+4030, vrr_stack+880, vrr_stack+2645, NULL);
 _BUILD_p0o0(Data,vrr_stack+11614, vrr_stack+4162, vrr_stack+16226, NULL, NULL, vrr_stack+4030);
 _BUILD_d0o0(Data,vrr_stack+0, vrr_stack+11614, vrr_stack+10912, vrr_stack+4162, vrr_stack+16226, vrr_stack+4360);
 _BUILD_00o0(Data,vrr_stack+4240, vrr_stack+2821, vrr_stack+7721, vrr_stack+1060, vrr_stack+3744, NULL);
 _BUILD_p0o0(Data,vrr_stack+4318, vrr_stack+16304, vrr_stack+4240, NULL, NULL, vrr_stack+2821);
 _BUILD_d0o0(Data,vrr_stack+2219, vrr_stack+16382, vrr_stack+4318, vrr_stack+16148, vrr_stack+16304, vrr_stack+2887);
 _BUILD_f0o0(Data,vrr_stack+21560, vrr_stack+11146, vrr_stack+2219, vrr_stack+10912, vrr_stack+16382, vrr_stack+13442);
 _BUILD_f0o0(Data,vrr_stack+22340, vrr_stack+0, vrr_stack+11146, vrr_stack+11614, vrr_stack+10912, vrr_stack+1625);
 _BUILD_g0o0(Data,vrr_stack+23120, vrr_stack+22340, vrr_stack+21560, vrr_stack+0, vrr_stack+11146, vrr_stack+13838);
 _BUILD_00o0(Data,vrr_stack+13442, vrr_stack+3085, vrr_stack+2755, vrr_stack+1240, vrr_stack+880, NULL);
 _BUILD_p0o0(Data,vrr_stack+13520, vrr_stack+13442, vrr_stack+4162, NULL, NULL, vrr_stack+2755);
 _BUILD_d0o0(Data,vrr_stack+13754, vrr_stack+13520, vrr_stack+11614, vrr_stack+13442, vrr_stack+4162, vrr_stack+2021);
 _BUILD_f0o0(Data,vrr_stack+468, vrr_stack+13754, vrr_stack+0, vrr_stack+13520, vrr_stack+11614, vrr_stack+5780);
 _BUILD_g0o0(Data,vrr_stack+24290, vrr_stack+468, vrr_stack+22340, vrr_stack+13754, vrr_stack+0, vrr_stack+14498);
 _BUILD_00p0(Data,vrr_stack+5780, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+5783, vrr_stack+7502, vrr_stack+5780, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+5789, vrr_stack+7505, vrr_stack+5783, vrr_stack+3580, vrr_stack+7502, NULL);
 _BUILD_00g0(Data,vrr_stack+5799, vrr_stack+7511, vrr_stack+5789, vrr_stack+3583, vrr_stack+7505, NULL);
 _BUILD_00h0(Data,vrr_stack+5814, vrr_stack+7521, vrr_stack+5799, vrr_stack+3589, vrr_stack+7511, NULL);
 _BUILD_00i0(Data,vrr_stack+5835, vrr_stack+7536, vrr_stack+5814, vrr_stack+3599, vrr_stack+7521, NULL);
 _BUILD_00k0(Data,vrr_stack+5863, vrr_stack+7557, vrr_stack+5835, vrr_stack+3614, vrr_stack+7536, NULL);
 _BUILD_00l0(Data,vrr_stack+5899, vrr_stack+7585, vrr_stack+5863, vrr_stack+3635, vrr_stack+7557, NULL);
 _BUILD_00m0(Data,vrr_stack+5944, vrr_stack+7621, vrr_stack+5899, vrr_stack+3663, vrr_stack+7585, NULL);
 _BUILD_00n0(Data,vrr_stack+5999, vrr_stack+7666, vrr_stack+5944, vrr_stack+3699, vrr_stack+7621, NULL);
 _BUILD_00o0(Data,vrr_stack+6065, vrr_stack+7721, vrr_stack+5999, vrr_stack+3744, vrr_stack+7666, NULL);
 _BUILD_p0o0(Data,vrr_stack+6143, vrr_stack+4240, vrr_stack+6065, NULL, NULL, vrr_stack+7721);
 _BUILD_d0o0(Data,vrr_stack+13520, vrr_stack+4318, vrr_stack+6143, vrr_stack+16304, vrr_stack+4240, vrr_stack+7787);
 _BUILD_f0o0(Data,vrr_stack+13988, vrr_stack+2219, vrr_stack+13520, vrr_stack+16382, vrr_stack+4318, vrr_stack+7985);
 _BUILD_g0o0(Data,vrr_stack+25460, vrr_stack+21560, vrr_stack+13988, vrr_stack+11146, vrr_stack+2219, vrr_stack+8381);
 _BUILD_h0o0(Data,vrr_stack+26630, vrr_stack+23120, vrr_stack+25460, vrr_stack+22340, vrr_stack+21560, vrr_stack+17798);
 _BUILD_h0o0(Data,vrr_stack+28268, vrr_stack+24290, vrr_stack+23120, vrr_stack+468, vrr_stack+22340, vrr_stack+15158);
   tmp = vrr_stack + 28268;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+468, vrr_stack+16148, vrr_stack+16304, vrr_stack+3964, vrr_stack+4096, NULL);
 _BUILD_00q0(Data,vrr_stack+559, vrr_stack+16226, vrr_stack+16148, vrr_stack+4030, vrr_stack+3964, NULL);
 _BUILD_00q0(Data,vrr_stack+650, vrr_stack+16304, vrr_stack+4240, vrr_stack+4096, vrr_stack+2821, NULL);
 _BUILD_p0q0(Data,vrr_stack+741, vrr_stack+468, vrr_stack+650, NULL, NULL, vrr_stack+16304);
 _BUILD_p0q0(Data,vrr_stack+1014, vrr_stack+559, vrr_stack+468, NULL, NULL, vrr_stack+16148);
 _BUILD_d0q0(Data,vrr_stack+1287, vrr_stack+1014, vrr_stack+741, vrr_stack+559, vrr_stack+468, vrr_stack+16382);
 _BUILD_00q0(Data,vrr_stack+16304, vrr_stack+4162, vrr_stack+16226, vrr_stack+2755, vrr_stack+4030, NULL);
 _BUILD_p0q0(Data,vrr_stack+16395, vrr_stack+16304, vrr_stack+559, NULL, NULL, vrr_stack+16226);
 _BUILD_d0q0(Data,vrr_stack+17798, vrr_stack+16395, vrr_stack+1014, vrr_stack+16304, vrr_stack+559, vrr_stack+10912);
 _BUILD_00q0(Data,vrr_stack+559, vrr_stack+4240, vrr_stack+6065, vrr_stack+2821, vrr_stack+7721, NULL);
 _BUILD_p0q0(Data,vrr_stack+1833, vrr_stack+650, vrr_stack+559, NULL, NULL, vrr_stack+4240);
 _BUILD_d0q0(Data,vrr_stack+7787, vrr_stack+741, vrr_stack+1833, vrr_stack+468, vrr_stack+650, vrr_stack+4318);
 _BUILD_f0q0(Data,vrr_stack+8333, vrr_stack+1287, vrr_stack+7787, vrr_stack+1014, vrr_stack+741, vrr_stack+2219);
 _BUILD_f0q0(Data,vrr_stack+3151, vrr_stack+17798, vrr_stack+1287, vrr_stack+16395, vrr_stack+1014, vrr_stack+11146);
 _BUILD_g0q0(Data,vrr_stack+29906, vrr_stack+3151, vrr_stack+8333, vrr_stack+17798, vrr_stack+1287, vrr_stack+21560);
 _BUILD_00q0(Data,vrr_stack+468, vrr_stack+13442, vrr_stack+4162, vrr_stack+3085, vrr_stack+2755, NULL);
 _BUILD_p0q0(Data,vrr_stack+1014, vrr_stack+468, vrr_stack+16304, NULL, NULL, vrr_stack+4162);
 _BUILD_d0q0(Data,vrr_stack+21560, vrr_stack+1014, vrr_stack+16395, vrr_stack+468, vrr_stack+16304, vrr_stack+11614);
 _BUILD_f0q0(Data,vrr_stack+10912, vrr_stack+21560, vrr_stack+17798, vrr_stack+1014, vrr_stack+16395, vrr_stack+0);
 _BUILD_g0q0(Data,vrr_stack+31271, vrr_stack+10912, vrr_stack+3151, vrr_stack+21560, vrr_stack+17798, vrr_stack+22340);
 _BUILD_00p0(Data,vrr_stack+17798, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+17801, vrr_stack+5780, vrr_stack+17798, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+17807, vrr_stack+5783, vrr_stack+17801, vrr_stack+7502, vrr_stack+5780, NULL);
 _BUILD_00g0(Data,vrr_stack+17817, vrr_stack+5789, vrr_stack+17807, vrr_stack+7505, vrr_stack+5783, NULL);
 _BUILD_00h0(Data,vrr_stack+17832, vrr_stack+5799, vrr_stack+17817, vrr_stack+7511, vrr_stack+5789, NULL);
 _BUILD_00i0(Data,vrr_stack+17798, vrr_stack+5814, vrr_stack+17832, vrr_stack+7521, vrr_stack+5799, NULL);
 _BUILD_00k0(Data,vrr_stack+17826, vrr_stack+5835, vrr_stack+17798, vrr_stack+7536, vrr_stack+5814, NULL);
 _BUILD_00l0(Data,vrr_stack+5780, vrr_stack+5863, vrr_stack+17826, vrr_stack+7557, vrr_stack+5835, NULL);
 _BUILD_00m0(Data,vrr_stack+17798, vrr_stack+5899, vrr_stack+5780, vrr_stack+7585, vrr_stack+5863, NULL);
 _BUILD_00n0(Data,vrr_stack+5780, vrr_stack+5944, vrr_stack+17798, vrr_stack+7621, vrr_stack+5899, NULL);
 _BUILD_00o0(Data,vrr_stack+13442, vrr_stack+5999, vrr_stack+5780, vrr_stack+7666, vrr_stack+5944, NULL);
 _BUILD_00q0(Data,vrr_stack+5780, vrr_stack+6065, vrr_stack+13442, vrr_stack+7721, vrr_stack+5999, NULL);
 _BUILD_p0q0(Data,vrr_stack+1014, vrr_stack+559, vrr_stack+5780, NULL, NULL, vrr_stack+6065);
 _BUILD_d0q0(Data,vrr_stack+17798, vrr_stack+1833, vrr_stack+1014, vrr_stack+650, vrr_stack+559, vrr_stack+6143);
 _BUILD_f0q0(Data,vrr_stack+21560, vrr_stack+7787, vrr_stack+17798, vrr_stack+741, vrr_stack+1833, vrr_stack+13520);
 _BUILD_g0q0(Data,vrr_stack+32636, vrr_stack+8333, vrr_stack+21560, vrr_stack+1287, vrr_stack+7787, vrr_stack+13988);
 _BUILD_h0q0(Data,vrr_stack+0, vrr_stack+29906, vrr_stack+32636, vrr_stack+3151, vrr_stack+8333, vrr_stack+25460);
 _BUILD_h0q0(Data,vrr_stack+32636, vrr_stack+31271, vrr_stack+29906, vrr_stack+10912, vrr_stack+3151, vrr_stack+23120);
   tmp = vrr_stack + 32636;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0m0(Data,vrr_stack+21560, vrr_stack+12287, vrr_stack+4625, vrr_stack+10087, vrr_stack+9262, vrr_stack+6557);
   tmp = vrr_stack + 21560;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0n0(Data,vrr_stack+5780, vrr_stack+20174, vrr_stack+18788, vrr_stack+16808, vrr_stack+15158, vrr_stack+4625);
   tmp = vrr_stack + 5780;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0o0(Data,vrr_stack+7628, vrr_stack+28268, vrr_stack+26630, vrr_stack+24290, vrr_stack+23120, vrr_stack+18788);
   tmp = vrr_stack + 7628;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0q0(Data,vrr_stack+23100, vrr_stack+32636, vrr_stack+0, vrr_stack+31271, vrr_stack+29906, vrr_stack+26630);
   tmp = vrr_stack + 23100;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];

}

