/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (pp|ki) integrals */

void vrr_order_ppki(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+4, Data->F+5, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+50, vrr_stack+15, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+56, vrr_stack+117, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+66, vrr_stack+127, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+163, vrr_stack+96, vrr_stack+142, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+31, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+191, vrr_stack+24, vrr_stack+34, vrr_stack+21, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+201, vrr_stack+191, vrr_stack+40, vrr_stack+24, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+216, vrr_stack+201, vrr_stack+81, vrr_stack+191, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+237, vrr_stack+216, vrr_stack+96, vrr_stack+201, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+265, vrr_stack+237, vrr_stack+163, NULL, NULL, vrr_stack+96);
 _BUILD_00k0(Data,vrr_stack+349, vrr_stack+237, vrr_stack+163, vrr_stack+216, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+21, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+84, vrr_stack+24, vrr_stack+81, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+385, vrr_stack+30, vrr_stack+191, vrr_stack+84, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+400, vrr_stack+385, vrr_stack+201, vrr_stack+30, vrr_stack+191, NULL);
 _BUILD_00i0(Data,vrr_stack+21, vrr_stack+400, vrr_stack+216, vrr_stack+385, vrr_stack+201, NULL);
 _BUILD_00k0(Data,vrr_stack+421, vrr_stack+21, vrr_stack+237, vrr_stack+400, vrr_stack+216, NULL);
 _BUILD_00p0(Data,vrr_stack+385, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+388, vrr_stack+0, vrr_stack+385, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+394, vrr_stack+15, vrr_stack+388, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+117, vrr_stack+394, vrr_stack+50, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+191, vrr_stack+127, vrr_stack+81, vrr_stack+56, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+457, vrr_stack+142, vrr_stack+191, vrr_stack+66, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+485, vrr_stack+163, vrr_stack+457, vrr_stack+96, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+521, vrr_stack+349, vrr_stack+485, NULL, NULL, vrr_stack+163);
 _BUILD_p0k0(Data,vrr_stack+629, vrr_stack+421, vrr_stack+349, NULL, NULL, vrr_stack+237);
   tmp = vrr_stack + 629;
   target_ptr = Libint->vrr_classes[1][7];
   for(i=0;i<108;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+737, vrr_stack+349, vrr_stack+485, vrr_stack+237, vrr_stack+163, NULL);
 _BUILD_00l0(Data,vrr_stack+782, vrr_stack+421, vrr_stack+349, vrr_stack+21, vrr_stack+237, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+385, vrr_stack+21, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+388, vrr_stack+24, vrr_stack+0, vrr_stack+385, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+394, vrr_stack+30, vrr_stack+15, vrr_stack+388, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+0, vrr_stack+117, vrr_stack+394, NULL);
 _BUILD_00i0(Data,vrr_stack+40, vrr_stack+191, vrr_stack+96, vrr_stack+127, vrr_stack+81, NULL);
 _BUILD_00k0(Data,vrr_stack+212, vrr_stack+457, vrr_stack+40, vrr_stack+142, vrr_stack+191, NULL);
 _BUILD_00l0(Data,vrr_stack+117, vrr_stack+485, vrr_stack+212, vrr_stack+163, vrr_stack+457, NULL);
 _BUILD_p0l0(Data,vrr_stack+827, vrr_stack+737, vrr_stack+117, NULL, NULL, vrr_stack+485);
 _BUILD_p0l0(Data,vrr_stack+962, vrr_stack+782, vrr_stack+737, NULL, NULL, vrr_stack+349);
   tmp = vrr_stack + 962;
   target_ptr = Libint->vrr_classes[1][8];
   for(i=0;i<135;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+1097, vrr_stack+737, vrr_stack+117, vrr_stack+349, vrr_stack+485, NULL);
 _BUILD_00m0(Data,vrr_stack+1152, vrr_stack+782, vrr_stack+737, vrr_stack+421, vrr_stack+349, NULL);
 _BUILD_00p0(Data,vrr_stack+162, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+21, vrr_stack+162, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+165, vrr_stack+24, vrr_stack+15, vrr_stack+385, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+175, vrr_stack+30, vrr_stack+165, vrr_stack+388, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+1207, vrr_stack+0, vrr_stack+175, vrr_stack+394, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+385, vrr_stack+96, vrr_stack+1207, vrr_stack+81, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+1228, vrr_stack+40, vrr_stack+385, vrr_stack+191, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+1264, vrr_stack+212, vrr_stack+1228, vrr_stack+457, vrr_stack+40, NULL);
 _BUILD_00m0(Data,vrr_stack+1309, vrr_stack+117, vrr_stack+1264, vrr_stack+485, vrr_stack+212, NULL);
 _BUILD_p0m0(Data,vrr_stack+1364, vrr_stack+1097, vrr_stack+1309, NULL, NULL, vrr_stack+117);
 _BUILD_p0m0(Data,vrr_stack+1529, vrr_stack+1152, vrr_stack+1097, NULL, NULL, vrr_stack+737);
   tmp = vrr_stack + 1529;
   target_ptr = Libint->vrr_classes[1][9];
   for(i=0;i<165;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+1694, vrr_stack+1097, vrr_stack+1309, vrr_stack+737, vrr_stack+117, NULL);
 _BUILD_00n0(Data,vrr_stack+1760, vrr_stack+1152, vrr_stack+1097, vrr_stack+782, vrr_stack+737, NULL);
 _BUILD_00p0(Data,vrr_stack+457, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+460, vrr_stack+162, vrr_stack+457, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+466, vrr_stack+15, vrr_stack+460, vrr_stack+21, vrr_stack+162, NULL);
 _BUILD_00g0(Data,vrr_stack+476, vrr_stack+165, vrr_stack+466, vrr_stack+24, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+491, vrr_stack+175, vrr_stack+476, vrr_stack+30, vrr_stack+165, NULL);
 _BUILD_00i0(Data,vrr_stack+68, vrr_stack+1207, vrr_stack+491, vrr_stack+0, vrr_stack+175, NULL);
 _BUILD_00k0(Data,vrr_stack+1826, vrr_stack+385, vrr_stack+68, vrr_stack+96, vrr_stack+1207, NULL);
 _BUILD_00l0(Data,vrr_stack+1862, vrr_stack+1228, vrr_stack+1826, vrr_stack+40, vrr_stack+385, NULL);
 _BUILD_00m0(Data,vrr_stack+1907, vrr_stack+1264, vrr_stack+1862, vrr_stack+212, vrr_stack+1228, NULL);
 _BUILD_00n0(Data,vrr_stack+190, vrr_stack+1309, vrr_stack+1907, vrr_stack+117, vrr_stack+1264, NULL);
 _BUILD_p0n0(Data,vrr_stack+1962, vrr_stack+1694, vrr_stack+190, NULL, NULL, vrr_stack+1309);
 _BUILD_p0n0(Data,vrr_stack+2160, vrr_stack+1760, vrr_stack+1694, NULL, NULL, vrr_stack+1097);
   tmp = vrr_stack + 2160;
   target_ptr = Libint->vrr_classes[1][10];
   for(i=0;i<198;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+2358, vrr_stack+1694, vrr_stack+190, vrr_stack+1097, vrr_stack+1309, NULL);
 _BUILD_00o0(Data,vrr_stack+2436, vrr_stack+1760, vrr_stack+1694, vrr_stack+1152, vrr_stack+1097, NULL);
 _BUILD_00p0(Data,vrr_stack+96, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+99, vrr_stack+457, vrr_stack+96, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+105, vrr_stack+460, vrr_stack+99, vrr_stack+162, vrr_stack+457, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+466, vrr_stack+105, vrr_stack+15, vrr_stack+460, NULL);
 _BUILD_00h0(Data,vrr_stack+15, vrr_stack+476, vrr_stack+0, vrr_stack+165, vrr_stack+466, NULL);
 _BUILD_00i0(Data,vrr_stack+36, vrr_stack+491, vrr_stack+15, vrr_stack+175, vrr_stack+476, NULL);
 _BUILD_00k0(Data,vrr_stack+115, vrr_stack+68, vrr_stack+36, vrr_stack+1207, vrr_stack+491, NULL);
 _BUILD_00l0(Data,vrr_stack+2514, vrr_stack+1826, vrr_stack+115, vrr_stack+385, vrr_stack+68, NULL);
 _BUILD_00m0(Data,vrr_stack+2559, vrr_stack+1862, vrr_stack+2514, vrr_stack+1228, vrr_stack+1826, NULL);
 _BUILD_00n0(Data,vrr_stack+2614, vrr_stack+1907, vrr_stack+2559, vrr_stack+1264, vrr_stack+1862, NULL);
 _BUILD_00o0(Data,vrr_stack+1207, vrr_stack+190, vrr_stack+2614, vrr_stack+1309, vrr_stack+1907, NULL);
 _BUILD_p0o0(Data,vrr_stack+2680, vrr_stack+2358, vrr_stack+1207, NULL, NULL, vrr_stack+190);
 _BUILD_p0o0(Data,vrr_stack+2914, vrr_stack+2436, vrr_stack+2358, NULL, NULL, vrr_stack+1694);
   tmp = vrr_stack + 2914;
   target_ptr = Libint->vrr_classes[1][11];
   for(i=0;i<234;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+3148, vrr_stack+2358, vrr_stack+1207, vrr_stack+1694, vrr_stack+190, NULL);
 _BUILD_00q0(Data,vrr_stack+3239, vrr_stack+2436, vrr_stack+2358, vrr_stack+1760, vrr_stack+1694, NULL);
 _BUILD_00p0(Data,vrr_stack+385, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+388, vrr_stack+96, vrr_stack+385, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+394, vrr_stack+99, vrr_stack+388, vrr_stack+457, vrr_stack+96, NULL);
 _BUILD_00g0(Data,vrr_stack+404, vrr_stack+105, vrr_stack+394, vrr_stack+460, vrr_stack+99, NULL);
 _BUILD_00h0(Data,vrr_stack+1285, vrr_stack+0, vrr_stack+404, vrr_stack+466, vrr_stack+105, NULL);
 _BUILD_00i0(Data,vrr_stack+1306, vrr_stack+15, vrr_stack+1285, vrr_stack+476, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+151, vrr_stack+36, vrr_stack+1306, vrr_stack+491, vrr_stack+15, NULL);
 _BUILD_00l0(Data,vrr_stack+457, vrr_stack+115, vrr_stack+151, vrr_stack+68, vrr_stack+36, NULL);
 _BUILD_00m0(Data,vrr_stack+3330, vrr_stack+2514, vrr_stack+457, vrr_stack+1826, vrr_stack+115, NULL);
 _BUILD_00n0(Data,vrr_stack+3385, vrr_stack+2559, vrr_stack+3330, vrr_stack+1862, vrr_stack+2514, NULL);
 _BUILD_00o0(Data,vrr_stack+1826, vrr_stack+2614, vrr_stack+3385, vrr_stack+1907, vrr_stack+2559, NULL);
 _BUILD_00q0(Data,vrr_stack+3451, vrr_stack+1207, vrr_stack+1826, vrr_stack+190, vrr_stack+2614, NULL);
 _BUILD_p0q0(Data,vrr_stack+3542, vrr_stack+3148, vrr_stack+3451, NULL, NULL, vrr_stack+1207);
 _BUILD_p0q0(Data,vrr_stack+3815, vrr_stack+3239, vrr_stack+3148, NULL, NULL, vrr_stack+2358);
   tmp = vrr_stack + 3815;
   target_ptr = Libint->vrr_classes[1][12];
   for(i=0;i<273;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4088, vrr_stack+3148, vrr_stack+3451, vrr_stack+2358, vrr_stack+1207, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4193, vrr_stack+3239, vrr_stack+3148, vrr_stack+2436, vrr_stack+2358, NULL);
 _BUILD_00p0(Data,vrr_stack+1904, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1907, vrr_stack+385, vrr_stack+1904, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+1913, vrr_stack+388, vrr_stack+1907, vrr_stack+96, vrr_stack+385, NULL);
 _BUILD_00g0(Data,vrr_stack+1923, vrr_stack+394, vrr_stack+1913, vrr_stack+99, vrr_stack+388, NULL);
 _BUILD_00h0(Data,vrr_stack+1938, vrr_stack+404, vrr_stack+1923, vrr_stack+105, vrr_stack+394, NULL);
 _BUILD_00i0(Data,vrr_stack+1904, vrr_stack+1285, vrr_stack+1938, vrr_stack+0, vrr_stack+404, NULL);
 _BUILD_00k0(Data,vrr_stack+385, vrr_stack+1306, vrr_stack+1904, vrr_stack+15, vrr_stack+1285, NULL);
 _BUILD_00l0(Data,vrr_stack+1904, vrr_stack+151, vrr_stack+385, vrr_stack+36, vrr_stack+1306, NULL);
 _BUILD_00m0(Data,vrr_stack+1285, vrr_stack+457, vrr_stack+1904, vrr_stack+115, vrr_stack+151, NULL);
 _BUILD_00n0(Data,vrr_stack+0, vrr_stack+3330, vrr_stack+1285, vrr_stack+2514, vrr_stack+457, NULL);
 _BUILD_00o0(Data,vrr_stack+1285, vrr_stack+3385, vrr_stack+0, vrr_stack+2559, vrr_stack+3330, NULL);
 _BUILD_00q0(Data,vrr_stack+0, vrr_stack+1826, vrr_stack+1285, vrr_stack+2614, vrr_stack+3385, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3330, vrr_stack+3451, vrr_stack+0, vrr_stack+1207, vrr_stack+1826, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4298, vrr_stack+4088, vrr_stack+3330, NULL, NULL, vrr_stack+3451);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4613, vrr_stack+4193, vrr_stack+4088, NULL, NULL, vrr_stack+3148);
   tmp = vrr_stack + 4613;
   target_ptr = Libint->vrr_classes[1][13];
   for(i=0;i<315;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0k0(Data,vrr_stack+0, vrr_stack+629, vrr_stack+521, vrr_stack+421, vrr_stack+349, vrr_stack+265);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[2][7];
   for(i=0;i<216;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0l0(Data,vrr_stack+216, vrr_stack+962, vrr_stack+827, vrr_stack+782, vrr_stack+737, vrr_stack+521);
   tmp = vrr_stack + 216;
   target_ptr = Libint->vrr_classes[2][8];
   for(i=0;i<270;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0m0(Data,vrr_stack+486, vrr_stack+1529, vrr_stack+1364, vrr_stack+1152, vrr_stack+1097, vrr_stack+827);
   tmp = vrr_stack + 486;
   target_ptr = Libint->vrr_classes[2][9];
   for(i=0;i<330;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0n0(Data,vrr_stack+816, vrr_stack+2160, vrr_stack+1962, vrr_stack+1760, vrr_stack+1694, vrr_stack+1364);
   tmp = vrr_stack + 816;
   target_ptr = Libint->vrr_classes[2][10];
   for(i=0;i<396;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0o0(Data,vrr_stack+1212, vrr_stack+2914, vrr_stack+2680, vrr_stack+2436, vrr_stack+2358, vrr_stack+1962);
   tmp = vrr_stack + 1212;
   target_ptr = Libint->vrr_classes[2][11];
   for(i=0;i<468;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0q0(Data,vrr_stack+1680, vrr_stack+3815, vrr_stack+3542, vrr_stack+3239, vrr_stack+3148, vrr_stack+2680);
   tmp = vrr_stack + 1680;
   target_ptr = Libint->vrr_classes[2][12];
   for(i=0;i<546;i++)
     target_ptr[i] += tmp[i];
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2226, vrr_stack+4613, vrr_stack+4298, vrr_stack+4193, vrr_stack+4088, vrr_stack+3542);
   tmp = vrr_stack + 2226;
   target_ptr = Libint->vrr_classes[2][13];
   for(i=0;i<630;i++)
     target_ptr[i] += tmp[i];

}

