/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (pp|ll) integrals */

void vrr_order_ppll(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+3, vrr_stack+12, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+65, vrr_stack+15, vrr_stack+3, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+71, vrr_stack+40, vrr_stack+65, vrr_stack+15, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+21, vrr_stack+12, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+96, vrr_stack+24, vrr_stack+15, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+106, vrr_stack+30, vrr_stack+96, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+121, vrr_stack+50, vrr_stack+106, vrr_stack+40, vrr_stack+30, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+81, vrr_stack+50, vrr_stack+71, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+163, vrr_stack+142, vrr_stack+121, vrr_stack+81, vrr_stack+50, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+12, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+21, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+191, vrr_stack+96, vrr_stack+40, vrr_stack+24, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+206, vrr_stack+106, vrr_stack+191, vrr_stack+30, vrr_stack+96, NULL);
 _BUILD_00i0(Data,vrr_stack+227, vrr_stack+121, vrr_stack+206, vrr_stack+50, vrr_stack+106, NULL);
 _BUILD_00k0(Data,vrr_stack+255, vrr_stack+163, vrr_stack+227, vrr_stack+142, vrr_stack+121, NULL);
 _BUILD_00p0(Data,vrr_stack+50, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+53, vrr_stack+50, vrr_stack+3, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+53, vrr_stack+65, vrr_stack+50, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+291, vrr_stack+21, vrr_stack+71, vrr_stack+53, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+306, vrr_stack+291, vrr_stack+81, vrr_stack+21, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+327, vrr_stack+306, vrr_stack+142, vrr_stack+291, vrr_stack+81, NULL);
 _BUILD_00k0(Data,vrr_stack+59, vrr_stack+327, vrr_stack+163, vrr_stack+306, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+355, vrr_stack+59, vrr_stack+255, NULL, NULL, vrr_stack+163);
 _BUILD_00l0(Data,vrr_stack+463, vrr_stack+59, vrr_stack+255, vrr_stack+327, vrr_stack+163, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+142, vrr_stack+3, vrr_stack+50, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+148, vrr_stack+142, vrr_stack+53, vrr_stack+3, vrr_stack+50, NULL);
 _BUILD_00g0(Data,vrr_stack+508, vrr_stack+148, vrr_stack+21, vrr_stack+142, vrr_stack+53, NULL);
 _BUILD_00h0(Data,vrr_stack+523, vrr_stack+508, vrr_stack+291, vrr_stack+148, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+544, vrr_stack+523, vrr_stack+306, vrr_stack+508, vrr_stack+291, NULL);
 _BUILD_00k0(Data,vrr_stack+572, vrr_stack+544, vrr_stack+327, vrr_stack+523, vrr_stack+306, NULL);
 _BUILD_00l0(Data,vrr_stack+608, vrr_stack+572, vrr_stack+59, vrr_stack+544, vrr_stack+327, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+291, vrr_stack+0, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+297, vrr_stack+6, vrr_stack+291, vrr_stack+12, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+307, vrr_stack+40, vrr_stack+297, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+191, vrr_stack+307, vrr_stack+96, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+12, vrr_stack+206, vrr_stack+142, vrr_stack+106, vrr_stack+191, NULL);
 _BUILD_00k0(Data,vrr_stack+508, vrr_stack+227, vrr_stack+12, vrr_stack+121, vrr_stack+206, NULL);
 _BUILD_00l0(Data,vrr_stack+95, vrr_stack+255, vrr_stack+508, vrr_stack+163, vrr_stack+227, NULL);
 _BUILD_p0l0(Data,vrr_stack+653, vrr_stack+463, vrr_stack+95, NULL, NULL, vrr_stack+255);
 _BUILD_p0l0(Data,vrr_stack+788, vrr_stack+608, vrr_stack+463, NULL, NULL, vrr_stack+59);
   tmp = vrr_stack + 788;
   target_ptr = Libint->vrr_classes[1][8];
   for(i=0;i<135;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+923, vrr_stack+463, vrr_stack+95, vrr_stack+59, vrr_stack+255, NULL);
 _BUILD_00m0(Data,vrr_stack+978, vrr_stack+608, vrr_stack+463, vrr_stack+572, vrr_stack+59, NULL);
 _BUILD_00p0(Data,vrr_stack+163, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+166, vrr_stack+3, vrr_stack+163, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+172, vrr_stack+291, vrr_stack+166, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+322, vrr_stack+297, vrr_stack+172, vrr_stack+6, vrr_stack+291, NULL);
 _BUILD_00h0(Data,vrr_stack+544, vrr_stack+307, vrr_stack+322, vrr_stack+40, vrr_stack+297, NULL);
 _BUILD_00i0(Data,vrr_stack+40, vrr_stack+142, vrr_stack+544, vrr_stack+191, vrr_stack+307, NULL);
 _BUILD_00k0(Data,vrr_stack+565, vrr_stack+12, vrr_stack+40, vrr_stack+206, vrr_stack+142, NULL);
 _BUILD_00l0(Data,vrr_stack+182, vrr_stack+508, vrr_stack+565, vrr_stack+227, vrr_stack+12, NULL);
 _BUILD_00m0(Data,vrr_stack+1033, vrr_stack+95, vrr_stack+182, vrr_stack+255, vrr_stack+508, NULL);
 _BUILD_p0m0(Data,vrr_stack+1088, vrr_stack+923, vrr_stack+1033, NULL, NULL, vrr_stack+95);
 _BUILD_p0m0(Data,vrr_stack+1253, vrr_stack+978, vrr_stack+923, NULL, NULL, vrr_stack+463);
   tmp = vrr_stack + 1253;
   target_ptr = Libint->vrr_classes[1][9];
   for(i=0;i<165;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+1418, vrr_stack+923, vrr_stack+1033, vrr_stack+463, vrr_stack+95, NULL);
 _BUILD_00n0(Data,vrr_stack+1484, vrr_stack+978, vrr_stack+923, vrr_stack+608, vrr_stack+463, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+163, vrr_stack+0, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+227, vrr_stack+166, vrr_stack+6, vrr_stack+3, vrr_stack+163, NULL);
 _BUILD_00g0(Data,vrr_stack+237, vrr_stack+172, vrr_stack+227, vrr_stack+291, vrr_stack+166, NULL);
 _BUILD_00h0(Data,vrr_stack+252, vrr_stack+322, vrr_stack+237, vrr_stack+297, vrr_stack+172, NULL);
 _BUILD_00i0(Data,vrr_stack+273, vrr_stack+544, vrr_stack+252, vrr_stack+307, vrr_stack+322, NULL);
 _BUILD_00k0(Data,vrr_stack+1550, vrr_stack+40, vrr_stack+273, vrr_stack+142, vrr_stack+544, NULL);
 _BUILD_00l0(Data,vrr_stack+1586, vrr_stack+565, vrr_stack+1550, vrr_stack+12, vrr_stack+40, NULL);
 _BUILD_00m0(Data,vrr_stack+1631, vrr_stack+182, vrr_stack+1586, vrr_stack+508, vrr_stack+565, NULL);
 _BUILD_00n0(Data,vrr_stack+1686, vrr_stack+1033, vrr_stack+1631, vrr_stack+95, vrr_stack+182, NULL);
 _BUILD_p0n0(Data,vrr_stack+1752, vrr_stack+1418, vrr_stack+1686, NULL, NULL, vrr_stack+1033);
 _BUILD_p0n0(Data,vrr_stack+1950, vrr_stack+1484, vrr_stack+1418, NULL, NULL, vrr_stack+923);
   tmp = vrr_stack + 1950;
   target_ptr = Libint->vrr_classes[1][10];
   for(i=0;i<198;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+68, vrr_stack+1418, vrr_stack+1686, vrr_stack+923, vrr_stack+1033, NULL);
 _BUILD_00o0(Data,vrr_stack+2148, vrr_stack+1484, vrr_stack+1418, vrr_stack+978, vrr_stack+923, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+508, vrr_stack+0, vrr_stack+3, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+514, vrr_stack+6, vrr_stack+508, vrr_stack+163, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+524, vrr_stack+227, vrr_stack+514, vrr_stack+166, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+301, vrr_stack+237, vrr_stack+524, vrr_stack+172, vrr_stack+227, NULL);
 _BUILD_00i0(Data,vrr_stack+12, vrr_stack+252, vrr_stack+301, vrr_stack+322, vrr_stack+237, NULL);
 _BUILD_00k0(Data,vrr_stack+146, vrr_stack+273, vrr_stack+12, vrr_stack+544, vrr_stack+252, NULL);
 _BUILD_00l0(Data,vrr_stack+2226, vrr_stack+1550, vrr_stack+146, vrr_stack+40, vrr_stack+273, NULL);
 _BUILD_00m0(Data,vrr_stack+2271, vrr_stack+1586, vrr_stack+2226, vrr_stack+565, vrr_stack+1550, NULL);
 _BUILD_00n0(Data,vrr_stack+539, vrr_stack+1631, vrr_stack+2271, vrr_stack+182, vrr_stack+1586, NULL);
 _BUILD_00o0(Data,vrr_stack+2326, vrr_stack+1686, vrr_stack+539, vrr_stack+1033, vrr_stack+1631, NULL);
 _BUILD_p0o0(Data,vrr_stack+2404, vrr_stack+68, vrr_stack+2326, NULL, NULL, vrr_stack+1686);
 _BUILD_p0o0(Data,vrr_stack+2638, vrr_stack+2148, vrr_stack+68, NULL, NULL, vrr_stack+1418);
   tmp = vrr_stack + 2638;
   target_ptr = Libint->vrr_classes[1][11];
   for(i=0;i<234;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+2872, vrr_stack+68, vrr_stack+2326, vrr_stack+1418, vrr_stack+1686, NULL);
 _BUILD_00q0(Data,vrr_stack+2963, vrr_stack+2148, vrr_stack+68, vrr_stack+1484, vrr_stack+1418, NULL);
 _BUILD_00p0(Data,vrr_stack+605, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1033, vrr_stack+3, vrr_stack+605, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+1039, vrr_stack+508, vrr_stack+1033, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+1049, vrr_stack+514, vrr_stack+1039, vrr_stack+6, vrr_stack+508, NULL);
 _BUILD_00h0(Data,vrr_stack+1064, vrr_stack+524, vrr_stack+1049, vrr_stack+227, vrr_stack+514, NULL);
 _BUILD_00i0(Data,vrr_stack+40, vrr_stack+301, vrr_stack+1064, vrr_stack+237, vrr_stack+524, NULL);
 _BUILD_00k0(Data,vrr_stack+182, vrr_stack+12, vrr_stack+40, vrr_stack+252, vrr_stack+301, NULL);
 _BUILD_00l0(Data,vrr_stack+218, vrr_stack+146, vrr_stack+182, vrr_stack+273, vrr_stack+12, NULL);
 _BUILD_00m0(Data,vrr_stack+3054, vrr_stack+2226, vrr_stack+218, vrr_stack+1550, vrr_stack+146, NULL);
 _BUILD_00n0(Data,vrr_stack+3109, vrr_stack+2271, vrr_stack+3054, vrr_stack+1586, vrr_stack+2226, NULL);
 _BUILD_00o0(Data,vrr_stack+1550, vrr_stack+539, vrr_stack+3109, vrr_stack+1631, vrr_stack+2271, NULL);
 _BUILD_00q0(Data,vrr_stack+3175, vrr_stack+2326, vrr_stack+1550, vrr_stack+1686, vrr_stack+539, NULL);
 _BUILD_p0q0(Data,vrr_stack+3266, vrr_stack+2872, vrr_stack+3175, NULL, NULL, vrr_stack+2326);
 _BUILD_p0q0(Data,vrr_stack+3539, vrr_stack+2963, vrr_stack+2872, NULL, NULL, vrr_stack+68);
   tmp = vrr_stack + 3539;
   target_ptr = Libint->vrr_classes[1][12];
   for(i=0;i<273;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1628, vrr_stack+2872, vrr_stack+3175, vrr_stack+68, vrr_stack+2326, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3812, vrr_stack+2963, vrr_stack+2872, vrr_stack+2148, vrr_stack+68, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+605, vrr_stack+0, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+1733, vrr_stack+1033, vrr_stack+6, vrr_stack+3, vrr_stack+605, NULL);
 _BUILD_00g0(Data,vrr_stack+263, vrr_stack+1039, vrr_stack+1733, vrr_stack+508, vrr_stack+1033, NULL);
 _BUILD_00h0(Data,vrr_stack+278, vrr_stack+1049, vrr_stack+263, vrr_stack+514, vrr_stack+1039, NULL);
 _BUILD_00i0(Data,vrr_stack+322, vrr_stack+1064, vrr_stack+278, vrr_stack+524, vrr_stack+1049, NULL);
 _BUILD_00k0(Data,vrr_stack+3917, vrr_stack+40, vrr_stack+322, vrr_stack+301, vrr_stack+1064, NULL);
 _BUILD_00l0(Data,vrr_stack+3953, vrr_stack+182, vrr_stack+3917, vrr_stack+12, vrr_stack+40, NULL);
 _BUILD_00m0(Data,vrr_stack+3998, vrr_stack+218, vrr_stack+3953, vrr_stack+146, vrr_stack+182, NULL);
 _BUILD_00n0(Data,vrr_stack+4053, vrr_stack+3054, vrr_stack+3998, vrr_stack+2226, vrr_stack+218, NULL);
 _BUILD_00o0(Data,vrr_stack+4119, vrr_stack+3109, vrr_stack+4053, vrr_stack+2271, vrr_stack+3054, NULL);
 _BUILD_00q0(Data,vrr_stack+2226, vrr_stack+1550, vrr_stack+4119, vrr_stack+539, vrr_stack+3109, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4197, vrr_stack+3175, vrr_stack+2226, vrr_stack+2326, vrr_stack+1550, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4302, vrr_stack+1628, vrr_stack+4197, NULL, NULL, vrr_stack+3175);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4617, vrr_stack+3812, vrr_stack+1628, NULL, NULL, vrr_stack+2872);
   tmp = vrr_stack + 4617;
   target_ptr = Libint->vrr_classes[1][13];
   for(i=0;i<315;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4932, vrr_stack+1628, vrr_stack+4197, vrr_stack+2872, vrr_stack+3175, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+5052, vrr_stack+3812, vrr_stack+1628, vrr_stack+2963, vrr_stack+2872, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2317, vrr_stack+0, vrr_stack+3, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+2323, vrr_stack+6, vrr_stack+2317, vrr_stack+605, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+2333, vrr_stack+1733, vrr_stack+2323, vrr_stack+1033, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+2348, vrr_stack+263, vrr_stack+2333, vrr_stack+1039, vrr_stack+1733, NULL);
 _BUILD_00i0(Data,vrr_stack+12, vrr_stack+278, vrr_stack+2348, vrr_stack+1049, vrr_stack+263, NULL);
 _BUILD_00k0(Data,vrr_stack+146, vrr_stack+322, vrr_stack+12, vrr_stack+1064, vrr_stack+278, NULL);
 _BUILD_00l0(Data,vrr_stack+1033, vrr_stack+3917, vrr_stack+146, vrr_stack+40, vrr_stack+322, NULL);
 _BUILD_00m0(Data,vrr_stack+508, vrr_stack+3953, vrr_stack+1033, vrr_stack+182, vrr_stack+3917, NULL);
 _BUILD_00n0(Data,vrr_stack+5172, vrr_stack+3998, vrr_stack+508, vrr_stack+218, vrr_stack+3953, NULL);
 _BUILD_00o0(Data,vrr_stack+182, vrr_stack+4053, vrr_stack+5172, vrr_stack+3054, vrr_stack+3998, NULL);
 _BUILD_00q0(Data,vrr_stack+5238, vrr_stack+4119, vrr_stack+182, vrr_stack+3109, vrr_stack+4053, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3054, vrr_stack+2226, vrr_stack+5238, vrr_stack+1550, vrr_stack+4119, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+5329, vrr_stack+4197, vrr_stack+3054, vrr_stack+3175, vrr_stack+2226, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+5449, vrr_stack+4932, vrr_stack+5329, NULL, NULL, vrr_stack+4197);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+5809, vrr_stack+5052, vrr_stack+4932, NULL, NULL, vrr_stack+1628);
   tmp = vrr_stack + 5809;
   target_ptr = Libint->vrr_classes[1][14];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6169, vrr_stack+4932, vrr_stack+5329, vrr_stack+1628, vrr_stack+4197, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6305, vrr_stack+5052, vrr_stack+4932, vrr_stack+3812, vrr_stack+1628, NULL);
 _BUILD_00p0(Data,vrr_stack+260, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1550, vrr_stack+3, vrr_stack+260, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+1078, vrr_stack+2317, vrr_stack+1550, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+1556, vrr_stack+2323, vrr_stack+1078, vrr_stack+6, vrr_stack+2317, NULL);
 _BUILD_00h0(Data,vrr_stack+1571, vrr_stack+2333, vrr_stack+1556, vrr_stack+1733, vrr_stack+2323, NULL);
 _BUILD_00i0(Data,vrr_stack+40, vrr_stack+2348, vrr_stack+1571, vrr_stack+263, vrr_stack+2333, NULL);
 _BUILD_00k0(Data,vrr_stack+1592, vrr_stack+12, vrr_stack+40, vrr_stack+278, vrr_stack+2348, NULL);
 _BUILD_00l0(Data,vrr_stack+563, vrr_stack+146, vrr_stack+1592, vrr_stack+322, vrr_stack+12, NULL);
 _BUILD_00m0(Data,vrr_stack+263, vrr_stack+1033, vrr_stack+563, vrr_stack+3917, vrr_stack+146, NULL);
 _BUILD_00n0(Data,vrr_stack+3159, vrr_stack+508, vrr_stack+263, vrr_stack+3953, vrr_stack+1033, NULL);
 _BUILD_00o0(Data,vrr_stack+3917, vrr_stack+5172, vrr_stack+3159, vrr_stack+3998, vrr_stack+508, NULL);
 _BUILD_00q0(Data,vrr_stack+6441, vrr_stack+182, vrr_stack+3917, vrr_stack+4053, vrr_stack+5172, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3995, vrr_stack+5238, vrr_stack+6441, vrr_stack+4119, vrr_stack+182, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+6532, vrr_stack+3054, vrr_stack+3995, vrr_stack+2226, vrr_stack+5238, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6652, vrr_stack+5329, vrr_stack+6532, vrr_stack+4197, vrr_stack+3054, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6788, vrr_stack+6169, vrr_stack+6652, NULL, NULL, vrr_stack+5329);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+7196, vrr_stack+6305, vrr_stack+6169, NULL, NULL, vrr_stack+4932);
   tmp = vrr_stack + 7196;
   target_ptr = Libint->vrr_classes[1][15];
   for(i=0;i<408;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+4100, vrr_stack+6169, vrr_stack+6652, vrr_stack+4932, vrr_stack+5329, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+7604, vrr_stack+6305, vrr_stack+6169, vrr_stack+5052, vrr_stack+4932, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+260, vrr_stack+0, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+2226, vrr_stack+1550, vrr_stack+6, vrr_stack+3, vrr_stack+260, NULL);
 _BUILD_00g0(Data,vrr_stack+2236, vrr_stack+1078, vrr_stack+2226, vrr_stack+2317, vrr_stack+1550, NULL);
 _BUILD_00h0(Data,vrr_stack+2251, vrr_stack+1556, vrr_stack+2236, vrr_stack+2323, vrr_stack+1078, NULL);
 _BUILD_00i0(Data,vrr_stack+2272, vrr_stack+1571, vrr_stack+2251, vrr_stack+2333, vrr_stack+1556, NULL);
 _BUILD_00k0(Data,vrr_stack+2226, vrr_stack+40, vrr_stack+2272, vrr_stack+2348, vrr_stack+1571, NULL);
 _BUILD_00l0(Data,vrr_stack+2262, vrr_stack+1592, vrr_stack+2226, vrr_stack+12, vrr_stack+40, NULL);
 _BUILD_00m0(Data,vrr_stack+2307, vrr_stack+563, vrr_stack+2262, vrr_stack+146, vrr_stack+1592, NULL);
 _BUILD_00n0(Data,vrr_stack+2226, vrr_stack+263, vrr_stack+2307, vrr_stack+1033, vrr_stack+563, NULL);
 _BUILD_00o0(Data,vrr_stack+1550, vrr_stack+3159, vrr_stack+2226, vrr_stack+508, vrr_stack+263, NULL);
 _BUILD_00q0(Data,vrr_stack+508, vrr_stack+3917, vrr_stack+1550, vrr_stack+5172, vrr_stack+3159, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3159, vrr_stack+6441, vrr_stack+508, vrr_stack+182, vrr_stack+3917, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2226, vrr_stack+3995, vrr_stack+3159, vrr_stack+5238, vrr_stack+6441, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+5172, vrr_stack+6532, vrr_stack+2226, vrr_stack+3054, vrr_stack+3995, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+3054, vrr_stack+6652, vrr_stack+5172, vrr_stack+5329, vrr_stack+6532, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+7757, vrr_stack+4100, vrr_stack+3054, NULL, NULL, vrr_stack+6652);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+8216, vrr_stack+7604, vrr_stack+4100, NULL, NULL, vrr_stack+6169);
   tmp = vrr_stack + 8216;
   target_ptr = Libint->vrr_classes[1][16];
   for(i=0;i<459;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0l0(Data,vrr_stack+5172, vrr_stack+788, vrr_stack+653, vrr_stack+608, vrr_stack+463, vrr_stack+355);
   tmp = vrr_stack + 5172;
   target_ptr = Libint->vrr_classes[2][8];
   for(i=0;i<270;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0m0(Data,vrr_stack+6441, vrr_stack+1253, vrr_stack+1088, vrr_stack+978, vrr_stack+923, vrr_stack+653);
   tmp = vrr_stack + 6441;
   target_ptr = Libint->vrr_classes[2][9];
   for(i=0;i<330;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0n0(Data,vrr_stack+146, vrr_stack+1950, vrr_stack+1752, vrr_stack+1484, vrr_stack+1418, vrr_stack+1088);
   tmp = vrr_stack + 146;
   target_ptr = Libint->vrr_classes[2][10];
   for(i=0;i<396;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0o0(Data,vrr_stack+542, vrr_stack+2638, vrr_stack+2404, vrr_stack+2148, vrr_stack+68, vrr_stack+1752);
   tmp = vrr_stack + 542;
   target_ptr = Libint->vrr_classes[2][11];
   for(i=0;i<468;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0q0(Data,vrr_stack+1010, vrr_stack+3539, vrr_stack+3266, vrr_stack+2963, vrr_stack+2872, vrr_stack+2404);
   tmp = vrr_stack + 1010;
   target_ptr = Libint->vrr_classes[2][12];
   for(i=0;i<546;i++)
     target_ptr[i] += tmp[i];
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1733, vrr_stack+4617, vrr_stack+4302, vrr_stack+3812, vrr_stack+1628, vrr_stack+3266);
   tmp = vrr_stack + 1733;
   target_ptr = Libint->vrr_classes[2][13];
   for(i=0;i<630;i++)
     target_ptr[i] += tmp[i];
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2363, vrr_stack+5809, vrr_stack+5449, vrr_stack+5052, vrr_stack+4932, vrr_stack+4302);
   tmp = vrr_stack + 2363;
   target_ptr = Libint->vrr_classes[2][14];
   for(i=0;i<720;i++)
     target_ptr[i] += tmp[i];
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+4253, vrr_stack+7196, vrr_stack+6788, vrr_stack+6305, vrr_stack+6169, vrr_stack+5449);
   tmp = vrr_stack + 4253;
   target_ptr = Libint->vrr_classes[2][15];
   for(i=0;i<816;i++)
     target_ptr[i] += tmp[i];
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+5442, vrr_stack+8216, vrr_stack+7757, vrr_stack+7604, vrr_stack+4100, vrr_stack+6788);
   tmp = vrr_stack + 5442;
   target_ptr = Libint->vrr_classes[2][16];
   for(i=0;i<918;i++)
     target_ptr[i] += tmp[i];

}

