/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_00pp(Libr12_t *, prim_data *);

  /* Computes (00|pp) integrals for linear R12-methods */

void hrr_grt_order_00pp(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[1][1] = int_stack + 0;
 Libr12->t2vrr_classes[0][1] = int_stack + 9;
 Libr12->t2vrr_classes[0][2] = int_stack + 12;
 Libr12->t1vrr_classes[0][1] = int_stack + 18;
 Libr12->t1vrr_classes[0][2] = int_stack + 21;
 Libr12->rvrr_classes[0][1] = int_stack + 27;
 Libr12->rvrr_classes[0][2] = int_stack + 30;
 Libr12->gvrr_classes[0][1] = int_stack + 36;
 Libr12->gvrr_classes[0][2] = int_stack + 39;
 memset(int_stack,0,45*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 45;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_00pp(Libr12, Data);
   Data++;
 }

 /*--- compute (00|[r12,T2]|pp) ---*/
   t2hrr3_build_pp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+45, int_stack+12, int_stack+9, int_stack+39, int_stack+0, int_stack+36, 0, 0);
     Libr12->te_ptr[3] = int_stack + 45;
 /*--- compute (00|[r12,T1]|pp) ---*/
   hrr3_build_pp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+21, int_stack+18, 1);
     Libr12->te_ptr[2] = int_stack + 0;
 /*--- compute (00||pp) ---*/
   hrr3_build_pp(Libr12->ShellQuartet.CD,int_stack+9, int_stack+30, int_stack+27, 1);
     Libr12->te_ptr[1] = int_stack + 9;
 /*--- compute (00|pp) ---*/
   hrr3_build_pp(Libr12->ShellQuartet.CD,int_stack+18, int_stack+39, int_stack+36, 1);
     Libr12->te_ptr[0] = int_stack + 18;

}
