/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_p0hh(Libr12_t *, prim_data *);

  /* Computes (p0|hh) integrals for linear R12-methods */

void hrr_grt_order_p0hh(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[2][5] = int_stack + 0;
 Libr12->t2vrr_classes[1][5] = int_stack + 126;
 Libr12->gvrr_classes[2][6] = int_stack + 189;
 Libr12->t2vrr_classes[1][6] = int_stack + 357;
 Libr12->gvrr_classes[2][7] = int_stack + 441;
 Libr12->t2vrr_classes[1][7] = int_stack + 657;
 Libr12->gvrr_classes[2][8] = int_stack + 765;
 Libr12->t2vrr_classes[1][8] = int_stack + 1035;
 Libr12->gvrr_classes[2][9] = int_stack + 1170;
 Libr12->t2vrr_classes[1][9] = int_stack + 1500;
 Libr12->t2vrr_classes[1][10] = int_stack + 1665;
 Libr12->t1vrr_classes[1][5] = int_stack + 1863;
 Libr12->t1vrr_classes[1][6] = int_stack + 1926;
 Libr12->t1vrr_classes[1][7] = int_stack + 2010;
 Libr12->t1vrr_classes[1][8] = int_stack + 2118;
 Libr12->t1vrr_classes[1][9] = int_stack + 2253;
 Libr12->t1vrr_classes[1][10] = int_stack + 2418;
 Libr12->rvrr_classes[1][5] = int_stack + 2616;
 Libr12->rvrr_classes[1][6] = int_stack + 2679;
 Libr12->rvrr_classes[1][7] = int_stack + 2763;
 Libr12->rvrr_classes[1][8] = int_stack + 2871;
 Libr12->rvrr_classes[1][9] = int_stack + 3006;
 Libr12->rvrr_classes[1][10] = int_stack + 3171;
 Libr12->gvrr_classes[1][5] = int_stack + 3369;
 Libr12->gvrr_classes[1][6] = int_stack + 3432;
 Libr12->gvrr_classes[1][7] = int_stack + 3516;
 Libr12->gvrr_classes[1][8] = int_stack + 3624;
 Libr12->gvrr_classes[1][9] = int_stack + 3759;
 Libr12->gvrr_classes[1][10] = int_stack + 3924;
 memset(int_stack,0,4122*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 4122;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_p0hh(Libr12, Data);
   Data++;
 }

 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+4122, int_stack+3432, int_stack+3369, 3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+4311, int_stack+3516, int_stack+3432, 3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+4563, int_stack+4311, int_stack+4122, 3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+4941, int_stack+3624, int_stack+3516, 3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+5265, int_stack+4941, int_stack+4311, 3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+5769, int_stack+5265, int_stack+4563, 3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+6399, int_stack+3759, int_stack+3624, 3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+6804, int_stack+6399, int_stack+4941, 3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+7452, int_stack+6804, int_stack+5265, 3);
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+8292, int_stack+7452, int_stack+5769, 3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+9237, int_stack+189, int_stack+0, 6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+9615, int_stack+441, int_stack+189, 6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+10119, int_stack+9615, int_stack+9237, 6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+10875, int_stack+765, int_stack+441, 6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+11523, int_stack+10875, int_stack+9615, 6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+12531, int_stack+11523, int_stack+10119, 6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+13791, int_stack+1170, int_stack+765, 6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+14601, int_stack+13791, int_stack+10875, 6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+15897, int_stack+14601, int_stack+11523, 6);
 /*--- compute (d0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+17577, int_stack+15897, int_stack+12531, 6);
 /*--- compute (p0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+19467, int_stack+3924, int_stack+3759, 3);
 /*--- compute (p0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+19962, int_stack+19467, int_stack+6399, 3);
 /*--- compute (p0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+20772, int_stack+19962, int_stack+6804, 3);
 /*--- compute (p0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+21852, int_stack+20772, int_stack+7452, 3);
 /*--- compute (p0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+23112, int_stack+357, int_stack+126, int_stack+3432, int_stack+0, int_stack+3369, 1, 0);
 /*--- compute (p0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+23301, int_stack+657, int_stack+357, int_stack+3516, int_stack+189, int_stack+3432, 1, 0);
 /*--- compute (p0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+0, int_stack+23301, int_stack+23112, int_stack+4311, int_stack+9237, int_stack+4122, 1, 0);
 /*--- compute (p0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+9237, int_stack+1035, int_stack+657, int_stack+3624, int_stack+441, int_stack+3516, 1, 0);
 /*--- compute (p0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+23553, int_stack+9237, int_stack+23301, int_stack+4941, int_stack+9615, int_stack+4311, 1, 0);
 /*--- compute (p0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+24057, int_stack+23553, int_stack+0, int_stack+5265, int_stack+10119, int_stack+4563, 1, 0);
 /*--- compute (p0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+0, int_stack+1500, int_stack+1035, int_stack+3759, int_stack+765, int_stack+3624, 1, 0);
 /*--- compute (p0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+405, int_stack+0, int_stack+9237, int_stack+6399, int_stack+10875, int_stack+4941, 1, 0);
 /*--- compute (p0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+9237, int_stack+405, int_stack+23553, int_stack+6804, int_stack+11523, int_stack+5265, 1, 0);
 /*--- compute (p0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+23112, int_stack+9237, int_stack+24057, int_stack+7452, int_stack+12531, int_stack+5769, 1, 0);
 /*--- compute (p0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+24057, int_stack+1665, int_stack+1500, int_stack+3924, int_stack+1170, int_stack+3759, 1, 0);
 /*--- compute (p0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1053, int_stack+24057, int_stack+0, int_stack+19467, int_stack+13791, int_stack+6399, 1, 0);
 /*--- compute (p0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+10077, int_stack+1053, int_stack+405, int_stack+19962, int_stack+14601, int_stack+6804, 1, 0);
 /*--- compute (p0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+19467, int_stack+10077, int_stack+9237, int_stack+20772, int_stack+15897, int_stack+7452, 1, 0);
 /*--- compute (p0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+9237, int_stack+1926, int_stack+1863, 3);
 /*--- compute (p0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+9426, int_stack+2010, int_stack+1926, 3);
 /*--- compute (p0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+9678, int_stack+9426, int_stack+9237, 3);
 /*--- compute (p0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+10056, int_stack+2118, int_stack+2010, 3);
 /*--- compute (p0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+10380, int_stack+10056, int_stack+9426, 3);
 /*--- compute (p0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+10884, int_stack+10380, int_stack+9678, 3);
 /*--- compute (p0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+9237, int_stack+2253, int_stack+2118, 3);
 /*--- compute (p0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+11514, int_stack+9237, int_stack+10056, 3);
 /*--- compute (p0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+12162, int_stack+11514, int_stack+10380, 3);
 /*--- compute (p0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+9642, int_stack+12162, int_stack+10884, 3);
 /*--- compute (p0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+10587, int_stack+2418, int_stack+2253, 3);
 /*--- compute (p0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+13002, int_stack+10587, int_stack+9237, 3);
 /*--- compute (p0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+13812, int_stack+13002, int_stack+11514, 3);
 /*--- compute (p0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+10587, int_stack+13812, int_stack+12162, 3);
 /*--- compute (p0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+9237, int_stack+2679, int_stack+2616, 3);
 /*--- compute (p0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+11847, int_stack+2763, int_stack+2679, 3);
 /*--- compute (p0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+12099, int_stack+11847, int_stack+9237, 3);
 /*--- compute (p0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+9237, int_stack+2871, int_stack+2763, 3);
 /*--- compute (p0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+12477, int_stack+9237, int_stack+11847, 3);
 /*--- compute (p0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+12981, int_stack+12477, int_stack+12099, 3);
 /*--- compute (p0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+11847, int_stack+3006, int_stack+2871, 3);
 /*--- compute (p0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+13611, int_stack+11847, int_stack+9237, 3);
 /*--- compute (p0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+14259, int_stack+13611, int_stack+12477, 3);
 /*--- compute (p0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+15099, int_stack+14259, int_stack+12981, 3);
 /*--- compute (p0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+12252, int_stack+3171, int_stack+3006, 3);
 /*--- compute (p0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+12747, int_stack+12252, int_stack+11847, 3);
 /*--- compute (p0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+16044, int_stack+12747, int_stack+13611, 3);
 /*--- compute (p0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+11847, int_stack+16044, int_stack+14259, 3);
 /*--- compute (p0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+16044, int_stack+19467, int_stack+23112, int_stack+21852, int_stack+17577, int_stack+8292, 1, 0);
     Libr12->te_ptr[3] = int_stack + 16044;
 /*--- compute (p0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+23112, int_stack+10587, int_stack+9642, 3);
     Libr12->te_ptr[2] = int_stack + 23112;
 /*--- compute (p0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+17367, int_stack+11847, int_stack+15099, 3);
     Libr12->te_ptr[1] = int_stack + 17367;
 /*--- compute (p0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+18690, int_stack+21852, int_stack+8292, 3);
     Libr12->te_ptr[0] = int_stack + 18690;

}
