/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ks||gs) integrals */

#include <libint/libint.h>
#include "libr12.h"

REALTYPE *_r_build_k0g0_0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (sixo2z)*I1[0] - (sixo4zn)*I4[0] - (fouro4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (sixo2z)*I1[1] - (sixo4zn)*I4[1] - (threeo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (sixo2z)*I1[2] - (sixo4zn)*I4[2] - (threeo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (sixo2z)*I1[3] - (sixo4zn)*I4[3] - (twoo4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (sixo2z)*I1[4] - (sixo4zn)*I4[4] - (twoo4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (sixo2z)*I1[5] - (sixo4zn)*I4[5] - (twoo4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (sixo2z)*I1[6] - (sixo4zn)*I4[6] - (oneo4zn)*I5[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (sixo2z)*I1[7] - (sixo4zn)*I4[7] - (oneo4zn)*I5[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (sixo2z)*I1[8] - (sixo4zn)*I4[8] - (oneo4zn)*I5[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (sixo2z)*I1[9] - (sixo4zn)*I4[9] - (oneo4zn)*I5[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (sixo2z)*I1[10] - (sixo4zn)*I4[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (sixo2z)*I1[11] - (sixo4zn)*I4[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (sixo2z)*I1[12] - (sixo4zn)*I4[12];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (sixo2z)*I1[13] - (sixo4zn)*I4[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (sixo2z)*I1[14] - (sixo4zn)*I4[14];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (fiveo2z)*I1[15] - (fiveo4zn)*I4[15] - (fouro4zn)*I5[10];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (fiveo2z)*I1[16] - (fiveo4zn)*I4[16] - (threeo4zn)*I5[11];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (fiveo2z)*I1[17] - (fiveo4zn)*I4[17] - (threeo4zn)*I5[12];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (fiveo2z)*I1[18] - (fiveo4zn)*I4[18] - (twoo4zn)*I5[13];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (fiveo2z)*I1[19] - (fiveo4zn)*I4[19] - (twoo4zn)*I5[14];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (fiveo2z)*I1[20] - (fiveo4zn)*I4[20] - (twoo4zn)*I5[15];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (fiveo2z)*I1[21] - (fiveo4zn)*I4[21] - (oneo4zn)*I5[16];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (fiveo2z)*I1[22] - (fiveo4zn)*I4[22] - (oneo4zn)*I5[17];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (fiveo2z)*I1[23] - (fiveo4zn)*I4[23] - (oneo4zn)*I5[18];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (fiveo2z)*I1[24] - (fiveo4zn)*I4[24] - (oneo4zn)*I5[19];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (fiveo2z)*I1[25] - (fiveo4zn)*I4[25];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (fiveo2z)*I1[26] - (fiveo4zn)*I4[26];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (fiveo2z)*I1[27] - (fiveo4zn)*I4[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (fiveo2z)*I1[28] - (fiveo4zn)*I4[28];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (fiveo2z)*I1[29] - (fiveo4zn)*I4[29];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (fiveo2z)*I1[30] - (fiveo4zn)*I4[30] - (fouro4zn)*I5[20];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (fiveo2z)*I1[31] - (fiveo4zn)*I4[31] - (threeo4zn)*I5[21];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (fiveo2z)*I1[32] - (fiveo4zn)*I4[32] - (threeo4zn)*I5[22];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (fiveo2z)*I1[33] - (fiveo4zn)*I4[33] - (twoo4zn)*I5[23];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (fiveo2z)*I1[34] - (fiveo4zn)*I4[34] - (twoo4zn)*I5[24];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (fiveo2z)*I1[35] - (fiveo4zn)*I4[35] - (twoo4zn)*I5[25];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (fiveo2z)*I1[36] - (fiveo4zn)*I4[36] - (oneo4zn)*I5[26];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (fiveo2z)*I1[37] - (fiveo4zn)*I4[37] - (oneo4zn)*I5[27];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (fiveo2z)*I1[38] - (fiveo4zn)*I4[38] - (oneo4zn)*I5[28];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (fiveo2z)*I1[39] - (fiveo4zn)*I4[39] - (oneo4zn)*I5[29];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (fiveo2z)*I1[40] - (fiveo4zn)*I4[40];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (fiveo2z)*I1[41] - (fiveo4zn)*I4[41];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (fiveo2z)*I1[42] - (fiveo4zn)*I4[42];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (fiveo2z)*I1[43] - (fiveo4zn)*I4[43];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (fiveo2z)*I1[44] - (fiveo4zn)*I4[44];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45]
        + (fouro2z)*I1[45] - (fouro4zn)*I4[45] - (fouro4zn)*I5[30];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46]
        + (fouro2z)*I1[46] - (fouro4zn)*I4[46] - (threeo4zn)*I5[31];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47]
        + (fouro2z)*I1[47] - (fouro4zn)*I4[47] - (threeo4zn)*I5[32];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48]
        + (fouro2z)*I1[48] - (fouro4zn)*I4[48] - (twoo4zn)*I5[33];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49]
        + (fouro2z)*I1[49] - (fouro4zn)*I4[49] - (twoo4zn)*I5[34];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50]
        + (fouro2z)*I1[50] - (fouro4zn)*I4[50] - (twoo4zn)*I5[35];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51]
        + (fouro2z)*I1[51] - (fouro4zn)*I4[51] - (oneo4zn)*I5[36];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52]
        + (fouro2z)*I1[52] - (fouro4zn)*I4[52] - (oneo4zn)*I5[37];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53]
        + (fouro2z)*I1[53] - (fouro4zn)*I4[53] - (oneo4zn)*I5[38];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54]
        + (fouro2z)*I1[54] - (fouro4zn)*I4[54] - (oneo4zn)*I5[39];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55]
        + (fouro2z)*I1[55] - (fouro4zn)*I4[55];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56]
        + (fouro2z)*I1[56] - (fouro4zn)*I4[56];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57]
        + (fouro2z)*I1[57] - (fouro4zn)*I4[57];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58]
        + (fouro2z)*I1[58] - (fouro4zn)*I4[58];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59]
        + (fouro2z)*I1[59] - (fouro4zn)*I4[59];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60]
        + (fouro2z)*I1[60] - (fouro4zn)*I4[60] - (fouro4zn)*I5[40];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61]
        + (fouro2z)*I1[61] - (fouro4zn)*I4[61] - (threeo4zn)*I5[41];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62]
        + (fouro2z)*I1[62] - (fouro4zn)*I4[62] - (threeo4zn)*I5[42];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63]
        + (fouro2z)*I1[63] - (fouro4zn)*I4[63] - (twoo4zn)*I5[43];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64]
        + (fouro2z)*I1[64] - (fouro4zn)*I4[64] - (twoo4zn)*I5[44];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65]
        + (fouro2z)*I1[65] - (fouro4zn)*I4[65] - (twoo4zn)*I5[45];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66]
        + (fouro2z)*I1[66] - (fouro4zn)*I4[66] - (oneo4zn)*I5[46];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67]
        + (fouro2z)*I1[67] - (fouro4zn)*I4[67] - (oneo4zn)*I5[47];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68]
        + (fouro2z)*I1[68] - (fouro4zn)*I4[68] - (oneo4zn)*I5[48];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69]
        + (fouro2z)*I1[69] - (fouro4zn)*I4[69] - (oneo4zn)*I5[49];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70]
        + (fouro2z)*I1[70] - (fouro4zn)*I4[70];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71]
        + (fouro2z)*I1[71] - (fouro4zn)*I4[71];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72]
        + (fouro2z)*I1[72] - (fouro4zn)*I4[72];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73]
        + (fouro2z)*I1[73] - (fouro4zn)*I4[73];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74]
        + (fouro2z)*I1[74] - (fouro4zn)*I4[74];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75]
        + (fouro2z)*I1[75] - (fouro4zn)*I4[75] - (fouro4zn)*I5[50];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76]
        + (fouro2z)*I1[76] - (fouro4zn)*I4[76] - (threeo4zn)*I5[51];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77]
        + (fouro2z)*I1[77] - (fouro4zn)*I4[77] - (threeo4zn)*I5[52];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78]
        + (fouro2z)*I1[78] - (fouro4zn)*I4[78] - (twoo4zn)*I5[53];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79]
        + (fouro2z)*I1[79] - (fouro4zn)*I4[79] - (twoo4zn)*I5[54];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80]
        + (fouro2z)*I1[80] - (fouro4zn)*I4[80] - (twoo4zn)*I5[55];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81]
        + (fouro2z)*I1[81] - (fouro4zn)*I4[81] - (oneo4zn)*I5[56];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82]
        + (fouro2z)*I1[82] - (fouro4zn)*I4[82] - (oneo4zn)*I5[57];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83]
        + (fouro2z)*I1[83] - (fouro4zn)*I4[83] - (oneo4zn)*I5[58];
*(vp++) = U00*I0[84] - U10*I3[84] + loo2p*I2[84]
        + (fouro2z)*I1[84] - (fouro4zn)*I4[84] - (oneo4zn)*I5[59];
*(vp++) = U00*I0[85] - U10*I3[85] + loo2p*I2[85]
        + (fouro2z)*I1[85] - (fouro4zn)*I4[85];
*(vp++) = U00*I0[86] - U10*I3[86] + loo2p*I2[86]
        + (fouro2z)*I1[86] - (fouro4zn)*I4[86];
*(vp++) = U00*I0[87] - U10*I3[87] + loo2p*I2[87]
        + (fouro2z)*I1[87] - (fouro4zn)*I4[87];
*(vp++) = U00*I0[88] - U10*I3[88] + loo2p*I2[88]
        + (fouro2z)*I1[88] - (fouro4zn)*I4[88];
*(vp++) = U00*I0[89] - U10*I3[89] + loo2p*I2[89]
        + (fouro2z)*I1[89] - (fouro4zn)*I4[89];
*(vp++) = U00*I0[90] - U10*I3[90] + loo2p*I2[90]
        + (threeo2z)*I1[90] - (threeo4zn)*I4[90] - (fouro4zn)*I5[60];
*(vp++) = U00*I0[91] - U10*I3[91] + loo2p*I2[91]
        + (threeo2z)*I1[91] - (threeo4zn)*I4[91] - (threeo4zn)*I5[61];
*(vp++) = U00*I0[92] - U10*I3[92] + loo2p*I2[92]
        + (threeo2z)*I1[92] - (threeo4zn)*I4[92] - (threeo4zn)*I5[62];
*(vp++) = U00*I0[93] - U10*I3[93] + loo2p*I2[93]
        + (threeo2z)*I1[93] - (threeo4zn)*I4[93] - (twoo4zn)*I5[63];
*(vp++) = U00*I0[94] - U10*I3[94] + loo2p*I2[94]
        + (threeo2z)*I1[94] - (threeo4zn)*I4[94] - (twoo4zn)*I5[64];
*(vp++) = U00*I0[95] - U10*I3[95] + loo2p*I2[95]
        + (threeo2z)*I1[95] - (threeo4zn)*I4[95] - (twoo4zn)*I5[65];
*(vp++) = U00*I0[96] - U10*I3[96] + loo2p*I2[96]
        + (threeo2z)*I1[96] - (threeo4zn)*I4[96] - (oneo4zn)*I5[66];
*(vp++) = U00*I0[97] - U10*I3[97] + loo2p*I2[97]
        + (threeo2z)*I1[97] - (threeo4zn)*I4[97] - (oneo4zn)*I5[67];
*(vp++) = U00*I0[98] - U10*I3[98] + loo2p*I2[98]
        + (threeo2z)*I1[98] - (threeo4zn)*I4[98] - (oneo4zn)*I5[68];
*(vp++) = U00*I0[99] - U10*I3[99] + loo2p*I2[99]
        + (threeo2z)*I1[99] - (threeo4zn)*I4[99] - (oneo4zn)*I5[69];
*(vp++) = U00*I0[100] - U10*I3[100] + loo2p*I2[100]
        + (threeo2z)*I1[100] - (threeo4zn)*I4[100];
*(vp++) = U00*I0[101] - U10*I3[101] + loo2p*I2[101]
        + (threeo2z)*I1[101] - (threeo4zn)*I4[101];
*(vp++) = U00*I0[102] - U10*I3[102] + loo2p*I2[102]
        + (threeo2z)*I1[102] - (threeo4zn)*I4[102];
*(vp++) = U00*I0[103] - U10*I3[103] + loo2p*I2[103]
        + (threeo2z)*I1[103] - (threeo4zn)*I4[103];
*(vp++) = U00*I0[104] - U10*I3[104] + loo2p*I2[104]
        + (threeo2z)*I1[104] - (threeo4zn)*I4[104];
*(vp++) = U00*I0[105] - U10*I3[105] + loo2p*I2[105]
        + (threeo2z)*I1[105] - (threeo4zn)*I4[105] - (fouro4zn)*I5[70];
*(vp++) = U00*I0[106] - U10*I3[106] + loo2p*I2[106]
        + (threeo2z)*I1[106] - (threeo4zn)*I4[106] - (threeo4zn)*I5[71];
*(vp++) = U00*I0[107] - U10*I3[107] + loo2p*I2[107]
        + (threeo2z)*I1[107] - (threeo4zn)*I4[107] - (threeo4zn)*I5[72];
*(vp++) = U00*I0[108] - U10*I3[108] + loo2p*I2[108]
        + (threeo2z)*I1[108] - (threeo4zn)*I4[108] - (twoo4zn)*I5[73];
*(vp++) = U00*I0[109] - U10*I3[109] + loo2p*I2[109]
        + (threeo2z)*I1[109] - (threeo4zn)*I4[109] - (twoo4zn)*I5[74];
*(vp++) = U00*I0[110] - U10*I3[110] + loo2p*I2[110]
        + (threeo2z)*I1[110] - (threeo4zn)*I4[110] - (twoo4zn)*I5[75];
*(vp++) = U00*I0[111] - U10*I3[111] + loo2p*I2[111]
        + (threeo2z)*I1[111] - (threeo4zn)*I4[111] - (oneo4zn)*I5[76];
*(vp++) = U00*I0[112] - U10*I3[112] + loo2p*I2[112]
        + (threeo2z)*I1[112] - (threeo4zn)*I4[112] - (oneo4zn)*I5[77];
*(vp++) = U00*I0[113] - U10*I3[113] + loo2p*I2[113]
        + (threeo2z)*I1[113] - (threeo4zn)*I4[113] - (oneo4zn)*I5[78];
*(vp++) = U00*I0[114] - U10*I3[114] + loo2p*I2[114]
        + (threeo2z)*I1[114] - (threeo4zn)*I4[114] - (oneo4zn)*I5[79];
*(vp++) = U00*I0[115] - U10*I3[115] + loo2p*I2[115]
        + (threeo2z)*I1[115] - (threeo4zn)*I4[115];
*(vp++) = U00*I0[116] - U10*I3[116] + loo2p*I2[116]
        + (threeo2z)*I1[116] - (threeo4zn)*I4[116];
*(vp++) = U00*I0[117] - U10*I3[117] + loo2p*I2[117]
        + (threeo2z)*I1[117] - (threeo4zn)*I4[117];
*(vp++) = U00*I0[118] - U10*I3[118] + loo2p*I2[118]
        + (threeo2z)*I1[118] - (threeo4zn)*I4[118];
*(vp++) = U00*I0[119] - U10*I3[119] + loo2p*I2[119]
        + (threeo2z)*I1[119] - (threeo4zn)*I4[119];
*(vp++) = U00*I0[120] - U10*I3[120] + loo2p*I2[120]
        + (threeo2z)*I1[120] - (threeo4zn)*I4[120] - (fouro4zn)*I5[80];
*(vp++) = U00*I0[121] - U10*I3[121] + loo2p*I2[121]
        + (threeo2z)*I1[121] - (threeo4zn)*I4[121] - (threeo4zn)*I5[81];
*(vp++) = U00*I0[122] - U10*I3[122] + loo2p*I2[122]
        + (threeo2z)*I1[122] - (threeo4zn)*I4[122] - (threeo4zn)*I5[82];
*(vp++) = U00*I0[123] - U10*I3[123] + loo2p*I2[123]
        + (threeo2z)*I1[123] - (threeo4zn)*I4[123] - (twoo4zn)*I5[83];
*(vp++) = U00*I0[124] - U10*I3[124] + loo2p*I2[124]
        + (threeo2z)*I1[124] - (threeo4zn)*I4[124] - (twoo4zn)*I5[84];
*(vp++) = U00*I0[125] - U10*I3[125] + loo2p*I2[125]
        + (threeo2z)*I1[125] - (threeo4zn)*I4[125] - (twoo4zn)*I5[85];
*(vp++) = U00*I0[126] - U10*I3[126] + loo2p*I2[126]
        + (threeo2z)*I1[126] - (threeo4zn)*I4[126] - (oneo4zn)*I5[86];
*(vp++) = U00*I0[127] - U10*I3[127] + loo2p*I2[127]
        + (threeo2z)*I1[127] - (threeo4zn)*I4[127] - (oneo4zn)*I5[87];
*(vp++) = U00*I0[128] - U10*I3[128] + loo2p*I2[128]
        + (threeo2z)*I1[128] - (threeo4zn)*I4[128] - (oneo4zn)*I5[88];
*(vp++) = U00*I0[129] - U10*I3[129] + loo2p*I2[129]
        + (threeo2z)*I1[129] - (threeo4zn)*I4[129] - (oneo4zn)*I5[89];
*(vp++) = U00*I0[130] - U10*I3[130] + loo2p*I2[130]
        + (threeo2z)*I1[130] - (threeo4zn)*I4[130];
*(vp++) = U00*I0[131] - U10*I3[131] + loo2p*I2[131]
        + (threeo2z)*I1[131] - (threeo4zn)*I4[131];
*(vp++) = U00*I0[132] - U10*I3[132] + loo2p*I2[132]
        + (threeo2z)*I1[132] - (threeo4zn)*I4[132];
*(vp++) = U00*I0[133] - U10*I3[133] + loo2p*I2[133]
        + (threeo2z)*I1[133] - (threeo4zn)*I4[133];
*(vp++) = U00*I0[134] - U10*I3[134] + loo2p*I2[134]
        + (threeo2z)*I1[134] - (threeo4zn)*I4[134];
*(vp++) = U00*I0[135] - U10*I3[135] + loo2p*I2[135]
        + (threeo2z)*I1[135] - (threeo4zn)*I4[135] - (fouro4zn)*I5[90];
*(vp++) = U00*I0[136] - U10*I3[136] + loo2p*I2[136]
        + (threeo2z)*I1[136] - (threeo4zn)*I4[136] - (threeo4zn)*I5[91];
*(vp++) = U00*I0[137] - U10*I3[137] + loo2p*I2[137]
        + (threeo2z)*I1[137] - (threeo4zn)*I4[137] - (threeo4zn)*I5[92];
*(vp++) = U00*I0[138] - U10*I3[138] + loo2p*I2[138]
        + (threeo2z)*I1[138] - (threeo4zn)*I4[138] - (twoo4zn)*I5[93];
*(vp++) = U00*I0[139] - U10*I3[139] + loo2p*I2[139]
        + (threeo2z)*I1[139] - (threeo4zn)*I4[139] - (twoo4zn)*I5[94];
*(vp++) = U00*I0[140] - U10*I3[140] + loo2p*I2[140]
        + (threeo2z)*I1[140] - (threeo4zn)*I4[140] - (twoo4zn)*I5[95];
*(vp++) = U00*I0[141] - U10*I3[141] + loo2p*I2[141]
        + (threeo2z)*I1[141] - (threeo4zn)*I4[141] - (oneo4zn)*I5[96];
*(vp++) = U00*I0[142] - U10*I3[142] + loo2p*I2[142]
        + (threeo2z)*I1[142] - (threeo4zn)*I4[142] - (oneo4zn)*I5[97];
*(vp++) = U00*I0[143] - U10*I3[143] + loo2p*I2[143]
        + (threeo2z)*I1[143] - (threeo4zn)*I4[143] - (oneo4zn)*I5[98];
*(vp++) = U00*I0[144] - U10*I3[144] + loo2p*I2[144]
        + (threeo2z)*I1[144] - (threeo4zn)*I4[144] - (oneo4zn)*I5[99];
*(vp++) = U00*I0[145] - U10*I3[145] + loo2p*I2[145]
        + (threeo2z)*I1[145] - (threeo4zn)*I4[145];
*(vp++) = U00*I0[146] - U10*I3[146] + loo2p*I2[146]
        + (threeo2z)*I1[146] - (threeo4zn)*I4[146];
*(vp++) = U00*I0[147] - U10*I3[147] + loo2p*I2[147]
        + (threeo2z)*I1[147] - (threeo4zn)*I4[147];
*(vp++) = U00*I0[148] - U10*I3[148] + loo2p*I2[148]
        + (threeo2z)*I1[148] - (threeo4zn)*I4[148];
*(vp++) = U00*I0[149] - U10*I3[149] + loo2p*I2[149]
        + (threeo2z)*I1[149] - (threeo4zn)*I4[149];
*(vp++) = U00*I0[150] - U10*I3[150] + loo2p*I2[150]
        + (twoo2z)*I1[150] - (twoo4zn)*I4[150] - (fouro4zn)*I5[100];
*(vp++) = U00*I0[151] - U10*I3[151] + loo2p*I2[151]
        + (twoo2z)*I1[151] - (twoo4zn)*I4[151] - (threeo4zn)*I5[101];
*(vp++) = U00*I0[152] - U10*I3[152] + loo2p*I2[152]
        + (twoo2z)*I1[152] - (twoo4zn)*I4[152] - (threeo4zn)*I5[102];
*(vp++) = U00*I0[153] - U10*I3[153] + loo2p*I2[153]
        + (twoo2z)*I1[153] - (twoo4zn)*I4[153] - (twoo4zn)*I5[103];
*(vp++) = U00*I0[154] - U10*I3[154] + loo2p*I2[154]
        + (twoo2z)*I1[154] - (twoo4zn)*I4[154] - (twoo4zn)*I5[104];
*(vp++) = U00*I0[155] - U10*I3[155] + loo2p*I2[155]
        + (twoo2z)*I1[155] - (twoo4zn)*I4[155] - (twoo4zn)*I5[105];
*(vp++) = U00*I0[156] - U10*I3[156] + loo2p*I2[156]
        + (twoo2z)*I1[156] - (twoo4zn)*I4[156] - (oneo4zn)*I5[106];
*(vp++) = U00*I0[157] - U10*I3[157] + loo2p*I2[157]
        + (twoo2z)*I1[157] - (twoo4zn)*I4[157] - (oneo4zn)*I5[107];
*(vp++) = U00*I0[158] - U10*I3[158] + loo2p*I2[158]
        + (twoo2z)*I1[158] - (twoo4zn)*I4[158] - (oneo4zn)*I5[108];
*(vp++) = U00*I0[159] - U10*I3[159] + loo2p*I2[159]
        + (twoo2z)*I1[159] - (twoo4zn)*I4[159] - (oneo4zn)*I5[109];
*(vp++) = U00*I0[160] - U10*I3[160] + loo2p*I2[160]
        + (twoo2z)*I1[160] - (twoo4zn)*I4[160];
*(vp++) = U00*I0[161] - U10*I3[161] + loo2p*I2[161]
        + (twoo2z)*I1[161] - (twoo4zn)*I4[161];
*(vp++) = U00*I0[162] - U10*I3[162] + loo2p*I2[162]
        + (twoo2z)*I1[162] - (twoo4zn)*I4[162];
*(vp++) = U00*I0[163] - U10*I3[163] + loo2p*I2[163]
        + (twoo2z)*I1[163] - (twoo4zn)*I4[163];
*(vp++) = U00*I0[164] - U10*I3[164] + loo2p*I2[164]
        + (twoo2z)*I1[164] - (twoo4zn)*I4[164];
*(vp++) = U00*I0[165] - U10*I3[165] + loo2p*I2[165]
        + (twoo2z)*I1[165] - (twoo4zn)*I4[165] - (fouro4zn)*I5[110];
*(vp++) = U00*I0[166] - U10*I3[166] + loo2p*I2[166]
        + (twoo2z)*I1[166] - (twoo4zn)*I4[166] - (threeo4zn)*I5[111];
*(vp++) = U00*I0[167] - U10*I3[167] + loo2p*I2[167]
        + (twoo2z)*I1[167] - (twoo4zn)*I4[167] - (threeo4zn)*I5[112];
*(vp++) = U00*I0[168] - U10*I3[168] + loo2p*I2[168]
        + (twoo2z)*I1[168] - (twoo4zn)*I4[168] - (twoo4zn)*I5[113];
*(vp++) = U00*I0[169] - U10*I3[169] + loo2p*I2[169]
        + (twoo2z)*I1[169] - (twoo4zn)*I4[169] - (twoo4zn)*I5[114];
*(vp++) = U00*I0[170] - U10*I3[170] + loo2p*I2[170]
        + (twoo2z)*I1[170] - (twoo4zn)*I4[170] - (twoo4zn)*I5[115];
*(vp++) = U00*I0[171] - U10*I3[171] + loo2p*I2[171]
        + (twoo2z)*I1[171] - (twoo4zn)*I4[171] - (oneo4zn)*I5[116];
*(vp++) = U00*I0[172] - U10*I3[172] + loo2p*I2[172]
        + (twoo2z)*I1[172] - (twoo4zn)*I4[172] - (oneo4zn)*I5[117];
*(vp++) = U00*I0[173] - U10*I3[173] + loo2p*I2[173]
        + (twoo2z)*I1[173] - (twoo4zn)*I4[173] - (oneo4zn)*I5[118];
*(vp++) = U00*I0[174] - U10*I3[174] + loo2p*I2[174]
        + (twoo2z)*I1[174] - (twoo4zn)*I4[174] - (oneo4zn)*I5[119];
*(vp++) = U00*I0[175] - U10*I3[175] + loo2p*I2[175]
        + (twoo2z)*I1[175] - (twoo4zn)*I4[175];
*(vp++) = U00*I0[176] - U10*I3[176] + loo2p*I2[176]
        + (twoo2z)*I1[176] - (twoo4zn)*I4[176];
*(vp++) = U00*I0[177] - U10*I3[177] + loo2p*I2[177]
        + (twoo2z)*I1[177] - (twoo4zn)*I4[177];
*(vp++) = U00*I0[178] - U10*I3[178] + loo2p*I2[178]
        + (twoo2z)*I1[178] - (twoo4zn)*I4[178];
*(vp++) = U00*I0[179] - U10*I3[179] + loo2p*I2[179]
        + (twoo2z)*I1[179] - (twoo4zn)*I4[179];
*(vp++) = U00*I0[180] - U10*I3[180] + loo2p*I2[180]
        + (twoo2z)*I1[180] - (twoo4zn)*I4[180] - (fouro4zn)*I5[120];
*(vp++) = U00*I0[181] - U10*I3[181] + loo2p*I2[181]
        + (twoo2z)*I1[181] - (twoo4zn)*I4[181] - (threeo4zn)*I5[121];
*(vp++) = U00*I0[182] - U10*I3[182] + loo2p*I2[182]
        + (twoo2z)*I1[182] - (twoo4zn)*I4[182] - (threeo4zn)*I5[122];
*(vp++) = U00*I0[183] - U10*I3[183] + loo2p*I2[183]
        + (twoo2z)*I1[183] - (twoo4zn)*I4[183] - (twoo4zn)*I5[123];
*(vp++) = U00*I0[184] - U10*I3[184] + loo2p*I2[184]
        + (twoo2z)*I1[184] - (twoo4zn)*I4[184] - (twoo4zn)*I5[124];
*(vp++) = U00*I0[185] - U10*I3[185] + loo2p*I2[185]
        + (twoo2z)*I1[185] - (twoo4zn)*I4[185] - (twoo4zn)*I5[125];
*(vp++) = U00*I0[186] - U10*I3[186] + loo2p*I2[186]
        + (twoo2z)*I1[186] - (twoo4zn)*I4[186] - (oneo4zn)*I5[126];
*(vp++) = U00*I0[187] - U10*I3[187] + loo2p*I2[187]
        + (twoo2z)*I1[187] - (twoo4zn)*I4[187] - (oneo4zn)*I5[127];
*(vp++) = U00*I0[188] - U10*I3[188] + loo2p*I2[188]
        + (twoo2z)*I1[188] - (twoo4zn)*I4[188] - (oneo4zn)*I5[128];
*(vp++) = U00*I0[189] - U10*I3[189] + loo2p*I2[189]
        + (twoo2z)*I1[189] - (twoo4zn)*I4[189] - (oneo4zn)*I5[129];
*(vp++) = U00*I0[190] - U10*I3[190] + loo2p*I2[190]
        + (twoo2z)*I1[190] - (twoo4zn)*I4[190];
*(vp++) = U00*I0[191] - U10*I3[191] + loo2p*I2[191]
        + (twoo2z)*I1[191] - (twoo4zn)*I4[191];
*(vp++) = U00*I0[192] - U10*I3[192] + loo2p*I2[192]
        + (twoo2z)*I1[192] - (twoo4zn)*I4[192];
*(vp++) = U00*I0[193] - U10*I3[193] + loo2p*I2[193]
        + (twoo2z)*I1[193] - (twoo4zn)*I4[193];
*(vp++) = U00*I0[194] - U10*I3[194] + loo2p*I2[194]
        + (twoo2z)*I1[194] - (twoo4zn)*I4[194];
*(vp++) = U00*I0[195] - U10*I3[195] + loo2p*I2[195]
        + (twoo2z)*I1[195] - (twoo4zn)*I4[195] - (fouro4zn)*I5[130];
*(vp++) = U00*I0[196] - U10*I3[196] + loo2p*I2[196]
        + (twoo2z)*I1[196] - (twoo4zn)*I4[196] - (threeo4zn)*I5[131];
*(vp++) = U00*I0[197] - U10*I3[197] + loo2p*I2[197]
        + (twoo2z)*I1[197] - (twoo4zn)*I4[197] - (threeo4zn)*I5[132];
*(vp++) = U00*I0[198] - U10*I3[198] + loo2p*I2[198]
        + (twoo2z)*I1[198] - (twoo4zn)*I4[198] - (twoo4zn)*I5[133];
*(vp++) = U00*I0[199] - U10*I3[199] + loo2p*I2[199]
        + (twoo2z)*I1[199] - (twoo4zn)*I4[199] - (twoo4zn)*I5[134];
*(vp++) = U00*I0[200] - U10*I3[200] + loo2p*I2[200]
        + (twoo2z)*I1[200] - (twoo4zn)*I4[200] - (twoo4zn)*I5[135];
*(vp++) = U00*I0[201] - U10*I3[201] + loo2p*I2[201]
        + (twoo2z)*I1[201] - (twoo4zn)*I4[201] - (oneo4zn)*I5[136];
*(vp++) = U00*I0[202] - U10*I3[202] + loo2p*I2[202]
        + (twoo2z)*I1[202] - (twoo4zn)*I4[202] - (oneo4zn)*I5[137];
*(vp++) = U00*I0[203] - U10*I3[203] + loo2p*I2[203]
        + (twoo2z)*I1[203] - (twoo4zn)*I4[203] - (oneo4zn)*I5[138];
*(vp++) = U00*I0[204] - U10*I3[204] + loo2p*I2[204]
        + (twoo2z)*I1[204] - (twoo4zn)*I4[204] - (oneo4zn)*I5[139];
*(vp++) = U00*I0[205] - U10*I3[205] + loo2p*I2[205]
        + (twoo2z)*I1[205] - (twoo4zn)*I4[205];
*(vp++) = U00*I0[206] - U10*I3[206] + loo2p*I2[206]
        + (twoo2z)*I1[206] - (twoo4zn)*I4[206];
*(vp++) = U00*I0[207] - U10*I3[207] + loo2p*I2[207]
        + (twoo2z)*I1[207] - (twoo4zn)*I4[207];
*(vp++) = U00*I0[208] - U10*I3[208] + loo2p*I2[208]
        + (twoo2z)*I1[208] - (twoo4zn)*I4[208];
*(vp++) = U00*I0[209] - U10*I3[209] + loo2p*I2[209]
        + (twoo2z)*I1[209] - (twoo4zn)*I4[209];
*(vp++) = U00*I0[210] - U10*I3[210] + loo2p*I2[210]
        + (twoo2z)*I1[210] - (twoo4zn)*I4[210] - (fouro4zn)*I5[140];
*(vp++) = U00*I0[211] - U10*I3[211] + loo2p*I2[211]
        + (twoo2z)*I1[211] - (twoo4zn)*I4[211] - (threeo4zn)*I5[141];
*(vp++) = U00*I0[212] - U10*I3[212] + loo2p*I2[212]
        + (twoo2z)*I1[212] - (twoo4zn)*I4[212] - (threeo4zn)*I5[142];
*(vp++) = U00*I0[213] - U10*I3[213] + loo2p*I2[213]
        + (twoo2z)*I1[213] - (twoo4zn)*I4[213] - (twoo4zn)*I5[143];
*(vp++) = U00*I0[214] - U10*I3[214] + loo2p*I2[214]
        + (twoo2z)*I1[214] - (twoo4zn)*I4[214] - (twoo4zn)*I5[144];
*(vp++) = U00*I0[215] - U10*I3[215] + loo2p*I2[215]
        + (twoo2z)*I1[215] - (twoo4zn)*I4[215] - (twoo4zn)*I5[145];
*(vp++) = U00*I0[216] - U10*I3[216] + loo2p*I2[216]
        + (twoo2z)*I1[216] - (twoo4zn)*I4[216] - (oneo4zn)*I5[146];
*(vp++) = U00*I0[217] - U10*I3[217] + loo2p*I2[217]
        + (twoo2z)*I1[217] - (twoo4zn)*I4[217] - (oneo4zn)*I5[147];
*(vp++) = U00*I0[218] - U10*I3[218] + loo2p*I2[218]
        + (twoo2z)*I1[218] - (twoo4zn)*I4[218] - (oneo4zn)*I5[148];
*(vp++) = U00*I0[219] - U10*I3[219] + loo2p*I2[219]
        + (twoo2z)*I1[219] - (twoo4zn)*I4[219] - (oneo4zn)*I5[149];
*(vp++) = U00*I0[220] - U10*I3[220] + loo2p*I2[220]
        + (twoo2z)*I1[220] - (twoo4zn)*I4[220];
*(vp++) = U00*I0[221] - U10*I3[221] + loo2p*I2[221]
        + (twoo2z)*I1[221] - (twoo4zn)*I4[221];
*(vp++) = U00*I0[222] - U10*I3[222] + loo2p*I2[222]
        + (twoo2z)*I1[222] - (twoo4zn)*I4[222];
*(vp++) = U00*I0[223] - U10*I3[223] + loo2p*I2[223]
        + (twoo2z)*I1[223] - (twoo4zn)*I4[223];
*(vp++) = U00*I0[224] - U10*I3[224] + loo2p*I2[224]
        + (twoo2z)*I1[224] - (twoo4zn)*I4[224];
*(vp++) = U00*I0[225] - U10*I3[225] + loo2p*I2[225]
        + (oneo2z)*I1[225] - (oneo4zn)*I4[225] - (fouro4zn)*I5[150];
*(vp++) = U00*I0[226] - U10*I3[226] + loo2p*I2[226]
        + (oneo2z)*I1[226] - (oneo4zn)*I4[226] - (threeo4zn)*I5[151];
*(vp++) = U00*I0[227] - U10*I3[227] + loo2p*I2[227]
        + (oneo2z)*I1[227] - (oneo4zn)*I4[227] - (threeo4zn)*I5[152];
*(vp++) = U00*I0[228] - U10*I3[228] + loo2p*I2[228]
        + (oneo2z)*I1[228] - (oneo4zn)*I4[228] - (twoo4zn)*I5[153];
*(vp++) = U00*I0[229] - U10*I3[229] + loo2p*I2[229]
        + (oneo2z)*I1[229] - (oneo4zn)*I4[229] - (twoo4zn)*I5[154];
*(vp++) = U00*I0[230] - U10*I3[230] + loo2p*I2[230]
        + (oneo2z)*I1[230] - (oneo4zn)*I4[230] - (twoo4zn)*I5[155];
*(vp++) = U00*I0[231] - U10*I3[231] + loo2p*I2[231]
        + (oneo2z)*I1[231] - (oneo4zn)*I4[231] - (oneo4zn)*I5[156];
*(vp++) = U00*I0[232] - U10*I3[232] + loo2p*I2[232]
        + (oneo2z)*I1[232] - (oneo4zn)*I4[232] - (oneo4zn)*I5[157];
*(vp++) = U00*I0[233] - U10*I3[233] + loo2p*I2[233]
        + (oneo2z)*I1[233] - (oneo4zn)*I4[233] - (oneo4zn)*I5[158];
*(vp++) = U00*I0[234] - U10*I3[234] + loo2p*I2[234]
        + (oneo2z)*I1[234] - (oneo4zn)*I4[234] - (oneo4zn)*I5[159];
*(vp++) = U00*I0[235] - U10*I3[235] + loo2p*I2[235]
        + (oneo2z)*I1[235] - (oneo4zn)*I4[235];
*(vp++) = U00*I0[236] - U10*I3[236] + loo2p*I2[236]
        + (oneo2z)*I1[236] - (oneo4zn)*I4[236];
*(vp++) = U00*I0[237] - U10*I3[237] + loo2p*I2[237]
        + (oneo2z)*I1[237] - (oneo4zn)*I4[237];
*(vp++) = U00*I0[238] - U10*I3[238] + loo2p*I2[238]
        + (oneo2z)*I1[238] - (oneo4zn)*I4[238];
*(vp++) = U00*I0[239] - U10*I3[239] + loo2p*I2[239]
        + (oneo2z)*I1[239] - (oneo4zn)*I4[239];
*(vp++) = U00*I0[240] - U10*I3[240] + loo2p*I2[240]
        + (oneo2z)*I1[240] - (oneo4zn)*I4[240] - (fouro4zn)*I5[160];
*(vp++) = U00*I0[241] - U10*I3[241] + loo2p*I2[241]
        + (oneo2z)*I1[241] - (oneo4zn)*I4[241] - (threeo4zn)*I5[161];
*(vp++) = U00*I0[242] - U10*I3[242] + loo2p*I2[242]
        + (oneo2z)*I1[242] - (oneo4zn)*I4[242] - (threeo4zn)*I5[162];
*(vp++) = U00*I0[243] - U10*I3[243] + loo2p*I2[243]
        + (oneo2z)*I1[243] - (oneo4zn)*I4[243] - (twoo4zn)*I5[163];
*(vp++) = U00*I0[244] - U10*I3[244] + loo2p*I2[244]
        + (oneo2z)*I1[244] - (oneo4zn)*I4[244] - (twoo4zn)*I5[164];
*(vp++) = U00*I0[245] - U10*I3[245] + loo2p*I2[245]
        + (oneo2z)*I1[245] - (oneo4zn)*I4[245] - (twoo4zn)*I5[165];
*(vp++) = U00*I0[246] - U10*I3[246] + loo2p*I2[246]
        + (oneo2z)*I1[246] - (oneo4zn)*I4[246] - (oneo4zn)*I5[166];
*(vp++) = U00*I0[247] - U10*I3[247] + loo2p*I2[247]
        + (oneo2z)*I1[247] - (oneo4zn)*I4[247] - (oneo4zn)*I5[167];
*(vp++) = U00*I0[248] - U10*I3[248] + loo2p*I2[248]
        + (oneo2z)*I1[248] - (oneo4zn)*I4[248] - (oneo4zn)*I5[168];
*(vp++) = U00*I0[249] - U10*I3[249] + loo2p*I2[249]
        + (oneo2z)*I1[249] - (oneo4zn)*I4[249] - (oneo4zn)*I5[169];
*(vp++) = U00*I0[250] - U10*I3[250] + loo2p*I2[250]
        + (oneo2z)*I1[250] - (oneo4zn)*I4[250];
*(vp++) = U00*I0[251] - U10*I3[251] + loo2p*I2[251]
        + (oneo2z)*I1[251] - (oneo4zn)*I4[251];
*(vp++) = U00*I0[252] - U10*I3[252] + loo2p*I2[252]
        + (oneo2z)*I1[252] - (oneo4zn)*I4[252];
*(vp++) = U00*I0[253] - U10*I3[253] + loo2p*I2[253]
        + (oneo2z)*I1[253] - (oneo4zn)*I4[253];
*(vp++) = U00*I0[254] - U10*I3[254] + loo2p*I2[254]
        + (oneo2z)*I1[254] - (oneo4zn)*I4[254];
*(vp++) = U00*I0[255] - U10*I3[255] + loo2p*I2[255]
        + (oneo2z)*I1[255] - (oneo4zn)*I4[255] - (fouro4zn)*I5[170];
*(vp++) = U00*I0[256] - U10*I3[256] + loo2p*I2[256]
        + (oneo2z)*I1[256] - (oneo4zn)*I4[256] - (threeo4zn)*I5[171];
*(vp++) = U00*I0[257] - U10*I3[257] + loo2p*I2[257]
        + (oneo2z)*I1[257] - (oneo4zn)*I4[257] - (threeo4zn)*I5[172];
*(vp++) = U00*I0[258] - U10*I3[258] + loo2p*I2[258]
        + (oneo2z)*I1[258] - (oneo4zn)*I4[258] - (twoo4zn)*I5[173];
*(vp++) = U00*I0[259] - U10*I3[259] + loo2p*I2[259]
        + (oneo2z)*I1[259] - (oneo4zn)*I4[259] - (twoo4zn)*I5[174];
*(vp++) = U00*I0[260] - U10*I3[260] + loo2p*I2[260]
        + (oneo2z)*I1[260] - (oneo4zn)*I4[260] - (twoo4zn)*I5[175];
*(vp++) = U00*I0[261] - U10*I3[261] + loo2p*I2[261]
        + (oneo2z)*I1[261] - (oneo4zn)*I4[261] - (oneo4zn)*I5[176];
*(vp++) = U00*I0[262] - U10*I3[262] + loo2p*I2[262]
        + (oneo2z)*I1[262] - (oneo4zn)*I4[262] - (oneo4zn)*I5[177];
*(vp++) = U00*I0[263] - U10*I3[263] + loo2p*I2[263]
        + (oneo2z)*I1[263] - (oneo4zn)*I4[263] - (oneo4zn)*I5[178];
*(vp++) = U00*I0[264] - U10*I3[264] + loo2p*I2[264]
        + (oneo2z)*I1[264] - (oneo4zn)*I4[264] - (oneo4zn)*I5[179];
*(vp++) = U00*I0[265] - U10*I3[265] + loo2p*I2[265]
        + (oneo2z)*I1[265] - (oneo4zn)*I4[265];
*(vp++) = U00*I0[266] - U10*I3[266] + loo2p*I2[266]
        + (oneo2z)*I1[266] - (oneo4zn)*I4[266];
*(vp++) = U00*I0[267] - U10*I3[267] + loo2p*I2[267]
        + (oneo2z)*I1[267] - (oneo4zn)*I4[267];
*(vp++) = U00*I0[268] - U10*I3[268] + loo2p*I2[268]
        + (oneo2z)*I1[268] - (oneo4zn)*I4[268];
*(vp++) = U00*I0[269] - U10*I3[269] + loo2p*I2[269]
        + (oneo2z)*I1[269] - (oneo4zn)*I4[269];
*(vp++) = U00*I0[270] - U10*I3[270] + loo2p*I2[270]
        + (oneo2z)*I1[270] - (oneo4zn)*I4[270] - (fouro4zn)*I5[180];
return vp;
}

REALTYPE *_r_build_k0g0_1(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[271] - U10*I3[271] + loo2p*I2[271]
        + (oneo2z)*I1[271] - (oneo4zn)*I4[271] - (threeo4zn)*I5[181];
*(vp++) = U00*I0[272] - U10*I3[272] + loo2p*I2[272]
        + (oneo2z)*I1[272] - (oneo4zn)*I4[272] - (threeo4zn)*I5[182];
*(vp++) = U00*I0[273] - U10*I3[273] + loo2p*I2[273]
        + (oneo2z)*I1[273] - (oneo4zn)*I4[273] - (twoo4zn)*I5[183];
*(vp++) = U00*I0[274] - U10*I3[274] + loo2p*I2[274]
        + (oneo2z)*I1[274] - (oneo4zn)*I4[274] - (twoo4zn)*I5[184];
*(vp++) = U00*I0[275] - U10*I3[275] + loo2p*I2[275]
        + (oneo2z)*I1[275] - (oneo4zn)*I4[275] - (twoo4zn)*I5[185];
*(vp++) = U00*I0[276] - U10*I3[276] + loo2p*I2[276]
        + (oneo2z)*I1[276] - (oneo4zn)*I4[276] - (oneo4zn)*I5[186];
*(vp++) = U00*I0[277] - U10*I3[277] + loo2p*I2[277]
        + (oneo2z)*I1[277] - (oneo4zn)*I4[277] - (oneo4zn)*I5[187];
*(vp++) = U00*I0[278] - U10*I3[278] + loo2p*I2[278]
        + (oneo2z)*I1[278] - (oneo4zn)*I4[278] - (oneo4zn)*I5[188];
*(vp++) = U00*I0[279] - U10*I3[279] + loo2p*I2[279]
        + (oneo2z)*I1[279] - (oneo4zn)*I4[279] - (oneo4zn)*I5[189];
*(vp++) = U00*I0[280] - U10*I3[280] + loo2p*I2[280]
        + (oneo2z)*I1[280] - (oneo4zn)*I4[280];
*(vp++) = U00*I0[281] - U10*I3[281] + loo2p*I2[281]
        + (oneo2z)*I1[281] - (oneo4zn)*I4[281];
*(vp++) = U00*I0[282] - U10*I3[282] + loo2p*I2[282]
        + (oneo2z)*I1[282] - (oneo4zn)*I4[282];
*(vp++) = U00*I0[283] - U10*I3[283] + loo2p*I2[283]
        + (oneo2z)*I1[283] - (oneo4zn)*I4[283];
*(vp++) = U00*I0[284] - U10*I3[284] + loo2p*I2[284]
        + (oneo2z)*I1[284] - (oneo4zn)*I4[284];
*(vp++) = U00*I0[285] - U10*I3[285] + loo2p*I2[285]
        + (oneo2z)*I1[285] - (oneo4zn)*I4[285] - (fouro4zn)*I5[190];
*(vp++) = U00*I0[286] - U10*I3[286] + loo2p*I2[286]
        + (oneo2z)*I1[286] - (oneo4zn)*I4[286] - (threeo4zn)*I5[191];
*(vp++) = U00*I0[287] - U10*I3[287] + loo2p*I2[287]
        + (oneo2z)*I1[287] - (oneo4zn)*I4[287] - (threeo4zn)*I5[192];
*(vp++) = U00*I0[288] - U10*I3[288] + loo2p*I2[288]
        + (oneo2z)*I1[288] - (oneo4zn)*I4[288] - (twoo4zn)*I5[193];
*(vp++) = U00*I0[289] - U10*I3[289] + loo2p*I2[289]
        + (oneo2z)*I1[289] - (oneo4zn)*I4[289] - (twoo4zn)*I5[194];
*(vp++) = U00*I0[290] - U10*I3[290] + loo2p*I2[290]
        + (oneo2z)*I1[290] - (oneo4zn)*I4[290] - (twoo4zn)*I5[195];
*(vp++) = U00*I0[291] - U10*I3[291] + loo2p*I2[291]
        + (oneo2z)*I1[291] - (oneo4zn)*I4[291] - (oneo4zn)*I5[196];
*(vp++) = U00*I0[292] - U10*I3[292] + loo2p*I2[292]
        + (oneo2z)*I1[292] - (oneo4zn)*I4[292] - (oneo4zn)*I5[197];
*(vp++) = U00*I0[293] - U10*I3[293] + loo2p*I2[293]
        + (oneo2z)*I1[293] - (oneo4zn)*I4[293] - (oneo4zn)*I5[198];
*(vp++) = U00*I0[294] - U10*I3[294] + loo2p*I2[294]
        + (oneo2z)*I1[294] - (oneo4zn)*I4[294] - (oneo4zn)*I5[199];
*(vp++) = U00*I0[295] - U10*I3[295] + loo2p*I2[295]
        + (oneo2z)*I1[295] - (oneo4zn)*I4[295];
*(vp++) = U00*I0[296] - U10*I3[296] + loo2p*I2[296]
        + (oneo2z)*I1[296] - (oneo4zn)*I4[296];
*(vp++) = U00*I0[297] - U10*I3[297] + loo2p*I2[297]
        + (oneo2z)*I1[297] - (oneo4zn)*I4[297];
*(vp++) = U00*I0[298] - U10*I3[298] + loo2p*I2[298]
        + (oneo2z)*I1[298] - (oneo4zn)*I4[298];
*(vp++) = U00*I0[299] - U10*I3[299] + loo2p*I2[299]
        + (oneo2z)*I1[299] - (oneo4zn)*I4[299];
*(vp++) = U00*I0[300] - U10*I3[300] + loo2p*I2[300]
        + (oneo2z)*I1[300] - (oneo4zn)*I4[300] - (fouro4zn)*I5[200];
*(vp++) = U00*I0[301] - U10*I3[301] + loo2p*I2[301]
        + (oneo2z)*I1[301] - (oneo4zn)*I4[301] - (threeo4zn)*I5[201];
*(vp++) = U00*I0[302] - U10*I3[302] + loo2p*I2[302]
        + (oneo2z)*I1[302] - (oneo4zn)*I4[302] - (threeo4zn)*I5[202];
*(vp++) = U00*I0[303] - U10*I3[303] + loo2p*I2[303]
        + (oneo2z)*I1[303] - (oneo4zn)*I4[303] - (twoo4zn)*I5[203];
*(vp++) = U00*I0[304] - U10*I3[304] + loo2p*I2[304]
        + (oneo2z)*I1[304] - (oneo4zn)*I4[304] - (twoo4zn)*I5[204];
*(vp++) = U00*I0[305] - U10*I3[305] + loo2p*I2[305]
        + (oneo2z)*I1[305] - (oneo4zn)*I4[305] - (twoo4zn)*I5[205];
*(vp++) = U00*I0[306] - U10*I3[306] + loo2p*I2[306]
        + (oneo2z)*I1[306] - (oneo4zn)*I4[306] - (oneo4zn)*I5[206];
*(vp++) = U00*I0[307] - U10*I3[307] + loo2p*I2[307]
        + (oneo2z)*I1[307] - (oneo4zn)*I4[307] - (oneo4zn)*I5[207];
*(vp++) = U00*I0[308] - U10*I3[308] + loo2p*I2[308]
        + (oneo2z)*I1[308] - (oneo4zn)*I4[308] - (oneo4zn)*I5[208];
*(vp++) = U00*I0[309] - U10*I3[309] + loo2p*I2[309]
        + (oneo2z)*I1[309] - (oneo4zn)*I4[309] - (oneo4zn)*I5[209];
*(vp++) = U00*I0[310] - U10*I3[310] + loo2p*I2[310]
        + (oneo2z)*I1[310] - (oneo4zn)*I4[310];
*(vp++) = U00*I0[311] - U10*I3[311] + loo2p*I2[311]
        + (oneo2z)*I1[311] - (oneo4zn)*I4[311];
*(vp++) = U00*I0[312] - U10*I3[312] + loo2p*I2[312]
        + (oneo2z)*I1[312] - (oneo4zn)*I4[312];
*(vp++) = U00*I0[313] - U10*I3[313] + loo2p*I2[313]
        + (oneo2z)*I1[313] - (oneo4zn)*I4[313];
*(vp++) = U00*I0[314] - U10*I3[314] + loo2p*I2[314]
        + (oneo2z)*I1[314] - (oneo4zn)*I4[314];
*(vp++) = U00*I0[315] - U10*I3[315] + loo2p*I2[315] - (fouro4zn)*I5[210];
*(vp++) = U00*I0[316] - U10*I3[316] + loo2p*I2[316] - (threeo4zn)*I5[211];
*(vp++) = U00*I0[317] - U10*I3[317] + loo2p*I2[317] - (threeo4zn)*I5[212];
*(vp++) = U00*I0[318] - U10*I3[318] + loo2p*I2[318] - (twoo4zn)*I5[213];
*(vp++) = U00*I0[319] - U10*I3[319] + loo2p*I2[319] - (twoo4zn)*I5[214];
*(vp++) = U00*I0[320] - U10*I3[320] + loo2p*I2[320] - (twoo4zn)*I5[215];
*(vp++) = U00*I0[321] - U10*I3[321] + loo2p*I2[321] - (oneo4zn)*I5[216];
*(vp++) = U00*I0[322] - U10*I3[322] + loo2p*I2[322] - (oneo4zn)*I5[217];
*(vp++) = U00*I0[323] - U10*I3[323] + loo2p*I2[323] - (oneo4zn)*I5[218];
*(vp++) = U00*I0[324] - U10*I3[324] + loo2p*I2[324] - (oneo4zn)*I5[219];
*(vp++) = U00*I0[325] - U10*I3[325] + loo2p*I2[325];
*(vp++) = U00*I0[326] - U10*I3[326] + loo2p*I2[326];
*(vp++) = U00*I0[327] - U10*I3[327] + loo2p*I2[327];
*(vp++) = U00*I0[328] - U10*I3[328] + loo2p*I2[328];
*(vp++) = U00*I0[329] - U10*I3[329] + loo2p*I2[329];
*(vp++) = U00*I0[330] - U10*I3[330] + loo2p*I2[330] - (fouro4zn)*I5[220];
*(vp++) = U00*I0[331] - U10*I3[331] + loo2p*I2[331] - (threeo4zn)*I5[221];
*(vp++) = U00*I0[332] - U10*I3[332] + loo2p*I2[332] - (threeo4zn)*I5[222];
*(vp++) = U00*I0[333] - U10*I3[333] + loo2p*I2[333] - (twoo4zn)*I5[223];
*(vp++) = U00*I0[334] - U10*I3[334] + loo2p*I2[334] - (twoo4zn)*I5[224];
*(vp++) = U00*I0[335] - U10*I3[335] + loo2p*I2[335] - (twoo4zn)*I5[225];
*(vp++) = U00*I0[336] - U10*I3[336] + loo2p*I2[336] - (oneo4zn)*I5[226];
*(vp++) = U00*I0[337] - U10*I3[337] + loo2p*I2[337] - (oneo4zn)*I5[227];
*(vp++) = U00*I0[338] - U10*I3[338] + loo2p*I2[338] - (oneo4zn)*I5[228];
*(vp++) = U00*I0[339] - U10*I3[339] + loo2p*I2[339] - (oneo4zn)*I5[229];
*(vp++) = U00*I0[340] - U10*I3[340] + loo2p*I2[340];
*(vp++) = U00*I0[341] - U10*I3[341] + loo2p*I2[341];
*(vp++) = U00*I0[342] - U10*I3[342] + loo2p*I2[342];
*(vp++) = U00*I0[343] - U10*I3[343] + loo2p*I2[343];
*(vp++) = U00*I0[344] - U10*I3[344] + loo2p*I2[344];
*(vp++) = U00*I0[345] - U10*I3[345] + loo2p*I2[345] - (fouro4zn)*I5[230];
*(vp++) = U00*I0[346] - U10*I3[346] + loo2p*I2[346] - (threeo4zn)*I5[231];
*(vp++) = U00*I0[347] - U10*I3[347] + loo2p*I2[347] - (threeo4zn)*I5[232];
*(vp++) = U00*I0[348] - U10*I3[348] + loo2p*I2[348] - (twoo4zn)*I5[233];
*(vp++) = U00*I0[349] - U10*I3[349] + loo2p*I2[349] - (twoo4zn)*I5[234];
*(vp++) = U00*I0[350] - U10*I3[350] + loo2p*I2[350] - (twoo4zn)*I5[235];
*(vp++) = U00*I0[351] - U10*I3[351] + loo2p*I2[351] - (oneo4zn)*I5[236];
*(vp++) = U00*I0[352] - U10*I3[352] + loo2p*I2[352] - (oneo4zn)*I5[237];
*(vp++) = U00*I0[353] - U10*I3[353] + loo2p*I2[353] - (oneo4zn)*I5[238];
*(vp++) = U00*I0[354] - U10*I3[354] + loo2p*I2[354] - (oneo4zn)*I5[239];
*(vp++) = U00*I0[355] - U10*I3[355] + loo2p*I2[355];
*(vp++) = U00*I0[356] - U10*I3[356] + loo2p*I2[356];
*(vp++) = U00*I0[357] - U10*I3[357] + loo2p*I2[357];
*(vp++) = U00*I0[358] - U10*I3[358] + loo2p*I2[358];
*(vp++) = U00*I0[359] - U10*I3[359] + loo2p*I2[359];
*(vp++) = U00*I0[360] - U10*I3[360] + loo2p*I2[360] - (fouro4zn)*I5[240];
*(vp++) = U00*I0[361] - U10*I3[361] + loo2p*I2[361] - (threeo4zn)*I5[241];
*(vp++) = U00*I0[362] - U10*I3[362] + loo2p*I2[362] - (threeo4zn)*I5[242];
*(vp++) = U00*I0[363] - U10*I3[363] + loo2p*I2[363] - (twoo4zn)*I5[243];
*(vp++) = U00*I0[364] - U10*I3[364] + loo2p*I2[364] - (twoo4zn)*I5[244];
*(vp++) = U00*I0[365] - U10*I3[365] + loo2p*I2[365] - (twoo4zn)*I5[245];
*(vp++) = U00*I0[366] - U10*I3[366] + loo2p*I2[366] - (oneo4zn)*I5[246];
*(vp++) = U00*I0[367] - U10*I3[367] + loo2p*I2[367] - (oneo4zn)*I5[247];
*(vp++) = U00*I0[368] - U10*I3[368] + loo2p*I2[368] - (oneo4zn)*I5[248];
*(vp++) = U00*I0[369] - U10*I3[369] + loo2p*I2[369] - (oneo4zn)*I5[249];
*(vp++) = U00*I0[370] - U10*I3[370] + loo2p*I2[370];
*(vp++) = U00*I0[371] - U10*I3[371] + loo2p*I2[371];
*(vp++) = U00*I0[372] - U10*I3[372] + loo2p*I2[372];
*(vp++) = U00*I0[373] - U10*I3[373] + loo2p*I2[373];
*(vp++) = U00*I0[374] - U10*I3[374] + loo2p*I2[374];
*(vp++) = U00*I0[375] - U10*I3[375] + loo2p*I2[375] - (fouro4zn)*I5[250];
*(vp++) = U00*I0[376] - U10*I3[376] + loo2p*I2[376] - (threeo4zn)*I5[251];
*(vp++) = U00*I0[377] - U10*I3[377] + loo2p*I2[377] - (threeo4zn)*I5[252];
*(vp++) = U00*I0[378] - U10*I3[378] + loo2p*I2[378] - (twoo4zn)*I5[253];
*(vp++) = U00*I0[379] - U10*I3[379] + loo2p*I2[379] - (twoo4zn)*I5[254];
*(vp++) = U00*I0[380] - U10*I3[380] + loo2p*I2[380] - (twoo4zn)*I5[255];
*(vp++) = U00*I0[381] - U10*I3[381] + loo2p*I2[381] - (oneo4zn)*I5[256];
*(vp++) = U00*I0[382] - U10*I3[382] + loo2p*I2[382] - (oneo4zn)*I5[257];
*(vp++) = U00*I0[383] - U10*I3[383] + loo2p*I2[383] - (oneo4zn)*I5[258];
*(vp++) = U00*I0[384] - U10*I3[384] + loo2p*I2[384] - (oneo4zn)*I5[259];
*(vp++) = U00*I0[385] - U10*I3[385] + loo2p*I2[385];
*(vp++) = U00*I0[386] - U10*I3[386] + loo2p*I2[386];
*(vp++) = U00*I0[387] - U10*I3[387] + loo2p*I2[387];
*(vp++) = U00*I0[388] - U10*I3[388] + loo2p*I2[388];
*(vp++) = U00*I0[389] - U10*I3[389] + loo2p*I2[389];
*(vp++) = U00*I0[390] - U10*I3[390] + loo2p*I2[390] - (fouro4zn)*I5[260];
*(vp++) = U00*I0[391] - U10*I3[391] + loo2p*I2[391] - (threeo4zn)*I5[261];
*(vp++) = U00*I0[392] - U10*I3[392] + loo2p*I2[392] - (threeo4zn)*I5[262];
*(vp++) = U00*I0[393] - U10*I3[393] + loo2p*I2[393] - (twoo4zn)*I5[263];
*(vp++) = U00*I0[394] - U10*I3[394] + loo2p*I2[394] - (twoo4zn)*I5[264];
*(vp++) = U00*I0[395] - U10*I3[395] + loo2p*I2[395] - (twoo4zn)*I5[265];
*(vp++) = U00*I0[396] - U10*I3[396] + loo2p*I2[396] - (oneo4zn)*I5[266];
*(vp++) = U00*I0[397] - U10*I3[397] + loo2p*I2[397] - (oneo4zn)*I5[267];
*(vp++) = U00*I0[398] - U10*I3[398] + loo2p*I2[398] - (oneo4zn)*I5[268];
*(vp++) = U00*I0[399] - U10*I3[399] + loo2p*I2[399] - (oneo4zn)*I5[269];
*(vp++) = U00*I0[400] - U10*I3[400] + loo2p*I2[400];
*(vp++) = U00*I0[401] - U10*I3[401] + loo2p*I2[401];
*(vp++) = U00*I0[402] - U10*I3[402] + loo2p*I2[402];
*(vp++) = U00*I0[403] - U10*I3[403] + loo2p*I2[403];
*(vp++) = U00*I0[404] - U10*I3[404] + loo2p*I2[404];
*(vp++) = U00*I0[405] - U10*I3[405] + loo2p*I2[405] - (fouro4zn)*I5[270];
*(vp++) = U00*I0[406] - U10*I3[406] + loo2p*I2[406] - (threeo4zn)*I5[271];
*(vp++) = U00*I0[407] - U10*I3[407] + loo2p*I2[407] - (threeo4zn)*I5[272];
*(vp++) = U00*I0[408] - U10*I3[408] + loo2p*I2[408] - (twoo4zn)*I5[273];
*(vp++) = U00*I0[409] - U10*I3[409] + loo2p*I2[409] - (twoo4zn)*I5[274];
*(vp++) = U00*I0[410] - U10*I3[410] + loo2p*I2[410] - (twoo4zn)*I5[275];
*(vp++) = U00*I0[411] - U10*I3[411] + loo2p*I2[411] - (oneo4zn)*I5[276];
*(vp++) = U00*I0[412] - U10*I3[412] + loo2p*I2[412] - (oneo4zn)*I5[277];
*(vp++) = U00*I0[413] - U10*I3[413] + loo2p*I2[413] - (oneo4zn)*I5[278];
*(vp++) = U00*I0[414] - U10*I3[414] + loo2p*I2[414] - (oneo4zn)*I5[279];
*(vp++) = U00*I0[415] - U10*I3[415] + loo2p*I2[415];
*(vp++) = U00*I0[416] - U10*I3[416] + loo2p*I2[416];
*(vp++) = U00*I0[417] - U10*I3[417] + loo2p*I2[417];
*(vp++) = U00*I0[418] - U10*I3[418] + loo2p*I2[418];
*(vp++) = U00*I0[419] - U10*I3[419] + loo2p*I2[419];
*(vp++) = U01*I0[315] - U11*I3[315] + loo2p*I2[420]
        + (sixo2z)*I1[225] - (sixo4zn)*I4[225];
*(vp++) = U01*I0[316] - U11*I3[316] + loo2p*I2[421]
        + (sixo2z)*I1[226] - (sixo4zn)*I4[226] - (oneo4zn)*I5[210];
*(vp++) = U01*I0[317] - U11*I3[317] + loo2p*I2[422]
        + (sixo2z)*I1[227] - (sixo4zn)*I4[227];
*(vp++) = U01*I0[318] - U11*I3[318] + loo2p*I2[423]
        + (sixo2z)*I1[228] - (sixo4zn)*I4[228] - (twoo4zn)*I5[211];
*(vp++) = U01*I0[319] - U11*I3[319] + loo2p*I2[424]
        + (sixo2z)*I1[229] - (sixo4zn)*I4[229] - (oneo4zn)*I5[212];
*(vp++) = U01*I0[320] - U11*I3[320] + loo2p*I2[425]
        + (sixo2z)*I1[230] - (sixo4zn)*I4[230];
*(vp++) = U01*I0[321] - U11*I3[321] + loo2p*I2[426]
        + (sixo2z)*I1[231] - (sixo4zn)*I4[231] - (threeo4zn)*I5[213];
*(vp++) = U01*I0[322] - U11*I3[322] + loo2p*I2[427]
        + (sixo2z)*I1[232] - (sixo4zn)*I4[232] - (twoo4zn)*I5[214];
*(vp++) = U01*I0[323] - U11*I3[323] + loo2p*I2[428]
        + (sixo2z)*I1[233] - (sixo4zn)*I4[233] - (oneo4zn)*I5[215];
*(vp++) = U01*I0[324] - U11*I3[324] + loo2p*I2[429]
        + (sixo2z)*I1[234] - (sixo4zn)*I4[234];
*(vp++) = U01*I0[325] - U11*I3[325] + loo2p*I2[430]
        + (sixo2z)*I1[235] - (sixo4zn)*I4[235] - (fouro4zn)*I5[216];
*(vp++) = U01*I0[326] - U11*I3[326] + loo2p*I2[431]
        + (sixo2z)*I1[236] - (sixo4zn)*I4[236] - (threeo4zn)*I5[217];
*(vp++) = U01*I0[327] - U11*I3[327] + loo2p*I2[432]
        + (sixo2z)*I1[237] - (sixo4zn)*I4[237] - (twoo4zn)*I5[218];
*(vp++) = U01*I0[328] - U11*I3[328] + loo2p*I2[433]
        + (sixo2z)*I1[238] - (sixo4zn)*I4[238] - (oneo4zn)*I5[219];
*(vp++) = U01*I0[329] - U11*I3[329] + loo2p*I2[434]
        + (sixo2z)*I1[239] - (sixo4zn)*I4[239];
*(vp++) = U01*I0[330] - U11*I3[330] + loo2p*I2[435]
        + (fiveo2z)*I1[240] - (fiveo4zn)*I4[240];
*(vp++) = U01*I0[331] - U11*I3[331] + loo2p*I2[436]
        + (fiveo2z)*I1[241] - (fiveo4zn)*I4[241] - (oneo4zn)*I5[220];
*(vp++) = U01*I0[332] - U11*I3[332] + loo2p*I2[437]
        + (fiveo2z)*I1[242] - (fiveo4zn)*I4[242];
*(vp++) = U01*I0[333] - U11*I3[333] + loo2p*I2[438]
        + (fiveo2z)*I1[243] - (fiveo4zn)*I4[243] - (twoo4zn)*I5[221];
*(vp++) = U01*I0[334] - U11*I3[334] + loo2p*I2[439]
        + (fiveo2z)*I1[244] - (fiveo4zn)*I4[244] - (oneo4zn)*I5[222];
*(vp++) = U01*I0[335] - U11*I3[335] + loo2p*I2[440]
        + (fiveo2z)*I1[245] - (fiveo4zn)*I4[245];
*(vp++) = U01*I0[336] - U11*I3[336] + loo2p*I2[441]
        + (fiveo2z)*I1[246] - (fiveo4zn)*I4[246] - (threeo4zn)*I5[223];
*(vp++) = U01*I0[337] - U11*I3[337] + loo2p*I2[442]
        + (fiveo2z)*I1[247] - (fiveo4zn)*I4[247] - (twoo4zn)*I5[224];
*(vp++) = U01*I0[338] - U11*I3[338] + loo2p*I2[443]
        + (fiveo2z)*I1[248] - (fiveo4zn)*I4[248] - (oneo4zn)*I5[225];
*(vp++) = U01*I0[339] - U11*I3[339] + loo2p*I2[444]
        + (fiveo2z)*I1[249] - (fiveo4zn)*I4[249];
*(vp++) = U01*I0[340] - U11*I3[340] + loo2p*I2[445]
        + (fiveo2z)*I1[250] - (fiveo4zn)*I4[250] - (fouro4zn)*I5[226];
*(vp++) = U01*I0[341] - U11*I3[341] + loo2p*I2[446]
        + (fiveo2z)*I1[251] - (fiveo4zn)*I4[251] - (threeo4zn)*I5[227];
*(vp++) = U01*I0[342] - U11*I3[342] + loo2p*I2[447]
        + (fiveo2z)*I1[252] - (fiveo4zn)*I4[252] - (twoo4zn)*I5[228];
*(vp++) = U01*I0[343] - U11*I3[343] + loo2p*I2[448]
        + (fiveo2z)*I1[253] - (fiveo4zn)*I4[253] - (oneo4zn)*I5[229];
*(vp++) = U01*I0[344] - U11*I3[344] + loo2p*I2[449]
        + (fiveo2z)*I1[254] - (fiveo4zn)*I4[254];
*(vp++) = U01*I0[345] - U11*I3[345] + loo2p*I2[450]
        + (fouro2z)*I1[255] - (fouro4zn)*I4[255];
*(vp++) = U01*I0[346] - U11*I3[346] + loo2p*I2[451]
        + (fouro2z)*I1[256] - (fouro4zn)*I4[256] - (oneo4zn)*I5[230];
*(vp++) = U01*I0[347] - U11*I3[347] + loo2p*I2[452]
        + (fouro2z)*I1[257] - (fouro4zn)*I4[257];
*(vp++) = U01*I0[348] - U11*I3[348] + loo2p*I2[453]
        + (fouro2z)*I1[258] - (fouro4zn)*I4[258] - (twoo4zn)*I5[231];
*(vp++) = U01*I0[349] - U11*I3[349] + loo2p*I2[454]
        + (fouro2z)*I1[259] - (fouro4zn)*I4[259] - (oneo4zn)*I5[232];
*(vp++) = U01*I0[350] - U11*I3[350] + loo2p*I2[455]
        + (fouro2z)*I1[260] - (fouro4zn)*I4[260];
*(vp++) = U01*I0[351] - U11*I3[351] + loo2p*I2[456]
        + (fouro2z)*I1[261] - (fouro4zn)*I4[261] - (threeo4zn)*I5[233];
*(vp++) = U01*I0[352] - U11*I3[352] + loo2p*I2[457]
        + (fouro2z)*I1[262] - (fouro4zn)*I4[262] - (twoo4zn)*I5[234];
*(vp++) = U01*I0[353] - U11*I3[353] + loo2p*I2[458]
        + (fouro2z)*I1[263] - (fouro4zn)*I4[263] - (oneo4zn)*I5[235];
*(vp++) = U01*I0[354] - U11*I3[354] + loo2p*I2[459]
        + (fouro2z)*I1[264] - (fouro4zn)*I4[264];
*(vp++) = U01*I0[355] - U11*I3[355] + loo2p*I2[460]
        + (fouro2z)*I1[265] - (fouro4zn)*I4[265] - (fouro4zn)*I5[236];
*(vp++) = U01*I0[356] - U11*I3[356] + loo2p*I2[461]
        + (fouro2z)*I1[266] - (fouro4zn)*I4[266] - (threeo4zn)*I5[237];
*(vp++) = U01*I0[357] - U11*I3[357] + loo2p*I2[462]
        + (fouro2z)*I1[267] - (fouro4zn)*I4[267] - (twoo4zn)*I5[238];
*(vp++) = U01*I0[358] - U11*I3[358] + loo2p*I2[463]
        + (fouro2z)*I1[268] - (fouro4zn)*I4[268] - (oneo4zn)*I5[239];
*(vp++) = U01*I0[359] - U11*I3[359] + loo2p*I2[464]
        + (fouro2z)*I1[269] - (fouro4zn)*I4[269];
*(vp++) = U01*I0[360] - U11*I3[360] + loo2p*I2[465]
        + (threeo2z)*I1[270] - (threeo4zn)*I4[270];
*(vp++) = U01*I0[361] - U11*I3[361] + loo2p*I2[466]
        + (threeo2z)*I1[271] - (threeo4zn)*I4[271] - (oneo4zn)*I5[240];
*(vp++) = U01*I0[362] - U11*I3[362] + loo2p*I2[467]
        + (threeo2z)*I1[272] - (threeo4zn)*I4[272];
*(vp++) = U01*I0[363] - U11*I3[363] + loo2p*I2[468]
        + (threeo2z)*I1[273] - (threeo4zn)*I4[273] - (twoo4zn)*I5[241];
*(vp++) = U01*I0[364] - U11*I3[364] + loo2p*I2[469]
        + (threeo2z)*I1[274] - (threeo4zn)*I4[274] - (oneo4zn)*I5[242];
*(vp++) = U01*I0[365] - U11*I3[365] + loo2p*I2[470]
        + (threeo2z)*I1[275] - (threeo4zn)*I4[275];
*(vp++) = U01*I0[366] - U11*I3[366] + loo2p*I2[471]
        + (threeo2z)*I1[276] - (threeo4zn)*I4[276] - (threeo4zn)*I5[243];
*(vp++) = U01*I0[367] - U11*I3[367] + loo2p*I2[472]
        + (threeo2z)*I1[277] - (threeo4zn)*I4[277] - (twoo4zn)*I5[244];
*(vp++) = U01*I0[368] - U11*I3[368] + loo2p*I2[473]
        + (threeo2z)*I1[278] - (threeo4zn)*I4[278] - (oneo4zn)*I5[245];
*(vp++) = U01*I0[369] - U11*I3[369] + loo2p*I2[474]
        + (threeo2z)*I1[279] - (threeo4zn)*I4[279];
*(vp++) = U01*I0[370] - U11*I3[370] + loo2p*I2[475]
        + (threeo2z)*I1[280] - (threeo4zn)*I4[280] - (fouro4zn)*I5[246];
*(vp++) = U01*I0[371] - U11*I3[371] + loo2p*I2[476]
        + (threeo2z)*I1[281] - (threeo4zn)*I4[281] - (threeo4zn)*I5[247];
*(vp++) = U01*I0[372] - U11*I3[372] + loo2p*I2[477]
        + (threeo2z)*I1[282] - (threeo4zn)*I4[282] - (twoo4zn)*I5[248];
*(vp++) = U01*I0[373] - U11*I3[373] + loo2p*I2[478]
        + (threeo2z)*I1[283] - (threeo4zn)*I4[283] - (oneo4zn)*I5[249];
*(vp++) = U01*I0[374] - U11*I3[374] + loo2p*I2[479]
        + (threeo2z)*I1[284] - (threeo4zn)*I4[284];
*(vp++) = U01*I0[375] - U11*I3[375] + loo2p*I2[480]
        + (twoo2z)*I1[285] - (twoo4zn)*I4[285];
*(vp++) = U01*I0[376] - U11*I3[376] + loo2p*I2[481]
        + (twoo2z)*I1[286] - (twoo4zn)*I4[286] - (oneo4zn)*I5[250];
*(vp++) = U01*I0[377] - U11*I3[377] + loo2p*I2[482]
        + (twoo2z)*I1[287] - (twoo4zn)*I4[287];
*(vp++) = U01*I0[378] - U11*I3[378] + loo2p*I2[483]
        + (twoo2z)*I1[288] - (twoo4zn)*I4[288] - (twoo4zn)*I5[251];
*(vp++) = U01*I0[379] - U11*I3[379] + loo2p*I2[484]
        + (twoo2z)*I1[289] - (twoo4zn)*I4[289] - (oneo4zn)*I5[252];
*(vp++) = U01*I0[380] - U11*I3[380] + loo2p*I2[485]
        + (twoo2z)*I1[290] - (twoo4zn)*I4[290];
*(vp++) = U01*I0[381] - U11*I3[381] + loo2p*I2[486]
        + (twoo2z)*I1[291] - (twoo4zn)*I4[291] - (threeo4zn)*I5[253];
*(vp++) = U01*I0[382] - U11*I3[382] + loo2p*I2[487]
        + (twoo2z)*I1[292] - (twoo4zn)*I4[292] - (twoo4zn)*I5[254];
*(vp++) = U01*I0[383] - U11*I3[383] + loo2p*I2[488]
        + (twoo2z)*I1[293] - (twoo4zn)*I4[293] - (oneo4zn)*I5[255];
*(vp++) = U01*I0[384] - U11*I3[384] + loo2p*I2[489]
        + (twoo2z)*I1[294] - (twoo4zn)*I4[294];
*(vp++) = U01*I0[385] - U11*I3[385] + loo2p*I2[490]
        + (twoo2z)*I1[295] - (twoo4zn)*I4[295] - (fouro4zn)*I5[256];
*(vp++) = U01*I0[386] - U11*I3[386] + loo2p*I2[491]
        + (twoo2z)*I1[296] - (twoo4zn)*I4[296] - (threeo4zn)*I5[257];
*(vp++) = U01*I0[387] - U11*I3[387] + loo2p*I2[492]
        + (twoo2z)*I1[297] - (twoo4zn)*I4[297] - (twoo4zn)*I5[258];
*(vp++) = U01*I0[388] - U11*I3[388] + loo2p*I2[493]
        + (twoo2z)*I1[298] - (twoo4zn)*I4[298] - (oneo4zn)*I5[259];
*(vp++) = U01*I0[389] - U11*I3[389] + loo2p*I2[494]
        + (twoo2z)*I1[299] - (twoo4zn)*I4[299];
*(vp++) = U01*I0[390] - U11*I3[390] + loo2p*I2[495]
        + (oneo2z)*I1[300] - (oneo4zn)*I4[300];
*(vp++) = U01*I0[391] - U11*I3[391] + loo2p*I2[496]
        + (oneo2z)*I1[301] - (oneo4zn)*I4[301] - (oneo4zn)*I5[260];
*(vp++) = U01*I0[392] - U11*I3[392] + loo2p*I2[497]
        + (oneo2z)*I1[302] - (oneo4zn)*I4[302];
*(vp++) = U01*I0[393] - U11*I3[393] + loo2p*I2[498]
        + (oneo2z)*I1[303] - (oneo4zn)*I4[303] - (twoo4zn)*I5[261];
*(vp++) = U01*I0[394] - U11*I3[394] + loo2p*I2[499]
        + (oneo2z)*I1[304] - (oneo4zn)*I4[304] - (oneo4zn)*I5[262];
*(vp++) = U01*I0[395] - U11*I3[395] + loo2p*I2[500]
        + (oneo2z)*I1[305] - (oneo4zn)*I4[305];
*(vp++) = U01*I0[396] - U11*I3[396] + loo2p*I2[501]
        + (oneo2z)*I1[306] - (oneo4zn)*I4[306] - (threeo4zn)*I5[263];
*(vp++) = U01*I0[397] - U11*I3[397] + loo2p*I2[502]
        + (oneo2z)*I1[307] - (oneo4zn)*I4[307] - (twoo4zn)*I5[264];
*(vp++) = U01*I0[398] - U11*I3[398] + loo2p*I2[503]
        + (oneo2z)*I1[308] - (oneo4zn)*I4[308] - (oneo4zn)*I5[265];
*(vp++) = U01*I0[399] - U11*I3[399] + loo2p*I2[504]
        + (oneo2z)*I1[309] - (oneo4zn)*I4[309];
*(vp++) = U01*I0[400] - U11*I3[400] + loo2p*I2[505]
        + (oneo2z)*I1[310] - (oneo4zn)*I4[310] - (fouro4zn)*I5[266];
*(vp++) = U01*I0[401] - U11*I3[401] + loo2p*I2[506]
        + (oneo2z)*I1[311] - (oneo4zn)*I4[311] - (threeo4zn)*I5[267];
*(vp++) = U01*I0[402] - U11*I3[402] + loo2p*I2[507]
        + (oneo2z)*I1[312] - (oneo4zn)*I4[312] - (twoo4zn)*I5[268];
*(vp++) = U01*I0[403] - U11*I3[403] + loo2p*I2[508]
        + (oneo2z)*I1[313] - (oneo4zn)*I4[313] - (oneo4zn)*I5[269];
*(vp++) = U01*I0[404] - U11*I3[404] + loo2p*I2[509]
        + (oneo2z)*I1[314] - (oneo4zn)*I4[314];
*(vp++) = U01*I0[405] - U11*I3[405] + loo2p*I2[510];
*(vp++) = U01*I0[406] - U11*I3[406] + loo2p*I2[511] - (oneo4zn)*I5[270];
*(vp++) = U01*I0[407] - U11*I3[407] + loo2p*I2[512];
*(vp++) = U01*I0[408] - U11*I3[408] + loo2p*I2[513] - (twoo4zn)*I5[271];
*(vp++) = U01*I0[409] - U11*I3[409] + loo2p*I2[514] - (oneo4zn)*I5[272];
*(vp++) = U01*I0[410] - U11*I3[410] + loo2p*I2[515];
*(vp++) = U01*I0[411] - U11*I3[411] + loo2p*I2[516] - (threeo4zn)*I5[273];
*(vp++) = U01*I0[412] - U11*I3[412] + loo2p*I2[517] - (twoo4zn)*I5[274];
*(vp++) = U01*I0[413] - U11*I3[413] + loo2p*I2[518] - (oneo4zn)*I5[275];
*(vp++) = U01*I0[414] - U11*I3[414] + loo2p*I2[519];
*(vp++) = U01*I0[415] - U11*I3[415] + loo2p*I2[520] - (fouro4zn)*I5[276];
*(vp++) = U01*I0[416] - U11*I3[416] + loo2p*I2[521] - (threeo4zn)*I5[277];
*(vp++) = U01*I0[417] - U11*I3[417] + loo2p*I2[522] - (twoo4zn)*I5[278];
*(vp++) = U01*I0[418] - U11*I3[418] + loo2p*I2[523] - (oneo4zn)*I5[279];
*(vp++) = U01*I0[419] - U11*I3[419] + loo2p*I2[524];
*(vp++) = U02*I0[405] - U12*I3[405] + loo2p*I2[525]
        + (sixo2z)*I1[300] - (sixo4zn)*I4[300];
*(vp++) = U02*I0[406] - U12*I3[406] + loo2p*I2[526]
        + (sixo2z)*I1[301] - (sixo4zn)*I4[301];
*(vp++) = U02*I0[407] - U12*I3[407] + loo2p*I2[527]
        + (sixo2z)*I1[302] - (sixo4zn)*I4[302] - (oneo4zn)*I5[270];
*(vp++) = U02*I0[408] - U12*I3[408] + loo2p*I2[528]
        + (sixo2z)*I1[303] - (sixo4zn)*I4[303];
*(vp++) = U02*I0[409] - U12*I3[409] + loo2p*I2[529]
        + (sixo2z)*I1[304] - (sixo4zn)*I4[304] - (oneo4zn)*I5[271];
*(vp++) = U02*I0[410] - U12*I3[410] + loo2p*I2[530]
        + (sixo2z)*I1[305] - (sixo4zn)*I4[305] - (twoo4zn)*I5[272];
*(vp++) = U02*I0[411] - U12*I3[411] + loo2p*I2[531]
        + (sixo2z)*I1[306] - (sixo4zn)*I4[306];
*(vp++) = U02*I0[412] - U12*I3[412] + loo2p*I2[532]
        + (sixo2z)*I1[307] - (sixo4zn)*I4[307] - (oneo4zn)*I5[273];
*(vp++) = U02*I0[413] - U12*I3[413] + loo2p*I2[533]
        + (sixo2z)*I1[308] - (sixo4zn)*I4[308] - (twoo4zn)*I5[274];
*(vp++) = U02*I0[414] - U12*I3[414] + loo2p*I2[534]
        + (sixo2z)*I1[309] - (sixo4zn)*I4[309] - (threeo4zn)*I5[275];
*(vp++) = U02*I0[415] - U12*I3[415] + loo2p*I2[535]
        + (sixo2z)*I1[310] - (sixo4zn)*I4[310];
*(vp++) = U02*I0[416] - U12*I3[416] + loo2p*I2[536]
        + (sixo2z)*I1[311] - (sixo4zn)*I4[311] - (oneo4zn)*I5[276];
*(vp++) = U02*I0[417] - U12*I3[417] + loo2p*I2[537]
        + (sixo2z)*I1[312] - (sixo4zn)*I4[312] - (twoo4zn)*I5[277];
*(vp++) = U02*I0[418] - U12*I3[418] + loo2p*I2[538]
        + (sixo2z)*I1[313] - (sixo4zn)*I4[313] - (threeo4zn)*I5[278];
*(vp++) = U02*I0[419] - U12*I3[419] + loo2p*I2[539]
        + (sixo2z)*I1[314] - (sixo4zn)*I4[314] - (fouro4zn)*I5[279];
return vp;
}
