/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (fs|[r12,T2]|ds) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t2_build_f0d0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezdon;
  REALTYPE twozdon;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezdon = 1.0*(Data->twozeta_d*Data->oo2n);
  twozdon = 2.0*(Data->twozeta_d*Data->oo2n);
  U10 = ShellData->CD[0]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U11 = ShellData->CD[1]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U12 = ShellData->CD[2]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U0  = (Data->twozeta_c - Data->twozeta_d*(Data->twozeta_c*ShellData->CDdotCA + 3.000000))*Data->oo2n;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[1] - I2[6])
          - U12*(I1[2] - I2[12])
          + (twozdon)*(I3[0] + AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[3] - I2[7])
          - U12*(I1[4] - I2[13])
          + (onezdon)*(I3[1] + AC0*I4[1])
          + (onezdon)*(I3[3] + AC1*I4[0]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[4] - I2[8])
          - U12*(I1[5] - I2[14])
          + (onezdon)*(I3[2] + AC0*I4[2])
          + (onezdon)*(I3[6] + AC2*I4[0]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[6] - I2[9])
          - U12*(I1[7] - I2[15])
          + (twozdon)*(I3[4] + AC1*I4[1]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[7] - I2[10])
          - U12*(I1[8] - I2[16])
          + (onezdon)*(I3[5] + AC1*I4[2])
          + (onezdon)*(I3[7] + AC2*I4[1]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[8] - I2[11])
          - U12*(I1[9] - I2[17])
          + (twozdon)*(I3[8] + AC2*I4[2]);
*(vp++) = U0*I0[6]
          - U10*(I1[10] - I2[6])
          - U11*(I1[11] - I2[18])
          - U12*(I1[12] - I2[24])
          + (twozdon)*(I3[3] + AC0*I4[3]);
*(vp++) = U0*I0[7]
          - U10*(I1[11] - I2[7])
          - U11*(I1[13] - I2[19])
          - U12*(I1[14] - I2[25])
          + (onezdon)*(I3[4] + AC0*I4[4])
          + (onezdon)*(I3[9] + AC1*I4[3]);
*(vp++) = U0*I0[8]
          - U10*(I1[12] - I2[8])
          - U11*(I1[14] - I2[20])
          - U12*(I1[15] - I2[26])
          + (onezdon)*(I3[5] + AC0*I4[5])
          + (onezdon)*(I3[12] + AC2*I4[3]);
*(vp++) = U0*I0[9]
          - U10*(I1[13] - I2[9])
          - U11*(I1[16] - I2[21])
          - U12*(I1[17] - I2[27])
          + (twozdon)*(I3[10] + AC1*I4[4]);
*(vp++) = U0*I0[10]
          - U10*(I1[14] - I2[10])
          - U11*(I1[17] - I2[22])
          - U12*(I1[18] - I2[28])
          + (onezdon)*(I3[11] + AC1*I4[5])
          + (onezdon)*(I3[13] + AC2*I4[4]);
*(vp++) = U0*I0[11]
          - U10*(I1[15] - I2[11])
          - U11*(I1[18] - I2[23])
          - U12*(I1[19] - I2[29])
          + (twozdon)*(I3[14] + AC2*I4[5]);
*(vp++) = U0*I0[12]
          - U10*(I1[20] - I2[12])
          - U11*(I1[21] - I2[24])
          - U12*(I1[22] - I2[30])
          + (twozdon)*(I3[6] + AC0*I4[6]);
*(vp++) = U0*I0[13]
          - U10*(I1[21] - I2[13])
          - U11*(I1[23] - I2[25])
          - U12*(I1[24] - I2[31])
          + (onezdon)*(I3[7] + AC0*I4[7])
          + (onezdon)*(I3[12] + AC1*I4[6]);
*(vp++) = U0*I0[14]
          - U10*(I1[22] - I2[14])
          - U11*(I1[24] - I2[26])
          - U12*(I1[25] - I2[32])
          + (onezdon)*(I3[8] + AC0*I4[8])
          + (onezdon)*(I3[15] + AC2*I4[6]);
*(vp++) = U0*I0[15]
          - U10*(I1[23] - I2[15])
          - U11*(I1[26] - I2[27])
          - U12*(I1[27] - I2[33])
          + (twozdon)*(I3[13] + AC1*I4[7]);
*(vp++) = U0*I0[16]
          - U10*(I1[24] - I2[16])
          - U11*(I1[27] - I2[28])
          - U12*(I1[28] - I2[34])
          + (onezdon)*(I3[14] + AC1*I4[8])
          + (onezdon)*(I3[16] + AC2*I4[7]);
*(vp++) = U0*I0[17]
          - U10*(I1[25] - I2[17])
          - U11*(I1[28] - I2[29])
          - U12*(I1[29] - I2[35])
          + (twozdon)*(I3[17] + AC2*I4[8]);
*(vp++) = U0*I0[18]
          - U10*(I1[30] - I2[18])
          - U11*(I1[31] - I2[36])
          - U12*(I1[32] - I2[42])
          + (twozdon)*(I3[9] + AC0*I4[9]);
*(vp++) = U0*I0[19]
          - U10*(I1[31] - I2[19])
          - U11*(I1[33] - I2[37])
          - U12*(I1[34] - I2[43])
          + (onezdon)*(I3[10] + AC0*I4[10])
          + (onezdon)*(I3[18] + AC1*I4[9]);
*(vp++) = U0*I0[20]
          - U10*(I1[32] - I2[20])
          - U11*(I1[34] - I2[38])
          - U12*(I1[35] - I2[44])
          + (onezdon)*(I3[11] + AC0*I4[11])
          + (onezdon)*(I3[21] + AC2*I4[9]);
*(vp++) = U0*I0[21]
          - U10*(I1[33] - I2[21])
          - U11*(I1[36] - I2[39])
          - U12*(I1[37] - I2[45])
          + (twozdon)*(I3[19] + AC1*I4[10]);
*(vp++) = U0*I0[22]
          - U10*(I1[34] - I2[22])
          - U11*(I1[37] - I2[40])
          - U12*(I1[38] - I2[46])
          + (onezdon)*(I3[20] + AC1*I4[11])
          + (onezdon)*(I3[22] + AC2*I4[10]);
*(vp++) = U0*I0[23]
          - U10*(I1[35] - I2[23])
          - U11*(I1[38] - I2[41])
          - U12*(I1[39] - I2[47])
          + (twozdon)*(I3[23] + AC2*I4[11]);
*(vp++) = U0*I0[24]
          - U10*(I1[40] - I2[24])
          - U11*(I1[41] - I2[42])
          - U12*(I1[42] - I2[48])
          + (twozdon)*(I3[12] + AC0*I4[12]);
*(vp++) = U0*I0[25]
          - U10*(I1[41] - I2[25])
          - U11*(I1[43] - I2[43])
          - U12*(I1[44] - I2[49])
          + (onezdon)*(I3[13] + AC0*I4[13])
          + (onezdon)*(I3[21] + AC1*I4[12]);
*(vp++) = U0*I0[26]
          - U10*(I1[42] - I2[26])
          - U11*(I1[44] - I2[44])
          - U12*(I1[45] - I2[50])
          + (onezdon)*(I3[14] + AC0*I4[14])
          + (onezdon)*(I3[24] + AC2*I4[12]);
*(vp++) = U0*I0[27]
          - U10*(I1[43] - I2[27])
          - U11*(I1[46] - I2[45])
          - U12*(I1[47] - I2[51])
          + (twozdon)*(I3[22] + AC1*I4[13]);
*(vp++) = U0*I0[28]
          - U10*(I1[44] - I2[28])
          - U11*(I1[47] - I2[46])
          - U12*(I1[48] - I2[52])
          + (onezdon)*(I3[23] + AC1*I4[14])
          + (onezdon)*(I3[25] + AC2*I4[13]);
*(vp++) = U0*I0[29]
          - U10*(I1[45] - I2[29])
          - U11*(I1[48] - I2[47])
          - U12*(I1[49] - I2[53])
          + (twozdon)*(I3[26] + AC2*I4[14]);
*(vp++) = U0*I0[30]
          - U10*(I1[50] - I2[30])
          - U11*(I1[51] - I2[48])
          - U12*(I1[52] - I2[54])
          + (twozdon)*(I3[15] + AC0*I4[15]);
*(vp++) = U0*I0[31]
          - U10*(I1[51] - I2[31])
          - U11*(I1[53] - I2[49])
          - U12*(I1[54] - I2[55])
          + (onezdon)*(I3[16] + AC0*I4[16])
          + (onezdon)*(I3[24] + AC1*I4[15]);
*(vp++) = U0*I0[32]
          - U10*(I1[52] - I2[32])
          - U11*(I1[54] - I2[50])
          - U12*(I1[55] - I2[56])
          + (onezdon)*(I3[17] + AC0*I4[17])
          + (onezdon)*(I3[27] + AC2*I4[15]);
*(vp++) = U0*I0[33]
          - U10*(I1[53] - I2[33])
          - U11*(I1[56] - I2[51])
          - U12*(I1[57] - I2[57])
          + (twozdon)*(I3[25] + AC1*I4[16]);
*(vp++) = U0*I0[34]
          - U10*(I1[54] - I2[34])
          - U11*(I1[57] - I2[52])
          - U12*(I1[58] - I2[58])
          + (onezdon)*(I3[26] + AC1*I4[17])
          + (onezdon)*(I3[28] + AC2*I4[16]);
*(vp++) = U0*I0[35]
          - U10*(I1[55] - I2[35])
          - U11*(I1[58] - I2[53])
          - U12*(I1[59] - I2[59])
          + (twozdon)*(I3[29] + AC2*I4[17]);
*(vp++) = U0*I0[36]
          - U10*(I1[60] - I2[36])
          - U11*(I1[61] - I2[60])
          - U12*(I1[62] - I2[66])
          + (twozdon)*(I3[18] + AC0*I4[18]);
*(vp++) = U0*I0[37]
          - U10*(I1[61] - I2[37])
          - U11*(I1[63] - I2[61])
          - U12*(I1[64] - I2[67])
          + (onezdon)*(I3[19] + AC0*I4[19])
          + (onezdon)*(I3[30] + AC1*I4[18]);
*(vp++) = U0*I0[38]
          - U10*(I1[62] - I2[38])
          - U11*(I1[64] - I2[62])
          - U12*(I1[65] - I2[68])
          + (onezdon)*(I3[20] + AC0*I4[20])
          + (onezdon)*(I3[33] + AC2*I4[18]);
*(vp++) = U0*I0[39]
          - U10*(I1[63] - I2[39])
          - U11*(I1[66] - I2[63])
          - U12*(I1[67] - I2[69])
          + (twozdon)*(I3[31] + AC1*I4[19]);
*(vp++) = U0*I0[40]
          - U10*(I1[64] - I2[40])
          - U11*(I1[67] - I2[64])
          - U12*(I1[68] - I2[70])
          + (onezdon)*(I3[32] + AC1*I4[20])
          + (onezdon)*(I3[34] + AC2*I4[19]);
*(vp++) = U0*I0[41]
          - U10*(I1[65] - I2[41])
          - U11*(I1[68] - I2[65])
          - U12*(I1[69] - I2[71])
          + (twozdon)*(I3[35] + AC2*I4[20]);
*(vp++) = U0*I0[42]
          - U10*(I1[70] - I2[42])
          - U11*(I1[71] - I2[66])
          - U12*(I1[72] - I2[72])
          + (twozdon)*(I3[21] + AC0*I4[21]);
*(vp++) = U0*I0[43]
          - U10*(I1[71] - I2[43])
          - U11*(I1[73] - I2[67])
          - U12*(I1[74] - I2[73])
          + (onezdon)*(I3[22] + AC0*I4[22])
          + (onezdon)*(I3[33] + AC1*I4[21]);
*(vp++) = U0*I0[44]
          - U10*(I1[72] - I2[44])
          - U11*(I1[74] - I2[68])
          - U12*(I1[75] - I2[74])
          + (onezdon)*(I3[23] + AC0*I4[23])
          + (onezdon)*(I3[36] + AC2*I4[21]);
*(vp++) = U0*I0[45]
          - U10*(I1[73] - I2[45])
          - U11*(I1[76] - I2[69])
          - U12*(I1[77] - I2[75])
          + (twozdon)*(I3[34] + AC1*I4[22]);
*(vp++) = U0*I0[46]
          - U10*(I1[74] - I2[46])
          - U11*(I1[77] - I2[70])
          - U12*(I1[78] - I2[76])
          + (onezdon)*(I3[35] + AC1*I4[23])
          + (onezdon)*(I3[37] + AC2*I4[22]);
*(vp++) = U0*I0[47]
          - U10*(I1[75] - I2[47])
          - U11*(I1[78] - I2[71])
          - U12*(I1[79] - I2[77])
          + (twozdon)*(I3[38] + AC2*I4[23]);
*(vp++) = U0*I0[48]
          - U10*(I1[80] - I2[48])
          - U11*(I1[81] - I2[72])
          - U12*(I1[82] - I2[78])
          + (twozdon)*(I3[24] + AC0*I4[24]);
*(vp++) = U0*I0[49]
          - U10*(I1[81] - I2[49])
          - U11*(I1[83] - I2[73])
          - U12*(I1[84] - I2[79])
          + (onezdon)*(I3[25] + AC0*I4[25])
          + (onezdon)*(I3[36] + AC1*I4[24]);
*(vp++) = U0*I0[50]
          - U10*(I1[82] - I2[50])
          - U11*(I1[84] - I2[74])
          - U12*(I1[85] - I2[80])
          + (onezdon)*(I3[26] + AC0*I4[26])
          + (onezdon)*(I3[39] + AC2*I4[24]);
*(vp++) = U0*I0[51]
          - U10*(I1[83] - I2[51])
          - U11*(I1[86] - I2[75])
          - U12*(I1[87] - I2[81])
          + (twozdon)*(I3[37] + AC1*I4[25]);
*(vp++) = U0*I0[52]
          - U10*(I1[84] - I2[52])
          - U11*(I1[87] - I2[76])
          - U12*(I1[88] - I2[82])
          + (onezdon)*(I3[38] + AC1*I4[26])
          + (onezdon)*(I3[40] + AC2*I4[25]);
*(vp++) = U0*I0[53]
          - U10*(I1[85] - I2[53])
          - U11*(I1[88] - I2[77])
          - U12*(I1[89] - I2[83])
          + (twozdon)*(I3[41] + AC2*I4[26]);
*(vp++) = U0*I0[54]
          - U10*(I1[90] - I2[54])
          - U11*(I1[91] - I2[78])
          - U12*(I1[92] - I2[84])
          + (twozdon)*(I3[27] + AC0*I4[27]);
*(vp++) = U0*I0[55]
          - U10*(I1[91] - I2[55])
          - U11*(I1[93] - I2[79])
          - U12*(I1[94] - I2[85])
          + (onezdon)*(I3[28] + AC0*I4[28])
          + (onezdon)*(I3[39] + AC1*I4[27]);
*(vp++) = U0*I0[56]
          - U10*(I1[92] - I2[56])
          - U11*(I1[94] - I2[80])
          - U12*(I1[95] - I2[86])
          + (onezdon)*(I3[29] + AC0*I4[29])
          + (onezdon)*(I3[42] + AC2*I4[27]);
*(vp++) = U0*I0[57]
          - U10*(I1[93] - I2[57])
          - U11*(I1[96] - I2[81])
          - U12*(I1[97] - I2[87])
          + (twozdon)*(I3[40] + AC1*I4[28]);
*(vp++) = U0*I0[58]
          - U10*(I1[94] - I2[58])
          - U11*(I1[97] - I2[82])
          - U12*(I1[98] - I2[88])
          + (onezdon)*(I3[41] + AC1*I4[29])
          + (onezdon)*(I3[43] + AC2*I4[28]);
*(vp++) = U0*I0[59]
          - U10*(I1[95] - I2[59])
          - U11*(I1[98] - I2[83])
          - U12*(I1[99] - I2[89])
          + (twozdon)*(I3[44] + AC2*I4[29]);

}
