/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* This machine-generated function computes a quartet of [r12,T2]|hd) integrals */

#include<libint/libint.h>

void t2hrr3_build_hd(REALTYPE *CD, REALTYPE *AC, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, int la, int lb)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];
  const REALTYPE AC0 = AC[0];
  const REALTYPE AC1 = AC[1];
  const REALTYPE AC2 = AC[2];
  static int io[] = { 1, 3, 6, 10, 15, 21, 28, 36, 45, 55, 66, 78};
  int bcdm1_num = io[lb]*63;

  int pa, qa, b;
  for(pa=0;pa<=la;pa++)
    for(qa=0;qa<=pa;qa++)
      for(b=0;b<((lb+1)*(lb+2)/2);b++) {
        *(vp++) = I0[0] + CD0*I1[0] + I2[0] - AC0*I4[0] - I3[0];
        *(vp++) = I0[1] + CD0*I1[1] + I2[1] - AC0*I4[1] - I3[1];
        *(vp++) = I0[2] + CD0*I1[2] + I2[2] - AC0*I4[2] - I3[2];
        *(vp++) = I0[4] + CD1*I1[1] + I2[4] - AC1*I4[1] - I3[(pa+1)*bcdm1_num+1];
        *(vp++) = I0[5] + CD1*I1[2] + I2[5] - AC1*I4[2] - I3[(pa+1)*bcdm1_num+2];
        *(vp++) = I0[8] + CD2*I1[2] + I2[8] - AC2*I4[2] - I3[(pa+2)*bcdm1_num+2];
        *(vp++) = I0[3] + CD0*I1[3] + I2[3] - AC0*I4[3] - I3[3];
        *(vp++) = I0[4] + CD0*I1[4] + I2[4] - AC0*I4[4] - I3[4];
        *(vp++) = I0[5] + CD0*I1[5] + I2[5] - AC0*I4[5] - I3[5];
        *(vp++) = I0[10] + CD1*I1[4] + I2[10] - AC1*I4[4] - I3[(pa+1)*bcdm1_num+4];
        *(vp++) = I0[11] + CD1*I1[5] + I2[11] - AC1*I4[5] - I3[(pa+1)*bcdm1_num+5];
        *(vp++) = I0[14] + CD2*I1[5] + I2[14] - AC2*I4[5] - I3[(pa+2)*bcdm1_num+5];
        *(vp++) = I0[6] + CD0*I1[6] + I2[6] - AC0*I4[6] - I3[6];
        *(vp++) = I0[7] + CD0*I1[7] + I2[7] - AC0*I4[7] - I3[7];
        *(vp++) = I0[8] + CD0*I1[8] + I2[8] - AC0*I4[8] - I3[8];
        *(vp++) = I0[13] + CD1*I1[7] + I2[13] - AC1*I4[7] - I3[(pa+1)*bcdm1_num+7];
        *(vp++) = I0[14] + CD1*I1[8] + I2[14] - AC1*I4[8] - I3[(pa+1)*bcdm1_num+8];
        *(vp++) = I0[17] + CD2*I1[8] + I2[17] - AC2*I4[8] - I3[(pa+2)*bcdm1_num+8];
        *(vp++) = I0[9] + CD0*I1[9] + I2[9] - AC0*I4[9] - I3[9];
        *(vp++) = I0[10] + CD0*I1[10] + I2[10] - AC0*I4[10] - I3[10];
        *(vp++) = I0[11] + CD0*I1[11] + I2[11] - AC0*I4[11] - I3[11];
        *(vp++) = I0[19] + CD1*I1[10] + I2[19] - AC1*I4[10] - I3[(pa+1)*bcdm1_num+10];
        *(vp++) = I0[20] + CD1*I1[11] + I2[20] - AC1*I4[11] - I3[(pa+1)*bcdm1_num+11];
        *(vp++) = I0[23] + CD2*I1[11] + I2[23] - AC2*I4[11] - I3[(pa+2)*bcdm1_num+11];
        *(vp++) = I0[12] + CD0*I1[12] + I2[12] - AC0*I4[12] - I3[12];
        *(vp++) = I0[13] + CD0*I1[13] + I2[13] - AC0*I4[13] - I3[13];
        *(vp++) = I0[14] + CD0*I1[14] + I2[14] - AC0*I4[14] - I3[14];
        *(vp++) = I0[22] + CD1*I1[13] + I2[22] - AC1*I4[13] - I3[(pa+1)*bcdm1_num+13];
        *(vp++) = I0[23] + CD1*I1[14] + I2[23] - AC1*I4[14] - I3[(pa+1)*bcdm1_num+14];
        *(vp++) = I0[26] + CD2*I1[14] + I2[26] - AC2*I4[14] - I3[(pa+2)*bcdm1_num+14];
        *(vp++) = I0[15] + CD0*I1[15] + I2[15] - AC0*I4[15] - I3[15];
        *(vp++) = I0[16] + CD0*I1[16] + I2[16] - AC0*I4[16] - I3[16];
        *(vp++) = I0[17] + CD0*I1[17] + I2[17] - AC0*I4[17] - I3[17];
        *(vp++) = I0[25] + CD1*I1[16] + I2[25] - AC1*I4[16] - I3[(pa+1)*bcdm1_num+16];
        *(vp++) = I0[26] + CD1*I1[17] + I2[26] - AC1*I4[17] - I3[(pa+1)*bcdm1_num+17];
        *(vp++) = I0[29] + CD2*I1[17] + I2[29] - AC2*I4[17] - I3[(pa+2)*bcdm1_num+17];
        *(vp++) = I0[18] + CD0*I1[18] + I2[18] - AC0*I4[18] - I3[18];
        *(vp++) = I0[19] + CD0*I1[19] + I2[19] - AC0*I4[19] - I3[19];
        *(vp++) = I0[20] + CD0*I1[20] + I2[20] - AC0*I4[20] - I3[20];
        *(vp++) = I0[31] + CD1*I1[19] + I2[31] - AC1*I4[19] - I3[(pa+1)*bcdm1_num+19];
        *(vp++) = I0[32] + CD1*I1[20] + I2[32] - AC1*I4[20] - I3[(pa+1)*bcdm1_num+20];
        *(vp++) = I0[35] + CD2*I1[20] + I2[35] - AC2*I4[20] - I3[(pa+2)*bcdm1_num+20];
        *(vp++) = I0[21] + CD0*I1[21] + I2[21] - AC0*I4[21] - I3[21];
        *(vp++) = I0[22] + CD0*I1[22] + I2[22] - AC0*I4[22] - I3[22];
        *(vp++) = I0[23] + CD0*I1[23] + I2[23] - AC0*I4[23] - I3[23];
        *(vp++) = I0[34] + CD1*I1[22] + I2[34] - AC1*I4[22] - I3[(pa+1)*bcdm1_num+22];
        *(vp++) = I0[35] + CD1*I1[23] + I2[35] - AC1*I4[23] - I3[(pa+1)*bcdm1_num+23];
        *(vp++) = I0[38] + CD2*I1[23] + I2[38] - AC2*I4[23] - I3[(pa+2)*bcdm1_num+23];
        *(vp++) = I0[24] + CD0*I1[24] + I2[24] - AC0*I4[24] - I3[24];
        *(vp++) = I0[25] + CD0*I1[25] + I2[25] - AC0*I4[25] - I3[25];
        *(vp++) = I0[26] + CD0*I1[26] + I2[26] - AC0*I4[26] - I3[26];
        *(vp++) = I0[37] + CD1*I1[25] + I2[37] - AC1*I4[25] - I3[(pa+1)*bcdm1_num+25];
        *(vp++) = I0[38] + CD1*I1[26] + I2[38] - AC1*I4[26] - I3[(pa+1)*bcdm1_num+26];
        *(vp++) = I0[41] + CD2*I1[26] + I2[41] - AC2*I4[26] - I3[(pa+2)*bcdm1_num+26];
        *(vp++) = I0[27] + CD0*I1[27] + I2[27] - AC0*I4[27] - I3[27];
        *(vp++) = I0[28] + CD0*I1[28] + I2[28] - AC0*I4[28] - I3[28];
        *(vp++) = I0[29] + CD0*I1[29] + I2[29] - AC0*I4[29] - I3[29];
        *(vp++) = I0[40] + CD1*I1[28] + I2[40] - AC1*I4[28] - I3[(pa+1)*bcdm1_num+28];
        *(vp++) = I0[41] + CD1*I1[29] + I2[41] - AC1*I4[29] - I3[(pa+1)*bcdm1_num+29];
        *(vp++) = I0[44] + CD2*I1[29] + I2[44] - AC2*I4[29] - I3[(pa+2)*bcdm1_num+29];
        *(vp++) = I0[30] + CD0*I1[30] + I2[30] - AC0*I4[30] - I3[30];
        *(vp++) = I0[31] + CD0*I1[31] + I2[31] - AC0*I4[31] - I3[31];
        *(vp++) = I0[32] + CD0*I1[32] + I2[32] - AC0*I4[32] - I3[32];
        *(vp++) = I0[46] + CD1*I1[31] + I2[46] - AC1*I4[31] - I3[(pa+1)*bcdm1_num+31];
        *(vp++) = I0[47] + CD1*I1[32] + I2[47] - AC1*I4[32] - I3[(pa+1)*bcdm1_num+32];
        *(vp++) = I0[50] + CD2*I1[32] + I2[50] - AC2*I4[32] - I3[(pa+2)*bcdm1_num+32];
        *(vp++) = I0[33] + CD0*I1[33] + I2[33] - AC0*I4[33] - I3[33];
        *(vp++) = I0[34] + CD0*I1[34] + I2[34] - AC0*I4[34] - I3[34];
        *(vp++) = I0[35] + CD0*I1[35] + I2[35] - AC0*I4[35] - I3[35];
        *(vp++) = I0[49] + CD1*I1[34] + I2[49] - AC1*I4[34] - I3[(pa+1)*bcdm1_num+34];
        *(vp++) = I0[50] + CD1*I1[35] + I2[50] - AC1*I4[35] - I3[(pa+1)*bcdm1_num+35];
        *(vp++) = I0[53] + CD2*I1[35] + I2[53] - AC2*I4[35] - I3[(pa+2)*bcdm1_num+35];
        *(vp++) = I0[36] + CD0*I1[36] + I2[36] - AC0*I4[36] - I3[36];
        *(vp++) = I0[37] + CD0*I1[37] + I2[37] - AC0*I4[37] - I3[37];
        *(vp++) = I0[38] + CD0*I1[38] + I2[38] - AC0*I4[38] - I3[38];
        *(vp++) = I0[52] + CD1*I1[37] + I2[52] - AC1*I4[37] - I3[(pa+1)*bcdm1_num+37];
        *(vp++) = I0[53] + CD1*I1[38] + I2[53] - AC1*I4[38] - I3[(pa+1)*bcdm1_num+38];
        *(vp++) = I0[56] + CD2*I1[38] + I2[56] - AC2*I4[38] - I3[(pa+2)*bcdm1_num+38];
        *(vp++) = I0[39] + CD0*I1[39] + I2[39] - AC0*I4[39] - I3[39];
        *(vp++) = I0[40] + CD0*I1[40] + I2[40] - AC0*I4[40] - I3[40];
        *(vp++) = I0[41] + CD0*I1[41] + I2[41] - AC0*I4[41] - I3[41];
        *(vp++) = I0[55] + CD1*I1[40] + I2[55] - AC1*I4[40] - I3[(pa+1)*bcdm1_num+40];
        *(vp++) = I0[56] + CD1*I1[41] + I2[56] - AC1*I4[41] - I3[(pa+1)*bcdm1_num+41];
        *(vp++) = I0[59] + CD2*I1[41] + I2[59] - AC2*I4[41] - I3[(pa+2)*bcdm1_num+41];
        *(vp++) = I0[42] + CD0*I1[42] + I2[42] - AC0*I4[42] - I3[42];
        *(vp++) = I0[43] + CD0*I1[43] + I2[43] - AC0*I4[43] - I3[43];
        *(vp++) = I0[44] + CD0*I1[44] + I2[44] - AC0*I4[44] - I3[44];
        *(vp++) = I0[58] + CD1*I1[43] + I2[58] - AC1*I4[43] - I3[(pa+1)*bcdm1_num+43];
        *(vp++) = I0[59] + CD1*I1[44] + I2[59] - AC1*I4[44] - I3[(pa+1)*bcdm1_num+44];
        *(vp++) = I0[62] + CD2*I1[44] + I2[62] - AC2*I4[44] - I3[(pa+2)*bcdm1_num+44];
        *(vp++) = I0[45] + CD0*I1[45] + I2[45] - AC0*I4[45] - I3[45];
        *(vp++) = I0[46] + CD0*I1[46] + I2[46] - AC0*I4[46] - I3[46];
        *(vp++) = I0[47] + CD0*I1[47] + I2[47] - AC0*I4[47] - I3[47];
        *(vp++) = I0[64] + CD1*I1[46] + I2[64] - AC1*I4[46] - I3[(pa+1)*bcdm1_num+46];
        *(vp++) = I0[65] + CD1*I1[47] + I2[65] - AC1*I4[47] - I3[(pa+1)*bcdm1_num+47];
        *(vp++) = I0[68] + CD2*I1[47] + I2[68] - AC2*I4[47] - I3[(pa+2)*bcdm1_num+47];
        *(vp++) = I0[48] + CD0*I1[48] + I2[48] - AC0*I4[48] - I3[48];
        *(vp++) = I0[49] + CD0*I1[49] + I2[49] - AC0*I4[49] - I3[49];
        *(vp++) = I0[50] + CD0*I1[50] + I2[50] - AC0*I4[50] - I3[50];
        *(vp++) = I0[67] + CD1*I1[49] + I2[67] - AC1*I4[49] - I3[(pa+1)*bcdm1_num+49];
        *(vp++) = I0[68] + CD1*I1[50] + I2[68] - AC1*I4[50] - I3[(pa+1)*bcdm1_num+50];
        *(vp++) = I0[71] + CD2*I1[50] + I2[71] - AC2*I4[50] - I3[(pa+2)*bcdm1_num+50];
        *(vp++) = I0[51] + CD0*I1[51] + I2[51] - AC0*I4[51] - I3[51];
        *(vp++) = I0[52] + CD0*I1[52] + I2[52] - AC0*I4[52] - I3[52];
        *(vp++) = I0[53] + CD0*I1[53] + I2[53] - AC0*I4[53] - I3[53];
        *(vp++) = I0[70] + CD1*I1[52] + I2[70] - AC1*I4[52] - I3[(pa+1)*bcdm1_num+52];
        *(vp++) = I0[71] + CD1*I1[53] + I2[71] - AC1*I4[53] - I3[(pa+1)*bcdm1_num+53];
        *(vp++) = I0[74] + CD2*I1[53] + I2[74] - AC2*I4[53] - I3[(pa+2)*bcdm1_num+53];
        *(vp++) = I0[54] + CD0*I1[54] + I2[54] - AC0*I4[54] - I3[54];
        *(vp++) = I0[55] + CD0*I1[55] + I2[55] - AC0*I4[55] - I3[55];
        *(vp++) = I0[56] + CD0*I1[56] + I2[56] - AC0*I4[56] - I3[56];
        *(vp++) = I0[73] + CD1*I1[55] + I2[73] - AC1*I4[55] - I3[(pa+1)*bcdm1_num+55];
        *(vp++) = I0[74] + CD1*I1[56] + I2[74] - AC1*I4[56] - I3[(pa+1)*bcdm1_num+56];
        *(vp++) = I0[77] + CD2*I1[56] + I2[77] - AC2*I4[56] - I3[(pa+2)*bcdm1_num+56];
        *(vp++) = I0[57] + CD0*I1[57] + I2[57] - AC0*I4[57] - I3[57];
        *(vp++) = I0[58] + CD0*I1[58] + I2[58] - AC0*I4[58] - I3[58];
        *(vp++) = I0[59] + CD0*I1[59] + I2[59] - AC0*I4[59] - I3[59];
        *(vp++) = I0[76] + CD1*I1[58] + I2[76] - AC1*I4[58] - I3[(pa+1)*bcdm1_num+58];
        *(vp++) = I0[77] + CD1*I1[59] + I2[77] - AC1*I4[59] - I3[(pa+1)*bcdm1_num+59];
        *(vp++) = I0[80] + CD2*I1[59] + I2[80] - AC2*I4[59] - I3[(pa+2)*bcdm1_num+59];
        *(vp++) = I0[60] + CD0*I1[60] + I2[60] - AC0*I4[60] - I3[60];
        *(vp++) = I0[61] + CD0*I1[61] + I2[61] - AC0*I4[61] - I3[61];
        *(vp++) = I0[62] + CD0*I1[62] + I2[62] - AC0*I4[62] - I3[62];
        *(vp++) = I0[79] + CD1*I1[61] + I2[79] - AC1*I4[61] - I3[(pa+1)*bcdm1_num+61];
        *(vp++) = I0[80] + CD1*I1[62] + I2[80] - AC1*I4[62] - I3[(pa+1)*bcdm1_num+62];
        *(vp++) = I0[83] + CD2*I1[62] + I2[83] - AC2*I4[62] - I3[(pa+2)*bcdm1_num+62];
        I0 += 84;
        I1 += 63;
        I2 += 84;
        I3 += 63;
        I4 += 63;
  }
}
