/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_fdhh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fd|hh) integrals */

void d12hrr_order_fdhh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][10][11] = int_stack + 0;
 Libderiv->deriv_classes[5][10][10] = int_stack + 1386;
 Libderiv->deriv_classes[5][10][9] = int_stack + 2772;
 Libderiv->deriv_classes[5][10][8] = int_stack + 4158;
 Libderiv->deriv_classes[5][10][7] = int_stack + 5544;
 Libderiv->dvrr_classes[5][9] = int_stack + 6930;
 Libderiv->deriv_classes[5][10][6] = int_stack + 8085;
 Libderiv->deriv_classes[5][10][2] = int_stack + 9471;
 Libderiv->deriv_classes[5][10][1] = int_stack + 10857;
 Libderiv->dvrr_classes[4][10] = int_stack + 12243;
 Libderiv->deriv_classes[5][10][0] = int_stack + 13233;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 14619;
 Libderiv->deriv2_classes[3][6][143] = int_stack + 14829;
 Libderiv->deriv2_classes[3][7][143] = int_stack + 15109;
 Libderiv->deriv2_classes[3][8][143] = int_stack + 15469;
 Libderiv->deriv2_classes[3][9][143] = int_stack + 15919;
 Libderiv->deriv2_classes[3][10][143] = int_stack + 16469;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 17129;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 17444;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 17864;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 18404;
 Libderiv->deriv2_classes[4][9][143] = int_stack + 19079;
 Libderiv->deriv2_classes[4][10][143] = int_stack + 19904;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 20894;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 21335;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 21923;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 22679;
 Libderiv->deriv2_classes[5][9][143] = int_stack + 23624;
 Libderiv->deriv2_classes[5][10][143] = int_stack + 24779;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 26165;
 Libderiv->deriv2_classes[3][6][131] = int_stack + 26375;
 Libderiv->deriv2_classes[3][7][131] = int_stack + 26655;
 Libderiv->deriv2_classes[3][8][131] = int_stack + 27015;
 Libderiv->deriv2_classes[3][9][131] = int_stack + 27465;
 Libderiv->deriv2_classes[3][10][131] = int_stack + 28015;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 28675;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 28990;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 29410;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 29950;
 Libderiv->deriv2_classes[4][9][131] = int_stack + 30625;
 Libderiv->deriv2_classes[4][10][131] = int_stack + 31450;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 32440;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 32881;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 33469;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 34225;
 Libderiv->deriv2_classes[5][9][131] = int_stack + 35170;
 Libderiv->deriv2_classes[5][10][131] = int_stack + 36325;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 37711;
 Libderiv->deriv2_classes[3][6][130] = int_stack + 37921;
 Libderiv->deriv2_classes[3][7][130] = int_stack + 38201;
 Libderiv->deriv2_classes[3][8][130] = int_stack + 38561;
 Libderiv->deriv2_classes[3][9][130] = int_stack + 39011;
 Libderiv->deriv2_classes[3][10][130] = int_stack + 39561;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 40221;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 40536;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 40956;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 41496;
 Libderiv->deriv2_classes[4][9][130] = int_stack + 42171;
 Libderiv->deriv2_classes[4][10][130] = int_stack + 42996;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 43986;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 44427;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 45015;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 45771;
 Libderiv->deriv2_classes[5][9][130] = int_stack + 46716;
 Libderiv->deriv2_classes[5][10][130] = int_stack + 47871;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 49257;
 Libderiv->deriv2_classes[3][6][119] = int_stack + 49467;
 Libderiv->deriv2_classes[3][7][119] = int_stack + 49747;
 Libderiv->deriv2_classes[3][8][119] = int_stack + 50107;
 Libderiv->deriv2_classes[3][9][119] = int_stack + 50557;
 Libderiv->deriv2_classes[3][10][119] = int_stack + 51107;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 51767;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 52082;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 52502;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 53042;
 Libderiv->deriv2_classes[4][9][119] = int_stack + 53717;
 Libderiv->deriv2_classes[4][10][119] = int_stack + 54542;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 55532;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 55973;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 56561;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 57317;
 Libderiv->deriv2_classes[5][9][119] = int_stack + 58262;
 Libderiv->deriv2_classes[5][10][119] = int_stack + 59417;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 60803;
 Libderiv->deriv2_classes[3][6][118] = int_stack + 61013;
 Libderiv->deriv2_classes[3][7][118] = int_stack + 61293;
 Libderiv->deriv2_classes[3][8][118] = int_stack + 61653;
 Libderiv->deriv2_classes[3][9][118] = int_stack + 62103;
 Libderiv->deriv2_classes[3][10][118] = int_stack + 62653;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 63313;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 63628;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 64048;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 64588;
 Libderiv->deriv2_classes[4][9][118] = int_stack + 65263;
 Libderiv->deriv2_classes[4][10][118] = int_stack + 66088;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 67078;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 67519;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 68107;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 68863;
 Libderiv->deriv2_classes[5][9][118] = int_stack + 69808;
 Libderiv->deriv2_classes[5][10][118] = int_stack + 70963;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 72349;
 Libderiv->deriv2_classes[3][6][117] = int_stack + 72559;
 Libderiv->deriv2_classes[3][7][117] = int_stack + 72839;
 Libderiv->deriv2_classes[3][8][117] = int_stack + 73199;
 Libderiv->deriv2_classes[3][9][117] = int_stack + 73649;
 Libderiv->deriv2_classes[3][10][117] = int_stack + 74199;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 74859;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 75174;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 75594;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 76134;
 Libderiv->deriv2_classes[4][9][117] = int_stack + 76809;
 Libderiv->deriv2_classes[4][10][117] = int_stack + 77634;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 78624;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 79065;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 79653;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 80409;
 Libderiv->deriv2_classes[5][9][117] = int_stack + 81354;
 Libderiv->deriv2_classes[5][10][117] = int_stack + 82509;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 83895;
 Libderiv->deriv2_classes[3][6][107] = int_stack + 84105;
 Libderiv->deriv2_classes[3][7][107] = int_stack + 84385;
 Libderiv->deriv2_classes[3][8][107] = int_stack + 84745;
 Libderiv->deriv2_classes[3][9][107] = int_stack + 85195;
 Libderiv->deriv2_classes[3][10][107] = int_stack + 85745;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 86405;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 86720;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 87140;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 87680;
 Libderiv->deriv2_classes[4][9][107] = int_stack + 88355;
 Libderiv->deriv2_classes[4][10][107] = int_stack + 89180;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 90170;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 90611;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 91199;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 91955;
 Libderiv->deriv2_classes[5][9][107] = int_stack + 92900;
 Libderiv->deriv2_classes[5][10][107] = int_stack + 94055;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 95441;
 Libderiv->deriv2_classes[3][6][106] = int_stack + 95651;
 Libderiv->deriv2_classes[3][7][106] = int_stack + 95931;
 Libderiv->deriv2_classes[3][8][106] = int_stack + 96291;
 Libderiv->deriv2_classes[3][9][106] = int_stack + 96741;
 Libderiv->deriv2_classes[3][10][106] = int_stack + 97291;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 97951;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 98266;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 98686;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 99226;
 Libderiv->deriv2_classes[4][9][106] = int_stack + 99901;
 Libderiv->deriv2_classes[4][10][106] = int_stack + 100726;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 101716;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 102157;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 102745;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 103501;
 Libderiv->deriv2_classes[5][9][106] = int_stack + 104446;
 Libderiv->deriv2_classes[5][10][106] = int_stack + 105601;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 106987;
 Libderiv->deriv2_classes[3][6][105] = int_stack + 107197;
 Libderiv->deriv2_classes[3][7][105] = int_stack + 107477;
 Libderiv->deriv2_classes[3][8][105] = int_stack + 107837;
 Libderiv->deriv2_classes[3][9][105] = int_stack + 108287;
 Libderiv->deriv2_classes[3][10][105] = int_stack + 108837;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 109497;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 109812;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 110232;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 110772;
 Libderiv->deriv2_classes[4][9][105] = int_stack + 111447;
 Libderiv->deriv2_classes[4][10][105] = int_stack + 112272;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 113262;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 113703;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 114291;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 115047;
 Libderiv->deriv2_classes[5][9][105] = int_stack + 115992;
 Libderiv->deriv2_classes[5][10][105] = int_stack + 117147;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 118533;
 Libderiv->deriv2_classes[3][6][104] = int_stack + 118743;
 Libderiv->deriv2_classes[3][7][104] = int_stack + 119023;
 Libderiv->deriv2_classes[3][8][104] = int_stack + 119383;
 Libderiv->deriv2_classes[3][9][104] = int_stack + 119833;
 Libderiv->deriv2_classes[3][10][104] = int_stack + 120383;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 121043;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 121358;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 121778;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 122318;
 Libderiv->deriv2_classes[4][9][104] = int_stack + 122993;
 Libderiv->deriv2_classes[4][10][104] = int_stack + 123818;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 124808;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 125249;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 125837;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 126593;
 Libderiv->deriv2_classes[5][9][104] = int_stack + 127538;
 Libderiv->deriv2_classes[5][10][104] = int_stack + 128693;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 130079;
 Libderiv->deriv2_classes[3][6][95] = int_stack + 130289;
 Libderiv->deriv2_classes[3][7][95] = int_stack + 130569;
 Libderiv->deriv2_classes[3][8][95] = int_stack + 130929;
 Libderiv->deriv2_classes[3][9][95] = int_stack + 131379;
 Libderiv->deriv2_classes[3][10][95] = int_stack + 131929;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 132589;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 132904;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 133324;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 133864;
 Libderiv->deriv2_classes[4][9][95] = int_stack + 134539;
 Libderiv->deriv2_classes[4][10][95] = int_stack + 135364;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 136354;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 136795;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 137383;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 138139;
 Libderiv->deriv2_classes[5][9][95] = int_stack + 139084;
 Libderiv->deriv2_classes[5][10][95] = int_stack + 140239;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 141625;
 Libderiv->deriv2_classes[3][6][94] = int_stack + 141835;
 Libderiv->deriv2_classes[3][7][94] = int_stack + 142115;
 Libderiv->deriv2_classes[3][8][94] = int_stack + 142475;
 Libderiv->deriv2_classes[3][9][94] = int_stack + 142925;
 Libderiv->deriv2_classes[3][10][94] = int_stack + 143475;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 144135;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 144450;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 144870;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 145410;
 Libderiv->deriv2_classes[4][9][94] = int_stack + 146085;
 Libderiv->deriv2_classes[4][10][94] = int_stack + 146910;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 147900;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 148341;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 148929;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 149685;
 Libderiv->deriv2_classes[5][9][94] = int_stack + 150630;
 Libderiv->deriv2_classes[5][10][94] = int_stack + 151785;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 153171;
 Libderiv->deriv2_classes[3][6][93] = int_stack + 153381;
 Libderiv->deriv2_classes[3][7][93] = int_stack + 153661;
 Libderiv->deriv2_classes[3][8][93] = int_stack + 154021;
 Libderiv->deriv2_classes[3][9][93] = int_stack + 154471;
 Libderiv->deriv2_classes[3][10][93] = int_stack + 155021;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 155681;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 155996;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 156416;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 156956;
 Libderiv->deriv2_classes[4][9][93] = int_stack + 157631;
 Libderiv->deriv2_classes[4][10][93] = int_stack + 158456;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 159446;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 159887;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 160475;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 161231;
 Libderiv->deriv2_classes[5][9][93] = int_stack + 162176;
 Libderiv->deriv2_classes[5][10][93] = int_stack + 163331;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 164717;
 Libderiv->deriv2_classes[3][6][92] = int_stack + 164927;
 Libderiv->deriv2_classes[3][7][92] = int_stack + 165207;
 Libderiv->deriv2_classes[3][8][92] = int_stack + 165567;
 Libderiv->deriv2_classes[3][9][92] = int_stack + 166017;
 Libderiv->deriv2_classes[3][10][92] = int_stack + 166567;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 167227;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 167542;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 167962;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 168502;
 Libderiv->deriv2_classes[4][9][92] = int_stack + 169177;
 Libderiv->deriv2_classes[4][10][92] = int_stack + 170002;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 170992;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 171433;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 172021;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 172777;
 Libderiv->deriv2_classes[5][9][92] = int_stack + 173722;
 Libderiv->deriv2_classes[5][10][92] = int_stack + 174877;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 176263;
 Libderiv->deriv2_classes[3][6][91] = int_stack + 176473;
 Libderiv->deriv2_classes[3][7][91] = int_stack + 176753;
 Libderiv->deriv2_classes[3][8][91] = int_stack + 177113;
 Libderiv->deriv2_classes[3][9][91] = int_stack + 177563;
 Libderiv->deriv2_classes[3][10][91] = int_stack + 178113;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 178773;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 179088;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 179508;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 180048;
 Libderiv->deriv2_classes[4][9][91] = int_stack + 180723;
 Libderiv->deriv2_classes[4][10][91] = int_stack + 181548;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 182538;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 182979;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 183567;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 184323;
 Libderiv->deriv2_classes[5][9][91] = int_stack + 185268;
 Libderiv->deriv2_classes[5][10][91] = int_stack + 186423;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 187809;
 Libderiv->deriv2_classes[3][6][83] = int_stack + 188019;
 Libderiv->deriv2_classes[3][7][83] = int_stack + 188299;
 Libderiv->deriv2_classes[3][8][83] = int_stack + 188659;
 Libderiv->deriv2_classes[3][9][83] = int_stack + 189109;
 Libderiv->deriv2_classes[3][10][83] = int_stack + 189659;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 190319;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 190634;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 191054;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 191594;
 Libderiv->deriv2_classes[4][9][83] = int_stack + 192269;
 Libderiv->deriv2_classes[4][10][83] = int_stack + 193094;
 Libderiv->deriv_classes[5][5][11] = int_stack + 194084;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 194525;
 Libderiv->deriv_classes[5][6][11] = int_stack + 194966;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 195554;
 Libderiv->deriv_classes[5][7][11] = int_stack + 196142;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 196898;
 Libderiv->deriv_classes[5][8][11] = int_stack + 197654;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 198599;
 Libderiv->deriv_classes[5][9][11] = int_stack + 199544;
 Libderiv->deriv2_classes[5][9][83] = int_stack + 200699;
 Libderiv->deriv2_classes[5][10][83] = int_stack + 201854;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 203240;
 Libderiv->deriv2_classes[3][6][82] = int_stack + 203450;
 Libderiv->deriv2_classes[3][7][82] = int_stack + 203730;
 Libderiv->deriv2_classes[3][8][82] = int_stack + 204090;
 Libderiv->deriv2_classes[3][9][82] = int_stack + 204540;
 Libderiv->deriv2_classes[3][10][82] = int_stack + 205090;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 205750;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 206065;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 206485;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 207025;
 Libderiv->deriv2_classes[4][9][82] = int_stack + 207700;
 Libderiv->deriv2_classes[4][10][82] = int_stack + 208525;
 Libderiv->deriv_classes[5][5][10] = int_stack + 209515;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 209956;
 Libderiv->deriv_classes[5][6][10] = int_stack + 210397;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 210985;
 Libderiv->deriv_classes[5][7][10] = int_stack + 211573;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 212329;
 Libderiv->deriv_classes[5][8][10] = int_stack + 213085;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 214030;
 Libderiv->deriv_classes[5][9][10] = int_stack + 214975;
 Libderiv->deriv2_classes[5][9][82] = int_stack + 216130;
 Libderiv->deriv2_classes[5][10][82] = int_stack + 217285;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 218671;
 Libderiv->deriv2_classes[3][6][81] = int_stack + 218881;
 Libderiv->deriv2_classes[3][7][81] = int_stack + 219161;
 Libderiv->deriv2_classes[3][8][81] = int_stack + 219521;
 Libderiv->deriv2_classes[3][9][81] = int_stack + 219971;
 Libderiv->deriv2_classes[3][10][81] = int_stack + 220521;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 221181;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 221496;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 221916;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 222456;
 Libderiv->deriv2_classes[4][9][81] = int_stack + 223131;
 Libderiv->deriv2_classes[4][10][81] = int_stack + 223956;
 Libderiv->deriv_classes[5][5][9] = int_stack + 224946;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 225387;
 Libderiv->deriv_classes[5][6][9] = int_stack + 225828;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 226416;
 Libderiv->deriv_classes[5][7][9] = int_stack + 227004;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 227760;
 Libderiv->deriv_classes[5][8][9] = int_stack + 228516;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 229461;
 Libderiv->deriv_classes[5][9][9] = int_stack + 230406;
 Libderiv->deriv2_classes[5][9][81] = int_stack + 231561;
 Libderiv->deriv2_classes[5][10][81] = int_stack + 232716;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 234102;
 Libderiv->deriv2_classes[3][6][80] = int_stack + 234312;
 Libderiv->deriv2_classes[3][7][80] = int_stack + 234592;
 Libderiv->deriv2_classes[3][8][80] = int_stack + 234952;
 Libderiv->deriv2_classes[3][9][80] = int_stack + 235402;
 Libderiv->deriv2_classes[3][10][80] = int_stack + 235952;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 236612;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 236927;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 237347;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 237887;
 Libderiv->deriv2_classes[4][9][80] = int_stack + 238562;
 Libderiv->deriv2_classes[4][10][80] = int_stack + 239387;
 Libderiv->deriv_classes[5][5][8] = int_stack + 240377;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 240818;
 Libderiv->deriv_classes[5][6][8] = int_stack + 241259;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 241847;
 Libderiv->deriv_classes[5][7][8] = int_stack + 242435;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 243191;
 Libderiv->deriv_classes[5][8][8] = int_stack + 243947;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 244892;
 Libderiv->deriv_classes[5][9][8] = int_stack + 245837;
 Libderiv->deriv2_classes[5][9][80] = int_stack + 246992;
 Libderiv->deriv2_classes[5][10][80] = int_stack + 248147;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 249533;
 Libderiv->deriv2_classes[3][6][79] = int_stack + 249743;
 Libderiv->deriv2_classes[3][7][79] = int_stack + 250023;
 Libderiv->deriv2_classes[3][8][79] = int_stack + 250383;
 Libderiv->deriv2_classes[3][9][79] = int_stack + 250833;
 Libderiv->deriv2_classes[3][10][79] = int_stack + 251383;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 252043;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 252358;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 252778;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 253318;
 Libderiv->deriv2_classes[4][9][79] = int_stack + 253993;
 Libderiv->deriv2_classes[4][10][79] = int_stack + 254818;
 Libderiv->deriv_classes[5][5][7] = int_stack + 255808;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 256249;
 Libderiv->deriv_classes[5][6][7] = int_stack + 256690;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 257278;
 Libderiv->deriv_classes[5][7][7] = int_stack + 257866;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 258622;
 Libderiv->deriv_classes[5][8][7] = int_stack + 259378;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 260323;
 Libderiv->deriv_classes[5][9][7] = int_stack + 261268;
 Libderiv->deriv2_classes[5][9][79] = int_stack + 262423;
 Libderiv->deriv2_classes[5][10][79] = int_stack + 263578;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 264964;
 Libderiv->deriv2_classes[3][6][78] = int_stack + 265174;
 Libderiv->deriv2_classes[3][7][78] = int_stack + 265454;
 Libderiv->deriv2_classes[3][8][78] = int_stack + 265814;
 Libderiv->deriv2_classes[3][9][78] = int_stack + 266264;
 Libderiv->deriv2_classes[3][10][78] = int_stack + 266814;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 267474;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 267789;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 268209;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 268749;
 Libderiv->deriv2_classes[4][9][78] = int_stack + 269424;
 Libderiv->deriv2_classes[4][10][78] = int_stack + 270249;
 Libderiv->dvrr_classes[5][5] = int_stack + 271239;
 Libderiv->deriv_classes[5][5][6] = int_stack + 271680;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 272121;
 Libderiv->dvrr_classes[5][6] = int_stack + 272562;
 Libderiv->deriv_classes[5][6][6] = int_stack + 273150;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 273738;
 Libderiv->dvrr_classes[5][7] = int_stack + 274326;
 Libderiv->deriv_classes[5][7][6] = int_stack + 275082;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 275838;
 Libderiv->dvrr_classes[5][8] = int_stack + 276594;
 Libderiv->deriv_classes[5][8][6] = int_stack + 277539;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 278484;
 Libderiv->deriv_classes[5][9][6] = int_stack + 279429;
 Libderiv->deriv2_classes[5][9][78] = int_stack + 280584;
 Libderiv->deriv2_classes[5][10][78] = int_stack + 281739;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 283125;
 Libderiv->deriv2_classes[3][6][35] = int_stack + 283335;
 Libderiv->deriv2_classes[3][7][35] = int_stack + 283615;
 Libderiv->deriv2_classes[3][8][35] = int_stack + 283975;
 Libderiv->deriv2_classes[3][9][35] = int_stack + 284425;
 Libderiv->deriv2_classes[3][10][35] = int_stack + 284975;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 285635;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 285950;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 286370;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 286910;
 Libderiv->deriv2_classes[4][9][35] = int_stack + 287585;
 Libderiv->deriv2_classes[4][10][35] = int_stack + 288410;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 289400;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 289841;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 290429;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 291185;
 Libderiv->deriv2_classes[5][9][35] = int_stack + 292130;
 Libderiv->deriv2_classes[5][10][35] = int_stack + 293285;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 294671;
 Libderiv->deriv2_classes[3][6][34] = int_stack + 294881;
 Libderiv->deriv2_classes[3][7][34] = int_stack + 295161;
 Libderiv->deriv2_classes[3][8][34] = int_stack + 295521;
 Libderiv->deriv2_classes[3][9][34] = int_stack + 295971;
 Libderiv->deriv2_classes[3][10][34] = int_stack + 296521;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 297181;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 297496;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 297916;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 298456;
 Libderiv->deriv2_classes[4][9][34] = int_stack + 299131;
 Libderiv->deriv2_classes[4][10][34] = int_stack + 299956;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 300946;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 301387;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 301975;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 302731;
 Libderiv->deriv2_classes[5][9][34] = int_stack + 303676;
 Libderiv->deriv2_classes[5][10][34] = int_stack + 304831;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 306217;
 Libderiv->deriv2_classes[3][6][33] = int_stack + 306427;
 Libderiv->deriv2_classes[3][7][33] = int_stack + 306707;
 Libderiv->deriv2_classes[3][8][33] = int_stack + 307067;
 Libderiv->deriv2_classes[3][9][33] = int_stack + 307517;
 Libderiv->deriv2_classes[3][10][33] = int_stack + 308067;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 308727;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 309042;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 309462;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 310002;
 Libderiv->deriv2_classes[4][9][33] = int_stack + 310677;
 Libderiv->deriv2_classes[4][10][33] = int_stack + 311502;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 312492;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 312933;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 313521;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 314277;
 Libderiv->deriv2_classes[5][9][33] = int_stack + 315222;
 Libderiv->deriv2_classes[5][10][33] = int_stack + 316377;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 317763;
 Libderiv->deriv2_classes[3][6][32] = int_stack + 317973;
 Libderiv->deriv2_classes[3][7][32] = int_stack + 318253;
 Libderiv->deriv2_classes[3][8][32] = int_stack + 318613;
 Libderiv->deriv2_classes[3][9][32] = int_stack + 319063;
 Libderiv->deriv2_classes[3][10][32] = int_stack + 319613;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 320273;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 320588;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 321008;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 321548;
 Libderiv->deriv2_classes[4][9][32] = int_stack + 322223;
 Libderiv->deriv2_classes[4][10][32] = int_stack + 323048;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 324038;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 324479;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 325067;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 325823;
 Libderiv->deriv2_classes[5][9][32] = int_stack + 326768;
 Libderiv->deriv2_classes[5][10][32] = int_stack + 327923;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 329309;
 Libderiv->deriv2_classes[3][6][31] = int_stack + 329519;
 Libderiv->deriv2_classes[3][7][31] = int_stack + 329799;
 Libderiv->deriv2_classes[3][8][31] = int_stack + 330159;
 Libderiv->deriv2_classes[3][9][31] = int_stack + 330609;
 Libderiv->deriv2_classes[3][10][31] = int_stack + 331159;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 331819;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 332134;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 332554;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 333094;
 Libderiv->deriv2_classes[4][9][31] = int_stack + 333769;
 Libderiv->deriv2_classes[4][10][31] = int_stack + 334594;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 335584;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 336025;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 336613;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 337369;
 Libderiv->deriv2_classes[5][9][31] = int_stack + 338314;
 Libderiv->deriv2_classes[5][10][31] = int_stack + 339469;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 340855;
 Libderiv->deriv2_classes[3][6][30] = int_stack + 341065;
 Libderiv->deriv2_classes[3][7][30] = int_stack + 341345;
 Libderiv->deriv2_classes[3][8][30] = int_stack + 341705;
 Libderiv->deriv2_classes[3][9][30] = int_stack + 342155;
 Libderiv->deriv2_classes[3][10][30] = int_stack + 342705;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 343365;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 343680;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 344100;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 344640;
 Libderiv->deriv2_classes[4][9][30] = int_stack + 345315;
 Libderiv->deriv2_classes[4][10][30] = int_stack + 346140;
 Libderiv->deriv_classes[5][5][2] = int_stack + 347130;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 347571;
 Libderiv->deriv_classes[5][6][2] = int_stack + 348012;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 348600;
 Libderiv->deriv_classes[5][7][2] = int_stack + 349188;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 349944;
 Libderiv->deriv_classes[5][8][2] = int_stack + 350700;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 351645;
 Libderiv->deriv_classes[5][9][2] = int_stack + 352590;
 Libderiv->deriv2_classes[5][9][30] = int_stack + 353745;
 Libderiv->deriv2_classes[5][10][30] = int_stack + 354900;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 356286;
 Libderiv->deriv2_classes[3][6][26] = int_stack + 356496;
 Libderiv->deriv2_classes[3][7][26] = int_stack + 356776;
 Libderiv->deriv2_classes[3][8][26] = int_stack + 357136;
 Libderiv->deriv2_classes[3][9][26] = int_stack + 357586;
 Libderiv->deriv2_classes[3][10][26] = int_stack + 358136;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 358796;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 359111;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 359531;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 360071;
 Libderiv->deriv2_classes[4][9][26] = int_stack + 360746;
 Libderiv->deriv2_classes[4][10][26] = int_stack + 361571;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 362561;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 363002;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 363590;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 364346;
 Libderiv->deriv2_classes[5][9][26] = int_stack + 365291;
 Libderiv->deriv2_classes[5][10][26] = int_stack + 366446;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 367832;
 Libderiv->deriv2_classes[3][6][23] = int_stack + 368042;
 Libderiv->deriv2_classes[3][7][23] = int_stack + 368322;
 Libderiv->deriv2_classes[3][8][23] = int_stack + 368682;
 Libderiv->deriv2_classes[3][9][23] = int_stack + 369132;
 Libderiv->deriv2_classes[3][10][23] = int_stack + 369682;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 370342;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 370657;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 371077;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 371617;
 Libderiv->deriv2_classes[4][9][23] = int_stack + 372292;
 Libderiv->deriv2_classes[4][10][23] = int_stack + 373117;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 374107;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 374548;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 375136;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 375892;
 Libderiv->deriv2_classes[5][9][23] = int_stack + 376837;
 Libderiv->deriv2_classes[5][10][23] = int_stack + 377992;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 379378;
 Libderiv->deriv2_classes[3][6][22] = int_stack + 379588;
 Libderiv->deriv2_classes[3][7][22] = int_stack + 379868;
 Libderiv->deriv2_classes[3][8][22] = int_stack + 380228;
 Libderiv->deriv2_classes[3][9][22] = int_stack + 380678;
 Libderiv->deriv2_classes[3][10][22] = int_stack + 381228;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 381888;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 382203;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 382623;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 383163;
 Libderiv->deriv2_classes[4][9][22] = int_stack + 383838;
 Libderiv->deriv2_classes[4][10][22] = int_stack + 384663;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 385653;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 386094;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 386682;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 387438;
 Libderiv->deriv2_classes[5][9][22] = int_stack + 388383;
 Libderiv->deriv2_classes[5][10][22] = int_stack + 389538;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 390924;
 Libderiv->deriv2_classes[3][6][21] = int_stack + 391134;
 Libderiv->deriv2_classes[3][7][21] = int_stack + 391414;
 Libderiv->deriv2_classes[3][8][21] = int_stack + 391774;
 Libderiv->deriv2_classes[3][9][21] = int_stack + 392224;
 Libderiv->deriv2_classes[3][10][21] = int_stack + 392774;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 393434;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 393749;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 394169;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 394709;
 Libderiv->deriv2_classes[4][9][21] = int_stack + 395384;
 Libderiv->deriv2_classes[4][10][21] = int_stack + 396209;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 397199;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 397640;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 398228;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 398984;
 Libderiv->deriv2_classes[5][9][21] = int_stack + 399929;
 Libderiv->deriv2_classes[5][10][21] = int_stack + 401084;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 402470;
 Libderiv->deriv2_classes[3][6][20] = int_stack + 402680;
 Libderiv->deriv2_classes[3][7][20] = int_stack + 402960;
 Libderiv->deriv2_classes[3][8][20] = int_stack + 403320;
 Libderiv->deriv2_classes[3][9][20] = int_stack + 403770;
 Libderiv->deriv2_classes[3][10][20] = int_stack + 404320;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 404980;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 405295;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 405715;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 406255;
 Libderiv->deriv2_classes[4][9][20] = int_stack + 406930;
 Libderiv->deriv2_classes[4][10][20] = int_stack + 407755;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 408745;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 409186;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 409774;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 410530;
 Libderiv->deriv2_classes[5][9][20] = int_stack + 411475;
 Libderiv->deriv2_classes[5][10][20] = int_stack + 412630;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 414016;
 Libderiv->deriv2_classes[3][6][19] = int_stack + 414226;
 Libderiv->deriv2_classes[3][7][19] = int_stack + 414506;
 Libderiv->deriv2_classes[3][8][19] = int_stack + 414866;
 Libderiv->deriv2_classes[3][9][19] = int_stack + 415316;
 Libderiv->deriv2_classes[3][10][19] = int_stack + 415866;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 416526;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 416841;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 417261;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 417801;
 Libderiv->deriv2_classes[4][9][19] = int_stack + 418476;
 Libderiv->deriv2_classes[4][10][19] = int_stack + 419301;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 420291;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 420732;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 421320;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 422076;
 Libderiv->deriv2_classes[5][9][19] = int_stack + 423021;
 Libderiv->deriv2_classes[5][10][19] = int_stack + 424176;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 425562;
 Libderiv->deriv2_classes[3][6][18] = int_stack + 425772;
 Libderiv->deriv2_classes[3][7][18] = int_stack + 426052;
 Libderiv->deriv2_classes[3][8][18] = int_stack + 426412;
 Libderiv->deriv2_classes[3][9][18] = int_stack + 426862;
 Libderiv->deriv2_classes[3][10][18] = int_stack + 427412;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 428072;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 428387;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 428807;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 429347;
 Libderiv->deriv2_classes[4][9][18] = int_stack + 430022;
 Libderiv->deriv2_classes[4][10][18] = int_stack + 430847;
 Libderiv->deriv_classes[5][5][1] = int_stack + 431837;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 432278;
 Libderiv->deriv_classes[5][6][1] = int_stack + 432719;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 433307;
 Libderiv->deriv_classes[5][7][1] = int_stack + 433895;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 434651;
 Libderiv->deriv_classes[5][8][1] = int_stack + 435407;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 436352;
 Libderiv->deriv_classes[5][9][1] = int_stack + 437297;
 Libderiv->deriv2_classes[5][9][18] = int_stack + 438452;
 Libderiv->deriv2_classes[5][10][18] = int_stack + 439607;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 440993;
 Libderiv->deriv2_classes[3][6][14] = int_stack + 441203;
 Libderiv->deriv2_classes[3][7][14] = int_stack + 441483;
 Libderiv->deriv2_classes[3][8][14] = int_stack + 441843;
 Libderiv->deriv2_classes[3][9][14] = int_stack + 442293;
 Libderiv->deriv2_classes[3][10][14] = int_stack + 442843;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 443503;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 443818;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 444238;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 444778;
 Libderiv->deriv2_classes[4][9][14] = int_stack + 445453;
 Libderiv->deriv2_classes[4][10][14] = int_stack + 446278;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 447268;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 447709;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 448297;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 449053;
 Libderiv->deriv2_classes[5][9][14] = int_stack + 449998;
 Libderiv->deriv2_classes[5][10][14] = int_stack + 451153;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 452539;
 Libderiv->deriv2_classes[3][6][13] = int_stack + 452749;
 Libderiv->deriv2_classes[3][7][13] = int_stack + 453029;
 Libderiv->deriv2_classes[3][8][13] = int_stack + 453389;
 Libderiv->deriv2_classes[3][9][13] = int_stack + 453839;
 Libderiv->deriv2_classes[3][10][13] = int_stack + 454389;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 455049;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 455364;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 455784;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 456324;
 Libderiv->deriv2_classes[4][9][13] = int_stack + 456999;
 Libderiv->deriv2_classes[4][10][13] = int_stack + 457824;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 458814;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 459255;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 459843;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 460599;
 Libderiv->deriv2_classes[5][9][13] = int_stack + 461544;
 Libderiv->deriv2_classes[5][10][13] = int_stack + 462699;
 Libderiv->deriv_classes[3][5][11] = int_stack + 464085;
 Libderiv->deriv_classes[3][6][11] = int_stack + 464295;
 Libderiv->deriv_classes[3][7][11] = int_stack + 464575;
 Libderiv->deriv_classes[3][8][11] = int_stack + 464935;
 Libderiv->deriv_classes[3][9][11] = int_stack + 465385;
 Libderiv->deriv_classes[3][10][11] = int_stack + 465935;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 466595;
 Libderiv->deriv2_classes[3][6][11] = int_stack + 466805;
 Libderiv->deriv2_classes[3][7][11] = int_stack + 467085;
 Libderiv->deriv2_classes[3][8][11] = int_stack + 467445;
 Libderiv->deriv2_classes[3][9][11] = int_stack + 467895;
 Libderiv->deriv2_classes[3][10][11] = int_stack + 468445;
 Libderiv->deriv_classes[4][5][11] = int_stack + 469105;
 Libderiv->deriv_classes[4][6][11] = int_stack + 469420;
 Libderiv->deriv_classes[4][7][11] = int_stack + 469840;
 Libderiv->deriv_classes[4][8][11] = int_stack + 470380;
 Libderiv->deriv_classes[4][9][11] = int_stack + 471055;
 Libderiv->deriv_classes[4][10][11] = int_stack + 471880;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 472870;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 473185;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 473605;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 474145;
 Libderiv->deriv2_classes[4][9][11] = int_stack + 474820;
 Libderiv->deriv2_classes[4][10][11] = int_stack + 475645;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 476635;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 477076;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 477664;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 478420;
 Libderiv->deriv2_classes[5][9][11] = int_stack + 479365;
 Libderiv->deriv2_classes[5][10][11] = int_stack + 480520;
 Libderiv->deriv_classes[3][5][10] = int_stack + 481906;
 Libderiv->deriv_classes[3][6][10] = int_stack + 482116;
 Libderiv->deriv_classes[3][7][10] = int_stack + 482396;
 Libderiv->deriv_classes[3][8][10] = int_stack + 482756;
 Libderiv->deriv_classes[3][9][10] = int_stack + 483206;
 Libderiv->deriv_classes[3][10][10] = int_stack + 483756;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 484416;
 Libderiv->deriv2_classes[3][6][10] = int_stack + 484626;
 Libderiv->deriv2_classes[3][7][10] = int_stack + 484906;
 Libderiv->deriv2_classes[3][8][10] = int_stack + 485266;
 Libderiv->deriv2_classes[3][9][10] = int_stack + 485716;
 Libderiv->deriv2_classes[3][10][10] = int_stack + 486266;
 Libderiv->deriv_classes[4][5][10] = int_stack + 486926;
 Libderiv->deriv_classes[4][6][10] = int_stack + 487241;
 Libderiv->deriv_classes[4][7][10] = int_stack + 487661;
 Libderiv->deriv_classes[4][8][10] = int_stack + 488201;
 Libderiv->deriv_classes[4][9][10] = int_stack + 488876;
 Libderiv->deriv_classes[4][10][10] = int_stack + 489701;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 490691;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 491006;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 491426;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 491966;
 Libderiv->deriv2_classes[4][9][10] = int_stack + 492641;
 Libderiv->deriv2_classes[4][10][10] = int_stack + 493466;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 494456;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 494897;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 495485;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 496241;
 Libderiv->deriv2_classes[5][9][10] = int_stack + 497186;
 Libderiv->deriv2_classes[5][10][10] = int_stack + 498341;
 Libderiv->deriv_classes[3][5][9] = int_stack + 499727;
 Libderiv->deriv_classes[3][6][9] = int_stack + 499937;
 Libderiv->deriv_classes[3][7][9] = int_stack + 500217;
 Libderiv->deriv_classes[3][8][9] = int_stack + 500577;
 Libderiv->deriv_classes[3][9][9] = int_stack + 501027;
 Libderiv->deriv_classes[3][10][9] = int_stack + 501577;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 502237;
 Libderiv->deriv2_classes[3][6][9] = int_stack + 502447;
 Libderiv->deriv2_classes[3][7][9] = int_stack + 502727;
 Libderiv->deriv2_classes[3][8][9] = int_stack + 503087;
 Libderiv->deriv2_classes[3][9][9] = int_stack + 503537;
 Libderiv->deriv2_classes[3][10][9] = int_stack + 504087;
 Libderiv->deriv_classes[4][5][9] = int_stack + 504747;
 Libderiv->deriv_classes[4][6][9] = int_stack + 505062;
 Libderiv->deriv_classes[4][7][9] = int_stack + 505482;
 Libderiv->deriv_classes[4][8][9] = int_stack + 506022;
 Libderiv->deriv_classes[4][9][9] = int_stack + 506697;
 Libderiv->deriv_classes[4][10][9] = int_stack + 507522;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 508512;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 508827;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 509247;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 509787;
 Libderiv->deriv2_classes[4][9][9] = int_stack + 510462;
 Libderiv->deriv2_classes[4][10][9] = int_stack + 511287;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 512277;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 512718;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 513306;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 514062;
 Libderiv->deriv2_classes[5][9][9] = int_stack + 515007;
 Libderiv->deriv2_classes[5][10][9] = int_stack + 516162;
 Libderiv->deriv_classes[3][5][8] = int_stack + 517548;
 Libderiv->deriv_classes[3][6][8] = int_stack + 517758;
 Libderiv->deriv_classes[3][7][8] = int_stack + 518038;
 Libderiv->deriv_classes[3][8][8] = int_stack + 518398;
 Libderiv->deriv_classes[3][9][8] = int_stack + 518848;
 Libderiv->deriv_classes[3][10][8] = int_stack + 519398;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 520058;
 Libderiv->deriv2_classes[3][6][8] = int_stack + 520268;
 Libderiv->deriv2_classes[3][7][8] = int_stack + 520548;
 Libderiv->deriv2_classes[3][8][8] = int_stack + 520908;
 Libderiv->deriv2_classes[3][9][8] = int_stack + 521358;
 Libderiv->deriv2_classes[3][10][8] = int_stack + 521908;
 Libderiv->deriv_classes[4][5][8] = int_stack + 522568;
 Libderiv->deriv_classes[4][6][8] = int_stack + 522883;
 Libderiv->deriv_classes[4][7][8] = int_stack + 523303;
 Libderiv->deriv_classes[4][8][8] = int_stack + 523843;
 Libderiv->deriv_classes[4][9][8] = int_stack + 524518;
 Libderiv->deriv_classes[4][10][8] = int_stack + 525343;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 526333;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 526648;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 527068;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 527608;
 Libderiv->deriv2_classes[4][9][8] = int_stack + 528283;
 Libderiv->deriv2_classes[4][10][8] = int_stack + 529108;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 530098;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 530539;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 531127;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 531883;
 Libderiv->deriv2_classes[5][9][8] = int_stack + 532828;
 Libderiv->deriv2_classes[5][10][8] = int_stack + 533983;
 Libderiv->deriv_classes[3][5][7] = int_stack + 535369;
 Libderiv->deriv_classes[3][6][7] = int_stack + 535579;
 Libderiv->deriv_classes[3][7][7] = int_stack + 535859;
 Libderiv->deriv_classes[3][8][7] = int_stack + 536219;
 Libderiv->deriv_classes[3][9][7] = int_stack + 536669;
 Libderiv->deriv_classes[3][10][7] = int_stack + 537219;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 537879;
 Libderiv->deriv2_classes[3][6][7] = int_stack + 538089;
 Libderiv->deriv2_classes[3][7][7] = int_stack + 538369;
 Libderiv->deriv2_classes[3][8][7] = int_stack + 538729;
 Libderiv->deriv2_classes[3][9][7] = int_stack + 539179;
 Libderiv->deriv2_classes[3][10][7] = int_stack + 539729;
 Libderiv->deriv_classes[4][5][7] = int_stack + 540389;
 Libderiv->deriv_classes[4][6][7] = int_stack + 540704;
 Libderiv->deriv_classes[4][7][7] = int_stack + 541124;
 Libderiv->deriv_classes[4][8][7] = int_stack + 541664;
 Libderiv->deriv_classes[4][9][7] = int_stack + 542339;
 Libderiv->deriv_classes[4][10][7] = int_stack + 543164;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 544154;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 544469;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 544889;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 545429;
 Libderiv->deriv2_classes[4][9][7] = int_stack + 546104;
 Libderiv->deriv2_classes[4][10][7] = int_stack + 546929;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 547919;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 548360;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 548948;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 549704;
 Libderiv->deriv2_classes[5][9][7] = int_stack + 550649;
 Libderiv->deriv2_classes[5][10][7] = int_stack + 551804;
 Libderiv->deriv_classes[3][5][6] = int_stack + 553190;
 Libderiv->deriv_classes[3][6][6] = int_stack + 553400;
 Libderiv->deriv_classes[3][7][6] = int_stack + 553680;
 Libderiv->deriv_classes[3][8][6] = int_stack + 554040;
 Libderiv->deriv_classes[3][9][6] = int_stack + 554490;
 Libderiv->deriv_classes[3][10][6] = int_stack + 555040;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 555700;
 Libderiv->deriv2_classes[3][6][6] = int_stack + 555910;
 Libderiv->deriv2_classes[3][7][6] = int_stack + 556190;
 Libderiv->deriv2_classes[3][8][6] = int_stack + 556550;
 Libderiv->deriv2_classes[3][9][6] = int_stack + 557000;
 Libderiv->deriv2_classes[3][10][6] = int_stack + 557550;
 Libderiv->dvrr_classes[4][5] = int_stack + 558210;
 Libderiv->deriv_classes[4][5][6] = int_stack + 558525;
 Libderiv->dvrr_classes[4][6] = int_stack + 558840;
 Libderiv->deriv_classes[4][6][6] = int_stack + 559260;
 Libderiv->dvrr_classes[4][7] = int_stack + 559680;
 Libderiv->deriv_classes[4][7][6] = int_stack + 560220;
 Libderiv->dvrr_classes[4][8] = int_stack + 560760;
 Libderiv->deriv_classes[4][8][6] = int_stack + 561435;
 Libderiv->dvrr_classes[4][9] = int_stack + 562110;
 Libderiv->deriv_classes[4][9][6] = int_stack + 562935;
 Libderiv->deriv_classes[4][10][6] = int_stack + 563760;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 564750;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 565065;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 565485;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 566025;
 Libderiv->deriv2_classes[4][9][6] = int_stack + 566700;
 Libderiv->deriv2_classes[4][10][6] = int_stack + 567525;
 Libderiv->deriv_classes[5][5][0] = int_stack + 568515;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 568956;
 Libderiv->deriv_classes[5][6][0] = int_stack + 569397;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 569985;
 Libderiv->deriv_classes[5][7][0] = int_stack + 570573;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 571329;
 Libderiv->deriv_classes[5][8][0] = int_stack + 572085;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 573030;
 Libderiv->deriv_classes[5][9][0] = int_stack + 573975;
 Libderiv->deriv2_classes[5][9][6] = int_stack + 575130;
 Libderiv->deriv2_classes[5][10][6] = int_stack + 576285;
 Libderiv->deriv_classes[3][5][2] = int_stack + 577671;
 Libderiv->deriv_classes[3][6][2] = int_stack + 577881;
 Libderiv->deriv_classes[3][7][2] = int_stack + 578161;
 Libderiv->deriv_classes[3][8][2] = int_stack + 578521;
 Libderiv->deriv_classes[3][9][2] = int_stack + 578971;
 Libderiv->deriv_classes[3][10][2] = int_stack + 579521;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 580181;
 Libderiv->deriv2_classes[3][6][2] = int_stack + 580391;
 Libderiv->deriv2_classes[3][7][2] = int_stack + 580671;
 Libderiv->deriv2_classes[3][8][2] = int_stack + 581031;
 Libderiv->deriv2_classes[3][9][2] = int_stack + 581481;
 Libderiv->deriv2_classes[3][10][2] = int_stack + 582031;
 Libderiv->deriv_classes[4][5][2] = int_stack + 582691;
 Libderiv->deriv_classes[4][6][2] = int_stack + 583006;
 Libderiv->deriv_classes[4][7][2] = int_stack + 583426;
 Libderiv->deriv_classes[4][8][2] = int_stack + 583966;
 Libderiv->deriv_classes[4][9][2] = int_stack + 584641;
 Libderiv->deriv_classes[4][10][2] = int_stack + 585466;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 586456;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 586771;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 587191;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 587731;
 Libderiv->deriv2_classes[4][9][2] = int_stack + 588406;
 Libderiv->deriv2_classes[4][10][2] = int_stack + 589231;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 590221;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 590662;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 591250;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 592006;
 Libderiv->deriv2_classes[5][9][2] = int_stack + 592951;
 Libderiv->deriv2_classes[5][10][2] = int_stack + 594106;
 Libderiv->deriv_classes[3][5][1] = int_stack + 595492;
 Libderiv->deriv_classes[3][6][1] = int_stack + 595702;
 Libderiv->deriv_classes[3][7][1] = int_stack + 595982;
 Libderiv->deriv_classes[3][8][1] = int_stack + 596342;
 Libderiv->deriv_classes[3][9][1] = int_stack + 596792;
 Libderiv->deriv_classes[3][10][1] = int_stack + 597342;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 598002;
 Libderiv->deriv2_classes[3][6][1] = int_stack + 598212;
 Libderiv->deriv2_classes[3][7][1] = int_stack + 598492;
 Libderiv->deriv2_classes[3][8][1] = int_stack + 598852;
 Libderiv->deriv2_classes[3][9][1] = int_stack + 599302;
 Libderiv->deriv2_classes[3][10][1] = int_stack + 599852;
 Libderiv->deriv_classes[4][5][1] = int_stack + 600512;
 Libderiv->deriv_classes[4][6][1] = int_stack + 600827;
 Libderiv->deriv_classes[4][7][1] = int_stack + 601247;
 Libderiv->deriv_classes[4][8][1] = int_stack + 601787;
 Libderiv->deriv_classes[4][9][1] = int_stack + 602462;
 Libderiv->deriv_classes[4][10][1] = int_stack + 603287;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 604277;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 604592;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 605012;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 605552;
 Libderiv->deriv2_classes[4][9][1] = int_stack + 606227;
 Libderiv->deriv2_classes[4][10][1] = int_stack + 607052;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 608042;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 608483;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 609071;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 609827;
 Libderiv->deriv2_classes[5][9][1] = int_stack + 610772;
 Libderiv->deriv2_classes[5][10][1] = int_stack + 611927;
 Libderiv->dvrr_classes[3][5] = int_stack + 613313;
 Libderiv->dvrr_classes[3][6] = int_stack + 613523;
 Libderiv->dvrr_classes[3][7] = int_stack + 613803;
 Libderiv->dvrr_classes[3][8] = int_stack + 614163;
 Libderiv->dvrr_classes[3][9] = int_stack + 614613;
 Libderiv->dvrr_classes[3][10] = int_stack + 615163;
 Libderiv->deriv_classes[3][5][0] = int_stack + 615823;
 Libderiv->deriv_classes[3][6][0] = int_stack + 616033;
 Libderiv->deriv_classes[3][7][0] = int_stack + 616313;
 Libderiv->deriv_classes[3][8][0] = int_stack + 616673;
 Libderiv->deriv_classes[3][9][0] = int_stack + 617123;
 Libderiv->deriv_classes[3][10][0] = int_stack + 617673;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 618333;
 Libderiv->deriv2_classes[3][6][0] = int_stack + 618543;
 Libderiv->deriv2_classes[3][7][0] = int_stack + 618823;
 Libderiv->deriv2_classes[3][8][0] = int_stack + 619183;
 Libderiv->deriv2_classes[3][9][0] = int_stack + 619633;
 Libderiv->deriv2_classes[3][10][0] = int_stack + 620183;
 Libderiv->deriv_classes[4][5][0] = int_stack + 620843;
 Libderiv->deriv_classes[4][6][0] = int_stack + 621158;
 Libderiv->deriv_classes[4][7][0] = int_stack + 621578;
 Libderiv->deriv_classes[4][8][0] = int_stack + 622118;
 Libderiv->deriv_classes[4][9][0] = int_stack + 622793;
 Libderiv->deriv_classes[4][10][0] = int_stack + 623618;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 624608;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 624923;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 625343;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 625883;
 Libderiv->deriv2_classes[4][9][0] = int_stack + 626558;
 Libderiv->deriv2_classes[4][10][0] = int_stack + 627383;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 628373;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 628814;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 629402;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 630158;
 Libderiv->deriv2_classes[5][9][0] = int_stack + 631103;
 Libderiv->deriv2_classes[5][10][0] = int_stack + 632258;
 memset(int_stack,0,5069152);

 Libderiv->dvrr_stack = int_stack + 2148343;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_fdhh(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+633644,int_stack+613523,int_stack+613313,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+634274,int_stack+613803,int_stack+613523,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+635114,int_stack+634274,int_stack+633644,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+636374,int_stack+614163,int_stack+613803,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+637454,int_stack+636374,int_stack+634274,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+639134,int_stack+637454,int_stack+635114,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+641234,int_stack+614613,int_stack+614163,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+642584,int_stack+641234,int_stack+636374,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+644744,int_stack+642584,int_stack+637454,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+647544,int_stack+644744,int_stack+639134,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+650694,int_stack+464295,int_stack+464085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613313,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+651324,int_stack+464575,int_stack+464295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613523,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+652164,int_stack+651324,int_stack+650694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633644,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+653424,int_stack+464935,int_stack+464575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613803,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+654504,int_stack+653424,int_stack+651324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634274,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+656184,int_stack+654504,int_stack+652164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635114,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+658284,int_stack+465385,int_stack+464935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614163,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+659634,int_stack+658284,int_stack+653424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+636374,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+661794,int_stack+659634,int_stack+654504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637454,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+664594,int_stack+661794,int_stack+656184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639134,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+667744,int_stack+465935,int_stack+465385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614613,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+669394,int_stack+667744,int_stack+658284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641234,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+672094,int_stack+669394,int_stack+659634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642584,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+667744,int_stack+672094,int_stack+661794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644744,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+671944,int_stack+667744,int_stack+664594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647544,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+667744,int_stack+558840,int_stack+558210,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+668689,int_stack+559680,int_stack+558840,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+669949,int_stack+668689,int_stack+667744,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+676354,int_stack+560760,int_stack+559680,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+677974,int_stack+676354,int_stack+668689,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+680494,int_stack+677974,int_stack+669949,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+683644,int_stack+562110,int_stack+560760,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+685669,int_stack+683644,int_stack+676354,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+688909,int_stack+685669,int_stack+677974,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+693109,int_stack+688909,int_stack+680494,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+697834,int_stack+469420,int_stack+469105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558210,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+698779,int_stack+469840,int_stack+469420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558840,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+700039,int_stack+698779,int_stack+697834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667744,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+701929,int_stack+470380,int_stack+469840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559680,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+703549,int_stack+701929,int_stack+698779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668689,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+706069,int_stack+703549,int_stack+700039, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669949,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+709219,int_stack+471055,int_stack+470380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560760,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+711244,int_stack+709219,int_stack+701929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676354,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+714484,int_stack+711244,int_stack+703549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677974,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+718684,int_stack+714484,int_stack+706069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680494,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+723409,int_stack+471880,int_stack+471055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562110,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+725884,int_stack+723409,int_stack+709219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683644,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+729934,int_stack+725884,int_stack+711244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+685669,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+723409,int_stack+729934,int_stack+714484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688909,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+729709,int_stack+723409,int_stack+718684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693109,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+736324,int_stack+729709,int_stack+671944,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+723409,int_stack+272562,int_stack+271239,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+724732,int_stack+274326,int_stack+272562,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+726496,int_stack+724732,int_stack+723409,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+749554,int_stack+276594,int_stack+274326,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+751822,int_stack+749554,int_stack+724732,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+755350,int_stack+751822,int_stack+726496,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+759760,int_stack+6930,int_stack+276594,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+762595,int_stack+759760,int_stack+749554,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+767131,int_stack+762595,int_stack+751822,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+773011,int_stack+767131,int_stack+755350,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779626,int_stack+194966,int_stack+194084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271239,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+780949,int_stack+196142,int_stack+194966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272562,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+782713,int_stack+780949,int_stack+779626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723409,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+785359,int_stack+197654,int_stack+196142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274326,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+787627,int_stack+785359,int_stack+780949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+724732,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+791155,int_stack+787627,int_stack+782713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726496,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+795565,int_stack+199544,int_stack+197654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276594,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+798400,int_stack+795565,int_stack+785359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749554,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+802936,int_stack+798400,int_stack+787627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751822,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+808816,int_stack+802936,int_stack+791155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755350,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+815431,int_stack+0,int_stack+199544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6930,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+818896,int_stack+815431,int_stack+795565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759760,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+824566,int_stack+818896,int_stack+798400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+762595,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+815431,int_stack+824566,int_stack+802936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767131,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+824251,int_stack+815431,int_stack+808816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773011,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+833512,int_stack+824251,int_stack+729709,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+815431,int_stack+482116,int_stack+481906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613313, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+816061,int_stack+482396,int_stack+482116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613523, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+816901,int_stack+816061,int_stack+815431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633644, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+818161,int_stack+482756,int_stack+482396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613803, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+819241,int_stack+818161,int_stack+816061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634274, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+820921,int_stack+819241,int_stack+816901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635114, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+823021,int_stack+483206,int_stack+482756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614163, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+824371,int_stack+823021,int_stack+818161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+636374, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+826531,int_stack+824371,int_stack+819241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637454, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+829331,int_stack+826531,int_stack+820921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639134, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+853357,int_stack+483756,int_stack+483206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614613, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+855007,int_stack+853357,int_stack+823021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641234, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+857707,int_stack+855007,int_stack+824371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642584, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+857707,int_stack+826531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644744, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+857557,int_stack+853357,int_stack+829331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647544, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+487241,int_stack+486926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558210, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+487661,int_stack+487241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558840, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667744, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+861967,int_stack+488201,int_stack+487661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559680, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+863587,int_stack+861967,int_stack+854302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668689, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+866107,int_stack+863587,int_stack+855562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669949, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+869257,int_stack+488876,int_stack+488201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560760, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+871282,int_stack+869257,int_stack+861967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676354, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+874522,int_stack+871282,int_stack+863587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677974, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+878722,int_stack+874522,int_stack+866107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680494, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+883447,int_stack+489701,int_stack+488876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562110, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+885922,int_stack+883447,int_stack+869257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683644, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+889972,int_stack+885922,int_stack+871282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+685669, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+883447,int_stack+889972,int_stack+874522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688909, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+889747,int_stack+883447,int_stack+878722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693109, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+896362,int_stack+889747,int_stack+857557,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+883447,int_stack+210397,int_stack+209515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271239, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+884770,int_stack+211573,int_stack+210397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272562, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+886534,int_stack+884770,int_stack+883447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723409, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+909592,int_stack+213085,int_stack+211573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274326, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+911860,int_stack+909592,int_stack+884770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+724732, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+915388,int_stack+911860,int_stack+886534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726496, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+919798,int_stack+214975,int_stack+213085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276594, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+922633,int_stack+919798,int_stack+909592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749554, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+927169,int_stack+922633,int_stack+911860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751822, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+933049,int_stack+927169,int_stack+915388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755350, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+939664,int_stack+1386,int_stack+214975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6930, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+943129,int_stack+939664,int_stack+919798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759760, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+948799,int_stack+943129,int_stack+922633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+762595, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+939664,int_stack+948799,int_stack+927169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767131, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+948484,int_stack+939664,int_stack+933049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773011, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+957745,int_stack+948484,int_stack+889747,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+939664,int_stack+499937,int_stack+499727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613313, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+940294,int_stack+500217,int_stack+499937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613523, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+941134,int_stack+940294,int_stack+939664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633644, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+942394,int_stack+500577,int_stack+500217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613803, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+943474,int_stack+942394,int_stack+940294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634274, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+945154,int_stack+943474,int_stack+941134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635114, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+947254,int_stack+501027,int_stack+500577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614163, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+948604,int_stack+947254,int_stack+942394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+636374, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+950764,int_stack+948604,int_stack+943474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637454, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+953564,int_stack+950764,int_stack+945154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639134, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+501577,int_stack+501027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614613, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+977590,int_stack+0,int_stack+947254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641234, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+980290,int_stack+977590,int_stack+948604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642584, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+983890,int_stack+980290,int_stack+950764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644744, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+977590,int_stack+983890,int_stack+953564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647544, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+505062,int_stack+504747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558210, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982945,int_stack+505482,int_stack+505062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558840, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+984205,int_stack+982945,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667744, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+986095,int_stack+506022,int_stack+505482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559680, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+986095,int_stack+982945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668689, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+987715,int_stack+0,int_stack+984205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669949, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+990865,int_stack+506697,int_stack+506022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560760, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+992890,int_stack+990865,int_stack+986095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676354, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+996130,int_stack+992890,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677974, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1000330,int_stack+996130,int_stack+987715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680494, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1005055,int_stack+507522,int_stack+506697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562110, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1007530,int_stack+1005055,int_stack+990865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683644, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1011580,int_stack+1007530,int_stack+992890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+685669, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1005055,int_stack+1011580,int_stack+996130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688909, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1011355,int_stack+1005055,int_stack+1000330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693109, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1017970,int_stack+1011355,int_stack+977590,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1005055,int_stack+225828,int_stack+224946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271239, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1006378,int_stack+227004,int_stack+225828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272562, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1008142,int_stack+1006378,int_stack+1005055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723409, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1031200,int_stack+228516,int_stack+227004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274326, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1033468,int_stack+1031200,int_stack+1006378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+724732, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1036996,int_stack+1033468,int_stack+1008142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726496, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1041406,int_stack+230406,int_stack+228516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276594, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1044241,int_stack+1041406,int_stack+1031200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749554, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1048777,int_stack+1044241,int_stack+1033468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751822, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1054657,int_stack+1048777,int_stack+1036996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755350, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1061272,int_stack+2772,int_stack+230406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6930, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1064737,int_stack+1061272,int_stack+1041406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759760, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1070407,int_stack+1064737,int_stack+1044241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+762595, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1061272,int_stack+1070407,int_stack+1048777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767131, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1070092,int_stack+1061272,int_stack+1054657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773011, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1079353,int_stack+1070092,int_stack+1011355,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1061272,int_stack+517758,int_stack+517548, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1061902,int_stack+518038,int_stack+517758, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1062742,int_stack+1061902,int_stack+1061272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1064002,int_stack+518398,int_stack+518038, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065082,int_stack+1064002,int_stack+1061902, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1066762,int_stack+1065082,int_stack+1062742, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1068862,int_stack+518848,int_stack+518398, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1070212,int_stack+1068862,int_stack+1064002, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+636374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1072372,int_stack+1070212,int_stack+1065082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1075172,int_stack+1072372,int_stack+1066762, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1099198,int_stack+519398,int_stack+518848, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1100848,int_stack+1099198,int_stack+1068862, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1103548,int_stack+1100848,int_stack+1070212, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+1103548,int_stack+1072372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1103398,int_stack+1099198,int_stack+1075172, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+522883,int_stack+522568, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+523303,int_stack+522883, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2520,int_stack+523843,int_stack+523303, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1107808,int_stack+2520,int_stack+1100143, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1110328,int_stack+1107808,int_stack+1101403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1113478,int_stack+524518,int_stack+523843, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1115503,int_stack+1113478,int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1118743,int_stack+1115503,int_stack+1107808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1122943,int_stack+1118743,int_stack+1110328, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1127668,int_stack+525343,int_stack+524518, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1130143,int_stack+1127668,int_stack+1113478, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1134193,int_stack+1130143,int_stack+1115503, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+685669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1127668,int_stack+1134193,int_stack+1118743, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1133968,int_stack+1127668,int_stack+1122943, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1140583,int_stack+1133968,int_stack+1103398,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1127668,int_stack+241259,int_stack+240377, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1128991,int_stack+242435,int_stack+241259, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1130755,int_stack+1128991,int_stack+1127668, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1153813,int_stack+243947,int_stack+242435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1156081,int_stack+1153813,int_stack+1128991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+724732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1159609,int_stack+1156081,int_stack+1130755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1164019,int_stack+245837,int_stack+243947, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1166854,int_stack+1164019,int_stack+1153813, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1171390,int_stack+1166854,int_stack+1156081, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1177270,int_stack+1171390,int_stack+1159609, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1183885,int_stack+4158,int_stack+245837, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1187350,int_stack+1183885,int_stack+1164019, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1193020,int_stack+1187350,int_stack+1166854, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+762595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1183885,int_stack+1193020,int_stack+1171390, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1192705,int_stack+1183885,int_stack+1177270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1201966,int_stack+1192705,int_stack+1133968,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1183885,int_stack+535579,int_stack+535369, 0.0, zero_stack, 1.0, int_stack+613313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1184515,int_stack+535859,int_stack+535579, 0.0, zero_stack, 1.0, int_stack+613523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1185355,int_stack+1184515,int_stack+1183885, 0.0, zero_stack, 1.0, int_stack+633644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1186615,int_stack+536219,int_stack+535859, 0.0, zero_stack, 1.0, int_stack+613803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1187695,int_stack+1186615,int_stack+1184515, 0.0, zero_stack, 1.0, int_stack+634274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1189375,int_stack+1187695,int_stack+1185355, 0.0, zero_stack, 1.0, int_stack+635114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1191475,int_stack+536669,int_stack+536219, 0.0, zero_stack, 1.0, int_stack+614163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1192825,int_stack+1191475,int_stack+1186615, 0.0, zero_stack, 1.0, int_stack+636374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1194985,int_stack+1192825,int_stack+1187695, 0.0, zero_stack, 1.0, int_stack+637454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1197785,int_stack+1194985,int_stack+1189375, 0.0, zero_stack, 1.0, int_stack+639134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1221811,int_stack+537219,int_stack+536669, 0.0, zero_stack, 1.0, int_stack+614613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1223461,int_stack+1221811,int_stack+1191475, 0.0, zero_stack, 1.0, int_stack+641234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1226161,int_stack+1223461,int_stack+1192825, 0.0, zero_stack, 1.0, int_stack+642584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1221811,int_stack+1226161,int_stack+1194985, 0.0, zero_stack, 1.0, int_stack+644744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1226011,int_stack+1221811,int_stack+1197785, 0.0, zero_stack, 1.0, int_stack+647544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1221811,int_stack+540704,int_stack+540389, 0.0, zero_stack, 1.0, int_stack+558210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1222756,int_stack+541124,int_stack+540704, 0.0, zero_stack, 1.0, int_stack+558840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1224016,int_stack+1222756,int_stack+1221811, 0.0, zero_stack, 1.0, int_stack+667744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1230421,int_stack+541664,int_stack+541124, 0.0, zero_stack, 1.0, int_stack+559680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1232041,int_stack+1230421,int_stack+1222756, 0.0, zero_stack, 1.0, int_stack+668689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1234561,int_stack+1232041,int_stack+1224016, 0.0, zero_stack, 1.0, int_stack+669949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1237711,int_stack+542339,int_stack+541664, 0.0, zero_stack, 1.0, int_stack+560760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1239736,int_stack+1237711,int_stack+1230421, 0.0, zero_stack, 1.0, int_stack+676354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1242976,int_stack+1239736,int_stack+1232041, 0.0, zero_stack, 1.0, int_stack+677974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1247176,int_stack+1242976,int_stack+1234561, 0.0, zero_stack, 1.0, int_stack+680494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1251901,int_stack+543164,int_stack+542339, 0.0, zero_stack, 1.0, int_stack+562110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1254376,int_stack+1251901,int_stack+1237711, 0.0, zero_stack, 1.0, int_stack+683644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1258426,int_stack+1254376,int_stack+1239736, 0.0, zero_stack, 1.0, int_stack+685669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1251901,int_stack+1258426,int_stack+1242976, 0.0, zero_stack, 1.0, int_stack+688909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1258201,int_stack+1251901,int_stack+1247176, 0.0, zero_stack, 1.0, int_stack+693109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1264816,int_stack+1258201,int_stack+1226011,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1251901,int_stack+256690,int_stack+255808, 0.0, zero_stack, 1.0, int_stack+271239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1253224,int_stack+257866,int_stack+256690, 0.0, zero_stack, 1.0, int_stack+272562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1254988,int_stack+1253224,int_stack+1251901, 0.0, zero_stack, 1.0, int_stack+723409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1278046,int_stack+259378,int_stack+257866, 0.0, zero_stack, 1.0, int_stack+274326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1280314,int_stack+1278046,int_stack+1253224, 0.0, zero_stack, 1.0, int_stack+724732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1283842,int_stack+1280314,int_stack+1254988, 0.0, zero_stack, 1.0, int_stack+726496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1288252,int_stack+261268,int_stack+259378, 0.0, zero_stack, 1.0, int_stack+276594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1291087,int_stack+1288252,int_stack+1278046, 0.0, zero_stack, 1.0, int_stack+749554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1295623,int_stack+1291087,int_stack+1280314, 0.0, zero_stack, 1.0, int_stack+751822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1301503,int_stack+1295623,int_stack+1283842, 0.0, zero_stack, 1.0, int_stack+755350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1308118,int_stack+5544,int_stack+261268, 0.0, zero_stack, 1.0, int_stack+6930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1311583,int_stack+1308118,int_stack+1288252, 0.0, zero_stack, 1.0, int_stack+759760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1317253,int_stack+1311583,int_stack+1291087, 0.0, zero_stack, 1.0, int_stack+762595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1308118,int_stack+1317253,int_stack+1295623, 0.0, zero_stack, 1.0, int_stack+767131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1316938,int_stack+1308118,int_stack+1301503, 0.0, zero_stack, 1.0, int_stack+773011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1326199,int_stack+1316938,int_stack+1258201,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1308118,int_stack+553400,int_stack+553190, 1.0, int_stack+613313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1308748,int_stack+553680,int_stack+553400, 1.0, int_stack+613523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1309588,int_stack+1308748,int_stack+1308118, 1.0, int_stack+633644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1310848,int_stack+554040,int_stack+553680, 1.0, int_stack+613803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1311928,int_stack+1310848,int_stack+1308748, 1.0, int_stack+634274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1313608,int_stack+1311928,int_stack+1309588, 1.0, int_stack+635114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+633644,int_stack+554490,int_stack+554040, 1.0, int_stack+614163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1315708,int_stack+633644,int_stack+1310848, 1.0, int_stack+636374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1317868,int_stack+1315708,int_stack+1311928, 1.0, int_stack+637454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+634994,int_stack+1317868,int_stack+1313608, 1.0, int_stack+639134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+638144,int_stack+555040,int_stack+554490, 1.0, int_stack+614613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1320668,int_stack+638144,int_stack+633644, 1.0, int_stack+641234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1346044,int_stack+1320668,int_stack+1315708, 1.0, int_stack+642584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1320668,int_stack+1346044,int_stack+1317868, 1.0, int_stack+644744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1346044,int_stack+1320668,int_stack+634994, 1.0, int_stack+647544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1320668,int_stack+559260,int_stack+558525, 1.0, int_stack+558210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1321613,int_stack+560220,int_stack+559260, 1.0, int_stack+558840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1322873,int_stack+1321613,int_stack+1320668, 1.0, int_stack+667744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+638144,int_stack+561435,int_stack+560220, 1.0, int_stack+559680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4140,int_stack+638144,int_stack+1321613, 1.0, int_stack+668689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1350454,int_stack+4140,int_stack+1322873, 1.0, int_stack+669949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+667744,int_stack+562935,int_stack+561435, 1.0, int_stack+560760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1353604,int_stack+667744,int_stack+638144, 1.0, int_stack+676354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1356844,int_stack+1353604,int_stack+4140, 1.0, int_stack+677974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1361044,int_stack+1356844,int_stack+1350454, 1.0, int_stack+680494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+676354,int_stack+563760,int_stack+562935, 1.0, int_stack+562110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+678829,int_stack+676354,int_stack+667744, 1.0, int_stack+683644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1365769,int_stack+678829,int_stack+1353604, 1.0, int_stack+685669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+676354,int_stack+1365769,int_stack+1356844, 1.0, int_stack+688909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1365769,int_stack+676354,int_stack+1361044, 1.0, int_stack+693109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1372384,int_stack+1365769,int_stack+1346044,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+676354,int_stack+273150,int_stack+271680, 1.0, int_stack+271239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+677677,int_stack+275082,int_stack+273150, 1.0, int_stack+272562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+679441,int_stack+677677,int_stack+676354, 1.0, int_stack+723409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1385614,int_stack+277539,int_stack+275082, 1.0, int_stack+274326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1387882,int_stack+1385614,int_stack+677677, 1.0, int_stack+724732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1391410,int_stack+1387882,int_stack+679441, 1.0, int_stack+726496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+723409,int_stack+279429,int_stack+277539, 1.0, int_stack+276594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1395820,int_stack+723409,int_stack+1385614, 1.0, int_stack+749554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1400356,int_stack+1395820,int_stack+1387882, 1.0, int_stack+751822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1406236,int_stack+1400356,int_stack+1391410, 1.0, int_stack+755350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+726244,int_stack+8085,int_stack+279429, 1.0, int_stack+6930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+749554,int_stack+726244,int_stack+723409, 1.0, int_stack+759760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1412851,int_stack+749554,int_stack+1395820, 1.0, int_stack+762595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+749554,int_stack+1412851,int_stack+1400356, 1.0, int_stack+767131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+758374,int_stack+749554,int_stack+1406236, 1.0, int_stack+773011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1412851,int_stack+758374,int_stack+1365769,441);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+749554,int_stack+615163,int_stack+614613,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+751204,int_stack+749554,int_stack+641234,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+753904,int_stack+751204,int_stack+642584,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+749554,int_stack+753904,int_stack+644744,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+753754,int_stack+749554,int_stack+647544,10);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+749554,int_stack+12243,int_stack+562110,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+758164,int_stack+749554,int_stack+683644,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+762214,int_stack+758164,int_stack+685669,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+767614,int_stack+762214,int_stack+688909,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+758164,int_stack+767614,int_stack+693109,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+764779,int_stack+758164,int_stack+753754,441);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+778009,int_stack+577881,int_stack+577671,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+778639,int_stack+578161,int_stack+577881,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+749554,int_stack+778639,int_stack+778009,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+750814,int_stack+578521,int_stack+578161,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+751894,int_stack+750814,int_stack+778639,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+726244,int_stack+751894,int_stack+749554,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+728344,int_stack+578971,int_stack+578521,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+682087,int_stack+728344,int_stack+750814,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+684247,int_stack+682087,int_stack+751894,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+687047,int_stack+684247,int_stack+726244,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+690197,int_stack+579521,int_stack+578971,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+691847,int_stack+690197,int_stack+728344,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+639764,int_stack+691847,int_stack+682087,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+690197,int_stack+639764,int_stack+684247,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+639764,int_stack+690197,int_stack+687047,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+276594,int_stack+583006,int_stack+582691,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+690197,int_stack+583426,int_stack+583006,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+691457,int_stack+690197,int_stack+276594,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+693347,int_stack+583966,int_stack+583426,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+694967,int_stack+693347,int_stack+690197,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+644174,int_stack+694967,int_stack+691457,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+647324,int_stack+584641,int_stack+583966,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1432696,int_stack+647324,int_stack+693347,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1435936,int_stack+1432696,int_stack+694967,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1440136,int_stack+1435936,int_stack+644174,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+613313,int_stack+585466,int_stack+584641,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1444861,int_stack+613313,int_stack+647324,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1448911,int_stack+1444861,int_stack+1432696,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1454311,int_stack+1448911,int_stack+1435936,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1444861,int_stack+1454311,int_stack+1440136,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1451476,int_stack+1444861,int_stack+639764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+613313,int_stack+348012,int_stack+347130,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+669769,int_stack+349188,int_stack+348012,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6660,int_stack+669769,int_stack+613313,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1464706,int_stack+350700,int_stack+349188,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1466974,int_stack+1464706,int_stack+669769,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1470502,int_stack+1466974,int_stack+6660,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1474912,int_stack+352590,int_stack+350700,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1477747,int_stack+1474912,int_stack+1464706,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1482283,int_stack+1477747,int_stack+1466974,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1488163,int_stack+1482283,int_stack+1470502,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1494778,int_stack+9471,int_stack+352590,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1498243,int_stack+1494778,int_stack+1474912,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1503913,int_stack+1498243,int_stack+1477747,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1494778,int_stack+1503913,int_stack+1482283,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1503598,int_stack+1494778,int_stack+1488163,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1512859,int_stack+1503598,int_stack+1444861, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+758164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1494778,int_stack+595702,int_stack+595492,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1495408,int_stack+595982,int_stack+595702,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1496248,int_stack+1495408,int_stack+1494778,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1497508,int_stack+596342,int_stack+595982,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1498588,int_stack+1497508,int_stack+1495408,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1500268,int_stack+1498588,int_stack+1496248,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1502368,int_stack+596792,int_stack+596342,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1503718,int_stack+1502368,int_stack+1497508,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1505878,int_stack+1503718,int_stack+1498588,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1508678,int_stack+1505878,int_stack+1500268,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1532704,int_stack+597342,int_stack+596792,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1534354,int_stack+1532704,int_stack+1502368,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1537054,int_stack+1534354,int_stack+1503718,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1532704,int_stack+1537054,int_stack+1505878,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1536904,int_stack+1532704,int_stack+1508678,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1532704,int_stack+600827,int_stack+600512,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1533649,int_stack+601247,int_stack+600827,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1534909,int_stack+1533649,int_stack+1532704,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1541314,int_stack+601787,int_stack+601247,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1542934,int_stack+1541314,int_stack+1533649,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1545454,int_stack+1542934,int_stack+1534909,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1548604,int_stack+602462,int_stack+601787,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1550629,int_stack+1548604,int_stack+1541314,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1553869,int_stack+1550629,int_stack+1542934,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1558069,int_stack+1553869,int_stack+1545454,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1562794,int_stack+603287,int_stack+602462,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1565269,int_stack+1562794,int_stack+1548604,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1569319,int_stack+1565269,int_stack+1550629,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1562794,int_stack+1569319,int_stack+1553869,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1569094,int_stack+1562794,int_stack+1558069,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1575709,int_stack+1569094,int_stack+1536904, 0.0, zero_stack, 1.0, int_stack+753754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1562794,int_stack+432719,int_stack+431837,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1564117,int_stack+433895,int_stack+432719,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1565881,int_stack+1564117,int_stack+1562794,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1588939,int_stack+435407,int_stack+433895,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1591207,int_stack+1588939,int_stack+1564117,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1594735,int_stack+1591207,int_stack+1565881,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1599145,int_stack+437297,int_stack+435407,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1601980,int_stack+1599145,int_stack+1588939,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1606516,int_stack+1601980,int_stack+1591207,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1612396,int_stack+1606516,int_stack+1594735,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1619011,int_stack+10857,int_stack+437297,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1622476,int_stack+1619011,int_stack+1599145,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1628146,int_stack+1622476,int_stack+1601980,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1619011,int_stack+1628146,int_stack+1606516,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1627831,int_stack+1619011,int_stack+1612396,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1637092,int_stack+1627831,int_stack+1569094, 0.0, zero_stack, 1.0, int_stack+758164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1619011,int_stack+616033,int_stack+615823,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1619641,int_stack+616313,int_stack+616033,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1620481,int_stack+1619641,int_stack+1619011,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1621741,int_stack+616673,int_stack+616313,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1622821,int_stack+1621741,int_stack+1619641,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1624501,int_stack+1622821,int_stack+1620481,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1626601,int_stack+617123,int_stack+616673,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1627951,int_stack+1626601,int_stack+1621741,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1630111,int_stack+1627951,int_stack+1622821,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1632911,int_stack+1630111,int_stack+1624501,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+9306,int_stack+617673,int_stack+617123,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1656937,int_stack+9306,int_stack+1626601,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+9306,int_stack+1656937,int_stack+1627951,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1656937,int_stack+9306,int_stack+1630111,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1661137,int_stack+1656937,int_stack+1632911,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1656937,int_stack+621158,int_stack+620843,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1657882,int_stack+621578,int_stack+621158,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1659142,int_stack+1657882,int_stack+1656937,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+9306,int_stack+622118,int_stack+621578,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1665547,int_stack+9306,int_stack+1657882,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1668067,int_stack+1665547,int_stack+1659142,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+10926,int_stack+622793,int_stack+622118,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1671217,int_stack+10926,int_stack+9306,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1674457,int_stack+1671217,int_stack+1665547,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1678657,int_stack+1674457,int_stack+1668067,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1683382,int_stack+623618,int_stack+622793,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1685857,int_stack+1683382,int_stack+10926,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1689907,int_stack+1685857,int_stack+1671217,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1683382,int_stack+1689907,int_stack+1674457,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1689682,int_stack+1683382,int_stack+1678657,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1696297,int_stack+1689682,int_stack+1661137, 1.0, int_stack+753754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1683382,int_stack+569397,int_stack+568515,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1684705,int_stack+570573,int_stack+569397,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1686469,int_stack+1684705,int_stack+1683382,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+753574,int_stack+572085,int_stack+570573,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1709527,int_stack+753574,int_stack+1684705,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1713055,int_stack+1709527,int_stack+1686469,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1717465,int_stack+573975,int_stack+572085,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1720300,int_stack+1717465,int_stack+753574,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1724836,int_stack+1720300,int_stack+1709527,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1730716,int_stack+1724836,int_stack+1713055,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+13233,int_stack+573975,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1740796,int_stack+1737331,int_stack+1717465,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1746466,int_stack+1740796,int_stack+1720300,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1737331,int_stack+1746466,int_stack+1724836,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1746151,int_stack+1737331,int_stack+1730716,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1755412,int_stack+1746151,int_stack+1689682, 1.0, int_stack+758164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+14829,int_stack+14619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+464085,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1737961,int_stack+15109,int_stack+14829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+464295,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1738801,int_stack+1737961,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+650694,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1740061,int_stack+15469,int_stack+15109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+464575,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1741141,int_stack+1740061,int_stack+1737961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+651324,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1742821,int_stack+1741141,int_stack+1738801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+652164,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1737331,int_stack+15919,int_stack+15469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+464935,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1744921,int_stack+1737331,int_stack+1740061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+653424,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1747081,int_stack+1744921,int_stack+1741141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+654504,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1738681,int_stack+1747081,int_stack+1742821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+656184,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1741831,int_stack+16469,int_stack+15919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+465385,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1749881,int_stack+1741831,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+658284,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+12951,int_stack+1749881,int_stack+1744921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+659634,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1749881,int_stack+12951,int_stack+1747081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+661794,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1741831,int_stack+1749881,int_stack+1738681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+664594,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12951,int_stack+17444,int_stack+17129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+469105,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13896,int_stack+17864,int_stack+17444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+469420,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15156,int_stack+13896,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+697834,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1737331,int_stack+18404,int_stack+17864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+469840,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1738951,int_stack+1737331,int_stack+13896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+698779,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1746241,int_stack+1738951,int_stack+15156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+700039,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12951,int_stack+19079,int_stack+18404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+470380,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+14976,int_stack+12951,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+701929,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1749391,int_stack+14976,int_stack+1738951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+703549,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+755842,int_stack+1749391,int_stack+1746241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+706069,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1746241,int_stack+19904,int_stack+19079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+471055,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1737331,int_stack+1746241,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+709219,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1775257,int_stack+1737331,int_stack+14976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+711244,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+12951,int_stack+1775257,int_stack+1749391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+714484,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1746241,int_stack+12951,int_stack+755842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+718684,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1775257,int_stack+1746241,int_stack+1741831,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+755842,int_stack+21335,int_stack+20894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+194084,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+757165,int_stack+21923,int_stack+21335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+194966,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+758929,int_stack+757165,int_stack+755842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+779626,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+761575,int_stack+22679,int_stack+21923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+196142,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12951,int_stack+761575,int_stack+757165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+780949,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16479,int_stack+12951,int_stack+758929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+782713,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+755842,int_stack+23624,int_stack+22679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+197654,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1737331,int_stack+755842,int_stack+761575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+785359,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+758677,int_stack+1737331,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+787627,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1788487,int_stack+758677,int_stack+16479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+791155,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+12951,int_stack+24779,int_stack+23624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+199544,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+16416,int_stack+12951,int_stack+755842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+795565,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1795102,int_stack+16416,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+798400,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1737331,int_stack+1795102,int_stack+758677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+802936,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+12951,int_stack+1737331,int_stack+1788487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+808816,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1788487,int_stack+12951,int_stack+1746241,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12951,int_stack+26375,int_stack+26165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464085, 1.0, int_stack+481906,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13581,int_stack+26655,int_stack+26375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464295, 1.0, int_stack+482116,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14421,int_stack+13581,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650694, 1.0, int_stack+815431,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15681,int_stack+27015,int_stack+26655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464575, 1.0, int_stack+482396,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16761,int_stack+15681,int_stack+13581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651324, 1.0, int_stack+816061,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18441,int_stack+16761,int_stack+14421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+652164, 1.0, int_stack+816901,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12951,int_stack+27465,int_stack+27015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464935, 1.0, int_stack+482756,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+20541,int_stack+12951,int_stack+15681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653424, 1.0, int_stack+818161,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22701,int_stack+20541,int_stack+16761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654504, 1.0, int_stack+819241,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14301,int_stack+22701,int_stack+18441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+656184, 1.0, int_stack+820921,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+17451,int_stack+28015,int_stack+27465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465385, 1.0, int_stack+483206,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25501,int_stack+17451,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658284, 1.0, int_stack+823021,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1737331,int_stack+25501,int_stack+20541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+659634, 1.0, int_stack+824371,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+17451,int_stack+1737331,int_stack+22701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661794, 1.0, int_stack+826531,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+17451,int_stack+14301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+664594, 1.0, int_stack+829331,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1741741,int_stack+28990,int_stack+28675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469105, 1.0, int_stack+486926,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1742686,int_stack+29410,int_stack+28990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469420, 1.0, int_stack+487241,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1743946,int_stack+1742686,int_stack+1741741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697834, 1.0, int_stack+853357,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1745836,int_stack+29950,int_stack+29410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469840, 1.0, int_stack+487661,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1747456,int_stack+1745836,int_stack+1742686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698779, 1.0, int_stack+854302,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1749976,int_stack+1747456,int_stack+1743946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700039, 1.0, int_stack+855562,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1741741,int_stack+30625,int_stack+29950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470380, 1.0, int_stack+488201,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+12951,int_stack+1741741,int_stack+1745836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701929, 1.0, int_stack+861967,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+16191,int_stack+12951,int_stack+1747456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703549, 1.0, int_stack+863587,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1743766,int_stack+16191,int_stack+1749976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706069, 1.0, int_stack+866107,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1748491,int_stack+31450,int_stack+30625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471055, 1.0, int_stack+488876,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1750966,int_stack+1748491,int_stack+1741741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+709219, 1.0, int_stack+869257,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+20391,int_stack+1750966,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711244, 1.0, int_stack+871282,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1748491,int_stack+20391,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714484, 1.0, int_stack+874522,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+12951,int_stack+1748491,int_stack+1743766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718684, 1.0, int_stack+878722,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1741741,int_stack+12951,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+32881,int_stack+32440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194084, 1.0, int_stack+209515,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+33469,int_stack+32881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194966, 1.0, int_stack+210397,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19566,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779626, 1.0, int_stack+883447,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22212,int_stack+34225,int_stack+33469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196142, 1.0, int_stack+211573,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24480,int_stack+22212,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780949, 1.0, int_stack+884770,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+24480,int_stack+19566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782713, 1.0, int_stack+886534,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+28008,int_stack+35170,int_stack+34225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197654, 1.0, int_stack+213085,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+755842,int_stack+28008,int_stack+22212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+785359, 1.0, int_stack+909592,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+24480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+787627, 1.0, int_stack+911860,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+19566,int_stack+1808332,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791155, 1.0, int_stack+915388,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+36325,int_stack+35170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199544, 1.0, int_stack+214975,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+30843,int_stack+1737331,int_stack+28008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795565, 1.0, int_stack+919798,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1814212,int_stack+30843,int_stack+755842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+798400, 1.0, int_stack+922633,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+755842,int_stack+1814212,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802936, 1.0, int_stack+927169,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+19566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808816, 1.0, int_stack+933049,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1817593,int_stack+1808332,int_stack+12951,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12951,int_stack+37921,int_stack+37711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+481906, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13581,int_stack+38201,int_stack+37921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+482116, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14421,int_stack+13581,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+815431, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15681,int_stack+38561,int_stack+38201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+482396, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16761,int_stack+15681,int_stack+13581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+816061, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18441,int_stack+16761,int_stack+14421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+816901, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12951,int_stack+39011,int_stack+38561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+482756, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+20541,int_stack+12951,int_stack+15681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+818161, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22701,int_stack+20541,int_stack+16761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+819241, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14301,int_stack+22701,int_stack+18441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+820921, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+17451,int_stack+39561,int_stack+39011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+483206, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25501,int_stack+17451,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+823021, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+28201,int_stack+25501,int_stack+20541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+824371, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+17451,int_stack+28201,int_stack+22701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+826531, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+17451,int_stack+14301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+829331, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12951,int_stack+40536,int_stack+40221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+486926, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13896,int_stack+40956,int_stack+40536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+487241, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15156,int_stack+13896,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+853357, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17046,int_stack+41496,int_stack+40956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+487661, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18666,int_stack+17046,int_stack+13896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+854302, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21186,int_stack+18666,int_stack+15156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+855562, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12951,int_stack+42171,int_stack+41496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+488201, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+24336,int_stack+12951,int_stack+17046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+861967, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+27576,int_stack+24336,int_stack+18666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+863587, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14976,int_stack+27576,int_stack+21186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+866107, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+19701,int_stack+42996,int_stack+42171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+488876, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+31776,int_stack+19701,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+869257, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+35826,int_stack+31776,int_stack+24336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+871282, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+19701,int_stack+35826,int_stack+27576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+874522, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+26001,int_stack+19701,int_stack+14976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+878722, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1837438,int_stack+26001,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+44427,int_stack+43986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+209515, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+45015,int_stack+44427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+210397, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12951,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+883447, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15597,int_stack+45771,int_stack+45015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+211573, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17865,int_stack+15597,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+884770, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+17865,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+886534, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21393,int_stack+46716,int_stack+45771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+213085, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+32616,int_stack+21393,int_stack+15597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+909592, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+37152,int_stack+32616,int_stack+17865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+911860, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+12951,int_stack+37152,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+915388, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+47871,int_stack+46716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+214975, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+43032,int_stack+1737331,int_stack+21393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+919798, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+43032,int_stack+32616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+922633, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+755842,int_stack+1808332,int_stack+37152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+927169, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+933049, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1850668,int_stack+1808332,int_stack+26001,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+49467,int_stack+49257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464085, 0.0, zero_stack, 1.0, int_stack+499727,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+49747,int_stack+49467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464295, 0.0, zero_stack, 1.0, int_stack+499937,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650694, 0.0, zero_stack, 1.0, int_stack+939664,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+50107,int_stack+49747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464575, 0.0, zero_stack, 1.0, int_stack+500217,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651324, 0.0, zero_stack, 1.0, int_stack+940294,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+652164, 0.0, zero_stack, 1.0, int_stack+941134,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+50557,int_stack+50107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464935, 0.0, zero_stack, 1.0, int_stack+500577,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+12951,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653424, 0.0, zero_stack, 1.0, int_stack+942394,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+15111,int_stack+12951,int_stack+1812142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654504, 0.0, zero_stack, 1.0, int_stack+943474,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+15111,int_stack+1813822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+656184, 0.0, zero_stack, 1.0, int_stack+945154,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+51107,int_stack+50557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465385, 0.0, zero_stack, 1.0, int_stack+501027,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658284, 0.0, zero_stack, 1.0, int_stack+947254,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+17911,int_stack+1814482,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+659634, 0.0, zero_stack, 1.0, int_stack+948604,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+17911,int_stack+15111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661794, 0.0, zero_stack, 1.0, int_stack+950764,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+664594, 0.0, zero_stack, 1.0, int_stack+953564,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12951,int_stack+52082,int_stack+51767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469105, 0.0, zero_stack, 1.0, int_stack+504747,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13896,int_stack+52502,int_stack+52082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469420, 0.0, zero_stack, 1.0, int_stack+505062,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15156,int_stack+13896,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697834, 0.0, zero_stack, 1.0, int_stack+982000,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17046,int_stack+53042,int_stack+52502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469840, 0.0, zero_stack, 1.0, int_stack+505482,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18666,int_stack+17046,int_stack+13896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698779, 0.0, zero_stack, 1.0, int_stack+982945,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21186,int_stack+18666,int_stack+15156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700039, 0.0, zero_stack, 1.0, int_stack+984205,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12951,int_stack+53717,int_stack+53042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470380, 0.0, zero_stack, 1.0, int_stack+506022,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+24336,int_stack+12951,int_stack+17046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701929, 0.0, zero_stack, 1.0, int_stack+986095,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+27576,int_stack+24336,int_stack+18666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703549, 0.0, zero_stack, 1.0, int_stack+0,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14976,int_stack+27576,int_stack+21186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706069, 0.0, zero_stack, 1.0, int_stack+987715,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+19701,int_stack+54542,int_stack+53717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471055, 0.0, zero_stack, 1.0, int_stack+506697,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+31776,int_stack+19701,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+709219, 0.0, zero_stack, 1.0, int_stack+990865,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+35826,int_stack+31776,int_stack+24336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711244, 0.0, zero_stack, 1.0, int_stack+992890,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+19701,int_stack+35826,int_stack+27576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714484, 0.0, zero_stack, 1.0, int_stack+996130,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+26001,int_stack+19701,int_stack+14976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718684, 0.0, zero_stack, 1.0, int_stack+1000330,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+32616,int_stack+26001,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+55973,int_stack+55532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194084, 0.0, zero_stack, 1.0, int_stack+224946,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+56561,int_stack+55973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194966, 0.0, zero_stack, 1.0, int_stack+225828,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12951,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779626, 0.0, zero_stack, 1.0, int_stack+1005055,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15597,int_stack+57317,int_stack+56561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196142, 0.0, zero_stack, 1.0, int_stack+227004,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17865,int_stack+15597,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780949, 0.0, zero_stack, 1.0, int_stack+1006378,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+17865,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782713, 0.0, zero_stack, 1.0, int_stack+1008142,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21393,int_stack+58262,int_stack+57317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197654, 0.0, zero_stack, 1.0, int_stack+228516,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+45846,int_stack+21393,int_stack+15597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+785359, 0.0, zero_stack, 1.0, int_stack+1031200,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+50382,int_stack+45846,int_stack+17865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+787627, 0.0, zero_stack, 1.0, int_stack+1033468,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+12951,int_stack+50382,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791155, 0.0, zero_stack, 1.0, int_stack+1036996,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+59417,int_stack+58262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199544, 0.0, zero_stack, 1.0, int_stack+230406,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+1737331,int_stack+21393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795565, 0.0, zero_stack, 1.0, int_stack+1041406,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755842,int_stack+1808332,int_stack+45846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+798400, 0.0, zero_stack, 1.0, int_stack+1044241,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+50382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802936, 0.0, zero_stack, 1.0, int_stack+1048777,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+45846,int_stack+1808332,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808816, 0.0, zero_stack, 1.0, int_stack+1054657,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1870513,int_stack+45846,int_stack+26001,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+45846,int_stack+61013,int_stack+60803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+481906, 1.0, int_stack+499727, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46476,int_stack+61293,int_stack+61013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482116, 1.0, int_stack+499937, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+47316,int_stack+46476,int_stack+45846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815431, 1.0, int_stack+939664, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+48576,int_stack+61653,int_stack+61293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482396, 1.0, int_stack+500217, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+49656,int_stack+48576,int_stack+46476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+816061, 1.0, int_stack+940294, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+51336,int_stack+49656,int_stack+47316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+816901, 1.0, int_stack+941134, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+45846,int_stack+62103,int_stack+61653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482756, 1.0, int_stack+500577, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+53436,int_stack+45846,int_stack+48576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+818161, 1.0, int_stack+942394, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+55596,int_stack+53436,int_stack+49656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819241, 1.0, int_stack+943474, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+47196,int_stack+55596,int_stack+51336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820921, 1.0, int_stack+945154, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+50346,int_stack+62653,int_stack+62103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483206, 1.0, int_stack+501027, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+58396,int_stack+50346,int_stack+45846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823021, 1.0, int_stack+947254, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+12951,int_stack+58396,int_stack+53436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824371, 1.0, int_stack+948604, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58396,int_stack+12951,int_stack+55596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+826531, 1.0, int_stack+950764, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+58396,int_stack+47196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829331, 1.0, int_stack+953564, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12951,int_stack+63628,int_stack+63313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+486926, 1.0, int_stack+504747, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13896,int_stack+64048,int_stack+63628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487241, 1.0, int_stack+505062, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15156,int_stack+13896,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853357, 1.0, int_stack+982000, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17046,int_stack+64588,int_stack+64048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487661, 1.0, int_stack+505482, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18666,int_stack+17046,int_stack+13896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854302, 1.0, int_stack+982945, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21186,int_stack+18666,int_stack+15156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+855562, 1.0, int_stack+984205, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12951,int_stack+65263,int_stack+64588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488201, 1.0, int_stack+506022, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+24336,int_stack+12951,int_stack+17046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+861967, 1.0, int_stack+986095, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+27576,int_stack+24336,int_stack+18666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+863587, 1.0, int_stack+0, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14976,int_stack+27576,int_stack+21186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866107, 1.0, int_stack+987715, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+19701,int_stack+66088,int_stack+65263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488876, 1.0, int_stack+506697, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+45846,int_stack+19701,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+869257, 1.0, int_stack+990865, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+49896,int_stack+45846,int_stack+24336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+871282, 1.0, int_stack+992890, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+19701,int_stack+49896,int_stack+27576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+874522, 1.0, int_stack+996130, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+26001,int_stack+19701,int_stack+14976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+878722, 1.0, int_stack+1000330, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+45846,int_stack+26001,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+67519,int_stack+67078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209515, 1.0, int_stack+224946, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+68107,int_stack+67519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210397, 1.0, int_stack+225828, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+59076,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883447, 1.0, int_stack+1005055, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61722,int_stack+68863,int_stack+68107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211573, 1.0, int_stack+227004, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+63990,int_stack+61722,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+884770, 1.0, int_stack+1006378, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+63990,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+886534, 1.0, int_stack+1008142, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12951,int_stack+69808,int_stack+68863, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213085, 1.0, int_stack+228516, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+15786,int_stack+12951,int_stack+61722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909592, 1.0, int_stack+1031200, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+15786,int_stack+63990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+911860, 1.0, int_stack+1033468, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+59076,int_stack+1808332,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+915388, 1.0, int_stack+1036996, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+70963,int_stack+69808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214975, 1.0, int_stack+230406, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+65691,int_stack+1737331,int_stack+12951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+919798, 1.0, int_stack+1041406, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755842,int_stack+65691,int_stack+15786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+922633, 1.0, int_stack+1044241, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+12951,int_stack+755842,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927169, 1.0, int_stack+1048777, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+12951,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+933049, 1.0, int_stack+1054657, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1890358,int_stack+1808332,int_stack+26001,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+72559,int_stack+72349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+499727, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+72839,int_stack+72559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+499937, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+939664, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+73199,int_stack+72839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+500217, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+940294, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+941134, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+73649,int_stack+73199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+500577, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+59076,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+942394, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61236,int_stack+59076,int_stack+1812142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+943474, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+61236,int_stack+1813822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+945154, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+74199,int_stack+73649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+501027, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+947254, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+64036,int_stack+1814482,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+948604, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+64036,int_stack+61236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+950764, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+953564, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+59076,int_stack+75174,int_stack+74859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+504747, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+60021,int_stack+75594,int_stack+75174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+505062, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+61281,int_stack+60021,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+982000, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+63171,int_stack+76134,int_stack+75594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+505482, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+64791,int_stack+63171,int_stack+60021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+982945, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+67311,int_stack+64791,int_stack+61281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+984205, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+59076,int_stack+76809,int_stack+76134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+506022, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+70461,int_stack+59076,int_stack+63171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+986095, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+70461,int_stack+64791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+61101,int_stack+1808332,int_stack+67311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+987715, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+65826,int_stack+77634,int_stack+76809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+506697, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+73701,int_stack+65826,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+990865, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+12951,int_stack+73701,int_stack+70461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+992890, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+65826,int_stack+12951,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+996130, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+65826,int_stack+61101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1000330, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+12951,int_stack+1808332,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+79065,int_stack+78624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+224946, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+79653,int_stack+79065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+225828, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814947,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1005055, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+26181,int_stack+80409,int_stack+79653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+227004, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+28449,int_stack+26181,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1006378, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+28449,int_stack+1814947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1008142, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+59076,int_stack+81354,int_stack+80409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+228516, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+61911,int_stack+59076,int_stack+26181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1031200, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+66447,int_stack+61911,int_stack+28449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1033468, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72327,int_stack+66447,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1036996, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+82509,int_stack+81354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+230406, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+26181,int_stack+1737331,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1041406, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755842,int_stack+26181,int_stack+61911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1044241, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1910203,int_stack+755842,int_stack+66447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1048777, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+59076,int_stack+1910203,int_stack+72327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1054657, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1910203,int_stack+59076,int_stack+1808332,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+84105,int_stack+83895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+517548,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+84385,int_stack+84105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+517758,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650694, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1061272,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+84745,int_stack+84385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518038,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1061902,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+652164, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1062742,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+85195,int_stack+84745, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+464935, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518398,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+59076,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653424, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1064002,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61236,int_stack+59076,int_stack+1812142, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654504, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1065082,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+61236,int_stack+1813822, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+656184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1066762,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+85745,int_stack+85195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518848,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1068862,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+64036,int_stack+1814482,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+659634, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1070212,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+64036,int_stack+61236, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661794, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1072372,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+664594, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1075172,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+59076,int_stack+86720,int_stack+86405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522568,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+60021,int_stack+87140,int_stack+86720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522883,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+61281,int_stack+60021,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1099198,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+63171,int_stack+87680,int_stack+87140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+523303,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+64791,int_stack+63171,int_stack+60021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698779, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100143,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+67311,int_stack+64791,int_stack+61281, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700039, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1101403,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+59076,int_stack+88355,int_stack+87680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+523843,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+70461,int_stack+59076,int_stack+63171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2520,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+73701,int_stack+70461,int_stack+64791, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703549, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1107808,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+61101,int_stack+73701,int_stack+67311, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706069, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1110328,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+65826,int_stack+89180,int_stack+88355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+524518,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+77901,int_stack+65826,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+709219, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1113478,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+81951,int_stack+77901,int_stack+70461, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711244, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1115503,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+65826,int_stack+81951,int_stack+73701, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1118743,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+72126,int_stack+65826,int_stack+61101, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718684, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1122943,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1930048,int_stack+72126,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+90611,int_stack+90170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194084, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240377,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+91199,int_stack+90611, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194966, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241259,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+59076,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779626, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1127668,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61722,int_stack+91955,int_stack+91199, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196142, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242435,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+63990,int_stack+61722,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780949, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1128991,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+63990,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782713, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1130755,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+67518,int_stack+92900,int_stack+91955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243947,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+78741,int_stack+67518,int_stack+61722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+785359, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1153813,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+83277,int_stack+78741,int_stack+63990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+787627, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1156081,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+59076,int_stack+83277,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1159609,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+94055,int_stack+92900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245837,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+89157,int_stack+1737331,int_stack+67518, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1164019,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+89157,int_stack+78741, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+798400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1166854,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+755842,int_stack+1808332,int_stack+83277, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802936, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1171390,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808816, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1177270,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1943278,int_stack+1808332,int_stack+72126,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+95651,int_stack+95441, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+481906, 0.0, zero_stack, 1.0, int_stack+517548, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+95931,int_stack+95651, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482116, 0.0, zero_stack, 1.0, int_stack+517758, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815431, 0.0, zero_stack, 1.0, int_stack+1061272, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+96291,int_stack+95931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482396, 0.0, zero_stack, 1.0, int_stack+518038, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+816061, 0.0, zero_stack, 1.0, int_stack+1061902, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+816901, 0.0, zero_stack, 1.0, int_stack+1062742, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+96741,int_stack+96291, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482756, 0.0, zero_stack, 1.0, int_stack+518398, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+59076,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+818161, 0.0, zero_stack, 1.0, int_stack+1064002, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61236,int_stack+59076,int_stack+1812142, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819241, 0.0, zero_stack, 1.0, int_stack+1065082, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+61236,int_stack+1813822, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820921, 0.0, zero_stack, 1.0, int_stack+1066762, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+97291,int_stack+96741, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483206, 0.0, zero_stack, 1.0, int_stack+518848, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823021, 0.0, zero_stack, 1.0, int_stack+1068862, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+64036,int_stack+1814482,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824371, 0.0, zero_stack, 1.0, int_stack+1070212, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+64036,int_stack+61236, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+826531, 0.0, zero_stack, 1.0, int_stack+1072372, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829331, 0.0, zero_stack, 1.0, int_stack+1075172, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+59076,int_stack+98266,int_stack+97951, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+486926, 0.0, zero_stack, 1.0, int_stack+522568, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+60021,int_stack+98686,int_stack+98266, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487241, 0.0, zero_stack, 1.0, int_stack+522883, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+61281,int_stack+60021,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853357, 0.0, zero_stack, 1.0, int_stack+1099198, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+63171,int_stack+99226,int_stack+98686, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487661, 0.0, zero_stack, 1.0, int_stack+523303, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+64791,int_stack+63171,int_stack+60021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854302, 0.0, zero_stack, 1.0, int_stack+1100143, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+67311,int_stack+64791,int_stack+61281, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+855562, 0.0, zero_stack, 1.0, int_stack+1101403, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+59076,int_stack+99901,int_stack+99226, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488201, 0.0, zero_stack, 1.0, int_stack+523843, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+70461,int_stack+59076,int_stack+63171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+861967, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+73701,int_stack+70461,int_stack+64791, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+863587, 0.0, zero_stack, 1.0, int_stack+1107808, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+61101,int_stack+73701,int_stack+67311, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866107, 0.0, zero_stack, 1.0, int_stack+1110328, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+65826,int_stack+100726,int_stack+99901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488876, 0.0, zero_stack, 1.0, int_stack+524518, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+77901,int_stack+65826,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+869257, 0.0, zero_stack, 1.0, int_stack+1113478, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+81951,int_stack+77901,int_stack+70461, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+871282, 0.0, zero_stack, 1.0, int_stack+1115503, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+65826,int_stack+81951,int_stack+73701, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+874522, 0.0, zero_stack, 1.0, int_stack+1118743, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+72126,int_stack+65826,int_stack+61101, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+878722, 0.0, zero_stack, 1.0, int_stack+1122943, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+78741,int_stack+72126,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+102157,int_stack+101716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209515, 0.0, zero_stack, 1.0, int_stack+240377, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+102745,int_stack+102157, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210397, 0.0, zero_stack, 1.0, int_stack+241259, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+59076,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883447, 0.0, zero_stack, 1.0, int_stack+1127668, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61722,int_stack+103501,int_stack+102745, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211573, 0.0, zero_stack, 1.0, int_stack+242435, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+63990,int_stack+61722,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+884770, 0.0, zero_stack, 1.0, int_stack+1128991, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+63990,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+886534, 0.0, zero_stack, 1.0, int_stack+1130755, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+67518,int_stack+104446,int_stack+103501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213085, 0.0, zero_stack, 1.0, int_stack+243947, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+91971,int_stack+67518,int_stack+61722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909592, 0.0, zero_stack, 1.0, int_stack+1153813, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+96507,int_stack+91971,int_stack+63990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+911860, 0.0, zero_stack, 1.0, int_stack+1156081, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+59076,int_stack+96507,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+915388, 0.0, zero_stack, 1.0, int_stack+1159609, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+105601,int_stack+104446, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214975, 0.0, zero_stack, 1.0, int_stack+245837, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+1737331,int_stack+67518, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+919798, 0.0, zero_stack, 1.0, int_stack+1164019, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755842,int_stack+1808332,int_stack+91971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+922633, 0.0, zero_stack, 1.0, int_stack+1166854, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+96507, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927169, 0.0, zero_stack, 1.0, int_stack+1171390, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+91971,int_stack+1808332,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+933049, 0.0, zero_stack, 1.0, int_stack+1177270, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1963123,int_stack+91971,int_stack+72126,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+91971,int_stack+107197,int_stack+106987, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+499727, 1.0, int_stack+517548, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92601,int_stack+107477,int_stack+107197, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+499937, 1.0, int_stack+517758, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+93441,int_stack+92601,int_stack+91971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+939664, 1.0, int_stack+1061272, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+94701,int_stack+107837,int_stack+107477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500217, 1.0, int_stack+518038, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+95781,int_stack+94701,int_stack+92601, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+940294, 1.0, int_stack+1061902, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+97461,int_stack+95781,int_stack+93441, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+941134, 1.0, int_stack+1062742, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+91971,int_stack+108287,int_stack+107837, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500577, 1.0, int_stack+518398, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+99561,int_stack+91971,int_stack+94701, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+942394, 1.0, int_stack+1064002, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+101721,int_stack+99561,int_stack+95781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+943474, 1.0, int_stack+1065082, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+93321,int_stack+101721,int_stack+97461, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945154, 1.0, int_stack+1066762, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+96471,int_stack+108837,int_stack+108287, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+501027, 1.0, int_stack+518848, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+104521,int_stack+96471,int_stack+91971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+947254, 1.0, int_stack+1068862, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+59076,int_stack+104521,int_stack+99561, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948604, 1.0, int_stack+1070212, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+104521,int_stack+59076,int_stack+101721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+950764, 1.0, int_stack+1072372, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+104521,int_stack+93321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+953564, 1.0, int_stack+1075172, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+59076,int_stack+109812,int_stack+109497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+504747, 1.0, int_stack+522568, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+60021,int_stack+110232,int_stack+109812, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+505062, 1.0, int_stack+522883, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+61281,int_stack+60021,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+982000, 1.0, int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+63171,int_stack+110772,int_stack+110232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+505482, 1.0, int_stack+523303, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+64791,int_stack+63171,int_stack+60021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+982945, 1.0, int_stack+1100143, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+67311,int_stack+64791,int_stack+61281, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+984205, 1.0, int_stack+1101403, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+59076,int_stack+111447,int_stack+110772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+506022, 1.0, int_stack+523843, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+70461,int_stack+59076,int_stack+63171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+986095, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+73701,int_stack+70461,int_stack+64791, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+1107808, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+61101,int_stack+73701,int_stack+67311, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+987715, 1.0, int_stack+1110328, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+65826,int_stack+112272,int_stack+111447, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+506697, 1.0, int_stack+524518, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+91971,int_stack+65826,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+990865, 1.0, int_stack+1113478, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+96021,int_stack+91971,int_stack+70461, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+992890, 1.0, int_stack+1115503, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+65826,int_stack+96021,int_stack+73701, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+996130, 1.0, int_stack+1118743, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+72126,int_stack+65826,int_stack+61101, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1000330, 1.0, int_stack+1122943, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+91971,int_stack+72126,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+113703,int_stack+113262, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224946, 1.0, int_stack+240377, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+114291,int_stack+113703, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225828, 1.0, int_stack+241259, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+105201,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1005055, 1.0, int_stack+1127668, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+107847,int_stack+115047,int_stack+114291, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227004, 1.0, int_stack+242435, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+110115,int_stack+107847,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1006378, 1.0, int_stack+1128991, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+110115,int_stack+105201, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1008142, 1.0, int_stack+1130755, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+59076,int_stack+115992,int_stack+115047, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228516, 1.0, int_stack+243947, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+61911,int_stack+59076,int_stack+107847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1031200, 1.0, int_stack+1153813, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+61911,int_stack+110115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1033468, 1.0, int_stack+1156081, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+105201,int_stack+1808332,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1036996, 1.0, int_stack+1159609, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+117147,int_stack+115992, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230406, 1.0, int_stack+245837, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+111816,int_stack+1737331,int_stack+59076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1041406, 1.0, int_stack+1164019, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755842,int_stack+111816,int_stack+61911, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1044241, 1.0, int_stack+1166854, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+59076,int_stack+755842,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1048777, 1.0, int_stack+1171390, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+59076,int_stack+105201, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1054657, 1.0, int_stack+1177270, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1982968,int_stack+1808332,int_stack+72126,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+118743,int_stack+118533, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+517548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+119023,int_stack+118743, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+517758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1061272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+119383,int_stack+119023, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+518038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1061902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1062742, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+119833,int_stack+119383, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+518398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+105201,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1064002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+107361,int_stack+105201,int_stack+1812142, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1065082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+107361,int_stack+1813822, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1066762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+120383,int_stack+119833, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+518848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1068862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+110161,int_stack+1814482,int_stack+105201, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1070212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+110161,int_stack+107361, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1072372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1075172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+105201,int_stack+121358,int_stack+121043, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+522568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+106146,int_stack+121778,int_stack+121358, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+522883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+107406,int_stack+106146,int_stack+105201, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+109296,int_stack+122318,int_stack+121778, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+523303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+110916,int_stack+109296,int_stack+106146, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1100143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+113436,int_stack+110916,int_stack+107406, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1101403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+105201,int_stack+122993,int_stack+122318, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+523843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+116586,int_stack+105201,int_stack+109296, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+116586,int_stack+110916, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1107808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+107226,int_stack+1808332,int_stack+113436, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1110328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+111951,int_stack+123818,int_stack+122993, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+524518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+119826,int_stack+111951,int_stack+105201, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1113478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+59076,int_stack+119826,int_stack+116586, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1115503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+111951,int_stack+59076,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1118743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+111951,int_stack+107226, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1122943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+59076,int_stack+1808332,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+125249,int_stack+124808, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+240377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+125837,int_stack+125249, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+241259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814947,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1127668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+72306,int_stack+126593,int_stack+125837, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+242435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+74574,int_stack+72306,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1128991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+74574,int_stack+1814947, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1130755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+105201,int_stack+127538,int_stack+126593, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+243947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+108036,int_stack+105201,int_stack+72306, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1153813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+112572,int_stack+108036,int_stack+74574, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1156081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+118452,int_stack+112572,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1159609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+128693,int_stack+127538, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+245837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+72306,int_stack+1737331,int_stack+105201, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1164019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755842,int_stack+72306,int_stack+108036, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1166854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2002813,int_stack+755842,int_stack+112572, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1171390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+105201,int_stack+2002813,int_stack+118452, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1177270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2002813,int_stack+105201,int_stack+1808332,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+130289,int_stack+130079, 0.0, zero_stack, 1.0, int_stack+464085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535369,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+130569,int_stack+130289, 0.0, zero_stack, 1.0, int_stack+464295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535579,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+650694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1183885,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+130929,int_stack+130569, 0.0, zero_stack, 1.0, int_stack+464575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535859,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 1.0, int_stack+651324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1184515,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 1.0, int_stack+652164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1185355,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+131379,int_stack+130929, 0.0, zero_stack, 1.0, int_stack+464935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536219,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+105201,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 1.0, int_stack+653424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1186615,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+107361,int_stack+105201,int_stack+1812142, 0.0, zero_stack, 1.0, int_stack+654504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1187695,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+107361,int_stack+1813822, 0.0, zero_stack, 1.0, int_stack+656184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1189375,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+131929,int_stack+131379, 0.0, zero_stack, 1.0, int_stack+465385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536669,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+658284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1191475,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+110161,int_stack+1814482,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+659634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1192825,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+110161,int_stack+107361, 0.0, zero_stack, 1.0, int_stack+661794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1194985,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 0.0, zero_stack, 1.0, int_stack+664594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1197785,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+105201,int_stack+132904,int_stack+132589, 0.0, zero_stack, 1.0, int_stack+469105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540389,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+106146,int_stack+133324,int_stack+132904, 0.0, zero_stack, 1.0, int_stack+469420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540704,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+107406,int_stack+106146,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+697834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1221811,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+109296,int_stack+133864,int_stack+133324, 0.0, zero_stack, 1.0, int_stack+469840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541124,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+110916,int_stack+109296,int_stack+106146, 0.0, zero_stack, 1.0, int_stack+698779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1222756,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+113436,int_stack+110916,int_stack+107406, 0.0, zero_stack, 1.0, int_stack+700039, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1224016,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+105201,int_stack+134539,int_stack+133864, 0.0, zero_stack, 1.0, int_stack+470380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541664,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+116586,int_stack+105201,int_stack+109296, 0.0, zero_stack, 1.0, int_stack+701929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1230421,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+119826,int_stack+116586,int_stack+110916, 0.0, zero_stack, 1.0, int_stack+703549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1232041,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+107226,int_stack+119826,int_stack+113436, 0.0, zero_stack, 1.0, int_stack+706069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1234561,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+111951,int_stack+135364,int_stack+134539, 0.0, zero_stack, 1.0, int_stack+471055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542339,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+124026,int_stack+111951,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+709219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1237711,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+128076,int_stack+124026,int_stack+116586, 0.0, zero_stack, 1.0, int_stack+711244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1239736,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+111951,int_stack+128076,int_stack+119826, 0.0, zero_stack, 1.0, int_stack+714484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1242976,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+118251,int_stack+111951,int_stack+107226, 0.0, zero_stack, 1.0, int_stack+718684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1247176,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+2022658,int_stack+118251,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+136795,int_stack+136354, 0.0, zero_stack, 1.0, int_stack+194084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255808,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+137383,int_stack+136795, 0.0, zero_stack, 1.0, int_stack+194966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256690,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+105201,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+779626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1251901,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+107847,int_stack+138139,int_stack+137383, 0.0, zero_stack, 1.0, int_stack+196142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257866,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+110115,int_stack+107847,int_stack+1738654, 0.0, zero_stack, 1.0, int_stack+780949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1253224,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+110115,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+782713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1254988,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+113643,int_stack+139084,int_stack+138139, 0.0, zero_stack, 1.0, int_stack+197654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259378,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+124866,int_stack+113643,int_stack+107847, 0.0, zero_stack, 1.0, int_stack+785359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1278046,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+129402,int_stack+124866,int_stack+110115, 0.0, zero_stack, 1.0, int_stack+787627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1280314,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+105201,int_stack+129402,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+791155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1283842,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+140239,int_stack+139084, 0.0, zero_stack, 1.0, int_stack+199544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261268,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+135282,int_stack+1737331,int_stack+113643, 0.0, zero_stack, 1.0, int_stack+795565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1288252,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+135282,int_stack+124866, 0.0, zero_stack, 1.0, int_stack+798400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1291087,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+755842,int_stack+1808332,int_stack+129402, 0.0, zero_stack, 1.0, int_stack+802936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1295623,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+808816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1301503,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2035888,int_stack+1808332,int_stack+118251,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+141835,int_stack+141625, 0.0, zero_stack, 1.0, int_stack+481906, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535369, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+142115,int_stack+141835, 0.0, zero_stack, 1.0, int_stack+482116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535579, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+815431, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1183885, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+142475,int_stack+142115, 0.0, zero_stack, 1.0, int_stack+482396, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535859, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 1.0, int_stack+816061, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1184515, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 1.0, int_stack+816901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1185355, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+142925,int_stack+142475, 0.0, zero_stack, 1.0, int_stack+482756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536219, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+105201,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 1.0, int_stack+818161, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1186615, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+107361,int_stack+105201,int_stack+1812142, 0.0, zero_stack, 1.0, int_stack+819241, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1187695, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+107361,int_stack+1813822, 0.0, zero_stack, 1.0, int_stack+820921, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1189375, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+143475,int_stack+142925, 0.0, zero_stack, 1.0, int_stack+483206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536669, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+823021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1191475, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+110161,int_stack+1814482,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+824371, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1192825, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+110161,int_stack+107361, 0.0, zero_stack, 1.0, int_stack+826531, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1194985, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 0.0, zero_stack, 1.0, int_stack+829331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1197785, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+105201,int_stack+144450,int_stack+144135, 0.0, zero_stack, 1.0, int_stack+486926, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540389, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+106146,int_stack+144870,int_stack+144450, 0.0, zero_stack, 1.0, int_stack+487241, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540704, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+107406,int_stack+106146,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1221811, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+109296,int_stack+145410,int_stack+144870, 0.0, zero_stack, 1.0, int_stack+487661, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541124, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+110916,int_stack+109296,int_stack+106146, 0.0, zero_stack, 1.0, int_stack+854302, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1222756, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+113436,int_stack+110916,int_stack+107406, 0.0, zero_stack, 1.0, int_stack+855562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1224016, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+105201,int_stack+146085,int_stack+145410, 0.0, zero_stack, 1.0, int_stack+488201, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541664, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+116586,int_stack+105201,int_stack+109296, 0.0, zero_stack, 1.0, int_stack+861967, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1230421, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+119826,int_stack+116586,int_stack+110916, 0.0, zero_stack, 1.0, int_stack+863587, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1232041, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+107226,int_stack+119826,int_stack+113436, 0.0, zero_stack, 1.0, int_stack+866107, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1234561, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+111951,int_stack+146910,int_stack+146085, 0.0, zero_stack, 1.0, int_stack+488876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542339, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+124026,int_stack+111951,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+869257, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1237711, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+128076,int_stack+124026,int_stack+116586, 0.0, zero_stack, 1.0, int_stack+871282, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1239736, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+111951,int_stack+128076,int_stack+119826, 0.0, zero_stack, 1.0, int_stack+874522, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1242976, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+118251,int_stack+111951,int_stack+107226, 0.0, zero_stack, 1.0, int_stack+878722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1247176, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+124866,int_stack+118251,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+148341,int_stack+147900, 0.0, zero_stack, 1.0, int_stack+209515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255808, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+148929,int_stack+148341, 0.0, zero_stack, 1.0, int_stack+210397, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256690, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+105201,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+883447, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1251901, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+107847,int_stack+149685,int_stack+148929, 0.0, zero_stack, 1.0, int_stack+211573, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257866, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+110115,int_stack+107847,int_stack+1738654, 0.0, zero_stack, 1.0, int_stack+884770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1253224, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+110115,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+886534, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1254988, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+113643,int_stack+150630,int_stack+149685, 0.0, zero_stack, 1.0, int_stack+213085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259378, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+138096,int_stack+113643,int_stack+107847, 0.0, zero_stack, 1.0, int_stack+909592, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1278046, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+142632,int_stack+138096,int_stack+110115, 0.0, zero_stack, 1.0, int_stack+911860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1280314, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+105201,int_stack+142632,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+915388, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1283842, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+151785,int_stack+150630, 0.0, zero_stack, 1.0, int_stack+214975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261268, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+1737331,int_stack+113643, 0.0, zero_stack, 1.0, int_stack+919798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1288252, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755842,int_stack+1808332,int_stack+138096, 0.0, zero_stack, 1.0, int_stack+922633, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1291087, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+142632, 0.0, zero_stack, 1.0, int_stack+927169, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1295623, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+138096,int_stack+1808332,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+933049, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1301503, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2055733,int_stack+138096,int_stack+118251,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+138096,int_stack+153381,int_stack+153171, 0.0, zero_stack, 1.0, int_stack+499727, 0.0, zero_stack, 1.0, int_stack+535369, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+138726,int_stack+153661,int_stack+153381, 0.0, zero_stack, 1.0, int_stack+499937, 0.0, zero_stack, 1.0, int_stack+535579, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+139566,int_stack+138726,int_stack+138096, 0.0, zero_stack, 1.0, int_stack+939664, 0.0, zero_stack, 1.0, int_stack+1183885, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+140826,int_stack+154021,int_stack+153661, 0.0, zero_stack, 1.0, int_stack+500217, 0.0, zero_stack, 1.0, int_stack+535859, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+141906,int_stack+140826,int_stack+138726, 0.0, zero_stack, 1.0, int_stack+940294, 0.0, zero_stack, 1.0, int_stack+1184515, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+143586,int_stack+141906,int_stack+139566, 0.0, zero_stack, 1.0, int_stack+941134, 0.0, zero_stack, 1.0, int_stack+1185355, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+138096,int_stack+154471,int_stack+154021, 0.0, zero_stack, 1.0, int_stack+500577, 0.0, zero_stack, 1.0, int_stack+536219, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+145686,int_stack+138096,int_stack+140826, 0.0, zero_stack, 1.0, int_stack+942394, 0.0, zero_stack, 1.0, int_stack+1186615, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+147846,int_stack+145686,int_stack+141906, 0.0, zero_stack, 1.0, int_stack+943474, 0.0, zero_stack, 1.0, int_stack+1187695, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+139446,int_stack+147846,int_stack+143586, 0.0, zero_stack, 1.0, int_stack+945154, 0.0, zero_stack, 1.0, int_stack+1189375, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+142596,int_stack+155021,int_stack+154471, 0.0, zero_stack, 1.0, int_stack+501027, 0.0, zero_stack, 1.0, int_stack+536669, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+150646,int_stack+142596,int_stack+138096, 0.0, zero_stack, 1.0, int_stack+947254, 0.0, zero_stack, 1.0, int_stack+1191475, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+105201,int_stack+150646,int_stack+145686, 0.0, zero_stack, 1.0, int_stack+948604, 0.0, zero_stack, 1.0, int_stack+1192825, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+150646,int_stack+105201,int_stack+147846, 0.0, zero_stack, 1.0, int_stack+950764, 0.0, zero_stack, 1.0, int_stack+1194985, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+150646,int_stack+139446, 0.0, zero_stack, 1.0, int_stack+953564, 0.0, zero_stack, 1.0, int_stack+1197785, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+105201,int_stack+155996,int_stack+155681, 0.0, zero_stack, 1.0, int_stack+504747, 0.0, zero_stack, 1.0, int_stack+540389, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+106146,int_stack+156416,int_stack+155996, 0.0, zero_stack, 1.0, int_stack+505062, 0.0, zero_stack, 1.0, int_stack+540704, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+107406,int_stack+106146,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+982000, 0.0, zero_stack, 1.0, int_stack+1221811, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+109296,int_stack+156956,int_stack+156416, 0.0, zero_stack, 1.0, int_stack+505482, 0.0, zero_stack, 1.0, int_stack+541124, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+110916,int_stack+109296,int_stack+106146, 0.0, zero_stack, 1.0, int_stack+982945, 0.0, zero_stack, 1.0, int_stack+1222756, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+113436,int_stack+110916,int_stack+107406, 0.0, zero_stack, 1.0, int_stack+984205, 0.0, zero_stack, 1.0, int_stack+1224016, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+105201,int_stack+157631,int_stack+156956, 0.0, zero_stack, 1.0, int_stack+506022, 0.0, zero_stack, 1.0, int_stack+541664, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+116586,int_stack+105201,int_stack+109296, 0.0, zero_stack, 1.0, int_stack+986095, 0.0, zero_stack, 1.0, int_stack+1230421, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+119826,int_stack+116586,int_stack+110916, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+1232041, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+107226,int_stack+119826,int_stack+113436, 0.0, zero_stack, 1.0, int_stack+987715, 0.0, zero_stack, 1.0, int_stack+1234561, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+111951,int_stack+158456,int_stack+157631, 0.0, zero_stack, 1.0, int_stack+506697, 0.0, zero_stack, 1.0, int_stack+542339, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+138096,int_stack+111951,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+990865, 0.0, zero_stack, 1.0, int_stack+1237711, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+142146,int_stack+138096,int_stack+116586, 0.0, zero_stack, 1.0, int_stack+992890, 0.0, zero_stack, 1.0, int_stack+1239736, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+111951,int_stack+142146,int_stack+119826, 0.0, zero_stack, 1.0, int_stack+996130, 0.0, zero_stack, 1.0, int_stack+1242976, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+118251,int_stack+111951,int_stack+107226, 0.0, zero_stack, 1.0, int_stack+1000330, 0.0, zero_stack, 1.0, int_stack+1247176, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+138096,int_stack+118251,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+159887,int_stack+159446, 0.0, zero_stack, 1.0, int_stack+224946, 0.0, zero_stack, 1.0, int_stack+255808, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+160475,int_stack+159887, 0.0, zero_stack, 1.0, int_stack+225828, 0.0, zero_stack, 1.0, int_stack+256690, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+151326,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1005055, 0.0, zero_stack, 1.0, int_stack+1251901, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153972,int_stack+161231,int_stack+160475, 0.0, zero_stack, 1.0, int_stack+227004, 0.0, zero_stack, 1.0, int_stack+257866, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156240,int_stack+153972,int_stack+1738654, 0.0, zero_stack, 1.0, int_stack+1006378, 0.0, zero_stack, 1.0, int_stack+1253224, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+156240,int_stack+151326, 0.0, zero_stack, 1.0, int_stack+1008142, 0.0, zero_stack, 1.0, int_stack+1254988, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+105201,int_stack+162176,int_stack+161231, 0.0, zero_stack, 1.0, int_stack+228516, 0.0, zero_stack, 1.0, int_stack+259378, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+108036,int_stack+105201,int_stack+153972, 0.0, zero_stack, 1.0, int_stack+1031200, 0.0, zero_stack, 1.0, int_stack+1278046, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+108036,int_stack+156240, 0.0, zero_stack, 1.0, int_stack+1033468, 0.0, zero_stack, 1.0, int_stack+1280314, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+151326,int_stack+1808332,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1036996, 0.0, zero_stack, 1.0, int_stack+1283842, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+163331,int_stack+162176, 0.0, zero_stack, 1.0, int_stack+230406, 0.0, zero_stack, 1.0, int_stack+261268, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+157941,int_stack+1737331,int_stack+105201, 0.0, zero_stack, 1.0, int_stack+1041406, 0.0, zero_stack, 1.0, int_stack+1288252, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755842,int_stack+157941,int_stack+108036, 0.0, zero_stack, 1.0, int_stack+1044241, 0.0, zero_stack, 1.0, int_stack+1291087, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+105201,int_stack+755842,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1048777, 0.0, zero_stack, 1.0, int_stack+1295623, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+105201,int_stack+151326, 0.0, zero_stack, 1.0, int_stack+1054657, 0.0, zero_stack, 1.0, int_stack+1301503, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2075578,int_stack+1808332,int_stack+118251,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+164927,int_stack+164717, 0.0, zero_stack, 1.0, int_stack+517548, 1.0, int_stack+535369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+165207,int_stack+164927, 0.0, zero_stack, 1.0, int_stack+517758, 1.0, int_stack+535579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1061272, 1.0, int_stack+1183885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+165567,int_stack+165207, 0.0, zero_stack, 1.0, int_stack+518038, 1.0, int_stack+535859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 1.0, int_stack+1061902, 1.0, int_stack+1184515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 1.0, int_stack+1062742, 1.0, int_stack+1185355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+166017,int_stack+165567, 0.0, zero_stack, 1.0, int_stack+518398, 1.0, int_stack+536219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+151326,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 1.0, int_stack+1064002, 1.0, int_stack+1186615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+153486,int_stack+151326,int_stack+1812142, 0.0, zero_stack, 1.0, int_stack+1065082, 1.0, int_stack+1187695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+153486,int_stack+1813822, 0.0, zero_stack, 1.0, int_stack+1066762, 1.0, int_stack+1189375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+166567,int_stack+166017, 0.0, zero_stack, 1.0, int_stack+518848, 1.0, int_stack+536669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1068862, 1.0, int_stack+1191475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+156286,int_stack+1814482,int_stack+151326, 0.0, zero_stack, 1.0, int_stack+1070212, 1.0, int_stack+1192825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+156286,int_stack+153486, 0.0, zero_stack, 1.0, int_stack+1072372, 1.0, int_stack+1194985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 0.0, zero_stack, 1.0, int_stack+1075172, 1.0, int_stack+1197785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+151326,int_stack+167542,int_stack+167227, 0.0, zero_stack, 1.0, int_stack+522568, 1.0, int_stack+540389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+152271,int_stack+167962,int_stack+167542, 0.0, zero_stack, 1.0, int_stack+522883, 1.0, int_stack+540704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+153531,int_stack+152271,int_stack+151326, 0.0, zero_stack, 1.0, int_stack+1099198, 1.0, int_stack+1221811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+155421,int_stack+168502,int_stack+167962, 0.0, zero_stack, 1.0, int_stack+523303, 1.0, int_stack+541124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+157041,int_stack+155421,int_stack+152271, 0.0, zero_stack, 1.0, int_stack+1100143, 1.0, int_stack+1222756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+159561,int_stack+157041,int_stack+153531, 0.0, zero_stack, 1.0, int_stack+1101403, 1.0, int_stack+1224016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+151326,int_stack+169177,int_stack+168502, 0.0, zero_stack, 1.0, int_stack+523843, 1.0, int_stack+541664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+162711,int_stack+151326,int_stack+155421, 0.0, zero_stack, 1.0, int_stack+2520, 1.0, int_stack+1230421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+162711,int_stack+157041, 0.0, zero_stack, 1.0, int_stack+1107808, 1.0, int_stack+1232041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+153351,int_stack+1808332,int_stack+159561, 0.0, zero_stack, 1.0, int_stack+1110328, 1.0, int_stack+1234561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+158076,int_stack+170002,int_stack+169177, 0.0, zero_stack, 1.0, int_stack+524518, 1.0, int_stack+542339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+165951,int_stack+158076,int_stack+151326, 0.0, zero_stack, 1.0, int_stack+1113478, 1.0, int_stack+1237711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+105201,int_stack+165951,int_stack+162711, 0.0, zero_stack, 1.0, int_stack+1115503, 1.0, int_stack+1239736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+158076,int_stack+105201,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1118743, 1.0, int_stack+1242976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+158076,int_stack+153351, 0.0, zero_stack, 1.0, int_stack+1122943, 1.0, int_stack+1247176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+105201,int_stack+1808332,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+171433,int_stack+170992, 0.0, zero_stack, 1.0, int_stack+240377, 1.0, int_stack+255808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+172021,int_stack+171433, 0.0, zero_stack, 1.0, int_stack+241259, 1.0, int_stack+256690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814947,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1127668, 1.0, int_stack+1251901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+118431,int_stack+172777,int_stack+172021, 0.0, zero_stack, 1.0, int_stack+242435, 1.0, int_stack+257866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+120699,int_stack+118431,int_stack+1738654, 0.0, zero_stack, 1.0, int_stack+1128991, 1.0, int_stack+1253224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+120699,int_stack+1814947, 0.0, zero_stack, 1.0, int_stack+1130755, 1.0, int_stack+1254988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+151326,int_stack+173722,int_stack+172777, 0.0, zero_stack, 1.0, int_stack+243947, 1.0, int_stack+259378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+154161,int_stack+151326,int_stack+118431, 0.0, zero_stack, 1.0, int_stack+1153813, 1.0, int_stack+1278046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+158697,int_stack+154161,int_stack+120699, 0.0, zero_stack, 1.0, int_stack+1156081, 1.0, int_stack+1280314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+164577,int_stack+158697,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1159609, 1.0, int_stack+1283842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+174877,int_stack+173722, 0.0, zero_stack, 1.0, int_stack+245837, 1.0, int_stack+261268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+118431,int_stack+1737331,int_stack+151326, 0.0, zero_stack, 1.0, int_stack+1164019, 1.0, int_stack+1288252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755842,int_stack+118431,int_stack+154161, 0.0, zero_stack, 1.0, int_stack+1166854, 1.0, int_stack+1291087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2095423,int_stack+755842,int_stack+158697, 0.0, zero_stack, 1.0, int_stack+1171390, 1.0, int_stack+1295623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+151326,int_stack+2095423,int_stack+164577, 0.0, zero_stack, 1.0, int_stack+1177270, 1.0, int_stack+1301503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2095423,int_stack+151326,int_stack+1808332,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+176473,int_stack+176263, 0.0, zero_stack, 2.0, int_stack+535369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+176753,int_stack+176473, 0.0, zero_stack, 2.0, int_stack+535579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 2.0, int_stack+1183885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+177113,int_stack+176753, 0.0, zero_stack, 2.0, int_stack+535859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 2.0, int_stack+1184515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 2.0, int_stack+1185355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+177563,int_stack+177113, 0.0, zero_stack, 2.0, int_stack+536219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+151326,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 2.0, int_stack+1186615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+153486,int_stack+151326,int_stack+1812142, 0.0, zero_stack, 2.0, int_stack+1187695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+153486,int_stack+1813822, 0.0, zero_stack, 2.0, int_stack+1189375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+178113,int_stack+177563, 0.0, zero_stack, 2.0, int_stack+536669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 2.0, int_stack+1191475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+156286,int_stack+1814482,int_stack+151326, 0.0, zero_stack, 2.0, int_stack+1192825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+156286,int_stack+153486, 0.0, zero_stack, 2.0, int_stack+1194985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 0.0, zero_stack, 2.0, int_stack+1197785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+151326,int_stack+179088,int_stack+178773, 0.0, zero_stack, 2.0, int_stack+540389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+152271,int_stack+179508,int_stack+179088, 0.0, zero_stack, 2.0, int_stack+540704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+153531,int_stack+152271,int_stack+151326, 0.0, zero_stack, 2.0, int_stack+1221811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+155421,int_stack+180048,int_stack+179508, 0.0, zero_stack, 2.0, int_stack+541124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+157041,int_stack+155421,int_stack+152271, 0.0, zero_stack, 2.0, int_stack+1222756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+159561,int_stack+157041,int_stack+153531, 0.0, zero_stack, 2.0, int_stack+1224016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+151326,int_stack+180723,int_stack+180048, 0.0, zero_stack, 2.0, int_stack+541664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+162711,int_stack+151326,int_stack+155421, 0.0, zero_stack, 2.0, int_stack+1230421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165951,int_stack+162711,int_stack+157041, 0.0, zero_stack, 2.0, int_stack+1232041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+153351,int_stack+165951,int_stack+159561, 0.0, zero_stack, 2.0, int_stack+1234561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+158076,int_stack+181548,int_stack+180723, 0.0, zero_stack, 2.0, int_stack+542339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+170151,int_stack+158076,int_stack+151326, 0.0, zero_stack, 2.0, int_stack+1237711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+174201,int_stack+170151,int_stack+162711, 0.0, zero_stack, 2.0, int_stack+1239736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+158076,int_stack+174201,int_stack+165951, 0.0, zero_stack, 2.0, int_stack+1242976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+164376,int_stack+158076,int_stack+153351, 0.0, zero_stack, 2.0, int_stack+1247176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+2115268,int_stack+164376,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+182979,int_stack+182538, 0.0, zero_stack, 2.0, int_stack+255808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+183567,int_stack+182979, 0.0, zero_stack, 2.0, int_stack+256690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+151326,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 2.0, int_stack+1251901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153972,int_stack+184323,int_stack+183567, 0.0, zero_stack, 2.0, int_stack+257866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156240,int_stack+153972,int_stack+1738654, 0.0, zero_stack, 2.0, int_stack+1253224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+156240,int_stack+151326, 0.0, zero_stack, 2.0, int_stack+1254988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+159768,int_stack+185268,int_stack+184323, 0.0, zero_stack, 2.0, int_stack+259378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+170991,int_stack+159768,int_stack+153972, 0.0, zero_stack, 2.0, int_stack+1278046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+175527,int_stack+170991,int_stack+156240, 0.0, zero_stack, 2.0, int_stack+1280314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+151326,int_stack+175527,int_stack+1737331, 0.0, zero_stack, 2.0, int_stack+1283842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+186423,int_stack+185268, 0.0, zero_stack, 2.0, int_stack+261268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+181407,int_stack+1737331,int_stack+159768, 0.0, zero_stack, 2.0, int_stack+1288252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+181407,int_stack+170991, 0.0, zero_stack, 2.0, int_stack+1291087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+755842,int_stack+1808332,int_stack+175527, 0.0, zero_stack, 2.0, int_stack+1295623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+151326, 0.0, zero_stack, 2.0, int_stack+1301503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2128498,int_stack+1808332,int_stack+164376,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+188019,int_stack+187809, 1.0, int_stack+464085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553190,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+188299,int_stack+188019, 1.0, int_stack+464295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553400,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 1.0, int_stack+650694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308118,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+188659,int_stack+188299, 1.0, int_stack+464575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553680,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 1.0, int_stack+651324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308748,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 1.0, int_stack+652164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1309588,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+189109,int_stack+188659, 1.0, int_stack+464935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554040,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+151326,int_stack+1808332,int_stack+1811062, 1.0, int_stack+653424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1310848,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+153486,int_stack+151326,int_stack+1812142, 1.0, int_stack+654504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1311928,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+153486,int_stack+1813822, 1.0, int_stack+656184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1313608,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+189659,int_stack+189109, 1.0, int_stack+465385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554490,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 1.0, int_stack+658284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633644,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+156286,int_stack+1814482,int_stack+151326, 1.0, int_stack+659634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1315708,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+156286,int_stack+153486, 1.0, int_stack+661794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1317868,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 1.0, int_stack+664594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634994,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+151326,int_stack+190634,int_stack+190319, 1.0, int_stack+469105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558525,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+152271,int_stack+191054,int_stack+190634, 1.0, int_stack+469420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559260,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+153531,int_stack+152271,int_stack+151326, 1.0, int_stack+697834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1320668,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+155421,int_stack+191594,int_stack+191054, 1.0, int_stack+469840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560220,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+157041,int_stack+155421,int_stack+152271, 1.0, int_stack+698779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1321613,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+159561,int_stack+157041,int_stack+153531, 1.0, int_stack+700039, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1322873,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+151326,int_stack+192269,int_stack+191594, 1.0, int_stack+470380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561435,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+162711,int_stack+151326,int_stack+155421, 1.0, int_stack+701929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+638144,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+165951,int_stack+162711,int_stack+157041, 1.0, int_stack+703549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4140,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+153351,int_stack+165951,int_stack+159561, 1.0, int_stack+706069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350454,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+158076,int_stack+193094,int_stack+192269, 1.0, int_stack+471055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562935,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+170151,int_stack+158076,int_stack+151326, 1.0, int_stack+709219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667744,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+174201,int_stack+170151,int_stack+162711, 1.0, int_stack+711244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353604,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+158076,int_stack+174201,int_stack+165951, 1.0, int_stack+714484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1356844,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+164376,int_stack+158076,int_stack+153351, 1.0, int_stack+718684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1361044,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+170991,int_stack+164376,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+195554,int_stack+194525, 1.0, int_stack+194084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271680,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+196898,int_stack+195554, 1.0, int_stack+194966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273150,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+151326,int_stack+1738654,int_stack+1737331, 1.0, int_stack+779626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676354,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153972,int_stack+198599,int_stack+196898, 1.0, int_stack+196142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275082,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156240,int_stack+153972,int_stack+1738654, 1.0, int_stack+780949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677677,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+156240,int_stack+151326, 1.0, int_stack+782713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+679441,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+159768,int_stack+200699,int_stack+198599, 1.0, int_stack+197654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277539,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+184221,int_stack+159768,int_stack+153972, 1.0, int_stack+785359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1385614,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+188757,int_stack+184221,int_stack+156240, 1.0, int_stack+787627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1387882,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+151326,int_stack+188757,int_stack+1737331, 1.0, int_stack+791155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1391410,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+201854,int_stack+200699, 1.0, int_stack+199544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+279429,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+194637,int_stack+1737331,int_stack+159768, 1.0, int_stack+795565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723409,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+194637,int_stack+184221, 1.0, int_stack+798400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1395820,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+755842,int_stack+1808332,int_stack+188757, 1.0, int_stack+802936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1400356,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+755842,int_stack+151326, 1.0, int_stack+808816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406236,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+697487,int_stack+1808332,int_stack+164376,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+203450,int_stack+203240, 1.0, int_stack+481906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553190, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+203730,int_stack+203450, 1.0, int_stack+482116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553400, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 1.0, int_stack+815431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308118, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+204090,int_stack+203730, 1.0, int_stack+482396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553680, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 1.0, int_stack+816061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308748, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 1.0, int_stack+816901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1309588, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+204540,int_stack+204090, 1.0, int_stack+482756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554040, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+151326,int_stack+1808332,int_stack+1811062, 1.0, int_stack+818161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1310848, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+153486,int_stack+151326,int_stack+1812142, 1.0, int_stack+819241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1311928, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+153486,int_stack+1813822, 1.0, int_stack+820921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1313608, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+205090,int_stack+204540, 1.0, int_stack+483206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554490, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 1.0, int_stack+823021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633644, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+156286,int_stack+1814482,int_stack+151326, 1.0, int_stack+824371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1315708, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1812832,int_stack+156286,int_stack+153486, 1.0, int_stack+826531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1317868, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1812832,int_stack+1809682, 1.0, int_stack+829331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634994, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+151326,int_stack+206065,int_stack+205750, 1.0, int_stack+486926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558525, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+152271,int_stack+206485,int_stack+206065, 1.0, int_stack+487241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559260, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+153531,int_stack+152271,int_stack+151326, 1.0, int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1320668, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+155421,int_stack+207025,int_stack+206485, 1.0, int_stack+487661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560220, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+157041,int_stack+155421,int_stack+152271, 1.0, int_stack+854302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1321613, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+159561,int_stack+157041,int_stack+153531, 1.0, int_stack+855562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1322873, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+207700,int_stack+207025, 1.0, int_stack+488201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561435, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+151326,int_stack+853357,int_stack+155421, 1.0, int_stack+861967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+638144, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+162711,int_stack+151326,int_stack+157041, 1.0, int_stack+863587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4140, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+154566,int_stack+162711,int_stack+159561, 1.0, int_stack+866107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350454, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+861967,int_stack+208525,int_stack+207700, 1.0, int_stack+488876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562935, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+864442,int_stack+861967,int_stack+853357, 1.0, int_stack+869257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667744, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+864442,int_stack+151326, 1.0, int_stack+871282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353604, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+861967,int_stack+1808332,int_stack+162711, 1.0, int_stack+874522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1356844, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+861967,int_stack+154566, 1.0, int_stack+878722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1361044, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+861967,int_stack+1808332,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+210985,int_stack+209956, 1.0, int_stack+209515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271680, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+212329,int_stack+210985, 1.0, int_stack+210397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273150, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814947,int_stack+1738654,int_stack+1737331, 1.0, int_stack+883447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676354, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+875197,int_stack+214030,int_stack+212329, 1.0, int_stack+211573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275082, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877465,int_stack+875197,int_stack+1738654, 1.0, int_stack+884770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677677, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+877465,int_stack+1814947, 1.0, int_stack+886534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+679441, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+880993,int_stack+216130,int_stack+214030, 1.0, int_stack+213085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277539, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+883828,int_stack+880993,int_stack+875197, 1.0, int_stack+909592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1385614, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+151326,int_stack+883828,int_stack+877465, 1.0, int_stack+911860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1387882, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+157206,int_stack+151326,int_stack+1737331, 1.0, int_stack+915388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1391410, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+217285,int_stack+216130, 1.0, int_stack+214975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+279429, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+909592,int_stack+1737331,int_stack+880993, 1.0, int_stack+919798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723409, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+875197,int_stack+909592,int_stack+883828, 1.0, int_stack+922633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1395820, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+909592,int_stack+875197,int_stack+151326, 1.0, int_stack+927169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1400356, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+875197,int_stack+909592,int_stack+157206, 1.0, int_stack+933049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406236, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+909592,int_stack+875197,int_stack+1808332,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+218881,int_stack+218671, 1.0, int_stack+499727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553190, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+219161,int_stack+218881, 1.0, int_stack+499937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553400, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 1.0, int_stack+939664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308118, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+219521,int_stack+219161, 1.0, int_stack+500217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553680, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 1.0, int_stack+940294, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308748, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 1.0, int_stack+941134, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1309588, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+219971,int_stack+219521, 1.0, int_stack+500577, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554040, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+875197,int_stack+1808332,int_stack+1811062, 1.0, int_stack+942394, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1310848, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877357,int_stack+875197,int_stack+1812142, 1.0, int_stack+943474, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1311928, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+877357,int_stack+1813822, 1.0, int_stack+945154, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1313608, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+220521,int_stack+219971, 1.0, int_stack+501027, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554490, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 1.0, int_stack+947254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633644, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+880157,int_stack+1814482,int_stack+875197, 1.0, int_stack+948604, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1315708, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+880157,int_stack+877357, 1.0, int_stack+950764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1317868, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+1809682, 1.0, int_stack+953564, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634994, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+221496,int_stack+221181, 1.0, int_stack+504747, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558525, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+221916,int_stack+221496, 1.0, int_stack+505062, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559260, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 1.0, int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1320668, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+875197,int_stack+222456,int_stack+221916, 1.0, int_stack+505482, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560220, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+876817,int_stack+875197,int_stack+854302, 1.0, int_stack+982945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1321613, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+879337,int_stack+876817,int_stack+855562, 1.0, int_stack+984205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1322873, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+223131,int_stack+222456, 1.0, int_stack+506022, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561435, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+853357,int_stack+982000,int_stack+875197, 1.0, int_stack+986095, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+638144, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+882487,int_stack+853357,int_stack+876817, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4140, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+882487,int_stack+879337, 1.0, int_stack+987715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350454, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+223956,int_stack+223131, 1.0, int_stack+506697, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562935, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+875197,int_stack+0,int_stack+982000, 1.0, int_stack+990865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667744, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+982000,int_stack+875197,int_stack+853357, 1.0, int_stack+992890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353604, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+875197,int_stack+982000,int_stack+882487, 1.0, int_stack+996130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1356844, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+875197,int_stack+1808332, 1.0, int_stack+1000330, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1361044, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+875197,int_stack+982000,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+226416,int_stack+225387, 1.0, int_stack+224946, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271680, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+227760,int_stack+226416, 1.0, int_stack+225828, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273150, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1808332,int_stack+1738654,int_stack+1737331, 1.0, int_stack+1005055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676354, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1810978,int_stack+229461,int_stack+227760, 1.0, int_stack+227004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275082, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1813246,int_stack+1810978,int_stack+1738654, 1.0, int_stack+1006378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677677, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1813246,int_stack+1808332, 1.0, int_stack+1008142, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+679441, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+988615,int_stack+231561,int_stack+229461, 1.0, int_stack+228516, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277539, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+991450,int_stack+988615,int_stack+1810978, 1.0, int_stack+1031200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1385614, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+995986,int_stack+991450,int_stack+1813246, 1.0, int_stack+1033468, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1387882, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+995986,int_stack+1737331, 1.0, int_stack+1036996, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1391410, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+232716,int_stack+231561, 1.0, int_stack+230406, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+279429, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1031200,int_stack+1737331,int_stack+988615, 1.0, int_stack+1041406, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723409, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1001866,int_stack+1031200,int_stack+991450, 1.0, int_stack+1044241, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1395820, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1031200,int_stack+1001866,int_stack+995986, 1.0, int_stack+1048777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1400356, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1040020,int_stack+1031200,int_stack+1808332, 1.0, int_stack+1054657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406236, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+988615,int_stack+1040020,int_stack+982000,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+234312,int_stack+234102, 1.0, int_stack+517548, 0.0, zero_stack, 1.0, int_stack+553190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+234592,int_stack+234312, 1.0, int_stack+517758, 0.0, zero_stack, 1.0, int_stack+553400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 1.0, int_stack+1061272, 0.0, zero_stack, 1.0, int_stack+1308118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+234952,int_stack+234592, 1.0, int_stack+518038, 0.0, zero_stack, 1.0, int_stack+553680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 1.0, int_stack+1061902, 0.0, zero_stack, 1.0, int_stack+1308748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+985810,int_stack+983470, 1.0, int_stack+1062742, 0.0, zero_stack, 1.0, int_stack+1309588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+235402,int_stack+234952, 1.0, int_stack+518398, 0.0, zero_stack, 1.0, int_stack+554040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+982000,int_stack+984730, 1.0, int_stack+1064002, 0.0, zero_stack, 1.0, int_stack+1310848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+985810, 1.0, int_stack+1065082, 0.0, zero_stack, 1.0, int_stack+1311928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+1812592,int_stack+1808332, 1.0, int_stack+1066762, 0.0, zero_stack, 1.0, int_stack+1313608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+235952,int_stack+235402, 1.0, int_stack+518848, 0.0, zero_stack, 1.0, int_stack+554490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1031200,int_stack+1808332,int_stack+982000, 1.0, int_stack+1068862, 0.0, zero_stack, 1.0, int_stack+633644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1033900,int_stack+1031200,int_stack+1810432, 1.0, int_stack+1070212, 0.0, zero_stack, 1.0, int_stack+1315708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+1033900,int_stack+1812592, 1.0, int_stack+1072372, 0.0, zero_stack, 1.0, int_stack+1317868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+983350, 1.0, int_stack+1075172, 0.0, zero_stack, 1.0, int_stack+634994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+236927,int_stack+236612, 1.0, int_stack+522568, 0.0, zero_stack, 1.0, int_stack+558525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+237347,int_stack+236927, 1.0, int_stack+522883, 0.0, zero_stack, 1.0, int_stack+559260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 1.0, int_stack+1099198, 0.0, zero_stack, 1.0, int_stack+1320668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1031200,int_stack+237887,int_stack+237347, 1.0, int_stack+523303, 0.0, zero_stack, 1.0, int_stack+560220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+1031200,int_stack+854302, 1.0, int_stack+1100143, 0.0, zero_stack, 1.0, int_stack+1321613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1032820,int_stack+0,int_stack+855562, 1.0, int_stack+1101403, 0.0, zero_stack, 1.0, int_stack+1322873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+238562,int_stack+237887, 1.0, int_stack+523843, 0.0, zero_stack, 1.0, int_stack+561435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+853357,int_stack+1099198,int_stack+1031200, 1.0, int_stack+2520, 0.0, zero_stack, 1.0, int_stack+638144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1035970,int_stack+853357,int_stack+0, 1.0, int_stack+1107808, 0.0, zero_stack, 1.0, int_stack+4140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1040170,int_stack+1035970,int_stack+1032820, 1.0, int_stack+1110328, 0.0, zero_stack, 1.0, int_stack+1350454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1107808,int_stack+239387,int_stack+238562, 1.0, int_stack+524518, 0.0, zero_stack, 1.0, int_stack+562935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+1107808,int_stack+1099198, 1.0, int_stack+1113478, 0.0, zero_stack, 1.0, int_stack+667744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1107808,int_stack+0,int_stack+853357, 1.0, int_stack+1115503, 0.0, zero_stack, 1.0, int_stack+1353604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1044895,int_stack+1107808,int_stack+1035970, 1.0, int_stack+1118743, 0.0, zero_stack, 1.0, int_stack+1356844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+1044895,int_stack+1040170, 1.0, int_stack+1122943, 0.0, zero_stack, 1.0, int_stack+1361044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1107808,int_stack+982000,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+241847,int_stack+240818, 1.0, int_stack+240377, 0.0, zero_stack, 1.0, int_stack+271680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+243191,int_stack+241847, 1.0, int_stack+241259, 0.0, zero_stack, 1.0, int_stack+273150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1121038,int_stack+1738654,int_stack+1737331, 1.0, int_stack+1127668, 0.0, zero_stack, 1.0, int_stack+676354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1123684,int_stack+244892,int_stack+243191, 1.0, int_stack+242435, 0.0, zero_stack, 1.0, int_stack+275082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+853357,int_stack+1123684,int_stack+1738654, 1.0, int_stack+1128991, 0.0, zero_stack, 1.0, int_stack+677677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+1121038, 1.0, int_stack+1130755, 0.0, zero_stack, 1.0, int_stack+679441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1125952,int_stack+246992,int_stack+244892, 1.0, int_stack+243947, 0.0, zero_stack, 1.0, int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1128787,int_stack+1125952,int_stack+1123684, 1.0, int_stack+1153813, 0.0, zero_stack, 1.0, int_stack+1385614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1031200,int_stack+1128787,int_stack+853357, 1.0, int_stack+1156081, 0.0, zero_stack, 1.0, int_stack+1387882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1037080,int_stack+1031200,int_stack+1737331, 1.0, int_stack+1159609, 0.0, zero_stack, 1.0, int_stack+1391410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+248147,int_stack+246992, 1.0, int_stack+245837, 0.0, zero_stack, 1.0, int_stack+279429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1153813,int_stack+1737331,int_stack+1125952, 1.0, int_stack+1164019, 0.0, zero_stack, 1.0, int_stack+723409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1121038,int_stack+1153813,int_stack+1128787, 1.0, int_stack+1166854, 0.0, zero_stack, 1.0, int_stack+1395820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1153813,int_stack+1121038,int_stack+1031200, 1.0, int_stack+1171390, 0.0, zero_stack, 1.0, int_stack+1400356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1153813,int_stack+1037080, 1.0, int_stack+1177270, 0.0, zero_stack, 1.0, int_stack+1406236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1153813,int_stack+1808332,int_stack+982000,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+249743,int_stack+249533, 1.0, int_stack+535369, 1.0, int_stack+553190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+250023,int_stack+249743, 1.0, int_stack+535579, 1.0, int_stack+553400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 1.0, int_stack+1183885, 1.0, int_stack+1308118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+250383,int_stack+250023, 1.0, int_stack+535859, 1.0, int_stack+553680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 1.0, int_stack+1184515, 1.0, int_stack+1308748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+985810,int_stack+983470, 1.0, int_stack+1185355, 1.0, int_stack+1309588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+250833,int_stack+250383, 1.0, int_stack+536219, 1.0, int_stack+554040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+982000,int_stack+984730, 1.0, int_stack+1186615, 1.0, int_stack+1310848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+985810, 1.0, int_stack+1187695, 1.0, int_stack+1311928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+1812592,int_stack+1808332, 1.0, int_stack+1189375, 1.0, int_stack+1313608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+251383,int_stack+250833, 1.0, int_stack+536669, 1.0, int_stack+554490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1173658,int_stack+1808332,int_stack+982000, 1.0, int_stack+1191475, 1.0, int_stack+633644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1176358,int_stack+1173658,int_stack+1810432, 1.0, int_stack+1192825, 1.0, int_stack+1315708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+1176358,int_stack+1812592, 1.0, int_stack+1194985, 1.0, int_stack+1317868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+983350, 1.0, int_stack+1197785, 1.0, int_stack+634994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+252358,int_stack+252043, 1.0, int_stack+540389, 1.0, int_stack+558525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+252778,int_stack+252358, 1.0, int_stack+540704, 1.0, int_stack+559260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 1.0, int_stack+1221811, 1.0, int_stack+1320668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1173658,int_stack+253318,int_stack+252778, 1.0, int_stack+541124, 1.0, int_stack+560220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1175278,int_stack+1173658,int_stack+854302, 1.0, int_stack+1222756, 1.0, int_stack+1321613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1177798,int_stack+1175278,int_stack+855562, 1.0, int_stack+1224016, 1.0, int_stack+1322873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1221811,int_stack+253993,int_stack+253318, 1.0, int_stack+541664, 1.0, int_stack+561435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+853357,int_stack+1221811,int_stack+1173658, 1.0, int_stack+1230421, 1.0, int_stack+638144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+853357,int_stack+1175278, 1.0, int_stack+1232041, 1.0, int_stack+4140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1180948,int_stack+1099198,int_stack+1177798, 1.0, int_stack+1234561, 1.0, int_stack+1350454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1230421,int_stack+254818,int_stack+253993, 1.0, int_stack+542339, 1.0, int_stack+562935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1232896,int_stack+1230421,int_stack+1221811, 1.0, int_stack+1237711, 1.0, int_stack+667744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1173658,int_stack+1232896,int_stack+853357, 1.0, int_stack+1239736, 1.0, int_stack+1353604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1230421,int_stack+1173658,int_stack+1099198, 1.0, int_stack+1242976, 1.0, int_stack+1356844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+1230421,int_stack+1180948, 1.0, int_stack+1247176, 1.0, int_stack+1361044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1230421,int_stack+982000,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+257278,int_stack+256249, 1.0, int_stack+255808, 1.0, int_stack+271680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+258622,int_stack+257278, 1.0, int_stack+256690, 1.0, int_stack+273150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1243651,int_stack+1738654,int_stack+1737331, 1.0, int_stack+1251901, 1.0, int_stack+676354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1246297,int_stack+260323,int_stack+258622, 1.0, int_stack+257866, 1.0, int_stack+275082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1248565,int_stack+1246297,int_stack+1738654, 1.0, int_stack+1253224, 1.0, int_stack+677677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1248565,int_stack+1243651, 1.0, int_stack+1254988, 1.0, int_stack+679441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1252093,int_stack+262423,int_stack+260323, 1.0, int_stack+259378, 1.0, int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1173658,int_stack+1252093,int_stack+1246297, 1.0, int_stack+1278046, 1.0, int_stack+1385614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1178194,int_stack+1173658,int_stack+1248565, 1.0, int_stack+1280314, 1.0, int_stack+1387882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1243651,int_stack+1178194,int_stack+1737331, 1.0, int_stack+1283842, 1.0, int_stack+1391410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+263578,int_stack+262423, 1.0, int_stack+261268, 1.0, int_stack+279429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1278046,int_stack+1737331,int_stack+1252093, 1.0, int_stack+1288252, 1.0, int_stack+723409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1250266,int_stack+1278046,int_stack+1173658, 1.0, int_stack+1291087, 1.0, int_stack+1395820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1278046,int_stack+1250266,int_stack+1178194, 1.0, int_stack+1295623, 1.0, int_stack+1400356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1278046,int_stack+1243651, 1.0, int_stack+1301503, 1.0, int_stack+1406236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1278046,int_stack+1808332,int_stack+982000,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+265174,int_stack+264964, 2.0, int_stack+553190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+265454,int_stack+265174, 2.0, int_stack+553400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 2.0, int_stack+1308118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+265814,int_stack+265454, 2.0, int_stack+553680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 2.0, int_stack+1308748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+985810,int_stack+983470, 2.0, int_stack+1309588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+266264,int_stack+265814, 2.0, int_stack+554040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+982000,int_stack+984730, 2.0, int_stack+1310848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+985810, 2.0, int_stack+1311928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+1812592,int_stack+1808332, 2.0, int_stack+1313608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+266814,int_stack+266264, 2.0, int_stack+554490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1243651,int_stack+1808332,int_stack+982000, 2.0, int_stack+633644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1246351,int_stack+1243651,int_stack+1810432, 2.0, int_stack+1315708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+1246351,int_stack+1812592, 2.0, int_stack+1317868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+983350, 2.0, int_stack+634994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+267789,int_stack+267474, 2.0, int_stack+558525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+268209,int_stack+267789, 2.0, int_stack+559260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198, 2.0, int_stack+1320668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1243651,int_stack+268749,int_stack+268209, 2.0, int_stack+560220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1245271,int_stack+1243651,int_stack+1100143, 2.0, int_stack+1321613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1247791,int_stack+1245271,int_stack+1101403, 2.0, int_stack+1322873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+269424,int_stack+268749, 2.0, int_stack+561435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1250941,int_stack+1099198,int_stack+1243651, 2.0, int_stack+638144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+1250941,int_stack+1245271, 2.0, int_stack+4140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+558210,int_stack+853357,int_stack+1247791, 2.0, int_stack+1350454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1350454,int_stack+270249,int_stack+269424, 2.0, int_stack+562935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1243651,int_stack+1350454,int_stack+1099198, 2.0, int_stack+667744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+633644,int_stack+1243651,int_stack+1250941, 2.0, int_stack+1353604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1243651,int_stack+633644,int_stack+853357, 2.0, int_stack+1356844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+1243651,int_stack+558210, 2.0, int_stack+1361044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1243651,int_stack+982000,int_stack+1737331,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+273738,int_stack+272121, 2.0, int_stack+271680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+275838,int_stack+273738, 2.0, int_stack+273150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+558210,int_stack+1738654,int_stack+1737331, 2.0, int_stack+676354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+560856,int_stack+278484,int_stack+275838, 2.0, int_stack+275082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+853357,int_stack+560856,int_stack+1738654, 2.0, int_stack+677677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+558210, 2.0, int_stack+679441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+676354,int_stack+280584,int_stack+278484, 2.0, int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+633644,int_stack+676354,int_stack+560856, 2.0, int_stack+1385614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+558210,int_stack+633644,int_stack+853357, 2.0, int_stack+1387882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1350454,int_stack+558210,int_stack+1737331, 2.0, int_stack+1391410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+281739,int_stack+280584, 2.0, int_stack+279429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1385614,int_stack+1737331,int_stack+676354, 2.0, int_stack+723409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1357069,int_stack+1385614,int_stack+633644, 2.0, int_stack+1395820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1385614,int_stack+1357069,int_stack+558210, 2.0, int_stack+1400356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1385614,int_stack+1350454, 2.0, int_stack+1406236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1385614,int_stack+1808332,int_stack+982000,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+283335,int_stack+283125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577671,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+283615,int_stack+283335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577881,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778009,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+283975,int_stack+283615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578161,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778639,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+985810,int_stack+983470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749554,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+284425,int_stack+283975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578521,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+982000,int_stack+984730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750814,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+985810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751894,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+1812592,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726244,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+284975,int_stack+284425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578971,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1350454,int_stack+1808332,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+728344,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1353154,int_stack+1350454,int_stack+1810432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682087,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+1353154,int_stack+1812592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684247,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+983350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687047,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+285950,int_stack+285635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582691,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+286370,int_stack+285950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583006,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276594,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1350454,int_stack+286910,int_stack+286370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583426,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1352074,int_stack+1350454,int_stack+854302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690197,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1354594,int_stack+1352074,int_stack+855562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+691457,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+287585,int_stack+286910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583966,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1357744,int_stack+853357,int_stack+1350454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693347,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+1357744,int_stack+1352074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694967,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1360984,int_stack+1099198,int_stack+1354594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644174,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1350454,int_stack+288410,int_stack+287585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584641,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1352929,int_stack+1350454,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647324,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+982000,int_stack+1352929,int_stack+1357744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1432696,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1350454,int_stack+982000,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1435936,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+1350454,int_stack+1360984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1440136,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1350454,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+289841,int_stack+289400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347130,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+290429,int_stack+289841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348012,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1099198,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613313,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+853357,int_stack+291185,int_stack+290429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349188,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1808332,int_stack+853357,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669769,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1808332,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6660,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+292130,int_stack+291185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+350700,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1811860,int_stack+1099198,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1464706,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1405459,int_stack+1811860,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1466974,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+277539,int_stack+1405459,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1470502,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+293285,int_stack+292130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352590,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+558210,int_stack+1737331,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1474912,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+284154,int_stack+558210,int_stack+1811860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1477747,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+284154,int_stack+1405459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1482283,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+284154,int_stack+1808332,int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1488163,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1297891,int_stack+284154,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+294881,int_stack+294671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577671, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+295161,int_stack+294881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577881, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778009, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+295521,int_stack+295161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578161, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778639, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+277539,int_stack+985810,int_stack+983470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749554, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+295971,int_stack+295521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578521, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+279639,int_stack+982000,int_stack+984730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750814, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+281799,int_stack+279639,int_stack+985810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751894, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+281799,int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726244, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+277539,int_stack+296521,int_stack+295971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578971, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+284599,int_stack+277539,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+728344, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+287299,int_stack+284599,int_stack+279639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682087, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+287299,int_stack+281799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684247, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+983350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687047, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+297496,int_stack+297181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582691, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+297916,int_stack+297496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583006, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276594, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+982000,int_stack+298456,int_stack+297916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583426, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+983620,int_stack+982000,int_stack+1100143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690197, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+277539,int_stack+983620,int_stack+1101403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+691457, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+299131,int_stack+298456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583966, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+280689,int_stack+1099198,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693347, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+280689,int_stack+983620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694967, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+982000,int_stack+853357,int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644174, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+277539,int_stack+299956,int_stack+299131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584641, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+283929,int_stack+277539,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647324, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+287979,int_stack+283929,int_stack+280689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1432696, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+277539,int_stack+287979,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1435936, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+283839,int_stack+277539,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1440136, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1173658,int_stack+283839,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+301387,int_stack+300946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347130, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+301975,int_stack+301387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348012, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+982000,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613313, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984646,int_stack+302731,int_stack+301975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349188, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+277539,int_stack+984646,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669769, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+277539,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6660, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+303676,int_stack+302731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+350700, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+290454,int_stack+853357,int_stack+984646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1464706, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+982000,int_stack+290454,int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1466974, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+294990,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1470502, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+304831,int_stack+303676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352590, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+277539,int_stack+1737331,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1474912, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+277539,int_stack+290454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1477747, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1186888,int_stack+1808332,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1482283, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1186888,int_stack+294990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1488163, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1031200,int_stack+1808332,int_stack+283839, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+889747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1808332,int_stack+306427,int_stack+306217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577671, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1808962,int_stack+306707,int_stack+306427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577881, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1809802,int_stack+1808962,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778009, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1811062,int_stack+307067,int_stack+306707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578161, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1812142,int_stack+1811062,int_stack+1808962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778639, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1813822,int_stack+1812142,int_stack+1809802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749554, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1808332,int_stack+307517,int_stack+307067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578521, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1186888,int_stack+1808332,int_stack+1811062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750814, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1189048,int_stack+1186888,int_stack+1812142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751894, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1809682,int_stack+1189048,int_stack+1813822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726244, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1812832,int_stack+308067,int_stack+307517, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578971, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814482,int_stack+1812832,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+728344, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1191848,int_stack+1814482,int_stack+1186888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682087, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+1191848,int_stack+1189048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684247, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+1809682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687047, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+309042,int_stack+308727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582691, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+309462,int_stack+309042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583006, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276594, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1186888,int_stack+310002,int_stack+309462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583426, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1188508,int_stack+1186888,int_stack+854302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690197, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1191028,int_stack+1188508,int_stack+855562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+691457, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+310677,int_stack+310002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583966, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1194178,int_stack+853357,int_stack+1186888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693347, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+1194178,int_stack+1188508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694967, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+1099198,int_stack+1191028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644174, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1186888,int_stack+311502,int_stack+310677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584641, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1189363,int_stack+1186888,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647324, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+982000,int_stack+1189363,int_stack+1194178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1432696, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1186888,int_stack+982000,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1435936, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+1186888,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1440136, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1186888,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+977590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+312933,int_stack+312492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347130, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+313521,int_stack+312933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348012, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1808332,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613313, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1810978,int_stack+314277,int_stack+313521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349188, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1813246,int_stack+1810978,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669769, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1813246,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6660, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+315222,int_stack+314277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+350700, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+277539,int_stack+1099198,int_stack+1810978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1464706, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+282075,int_stack+277539,int_stack+1813246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1466974, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+282075,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1470502, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+316377,int_stack+315222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352590, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+287955,int_stack+1737331,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1474912, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+293625,int_stack+287955,int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1477747, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+301185,int_stack+293625,int_stack+282075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1482283, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+277539,int_stack+301185,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1488163, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+286800,int_stack+277539,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+317973,int_stack+317763, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+318253,int_stack+317973, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+318613,int_stack+318253, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+277539,int_stack+985810,int_stack+983470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+319063,int_stack+318613, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+279639,int_stack+982000,int_stack+984730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+281799,int_stack+279639,int_stack+985810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+281799,int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+277539,int_stack+319613,int_stack+319063, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+277539,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+728344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1811032,int_stack+1808332,int_stack+279639, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+1811032,int_stack+281799, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+983350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+320588,int_stack+320273, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+321008,int_stack+320588, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1808332,int_stack+321548,int_stack+321008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1809952,int_stack+1808332,int_stack+1100143, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812472,int_stack+1809952,int_stack+1101403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+691457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+322223,int_stack+321548, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+982000,int_stack+1099198,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+982000,int_stack+1809952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+277539,int_stack+853357,int_stack+1812472, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+323048,int_stack+322223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1810807,int_stack+1808332,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+306645,int_stack+1810807,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1432696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+982000,int_stack+306645,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1435936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+306645,int_stack+982000,int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1440136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1051045,int_stack+306645,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1103398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+324479,int_stack+324038, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+325067,int_stack+324479, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+277539,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+280185,int_stack+325823,int_stack+325067, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+282453,int_stack+280185,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+282453,int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+326768,int_stack+325823, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+350700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+313260,int_stack+982000,int_stack+280185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1464706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+317796,int_stack+313260,int_stack+282453, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1466974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+277539,int_stack+317796,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1470502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+327923,int_stack+326768, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+1737331,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1474912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1317736,int_stack+1808332,int_stack+313260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1477747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+1317736,int_stack+317796, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1482283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+313260,int_stack+1808332,int_stack+277539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1488163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+929437,int_stack+313260,int_stack+306645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1133968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306645,int_stack+329519,int_stack+329309, 0.0, zero_stack, 1.0, int_stack+577671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+307275,int_stack+329799,int_stack+329519, 0.0, zero_stack, 1.0, int_stack+577881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+308115,int_stack+307275,int_stack+306645, 0.0, zero_stack, 1.0, int_stack+778009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+309375,int_stack+330159,int_stack+329799, 0.0, zero_stack, 1.0, int_stack+578161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+310455,int_stack+309375,int_stack+307275, 0.0, zero_stack, 1.0, int_stack+778639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+312135,int_stack+310455,int_stack+308115, 0.0, zero_stack, 1.0, int_stack+749554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+306645,int_stack+330609,int_stack+330159, 0.0, zero_stack, 1.0, int_stack+578521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+314235,int_stack+306645,int_stack+309375, 0.0, zero_stack, 1.0, int_stack+750814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+316395,int_stack+314235,int_stack+310455, 0.0, zero_stack, 1.0, int_stack+751894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+307995,int_stack+316395,int_stack+312135, 0.0, zero_stack, 1.0, int_stack+726244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+311145,int_stack+331159,int_stack+330609, 0.0, zero_stack, 1.0, int_stack+578971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+319195,int_stack+311145,int_stack+306645, 0.0, zero_stack, 1.0, int_stack+728344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+321895,int_stack+319195,int_stack+314235, 0.0, zero_stack, 1.0, int_stack+682087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+321895,int_stack+316395, 0.0, zero_stack, 1.0, int_stack+684247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+307995, 0.0, zero_stack, 1.0, int_stack+687047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+332134,int_stack+331819, 0.0, zero_stack, 1.0, int_stack+582691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+332554,int_stack+332134, 0.0, zero_stack, 1.0, int_stack+583006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 0.0, zero_stack, 1.0, int_stack+276594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+306645,int_stack+333094,int_stack+332554, 0.0, zero_stack, 1.0, int_stack+583426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+308265,int_stack+306645,int_stack+854302, 0.0, zero_stack, 1.0, int_stack+690197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+310785,int_stack+308265,int_stack+855562, 0.0, zero_stack, 1.0, int_stack+691457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+333769,int_stack+333094, 0.0, zero_stack, 1.0, int_stack+583966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+313935,int_stack+853357,int_stack+306645, 0.0, zero_stack, 1.0, int_stack+693347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+313935,int_stack+308265, 0.0, zero_stack, 1.0, int_stack+694967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+317175,int_stack+1099198,int_stack+310785, 0.0, zero_stack, 1.0, int_stack+644174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+306645,int_stack+334594,int_stack+333769, 0.0, zero_stack, 1.0, int_stack+584641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+309120,int_stack+306645,int_stack+853357, 0.0, zero_stack, 1.0, int_stack+647324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+321900,int_stack+309120,int_stack+313935, 0.0, zero_stack, 1.0, int_stack+1432696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+306645,int_stack+321900,int_stack+1099198, 0.0, zero_stack, 1.0, int_stack+1435936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+306645,int_stack+317175, 0.0, zero_stack, 1.0, int_stack+1440136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+306645,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1226011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+336025,int_stack+335584, 0.0, zero_stack, 1.0, int_stack+347130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+336613,int_stack+336025, 0.0, zero_stack, 1.0, int_stack+348012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+319875,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+613313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+322521,int_stack+337369,int_stack+336613, 0.0, zero_stack, 1.0, int_stack+349188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+324789,int_stack+322521,int_stack+1738654, 0.0, zero_stack, 1.0, int_stack+669769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+324789,int_stack+319875, 0.0, zero_stack, 1.0, int_stack+6660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+328317,int_stack+338314,int_stack+337369, 0.0, zero_stack, 1.0, int_stack+350700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+331152,int_stack+328317,int_stack+322521, 0.0, zero_stack, 1.0, int_stack+1464706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+277539,int_stack+331152,int_stack+324789, 0.0, zero_stack, 1.0, int_stack+1466974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+319875,int_stack+277539,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1470502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+339469,int_stack+338314, 0.0, zero_stack, 1.0, int_stack+352590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+1737331,int_stack+328317, 0.0, zero_stack, 1.0, int_stack+1474912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1317736,int_stack+1808332,int_stack+331152, 0.0, zero_stack, 1.0, int_stack+1477747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+1317736,int_stack+277539, 0.0, zero_stack, 1.0, int_stack+1482283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+277539,int_stack+1808332,int_stack+319875, 0.0, zero_stack, 1.0, int_stack+1488163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+319875,int_stack+277539,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1258201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+341065,int_stack+340855, 1.0, int_stack+577671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+341345,int_stack+341065, 1.0, int_stack+577881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 1.0, int_stack+778009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+341705,int_stack+341345, 1.0, int_stack+578161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 1.0, int_stack+778639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+778009,int_stack+985810,int_stack+983470, 1.0, int_stack+749554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+780109,int_stack+342155,int_stack+341705, 1.0, int_stack+578521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+781459,int_stack+780109,int_stack+984730, 1.0, int_stack+750814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+783619,int_stack+781459,int_stack+985810, 1.0, int_stack+751894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+749554,int_stack+783619,int_stack+778009, 1.0, int_stack+726244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+778009,int_stack+342705,int_stack+342155, 1.0, int_stack+578971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+786419,int_stack+778009,int_stack+780109, 1.0, int_stack+728344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+789119,int_stack+786419,int_stack+781459, 1.0, int_stack+682087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+789119,int_stack+783619, 1.0, int_stack+684247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+749554, 1.0, int_stack+687047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+749554,int_stack+343680,int_stack+343365, 1.0, int_stack+582691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+750499,int_stack+344100,int_stack+343680, 1.0, int_stack+583006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1099198,int_stack+750499,int_stack+749554, 1.0, int_stack+276594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+751759,int_stack+344640,int_stack+344100, 1.0, int_stack+583426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+778009,int_stack+751759,int_stack+750499, 1.0, int_stack+690197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+780529,int_stack+778009,int_stack+1099198, 1.0, int_stack+691457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+345315,int_stack+344640, 1.0, int_stack+583966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+783679,int_stack+1099198,int_stack+751759, 1.0, int_stack+693347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+783679,int_stack+778009, 1.0, int_stack+694967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+786919,int_stack+853357,int_stack+780529, 1.0, int_stack+644174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+644174,int_stack+346140,int_stack+345315, 1.0, int_stack+584641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+778009,int_stack+644174,int_stack+1099198, 1.0, int_stack+647324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+644174,int_stack+778009,int_stack+783679, 1.0, int_stack+1432696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+778009,int_stack+644174,int_stack+853357, 1.0, int_stack+1435936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+778009,int_stack+786919, 1.0, int_stack+1440136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+778009,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1346044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+348600,int_stack+347571, 1.0, int_stack+347130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+349944,int_stack+348600, 1.0, int_stack+348012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+791239,int_stack+1738654,int_stack+1737331, 1.0, int_stack+613313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+613313,int_stack+351645,int_stack+349944, 1.0, int_stack+349188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+793885,int_stack+613313,int_stack+1738654, 1.0, int_stack+669769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+793885,int_stack+791239, 1.0, int_stack+6660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+797413,int_stack+353745,int_stack+351645, 1.0, int_stack+350700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+800248,int_stack+797413,int_stack+613313, 1.0, int_stack+1464706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+804784,int_stack+800248,int_stack+793885, 1.0, int_stack+1466974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+810664,int_stack+804784,int_stack+1737331, 1.0, int_stack+1470502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+354900,int_stack+353745, 1.0, int_stack+352590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1464706,int_stack+1737331,int_stack+797413, 1.0, int_stack+1474912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+791239,int_stack+1464706,int_stack+800248, 1.0, int_stack+1477747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1464706,int_stack+791239,int_stack+804784, 1.0, int_stack+1482283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1464706,int_stack+810664, 1.0, int_stack+1488163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1464706,int_stack+1808332,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1365769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+356496,int_stack+356286,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+356776,int_stack+356496,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+357136,int_stack+356776,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+985810,int_stack+983470,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+357586,int_stack+357136,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+982000,int_stack+984730,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+985810,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+1812592,int_stack+1808332,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+358136,int_stack+357586,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1484551,int_stack+1808332,int_stack+982000,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1487251,int_stack+1484551,int_stack+1810432,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+1487251,int_stack+1812592,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+983350,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+359111,int_stack+358796,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+359531,int_stack+359111,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1484551,int_stack+360071,int_stack+359531,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1486171,int_stack+1484551,int_stack+854302,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1488691,int_stack+1486171,int_stack+855562,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+360746,int_stack+360071,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+982000,int_stack+853357,int_stack+1484551,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+982000,int_stack+1486171,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+1099198,int_stack+1488691,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1484551,int_stack+361571,int_stack+360746,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1487026,int_stack+1484551,int_stack+853357,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+791239,int_stack+1487026,int_stack+982000,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+982000,int_stack+791239,int_stack+1099198,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+791239,int_stack+982000,int_stack+1808332,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+797854,int_stack+791239,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+639764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+363002,int_stack+362561,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+363590,int_stack+363002,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1808332,int_stack+1738654,int_stack+1737331,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1810978,int_stack+364346,int_stack+363590,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1813246,int_stack+1810978,int_stack+1738654,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1813246,int_stack+1808332,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+365291,int_stack+364346,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+811084,int_stack+982000,int_stack+1810978,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+815620,int_stack+811084,int_stack+1813246,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+815620,int_stack+1737331,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+366446,int_stack+365291,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+821500,int_stack+1737331,int_stack+982000,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1484551,int_stack+821500,int_stack+811084,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+821500,int_stack+1484551,int_stack+815620,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1484551,int_stack+821500,int_stack+1808332,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+811084,int_stack+1484551,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1444861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+791239,int_stack+368042,int_stack+367832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595492,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+791869,int_stack+368322,int_stack+368042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595702,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+792709,int_stack+791869,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1494778,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+793969,int_stack+368682,int_stack+368322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595982,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+795049,int_stack+793969,int_stack+791869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495408,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1484551,int_stack+795049,int_stack+792709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1496248,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+369132,int_stack+368682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596342,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1486651,int_stack+791239,int_stack+793969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497508,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1488811,int_stack+1486651,int_stack+795049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1498588,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+792589,int_stack+1488811,int_stack+1484551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1500268,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1484551,int_stack+369682,int_stack+369132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596792,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1491611,int_stack+1484551,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1502368,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+1491611,int_stack+1486651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1503718,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+1808332,int_stack+1488811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1505878,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+792589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1508678,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+370657,int_stack+370342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600512,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+371077,int_stack+370657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600827,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1532704,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1808332,int_stack+371617,int_stack+371077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601247,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1809952,int_stack+1808332,int_stack+1100143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1533649,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812472,int_stack+1809952,int_stack+1101403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1534909,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+372292,int_stack+371617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601787,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+791239,int_stack+1099198,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1541314,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+791239,int_stack+1809952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1542934,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1484551,int_stack+853357,int_stack+1812472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1545454,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+373117,int_stack+372292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602462,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1810807,int_stack+1808332,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548604,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1489276,int_stack+1810807,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550629,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+791239,int_stack+1489276,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1553869,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+791239,int_stack+1484551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1558069,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+644174,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+671944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+374548,int_stack+374107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431837,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+375136,int_stack+374548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432719,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1484551,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1562794,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1487197,int_stack+375892,int_stack+375136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433895,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1489465,int_stack+1487197,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1564117,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1489465,int_stack+1484551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1565881,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+376837,int_stack+375892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435407,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1808332,int_stack+791239,int_stack+1487197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1588939,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+657404,int_stack+1808332,int_stack+1489465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1591207,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1484551,int_stack+657404,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1594735,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+377992,int_stack+376837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+437297,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+663284,int_stack+1737331,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599145,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1432696,int_stack+663284,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1601980,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+1432696,int_stack+657404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1606516,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+657404,int_stack+1808332,int_stack+1484551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1612396,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+339720,int_stack+657404,int_stack+982000, 0.0, zero_stack, 1.0, int_stack+729709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+379588,int_stack+379378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595492, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+379868,int_stack+379588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595702, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1494778, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+380228,int_stack+379868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595982, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495408, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+657404,int_stack+985810,int_stack+983470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1496248, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+380678,int_stack+380228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596342, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+659504,int_stack+982000,int_stack+984730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497508, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+661664,int_stack+659504,int_stack+985810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1498588, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+661664,int_stack+657404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1500268, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+657404,int_stack+381228,int_stack+380678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596792, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+664464,int_stack+657404,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1502368, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+667164,int_stack+664464,int_stack+659504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1503718, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+667164,int_stack+661664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1505878, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+983350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1508678, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+382203,int_stack+381888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600512, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+382623,int_stack+382203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600827, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1532704, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+982000,int_stack+383163,int_stack+382623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601247, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+983620,int_stack+982000,int_stack+854302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1533649, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+657404,int_stack+983620,int_stack+855562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1534909, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+383838,int_stack+383163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601787, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+660554,int_stack+853357,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1541314, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+660554,int_stack+983620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1542934, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+982000,int_stack+1099198,int_stack+657404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1545454, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+657404,int_stack+384663,int_stack+383838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602462, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+663794,int_stack+657404,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548604, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1484551,int_stack+663794,int_stack+660554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550629, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+657404,int_stack+1484551,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1553869, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+791239,int_stack+657404,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1558069, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+657404,int_stack+791239,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+857557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+386094,int_stack+385653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431837, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+386682,int_stack+386094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432719, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+982000,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1562794, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984646,int_stack+387438,int_stack+386682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433895, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1099198,int_stack+984646,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1564117, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1565881, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1484551,int_stack+388383,int_stack+387438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435407, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1487386,int_stack+1484551,int_stack+984646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1588939, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+982000,int_stack+1487386,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1591207, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1594735, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+389538,int_stack+388383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+437297, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1432696,int_stack+1737331,int_stack+1484551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599145, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+359565,int_stack+1432696,int_stack+1487386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1601980, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1432696,int_stack+359565,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1606516, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+359565,int_stack+1432696,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1612396, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+368826,int_stack+359565,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+889747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+791239,int_stack+391134,int_stack+390924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595492, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+791869,int_stack+391414,int_stack+391134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595702, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+792709,int_stack+791869,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1494778, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+793969,int_stack+391774,int_stack+391414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595982, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+795049,int_stack+793969,int_stack+791869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495408, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+359565,int_stack+795049,int_stack+792709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1496248, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+392224,int_stack+391774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596342, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+361665,int_stack+791239,int_stack+793969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497508, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+363825,int_stack+361665,int_stack+795049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1498588, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+792589,int_stack+363825,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1500268, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+359565,int_stack+392774,int_stack+392224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596792, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+359565,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1502368, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1811032,int_stack+1808332,int_stack+361665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1503718, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+1811032,int_stack+363825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1505878, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+792589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1508678, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+393749,int_stack+393434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600512, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+394169,int_stack+393749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600827, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1532704, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1808332,int_stack+394709,int_stack+394169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601247, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1809952,int_stack+1808332,int_stack+1100143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1533649, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812472,int_stack+1809952,int_stack+1101403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1534909, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+395384,int_stack+394709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601787, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+791239,int_stack+1099198,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1541314, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+791239,int_stack+1809952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1542934, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+359565,int_stack+853357,int_stack+1812472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1545454, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+396209,int_stack+395384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602462, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1810807,int_stack+1808332,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548604, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1432696,int_stack+1810807,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550629, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+791239,int_stack+1432696,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1553869, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+791239,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1558069, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+676354,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+977590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+397640,int_stack+397199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431837, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+398228,int_stack+397640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432719, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+359565,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1562794, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+362211,int_stack+398984,int_stack+398228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433895, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+364479,int_stack+362211,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1564117, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+364479,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1565881, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+399929,int_stack+398984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435407, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1432696,int_stack+791239,int_stack+362211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1588939, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1437232,int_stack+1432696,int_stack+364479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1591207, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+359565,int_stack+1437232,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1594735, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+401084,int_stack+399929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+437297, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+1737331,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599145, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+388671,int_stack+1808332,int_stack+1432696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1601980, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+388671,int_stack+1437232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1606516, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+388671,int_stack+1808332,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1612396, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+184221,int_stack+388671,int_stack+982000, 0.0, zero_stack, 1.0, int_stack+1011355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+402680,int_stack+402470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+402960,int_stack+402680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1494778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+403320,int_stack+402960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+388671,int_stack+985810,int_stack+983470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1496248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+403770,int_stack+403320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+390771,int_stack+982000,int_stack+984730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+392931,int_stack+390771,int_stack+985810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1498588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+392931,int_stack+388671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1500268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+388671,int_stack+404320,int_stack+403770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+395731,int_stack+388671,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1502368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+398431,int_stack+395731,int_stack+390771, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1503718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+398431,int_stack+392931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1505878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+983350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1508678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+405295,int_stack+404980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+405715,int_stack+405295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1532704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+982000,int_stack+406255,int_stack+405715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+983620,int_stack+982000,int_stack+854302, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1533649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+388671,int_stack+983620,int_stack+855562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1534909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+406930,int_stack+406255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+391821,int_stack+853357,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1541314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+391821,int_stack+983620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1542934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+982000,int_stack+1099198,int_stack+388671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1545454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+388671,int_stack+407755,int_stack+406930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+395061,int_stack+388671,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+399111,int_stack+395061,int_stack+391821, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+388671,int_stack+399111,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1553869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+791239,int_stack+388671,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1558069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+388671,int_stack+791239,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1103398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+409186,int_stack+408745, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+409774,int_stack+409186, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432719, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+982000,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1562794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984646,int_stack+410530,int_stack+409774, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+401901,int_stack+984646,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1564117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+401901,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1565881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+405429,int_stack+411475,int_stack+410530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+359565,int_stack+405429,int_stack+984646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1588939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+982000,int_stack+359565,int_stack+401901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1591207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1594735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+412630,int_stack+411475, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+437297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+408264,int_stack+1737331,int_stack+405429, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1432696,int_stack+408264,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1601980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+359565,int_stack+1432696,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1606516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1432696,int_stack+359565,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1612396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+204066,int_stack+1432696,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+1133968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+791239,int_stack+414226,int_stack+414016, 0.0, zero_stack, 1.0, int_stack+595492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+791869,int_stack+414506,int_stack+414226, 0.0, zero_stack, 1.0, int_stack+595702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+792709,int_stack+791869,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+1494778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+793969,int_stack+414866,int_stack+414506, 0.0, zero_stack, 1.0, int_stack+595982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+795049,int_stack+793969,int_stack+791869, 0.0, zero_stack, 1.0, int_stack+1495408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1432696,int_stack+795049,int_stack+792709, 0.0, zero_stack, 1.0, int_stack+1496248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+415316,int_stack+414866, 0.0, zero_stack, 1.0, int_stack+596342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1434796,int_stack+791239,int_stack+793969, 0.0, zero_stack, 1.0, int_stack+1497508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1436956,int_stack+1434796,int_stack+795049, 0.0, zero_stack, 1.0, int_stack+1498588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+792589,int_stack+1436956,int_stack+1432696, 0.0, zero_stack, 1.0, int_stack+1500268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1432696,int_stack+415866,int_stack+415316, 0.0, zero_stack, 1.0, int_stack+596792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1439756,int_stack+1432696,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+1502368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+1439756,int_stack+1434796, 0.0, zero_stack, 1.0, int_stack+1503718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+1808332,int_stack+1436956, 0.0, zero_stack, 1.0, int_stack+1505878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+792589, 0.0, zero_stack, 1.0, int_stack+1508678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+416841,int_stack+416526, 0.0, zero_stack, 1.0, int_stack+600512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+417261,int_stack+416841, 0.0, zero_stack, 1.0, int_stack+600827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198, 0.0, zero_stack, 1.0, int_stack+1532704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1808332,int_stack+417801,int_stack+417261, 0.0, zero_stack, 1.0, int_stack+601247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1809952,int_stack+1808332,int_stack+1100143, 0.0, zero_stack, 1.0, int_stack+1533649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812472,int_stack+1809952,int_stack+1101403, 0.0, zero_stack, 1.0, int_stack+1534909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+418476,int_stack+417801, 0.0, zero_stack, 1.0, int_stack+601787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+791239,int_stack+1099198,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1541314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+791239,int_stack+1809952, 0.0, zero_stack, 1.0, int_stack+1542934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1432696,int_stack+853357,int_stack+1812472, 0.0, zero_stack, 1.0, int_stack+1545454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+419301,int_stack+418476, 0.0, zero_stack, 1.0, int_stack+602462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1810807,int_stack+1808332,int_stack+1099198, 0.0, zero_stack, 1.0, int_stack+1548604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1437421,int_stack+1810807,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+1550629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+791239,int_stack+1437421,int_stack+853357, 0.0, zero_stack, 1.0, int_stack+1553869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+791239,int_stack+1432696, 0.0, zero_stack, 1.0, int_stack+1558069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+401901,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1226011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+420732,int_stack+420291, 0.0, zero_stack, 1.0, int_stack+431837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+421320,int_stack+420732, 0.0, zero_stack, 1.0, int_stack+432719, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1432696,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1562794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1435342,int_stack+422076,int_stack+421320, 0.0, zero_stack, 1.0, int_stack+433895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1437610,int_stack+1435342,int_stack+1738654, 0.0, zero_stack, 1.0, int_stack+1564117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1437610,int_stack+1432696, 0.0, zero_stack, 1.0, int_stack+1565881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1441138,int_stack+423021,int_stack+422076, 0.0, zero_stack, 1.0, int_stack+435407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+791239,int_stack+1441138,int_stack+1435342, 0.0, zero_stack, 1.0, int_stack+1588939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+791239,int_stack+1437610, 0.0, zero_stack, 1.0, int_stack+1591207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1432696,int_stack+1808332,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1594735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+424176,int_stack+423021, 0.0, zero_stack, 1.0, int_stack+437297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+359565,int_stack+1737331,int_stack+1441138, 0.0, zero_stack, 1.0, int_stack+1599145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415131,int_stack+359565,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+1601980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+359565,int_stack+415131,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1606516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+359565,int_stack+1432696, 0.0, zero_stack, 1.0, int_stack+1612396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+223911,int_stack+1808332,int_stack+982000, 0.0, zero_stack, 1.0, int_stack+1258201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+425772,int_stack+425562, 1.0, int_stack+595492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+426052,int_stack+425772, 1.0, int_stack+595702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 1.0, int_stack+1494778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+426412,int_stack+426052, 1.0, int_stack+595982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 1.0, int_stack+1495408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+985810,int_stack+983470, 1.0, int_stack+1496248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+426862,int_stack+426412, 1.0, int_stack+596342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+982000,int_stack+984730, 1.0, int_stack+1497508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+985810, 1.0, int_stack+1498588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+1812592,int_stack+1808332, 1.0, int_stack+1500268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+427412,int_stack+426862, 1.0, int_stack+596792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1432696,int_stack+1808332,int_stack+982000, 1.0, int_stack+1502368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1435396,int_stack+1432696,int_stack+1810432, 1.0, int_stack+1503718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+1435396,int_stack+1812592, 1.0, int_stack+1505878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+983350, 1.0, int_stack+1508678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+428387,int_stack+428072, 1.0, int_stack+600512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+428807,int_stack+428387, 1.0, int_stack+600827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 1.0, int_stack+1532704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1432696,int_stack+429347,int_stack+428807, 1.0, int_stack+601247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1434316,int_stack+1432696,int_stack+854302, 1.0, int_stack+1533649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1436836,int_stack+1434316,int_stack+855562, 1.0, int_stack+1534909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1532704,int_stack+430022,int_stack+429347, 1.0, int_stack+601787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+853357,int_stack+1532704,int_stack+1432696, 1.0, int_stack+1541314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+853357,int_stack+1434316, 1.0, int_stack+1542934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1439986,int_stack+1099198,int_stack+1436836, 1.0, int_stack+1545454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1541314,int_stack+430847,int_stack+430022, 1.0, int_stack+602462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1543789,int_stack+1541314,int_stack+1532704, 1.0, int_stack+1548604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1432696,int_stack+1543789,int_stack+853357, 1.0, int_stack+1550629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1541314,int_stack+1432696,int_stack+1099198, 1.0, int_stack+1553869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+1541314,int_stack+1439986, 1.0, int_stack+1558069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1541314,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1346044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+433307,int_stack+432278, 1.0, int_stack+431837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+434651,int_stack+433307, 1.0, int_stack+432719, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1554544,int_stack+1738654,int_stack+1737331, 1.0, int_stack+1562794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1557190,int_stack+436352,int_stack+434651, 1.0, int_stack+433895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1559458,int_stack+1557190,int_stack+1738654, 1.0, int_stack+1564117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1559458,int_stack+1554544, 1.0, int_stack+1565881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1562986,int_stack+438452,int_stack+436352, 1.0, int_stack+435407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1432696,int_stack+1562986,int_stack+1557190, 1.0, int_stack+1588939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1437232,int_stack+1432696,int_stack+1559458, 1.0, int_stack+1591207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+791239,int_stack+1437232,int_stack+1737331, 1.0, int_stack+1594735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+439607,int_stack+438452, 1.0, int_stack+437297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1588939,int_stack+1737331,int_stack+1562986, 1.0, int_stack+1599145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1554544,int_stack+1588939,int_stack+1432696, 1.0, int_stack+1601980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1588939,int_stack+1554544,int_stack+1437232, 1.0, int_stack+1606516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1588939,int_stack+791239, 1.0, int_stack+1612396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1588939,int_stack+1808332,int_stack+982000, 0.0, zero_stack, 1.0, int_stack+1365769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+441203,int_stack+440993,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+441483,int_stack+441203,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+441843,int_stack+441483,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+985810,int_stack+983470,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+442293,int_stack+441843,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+982000,int_stack+984730,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+985810,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+1812592,int_stack+1808332,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+442843,int_stack+442293,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+791239,int_stack+1808332,int_stack+982000,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+793939,int_stack+791239,int_stack+1810432,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+793939,int_stack+1812592,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+983350,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+443818,int_stack+443503,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+444238,int_stack+443818,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+791239,int_stack+444778,int_stack+444238,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+792859,int_stack+791239,int_stack+1100143,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+982000,int_stack+792859,int_stack+1101403,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+445453,int_stack+444778,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+985150,int_stack+1099198,int_stack+791239,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+985150,int_stack+792859,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+791239,int_stack+853357,int_stack+982000,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+982000,int_stack+446278,int_stack+445453,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+982000,int_stack+1099198,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1608784,int_stack+1808332,int_stack+985150,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+1608784,int_stack+853357,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+1808332,int_stack+791239,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1554544,int_stack+982000,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+639764, 1.0, int_stack+1536904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+447709,int_stack+447268,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+448297,int_stack+447709,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+791239,int_stack+1738654,int_stack+1737331,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+793885,int_stack+449053,int_stack+448297,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1808332,int_stack+793885,int_stack+1738654,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1808332,int_stack+791239,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1811860,int_stack+449998,int_stack+449053,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1608784,int_stack+1811860,int_stack+793885,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+791239,int_stack+1608784,int_stack+1808332,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1432696,int_stack+791239,int_stack+1737331,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+451153,int_stack+449998,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1613320,int_stack+1737331,int_stack+1811860,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+1613320,int_stack+1608784,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1608784,int_stack+1808332,int_stack+791239,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1608784,int_stack+1432696,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+415131,int_stack+1808332,int_stack+982000, 0.0, zero_stack, 1.0, int_stack+1444861, 1.0, int_stack+1569094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+452749,int_stack+452539,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+453029,int_stack+452749,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+453389,int_stack+453029,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+985810,int_stack+983470,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+453839,int_stack+453389,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+982000,int_stack+984730,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+985810,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+1812592,int_stack+1808332,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+454389,int_stack+453839,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1432696,int_stack+1808332,int_stack+982000,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1435396,int_stack+1432696,int_stack+1810432,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+1435396,int_stack+1812592,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+983350,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+455364,int_stack+455049,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+455784,int_stack+455364,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1432696,int_stack+456324,int_stack+455784,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1434316,int_stack+1432696,int_stack+854302,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1436836,int_stack+1434316,int_stack+855562,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+456999,int_stack+456324,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1439986,int_stack+853357,int_stack+1432696,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+1439986,int_stack+1434316,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+982000,int_stack+1099198,int_stack+1436836,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1432696,int_stack+457824,int_stack+456999,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1435171,int_stack+1432696,int_stack+853357,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+1435171,int_stack+1439986,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1432696,int_stack+1808332,int_stack+1099198,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+791239,int_stack+1432696,int_stack+982000,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+434976,int_stack+791239,int_stack+1737331, 0.0, zero_stack, 2.0, int_stack+1536904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+459255,int_stack+458814,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+459843,int_stack+459255,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+982000,int_stack+1738654,int_stack+1737331,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+984646,int_stack+460599,int_stack+459843,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1432696,int_stack+984646,int_stack+1738654,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1432696,int_stack+982000,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1436224,int_stack+461544,int_stack+460599,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1439059,int_stack+1436224,int_stack+984646,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+982000,int_stack+1439059,int_stack+1432696,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+982000,int_stack+1737331,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+462699,int_stack+461544,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1608784,int_stack+1737331,int_stack+1436224,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+359565,int_stack+1608784,int_stack+1439059,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1608784,int_stack+359565,int_stack+982000,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+359565,int_stack+1608784,int_stack+1808332,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1484551,int_stack+359565,int_stack+791239, 0.0, zero_stack, 2.0, int_stack+1569094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+791239,int_stack+466805,int_stack+466595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+615823,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+791869,int_stack+467085,int_stack+466805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616033,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+792709,int_stack+791869,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619011,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+793969,int_stack+467445,int_stack+467085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616313,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+795049,int_stack+793969,int_stack+791869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619641,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+359565,int_stack+795049,int_stack+792709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620481,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+467895,int_stack+467445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616673,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+361665,int_stack+791239,int_stack+793969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1621741,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+363825,int_stack+361665,int_stack+795049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1622821,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+792589,int_stack+363825,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1624501,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+359565,int_stack+468445,int_stack+467895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+617123,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+359565,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1626601,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1811032,int_stack+1808332,int_stack+361665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1627951,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+1811032,int_stack+363825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1630111,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+792589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1632911,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+473185,int_stack+472870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620843,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+473605,int_stack+473185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621158,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1656937,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1808332,int_stack+474145,int_stack+473605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621578,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1809952,int_stack+1808332,int_stack+1100143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1657882,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812472,int_stack+1809952,int_stack+1101403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1659142,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+474820,int_stack+474145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622118,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+791239,int_stack+1099198,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9306,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+791239,int_stack+1809952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1665547,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+359565,int_stack+853357,int_stack+1812472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1668067,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+475645,int_stack+474820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622793,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1810807,int_stack+1808332,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10926,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1608784,int_stack+1810807,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671217,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+791239,int_stack+1608784,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1674457,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+791239,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1678657,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+448206,int_stack+982000,int_stack+1737331, 1.0, int_stack+671944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+477076,int_stack+476635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568515,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+477664,int_stack+477076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569397,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+359565,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1683382,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+362211,int_stack+478420,int_stack+477664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570573,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+364479,int_stack+362211,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1684705,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+364479,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1686469,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+479365,int_stack+478420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572085,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1608784,int_stack+791239,int_stack+362211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753574,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+1608784,int_stack+364479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1709527,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+359565,int_stack+1808332,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1713055,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+480520,int_stack+479365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+573975,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1613320,int_stack+1737331,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1717465,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1432696,int_stack+1613320,int_stack+1608784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1720300,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1608784,int_stack+1432696,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1724836,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1608784,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730716,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+461436,int_stack+1808332,int_stack+982000, 1.0, int_stack+729709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+982000,int_stack+484626,int_stack+484416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+615823, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982630,int_stack+484906,int_stack+484626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616033, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+983470,int_stack+982630,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619011, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+984730,int_stack+485266,int_stack+484906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616313, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+985810,int_stack+984730,int_stack+982630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619641, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+985810,int_stack+983470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620481, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+485716,int_stack+485266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616673, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+982000,int_stack+984730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1621741, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+985810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1622821, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+983350,int_stack+1812592,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1624501, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+486266,int_stack+485716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+617123, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+359565,int_stack+1808332,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1626601, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+362265,int_stack+359565,int_stack+1810432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1627951, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+853357,int_stack+362265,int_stack+1812592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1630111, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+853357,int_stack+983350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1632911, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853357,int_stack+491006,int_stack+490691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620843, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+854302,int_stack+491426,int_stack+491006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621158, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855562,int_stack+854302,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1656937, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+359565,int_stack+491966,int_stack+491426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621578, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+361185,int_stack+359565,int_stack+854302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1657882, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+363705,int_stack+361185,int_stack+855562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1659142, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+853357,int_stack+492641,int_stack+491966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622118, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+982000,int_stack+853357,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9306, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+982000,int_stack+361185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1665547, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+1099198,int_stack+363705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1668067, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+359565,int_stack+493466,int_stack+492641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622793, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+362040,int_stack+359565,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10926, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1608784,int_stack+362040,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671217, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+982000,int_stack+1608784,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1674457, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+791239,int_stack+982000,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1678657, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1064275,int_stack+791239,int_stack+1737331, 1.0, int_stack+857557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+494897,int_stack+494456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568515, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+495485,int_stack+494897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569397, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1808332,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1683382, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1810978,int_stack+496241,int_stack+495485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570573, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1813246,int_stack+1810978,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1684705, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1813246,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1686469, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+982000,int_stack+497186,int_stack+496241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572085, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1608784,int_stack+982000,int_stack+1810978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753574, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+853357,int_stack+1608784,int_stack+1813246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1709527, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+853357,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1713055, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+498341,int_stack+497186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+573975, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1613320,int_stack+1737331,int_stack+982000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1717465, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+359565,int_stack+1613320,int_stack+1608784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1720300, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1608784,int_stack+359565,int_stack+853357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1724836, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+359565,int_stack+1608784,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730716, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+481281,int_stack+359565,int_stack+791239, 1.0, int_stack+889747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+791239,int_stack+502447,int_stack+502237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+615823, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+791869,int_stack+502727,int_stack+502447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616033, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+792709,int_stack+791869,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619011, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+793969,int_stack+503087,int_stack+502727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616313, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+795049,int_stack+793969,int_stack+791869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619641, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+359565,int_stack+795049,int_stack+792709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620481, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+503537,int_stack+503087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616673, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+361665,int_stack+791239,int_stack+793969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1621741, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+363825,int_stack+361665,int_stack+795049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1622821, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+792589,int_stack+363825,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1624501, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+359565,int_stack+504087,int_stack+503537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+617123, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+359565,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1626601, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1811032,int_stack+1808332,int_stack+361665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1627951, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1099198,int_stack+1811032,int_stack+363825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1630111, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1099198,int_stack+792589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1632911, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1099198,int_stack+508827,int_stack+508512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620843, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1100143,int_stack+509247,int_stack+508827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621158, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1101403,int_stack+1100143,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1656937, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1808332,int_stack+509787,int_stack+509247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621578, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1809952,int_stack+1808332,int_stack+1100143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1657882, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812472,int_stack+1809952,int_stack+1101403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1659142, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+510462,int_stack+509787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622118, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+791239,int_stack+1099198,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9306, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1532704,int_stack+791239,int_stack+1809952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1665547, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+359565,int_stack+1532704,int_stack+1812472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1668067, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+511287,int_stack+510462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622793, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1810807,int_stack+1808332,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10926, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1608784,int_stack+1810807,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671217, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+791239,int_stack+1608784,int_stack+1532704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1674457, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982000,int_stack+791239,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1678657, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+151326,int_stack+982000,int_stack+1737331, 1.0, int_stack+977590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+977590,int_stack+512718,int_stack+512277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568515, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+978913,int_stack+513306,int_stack+512718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569397, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1737331,int_stack+978913,int_stack+977590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1683382, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+359565,int_stack+514062,int_stack+513306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570573, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+361833,int_stack+359565,int_stack+978913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1684705, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+977590,int_stack+361833,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1686469, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1737331,int_stack+515007,int_stack+514062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572085, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+791239,int_stack+1737331,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753574, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1608784,int_stack+791239,int_stack+361833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1709527, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+359565,int_stack+1608784,int_stack+977590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1713055, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+977590,int_stack+516162,int_stack+515007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+573975, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+977590,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1717465, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+853357,int_stack+1808332,int_stack+791239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1720300, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+853357,int_stack+1608784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1724836, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1608784,int_stack+1808332,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730716, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+243756,int_stack+1608784,int_stack+982000, 1.0, int_stack+1011355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1608784,int_stack+520268,int_stack+520058, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+615823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1609414,int_stack+520548,int_stack+520268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1610254,int_stack+1609414,int_stack+1608784, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1611514,int_stack+520908,int_stack+520548, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1612594,int_stack+1611514,int_stack+1609414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1614274,int_stack+1612594,int_stack+1610254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1608784,int_stack+521358,int_stack+520908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1616374,int_stack+1608784,int_stack+1611514, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1621741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+359565,int_stack+1616374,int_stack+1612594, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1622821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1610134,int_stack+359565,int_stack+1614274, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1624501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1613284,int_stack+521908,int_stack+521358, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+617123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+362365,int_stack+1613284,int_stack+1608784, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1626601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+365065,int_stack+362365,int_stack+1616374, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1627951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1532704,int_stack+365065,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1630111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1532704,int_stack+1610134, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1632911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1532704,int_stack+526648,int_stack+526333, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1533649,int_stack+527068,int_stack+526648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1534909,int_stack+1533649,int_stack+1532704, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1656937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+359565,int_stack+527608,int_stack+527068, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+361185,int_stack+359565,int_stack+1533649, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1657882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+363705,int_stack+361185,int_stack+1534909, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1659142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1532704,int_stack+528283,int_stack+527608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1608784,int_stack+1532704,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1099198,int_stack+1608784,int_stack+361185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1665547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1612024,int_stack+1099198,int_stack+363705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1668067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+359565,int_stack+529108,int_stack+528283, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+362040,int_stack+359565,int_stack+1532704, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1808332,int_stack+362040,int_stack+1608784, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+359565,int_stack+1808332,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1674457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+791239,int_stack+359565,int_stack+1612024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1678657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+501126,int_stack+791239,int_stack+1737331, 1.0, int_stack+1103398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+530539,int_stack+530098, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+531127,int_stack+530539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+359565,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1683382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+362211,int_stack+531883,int_stack+531127, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+364479,int_stack+362211,int_stack+1738654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1684705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+364479,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1686469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1099198,int_stack+532828,int_stack+531883, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1102033,int_stack+1099198,int_stack+362211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1808332,int_stack+1102033,int_stack+364479, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1709527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+359565,int_stack+1808332,int_stack+1737331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1713055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+533983,int_stack+532828, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+573975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1608784,int_stack+1737331,int_stack+1099198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1717465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+853357,int_stack+1608784,int_stack+1102033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1720300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1608784,int_stack+853357,int_stack+1808332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1724836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1608784,int_stack+359565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+514356,int_stack+1808332,int_stack+791239, 1.0, int_stack+1133968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+791239,int_stack+538089,int_stack+537879, 0.0, zero_stack, 1.0, int_stack+615823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+791869,int_stack+538369,int_stack+538089, 0.0, zero_stack, 1.0, int_stack+616033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+792709,int_stack+791869,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+1619011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+793969,int_stack+538729,int_stack+538369, 0.0, zero_stack, 1.0, int_stack+616313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+795049,int_stack+793969,int_stack+791869, 0.0, zero_stack, 1.0, int_stack+1619641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1808332,int_stack+795049,int_stack+792709, 0.0, zero_stack, 1.0, int_stack+1620481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+539179,int_stack+538729, 0.0, zero_stack, 1.0, int_stack+616673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1810432,int_stack+791239,int_stack+793969, 0.0, zero_stack, 1.0, int_stack+1621741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1812592,int_stack+1810432,int_stack+795049, 0.0, zero_stack, 1.0, int_stack+1622821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+792589,int_stack+1812592,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1624501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+539729,int_stack+539179, 0.0, zero_stack, 1.0, int_stack+617123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+359565,int_stack+1808332,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+1626601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+362265,int_stack+359565,int_stack+1810432, 0.0, zero_stack, 1.0, int_stack+1627951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1532704,int_stack+362265,int_stack+1812592, 0.0, zero_stack, 1.0, int_stack+1630111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1532704,int_stack+792589, 0.0, zero_stack, 1.0, int_stack+1632911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1532704,int_stack+544469,int_stack+544154, 0.0, zero_stack, 1.0, int_stack+620843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1533649,int_stack+544889,int_stack+544469, 0.0, zero_stack, 1.0, int_stack+621158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1534909,int_stack+1533649,int_stack+1532704, 0.0, zero_stack, 1.0, int_stack+1656937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+359565,int_stack+545429,int_stack+544889, 0.0, zero_stack, 1.0, int_stack+621578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+361185,int_stack+359565,int_stack+1533649, 0.0, zero_stack, 1.0, int_stack+1657882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+363705,int_stack+361185,int_stack+1534909, 0.0, zero_stack, 1.0, int_stack+1659142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1532704,int_stack+546104,int_stack+545429, 0.0, zero_stack, 1.0, int_stack+622118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+791239,int_stack+1532704,int_stack+359565, 0.0, zero_stack, 1.0, int_stack+9306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1221811,int_stack+791239,int_stack+361185, 0.0, zero_stack, 1.0, int_stack+1665547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+1221811,int_stack+363705, 0.0, zero_stack, 1.0, int_stack+1668067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+359565,int_stack+546929,int_stack+546104, 0.0, zero_stack, 1.0, int_stack+622793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+362040,int_stack+359565,int_stack+1532704, 0.0, zero_stack, 1.0, int_stack+10926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1608784,int_stack+362040,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+1671217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+791239,int_stack+1608784,int_stack+1221811, 0.0, zero_stack, 1.0, int_stack+1674457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1608784,int_stack+791239,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1678657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+534201,int_stack+1608784,int_stack+1737331, 1.0, int_stack+1226011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1737331,int_stack+548360,int_stack+547919, 0.0, zero_stack, 1.0, int_stack+568515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1738654,int_stack+548948,int_stack+548360, 0.0, zero_stack, 1.0, int_stack+569397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1808332,int_stack+1738654,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1683382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1810978,int_stack+549704,int_stack+548948, 0.0, zero_stack, 1.0, int_stack+570573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1813246,int_stack+1810978,int_stack+1738654, 0.0, zero_stack, 1.0, int_stack+1684705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1737331,int_stack+1813246,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1686469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+550649,int_stack+549704, 0.0, zero_stack, 1.0, int_stack+572085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1221811,int_stack+791239,int_stack+1810978, 0.0, zero_stack, 1.0, int_stack+753574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+359565,int_stack+1221811,int_stack+1813246, 0.0, zero_stack, 1.0, int_stack+1709527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+359565,int_stack+1737331, 0.0, zero_stack, 1.0, int_stack+1713055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1737331,int_stack+551804,int_stack+550649, 0.0, zero_stack, 1.0, int_stack+573975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+853357,int_stack+1737331,int_stack+791239, 0.0, zero_stack, 1.0, int_stack+1717465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1099198,int_stack+853357,int_stack+1221811, 0.0, zero_stack, 1.0, int_stack+1720300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+977590,int_stack+1099198,int_stack+359565, 0.0, zero_stack, 1.0, int_stack+1724836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+359565,int_stack+977590,int_stack+1808332, 0.0, zero_stack, 1.0, int_stack+1730716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+263601,int_stack+359565,int_stack+1608784, 1.0, int_stack+1258201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1608784,int_stack+555910,int_stack+555700, 1.0, int_stack+615823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1609414,int_stack+556190,int_stack+555910, 1.0, int_stack+616033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1610254,int_stack+1609414,int_stack+1608784, 1.0, int_stack+1619011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1611514,int_stack+556550,int_stack+556190, 1.0, int_stack+616313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1612594,int_stack+1611514,int_stack+1609414, 1.0, int_stack+1619641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1614274,int_stack+1612594,int_stack+1610254, 1.0, int_stack+1620481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1608784,int_stack+557000,int_stack+556550, 1.0, int_stack+616673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1616374,int_stack+1608784,int_stack+1611514, 1.0, int_stack+1621741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1618534,int_stack+1616374,int_stack+1612594, 1.0, int_stack+1622821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1610134,int_stack+1618534,int_stack+1614274, 1.0, int_stack+1624501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1613284,int_stack+557550,int_stack+557000, 1.0, int_stack+617123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1621334,int_stack+1613284,int_stack+1608784, 1.0, int_stack+1626601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1624034,int_stack+1621334,int_stack+1616374, 1.0, int_stack+1627951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1532704,int_stack+1624034,int_stack+1618534, 1.0, int_stack+1630111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1737331,int_stack+1532704,int_stack+1610134, 1.0, int_stack+1632911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1532704,int_stack+565065,int_stack+564750, 1.0, int_stack+620843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1533649,int_stack+565485,int_stack+565065, 1.0, int_stack+621158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1534909,int_stack+1533649,int_stack+1532704, 1.0, int_stack+1656937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1608784,int_stack+566025,int_stack+565485, 1.0, int_stack+621578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1610404,int_stack+1608784,int_stack+1533649, 1.0, int_stack+1657882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1612924,int_stack+1610404,int_stack+1534909, 1.0, int_stack+1659142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1656937,int_stack+566700,int_stack+566025, 1.0, int_stack+622118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1532704,int_stack+1656937,int_stack+1608784, 1.0, int_stack+9306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1616074,int_stack+1532704,int_stack+1610404, 1.0, int_stack+1665547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1620274,int_stack+1616074,int_stack+1612924, 1.0, int_stack+1668067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1665547,int_stack+567525,int_stack+566700, 1.0, int_stack+622793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1608784,int_stack+1665547,int_stack+1656937, 1.0, int_stack+10926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1665547,int_stack+1608784,int_stack+1532704, 1.0, int_stack+1671217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1608784,int_stack+1665547,int_stack+1616074, 1.0, int_stack+1674457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+791239,int_stack+1608784,int_stack+1620274, 1.0, int_stack+1678657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1608784,int_stack+791239,int_stack+1737331, 1.0, int_stack+1346044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1346044,int_stack+569985,int_stack+568956, 1.0, int_stack+568515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1347367,int_stack+571329,int_stack+569985, 1.0, int_stack+569397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1737331,int_stack+1347367,int_stack+1346044, 1.0, int_stack+1683382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1622014,int_stack+573030,int_stack+571329, 1.0, int_stack+570573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1624282,int_stack+1622014,int_stack+1347367, 1.0, int_stack+1684705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1346044,int_stack+1624282,int_stack+1737331, 1.0, int_stack+1686469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1737331,int_stack+575130,int_stack+573030, 1.0, int_stack+572085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1627810,int_stack+1737331,int_stack+1622014, 1.0, int_stack+753574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1665547,int_stack+1627810,int_stack+1624282, 1.0, int_stack+1709527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1671427,int_stack+1665547,int_stack+1346044, 1.0, int_stack+1713055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1346044,int_stack+576285,int_stack+575130, 1.0, int_stack+573975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1709527,int_stack+1346044,int_stack+1737331, 1.0, int_stack+1717465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1678042,int_stack+1709527,int_stack+1627810, 1.0, int_stack+1720300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1709527,int_stack+1678042,int_stack+1665547, 1.0, int_stack+1724836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+359565,int_stack+1709527,int_stack+1671427, 1.0, int_stack+1730716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1709527,int_stack+359565,int_stack+791239, 1.0, int_stack+1365769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+791239,int_stack+580391,int_stack+580181,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+791869,int_stack+580671,int_stack+580391,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+792709,int_stack+791869,int_stack+791239,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+793969,int_stack+581031,int_stack+580671,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+795049,int_stack+793969,int_stack+791869,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+359565,int_stack+795049,int_stack+792709,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+581481,int_stack+581031,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+361665,int_stack+791239,int_stack+793969,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+363825,int_stack+361665,int_stack+795049,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+792589,int_stack+363825,int_stack+359565,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+359565,int_stack+582031,int_stack+581481,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1729372,int_stack+359565,int_stack+791239,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1732072,int_stack+1729372,int_stack+361665,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1532704,int_stack+1732072,int_stack+363825,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1346044,int_stack+1532704,int_stack+792589,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1532704,int_stack+586771,int_stack+586456,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1533649,int_stack+587191,int_stack+586771,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1534909,int_stack+1533649,int_stack+1532704,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1729372,int_stack+587731,int_stack+587191,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1730992,int_stack+1729372,int_stack+1533649,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1733512,int_stack+1730992,int_stack+1534909,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1532704,int_stack+588406,int_stack+587731,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1736662,int_stack+1532704,int_stack+1729372,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1656937,int_stack+1736662,int_stack+1730992,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+791239,int_stack+1656937,int_stack+1733512,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1729372,int_stack+589231,int_stack+588406,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1731847,int_stack+1729372,int_stack+1532704,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+359565,int_stack+1731847,int_stack+1736662,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1729372,int_stack+359565,int_stack+1656937,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+359565,int_stack+1729372,int_stack+791239,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1665547,int_stack+359565,int_stack+1346044, 1.0, int_stack+639764, 0.0, zero_stack, 1.0, int_stack+1661137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1346044,int_stack+590662,int_stack+590221,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1347367,int_stack+591250,int_stack+590662,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+366180,int_stack+1347367,int_stack+1346044,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+791239,int_stack+592006,int_stack+591250,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+793507,int_stack+791239,int_stack+1347367,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1346044,int_stack+793507,int_stack+366180,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1729372,int_stack+592951,int_stack+592006,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1732207,int_stack+1729372,int_stack+791239,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1678777,int_stack+1732207,int_stack+793507,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+791239,int_stack+1678777,int_stack+1346044,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1346044,int_stack+594106,int_stack+592951,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1622014,int_stack+1346044,int_stack+1729372,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1627684,int_stack+1622014,int_stack+1732207,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1729372,int_stack+1627684,int_stack+1678777,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1808332,int_stack+1729372,int_stack+791239,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+547431,int_stack+1808332,int_stack+359565, 1.0, int_stack+1444861, 0.0, zero_stack, 1.0, int_stack+1689682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+359565,int_stack+598212,int_stack+598002,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+360195,int_stack+598492,int_stack+598212,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+361035,int_stack+360195,int_stack+359565,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+362295,int_stack+598852,int_stack+598492,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+363375,int_stack+362295,int_stack+360195,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+365055,int_stack+363375,int_stack+361035,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+359565,int_stack+599302,int_stack+598852,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1808332,int_stack+359565,int_stack+362295,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1810492,int_stack+1808332,int_stack+363375,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+360915,int_stack+1810492,int_stack+365055,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+364065,int_stack+599852,int_stack+599302,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+365715,int_stack+364065,int_stack+359565,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1813292,int_stack+365715,int_stack+1808332,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1656937,int_stack+1813292,int_stack+1810492,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1346044,int_stack+1656937,int_stack+360915,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1656937,int_stack+604592,int_stack+604277,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1657882,int_stack+605012,int_stack+604592,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1659142,int_stack+1657882,int_stack+1656937,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1808332,int_stack+605552,int_stack+605012,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1809952,int_stack+1808332,int_stack+1657882,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1812472,int_stack+1809952,int_stack+1659142,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1656937,int_stack+606227,int_stack+605552,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+359565,int_stack+1656937,int_stack+1808332,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1532704,int_stack+359565,int_stack+1809952,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+362805,int_stack+1532704,int_stack+1812472,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+607052,int_stack+606227,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1810807,int_stack+1808332,int_stack+1656937,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+791239,int_stack+1810807,int_stack+359565,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+791239,int_stack+1532704,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+791239,int_stack+1808332,int_stack+362805,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1622014,int_stack+791239,int_stack+1346044, 1.0, int_stack+1536904, 1.0, int_stack+1661137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1346044,int_stack+608483,int_stack+608042,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1347367,int_stack+609071,int_stack+608483,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1808332,int_stack+1347367,int_stack+1346044,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1810978,int_stack+609827,int_stack+609071,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1813246,int_stack+1810978,int_stack+1347367,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1346044,int_stack+1813246,int_stack+1808332,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1532704,int_stack+610772,int_stack+609827,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1535539,int_stack+1532704,int_stack+1810978,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+359565,int_stack+1535539,int_stack+1813246,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1808332,int_stack+359565,int_stack+1346044,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1346044,int_stack+611927,int_stack+610772,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1729372,int_stack+1346044,int_stack+1532704,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1678777,int_stack+1729372,int_stack+1535539,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1729372,int_stack+1678777,int_stack+359565,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+359565,int_stack+1729372,int_stack+1808332,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+567276,int_stack+359565,int_stack+791239, 1.0, int_stack+1569094, 1.0, int_stack+1689682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+791239,int_stack+618543,int_stack+618333,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+791869,int_stack+618823,int_stack+618543,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+792709,int_stack+791869,int_stack+791239,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+793969,int_stack+619183,int_stack+618823,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+795049,int_stack+793969,int_stack+791869,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+359565,int_stack+795049,int_stack+792709,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+791239,int_stack+619633,int_stack+619183,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+361665,int_stack+791239,int_stack+793969,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+363825,int_stack+361665,int_stack+795049,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+792589,int_stack+363825,int_stack+359565,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+359565,int_stack+620183,int_stack+619633,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+359565,int_stack+791239,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1811032,int_stack+1808332,int_stack+361665,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1656937,int_stack+1811032,int_stack+363825,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1346044,int_stack+1656937,int_stack+792589,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1656937,int_stack+624923,int_stack+624608,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1657882,int_stack+625343,int_stack+624923,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1659142,int_stack+1657882,int_stack+1656937,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1808332,int_stack+625883,int_stack+625343,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1809952,int_stack+1808332,int_stack+1657882,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1812472,int_stack+1809952,int_stack+1659142,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1656937,int_stack+626558,int_stack+625883,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+791239,int_stack+1656937,int_stack+1808332,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+359565,int_stack+791239,int_stack+1809952,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+363765,int_stack+359565,int_stack+1812472,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1808332,int_stack+627383,int_stack+626558,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1810807,int_stack+1808332,int_stack+1656937,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1729372,int_stack+1810807,int_stack+791239,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+791239,int_stack+1729372,int_stack+359565,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1729372,int_stack+791239,int_stack+363765,15);
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1432696,int_stack+1729372,int_stack+1346044, 2.0, int_stack+1661137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1346044,int_stack+628814,int_stack+628373,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1347367,int_stack+629402,int_stack+628814,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+791239,int_stack+1347367,int_stack+1346044,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+793885,int_stack+630158,int_stack+629402,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+359565,int_stack+793885,int_stack+1347367,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1346044,int_stack+359565,int_stack+791239,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+363093,int_stack+631103,int_stack+630158,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1735987,int_stack+363093,int_stack+793885,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+791239,int_stack+1735987,int_stack+359565,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1656937,int_stack+791239,int_stack+1346044,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1346044,int_stack+632258,int_stack+631103,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1808332,int_stack+1346044,int_stack+363093,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+359565,int_stack+1808332,int_stack+1735987,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1808332,int_stack+359565,int_stack+791239,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+359565,int_stack+1808332,int_stack+1656937,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+587121,int_stack+359565,int_stack+1729372, 2.0, int_stack+1689682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+606966,int_stack+833512,int_stack+736324,441);
     Libderiv->ABCD[11] = int_stack + 606966;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+830929,int_stack+957745,int_stack+896362,441);
     Libderiv->ABCD[10] = int_stack + 830929;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+949282,int_stack+1079353,int_stack+1017970,441);
     Libderiv->ABCD[9] = int_stack + 949282;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1077505,int_stack+1201966,int_stack+1140583,441);
     Libderiv->ABCD[8] = int_stack + 1077505;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1200118,int_stack+1326199,int_stack+1264816,441);
     Libderiv->ABCD[7] = int_stack + 1200118;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1317736,int_stack+1412851,int_stack+1372384,441);
     Libderiv->ABCD[6] = int_stack + 1317736;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1405459,int_stack+1512859,int_stack+1451476, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 1405459;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1504396,int_stack+1637092,int_stack+1575709, 0.0, zero_stack, 1.0, int_stack+764779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 1504396;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1635244,int_stack+1755412,int_stack+1696297, 1.0, int_stack+764779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 1635244;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+749554,int_stack+1788487,int_stack+1775257,441);
     Libderiv->ABCD[155] = int_stack + 749554;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1754971,int_stack+1817593,int_stack+1741741,441);
     Libderiv->ABCD[143] = int_stack + 1754971;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1781431,int_stack+1850668,int_stack+1837438,441);
     Libderiv->ABCD[142] = int_stack + 1781431;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1807891,int_stack+1870513,int_stack+32616,441);
     Libderiv->ABCD[131] = int_stack + 1807891;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1834351,int_stack+1890358,int_stack+45846,441);
     Libderiv->ABCD[130] = int_stack + 1834351;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+26181,int_stack+1910203,int_stack+12951,441);
     Libderiv->ABCD[129] = int_stack + 26181;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1860811,int_stack+1943278,int_stack+1930048,441);
     Libderiv->ABCD[119] = int_stack + 1860811;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1887271,int_stack+1963123,int_stack+78741,441);
     Libderiv->ABCD[118] = int_stack + 1887271;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1913731,int_stack+1982968,int_stack+91971,441);
     Libderiv->ABCD[117] = int_stack + 1913731;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+72306,int_stack+2002813,int_stack+59076,441);
     Libderiv->ABCD[116] = int_stack + 72306;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1940191,int_stack+2035888,int_stack+2022658,441);
     Libderiv->ABCD[107] = int_stack + 1940191;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1966651,int_stack+2055733,int_stack+124866,441);
     Libderiv->ABCD[106] = int_stack + 1966651;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1993111,int_stack+2075578,int_stack+138096,441);
     Libderiv->ABCD[105] = int_stack + 1993111;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+118431,int_stack+2095423,int_stack+105201,441);
     Libderiv->ABCD[104] = int_stack + 118431;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+2019571,int_stack+2128498,int_stack+2115268,441);
     Libderiv->ABCD[103] = int_stack + 2019571;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+2046031,int_stack+697487,int_stack+170991,441);
     Libderiv->ABCD[95] = int_stack + 2046031;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+689584,int_stack+909592,int_stack+861967,441);
     Libderiv->ABCD[94] = int_stack + 689584;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+2072491,int_stack+988615,int_stack+875197,441);
     Libderiv->ABCD[93] = int_stack + 2072491;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+857389,int_stack+1153813,int_stack+1107808,441);
     Libderiv->ABCD[92] = int_stack + 857389;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1103965,int_stack+1278046,int_stack+1230421,441);
     Libderiv->ABCD[91] = int_stack + 1103965;
 /*--- compute (fd|hh) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+975742,int_stack+1385614,int_stack+1243651,441);
     Libderiv->ABCD[90] = int_stack + 975742;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1226578,int_stack+1297891,int_stack+1350454, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+736324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[47] = int_stack + 1226578;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1278046,int_stack+1031200,int_stack+1173658, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+896362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[46] = int_stack + 1278046;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1153813,int_stack+286800,int_stack+1186888, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1017970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[45] = int_stack + 1153813;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1344196,int_stack+929437,int_stack+1051045, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1140583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[44] = int_stack + 1344196;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1031200,int_stack+319875,int_stack+306645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1264816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[43] = int_stack + 1031200;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+909592,int_stack+1464706,int_stack+778009, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1372384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[42] = int_stack + 909592;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+283446,int_stack+811084,int_stack+797854, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1451476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[38] = int_stack + 283446;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+776014,int_stack+339720,int_stack+644174, 0.0, zero_stack, 1.0, int_stack+736324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[35] = int_stack + 776014;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+802474,int_stack+368826,int_stack+657404, 0.0, zero_stack, 1.0, int_stack+896362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[34] = int_stack + 802474;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+633426,int_stack+184221,int_stack+676354, 0.0, zero_stack, 1.0, int_stack+1017970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[33] = int_stack + 633426;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+659886,int_stack+204066,int_stack+388671, 0.0, zero_stack, 1.0, int_stack+1140583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[32] = int_stack + 659886;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+164556,int_stack+223911,int_stack+401901, 0.0, zero_stack, 1.0, int_stack+1264816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[31] = int_stack + 164556;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+191016,int_stack+1588939,int_stack+1541314, 0.0, zero_stack, 1.0, int_stack+1372384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[30] = int_stack + 191016;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+309906,int_stack+415131,int_stack+1554544, 0.0, zero_stack, 1.0, int_stack+1451476, 1.0, int_stack+1575709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[26] = int_stack + 309906;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1530856,int_stack+1484551,int_stack+434976, 0.0, zero_stack, 2.0, int_stack+1575709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[25] = int_stack + 1530856;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1464706,int_stack+461436,int_stack+448206, 1.0, int_stack+736324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[23] = int_stack + 1464706;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+716044,int_stack+481281,int_stack+1064275, 1.0, int_stack+896362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[22] = int_stack + 716044;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+336366,int_stack+243756,int_stack+151326, 1.0, int_stack+1017970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[21] = int_stack + 336366;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1002202,int_stack+514356,int_stack+501126, 1.0, int_stack+1140583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[20] = int_stack + 1002202;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+217476,int_stack+263601,int_stack+534201, 1.0, int_stack+1264816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[19] = int_stack + 217476;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+243936,int_stack+1709527,int_stack+1608784, 1.0, int_stack+1372384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[18] = int_stack + 243936;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1709527,int_stack+547431,int_stack+1665547, 1.0, int_stack+1451476, 0.0, zero_stack, 1.0, int_stack+1696297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[14] = int_stack + 1709527;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1588939,int_stack+567276,int_stack+1622014, 1.0, int_stack+1575709, 1.0, int_stack+1696297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[13] = int_stack + 1588939;
 /*--- compute (fd|hh) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1661704,int_stack+587121,int_stack+1432696, 2.0, int_stack+1696297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[12] = int_stack + 1661704;

}
